"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

require("..\\..\\..\\src\\components\\VBtn\\VBtn.sass");

var _VSheet = _interopRequireDefault(require("../VSheet"));

var _VProgressCircular = _interopRequireDefault(require("../VProgressCircular"));

var _groupable = require("../../mixins/groupable");

var _toggleable = require("../../mixins/toggleable");

var _elevatable = _interopRequireDefault(require("../../mixins/elevatable"));

var _positionable = _interopRequireDefault(require("../../mixins/positionable"));

var _routable = _interopRequireDefault(require("../../mixins/routable"));

var _sizeable = _interopRequireDefault(require("../../mixins/sizeable"));

var _mixins = _interopRequireDefault(require("../../util/mixins"));

var _console = require("../../util/console");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance"); }

function _iterableToArrayLimit(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(source, true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(source).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var baseMixins = (0, _mixins.default)(_VSheet.default, _routable.default, _positionable.default, _sizeable.default, (0, _groupable.factory)('btnToggle'), (0, _toggleable.factory)('inputValue')
/* @vue/component */
);

var _default2 = baseMixins.extend().extend({
  name: 'v-btn',
  props: {
    activeClass: {
      type: String,
      default: function _default() {
        if (!this.btnToggle) return '';
        return this.btnToggle.activeClass;
      }
    },
    block: Boolean,
    depressed: Boolean,
    fab: Boolean,
    icon: Boolean,
    loading: Boolean,
    outlined: Boolean,
    plain: Boolean,
    retainFocusOnClick: Boolean,
    rounded: Boolean,
    tag: {
      type: String,
      default: 'button'
    },
    text: Boolean,
    tile: Boolean,
    type: {
      type: String,
      default: 'button'
    },
    value: null,
    classPrefix: {
      type: String,
      default: ''
    }
  },
  data: function data() {
    return {
      proxyClass: 'v-btn--active'
    };
  },
  computed: {
    classes: function classes() {
      var _objectSpread3;

      return _objectSpread(_defineProperty({}, "".concat(this.classPrefix, "v-btn"), true), _routable.default.options.computed.classes.call(this), (_objectSpread3 = {}, _defineProperty(_objectSpread3, "".concat(this.classPrefix, "v-btn--absolute"), this.absolute), _defineProperty(_objectSpread3, "".concat(this.classPrefix, "v-btn--block"), this.block), _defineProperty(_objectSpread3, "".concat(this.classPrefix, "v-btn--bottom"), this.bottom), _defineProperty(_objectSpread3, "".concat(this.classPrefix, "v-btn--disabled"), this.disabled), _defineProperty(_objectSpread3, "".concat(this.classPrefix, "v-btn--is-elevated"), this.isElevated), _defineProperty(_objectSpread3, "".concat(this.classPrefix, "v-btn--fab"), this.fab), _defineProperty(_objectSpread3, "".concat(this.classPrefix, "v-btn--fixed"), this.fixed), _defineProperty(_objectSpread3, "".concat(this.classPrefix, "v-btn--has-bg"), this.hasBg), _defineProperty(_objectSpread3, "".concat(this.classPrefix, "v-btn--icon"), this.icon), _defineProperty(_objectSpread3, "".concat(this.classPrefix, "v-btn--left"), this.left), _defineProperty(_objectSpread3, "".concat(this.classPrefix, "v-btn--loading"), this.loading), _defineProperty(_objectSpread3, "".concat(this.classPrefix, "v-btn--outlined"), this.outlined), _defineProperty(_objectSpread3, "".concat(this.classPrefix, "v-btn--plain"), this.plain), _defineProperty(_objectSpread3, "".concat(this.classPrefix, "v-btn--right"), this.right), _defineProperty(_objectSpread3, "".concat(this.classPrefix, "v-btn--round"), this.isRound), _defineProperty(_objectSpread3, "".concat(this.classPrefix, "v-btn--rounded"), this.rounded), _defineProperty(_objectSpread3, "".concat(this.classPrefix, "v-btn--router"), this.to), _defineProperty(_objectSpread3, "".concat(this.classPrefix, "v-btn--text"), this.text), _defineProperty(_objectSpread3, "".concat(this.classPrefix, "v-btn--tile"), this.tile), _defineProperty(_objectSpread3, "".concat(this.classPrefix, "v-btn--top"), this.top), _objectSpread3), this.themeClasses, {}, this.groupClasses, {}, this.elevationClasses, {}, this.sizeableClasses);
    },
    computedElevation: function computedElevation() {
      if (this.disabled) return undefined;
      return _elevatable.default.options.computed.computedElevation.call(this);
    },
    computedRipple: function computedRipple() {
      var _this$ripple;

      var defaultRipple = this.icon || this.fab ? {
        circle: true
      } : true;
      if (this.disabled) return false;else return (_this$ripple = this.ripple) != null ? _this$ripple : defaultRipple;
    },
    hasBg: function hasBg() {
      return !this.text && !this.plain && !this.outlined && !this.icon;
    },
    isElevated: function isElevated() {
      return Boolean(!this.icon && !this.text && !this.outlined && !this.depressed && !this.disabled && !this.plain && (this.elevation == null || Number(this.elevation) > 0));
    },
    isRound: function isRound() {
      return Boolean(this.icon || this.fab);
    },
    styles: function styles() {
      return _objectSpread({}, this.measurableStyles);
    }
  },
  created: function created() {
    var _this = this;

    var breakingProps = [['flat', 'text'], ['outline', 'outlined'], ['round', 'rounded']];
    /* istanbul ignore next */

    breakingProps.forEach(function (_ref) {
      var _ref2 = _slicedToArray(_ref, 2),
          original = _ref2[0],
          replacement = _ref2[1];

      if (_this.$attrs.hasOwnProperty(original)) (0, _console.breaking)(original, replacement, _this);
    });
    this.proxyClass = this.classPrefix + this.proxyClass;
  },
  methods: {
    click: function click(e) {
      // TODO: Remove this in v3
      !this.retainFocusOnClick && !this.fab && e.detail && this.$el.blur();
      this.$emit('click', e);
      this.btnToggle && this.toggle();
    },
    genContent: function genContent() {
      return this.$createElement('span', {
        staticClass: "".concat(this.classPrefix, "v-btn__content")
      }, this.$slots.default);
    },
    genLoader: function genLoader() {
      return this.$createElement('span', {
        class: "".concat(this.classPrefix, "v-btn__loader")
      }, this.$slots.loader || [this.$createElement(_VProgressCircular.default, {
        props: {
          indeterminate: true,
          size: 23,
          width: 2
        }
      })]);
    }
  },
  render: function render(h) {
    var children = [this.genContent(), this.loading && this.genLoader()];

    var _this$generateRouteLi = this.generateRouteLink(),
        tag = _this$generateRouteLi.tag,
        data = _this$generateRouteLi.data;

    var setColor = this.hasBg ? this.setBackgroundColor : this.setTextColor;

    if (tag === 'button') {
      data.attrs.type = this.type;
      data.attrs.disabled = this.disabled;
    }

    data.attrs.value = ['string', 'number'].includes(_typeof(this.value)) ? this.value : JSON.stringify(this.value);
    return h(tag, this.disabled ? data : setColor(this.color, data), children);
  }
});

exports.default = _default2;
//# sourceMappingURL=VBtn.js.map