// Styles
import "..\\..\\..\\src\\components\\VCounter\\VCounter.sass"; // Mixins

import Themeable, { functionalThemeClasses } from '../../mixins/themeable';
import mixins from '../../util/mixins';
/* @vue/component */

export default mixins(Themeable).extend({
  name: 'v-counter',
  functional: true,
  props: {
    value: {
      type: [Number, String],
      default: ''
    },
    max: [Number, String],
    classPrefix: {
      type: String,
      default: ''
    }
  },

  render(h, ctx) {
    const {
      props
    } = ctx;
    const max = parseInt(props.max, 10);
    const value = parseInt(props.value, 10);
    const content = max ? `${value} / ${max}` : String(props.value);
    const isGreater = max && value > max;
    return h('div', {
      staticClass: `${this.classPrefix}v-counter`,
      class: {
        [`${this.classPrefix}error--text`]: isGreater,
        ...functionalThemeClasses(ctx)
      }
    }, content);
  }

});
//# sourceMappingURL=VCounter.js.map