# Changelog

All notable changes to this project will be documented in this file. See [standard-version](https://github.com/conventional-changelog/standard-version) for commit guidelines.

## 4.0.0 (2021-07-14)


### ⚠ BREAKING CHANGES

* **styles:** requires sass@1.33.0
* **VMessages:** Rules for all inputs are now escaped. A scoped slot has been added for users who
need to customize the styling of messages.
* **kitchen:** was failing with an Assertion error, signal SIGABRT when building kitchen sometimes
in CI
* **grid:** css specificity reduced on `.layout.reverse`
* **VDataTable:** the virtual-rows prop (from alpha/beta) will no longer work
* all ma-x etc. helpers need to be changed

before: 0 4 8 16 24 48
after:  0 4 8 12 16 20 24 28 32 36 40 44 48

* refactor(VCol): remove redundant col prop

* fix(VCol): apply class when breakpoints specified

* feat: merge legacy-grid back into vuetify

v-layout and v-flex now coexist with the new components

some styles will still change from 1.x as there is some overlap between
the two systems, but the overall upgrade workload should be less

* docs: update classes

* feat: add back start/end spacing helpers for rtl

* feat: revert space-between -> between breaking change

* style: fix lint

* test: update snapshots

* docs: revert space-between -> between breaking change

partially reverts fc21169bc

* chore(ci): build before lint

eslint-plugin-vuetify needs to import from dist

* style: fix lint

* fix(VDataTable): replace text-xs-start

* style: fix lint

* fix(VRow): add flex-grow for IE11
* **validatable:** all form inputs default to white when using the dark prop
* **VApp:** the dark and light prop no longer have an effect on application theme variants
* **VApp:** the v-app component classes have been prepended with v-
* **VChip:** the value prop is now active, @input is now @active.sync
* **VList/Item/Group:** the item scoped slot value of { tile } is now { attrs, on }. is now bound similar
to the v-menu activator slot
* **VTextField:** `v-select` no longer has a default autocomplete of "on"
* **routable/VItemGroup:** activeClass items must now control their active-state colors through classes

* refactor(routable): change tabindex logic

* chore(VChip): remove deprecated style

* refactor(routable): remove arguments from generation method

* refactor(ItemGroups): add support for color over active-class

* refactor: update colors, change how bottom nav derives color

continue to normalize behavior between multiple components
* **routable/VItemGroup:** VBottomNavigation color now applies text color, adds new background color prop,
removed default color from VListGroup

* docs: update examples

* chore: add comment on types for routable

Co-Authored-By: Dmitry Sharshakov <d3dx12.xx@gmail.com>

* refactor: improvements from code review

* refactor(routable): remove unnecessary activeClass designation

* refactor(VBreadcrumbsItem): normalize ripple type

* refactor(VListItem): remove duplicated activeClass designation

* refactor(routable): only explicitly apply proxy/active class if not a router link

* refactor(VTabs): normalize how VTab derives its activeClass

make similar to other implementations

* docs(VListItemGroup): improve example
* **activatable:** all activator slots must be bound with v-slot

* refactor(VMenu): remove genActivator method

* docs(Core/SpecBtn): update slot structure

* refactor(activatable): update getActivator logic

use activatorNode of available

* refactor(VTooltip): update to properly use activatable

* refactor(activatable): change ordering of getActivator conditional

favor event over activatorNode

* refactor(activatable): change logic for activator slot bind error

* test(activatable): fix tests

* fix(activatable/VMenu): properly handle dynamic activators

* chore(VMenu): remove deprecated message

* fix(menuable): add support for disabling open-on-click

* style(menuable): remove explicit type declaration

* chore: remove unused props from tests
* No way to use this function any more

* refactor(test helpers): convert to TS

* chore: remove avoriaz

* chore: update to jest 24

* test(jest): convert jest globals into module

* Update packages/vuetify/src/components/VSlideGroup/__tests__/VSlideGroup.spec.ts

Co-Authored-By: sh7dm <sh7dm@outlook.com>
Co-Authored-By: John Leider <john@vuetifyjs.com>

* Update jest.config.js
* **VCarousel:** The **cycle** prop is no longer implicit, must be defined in order to have screens
switch

* refactor(VCarousel/VWindow): clean-up styles

* fix(VWindow): update default for **show-arrows** prop

* docs(VCarousel): add new **cycle** example

* docs(VCarousel): update example

* docs(VCarousel): update **customTransition** example

* refactor(VCarousel): remove duplicated (essentially) render function

* refactor(VWindow): abstract **show-arrows-on-hover** from `v-carousel`

* feat(VCarousel): add **progress** prop

* refactor(VWindow): reduce control margin

* refactor(VWindow): reduce size of controls

* refactor(VCarousel): **progres-color** is inferred as default from `v-progress-linear`

* feat(VCarousel): add **vertical-delmiiters** prop
* requires dart-sass or an unreleased version of libsass
* **framework:** no more Stylus

* build: remove all stylus processing (loaders)
* **framework:** no availibility to transform stylus

* chore: remove .styl files from .eslintignore and sideEffects

* chore(kitchen): remove stylus and stylus-loader

* docs: replace Stylus custimization guide with Sass one

Co-authored-by: Pedro Vieira <peluprvi@gmail.com>

* build(docs): transpile Sass

* docs: replace node-sass with sass

* refactor(docs): use Sass, not SCSS

* build(framework): use sass everywhere instead of node-sass

* chore: fix warnings

* refactor(VSlider): change variables type

should be .scss to match rest of framework

* docs: replace mentions of node-sass with sass
* **VBottomSheet:** the `v-bottom-sheet-transition` component has been removed
* **VExpansionPanel:** many components have been renamed and props moved
v-expansion-panel         => v-expansion-panels
v-expansion-panel-content => v-expansion-panel
new component                v-expansion-panel-header
new component                v-expansion-panel-content

* style(VExpansionPanel): clean-up styles

* fix: add vertical padding to header

* docs(VExpansionPanels): update examples to new structure

* fix(VExpansionPanelHeader): use correct css selector for **disabled** prop

* fix(VExpansionPanelHeader): add proper focus support for a11y

* docs(VExpansionPanel): add advanced example

* refactor(VExpansionPanel): clean-up files

* test(VExpansionPanel): fix existing tests and expand coverage

* docs: remove unused variable from example

* fix: prevent disabled panels from being toggled

* docs: combine repetitive examples, update props and language

* docs: :man_facepalming:

* docs(VExpansionPanels): remove prop from api entirely

no property deprecations for 2.0

* test(VExpansionPanelHeader): update snapshots

* test(VExpansionPanel): fix tests from bootable update
* **VBottomNav:** `v-bottom-nav` is now `v-bottom-navigation`

* fix(VBottomNavigation): add missing sync update for input-value

* docs(VBottomNavigation): add missing language for api

* style(VBottomNavigation): add font-size variable
* **bootable:** **lazy** now has no effect

* test: fix existing broken tests

* docs(bootable): update language
* **VTabs:** fixes #5636

* test(VTabs): fix tests

* fix(VTabs): move pseudo to :before

was making other items not clickable

* fix(VItemGroup): derive item index in real time

* chore(VTabs): add comments throughout

* refactor(VTabs): improve scroll arrow functionality

utilize existing computed property, updated tests to accommodate

* feat(VSlideGroup): add rtl support
* **VChip/Group:** **value** no longer controls visibility. **input** event emitted when clicking
close is now **click:close**

* refactor(VChip): fix cursor styles

* test(VSelect/VChip): fix unit tests

* docs(CoreItem): use new chip style for xsmall

* refactor(VChip): improve styling within v-chip-group

add keys to append/prepend to support dynamic swapping of column/row

* docs(VChipGroup): add documentation and examples

* feat(VChip): add filter styles, improve existing selection styles
* **validatable:** fixes #5877

### Features

* **activatable:** add value to slot scope ([#7288](https://github.com/vuetifyjs/vuetify/issues/7288)) ([b5dafc4](https://github.com/vuetifyjs/vuetify/commit/b5dafc4e78f802fe3f1dfe8cdce04e7524e4f47e))
* **docs:** refactored api-gen, moved away from md tables for API ([#12184](https://github.com/vuetifyjs/vuetify/issues/12184)) ([a04426f](https://github.com/vuetifyjs/vuetify/commit/a04426fdd756c9ea8036d16ef1d32df906213145))
* **grid:** remove useless .layout.row class ([3f435b5](https://github.com/vuetifyjs/vuetify/commit/3f435b5a3bc6e0686c19009c4429164910a5949e))
* **locale:** add Azerbaijani locale ([#12084](https://github.com/vuetifyjs/vuetify/issues/12084)) ([a2267b2](https://github.com/vuetifyjs/vuetify/commit/a2267b2bda827545290c4eef69440d0501367831))
* **locale:** add Czech translation ([#8228](https://github.com/vuetifyjs/vuetify/issues/8228)) ([8ec6f05](https://github.com/vuetifyjs/vuetify/commit/8ec6f05073f64347fa916057bb4bed2cdea20fad))
* **locale:** add Korean locale files ([#7366](https://github.com/vuetifyjs/vuetify/issues/7366)) ([f1cf81e](https://github.com/vuetifyjs/vuetify/commit/f1cf81ebfab7cf7605af129918dc9eeb879dc942))
* **locale:** add Norwegian translation ([#7587](https://github.com/vuetifyjs/vuetify/issues/7587)) ([b78fe28](https://github.com/vuetifyjs/vuetify/commit/b78fe28dc7c025391610f5195fe95e6830c44753))
* **locale:** add Serbian Latin translation and fix Cyrilic [#13015](https://github.com/vuetifyjs/vuetify/issues/13015) ([#13016](https://github.com/vuetifyjs/vuetify/issues/13016)) ([5650695](https://github.com/vuetifyjs/vuetify/commit/5650695841018c7802679a0e92036503183d4eca))
* **styles:** add rtl/ltr start/end spacing and alignment ([#7448](https://github.com/vuetifyjs/vuetify/issues/7448)) ([3a51619](https://github.com/vuetifyjs/vuetify/commit/3a5161948a1d9c1667760f490733f7081d2f9e4d)), closes [#4660](https://github.com/vuetifyjs/vuetify/issues/4660)
* **styles:** added text-pre-line utility class ([53cc6de](https://github.com/vuetifyjs/vuetify/commit/53cc6de3f8f91a44950113f0fbfcd6f54bd8c800))
* **styles:** float classes breakpointed ([#7922](https://github.com/vuetifyjs/vuetify/issues/7922)) ([26ad2e5](https://github.com/vuetifyjs/vuetify/commit/26ad2e534d68c9a57a5cd59fa38ec5e8fbc77776)), closes [#7921](https://github.com/vuetifyjs/vuetify/issues/7921)
* **theme:** add anchor color support ([#7455](https://github.com/vuetifyjs/vuetify/issues/7455)) ([40f3df8](https://github.com/vuetifyjs/vuetify/commit/40f3df8cc1b3a13fd34187c804905b48effcdb1f)), closes [#6360](https://github.com/vuetifyjs/vuetify/issues/6360)
* **transitions:** add dialog-top-transition ([#12751](https://github.com/vuetifyjs/vuetify/issues/12751)) ([09ddab5](https://github.com/vuetifyjs/vuetify/commit/09ddab59453f15d06d1fb93f19ed3743dcaad4fa))
* **typography:** add text-pre helper class ([7a03376](https://github.com/vuetifyjs/vuetify/commit/7a0337646c1231218e10b876fe67ce01d0168657))
* **Typography:** add text-pre-wrap utility class ([#11772](https://github.com/vuetifyjs/vuetify/issues/11772)) ([bf78f62](https://github.com/vuetifyjs/vuetify/commit/bf78f6288d7ab5e57a9349a7e5d92c928b122b83)), closes [#11761](https://github.com/vuetifyjs/vuetify/issues/11761)
* **Typography:** improve <code> styles ([7877bef](https://github.com/vuetifyjs/vuetify/commit/7877beff68013bb46c4c8d34d4a33c69ca1115c7))
* **VAppBar:** don't truncate title with shrink-on-scroll ([#12516](https://github.com/vuetifyjs/vuetify/issues/12516)) ([8c5ee02](https://github.com/vuetifyjs/vuetify/commit/8c5ee0268dcc78d4cde57f36a90bc68ec1656639)), closes [#12514](https://github.com/vuetifyjs/vuetify/issues/12514)
* **VBreadcrumbs:** support aria ([0e8ca8f](https://github.com/vuetifyjs/vuetify/commit/0e8ca8f48a8d0d9fffc8efb817c339a4e382ecaf))
* **VBtn:** add new styling property plain ([#12814](https://github.com/vuetifyjs/vuetify/issues/12814)) ([bae707c](https://github.com/vuetifyjs/vuetify/commit/bae707c211eb1572d3f2d8a16bfeac48576d0f6b)), closes [#3026](https://github.com/vuetifyjs/vuetify/issues/3026)
* **VBtn:** inherit justify-items from root ([c028904](https://github.com/vuetifyjs/vuetify/commit/c028904c3ad884546f959506c327c74e3f42f26f)), closes [#7896](https://github.com/vuetifyjs/vuetify/issues/7896)
* **VCalendar:** add support for object categories ([#12518](https://github.com/vuetifyjs/vuetify/issues/12518)) ([806864c](https://github.com/vuetifyjs/vuetify/commit/806864cdf1076990bf48a1051145f25308df42a6))
* **VCalendar:** events improvements ([#6475](https://github.com/vuetifyjs/vuetify/issues/6475)) ([964a750](https://github.com/vuetifyjs/vuetify/commit/964a7502f17d5b340ecd3cb30ed558ac5bcc3c88)), closes [#6511](https://github.com/vuetifyjs/vuetify/issues/6511) [#7406](https://github.com/vuetifyjs/vuetify/issues/7406) [#7308](https://github.com/vuetifyjs/vuetify/issues/7308) [#7152](https://github.com/vuetifyjs/vuetify/issues/7152) [#7213](https://github.com/vuetifyjs/vuetify/issues/7213) [#7270](https://github.com/vuetifyjs/vuetify/issues/7270) [#7271](https://github.com/vuetifyjs/vuetify/issues/7271) [#7318](https://github.com/vuetifyjs/vuetify/issues/7318) [#7337](https://github.com/vuetifyjs/vuetify/issues/7337) [#7335](https://github.com/vuetifyjs/vuetify/issues/7335) [#7320](https://github.com/vuetifyjs/vuetify/issues/7320) [#7341](https://github.com/vuetifyjs/vuetify/issues/7341) [#7334](https://github.com/vuetifyjs/vuetify/issues/7334) [#7342](https://github.com/vuetifyjs/vuetify/issues/7342) [#7338](https://github.com/vuetifyjs/vuetify/issues/7338) [#7343](https://github.com/vuetifyjs/vuetify/issues/7343) [#7345](https://github.com/vuetifyjs/vuetify/issues/7345) [#7340](https://github.com/vuetifyjs/vuetify/issues/7340) [#7330](https://github.com/vuetifyjs/vuetify/issues/7330) [#7350](https://github.com/vuetifyjs/vuetify/issues/7350) [#7287](https://github.com/vuetifyjs/vuetify/issues/7287) [#7349](https://github.com/vuetifyjs/vuetify/issues/7349) [#7059](https://github.com/vuetifyjs/vuetify/issues/7059) [#7362](https://github.com/vuetifyjs/vuetify/issues/7362) [#7363](https://github.com/vuetifyjs/vuetify/issues/7363) [#4683](https://github.com/vuetifyjs/vuetify/issues/4683) [#6978](https://github.com/vuetifyjs/vuetify/issues/6978) [#7346](https://github.com/vuetifyjs/vuetify/issues/7346) [#7368](https://github.com/vuetifyjs/vuetify/issues/7368) [#6178](https://github.com/vuetifyjs/vuetify/issues/6178) [#7373](https://github.com/vuetifyjs/vuetify/issues/7373) [#7380](https://github.com/vuetifyjs/vuetify/issues/7380) [#7366](https://github.com/vuetifyjs/vuetify/issues/7366) [#7367](https://github.com/vuetifyjs/vuetify/issues/7367) [#7344](https://github.com/vuetifyjs/vuetify/issues/7344) [#7408](https://github.com/vuetifyjs/vuetify/issues/7408) [#7452](https://github.com/vuetifyjs/vuetify/issues/7452)
* **VCalendar:** update parser to return full category ([#12638](https://github.com/vuetifyjs/vuetify/issues/12638)) ([e2200c3](https://github.com/vuetifyjs/vuetify/commit/e2200c34d4ffab8806308f70eed16a2a76690949))
* **vcolorpicker:** add hideSliders prop ([#12618](https://github.com/vuetifyjs/vuetify/issues/12618)) ([e35d79b](https://github.com/vuetifyjs/vuetify/commit/e35d79b5012d3c0b445c1b9d5beb7f547345696f)), closes [#11138](https://github.com/vuetifyjs/vuetify/issues/11138)
* **VColorPicker:** add a new component ([#6988](https://github.com/vuetifyjs/vuetify/issues/6988)) ([a5a1102](https://github.com/vuetifyjs/vuetify/commit/a5a11023019a13e5ccb8519b5c6a3a913ec33412))
* **VDataTable:** add `foot` and `footer.prepend` slots ([#13081](https://github.com/vuetifyjs/vuetify/issues/13081)) ([1c81605](https://github.com/vuetifyjs/vuetify/commit/1c81605cef397d946e75a13fb4c28461e7ce7c33)), closes [#8767](https://github.com/vuetifyjs/vuetify/issues/8767) [#9695](https://github.com/vuetifyjs/vuetify/issues/9695)
* **VDataTable:** add cellClass property to headers ([#11775](https://github.com/vuetifyjs/vuetify/issues/11775)) ([8d06d45](https://github.com/vuetifyjs/vuetify/commit/8d06d4573237b0d2134c03e763a0f36aa2986b06))
* **VDataTable:** Add checkboxColor prop ([#11975](https://github.com/vuetifyjs/vuetify/issues/11975)) ([4c469fd](https://github.com/vuetifyjs/vuetify/commit/4c469fd945c45fc4323f1846dc055babc794655e)), closes [#8348](https://github.com/vuetifyjs/vuetify/issues/8348)
* **VDataTable:** Add shift key logic for multiple selection ([#11921](https://github.com/vuetifyjs/vuetify/issues/11921)) ([bb252c1](https://github.com/vuetifyjs/vuetify/commit/bb252c126fdd7640f50b49d1f7dfa9543d0a43b7)), closes [#9958](https://github.com/vuetifyjs/vuetify/issues/9958)
* **VDataTable:** change data-table scoped slot props structure ([#7585](https://github.com/vuetifyjs/vuetify/issues/7585)) ([878be3e](https://github.com/vuetifyjs/vuetify/commit/878be3e9de715e01d76aa45761ba7acb5d14568e))
* **VDataTable:** index prop in item* slots ([#12605](https://github.com/vuetifyjs/vuetify/issues/12605)) ([9daeb16](https://github.com/vuetifyjs/vuetify/commit/9daeb1691d7cc0ecd64289033a2d4ec96f6f4b80)), closes [#10646](https://github.com/vuetifyjs/vuetify/issues/10646)
* **VDataTable:** isMobile prop in scoped slots ([#12604](https://github.com/vuetifyjs/vuetify/issues/12604)) ([e1720a8](https://github.com/vuetifyjs/vuetify/commit/e1720a8d5d0361fc223a4113588caf6f32ce1e59)), closes [#11330](https://github.com/vuetifyjs/vuetify/issues/11330)
* **VDatePicker:** `show-adjacent-months` prop ([#12603](https://github.com/vuetifyjs/vuetify/issues/12603)) ([8f1cf64](https://github.com/vuetifyjs/vuetify/commit/8f1cf64691d05c673306563366e5ee794e8b75de)), closes [#12237](https://github.com/vuetifyjs/vuetify/issues/12237)
* **VDatePicker:** activePicker prop ([#12754](https://github.com/vuetifyjs/vuetify/issues/12754)) ([42b56bb](https://github.com/vuetifyjs/vuetify/commit/42b56bbfdfb5ae218661adcf4441984237beb558)), closes [#11576](https://github.com/vuetifyjs/vuetify/issues/11576)
* **VDialog:** add retainFocus prop ([3681cd5](https://github.com/vuetifyjs/vuetify/commit/3681cd59fe82bd1716a46038245236b2922923db)), closes [#6892](https://github.com/vuetifyjs/vuetify/issues/6892)
* **VIcon:** specify a global default icon component ([#12244](https://github.com/vuetifyjs/vuetify/issues/12244)) ([41fd082](https://github.com/vuetifyjs/vuetify/commit/41fd082dc2ae59a35b399e5d86cf4d66729ec63b)), closes [#7821](https://github.com/vuetifyjs/vuetify/issues/7821)
* **VImg:** add loadstart event ([c057c92](https://github.com/vuetifyjs/vuetify/commit/c057c929fa8be1d5e1914d826ed25acff84e55f5))
* **VStepper:** extend VSheet functionality ([ae51c07](https://github.com/vuetifyjs/vuetify/commit/ae51c07600c2ee746aa9a2fed58ce933cbbb8b5d)), closes [#4076](https://github.com/vuetifyjs/vuetify/issues/4076)
* `float-<bp>-start` and `float-<bp>-end` utility classes ([#12753](https://github.com/vuetifyjs/vuetify/issues/12753)) ([13ab192](https://github.com/vuetifyjs/vuetify/commit/13ab192c573a8401c5f4c52d4b0d3b1bf5f3c349)), closes [#11874](https://github.com/vuetifyjs/vuetify/issues/11874)
* **locale:** add Central Kurdish locale ([#12100](https://github.com/vuetifyjs/vuetify/issues/12100)) ([e121bc2](https://github.com/vuetifyjs/vuetify/commit/e121bc249f1ecd1f23bc778f899882c344ef348c))
* add 404 page ([#126](https://github.com/vuetifyjs/vuetify/issues/126)) ([8dbd662](https://github.com/vuetifyjs/vuetify/commit/8dbd6624e45ad4b2c1d6a16ecfa2a471f1232103))
* add error handling when loading example ([#14](https://github.com/vuetifyjs/vuetify/issues/14)) ([72ecab6](https://github.com/vuetifyjs/vuetify/commit/72ecab6794cd504cc56def66b73a78f2e314b443))
* detect user preferred color theme as default ([#76](https://github.com/vuetifyjs/vuetify/issues/76)) ([991ca90](https://github.com/vuetifyjs/vuetify/commit/991ca909ecc1545659c9e295277970e08d1f89b4))
* **a11y:** add visually hidden css utility classes ([#11258](https://github.com/vuetifyjs/vuetify/issues/11258)) ([9e4c3c8](https://github.com/vuetifyjs/vuetify/commit/9e4c3c8995425aa8f398908063cfa586a40cd702)), closes [#10914](https://github.com/vuetifyjs/vuetify/issues/10914)
* **api:** re-build api pages when source data changes ([#24](https://github.com/vuetifyjs/vuetify/issues/24)) ([eba2631](https://github.com/vuetifyjs/vuetify/commit/eba2631731ecb4a6d3178e2264a273f6793813c0))
* **breakpoint:** add global variables/mixin ([#11480](https://github.com/vuetifyjs/vuetify/issues/11480)) ([9f6f5a5](https://github.com/vuetifyjs/vuetify/commit/9f6f5a58481e5de6e95f8e7a84242cced940d70c)), closes [#6945](https://github.com/vuetifyjs/vuetify/issues/6945) [#9272](https://github.com/vuetifyjs/vuetify/issues/9272)
* **directives:** expose all options to templates ([#10905](https://github.com/vuetifyjs/vuetify/issues/10905)) ([a8d0def](https://github.com/vuetifyjs/vuetify/commit/a8d0def2f29affaf7c14162503d0343bf39c94f2)), closes [#4654](https://github.com/vuetifyjs/vuetify/issues/4654)
* **DocumentationDrawer:** add alphabetical sorting mode ([#25](https://github.com/vuetifyjs/vuetify/issues/25)) ([34ddb2e](https://github.com/vuetifyjs/vuetify/commit/34ddb2e7f30517f32ba5e7a70c1fccb31d10dff1))
* **loaders:** improve loading styles for table and cards ([c2c1d6a](https://github.com/vuetifyjs/vuetify/commit/c2c1d6ac8bb78e783243ca3d7fdb8390b25235ba))
* **Ripple:** hide effect for touch scroll events ([#7887](https://github.com/vuetifyjs/vuetify/issues/7887)) ([#10596](https://github.com/vuetifyjs/vuetify/issues/10596)) ([337fd24](https://github.com/vuetifyjs/vuetify/commit/337fd248ac75c99adeb3c33a29ce441eefce724b))
* **Spacing:** add support for 16 sizes of margin/padding ([bbfe878](https://github.com/vuetifyjs/vuetify/commit/bbfe8783ac2341ff9b28c18763c6b39791f94c1c)), closes [#10675](https://github.com/vuetifyjs/vuetify/issues/10675)
* **theme:** add new option to disable variation generation ([d4c311e](https://github.com/vuetifyjs/vuetify/commit/d4c311e4c892da726e1491a702219436aef9c413))
* **types:** add DataItemProps and DataTableItemProps interfaces ([#11593](https://github.com/vuetifyjs/vuetify/issues/11593)) ([e0d0296](https://github.com/vuetifyjs/vuetify/commit/e0d0296a7a6b4cd2d2fb4332ef66adf2f63a58ab))
* **v-data-table:** add item-class property ([#11254](https://github.com/vuetifyjs/vuetify/issues/11254)) ([7d1489a](https://github.com/vuetifyjs/vuetify/commit/7d1489aee79793407f2ede280af71cdac1c8eb90)), closes [#8643](https://github.com/vuetifyjs/vuetify/issues/8643)
* **VAvatar:** integrate roundable mixin ([#11435](https://github.com/vuetifyjs/vuetify/issues/11435)) ([8d1eac0](https://github.com/vuetifyjs/vuetify/commit/8d1eac0c1a7ecf7c4306a137f276a8d61126dc55))
* **VCalendar:** general improvements & category view ([#11198](https://github.com/vuetifyjs/vuetify/issues/11198)) ([5ab3d41](https://github.com/vuetifyjs/vuetify/commit/5ab3d416ce9bf41ae6c3aea03d6abeca0a8170af)), closes [#8667](https://github.com/vuetifyjs/vuetify/issues/8667) [#11080](https://github.com/vuetifyjs/vuetify/issues/11080) [#11093](https://github.com/vuetifyjs/vuetify/issues/11093) [#11133](https://github.com/vuetifyjs/vuetify/issues/11133) [#11182](https://github.com/vuetifyjs/vuetify/issues/11182)
* **VCalendar:** show week numbers in month-view ([#10928](https://github.com/vuetifyjs/vuetify/issues/10928)) ([39177c2](https://github.com/vuetifyjs/vuetify/commit/39177c283438097b4fa5905c4a4042f8e9e45385)), closes [#9117](https://github.com/vuetifyjs/vuetify/issues/9117)
* **VDataTable:** add groupable property to header items ([#11361](https://github.com/vuetifyjs/vuetify/issues/11361)) ([e0215ff](https://github.com/vuetifyjs/vuetify/commit/e0215ffb8509852fb24f38ef15299307e23b16e2)), closes [#10889](https://github.com/vuetifyjs/vuetify/issues/10889)
* **VDatePicker:** native events on day/month/year ([#11126](https://github.com/vuetifyjs/vuetify/issues/11126)) ([e706660](https://github.com/vuetifyjs/vuetify/commit/e706660aebe3f11f7869204fee1cee8b62952650)), closes [#5598](https://github.com/vuetifyjs/vuetify/issues/5598)
* **VDatePicker:** prev/next month/year icon aria label ([#10366](https://github.com/vuetifyjs/vuetify/issues/10366)) ([9c2a8b5](https://github.com/vuetifyjs/vuetify/commit/9c2a8b5764131d463a660e62733e24f7f4edbc45)), closes [#9694](https://github.com/vuetifyjs/vuetify/issues/9694)
* **VFileInput:** add new prop hide-input ([#11031](https://github.com/vuetifyjs/vuetify/issues/11031)) ([0b256c9](https://github.com/vuetifyjs/vuetify/commit/0b256c92804021f2006b596065b87cbc9fcfbf14)), closes [#10886](https://github.com/vuetifyjs/vuetify/issues/10886)
* **VForm:** add form level disabled prop ([#10325](https://github.com/vuetifyjs/vuetify/issues/10325)) ([ccf25e8](https://github.com/vuetifyjs/vuetify/commit/ccf25e82b41afe41887d859bc590372d476d1ee0)), closes [#1707](https://github.com/vuetifyjs/vuetify/issues/1707)
* **VItemGroup:** add tag prop to component ([#12771](https://github.com/vuetifyjs/vuetify/issues/12771)) ([e3378fc](https://github.com/vuetifyjs/vuetify/commit/e3378fc2d7a4a8e9ccf5b4d622e9b570382dbd92)), closes [#11392](https://github.com/vuetifyjs/vuetify/issues/11392)
* **VMain:** create new component from v-content ([7a85220](https://github.com/vuetifyjs/vuetify/commit/7a852200604b5755a63e6fecd0a773d5e4c4a59f))
* **VMenu:** add jump to first/last item keyboard navigation ([#12348](https://github.com/vuetifyjs/vuetify/issues/12348)) ([181d337](https://github.com/vuetifyjs/vuetify/commit/181d33763bb3dca0cd6a47787e20a1ab4bf65f4a))
* **VMenu:** add rounded support to menu content ([#11447](https://github.com/vuetifyjs/vuetify/issues/11447)) ([ea52a89](https://github.com/vuetifyjs/vuetify/commit/ea52a8933ac4d1efc2843a27f6987b4f3d5cd3af)), closes [#10397](https://github.com/vuetifyjs/vuetify/issues/10397)
* **VParallax:** add srcset support ([e72e78f](https://github.com/vuetifyjs/vuetify/commit/e72e78f3e9872c65589cfbdd197d23c214c8426e)), closes [#1535](https://github.com/vuetifyjs/vuetify/issues/1535)
* **VProgress:** only play animations when visible ([#13136](https://github.com/vuetifyjs/vuetify/issues/13136)) ([4485598](https://github.com/vuetifyjs/vuetify/commit/448559817b5bea8d8feae11ca84ccfdd8a0c6e39)), closes [#12731](https://github.com/vuetifyjs/vuetify/issues/12731)
* **VResponsive:** add contentClass prop ([71b8854](https://github.com/vuetifyjs/vuetify/commit/71b8854a27eac53876252163a906fc7172960920)), closes [#10982](https://github.com/vuetifyjs/vuetify/issues/10982)
* **VSheet:** refactor style propagation ([#11335](https://github.com/vuetifyjs/vuetify/issues/11335)) ([cbaf955](https://github.com/vuetifyjs/vuetify/commit/cbaf955fccdceb7d8bf70fdbe4091a1ee27c0c82))
* **VSnackbar:** add applicationable support ([#11448](https://github.com/vuetifyjs/vuetify/issues/11448)) ([6098e5f](https://github.com/vuetifyjs/vuetify/commit/6098e5f732856a693f459f8fd71697605cb30903)), closes [#4468](https://github.com/vuetifyjs/vuetify/issues/4468)
* **VSnackbar:** add new properties and improve md2 spec ([#11542](https://github.com/vuetifyjs/vuetify/issues/11542)) ([d44b590](https://github.com/vuetifyjs/vuetify/commit/d44b590e51d23e54fda6d99ea69540bdade192af)), closes [#5865](https://github.com/vuetifyjs/vuetify/issues/5865) [#10935](https://github.com/vuetifyjs/vuetify/issues/10935)
* **VSnackbar:** keep snackbar open while mouseover ([#12599](https://github.com/vuetifyjs/vuetify/issues/12599)) ([8808d98](https://github.com/vuetifyjs/vuetify/commit/8808d98ce0f4ab4882f9ab21625263d2c309c0a1)), closes [#12494](https://github.com/vuetifyjs/vuetify/issues/12494)
* **VTextField:** add `counter` scoped slot ([#12634](https://github.com/vuetifyjs/vuetify/issues/12634)) ([ed46cfb](https://github.com/vuetifyjs/vuetify/commit/ed46cfb70ef3b34c03f217aa28caf338f81b7b78)), closes [#9548](https://github.com/vuetifyjs/vuetify/issues/9548)
* **VTextField:** add persistentPlaceholder prop ([#13001](https://github.com/vuetifyjs/vuetify/issues/13001)) ([005d56d](https://github.com/vuetifyjs/vuetify/commit/005d56d43924efc17db54fd419e5f8a241f82a14)), closes [#12839](https://github.com/vuetifyjs/vuetify/issues/12839)
* **VTextField:** only show placeholder on focus if label is set ([#12635](https://github.com/vuetifyjs/vuetify/issues/12635)) ([ff500ba](https://github.com/vuetifyjs/vuetify/commit/ff500ba38592f3db1288c7552000260cedadd4e0)), closes [#12499](https://github.com/vuetifyjs/vuetify/issues/12499)
* **VWindow,VCarousel:** **prev** and **next** slots ([#12602](https://github.com/vuetifyjs/vuetify/issues/12602)) ([a0140b0](https://github.com/vuetifyjs/vuetify/commit/a0140b0268c0bc5cebfa0d66d3705d74ead68514)), closes [#3235](https://github.com/vuetifyjs/vuetify/issues/3235)
* add pwa/http-server ([bfcfe7c](https://github.com/vuetifyjs/vuetify/commit/bfcfe7c6799c1572e0d6c3ce4c38f35a326625c1))
* add vue-i18n ([#5](https://github.com/vuetifyjs/vuetify/issues/5)) ([eed47fe](https://github.com/vuetifyjs/vuetify/commit/eed47fec4094817b95c6befc83fbd714f73709c0))
* allow all console messages to be disabled ([#10909](https://github.com/vuetifyjs/vuetify/issues/10909)) ([7f99918](https://github.com/vuetifyjs/vuetify/commit/7f99918095c690974855271f85594a18523e78c0)), closes [#10888](https://github.com/vuetifyjs/vuetify/issues/10888)
* dynamically generate drawer items ([#3](https://github.com/vuetifyjs/vuetify/issues/3)) ([776294f](https://github.com/vuetifyjs/vuetify/commit/776294f9e17d586fc78a0b1a149d1492307a432d))
* use component syntax for alerts instead of blockquoute ([73fb18a](https://github.com/vuetifyjs/vuetify/commit/73fb18adb7cd97f116f12ef130b19677d851b0b5))
* **colorable:** add support for CSS custom props ([#9637](https://github.com/vuetifyjs/vuetify/issues/9637)) ([ac58e80](https://github.com/vuetifyjs/vuetify/commit/ac58e80c35a14499305263fc7d3efa236c10328b))
* **directives:** add color directive ([#10866](https://github.com/vuetifyjs/vuetify/issues/10866)) ([bf3799b](https://github.com/vuetifyjs/vuetify/commit/bf3799be2abaeb35414df0f3e3071301e0f1e557))
* **framework:** create new decoration helper classes ([#11035](https://github.com/vuetifyjs/vuetify/issues/11035)) ([bf3fad2](https://github.com/vuetifyjs/vuetify/commit/bf3fad2c4ccacadd4da9ef30dc1e35ebd05c7aa3))
* **i18n:** translate Sort by to Norwegian ([#8762](https://github.com/vuetifyjs/vuetify/issues/8762)) ([6eb70a7](https://github.com/vuetifyjs/vuetify/commit/6eb70a71174968ba13e2967c2f35c5fabc7fb443))
* **kbd/code:** update colors/style, added new variables ([47042cd](https://github.com/vuetifyjs/vuetify/commit/47042cd55d2cd6d343635dfa1d6761bc2fc9aca7))
* **locale:** add Finnish translation ([#10381](https://github.com/vuetifyjs/vuetify/issues/10381)) ([0ce1a66](https://github.com/vuetifyjs/vuetify/commit/0ce1a66851162385f89f144d69411b9966ab777c))
* **locale:** add Lithuanian translation ([#8605](https://github.com/vuetifyjs/vuetify/issues/8605)) ([6216517](https://github.com/vuetifyjs/vuetify/commit/6216517e4477ad61637f74ce09ea3e1dd704e531))
* **locale:** add Slovak translation ([#10328](https://github.com/vuetifyjs/vuetify/issues/10328)) ([59b8422](https://github.com/vuetifyjs/vuetify/commit/59b8422b3a3cd5048f990c1ccd636f0f5b89cd16))
* **mutate:** add a new directive ([#9148](https://github.com/vuetifyjs/vuetify/issues/9148)) ([51de110](https://github.com/vuetifyjs/vuetify/commit/51de110c71d6145e54507216bbaa1448f4b454a4))
* **presets:** add new service ([#9894](https://github.com/vuetifyjs/vuetify/issues/9894)) ([5c0a67c](https://github.com/vuetifyjs/vuetify/commit/5c0a67c1dff1ceb4b84168dd42a80f1beeb70e8f))
* **rounded:** add border-radius helper classes ([82dbdbf](https://github.com/vuetifyjs/vuetify/commit/82dbdbf58a0caf3ade7d0d5c2ffa4c42800caad6))
* **sass:** create more preset variables ([#9766](https://github.com/vuetifyjs/vuetify/issues/9766)) ([2c901ba](https://github.com/vuetifyjs/vuetify/commit/2c901ba806db5a20af342c0eaa2b28634b114924))
* **types:** expose public interfaces for props and slots ([#9763](https://github.com/vuetifyjs/vuetify/issues/9763)) ([b03b507](https://github.com/vuetifyjs/vuetify/commit/b03b507fc811ce4657a8cdbc3993ed58932cbab6))
* **typography:** add break-point functionality to new type classes ([#11033](https://github.com/vuetifyjs/vuetify/issues/11033)) ([e83a203](https://github.com/vuetifyjs/vuetify/commit/e83a203c8dc13c02eb75792d1de9404c8e998798))
* **typography:** add new variables for font-family ([fb84327](https://github.com/vuetifyjs/vuetify/commit/fb8432741ebe4bb4c84cf40c65826e72896c39d2))
* **v-scroll:** add self modifier to target the bound element ([#11244](https://github.com/vuetifyjs/vuetify/issues/11244)) ([9748731](https://github.com/vuetifyjs/vuetify/commit/9748731c072f6d83ce326666d2315fc275ed1333))
* **VAlert:** add closeIcon prop ([#11124](https://github.com/vuetifyjs/vuetify/issues/11124)) ([ec151b3](https://github.com/vuetifyjs/vuetify/commit/ec151b3ae11bfc7b410d21b41916ddead440d807))
* **VAutocomplete:** make items copy-pasteable ([#7759](https://github.com/vuetifyjs/vuetify/issues/7759)) ([c72f902](https://github.com/vuetifyjs/vuetify/commit/c72f902aadaf6963c530b709e1bf479756940728)), closes [#6226](https://github.com/vuetifyjs/vuetify/issues/6226)
* **VBadge:** refactor for v2.2 ([#9328](https://github.com/vuetifyjs/vuetify/issues/9328)) ([b7fe7c2](https://github.com/vuetifyjs/vuetify/commit/b7fe7c2b8493428fcc612fd2066142f5bb1ac123)), closes [#8245](https://github.com/vuetifyjs/vuetify/issues/8245)
* **VBanner:** allow banner text to extend full-width ([a3466e0](https://github.com/vuetifyjs/vuetify/commit/a3466e0ec9d7b7bb9bd1f28a9f608257b73a71d2))
* **VBtn:** add retainFocusOnClick property ([#9046](https://github.com/vuetifyjs/vuetify/issues/9046)) ([14a0acd](https://github.com/vuetifyjs/vuetify/commit/14a0acd8ad8fc4d856457ca299f8c889985cce6e))
* **VBtnToggle:** add new variants ([#7582](https://github.com/vuetifyjs/vuetify/issues/7582)) ([33f031a](https://github.com/vuetifyjs/vuetify/commit/33f031a3b2219237a2cd0a159238b31227a82935)), closes [#4325](https://github.com/vuetifyjs/vuetify/issues/4325)
* **VCalendar:** redo event overlap logic ([#9974](https://github.com/vuetifyjs/vuetify/issues/9974)) ([20a7a1a](https://github.com/vuetifyjs/vuetify/commit/20a7a1a06a683b696921bc0a877d814e6f76bdc0)), closes [#8826](https://github.com/vuetifyjs/vuetify/issues/8826) [#8928](https://github.com/vuetifyjs/vuetify/issues/8928) [#8620](https://github.com/vuetifyjs/vuetify/issues/8620) [#8396](https://github.com/vuetifyjs/vuetify/issues/8396) [#8792](https://github.com/vuetifyjs/vuetify/issues/8792) [#8937](https://github.com/vuetifyjs/vuetify/issues/8937) [#8565](https://github.com/vuetifyjs/vuetify/issues/8565) [#8400](https://github.com/vuetifyjs/vuetify/issues/8400)
* **VCard:** add elevation SASS variable ([575acbd](https://github.com/vuetifyjs/vuetify/commit/575acbda788a1332ebd124c4d74484870c9bfe8b))
* **VCard:** add new shaped prop ([18d732d](https://github.com/vuetifyjs/vuetify/commit/18d732d24fa0b912f1bca731b9de8b56717f31b2))
* **VCard:** increase hover effect when focusing ([#8143](https://github.com/vuetifyjs/vuetify/issues/8143)) ([5dc3345](https://github.com/vuetifyjs/vuetify/commit/5dc3345e2a73765ea844ac33b4a4f2ebd41d85eb))
* **VCol:** add justify-self property ([1ba5f82](https://github.com/vuetifyjs/vuetify/commit/1ba5f829cb727452343abc7db03b440da78a6357))
* **vdata:** custom grouping functions ([#9253](https://github.com/vuetifyjs/vuetify/issues/9253)) ([87f22c2](https://github.com/vuetifyjs/vuetify/commit/87f22c2d5e742c2c87df65c258f5576fefd9081a))
* **VDataFooter:** added page-text prop ([#8511](https://github.com/vuetifyjs/vuetify/issues/8511)) ([d00534f](https://github.com/vuetifyjs/vuetify/commit/d00534f2ad9902ace931b150cfacc1dba3171821)), closes [#8110](https://github.com/vuetifyjs/vuetify/issues/8110)
* **VDataIterator:** add current items to toggle-select-all event ([#9641](https://github.com/vuetifyjs/vuetify/issues/9641)) ([ab28d72](https://github.com/vuetifyjs/vuetify/commit/ab28d728e63ebbc134f543806b64e0aa99e9d752)), closes [#8532](https://github.com/vuetifyjs/vuetify/issues/8532)
* **VDataIterator:** emit the page-count event from VData ([#10588](https://github.com/vuetifyjs/vuetify/issues/10588)) ([db98a1e](https://github.com/vuetifyjs/vuetify/commit/db98a1e2bc6b544abf9583c6a454bca718ae0894))
* **VDataIterator:** items can now be made unselectable ([#9645](https://github.com/vuetifyjs/vuetify/issues/9645)) ([65256b2](https://github.com/vuetifyjs/vuetify/commit/65256b256dad0f0c2d69a7e173d91b46f252519b)), closes [#8915](https://github.com/vuetifyjs/vuetify/issues/8915)
* **VDataIterator:** propagate and add toggle-select-all event ([#8975](https://github.com/vuetifyjs/vuetify/issues/8975)) ([c9b00db](https://github.com/vuetifyjs/vuetify/commit/c9b00dbd845783be3849ac712f0c943e23981eb7)), closes [#8974](https://github.com/vuetifyjs/vuetify/issues/8974)
* **VDatatable:** add isOpen to group.header slot parameters ([#9721](https://github.com/vuetifyjs/vuetify/issues/9721)) ([bb26a2e](https://github.com/vuetifyjs/vuetify/commit/bb26a2ee0a6e9a13bdf468bee12711cade78537d))
* **VDataTable:** add contexmenu:row event for data table ([#10989](https://github.com/vuetifyjs/vuetify/issues/10989)) ([26c9ec9](https://github.com/vuetifyjs/vuetify/commit/26c9ec9bb60429b422a93ebf96a1c52c3113274e)), closes [#9382](https://github.com/vuetifyjs/vuetify/issues/9382)
* **VDataTable:** added filterable property to header items ([#8439](https://github.com/vuetifyjs/vuetify/issues/8439)) ([00c6a73](https://github.com/vuetifyjs/vuetify/commit/00c6a73b867702574673358e622492822f3db4a3)), closes [#8242](https://github.com/vuetifyjs/vuetify/issues/8242)
* **VDataTable:** expose expand/select functionality ([#9642](https://github.com/vuetifyjs/vuetify/issues/9642)) ([587edf9](https://github.com/vuetifyjs/vuetify/commit/587edf964cb3c9148184c775d17611b94103cacb)), closes [#8008](https://github.com/vuetifyjs/vuetify/issues/8008)
* **VDataTable:** hide sort by select on mobile if not needed ([#9215](https://github.com/vuetifyjs/vuetify/issues/9215)) ([665ebe3](https://github.com/vuetifyjs/vuetify/commit/665ebe34473606be487b7d55ec0ccaf0fc856fed)), closes [#9209](https://github.com/vuetifyjs/vuetify/issues/9209)
* **VDatePicker:** pick date range ([#8891](https://github.com/vuetifyjs/vuetify/issues/8891)) ([64867ba](https://github.com/vuetifyjs/vuetify/commit/64867ba6274548d4aec7b979386fb0e31ce155ea)), closes [#1646](https://github.com/vuetifyjs/vuetify/issues/1646)
* **VExpansionPanels:** implement flat, tile, hover, and color props ([#9643](https://github.com/vuetifyjs/vuetify/issues/9643)) ([39d7e1e](https://github.com/vuetifyjs/vuetify/commit/39d7e1e3bcad6daf7abffd6797c492a041474997)), closes [#8939](https://github.com/vuetifyjs/vuetify/issues/8939)
* **VIcon:** add font awesome duotone support ([#9170](https://github.com/vuetifyjs/vuetify/issues/9170)) ([629b595](https://github.com/vuetifyjs/vuetify/commit/629b595312136ec98c86fc399946b57e3956c55e)), closes [#8398](https://github.com/vuetifyjs/vuetify/issues/8398)
* **VIcon:** shorter iconName prefix ([#7672](https://github.com/vuetifyjs/vuetify/issues/7672)) ([952f561](https://github.com/vuetifyjs/vuetify/commit/952f561bb9d2278f5920f202fb8be8932d5dfe73))
* **VImg:** add lazy loading functionality ([0df5f42](https://github.com/vuetifyjs/vuetify/commit/0df5f4290f2338066af3fe032cadf10f22fbf5ad))
* **VImg:** add themeable support ([#11034](https://github.com/vuetifyjs/vuetify/issues/11034)) ([5e13729](https://github.com/vuetifyjs/vuetify/commit/5e137292f54ebe9ae6ab1b76926c01373bf71d41))
* **VImg:** add themeable support ([#9805](https://github.com/vuetifyjs/vuetify/issues/9805)) ([5d180dd](https://github.com/vuetifyjs/vuetify/commit/5d180dd235b8801545ec49db2a701cd14fdea051))
* **VImg:** remove error logging ([755dc3d](https://github.com/vuetifyjs/vuetify/commit/755dc3d0380ac9a02d6e67a77a8603f222238169)), closes [#6755](https://github.com/vuetifyjs/vuetify/issues/6755)
* **VInput:** add dense prop ([#8810](https://github.com/vuetifyjs/vuetify/issues/8810)) ([5bfc87e](https://github.com/vuetifyjs/vuetify/commit/5bfc87e23f6d664276d78dfb93593a3a0f851def)), closes [#1846](https://github.com/vuetifyjs/vuetify/issues/1846)
* **VInput:** auto hiding details if no messages/counter ([#7472](https://github.com/vuetifyjs/vuetify/issues/7472)) ([7a9080a](https://github.com/vuetifyjs/vuetify/commit/7a9080a0dd856be67d74c53476ae7363e4df65be)), closes [#7434](https://github.com/vuetifyjs/vuetify/issues/7434)
* **VIntersect:** add new directive ([#9071](https://github.com/vuetifyjs/vuetify/issues/9071)) ([9aee2d6](https://github.com/vuetifyjs/vuetify/commit/9aee2d6f6c63af30a9be7c1d4ef605d8fe15b526))
* **VLazy:** add measurable mixin ([a3a4e67](https://github.com/vuetifyjs/vuetify/commit/a3a4e678f63594dac4c761deeeb7d6ddae86a66e))
* **VLazy:** add new component ([86590b4](https://github.com/vuetifyjs/vuetify/commit/86590b468bb7b936238015dd7c5068ebd4bf9df5))
* **VLazy:** add tag prop ([00fb555](https://github.com/vuetifyjs/vuetify/commit/00fb5558766614314ebe5b9f0a089cf41786aec5)), closes [#9191](https://github.com/vuetifyjs/vuetify/issues/9191)
* **VListItem:** add selectable prop ([#8622](https://github.com/vuetifyjs/vuetify/issues/8622)) ([b6c4f15](https://github.com/vuetifyjs/vuetify/commit/b6c4f15c764861fff90fc98152ae991f5831fb30)), closes [#8464](https://github.com/vuetifyjs/vuetify/issues/8464)
* **VPagination:** add a11y support ([#9926](https://github.com/vuetifyjs/vuetify/issues/9926)) ([042a4bd](https://github.com/vuetifyjs/vuetify/commit/042a4bd47d508fcd86dc06b60bf7c5a31c46dc60)), closes [#9849](https://github.com/vuetifyjs/vuetify/issues/9849)
* **VPicker:** `flat` and `elevation` props for pickers ([#10362](https://github.com/vuetifyjs/vuetify/issues/10362)) ([e557759](https://github.com/vuetifyjs/vuetify/commit/e5577598156dd877f64b11e321e14b678a821a1a)), closes [#6006](https://github.com/vuetifyjs/vuetify/issues/6006)
* **VProgressLinear:** add new **reverse** prop ([#11259](https://github.com/vuetifyjs/vuetify/issues/11259)) ([b4e16c6](https://github.com/vuetifyjs/vuetify/commit/b4e16c6668e14889570c8daa014aa8829d95b4fa)), closes [#11245](https://github.com/vuetifyjs/vuetify/issues/11245)
* **VSelect:** add prop for disabling keyboard lookup ([#9297](https://github.com/vuetifyjs/vuetify/issues/9297)) ([b0a7c30](https://github.com/vuetifyjs/vuetify/commit/b0a7c300009ee07c2f93b53bf7e7a92b83026037)), closes [#9271](https://github.com/vuetifyjs/vuetify/issues/9271)
* **VSelect:** emit selected listIndex event ([#7828](https://github.com/vuetifyjs/vuetify/issues/7828)) ([b795145](https://github.com/vuetifyjs/vuetify/commit/b7951455defba24d39476d5acb846a54fa27cbac)), closes [#7808](https://github.com/vuetifyjs/vuetify/issues/7808)
* **VSkeletonLoader:** add new component ([#9037](https://github.com/vuetifyjs/vuetify/issues/9037)) ([160c7e8](https://github.com/vuetifyjs/vuetify/commit/160c7e8e94f540ce841cc771c60e704b777dab7f))
* **VSnackbar:** add border-radius sass variable ([5b7341e](https://github.com/vuetifyjs/vuetify/commit/5b7341e82208511297c9600eca8b26e1e8c915ab))
* **VTabs:** add new bar-background-color variable ([72f46dc](https://github.com/vuetifyjs/vuetify/commit/72f46dc52ca50f7544f4cc248b6854f6bafcb031))
* **VTextField:** add $text-field-filled-border-radius sass variable ([d1a0189](https://github.com/vuetifyjs/vuetify/commit/d1a0189faccf1a5d323a1d4c68e2bebd3c8845a3))
* **VTextField:** add customizable counter value ([#8802](https://github.com/vuetifyjs/vuetify/issues/8802)) ([9aa761e](https://github.com/vuetifyjs/vuetify/commit/9aa761e87722188b07f4e275b57ffbac3f0e2a89)), closes [#8788](https://github.com/vuetifyjs/vuetify/issues/8788)
* **VThemeProvider:** add new component ([#9804](https://github.com/vuetifyjs/vuetify/issues/9804)) ([2dba817](https://github.com/vuetifyjs/vuetify/commit/2dba817f046d61d6eb05a7ed27d0893040f84b67))
* **VTimePicker:** show am/pm indicator in title and in clock ([#10364](https://github.com/vuetifyjs/vuetify/issues/10364)) ([279af0e](https://github.com/vuetifyjs/vuetify/commit/279af0e8bd24df7d08885ceff5d2baa258dfa921)), closes [#9572](https://github.com/vuetifyjs/vuetify/issues/9572)
* added color and opacity props to overlayable mixin ([#8861](https://github.com/vuetifyjs/vuetify/issues/8861)) ([fc7697d](https://github.com/vuetifyjs/vuetify/commit/fc7697df2cd889d8dbe0d01517787317d911bb15)), closes [#8301](https://github.com/vuetifyjs/vuetify/issues/8301)
* **VTimePicker:** am/pm i18n. ([#9032](https://github.com/vuetifyjs/vuetify/issues/9032)) ([0b8fa7c](https://github.com/vuetifyjs/vuetify/commit/0b8fa7c9a0d92908c35c4883dd091cb386f604d2))
* **VVirtualScroll :** add new component ([#10944](https://github.com/vuetifyjs/vuetify/issues/10944)) ([a1423cd](https://github.com/vuetifyjs/vuetify/commit/a1423cd9bb147a2d6e313ab8b6ad2feeb8ea1ed5))
* use a bootstrap-style grid system ([#7327](https://github.com/vuetifyjs/vuetify/issues/7327)) ([9c122fe](https://github.com/vuetifyjs/vuetify/commit/9c122fe71b421d0509cec745bafb7277fdf8f317)), closes [#1434](https://github.com/vuetifyjs/vuetify/issues/1434) [#5168](https://github.com/vuetifyjs/vuetify/issues/5168) [#5272](https://github.com/vuetifyjs/vuetify/issues/5272) [#6020](https://github.com/vuetifyjs/vuetify/issues/6020) [#7733](https://github.com/vuetifyjs/vuetify/issues/7733)
* **locale:** remove obsolete gr.ts locale ([f0a3b23](https://github.com/vuetifyjs/vuetify/commit/f0a3b23877c7531e1707cbfa1c57cde8e8dcfbc0))
* **VAlert:** add text variant ([76d70e3](https://github.com/vuetifyjs/vuetify/commit/76d70e3219ae0dade2887ff3841e620e9243b414))
* **VAlert:** refactor for v2 ([#6107](https://github.com/vuetifyjs/vuetify/issues/6107)) ([c889973](https://github.com/vuetifyjs/vuetify/commit/c88997356cb5dda6974f81c0843b7ad3f1cdad9d)), closes [#6126](https://github.com/vuetifyjs/vuetify/issues/6126) [#3768](https://github.com/vuetifyjs/vuetify/issues/3768) [#6125](https://github.com/vuetifyjs/vuetify/issues/6125) [#6064](https://github.com/vuetifyjs/vuetify/issues/6064) [#5881](https://github.com/vuetifyjs/vuetify/issues/5881) [#6088](https://github.com/vuetifyjs/vuetify/issues/6088) [#6080](https://github.com/vuetifyjs/vuetify/issues/6080)
* **VAvatar:** update to md2 ([#6433](https://github.com/vuetifyjs/vuetify/issues/6433)) ([b19947e](https://github.com/vuetifyjs/vuetify/commit/b19947ea694d03d397e3114df3dfaf4c5629236a))
* **VBadge:** update to md2 ([#6514](https://github.com/vuetifyjs/vuetify/issues/6514)) ([f5c9a9d](https://github.com/vuetifyjs/vuetify/commit/f5c9a9d5d5012c19f9f95221868a159e59c9e02e))
* **VBanner:** add new component ([#6520](https://github.com/vuetifyjs/vuetify/issues/6520)) ([043fff0](https://github.com/vuetifyjs/vuetify/commit/043fff01e3554ffd0f3c7d848b9c9eb1f56457c2))
* **VCalendar:** add new component ([#6092](https://github.com/vuetifyjs/vuetify/issues/6092)) ([1f3dd1e](https://github.com/vuetifyjs/vuetify/commit/1f3dd1ebfa0e57a74e199d55f5b4fc8bead6c672))
* **VCalendar:** use $vuetify.lang.current as default language ([#6613](https://github.com/vuetifyjs/vuetify/issues/6613)) ([5bd9708](https://github.com/vuetifyjs/vuetify/commit/5bd97081c42176c5594a9fb6c8b70531c650240f))
* **VChip/Group:** add v-chip-group and update to md2 ([#6303](https://github.com/vuetifyjs/vuetify/issues/6303)) ([a317d8b](https://github.com/vuetifyjs/vuetify/commit/a317d8b246d05a2df7c681206f69df4dc2157ccd)), closes [#6270](https://github.com/vuetifyjs/vuetify/issues/6270) [#6279](https://github.com/vuetifyjs/vuetify/issues/6279) [#6286](https://github.com/vuetifyjs/vuetify/issues/6286) [#6297](https://github.com/vuetifyjs/vuetify/issues/6297) [#6299](https://github.com/vuetifyjs/vuetify/issues/6299) [#6301](https://github.com/vuetifyjs/vuetify/issues/6301) [#6302](https://github.com/vuetifyjs/vuetify/issues/6302)
* **VDataTable:** add row click event ([#7578](https://github.com/vuetifyjs/vuetify/issues/7578)) ([e3e494a](https://github.com/vuetifyjs/vuetify/commit/e3e494a3f310de249e34e6e2b5bd471c6e44e43e)), closes [#7491](https://github.com/vuetifyjs/vuetify/issues/7491)
* **VDataTable:** column filtering ([#7271](https://github.com/vuetifyjs/vuetify/issues/7271)) ([60a5a09](https://github.com/vuetifyjs/vuetify/commit/60a5a09658da679ce0c39ffa347a88cd64a169ae))
* **VDataTable:** enable customization of select/expand headers ([#7235](https://github.com/vuetifyjs/vuetify/issues/7235)) ([f047b6f](https://github.com/vuetifyjs/vuetify/commit/f047b6f59aa71c7e97b378d69552ffbfe67557a6)), closes [#3376](https://github.com/vuetifyjs/vuetify/issues/3376)
* **VDatePicker:** selected items count translation ([#7361](https://github.com/vuetifyjs/vuetify/issues/7361)) ([dac2af9](https://github.com/vuetifyjs/vuetify/commit/dac2af9a883853fe669812eb176c0108b4da317a)), closes [#7070](https://github.com/vuetifyjs/vuetify/issues/7070)
* **VDatePicker:** use $vuetify.lang.current ([#6320](https://github.com/vuetifyjs/vuetify/issues/6320)) ([814a372](https://github.com/vuetifyjs/vuetify/commit/814a3728f7eb86511296a6300fa11bfc9aba6d4b)), closes [#5618](https://github.com/vuetifyjs/vuetify/issues/5618)
* **VDivider:** adds a11y attributes ([#7708](https://github.com/vuetifyjs/vuetify/issues/7708)) ([83bc365](https://github.com/vuetifyjs/vuetify/commit/83bc365d8c6cb38cb766f82e0484bf7fb3668778))
* **VDivider:** update to md2 ([#6582](https://github.com/vuetifyjs/vuetify/issues/6582)) ([5adf0ea](https://github.com/vuetifyjs/vuetify/commit/5adf0ea04d380bca401721270e915886f7473ccf))
* **VFileInput:** add new component ([#7654](https://github.com/vuetifyjs/vuetify/issues/7654)) ([1d4dd66](https://github.com/vuetifyjs/vuetify/commit/1d4dd66d5591e2bca0c314320d1625d4a9281998)), closes [#238](https://github.com/vuetifyjs/vuetify/issues/238)
* **VGrid:** add grow-shrink-0 ([#6538](https://github.com/vuetifyjs/vuetify/issues/6538)) ([2db5690](https://github.com/vuetifyjs/vuetify/commit/2db569080a41c048e7a706d2730344d1be0bf0e6)), closes [#6530](https://github.com/vuetifyjs/vuetify/issues/6530)
* **VGrid:** pass down data-* attributes ([#6208](https://github.com/vuetifyjs/vuetify/issues/6208)) ([198a3d4](https://github.com/vuetifyjs/vuetify/commit/198a3d460cfb169d0333ec0ed4fec181aad3ef00))
* **VIcon:** Accessible icon button ([#7198](https://github.com/vuetifyjs/vuetify/issues/7198)) ([3e8d0ac](https://github.com/vuetifyjs/vuetify/commit/3e8d0ac8a6bb65a193f6f7d0895755f6d28a0cab)), closes [#4770](https://github.com/vuetifyjs/vuetify/issues/4770)
* **VIcon:** update to md2 ([#6439](https://github.com/vuetifyjs/vuetify/issues/6439)) ([aca9ba5](https://github.com/vuetifyjs/vuetify/commit/aca9ba5c0b1ebf463cd5b687901b59bc6511096d))
* **VItemGroup:** update to md2 ([#6631](https://github.com/vuetifyjs/vuetify/issues/6631)) ([2d6d90c](https://github.com/vuetifyjs/vuetify/commit/2d6d90c865e7da9ccf2809fcac26c0921471ae11))
* **VLabel:** update to md2 ([#6584](https://github.com/vuetifyjs/vuetify/issues/6584)) ([4dd4c9b](https://github.com/vuetifyjs/vuetify/commit/4dd4c9bddd171f245c843c2bb893175fd89b8b5d))
* **VList/Item/Group:** improve a11y ([#7651](https://github.com/vuetifyjs/vuetify/issues/7651)) ([5928b65](https://github.com/vuetifyjs/vuetify/commit/5928b651780d562b96cf2f3ebd396c3301da0fb2))
* **VMessages:** update to md2 ([#6585](https://github.com/vuetifyjs/vuetify/issues/6585)) ([30a174f](https://github.com/vuetifyjs/vuetify/commit/30a174f60e117d49bc092723c5937220844313b2))
* **VRating:** convert to md2 ([bc91c41](https://github.com/vuetifyjs/vuetify/commit/bc91c411da2fa26323ea48e375042f49bd373edd))
* **VSparkline:** render negative values in bar mode ([f8d180c](https://github.com/vuetifyjs/vuetify/commit/f8d180cd9891090a7acb9cafc3882f318b076d0a))
* **VTabs:** center-active prop ([#7238](https://github.com/vuetifyjs/vuetify/issues/7238)) ([bd4a873](https://github.com/vuetifyjs/vuetify/commit/bd4a873d1f6b891d71a196306ea426172cece142))
* **VTextField:** remove mask functionality ([#7304](https://github.com/vuetifyjs/vuetify/issues/7304)) ([0cecd4a](https://github.com/vuetifyjs/vuetify/commit/0cecd4a5dc3aed38470ba2a5cf4ab6672d306ac1))
* **VTextField:** update to md2 ([#7157](https://github.com/vuetifyjs/vuetify/issues/7157)) ([32c77ee](https://github.com/vuetifyjs/vuetify/commit/32c77ee07213c64dacfa6921b12003a96796a5f9))
* **VTreeview:** **color** prop ([#7617](https://github.com/vuetifyjs/vuetify/issues/7617)) ([b60b094](https://github.com/vuetifyjs/vuetify/commit/b60b0943e8fef9aede30075ac1f8507055a0243f)), closes [#7613](https://github.com/vuetifyjs/vuetify/issues/7613)
* **VTreeview:** **dense** prop, css tweaks ([#7518](https://github.com/vuetifyjs/vuetify/issues/7518)) ([3bdffae](https://github.com/vuetifyjs/vuetify/commit/3bdffaecf994df07be7146ab8606817a9a3b78d7)), closes [#7475](https://github.com/vuetifyjs/vuetify/issues/7475)
* **VTreeview:** **item-disabled** prop ([#7618](https://github.com/vuetifyjs/vuetify/issues/7618)) ([ae15ed8](https://github.com/vuetifyjs/vuetify/commit/ae15ed825837eac0134b336ed4219cc33faff9bb))
* **VTreeview:** **rounded**/**shaped** props ([#7616](https://github.com/vuetifyjs/vuetify/issues/7616)) ([acfdef7](https://github.com/vuetifyjs/vuetify/commit/acfdef7bec8dd521d2ea87382276c25f016fc84f)), closes [#7614](https://github.com/vuetifyjs/vuetify/issues/7614)
* **VTreeview:** add selectionType prop ([#7575](https://github.com/vuetifyjs/vuetify/issues/7575)) ([2ecec4a](https://github.com/vuetifyjs/vuetify/commit/2ecec4ab0d95b5c879334cb8871039d9638e39a5)), closes [#6903](https://github.com/vuetifyjs/vuetify/issues/6903)
* add arabic locale ([#6291](https://github.com/vuetifyjs/vuetify/issues/6291)) ([3c600da](https://github.com/vuetifyjs/vuetify/commit/3c600daa2cc29723bce5e78ed63249cc272761bc))
* add Japanese locale ([#6274](https://github.com/vuetifyjs/vuetify/issues/6274)) ([1a02856](https://github.com/vuetifyjs/vuetify/commit/1a02856cb35964bb7f234f22a97aec8ab1aa5349))
* add slovenian locale ([#6345](https://github.com/vuetifyjs/vuetify/issues/6345)) ([941389f](https://github.com/vuetifyjs/vuetify/commit/941389f24847ab80775f406e38393d3f00172864))
* add turkish locale ([#6384](https://github.com/vuetifyjs/vuetify/issues/6384)) ([20d2332](https://github.com/vuetifyjs/vuetify/commit/20d2332da0d13dea10c3a3a71fb65e6fe3d64d8b))
* create v-expand-x-transition ([e0efefe](https://github.com/vuetifyjs/vuetify/commit/e0efefe6f5c24559e63670d50b01d836fd42ce76))
* include helper json in built dist folder ([#7551](https://github.com/vuetifyjs/vuetify/issues/7551)) ([ce8538f](https://github.com/vuetifyjs/vuetify/commit/ce8538f8e1ab0b19967b4ce02355b885d4686280))
* **a-la-carte:** add type defs for vuetify/lib ([eb27425](https://github.com/vuetifyjs/vuetify/commit/eb27425806983591c2e6e09da3f45bb826a4c425))
* **activatable:** create new mixin ([#7037](https://github.com/vuetifyjs/vuetify/issues/7037)) ([553a0d8](https://github.com/vuetifyjs/vuetify/commit/553a0d8c1e5e98014451ef7d2253778712bbfec8))
* **bootable:** update for v2 ([#6735](https://github.com/vuetifyjs/vuetify/issues/6735)) ([5cc2d07](https://github.com/vuetifyjs/vuetify/commit/5cc2d07e4267066468b1695fe71637efceddd7bc))
* **locale:** add Hebrew locale files ([#6872](https://github.com/vuetifyjs/vuetify/issues/6872)) ([184512c](https://github.com/vuetifyjs/vuetify/commit/184512c69a112b0657156fc48571e5d760c23631))
* **theme:** add reactivity ([#6882](https://github.com/vuetifyjs/vuetify/issues/6882)) ([7261bdc](https://github.com/vuetifyjs/vuetify/commit/7261bdc3c0d3d54bc1de0b70cd45e7cda6320be9))
* **theme:** add setTheme and resetTheme methods ([6b4d2a9](https://github.com/vuetifyjs/vuetify/commit/6b4d2a9bc91a61dd6e41520f54841f901e855222))
* **typography:** change root font size, update caption rem size ([bee34ca](https://github.com/vuetifyjs/vuetify/commit/bee34ca3ba3fcbc176b35d0834e3efa7ba01a1f1))
* **typography:** update typography font weight to md2 ([#6653](https://github.com/vuetifyjs/vuetify/issues/6653)) ([1f8b620](https://github.com/vuetifyjs/vuetify/commit/1f8b620f101a56f90758b4362c271abd32af1a6c))
* **v-dialog:** adds click:outside call ([#6719](https://github.com/vuetifyjs/vuetify/issues/6719)) ([aa64854](https://github.com/vuetifyjs/vuetify/commit/aa648546aedaf0f7039e18bfb2708be07646196c))
* **VAppBar:** update application state on scrolling effects change ([358c62c](https://github.com/vuetifyjs/vuetify/commit/358c62ca4ce4512f2ef9b3f4694f9e541d9b0769)), closes [#3820](https://github.com/vuetifyjs/vuetify/issues/3820)
* **VBadge:** add support for more characters ([494bb28](https://github.com/vuetifyjs/vuetify/commit/494bb2833cb13e6d50280e63e5b972ab3c33e404)), closes [#4934](https://github.com/vuetifyjs/vuetify/issues/4934)
* **VCard:** update to md2 ([#6788](https://github.com/vuetifyjs/vuetify/issues/6788)) ([a63b300](https://github.com/vuetifyjs/vuetify/commit/a63b300842c191c65ed646b61bb6f3bf4388c588)), closes [#3925](https://github.com/vuetifyjs/vuetify/issues/3925)
* **VCarousel:** v2 update ([#6924](https://github.com/vuetifyjs/vuetify/issues/6924)) ([5c06f4d](https://github.com/vuetifyjs/vuetify/commit/5c06f4dfc58aab16c7011176b30260f7e6ac88d1)), closes [#6158](https://github.com/vuetifyjs/vuetify/issues/6158) [#6067](https://github.com/vuetifyjs/vuetify/issues/6067) [#6261](https://github.com/vuetifyjs/vuetify/issues/6261) [#6696](https://github.com/vuetifyjs/vuetify/issues/6696)
* **VExpansionPanel:** update to v2 ([#6720](https://github.com/vuetifyjs/vuetify/issues/6720)) ([f891304](https://github.com/vuetifyjs/vuetify/commit/f89130422fc0f328972ff2cedc72d42ad77cda2b)), closes [#6663](https://github.com/vuetifyjs/vuetify/issues/6663) [#6290](https://github.com/vuetifyjs/vuetify/issues/6290)
* **VFooter:** update for v2 ([#6711](https://github.com/vuetifyjs/vuetify/issues/6711)) ([959f074](https://github.com/vuetifyjs/vuetify/commit/959f07440fedb76473dedb71b1b0766d238a8531)), closes [#5444](https://github.com/vuetifyjs/vuetify/issues/5444) [#4872](https://github.com/vuetifyjs/vuetify/issues/4872)
* **VIcon:** Add 'tag' prop to VIcon that sets a custom tag to be used ([#6899](https://github.com/vuetifyjs/vuetify/issues/6899)) ([6504a7a](https://github.com/vuetifyjs/vuetify/commit/6504a7a8573d2881c8d9a459035375c86df85a58))
* **VIcon:** add svg path support and update default iconfont ([#6815](https://github.com/vuetifyjs/vuetify/issues/6815)) ([3997c53](https://github.com/vuetifyjs/vuetify/commit/3997c5394a1036ed0910e6c89523e1caf71c835e))
* **VIcon:** remove the need for svg- prefix ([#7019](https://github.com/vuetifyjs/vuetify/issues/7019)) ([e6a291d](https://github.com/vuetifyjs/vuetify/commit/e6a291dc86d8bd2adf3a895e63c2aad64eb17886))
* **VImg:** use inherent width from image ([#5788](https://github.com/vuetifyjs/vuetify/issues/5788)) ([09725fc](https://github.com/vuetifyjs/vuetify/commit/09725fc8f27d1ec543fced9236b033629c940b8c)), closes [#5757](https://github.com/vuetifyjs/vuetify/issues/5757)
* **VList:** add **rounded** prop ([fa8bb1b](https://github.com/vuetifyjs/vuetify/commit/fa8bb1b70c5853b9b23c9281f37862f5b06119ec))
* **VList:** add right padding for shaped list-items ([26a47a2](https://github.com/vuetifyjs/vuetify/commit/26a47a2fec0a15be1204e20be254b395c1a66cf5))
* **VList:** update to md2 ([#6648](https://github.com/vuetifyjs/vuetify/issues/6648)) ([afed09a](https://github.com/vuetifyjs/vuetify/commit/afed09acc90718f612e455b23c54ea1473273543)), closes [#4180](https://github.com/vuetifyjs/vuetify/issues/4180) [#3597](https://github.com/vuetifyjs/vuetify/issues/3597) [#6455](https://github.com/vuetifyjs/vuetify/issues/6455)
* **VListGroup:** add indent for **no-action** sub-groups ([79c9825](https://github.com/vuetifyjs/vuetify/commit/79c98251c809f8fae088deecd80108dc003de556))
* **VNavigationDrawer:** update to md2 ([#6947](https://github.com/vuetifyjs/vuetify/issues/6947)) ([f8a6c20](https://github.com/vuetifyjs/vuetify/commit/f8a6c20deaa07efca2aec5ae08c1a93515d26a5b)), closes [#6283](https://github.com/vuetifyjs/vuetify/issues/6283) [#3919](https://github.com/vuetifyjs/vuetify/issues/3919) [#6926](https://github.com/vuetifyjs/vuetify/issues/6926) [#2606](https://github.com/vuetifyjs/vuetify/issues/2606) [#4233](https://github.com/vuetifyjs/vuetify/issues/4233) [#6652](https://github.com/vuetifyjs/vuetify/issues/6652)
* **VOverlay:** create new component ([#6768](https://github.com/vuetifyjs/vuetify/issues/6768)) ([69b15cf](https://github.com/vuetifyjs/vuetify/commit/69b15cf0ee9d5d3c7b52016a71c4e185f22c4d4b))
* **VProgressLinear:** update to md2 ([#7057](https://github.com/vuetifyjs/vuetify/issues/7057)) ([fa69676](https://github.com/vuetifyjs/vuetify/commit/fa69676d1b136723ee6e7617f94e7937dd951d95)), closes [#5147](https://github.com/vuetifyjs/vuetify/issues/5147)
* **VSlider:** update to md2 spec ([#6424](https://github.com/vuetifyjs/vuetify/issues/6424)) ([5e7b72f](https://github.com/vuetifyjs/vuetify/commit/5e7b72ffdd4e3d4a343e29f2bb6c0c017a29636a)), closes [#5650](https://github.com/vuetifyjs/vuetify/issues/5650)
* **VSwitch:** update to md2 ([#6851](https://github.com/vuetifyjs/vuetify/issues/6851)) ([72b5895](https://github.com/vuetifyjs/vuetify/commit/72b58953037f59d2925bc6b22b703a4e119e9d3d))
* **VTabs:** update to md2 ([#6606](https://github.com/vuetifyjs/vuetify/issues/6606)) ([f22d754](https://github.com/vuetifyjs/vuetify/commit/f22d754e4eac04b1266b406137242af3fd14f4f3)), closes [#6575](https://github.com/vuetifyjs/vuetify/issues/6575) [#5398](https://github.com/vuetifyjs/vuetify/issues/5398) [#6505](https://github.com/vuetifyjs/vuetify/issues/6505) [#3971](https://github.com/vuetifyjs/vuetify/issues/3971) [#4420](https://github.com/vuetifyjs/vuetify/issues/4420)
* **VTimeline:** add reverse functionality, convert to md2 ([#6656](https://github.com/vuetifyjs/vuetify/issues/6656)) ([deb3e3d](https://github.com/vuetifyjs/vuetify/commit/deb3e3d2f4e250a19925c3ab83c61d24146b9fd8)), closes [#5437](https://github.com/vuetifyjs/vuetify/issues/5437)
* **VTimePicker:** update to md2 ([#6869](https://github.com/vuetifyjs/vuetify/issues/6869)) ([da54462](https://github.com/vuetifyjs/vuetify/commit/da54462f7003c085e0e2945832b87692807c840d))
* add Latvian locale ([#6784](https://github.com/vuetifyjs/vuetify/issues/6784)) ([ee1ac86](https://github.com/vuetifyjs/vuetify/commit/ee1ac86680a02649082c400428c77c60cb635893))
* **VToolbar/VAppBar:** update to md2 spec ([#6701](https://github.com/vuetifyjs/vuetify/issues/6701)) ([fc8c2ed](https://github.com/vuetifyjs/vuetify/commit/fc8c2ede01c380a0053a26bd91d752ae8c55f92f)), closes [#5369](https://github.com/vuetifyjs/vuetify/issues/5369) [#3938](https://github.com/vuetifyjs/vuetify/issues/3938) [#4985](https://github.com/vuetifyjs/vuetify/issues/4985)
* restructure core, add services ([#6464](https://github.com/vuetifyjs/vuetify/issues/6464)) ([09c2617](https://github.com/vuetifyjs/vuetify/commit/09c26170d9ddf9a4e3f80ff1b2cd429b29d3404d))
* **detachable:** add activator scoped slot ([#5318](https://github.com/vuetifyjs/vuetify/issues/5318)) ([a025093](https://github.com/vuetifyjs/vuetify/commit/a0250938d07b54b76f8e99bd4c68f880f706ef2c)), closes [#2489](https://github.com/vuetifyjs/vuetify/issues/2489) [#3030](https://github.com/vuetifyjs/vuetify/issues/3030) [#3107](https://github.com/vuetifyjs/vuetify/issues/3107) [#4428](https://github.com/vuetifyjs/vuetify/issues/4428) [#5193](https://github.com/vuetifyjs/vuetify/issues/5193)
* **drawer:** update drawer structure ([9a03bac](https://github.com/vuetifyjs/vuetify/commit/9a03bac8a85c0cd917b13ad1b3f0cae328c71b1e))
* **home-page:** update structure ([34f584e](https://github.com/vuetifyjs/vuetify/commit/34f584e59c14f597fcde32ffc69f6e320c01aeb2))
* **kitchen:** add avatars ([ba7790a](https://github.com/vuetifyjs/vuetify/commit/ba7790a5cd5e8ae457ae888315d004a4885157b4))
* **kitchen:** add home page ([878369b](https://github.com/vuetifyjs/vuetify/commit/878369baa90a8313d68ff57e11d71e89d85c8eb3))
* **kitchen:** add more avatar sizes ([ceb811b](https://github.com/vuetifyjs/vuetify/commit/ceb811b6ab4f9d3f4d00fe1a5df91f43d85f84ca))
* **kitchen:** add parallax pan ([26e88a8](https://github.com/vuetifyjs/vuetify/commit/26e88a80e06ac4d4c69a737e65bcdaec8b39336b))
* **kitchen:** add VChip ([387f12e](https://github.com/vuetifyjs/vuetify/commit/387f12ed64c9f61236f2b4533ba932762e701fe5))
* **kitchen:** add VSparkline pan ([a60a584](https://github.com/vuetifyjs/vuetify/commit/a60a584c77fc317ac7e93b371364b2eb302228a3))
* **List:** improve aria support ([#5671](https://github.com/vuetifyjs/vuetify/issues/5671)) ([3024566](https://github.com/vuetifyjs/vuetify/commit/3024566ab5d1aa980a83289e1530844a6d64392c)), closes [#5667](https://github.com/vuetifyjs/vuetify/issues/5667)
* **locale:** add Estonian translation ([#5995](https://github.com/vuetifyjs/vuetify/issues/5995)) ([5e7afd4](https://github.com/vuetifyjs/vuetify/commit/5e7afd44a9ec1a7cf01cb3393700f70b38a4e43b))
* **measurable:** add min width and height props ([c8ecf7f](https://github.com/vuetifyjs/vuetify/commit/c8ecf7fb81ac18f1fdea764c4d06d344780d0bc2))
* **playground:** add new package ([80dcce1](https://github.com/vuetifyjs/vuetify/commit/80dcce1f2d446df326fb32f8bad26c7cb48c45d3))
* **styles:** converted base vbtn styles ([a1fec67](https://github.com/vuetifyjs/vuetify/commit/a1fec67c51d36a17788b8d4819a5ef561719e935))
* **Theme:** change default warning color ([e0888d3](https://github.com/vuetifyjs/vuetify/commit/e0888d37be0a571884075aee626c9931a0eb8623)), closes [#1693](https://github.com/vuetifyjs/vuetify/issues/1693)
* **Typography:** add text-transform: none helper class ([0902491](https://github.com/vuetifyjs/vuetify/commit/0902491aa61c6e652bfde7c779828c579559b6c8)), closes [#5503](https://github.com/vuetifyjs/vuetify/issues/5503)
* **VAutocomplete:** add autoSelectFirst prop ([#4208](https://github.com/vuetifyjs/vuetify/issues/4208)) ([3c807b6](https://github.com/vuetifyjs/vuetify/commit/3c807b662aa39928c9083c768a5cc79ae2dcdf0d)), closes [#4207](https://github.com/vuetifyjs/vuetify/issues/4207)
* **VBtn:** convert to md2 ([18c8355](https://github.com/vuetifyjs/vuetify/commit/18c8355ece3c539211ef511c7368959b662a6045))
* **VBtnToggle:** convert to sass ([3e44471](https://github.com/vuetifyjs/vuetify/commit/3e44471486119a8fc243067b041d7e577504ab34))
* **VDatePicker:** month events ([#5502](https://github.com/vuetifyjs/vuetify/issues/5502)) ([64c0427](https://github.com/vuetifyjs/vuetify/commit/64c0427a72903f908c4615e50538acc241bcf20b)), closes [#5113](https://github.com/vuetifyjs/vuetify/issues/5113)
* **VDatePicker:** mouse events - click/dblclick ([#5832](https://github.com/vuetifyjs/vuetify/issues/5832)) ([3139768](https://github.com/vuetifyjs/vuetify/commit/3139768c69a481044f6ecbfbbfddf93efda21e69)), closes [#3023](https://github.com/vuetifyjs/vuetify/issues/3023) [#4884](https://github.com/vuetifyjs/vuetify/issues/4884)
* **VDatePicker:** multiple event indicators ([#5512](https://github.com/vuetifyjs/vuetify/issues/5512)) ([1d6737b](https://github.com/vuetifyjs/vuetify/commit/1d6737b87048042ad6aec8f9c92c4520ce471b19))
* **VDatePicker:** show week number ([#5678](https://github.com/vuetifyjs/vuetify/issues/5678)) ([6007897](https://github.com/vuetifyjs/vuetify/commit/6007897e6e7ceb12b0d5f60f5461f3459c68d260)), closes [#5077](https://github.com/vuetifyjs/vuetify/issues/5077)
* **VIcon:** add svg support ([#4910](https://github.com/vuetifyjs/vuetify/issues/4910)) ([6c0b89d](https://github.com/vuetifyjs/vuetify/commit/6c0b89d30ba624030d71034b71bf4e456f8c8e7c))
* **VImg:** use inherent width from image ([#5783](https://github.com/vuetifyjs/vuetify/issues/5783)) ([98fa2ed](https://github.com/vuetifyjs/vuetify/commit/98fa2ed5a66ea883a27b144422405f1bb40a8b61)), closes [#5757](https://github.com/vuetifyjs/vuetify/issues/5757)
* **VMenu:** disable-keys prop ([#5138](https://github.com/vuetifyjs/vuetify/issues/5138)) ([d6b3297](https://github.com/vuetifyjs/vuetify/commit/d6b32973f92bb73971e584bcfb5e611add3e8ca4)), closes [#5103](https://github.com/vuetifyjs/vuetify/issues/5103)
* **VProgressLinear:** add support for content inside progress bar ([#6126](https://github.com/vuetifyjs/vuetify/issues/6126)) ([7d357e8](https://github.com/vuetifyjs/vuetify/commit/7d357e80449136e2ecbd272207da42a1df0e116f)), closes [#3768](https://github.com/vuetifyjs/vuetify/issues/3768)
* **VSelect:** replicate html select hotkeys ([#6086](https://github.com/vuetifyjs/vuetify/issues/6086)) ([dd9cd63](https://github.com/vuetifyjs/vuetify/commit/dd9cd6343fb64f95d5a6972a9f4690ea59fb923b)), closes [#4853](https://github.com/vuetifyjs/vuetify/issues/4853)
* **VSlideGroup:** create new component ([#6240](https://github.com/vuetifyjs/vuetify/issues/6240)) ([7026f34](https://github.com/vuetifyjs/vuetify/commit/7026f3451aff2279857ac1f7a1ba6012a1e596dc))
* **VSparkline:** add bar type ([#6080](https://github.com/vuetifyjs/vuetify/issues/6080)) ([3f17eab](https://github.com/vuetifyjs/vuetify/commit/3f17eabcdf2c3b25bb0b0ec8c607bfc5b5aa887c))
* **VSparkline:** add fill property ([#6132](https://github.com/vuetifyjs/vuetify/issues/6132)) ([54c3f83](https://github.com/vuetifyjs/vuetify/commit/54c3f839a000c7a918d0933cfa2d6fafbcc97508))
* **VTimePicker:** emit click:xxx events ([#6321](https://github.com/vuetifyjs/vuetify/issues/6321)) ([58c45b0](https://github.com/vuetifyjs/vuetify/commit/58c45b078c3199e32df1d3023780c5563dabbe34)), closes [#6163](https://github.com/vuetifyjs/vuetify/issues/6163)
* **VTreeItem:** add itemFilter prop, remove customFilter prop ([#6349](https://github.com/vuetifyjs/vuetify/issues/6349)) ([ba35207](https://github.com/vuetifyjs/vuetify/commit/ba352075339d93dd25696db33d76eb52ede9992c))
* **VTreeview:** add return-object prop ([#6064](https://github.com/vuetifyjs/vuetify/issues/6064)) ([65317e5](https://github.com/vuetifyjs/vuetify/commit/65317e56fe76a954ef3be22fd7d1dbf14899cbe8)), closes [#5881](https://github.com/vuetifyjs/vuetify/issues/5881)
* **VTreeview:** add search functionality ([#6124](https://github.com/vuetifyjs/vuetify/issues/6124)) ([75bbcc5](https://github.com/vuetifyjs/vuetify/commit/75bbcc5cbf1090c99393fa69355000f98edbe2ef)), closes [#5621](https://github.com/vuetifyjs/vuetify/issues/5621)
* **VTreeview:** updateAll public method ([#6363](https://github.com/vuetifyjs/vuetify/issues/6363)) ([3fb72ba](https://github.com/vuetifyjs/vuetify/commit/3fb72ba4407bfc2d2ec2ede055d5176d3cd40696))
* add Afrikaans locale ([#5385](https://github.com/vuetifyjs/vuetify/issues/5385)) ([62f7bb3](https://github.com/vuetifyjs/vuetify/commit/62f7bb31e8da898d8c404b3f93de6a63a5d6319e))
* add croatian locale ([#6125](https://github.com/vuetifyjs/vuetify/issues/6125)) ([267ecca](https://github.com/vuetifyjs/vuetify/commit/267ecca2a9717d50b5e7cb3039bc98191da86ece))
* add d-none helper class ([#5396](https://github.com/vuetifyjs/vuetify/issues/5396)) ([3242321](https://github.com/vuetifyjs/vuetify/commit/32423213930c249635740c9b8a46cf9256f2a56f))
* add display breakpoints for printing ([#5747](https://github.com/vuetifyjs/vuetify/issues/5747)) ([d1e3f7d](https://github.com/vuetifyjs/vuetify/commit/d1e3f7d5c1361c52da4d525a7bbc9790934a8bb0))
* add how to async load fonts ([#5473](https://github.com/vuetifyjs/vuetify/issues/5473)) ([da0cdec](https://github.com/vuetifyjs/vuetify/commit/da0cdec9a4a0a7282e402530b28a56a2f017aaf2))
* add spanish locale ([#5359](https://github.com/vuetifyjs/vuetify/issues/5359)) ([dd3f7c8](https://github.com/vuetifyjs/vuetify/commit/dd3f7c8f6a02885dd9f9160a07829659ee105baf))
* added back missing treeview page ([b2a6102](https://github.com/vuetifyjs/vuetify/commit/b2a6102edd6304ad6562e7d09d4065a20401759f))
* locales index ([#5425](https://github.com/vuetifyjs/vuetify/issues/5425)) ([6b501c2](https://github.com/vuetifyjs/vuetify/commit/6b501c294410e2826ebf1f355d386ca5f4b7ad09))
* override breakpoint thresholds ([#5666](https://github.com/vuetifyjs/vuetify/issues/5666)) ([4906f03](https://github.com/vuetifyjs/vuetify/commit/4906f03297d1bd28bc919dac441b2ecc1f0ff18f))
* update tooltip design ([#6111](https://github.com/vuetifyjs/vuetify/issues/6111)) ([2d2312a](https://github.com/vuetifyjs/vuetify/commit/2d2312a220713c88484a03532e8cebae98dd0d45))
* update typography to md2 ([#6644](https://github.com/vuetifyjs/vuetify/issues/6644)) ([71e9dd1](https://github.com/vuetifyjs/vuetify/commit/71e9dd1e487339d3b123029df2da9368ed893618))
* **$docs:** updated home-page, updated backers ([1acd46d](https://github.com/vuetifyjs/vuetify/commit/1acd46d25bfff3cfacf500aa178778451c58c0f1))
* **$home-page:** changed layout ([4398494](https://github.com/vuetifyjs/vuetify/commit/43984945c061dc102b097eebed19ccbb5c03bbfd))
* **$license:** added LICENSE.md ([00b1da4](https://github.com/vuetifyjs/vuetify/commit/00b1da427b544ab20f9237de6813f4949cc3db37)), closes [#333](https://github.com/vuetifyjs/vuetify/issues/333)
* **ad:** change ad service to codefund ([4e5567c](https://github.com/vuetifyjs/vuetify/commit/4e5567cf4c6493bf0cdca7c53cdf82e5fe70446d))
* **ad-interface:** upgrade ad and toc functionality ([08bc7bc](https://github.com/vuetifyjs/vuetify/commit/08bc7bc9df9b436b46f970389218e17467e33bda))
* **alacarte:** update guide for 1.3 and vuetify-loader ([3e6bcd1](https://github.com/vuetifyjs/vuetify/commit/3e6bcd1fa79ce3cffb9d65b7eb76b23e8617d323))
* **api-generator:** update paths ([2276e6e](https://github.com/vuetifyjs/vuetify/commit/2276e6e738f08d941487f882ea4a7c8833683821))
* **app:** add examples, new paths/functionality for drawer ([0566235](https://github.com/vuetifyjs/vuetify/commit/0566235c9115e0ff890e5c66b47b36437de2e5c3))
* **app:** changed toolbar behavior, moved snackbar ([30e03fb](https://github.com/vuetifyjs/vuetify/commit/30e03fb597d5f1501640cb20015f54bb71a4e596))
* **app:** improve mobile experience ([c13309e](https://github.com/vuetifyjs/vuetify/commit/c13309ec898bc86d9ada33deaad6c6c85c879ac0))
* **app:** update snackbar ([d90a68e](https://github.com/vuetifyjs/vuetify/commit/d90a68efe9a9ce9a71e5391b67c10351f79e5cdb))
* **app-toolbar:** add dynamic sale tag ([f1b1827](https://github.com/vuetifyjs/vuetify/commit/f1b1827de4efcd1deff5db786f4c6df77a42dc85))
* **application-layout:** move patrons ([244d772](https://github.com/vuetifyjs/vuetify/commit/244d772aabbe832548bf2696716e97961f659e87))
* **assets:** change image locations ([d06620a](https://github.com/vuetifyjs/vuetify/commit/d06620a0b491ffd1be566d2315989d55ae189188))
* **at-a-glance:** added component api page ([c00aee8](https://github.com/vuetifyjs/vuetify/commit/c00aee8ebef37b62ba201f0f2b9f9856fee2f80b))
* **backer:** add digital-maas ([cfc2200](https://github.com/vuetifyjs/vuetify/commit/cfc2200384a42bf9443f66a75c21ab2cb63ec4cf))
* **build:** create separate entry for /lib, flatten components export ([0646cfe](https://github.com/vuetifyjs/vuetify/commit/0646cfed9fc4c0ae175efbdb8419098f2b5afd12))
* **cta:** add sale to cta ([be3ace5](https://github.com/vuetifyjs/vuetify/commit/be3ace55d954a1628a421957b3dc4c40156ad990))
* **deployment:** added automatic ci deployment ([28ab126](https://github.com/vuetifyjs/vuetify/commit/28ab126ef757625389f9a960726562362ac866ec))
* **docs:** move hashes around ([5d94491](https://github.com/vuetifyjs/vuetify/commit/5d944910b1c343db9e72259fb3efcfd9eb42da6d))
* **dynamic-async:** make components dynamic and async ([5d3def0](https://github.com/vuetifyjs/vuetify/commit/5d3def088a614f4baaec1f749f80e66bf69d525c))
* **ecosystem:** added reddit ([ed93b33](https://github.com/vuetifyjs/vuetify/commit/ed93b339c45146cbcbd37b2bf32bd194bc6f4240))
* **elevatable:** create new mixin ([85f249c](https://github.com/vuetifyjs/vuetify/commit/85f249cfdcc0eaceb29cfc4bfec48a7217e65cdd))
* **fakeComponents:** generate .js and .ts ([5f6cfda](https://github.com/vuetifyjs/vuetify/commit/5f6cfdace411ad820f549d84d86fe19e3c7d18ea))
* **flags:** add mx flag ([1c700b3](https://github.com/vuetifyjs/vuetify/commit/1c700b3586c653bb07e31f9dbefd7091317a95c0))
* **flags:** move to cdn ([b9a8345](https://github.com/vuetifyjs/vuetify/commit/b9a8345819870a05816a981da5f0c8b6ba6de7bf))
* **framework/icons:** add fontawesome info ([463951c](https://github.com/vuetifyjs/vuetify/commit/463951c93538fa385b2ee22482e3cf747cb80e9b)), closes [#509](https://github.com/vuetifyjs/vuetify/issues/509)
* **gitignore:** ignore yarn-error files ([9be53b2](https://github.com/vuetifyjs/vuetify/commit/9be53b2a82e0a0ad5682e7778b1c05a500dfa291))
* **groupable:** turn into factory function ([6f2f73e](https://github.com/vuetifyjs/vuetify/commit/6f2f73eca2eec5d79324accba73784b6c61fdfd9))
* **img:** optimized image ([47a9b5e](https://github.com/vuetifyjs/vuetify/commit/47a9b5e69cb43cfd84ddbfc4c83039331a42bb74))
* **layouts:** added codepens ([4d321d8](https://github.com/vuetifyjs/vuetify/commit/4d321d8dcc47e8f05bd91e7359423d9611a913db)), closes [#157](https://github.com/vuetifyjs/vuetify/issues/157)
* **package.json:** add setup script ([3d34450](https://github.com/vuetifyjs/vuetify/commit/3d344502c390f6f0aaf19c85bca762b9de18b5cd))
* added moment and date-fns examples ([#650](https://github.com/vuetifyjs/vuetify/issues/650)) ([fccac58](https://github.com/vuetifyjs/vuetify/commit/fccac581e1f14cd91f66fc057814974d87a157e6)), closes [#218](https://github.com/vuetifyjs/vuetify/issues/218)
* fake components generator for webstorm ([969c404](https://github.com/vuetifyjs/vuetify/commit/969c4040eeb82fd68e917adca3c25ecfd674fbda)), closes [vuetifyjs/vuetify#4590](https://github.com/vuetifyjs/vuetify/issues/4590)
* **groups:** update group pages ([14727c3](https://github.com/vuetifyjs/vuetify/commit/14727c308ad70a17d6f34a774b97d495c566433a))
* **patrons:** updated supporters ([9b5b8ad](https://github.com/vuetifyjs/vuetify/commit/9b5b8ad3079014094da1324148c3bf6c0b6686d3))
* **pm2:** add process file ([b0be640](https://github.com/vuetifyjs/vuetify/commit/b0be64011de7d160046057d0706653dd06b9c30d))
* **product-images:** update src ([e0e0bf4](https://github.com/vuetifyjs/vuetify/commit/e0e0bf4a77fcf066088914b699471856a911795e))
* **progress:** added missing language ([4019796](https://github.com/vuetifyjs/vuetify/commit/4019796dc10c91ac2dee84ceb42e570dc8944a31))
* **roadmap:** mark v1.3 as complete ([f516bbe](https://github.com/vuetifyjs/vuetify/commit/f516bbe469fef4dde0f19796e4fa4569535296a9))
* **roadmap:** update roadmap ([4ab1a69](https://github.com/vuetifyjs/vuetify/commit/4ab1a69397efbc93482c54d73d013231f5f16a3f))
* **snackbar:** update app snack ([1120e62](https://github.com/vuetifyjs/vuetify/commit/1120e6202308dd69a39bce60bc6e3e9ab122f8a8))
* **snackbar:** update message ([3ed32a4](https://github.com/vuetifyjs/vuetify/commit/3ed32a4737f119d4e49458fb12a9ffbcff70e48d))
* **toolbar:** add v1 link ([5a07151](https://github.com/vuetifyjs/vuetify/commit/5a0715105400778c92141cda192cfeb2219a10ff))
* **v-hover:** add mappings ([63cab04](https://github.com/vuetifyjs/vuetify/commit/63cab04f01ea6f59c9cd2725bf1d5b0c9e45bee1))
* add a-la-carte limitations section ([0fde3a0](https://github.com/vuetifyjs/vuetify/commit/0fde3a082e135ec171dcc3045ee35de4ef9f548e))
* add esm build, enable sideEffects ([c3c61a9](https://github.com/vuetifyjs/vuetify/commit/c3c61a9fab5dc286b476cbf1e244cee190ac8b1f))
* add hreflang meta tags ([db06523](https://github.com/vuetifyjs/vuetify/commit/db06523101931ea7340935cd79537f213be8c440))
* added $vuetify object to api.js output ([62211ec](https://github.com/vuetifyjs/vuetify/commit/62211ec057183c118bbc1e4ac7668633869c235d))
* added source property to output ([b412c20](https://github.com/vuetifyjs/vuetify/commit/b412c203fd1510167546d6128634677166dbeb22))
* added tags/attributes output ([eeee218](https://github.com/vuetifyjs/vuetify/commit/eeee2185ca09741cdcd9aa365943c56be5861551))
* allow users to cache html responses ([53a240e](https://github.com/vuetifyjs/vuetify/commit/53a240ee012bcc71a90795367e8bdff1b7ade4a0))
* parse extended components ([d7df5f8](https://github.com/vuetifyjs/vuetify/commit/d7df5f841a2bea2774d80be4902434f0b9b9e07c))
* parse wrapped components and ExtendedVue mixins ([daa44c3](https://github.com/vuetifyjs/vuetify/commit/daa44c339aa8671f523f02c447ffc37b9a16dd1d))
* **a-la-carte:** Enable global single components in plugin ([#4667](https://github.com/vuetifyjs/vuetify/issues/4667)) ([765c5c2](https://github.com/vuetifyjs/vuetify/commit/765c5c21d85a6e2dd9ab856e2f2c64c563fe6856))
* **backers:** update current sponsors/backers ([61cbd22](https://github.com/vuetifyjs/vuetify/commit/61cbd22f9266c2484dff17059b5e6289466b6cfb))
* **colorable:** convert to ts ([77c9598](https://github.com/vuetifyjs/vuetify/commit/77c95981cd076075429988286d96a7d63325feff))
* **colorable:** hex colors ([#4342](https://github.com/vuetifyjs/vuetify/issues/4342)) ([29e05dc](https://github.com/vuetifyjs/vuetify/commit/29e05dc0e14c5434c9d70108fb9dd14f8accaad9)), closes [#3416](https://github.com/vuetifyjs/vuetify/issues/3416)
* **components-index:** convert to ts ([db4c8f1](https://github.com/vuetifyjs/vuetify/commit/db4c8f1e9863542f5acae63795d831281a3e6002))
* **dependent:** convert to ts ([9ff9b47](https://github.com/vuetifyjs/vuetify/commit/9ff9b475073e5bd3a15a2ad4fc69f4b129d73833))
* **filterable:** convert to ts ([a2d344f](https://github.com/vuetifyjs/vuetify/commit/a2d344fccc0b70bc589a6ad9e1d83e03447841aa))
* **helper-classes:** added missing helper classes ([0ed01dd](https://github.com/vuetifyjs/vuetify/commit/0ed01ddc00042bf166d66221b3c3a915925aa56a))
* **locale:** chinese ([#4747](https://github.com/vuetifyjs/vuetify/issues/4747)) ([ce15db7](https://github.com/vuetifyjs/vuetify/commit/ce15db7e143b0df59b4d44bc30cde8476f69840f))
* **locale:** farsi ([#4903](https://github.com/vuetifyjs/vuetify/issues/4903)) ([342774b](https://github.com/vuetifyjs/vuetify/commit/342774b70360ac500aa7647c2e922f6eab8e286b))
* **measurable:** add new mixin ([b6c34b7](https://github.com/vuetifyjs/vuetify/commit/b6c34b70a33f234946bb12d44a6e18077e37f7b4))
* **proxyable:** create new mixin ([0a2e9ca](https://github.com/vuetifyjs/vuetify/commit/0a2e9cabe52ade10e4e372425ad92e1aff6f2d55))
* **returnable:** convert to ts ([a90b427](https://github.com/vuetifyjs/vuetify/commit/a90b427dec39273fb225ddb09cd16fcfbbf92604))
* **roadmap:** update language ([7f5984d](https://github.com/vuetifyjs/vuetify/commit/7f5984d8d2b86cd08b9a7a804ade77d9ced8c34f))
* **selection-controls:** use native input change event ([#4804](https://github.com/vuetifyjs/vuetify/issues/4804)) ([e32e48d](https://github.com/vuetifyjs/vuetify/commit/e32e48d699839b2587290f7471ebe83c27c456c8)), closes [#4627](https://github.com/vuetifyjs/vuetify/issues/4627)
* **snackbar:** added new message ([21c1328](https://github.com/vuetifyjs/vuetify/commit/21c1328785f70c880d511ed9f55015d10f87d9a9))
* **snackbar:** update msg ([5462b21](https://github.com/vuetifyjs/vuetify/commit/5462b2177459adaf2ca10ee0ad5f197de8c793aa))
* **snackbar:** updated snackbar ([87fb339](https://github.com/vuetifyjs/vuetify/commit/87fb33909acf11bb9500323331246b65af5ac39a))
* **sponsors-and-backers:** added patron ([2bd680c](https://github.com/vuetifyjs/vuetify/commit/2bd680cfc1bebea36a899f982450a1f8fe124bb1))
* **store:** add loader to front ([cc912b5](https://github.com/vuetifyjs/vuetify/commit/cc912b515671d4c1dce670fd00865a17b5a5d869))
* **store:** added banner ([7ce2b1a](https://github.com/vuetifyjs/vuetify/commit/7ce2b1a0c029fdadcf6a1da588068f4d331bd30f))
* **store:** added sale chips, carousel ([6bdab08](https://github.com/vuetifyjs/vuetify/commit/6bdab08cec585c97e84e4e857031080a1716ee2e))
* **store:** update front-page ([a32fb28](https://github.com/vuetifyjs/vuetify/commit/a32fb28d916bded481f924614eb39487bb9f3522))
* **store:** update product-page ([ba51ed9](https://github.com/vuetifyjs/vuetify/commit/ba51ed993674a4dcd0771573a8c815e9ed6773ab))
* **store-images:** update angryman ([54c6988](https://github.com/vuetifyjs/vuetify/commit/54c6988c02af6c0380629b1ed663c1d5a4c124dd))
* **store-toolbar:** add dynamic cart icon ([b70075c](https://github.com/vuetifyjs/vuetify/commit/b70075cfb8d6dfe61d8ad1a8accb3c0596a058e3))
* **text-fields:** updated language ([9ebd29c](https://github.com/vuetifyjs/vuetify/commit/9ebd29cd706bcf0be0787d424deb653eb71c571d))
* **tidelift:** add tidelift to homepage ([5a98d9e](https://github.com/vuetifyjs/vuetify/commit/5a98d9ed3f29110fc8dff462b1167607a644609f))
* **typography:** add font weights ([c287461](https://github.com/vuetifyjs/vuetify/commit/c28746125e15a039baf72963600936bcb33c8a04))
* **v-navigation-drawer:** added nested example ([91328ff](https://github.com/vuetifyjs/vuetify/commit/91328ff28e9eec15ea20858d23cf556944f17f6b))
* **v-navigation-drawer:** added new example ([34e0dea](https://github.com/vuetifyjs/vuetify/commit/34e0dea4064f3d0e873e78e34de8a4b7bfd58e69))
* **v-slider:** add new example ([642d02c](https://github.com/vuetifyjs/vuetify/commit/642d02c83dff50df0b49c9b95062f4a44b377653))
* **v-slider:** update language for metronome example ([d8c5e47](https://github.com/vuetifyjs/vuetify/commit/d8c5e4786407c7fdd48ae887d0afc2f35f83886e))
* **v-textarea:** add new example ([2f060af](https://github.com/vuetifyjs/vuetify/commit/2f060afc30c0ed2dc2410db075c97648a27d16ab))
* **v-timeline:** add doc page ([#595](https://github.com/vuetifyjs/vuetify/issues/595)) ([2742d21](https://github.com/vuetifyjs/vuetify/commit/2742d21b1f6023d40a31caf7664d27aca871dbba))
* **v-treeview:** add new example ([#615](https://github.com/vuetifyjs/vuetify/issues/615)) ([2aa735f](https://github.com/vuetifyjs/vuetify/commit/2aa735f12703c5f2bceeb05b74cfa8a890a11456))
* **v-treeview:** update page/add examples ([f893a08](https://github.com/vuetifyjs/vuetify/commit/f893a080a6ee99aa96c04d414b2e496f68471b7e))
* **vue-markdown:** dynamically load ([0731cc5](https://github.com/vuetifyjs/vuetify/commit/0731cc5407e2da52216c066df812d0484411563c))
* added support for functions in api section ([f027922](https://github.com/vuetifyjs/vuetify/commit/f027922778e0dff4043205fc55a4908415773b19))
* **faq:** added markdown support ([5c80a5b](https://github.com/vuetifyjs/vuetify/commit/5c80a5bca2956b726b782a5b7cb74c215bfbb07e)), closes [#148](https://github.com/vuetifyjs/vuetify/issues/148)
* ThemeGenerator now exports using color names instead of hex ([0046937](https://github.com/vuetifyjs/vuetify/commit/00469370903601ea6ebf1d27354e9dafc5cc5ce0))
* **quick-start:** started to setup page ([29d6ac3](https://github.com/vuetifyjs/vuetify/commit/29d6ac3906d1890d8a1980a813844d380158be93))
* **repository:** convert to mono-repo ([bb3ef96](https://github.com/vuetifyjs/vuetify/commit/bb3ef969b0bbfda631219822c315d572bdaff6fe))
* **selection-controls:** overwrite selection control container width ([caace72](https://github.com/vuetifyjs/vuetify/commit/caace7224fc316b135fca206bfaf7987ee5c0438))
* **theme:** accept color objects ([#4751](https://github.com/vuetifyjs/vuetify/issues/4751)) ([1617c38](https://github.com/vuetifyjs/vuetify/commit/1617c38ce89f521b123ef9a269160d787207a8b0)), closes [#4408](https://github.com/vuetifyjs/vuetify/issues/4408)
* **theme:** css vars ([#4774](https://github.com/vuetifyjs/vuetify/issues/4774)) ([dabaaa9](https://github.com/vuetifyjs/vuetify/commit/dabaaa941f6fa8edaee511ef2dcd9913c1d066d8))
* **themeable:** use provide/inject ([#4386](https://github.com/vuetifyjs/vuetify/issues/4386)) ([22a5a29](https://github.com/vuetifyjs/vuetify/commit/22a5a29d9520b158c0de5afd7bbd3de980b5b05d))
* **transitions:** improve interaction with groups ([bca41c6](https://github.com/vuetifyjs/vuetify/commit/bca41c6f03f0a6392ff78a049789e5c41beed228))
* **transitions:** spring cleaning ([8a4b59d](https://github.com/vuetifyjs/vuetify/commit/8a4b59d21b1e5853094a14cf46940c822387547b))
* **types:** add definitions for vuetify/lib ([7085754](https://github.com/vuetifyjs/vuetify/commit/7085754564a3058e889b8c92754898c491fa06c6))
* **v-bottom-nav:** converted to use v-btn-toggle ([ffe5a90](https://github.com/vuetifyjs/vuetify/commit/ffe5a901de520bc9e498fce7e2cd040630e3423b))
* **v-btn-toggle:** refactor to use v-item-group ([6218e94](https://github.com/vuetifyjs/vuetify/commit/6218e94ed76f2cbac2920a9bcce0810321a0a683))
* **v-card:** convert to extend v-paper ([737d8d7](https://github.com/vuetifyjs/vuetify/commit/737d8d7b5f6abda557cc8a9aac89e91cb8610189))
* **v-carousel:** convert to ts ([9ce0a8c](https://github.com/vuetifyjs/vuetify/commit/9ce0a8cf3c21aea44b7faac4a51a7083baf19138))
* **v-carousel:** convert to use item-group functionality ([beb16d2](https://github.com/vuetifyjs/vuetify/commit/beb16d2079762cde6a1cf8797f90030fe8b6480e))
* **v-img:** add gradient prop ([c7c463f](https://github.com/vuetifyjs/vuetify/commit/c7c463f6926ca05bcec5076b41ac16648a45625e))
* **v-item-group:** separate provide from instance ([ce8a708](https://github.com/vuetifyjs/vuetify/commit/ce8a708e8ae9821df29d6a049364bca165bc9335))
* **v-paper:** create new component ([120eb31](https://github.com/vuetifyjs/vuetify/commit/120eb3185403bf88f34c3a164d679b82d1f6a8e0))
* **v-select:** additional slots before/after options list ([#4179](https://github.com/vuetifyjs/vuetify/issues/4179)) ([0ea55ca](https://github.com/vuetifyjs/vuetify/commit/0ea55cab7c4354a8c6779c5b1f8ce191f74e6ecf))
* **v-tabs:** convert to use item/group ([#5022](https://github.com/vuetifyjs/vuetify/issues/5022)) ([a9475f4](https://github.com/vuetifyjs/vuetify/commit/a9475f40f2474a8b92c11ca5a0027b11d2b2c001))
* **v-tabs:** update to use v-window ([5e7f01b](https://github.com/vuetifyjs/vuetify/commit/5e7f01b142b86cbdc38a068553c80e4e20b63c33))
* **v-window:** add new touch prop ([a5fc8e4](https://github.com/vuetifyjs/vuetify/commit/a5fc8e4f626dd67a05257d1e3058e325d0a7ec66)), closes [#4813](https://github.com/vuetifyjs/vuetify/issues/4813)
* **v-window:** add proxyable model support ([02ee27f](https://github.com/vuetifyjs/vuetify/commit/02ee27fe574f56aa2c72221ebdf72d36c64a5c9c))
* **v-window:** add reverse prop ([bdcfc60](https://github.com/vuetifyjs/vuetify/commit/bdcfc60a86d4a0aa3ab4293ce6f7b6f69e7b0166))
* **v-window:** create new component ([ffc6317](https://github.com/vuetifyjs/vuetify/commit/ffc63171ae765e63f924f73215e826378d0799cd))
* **v-window:** integrate item-group ([1f4347f](https://github.com/vuetifyjs/vuetify/commit/1f4347f7fc7cb361f0fb2bea91989b3db036b6dc))
* **VDatePicker:** add weekdayFormat prop ([#5257](https://github.com/vuetifyjs/vuetify/issues/5257)) ([6fde964](https://github.com/vuetifyjs/vuetify/commit/6fde964555bf36ad40529d1be87604611933c7f1)), closes [#5020](https://github.com/vuetifyjs/vuetify/issues/5020)
* **VIcon:** apply left/right even if not in a button ([f8de29d](https://github.com/vuetifyjs/vuetify/commit/f8de29dba0cca41ee6fd01c188cf1c8f1071b243))
* **VSwitch:** add loading prop ([#4805](https://github.com/vuetifyjs/vuetify/issues/4805)) ([91ad55b](https://github.com/vuetifyjs/vuetify/commit/91ad55b915fc7eb1ecf954ef6e455b99ca489107))
* **VTimePicker, VDatePicker:** disabled prop ([#5685](https://github.com/vuetifyjs/vuetify/issues/5685)) ([0b13705](https://github.com/vuetifyjs/vuetify/commit/0b13705ef28acb5166ea3a6c7458e0122cfb97de)), closes [#5631](https://github.com/vuetifyjs/vuetify/issues/5631)
* create v-timeline ([#3912](https://github.com/vuetifyjs/vuetify/issues/3912)) ([228e1e9](https://github.com/vuetifyjs/vuetify/commit/228e1e9d4265e18874f819b8171caed5a018eb76))
* **VForm:** add public resetValidation method ([#4763](https://github.com/vuetifyjs/vuetify/issues/4763)) ([01f5c66](https://github.com/vuetifyjs/vuetify/commit/01f5c66f85b0442378281af33e988037bbc3aea8)), closes [#3316](https://github.com/vuetifyjs/vuetify/issues/3316)
* **VListTile:** add themeable ([5ac572b](https://github.com/vuetifyjs/vuetify/commit/5ac572b4ed47b2473adc45901ef247418b73a512))
* **VProgress:** normalized value and buffer, add a11y ([#4953](https://github.com/vuetifyjs/vuetify/issues/4953)) ([9a526d8](https://github.com/vuetifyjs/vuetify/commit/9a526d845ed8ce3997be7f9a0dac20b282b749dc))
* **VRating:** add dense prop ([#4924](https://github.com/vuetifyjs/vuetify/issues/4924)) ([700cd75](https://github.com/vuetifyjs/vuetify/commit/700cd75cb997e67841f584a2c2709ddfa6cd2ac8))
* **VResponsive:** add width props ([6b8d7bb](https://github.com/vuetifyjs/vuetify/commit/6b8d7bb62563bd3f698b14c51c531af1fe89f6cb))
* **VSelect:** add menu-props prop, deprecate everything else ([#4795](https://github.com/vuetifyjs/vuetify/issues/4795)) ([f5a3f82](https://github.com/vuetifyjs/vuetify/commit/f5a3f8296906fc63c87a60ca63c4ed9397bbe37c))
* **VTimePicker:** readonly prop ([#4890](https://github.com/vuetifyjs/vuetify/issues/4890)) ([c158dec](https://github.com/vuetifyjs/vuetify/commit/c158dec6b242c890ff60280b8b431d113b7287cb)), closes [#3715](https://github.com/vuetifyjs/vuetify/issues/3715)
* **vuetify-package:** remove eslint-local rules, move files around, finish setup ([96961d9](https://github.com/vuetifyjs/vuetify/commit/96961d9c9970f124849771c27dfd58084c802016))
* create v-hover component, add group prop to transitions ([#4841](https://github.com/vuetifyjs/vuetify/issues/4841)) ([2313f55](https://github.com/vuetifyjs/vuetify/commit/2313f55fac25d2a72d4f9102f6114ff85f2929d4))
* **bootable:** removes animation on boot for ssr components ([b75f243](https://github.com/vuetifyjs/vuetify/commit/b75f243977164d19f72cc840d3aa75dbac595945))
* **locale:** german ([#4694](https://github.com/vuetifyjs/vuetify/issues/4694)) ([501ea17](https://github.com/vuetifyjs/vuetify/commit/501ea17a272baa5a07cd756a2855013f85a851b6))
* **locale:** greek ([#4718](https://github.com/vuetifyjs/vuetify/issues/4718)) ([1e66ec4](https://github.com/vuetifyjs/vuetify/commit/1e66ec44ea9060a8e2dc45542ab5cdede7379fae))
* **locale:** portuguese ([#4680](https://github.com/vuetifyjs/vuetify/issues/4680)) ([97bfcba](https://github.com/vuetifyjs/vuetify/commit/97bfcbaf394884eeb191756a9a755e04a92f89a9))
* add french locale ([#4685](https://github.com/vuetifyjs/vuetify/issues/4685)) ([0a5c9c6](https://github.com/vuetifyjs/vuetify/commit/0a5c9c638efded6ace42c129d84083675d5a4786))
* add ukrainian locale ([#4435](https://github.com/vuetifyjs/vuetify/issues/4435)) ([d3d6ee4](https://github.com/vuetifyjs/vuetify/commit/d3d6ee463b25768506a29f4caafe2f51be35a6a5))
* create v-img and v-responsive components ([#4472](https://github.com/vuetifyjs/vuetify/issues/4472)) ([c03f506](https://github.com/vuetifyjs/vuetify/commit/c03f506a6188a1758f9b7b9d7f834cb2d25f23ab))
* **detachable:** pass through scoped style attribute from parent ([#4282](https://github.com/vuetifyjs/vuetify/issues/4282)) ([8dc4ef5](https://github.com/vuetifyjs/vuetify/commit/8dc4ef5e89ee4d2dcc4a118a271a5a32ff5fdb48))
* **inputs:** emit events instead of using callback props on icons ([#4254](https://github.com/vuetifyjs/vuetify/issues/4254)) ([eaf0e93](https://github.com/vuetifyjs/vuetify/commit/eaf0e931f6eac5848837b6377a38a3e0fc12df0e))
* **inputs:** remove icon slots ([#4252](https://github.com/vuetifyjs/vuetify/issues/4252)) ([8defef1](https://github.com/vuetifyjs/vuetify/commit/8defef167ad508669b6b7ef0e01462c86ebce588))
* **locale:** polish ([#4437](https://github.com/vuetifyjs/vuetify/issues/4437)) ([7ac60f7](https://github.com/vuetifyjs/vuetify/commit/7ac60f7df1cc86e4d0ba7903edcdd54abe551dbb))
* **pm2:** add process file ([8c6b250](https://github.com/vuetifyjs/vuetify/commit/8c6b250c77f8df6d18e478f464a8120c050400fd))
* add russian locale ([#4425](https://github.com/vuetifyjs/vuetify/issues/4425)) ([0e7e0bc](https://github.com/vuetifyjs/vuetify/commit/0e7e0bcd661a60257b72b9f07268d3ae353bdc32))
* **a-la-carte:** add types and sourcemaps ([10c86d1](https://github.com/vuetifyjs/vuetify/commit/10c86d1c855af9031fde65f3532e1897c71dc9e8))
* **playground:** add mdi ([55fd507](https://github.com/vuetifyjs/vuetify/commit/55fd5076ec6bc01945b99c6fae72d680cf692c08))
* **tags:** add new delimiters prop ([349423e](https://github.com/vuetifyjs/vuetify/commit/349423e6ee8cff7a7509320fdb61c0b35be6c315)), closes [#3287](https://github.com/vuetifyjs/vuetify/issues/3287)
* **text/font:** added new helpers ([#3598](https://github.com/vuetifyjs/vuetify/issues/3598)) ([5ad4846](https://github.com/vuetifyjs/vuetify/commit/5ad48468f826500e4364b303b24ce206c7d8d3e9))
* **types:** add definition for a-la-carte directives ([c646c66](https://github.com/vuetifyjs/vuetify/commit/c646c66409c5753c65f028c191b71c87f8318c2a))
* **v-autocomplete:** add chip editing ([5f6aaaa](https://github.com/vuetifyjs/vuetify/commit/5f6aaaa487cd93afc24be443686fbb5f62191d67))
* **v-autocomplete:** add new **hide-no-data** prop ([20228a5](https://github.com/vuetifyjs/vuetify/commit/20228a5ece31745e2553de1898b9aef3585de753)), closes [#2613](https://github.com/vuetifyjs/vuetify/issues/2613)
* **v-autocomplete:** add no-filter prop ([ba6472a](https://github.com/vuetifyjs/vuetify/commit/ba6472aa6c5a561f6f6b44e7b46058ed6a35afe2)), closes [#2767](https://github.com/vuetifyjs/vuetify/issues/2767)
* **v-data-iterator:** add header slot ([#3922](https://github.com/vuetifyjs/vuetify/issues/3922)) ([070903e](https://github.com/vuetifyjs/vuetify/commit/070903e6a82c32491e7a72aaa7a1da8b26f8ff6d)), closes [#2748](https://github.com/vuetifyjs/vuetify/issues/2748)
* **v-form:** improve grid styles ([4a2e85d](https://github.com/vuetifyjs/vuetify/commit/4a2e85d0c09eebc703ac8bae9957dde61b871c14))
* **v-input:** add v-label state animation ([4975c1a](https://github.com/vuetifyjs/vuetify/commit/4975c1aaa06c5ddfdfe2da7327c56f3aa54a74f7))
* **v-input:** improve loader styles ([3dd6ff9](https://github.com/vuetifyjs/vuetify/commit/3dd6ff9a925ce363c2daa2146a28ae45528b3b1f)), closes [#2399](https://github.com/vuetifyjs/vuetify/issues/2399)
* **v-radio-group:** improve list func ([f57cacd](https://github.com/vuetifyjs/vuetify/commit/f57cacd36a8ec5d6bab861ff5920de490b87e333)), closes [#2345](https://github.com/vuetifyjs/vuetify/issues/2345)
* **v-select:** change display order ([e4cb7f3](https://github.com/vuetifyjs/vuetify/commit/e4cb7f378af926018df93ff9340dc9799bee9593)), closes [#4082](https://github.com/vuetifyjs/vuetify/issues/4082)
* **v-select:** change fallback ([495e413](https://github.com/vuetifyjs/vuetify/commit/495e4136d0052d2af8b44bf6b921c5fe02ea0e3f))
* **v-time-picker-clock:** allows scrollable with allowed-values ([#4202](https://github.com/vuetifyjs/vuetify/issues/4202)) ([8e6784a](https://github.com/vuetifyjs/vuetify/commit/8e6784a4782f2fa3c95e736082233e5aad1c5f51)), closes [#4195](https://github.com/vuetifyjs/vuetify/issues/4195)
* **v-toolbar:** normalize gutter functionality ([#4305](https://github.com/vuetifyjs/vuetify/issues/4305)) ([b77bec4](https://github.com/vuetifyjs/vuetify/commit/b77bec4ce88f297a101dfe1eef1a251e6d50dee9)), closes [#4315](https://github.com/vuetifyjs/vuetify/issues/4315)
* **VExpansionPanel:** add disabled and readonly props ([#3969](https://github.com/vuetifyjs/vuetify/issues/3969)) ([c2fc0fd](https://github.com/vuetifyjs/vuetify/commit/c2fc0fd74b27c943a3395beda082f8e6e9fded8d))
* **VLabel:** add aria-hidden ([a691511](https://github.com/vuetifyjs/vuetify/commit/a691511048ceaced40cd4fc98e6f318d59466c94))
* **VTextField:** add background-color ([#4353](https://github.com/vuetifyjs/vuetify/issues/4353)) ([1d79e5b](https://github.com/vuetifyjs/vuetify/commit/1d79e5bb0ad7742555ebf531848a9526892bfb70))
* create v-overflow-btn ([#3992](https://github.com/vuetifyjs/vuetify/issues/3992)) ([7010263](https://github.com/vuetifyjs/vuetify/commit/70102630ea19784e54c2482870544578c1d38b59))
* Specify custom translation function ([#4319](https://github.com/vuetifyjs/vuetify/issues/4319)) ([5c5fb84](https://github.com/vuetifyjs/vuetify/commit/5c5fb844c698ff00765a6d499702add4e101623e))
* VCombobox ([#4309](https://github.com/vuetifyjs/vuetify/issues/4309)) ([c0d3492](https://github.com/vuetifyjs/vuetify/commit/c0d3492268816346e5be94b925f09bb4467001a1))
* **grids:** remove variable padding ([5a4635c](https://github.com/vuetifyjs/vuetify/commit/5a4635cb1b17027a749e1acbfa25539e9852d662)), closes [#2264](https://github.com/vuetifyjs/vuetify/issues/2264)
* **input-controls:** updated styles, various updates ([45c3c3d](https://github.com/vuetifyjs/vuetify/commit/45c3c3da4825ada70bbd1ec8bf6de5f21b47db0f))
* **rtl:** adapted v-slider for rtl ([1c0007c](https://github.com/vuetifyjs/vuetify/commit/1c0007c3bce31faee4dc0403a24aad417fe2d109))
* **rtl:** added more rtl support ([e133a67](https://github.com/vuetifyjs/vuetify/commit/e133a67ac8b96adeeb039591170652d30010cac4))
* **selection-controls:** move icons to props ([e334898](https://github.com/vuetifyjs/vuetify/commit/e3348987532f6555a432ae9a601be640cdf6891b)), closes [#2784](https://github.com/vuetifyjs/vuetify/issues/2784)
* **v-autocomplete:** implement tags ([db6c118](https://github.com/vuetifyjs/vuetify/commit/db6c118a514ea8aa5376139462d8aab64f0e9a67))
* **v-select:** improve chips ([9f4ea6b](https://github.com/vuetifyjs/vuetify/commit/9f4ea6b832ae6cf6a59fafff24b2c3cc71bf88c9)), closes [#2933](https://github.com/vuetifyjs/vuetify/issues/2933)
* goTo returns a Promise ([#3832](https://github.com/vuetifyjs/vuetify/issues/3832)) ([550fa80](https://github.com/vuetifyjs/vuetify/commit/550fa8092a818fdd96fc96d45e484609b17a9c7f)), closes [#3748](https://github.com/vuetifyjs/vuetify/issues/3748)
* **grid:** added grow/shrink helper classes ([23dbfa2](https://github.com/vuetifyjs/vuetify/commit/23dbfa27c2eaa223ed69100dae70c93d83d147de))
* **inputs:** abstracted more functionality, moved code around ([d2126a1](https://github.com/vuetifyjs/vuetify/commit/d2126a1a74736b7aa98b9aa89efec6ca01351361))
* **routable:** allow object for **ripple** prop ([b49c980](https://github.com/vuetifyjs/vuetify/commit/b49c9807d50f5858a9021cfc75bc772eb9ef2b65))
* **rtl:** started initial implementation ([ef761a7](https://github.com/vuetifyjs/vuetify/commit/ef761a74b8d90852f3cc12d7d32ba6b66a7b36cd))
* **select/text-field:** added new functionality, **solo-inverted** ([0e81afa](https://github.com/vuetifyjs/vuetify/commit/0e81afa413a9c9f0ccb1fde9bb60f0a765e0f7fe))
* **selection-controls:** abstracted further ([7313b77](https://github.com/vuetifyjs/vuetify/commit/7313b77f8a64c42951491e00682de65225e66369))
* **spacing:** added new `mx-auto` class ([b748b73](https://github.com/vuetifyjs/vuetify/commit/b748b7387110461276195c791fe4b0c40bb8b731))
* **ssr:** removed entry animation on layout components in ssr ([d634351](https://github.com/vuetifyjs/vuetify/commit/d6343519f40dca2815e09d5ab85617cc5cd99756))
* **stylus colors:** allow redefinition ([67e440a](https://github.com/vuetifyjs/vuetify/commit/67e440a367da9081fb90a60032b73b5d2c053f6e)), closes [#2155](https://github.com/vuetifyjs/vuetify/issues/2155)
* **theme:** add theme support to anchor tags ([#2566](https://github.com/vuetifyjs/vuetify/issues/2566)) ([a90fcdb](https://github.com/vuetifyjs/vuetify/commit/a90fcdb2448d51834ad003259b7ed579f478e20e)), closes [#2515](https://github.com/vuetifyjs/vuetify/issues/2515)
* **theme:** allow a nonce to be specified for the stylesheet ([#3952](https://github.com/vuetifyjs/vuetify/issues/3952)) ([2d69b1e](https://github.com/vuetifyjs/vuetify/commit/2d69b1eb83100a502234af423231a8776be6f5ff)), closes [#3950](https://github.com/vuetifyjs/vuetify/issues/3950)
* **theme:** Create util file with color variables ([#2567](https://github.com/vuetifyjs/vuetify/issues/2567)) ([fb6f448](https://github.com/vuetifyjs/vuetify/commit/fb6f448ccd946550a197b76cef8e82523ad7074b)), closes [#2564](https://github.com/vuetifyjs/vuetify/issues/2564)
* **types:** add icons and Vuetify plugin to type definition ([#3785](https://github.com/vuetifyjs/vuetify/issues/3785)) ([07e21c4](https://github.com/vuetifyjs/vuetify/commit/07e21c42389f0ca22ef9a742a22484e9348be91b))
* **v-bottom-sheet:** added **hide-overlay** prop ([4a3f68c](https://github.com/vuetifyjs/vuetify/commit/4a3f68cc0526ab440e31d23fa5cbd8d6791d83e8)), closes [#2668](https://github.com/vuetifyjs/vuetify/issues/2668)
* **v-card:** added new **width** prop ([5bc20c8](https://github.com/vuetifyjs/vuetify/commit/5bc20c85e7b1ca63459713a09208b0fe9dd88078))
* **v-checkbox:** added initial impl ([49e482b](https://github.com/vuetifyjs/vuetify/commit/49e482bf6ed40e2d48f1df41b6b96a660cc49dd6))
* **v-data-table:** no-data and no-results slots can take custom tr/tds ([#2952](https://github.com/vuetifyjs/vuetify/issues/2952)) ([c2c356a](https://github.com/vuetifyjs/vuetify/commit/c2c356a13e103ce7fdf047142af14d0db05500c9)), closes [#2504](https://github.com/vuetifyjs/vuetify/issues/2504)
* **v-date-picker:** improved animations ([d8e2441](https://github.com/vuetifyjs/vuetify/commit/d8e244148b2e5e6aae5ed05b68a12939848576d2))
* **v-input:** abstracted inputable to a component ([f5574fe](https://github.com/vuetifyjs/vuetify/commit/f5574fe5cc51a8101951b8b9207d41b21cd296eb))
* **v-label:** added left prop ([247de34](https://github.com/vuetifyjs/vuetify/commit/247de3457442eca6b4cd98b38ef4abee3e367fe2))
* **v-list:** added nesting functionality to list-groups ([#2563](https://github.com/vuetifyjs/vuetify/issues/2563)) ([f0764a7](https://github.com/vuetifyjs/vuetify/commit/f0764a769124778f60ad007cb2ed6fe7f402c8b1)), closes [#1898](https://github.com/vuetifyjs/vuetify/issues/1898)
* **v-select:** removed debounce prop ([#3138](https://github.com/vuetifyjs/vuetify/issues/3138)) ([ad4b1ce](https://github.com/vuetifyjs/vuetify/commit/ad4b1ce1c99d3d7ca3f066ce161eaeb9dab982eb)), closes [#2978](https://github.com/vuetifyjs/vuetify/issues/2978)
* **v-stepper-step:** added colorable support ([60a4bc6](https://github.com/vuetifyjs/vuetify/commit/60a4bc6006caa3e272ee9782e12896553530d773)), closes [#3276](https://github.com/vuetifyjs/vuetify/issues/3276)
* **v-switch:** added initial impl ([03a4a1c](https://github.com/vuetifyjs/vuetify/commit/03a4a1c190ac5a7da22ae7733f2220a556a70d4a))
* **v-tabs/v-tabs-items:** allow **value** to accept Number's ([c9e493c](https://github.com/vuetifyjs/vuetify/commit/c9e493c4b074ea755ae8356aa247d55bfbbfbe06))
* **v-text-field:** added affixes, backwards compat for appendIcon ([0857039](https://github.com/vuetifyjs/vuetify/commit/0857039ce3b62efd9aa1461c0afd719614d3e8c9))
* **v-text-field:** added counter ([4bb0536](https://github.com/vuetifyjs/vuetify/commit/4bb0536f5724359e9a3ec055f72c51dde8344ea4))
* **v-text-field:** started implementation with v-input ([eec081c](https://github.com/vuetifyjs/vuetify/commit/eec081c5be50a7326e9ac8123e3c55c1939206e8))
* **persistent** prop for v-edit-dialog ([#3196](https://github.com/vuetifyjs/vuetify/issues/3196)) ([d174129](https://github.com/vuetifyjs/vuetify/commit/d174129671d4c516c7190b8fe70866d21784fd32)), closes [#3195](https://github.com/vuetifyjs/vuetify/issues/3195)
* **width** and **full-width** props for pickers ([#3001](https://github.com/vuetifyjs/vuetify/issues/3001)) ([343335f](https://github.com/vuetifyjs/vuetify/commit/343335f9e937c74637b81f21dd0d892d0459513c))
* add options to $vuetify.goTo ([#3073](https://github.com/vuetifyjs/vuetify/issues/3073)) ([71484a1](https://github.com/vuetifyjs/vuetify/commit/71484a135f3fd5d9d6cf17de07eae460545c02ab))
* added new component, added routable to carousel, new prop to icon ([6c612c5](https://github.com/vuetifyjs/vuetify/commit/6c612c560ce19ca8c815aa5ea731b4f56ed48aea)), closes [#1709](https://github.com/vuetifyjs/vuetify/issues/1709)
* allow theme to be disabled entirely ([#3379](https://github.com/vuetifyjs/vuetify/issues/3379)) ([a7e8bb8](https://github.com/vuetifyjs/vuetify/commit/a7e8bb87b4cd3053eb99268d05e9d65b03f0fdb8)), closes [#3349](https://github.com/vuetifyjs/vuetify/issues/3349)
* contentClass for VSelect ([#2375](https://github.com/vuetifyjs/vuetify/issues/2375)) ([3c52ac6](https://github.com/vuetifyjs/vuetify/commit/3c52ac68f62a2e3eeb99dd140d585f84d3027832)), closes [#2374](https://github.com/vuetifyjs/vuetify/issues/2374)
* min/max props for date/time picker ([#3029](https://github.com/vuetifyjs/vuetify/issues/3029)) ([259ff73](https://github.com/vuetifyjs/vuetify/commit/259ff73ad27376d272dc02cb87320d5f967c6512)), closes [#2991](https://github.com/vuetifyjs/vuetify/issues/2991)
* pickerDate.sync prop ([#3019](https://github.com/vuetifyjs/vuetify/issues/3019)) ([d325bf1](https://github.com/vuetifyjs/vuetify/commit/d325bf1f3fc1d6abc3db648ee38089d75612a30d)), closes [#3008](https://github.com/vuetifyjs/vuetify/issues/3008)
* Set header font via `$header-font-family` ([b947121](https://github.com/vuetifyjs/vuetify/commit/b9471216a5967791797e36564cf2c51ac97d326a))
* **v-scroll:** added window offset to scroll callback ([8c39667](https://github.com/vuetifyjs/vuetify/commit/8c39667159ec979c455b443216735b57ff8bf0a3))
* **v-toolbar:** added new scrolling functionality to `v-toolbar` ([eac768b](https://github.com/vuetifyjs/vuetify/commit/eac768be6007fa0fd694e7725dc0bb7d259b4a76))
* add class to application if touch is supported ([#2356](https://github.com/vuetifyjs/vuetify/issues/2356)) ([6f0b6c6](https://github.com/vuetifyjs/vuetify/commit/6f0b6c69cdd1a3d22359f951fe1bed27c9218f4c))
* add disabled prop for tooltips ([#2164](https://github.com/vuetifyjs/vuetify/issues/2164)) ([13e5fbf](https://github.com/vuetifyjs/vuetify/commit/13e5fbf69788fb104a7d49015d59326b1e382328)), closes [#2002](https://github.com/vuetifyjs/vuetify/issues/2002)
* add fixed/absolute props to v-system-bar ([#2188](https://github.com/vuetifyjs/vuetify/issues/2188)) ([28fbca9](https://github.com/vuetifyjs/vuetify/commit/28fbca9262d01a9584b181e83494ecfd94468c94)), closes [#2186](https://github.com/vuetifyjs/vuetify/issues/2186) [#2186](https://github.com/vuetifyjs/vuetify/issues/2186)
* add support for float values in slider ([#2242](https://github.com/vuetifyjs/vuetify/issues/2242)) ([5478c1b](https://github.com/vuetifyjs/vuetify/commit/5478c1bf20882113fc51c2371caa9d55473ae4b3)), closes [#1914](https://github.com/vuetifyjs/vuetify/issues/1914)
* allow overriding color for contextual alert ([6e04ff1](https://github.com/vuetifyjs/vuetify/commit/6e04ff1a61ccbf02116274416c2f6e3ff6f344b4))
* do not render items-per-page select with only 1 option ([#2459](https://github.com/vuetifyjs/vuetify/issues/2459)) ([d0ce490](https://github.com/vuetifyjs/vuetify/commit/d0ce490154c60887a46fcbc81b0e88b531ee9f29)), closes [#2438](https://github.com/vuetifyjs/vuetify/issues/2438)
* hideSelected prop for v-select ([#2260](https://github.com/vuetifyjs/vuetify/issues/2260)) ([3231d06](https://github.com/vuetifyjs/vuetify/commit/3231d06e25203e055064b3def40e3a70445ee7be))
* inherit checkbox/text of selected item from v-select ([#2189](https://github.com/vuetifyjs/vuetify/issues/2189)) ([6968476](https://github.com/vuetifyjs/vuetify/commit/6968476c9e316171fa3f60cd668bcf020ea90f95)), closes [#2174](https://github.com/vuetifyjs/vuetify/issues/2174)
* Make VIcon aria-hidden by default ([f0b5043](https://github.com/vuetifyjs/vuetify/commit/f0b50437c7b22d22a0a2939bab7bbefac540c408))
* **v-alert:** added contextual support with **type** prop ([623ebca](https://github.com/vuetifyjs/vuetify/commit/623ebcabde2379ecf0b5f8931d683d65b904e276))
* **v-autocomplete:** added new functionality ([17c4d2e](https://github.com/vuetifyjs/vuetify/commit/17c4d2eea0cea3d1007ab87b810b553988795122))
* **v-autocomplete:** expanded functionality ([eb16480](https://github.com/vuetifyjs/vuetify/commit/eb16480eaea764091ea6c2c6dedf20b36355c264))
* **v-autocomplete:** improved process ([309443a](https://github.com/vuetifyjs/vuetify/commit/309443a50da2bf39dd58a2f5a6ece08ce4145f1b))
* **v-autocomplete:** started add combobox functionality ([ad99bc5](https://github.com/vuetifyjs/vuetify/commit/ad99bc5f751c6eb1274b8e6172ec7ca8bcc8bcd1))
* **v-autocomplete:** started initial impl ([115e21d](https://github.com/vuetifyjs/vuetify/commit/115e21de6e8b9cb70b20c5e5c592c4d6af00ac35))
* **v-divider:** add vertical variant ([b71b4f8](https://github.com/vuetifyjs/vuetify/commit/b71b4f89b68b1709a1634689d2d5a1f17faccb32)), closes [#3578](https://github.com/vuetifyjs/vuetify/issues/3578)
* **v-input:** add hide-details func ([ac481e0](https://github.com/vuetifyjs/vuetify/commit/ac481e0c94ebc0c40512a2827b362534d577519d))
* **v-select:** added **dense** prop to `v-select` ([729569a](https://github.com/vuetifyjs/vuetify/commit/729569a6ac3e24bf744a2d7f2db47729d64cd395))
* **v-select:** finished initial re-impl ([1d48e27](https://github.com/vuetifyjs/vuetify/commit/1d48e272ce8e12e1cbee0304b898dd55a05201c8))
* **v-select:** improved chip support, minor tweaks ([248b8fd](https://github.com/vuetifyjs/vuetify/commit/248b8fd7e2e02159495f2504bb6a05162e694f65))
* **v-select:** initial impl of `v-select` ([948b6f8](https://github.com/vuetifyjs/vuetify/commit/948b6f85e12f517ffdd13d869b49926fa435f0c4))
* **v-select:** select rebuilding for abstraction ([344eaf8](https://github.com/vuetifyjs/vuetify/commit/344eaf8253128cea3909866987648eff1990ddd7))
* **v-select:** update chip support ([bc32335](https://github.com/vuetifyjs/vuetify/commit/bc323355ed428bc8f4c229de88f3b215ff91ff77))
* **v-slider:** add new functionality ([d1f01a0](https://github.com/vuetifyjs/vuetify/commit/d1f01a06eec4214860b940356c682e9ea8b011f5)), closes [#1686](https://github.com/vuetifyjs/vuetify/issues/1686)
* **v-slider:** added v-slider support ([4a4abfb](https://github.com/vuetifyjs/vuetify/commit/4a4abfb11d22b0191298d884ffdf545d9f1240dc))
* **v-switch:** added touch support ([0614a23](https://github.com/vuetifyjs/vuetify/commit/0614a2382e62e5ef78caf78cb94e20c586673306))
* **v-text-field:** add reverse functionality ([1bbf319](https://github.com/vuetifyjs/vuetify/commit/1bbf319b365c518a3f842b29ee0cc778330684a3)), closes [#1782](https://github.com/vuetifyjs/vuetify/issues/1782)
* **v-text-field:** added new features, new styles ([7683547](https://github.com/vuetifyjs/vuetify/commit/768354778575a7b47c8da9075bb125d3864979e9))
* **v-textarea/field:** added box styles, improved textarea consistency ([572c98d](https://github.com/vuetifyjs/vuetify/commit/572c98dcfbb2402b90d3fb9e25134618ef345e2b))
* **VSelect:** deprecate all autocomplete props with functional wrapper ([02be146](https://github.com/vuetifyjs/vuetify/commit/02be1465f6fdc1ac298c47910d1f078671bbee6b))
* make $vuetify.breakpoint available before page load ([dd8214e](https://github.com/vuetifyjs/vuetify/commit/dd8214e191c1f9578ad94e99a3070e1d39d7e04b)), closes [#2208](https://github.com/vuetifyjs/vuetify/issues/2208) [#2121](https://github.com/vuetifyjs/vuetify/issues/2121)
* make $vuetify.breakpoint available before page load ([24cea8c](https://github.com/vuetifyjs/vuetify/commit/24cea8cee42e7315dae7400399995f04538b42bc)), closes [#2208](https://github.com/vuetifyjs/vuetify/issues/2208) [#2121](https://github.com/vuetifyjs/vuetify/issues/2121)
* make date/time pickers colorable ([#2199](https://github.com/vuetifyjs/vuetify/issues/2199)) ([05dfc4e](https://github.com/vuetifyjs/vuetify/commit/05dfc4e25e917d31651fe0dc23945535e3f0bd9e)), closes [#2163](https://github.com/vuetifyjs/vuetify/issues/2163)
* no-data and no-results slots for data table ([#2252](https://github.com/vuetifyjs/vuetify/issues/2252)) ([198f8bc](https://github.com/vuetifyjs/vuetify/commit/198f8bcdeed65de78756f2657c0c8d6a524385b1)), closes [#1977](https://github.com/vuetifyjs/vuetify/issues/1977)
* selects input value when focusing autocomplete ([#2358](https://github.com/vuetifyjs/vuetify/issues/2358)) ([c0ce13a](https://github.com/vuetifyjs/vuetify/commit/c0ce13aac4594d3463a1bfe7df2c84239707d523)), closes [#2255](https://github.com/vuetifyjs/vuetify/issues/2255)
* VSelectList component ([37572cf](https://github.com/vuetifyjs/vuetify/commit/37572cf5b10f31867ecf8c86ae53ceb69fd9d8ec))
* VSelectList component (cleanup) ([968fbae](https://github.com/vuetifyjs/vuetify/commit/968fbae087587b88a95277aedecdbbb2f0236750))
* **v-dialog:** changed defaults for `v-dialog` props ([5168d64](https://github.com/vuetifyjs/vuetify/commit/5168d648d62e61265c133353936e4fb0695d9725)), closes [#2098](https://github.com/vuetifyjs/vuetify/issues/2098)
* **v-select:** removed entry label animation when dirty ([1e2650b](https://github.com/vuetifyjs/vuetify/commit/1e2650b8d3b4c5cc2e41aea53812bad892e4078f)), closes [#1941](https://github.com/vuetifyjs/vuetify/issues/1941)
* **v-select:** removed entry label animation when dirty ([e8eb752](https://github.com/vuetifyjs/vuetify/commit/e8eb75297e3fe9eebd11a7b5944a18463123abf8)), closes [#1941](https://github.com/vuetifyjs/vuetify/issues/1941)
* **v-time-picker:** added argument to disabled function call ([18f6aad](https://github.com/vuetifyjs/vuetify/commit/18f6aad3c7c374aca127d7c41cd004ca2129804d)), closes [#1916](https://github.com/vuetifyjs/vuetify/issues/1916)
* **VSelect:** allow the use of custom list tiles in items slot ([#2710](https://github.com/vuetifyjs/vuetify/issues/2710)) ([263e14a](https://github.com/vuetifyjs/vuetify/commit/263e14acb4afe000fda9c9bc0cb1231be75736f4))
* **VTreeview:** add label slot ([#5567](https://github.com/vuetifyjs/vuetify/issues/5567)) ([3a968d0](https://github.com/vuetifyjs/vuetify/commit/3a968d030acbb9b18f5a750978bcf2585e47cc52)), closes [#5531](https://github.com/vuetifyjs/vuetify/issues/5531)


### Bug Fixes

* **api:** props should be kebab-case ([2007b42](https://github.com/vuetifyjs/vuetify/commit/2007b425e93ec0f4a1bfb1284c6e0ecdd2fbd2cf))
* **api:** remove source header in production ([ff7f8b8](https://github.com/vuetifyjs/vuetify/commit/ff7f8b8b6b754241379aa0f797791048d04d833c))
* **api-gen:** exclude v-virtual-table ([cf1630f](https://github.com/vuetifyjs/vuetify/commit/cf1630f9cc5c29773fb83f1c55da27f2dd5a82e6))
* **api-gen:** incorrect prop data for validatable mixin ([0074870](https://github.com/vuetifyjs/vuetify/commit/00748705faa397a66053f0a0d705af57b57541e1))
* **breakpoint:** set correct mobile value when using breakpoint strings ([468d4b6](https://github.com/vuetifyjs/vuetify/commit/468d4b646a7a5fef6b76c5d4265e9b4b2a018767))
* **build:** generate API pages for all languages ([#143](https://github.com/vuetifyjs/vuetify/issues/143)) ([5da56e3](https://github.com/vuetifyjs/vuetify/commit/5da56e330fbb5d6514318b48ea3410eb8ec96191))
* **build:** remove EN_LOCALE_ONLY flag ([#144](https://github.com/vuetifyjs/vuetify/issues/144)) ([01af502](https://github.com/vuetifyjs/vuetify/commit/01af50244950544da5b1c224e144bdcf26e64bb4))
* **build:** use platform specific separator when replacing sass paths ([5149db2](https://github.com/vuetifyjs/vuetify/commit/5149db21b53dea58ff755c290d39de7746833519))
* **click-outside:** allow programmatic click outside ([#12109](https://github.com/vuetifyjs/vuetify/issues/12109)) ([6d26819](https://github.com/vuetifyjs/vuetify/commit/6d268193d31b5bce46edafdcb1647291ee257457)), closes [#12107](https://github.com/vuetifyjs/vuetify/issues/12107)
* **click-outside:** don't trigger if mousedown inside target ([#13244](https://github.com/vuetifyjs/vuetify/issues/13244)) ([f4f8c7a](https://github.com/vuetifyjs/vuetify/commit/f4f8c7a378ec969b9aea7ad544d4692c328140c0)), closes [#5886](https://github.com/vuetifyjs/vuetify/issues/5886) [#9283](https://github.com/vuetifyjs/vuetify/issues/9283)
* **colorutils.ts:** lookbehind regexp causing FF throw error ([#11215](https://github.com/vuetifyjs/vuetify/issues/11215)) ([0604b0b](https://github.com/vuetifyjs/vuetify/commit/0604b0babcdd79b076398b18f73129e63b0f9436)), closes [#11214](https://github.com/vuetifyjs/vuetify/issues/11214)
* **docs:** fix anchors in non-latin translations ([#12790](https://github.com/vuetifyjs/vuetify/issues/12790)) ([89e833a](https://github.com/vuetifyjs/vuetify/commit/89e833a145a6d585eabdf881809f1a99f217239a))
* **docs:** ignore everything in src/pages but the en folder ([c6773fc](https://github.com/vuetifyjs/vuetify/commit/c6773fc6deb07d311a98b4c96360da609d0a98a9))
* **docs:** remove local i18n links, add missing messages ([#12185](https://github.com/vuetifyjs/vuetify/issues/12185)) ([8d58a69](https://github.com/vuetifyjs/vuetify/commit/8d58a692d46c88484c52eeddfc70c359d2908e60))
* **docs:** special characters in headers ([eaa79b9](https://github.com/vuetifyjs/vuetify/commit/eaa79b999a049ff98f05a659e8389c351f8c6a62))
* **Example:** enable prism theme colors ([c25b07f](https://github.com/vuetifyjs/vuetify/commit/c25b07f7fe67687937eb234d07dc31a2971ad3fe))
* **i18n:** Remove untranslated string from ru.ts ([#10945](https://github.com/vuetifyjs/vuetify/issues/10945)) ([c092083](https://github.com/vuetifyjs/vuetify/commit/c0920833923c6c3cd7813f9f8b73c8dd25b5f721))
* **icons:** use correct mdi icon for rating-half ([#12429](https://github.com/vuetifyjs/vuetify/issues/12429)) ([82fb3b9](https://github.com/vuetifyjs/vuetify/commit/82fb3b9503e20fc5f1cbf35f828eac1a7e4c0b0a))
* **inputs:** reset value to null instead of undefined ([#12373](https://github.com/vuetifyjs/vuetify/issues/12373)) ([8e5554d](https://github.com/vuetifyjs/vuetify/commit/8e5554d11828258cb51e25b8bbf17808d6a8730a)), closes [#7429](https://github.com/vuetifyjs/vuetify/issues/7429)
* **locale:** german translation of `carousel.ariaLabel.delimiter` ([#10789](https://github.com/vuetifyjs/vuetify/issues/10789)) ([02df247](https://github.com/vuetifyjs/vuetify/commit/02df247e81aaf4534063c4d54f89e7252a38f45d))
* **locale:** improve and add new fr translation ([#12587](https://github.com/vuetifyjs/vuetify/issues/12587)) ([4b19ae9](https://github.com/vuetifyjs/vuetify/commit/4b19ae9741f4c26c8c000ed9e33dc5c3d3261b60))
* **locale:** improve japanese translations ([#12535](https://github.com/vuetifyjs/vuetify/issues/12535)) ([6c80202](https://github.com/vuetifyjs/vuetify/commit/6c80202775bc91656adf0a98f96d85663c9488e5))
* **Locale:** add missing pagination objects to fi/sk ([aae297b](https://github.com/vuetifyjs/vuetify/commit/aae297b32dddbe8b489f390e348ea49ede3ac0d5))
* **locales:** SK localization fixes and additions ([#11497](https://github.com/vuetifyjs/vuetify/issues/11497)) ([f99df87](https://github.com/vuetifyjs/vuetify/commit/f99df870dde05f6f61607fe875918f512239cb5b))
* **locales:** update language for th-Thai 18n translation ([#12338](https://github.com/vuetifyjs/vuetify/issues/12338)) ([b0913ae](https://github.com/vuetifyjs/vuetify/commit/b0913ae557d8e5247278bd79ae3226c756da9c55))
* **locales:** update NL i18n translation ([#11992](https://github.com/vuetifyjs/vuetify/issues/11992)) ([47325bf](https://github.com/vuetifyjs/vuetify/commit/47325bfb6a71afd9f3d7bb00f65c4785f49ee7a1))
* **metadata:** add unique identifier property to prevent duplicate meta ([808cf6d](https://github.com/vuetifyjs/vuetify/commit/808cf6d0acf84feaeb84c21282085a46476d66ee))
* **overlayable:** overlay must be removed if quickly deactivated ([#10975](https://github.com/vuetifyjs/vuetify/issues/10975)) ([63eb1be](https://github.com/vuetifyjs/vuetify/commit/63eb1be1ea756453a5bf1268deb4b501baca96d7)), closes [#8625](https://github.com/vuetifyjs/vuetify/issues/8625) [#9588](https://github.com/vuetifyjs/vuetify/issues/9588)
* **SelectionControls:** adjust focus and hover styles ([1e66229](https://github.com/vuetifyjs/vuetify/commit/1e66229e86b1e9ec86ce23d69099cfd39e6a7437))
* **SelectionControls:** fix mouse events on field ([40557a6](https://github.com/vuetifyjs/vuetify/commit/40557a690b1b05f24547d0cfa603b2824b7a9ae3)), closes [#10479](https://github.com/vuetifyjs/vuetify/issues/10479)
* **SelectionControls:** fix mouse events on field ([4b6f14b](https://github.com/vuetifyjs/vuetify/commit/4b6f14b64787f9e0461082c0306f84a56c5766be)), closes [#10462](https://github.com/vuetifyjs/vuetify/issues/10462)
* **SelectionControls:** remove color from transition-property ([2f499d2](https://github.com/vuetifyjs/vuetify/commit/2f499d2f5626782cb5efd7868123beae32c19dc1))
* **SelectionControls:** remove duplicate import ([2beb81b](https://github.com/vuetifyjs/vuetify/commit/2beb81b20ed6ba53133f6c3e1e7d1034d3aa4561))
* **spacing:** set negative margin baseline to -4px ([#11453](https://github.com/vuetifyjs/vuetify/issues/11453)) ([af13208](https://github.com/vuetifyjs/vuetify/commit/af13208726a77dcffca968beefd7d71238ff5672))
* **toc:** properly update toc when at bottom of page ([#145](https://github.com/vuetifyjs/vuetify/issues/145)) ([cba2bb9](https://github.com/vuetifyjs/vuetify/commit/cba2bb98b93e89d301a2537bd5e44cf955957194))
* **types:** add missing icons to VuetifyIcons interface ([#12131](https://github.com/vuetifyjs/vuetify/issues/12131)) ([9ee10fd](https://github.com/vuetifyjs/vuetify/commit/9ee10fde8e3334f4db406ddd56b55029528844ec))
* **types:** export VueConstructor instead of Component ([f9bf635](https://github.com/vuetifyjs/vuetify/commit/f9bf63545944aa28b3c9abecfe24ab715ebe649e)), closes [#11463](https://github.com/vuetifyjs/vuetify/issues/11463)
* **types:** export VueConstructor instead of Component ([268434a](https://github.com/vuetifyjs/vuetify/commit/268434aa851dded8b67c0e67bfa39b3cbe791584)), closes [#11463](https://github.com/vuetifyjs/vuetify/issues/11463)
* **types:** export Vuetify as a class ([3a0bd24](https://github.com/vuetifyjs/vuetify/commit/3a0bd24bb19be055d94d00beddffa78f60a098bf)), closes [#12511](https://github.com/vuetifyjs/vuetify/issues/12511)
* **types:** remove number type from Breakpoint['name' ([#12113](https://github.com/vuetifyjs/vuetify/issues/12113)) ([592aca5](https://github.com/vuetifyjs/vuetify/commit/592aca5bf9dfec279a34efc3710b4e3c9ab2ccf3))
* **typography:** conditionally remove important from utility mapping ([c11ae35](https://github.com/vuetifyjs/vuetify/commit/c11ae35ab4275b72525c829969184884d9e3bc34))
* **validatable:** Allow "messages" properties to be null ([#11927](https://github.com/vuetifyjs/vuetify/issues/11927)) ([8ccff06](https://github.com/vuetifyjs/vuetify/commit/8ccff061ba8e74813e0cf9be755cb7f0444c2430)), closes [#11926](https://github.com/vuetifyjs/vuetify/issues/11926)
* **VAppBar:** ensure app bar visibility when hide-on-scroll ([#9993](https://github.com/vuetifyjs/vuetify/issues/9993)) ([#11204](https://github.com/vuetifyjs/vuetify/issues/11204)) ([baa0dd7](https://github.com/vuetifyjs/vuetify/commit/baa0dd75a1fe9043b7034b7461bd1bf3b9264f21))
* **VAppBar:** inverted scroll not hiding the app bar in an edge case ([#10656](https://github.com/vuetifyjs/vuetify/issues/10656)) ([151ae74](https://github.com/vuetifyjs/vuetify/commit/151ae7411f8328848b50be03247daad3d0032f1a)), closes [#10590](https://github.com/vuetifyjs/vuetify/issues/10590)
* **vautocomplete:** change onClick to not reopen menu ([#10158](https://github.com/vuetifyjs/vuetify/issues/10158)) ([10abc11](https://github.com/vuetifyjs/vuetify/commit/10abc11195c9d4deba4c07814f7e8855dee36306)), closes [#6564](https://github.com/vuetifyjs/vuetify/issues/6564)
* **VAutocomplete:** add minimum input width when focused ([254bb29](https://github.com/vuetifyjs/vuetify/commit/254bb29a3e0d2cbd5469e5159f5eec9e58ca3a11))
* **VAutocomplete:** apply focus properly ([#12397](https://github.com/vuetifyjs/vuetify/issues/12397)) ([5100e6e](https://github.com/vuetifyjs/vuetify/commit/5100e6e83afa2c79caa9b84341b0c4af71c7e4bb)), closes [#11989](https://github.com/vuetifyjs/vuetify/issues/11989)
* **VAutocomplete:** avoid scrolling screen when pressing down ([4fce059](https://github.com/vuetifyjs/vuetify/commit/4fce0593088017ef13b0f2b45f050dcbd248d3bd))
* **VAutocomplete:** check for inital search input prop ([#10642](https://github.com/vuetifyjs/vuetify/issues/10642)) ([e09c916](https://github.com/vuetifyjs/vuetify/commit/e09c916f4006f1d3e7fda1b3d1c79b3dc32f2e60)), closes [#9757](https://github.com/vuetifyjs/vuetify/issues/9757) [#9757](https://github.com/vuetifyjs/vuetify/issues/9757) [#9757](https://github.com/vuetifyjs/vuetify/issues/9757)
* **VAutocomplete:** don't try to set data on an empty clipboard event ([8e8c360](https://github.com/vuetifyjs/vuetify/commit/8e8c360912a393b7a9a7f84b475d41406e9fb25d)), closes [#11187](https://github.com/vuetifyjs/vuetify/issues/11187)
* **VAutocomplete:** prefix overlap with placeholder ([#10781](https://github.com/vuetifyjs/vuetify/issues/10781)) ([02723e5](https://github.com/vuetifyjs/vuetify/commit/02723e533413c8f85ea67e4a5fc6b7a1d1c94d28)), closes [#10538](https://github.com/vuetifyjs/vuetify/issues/10538)
* **VAutocomplete:** set isFocused to false on blur ([#12031](https://github.com/vuetifyjs/vuetify/issues/12031)) ([93a2ef7](https://github.com/vuetifyjs/vuetify/commit/93a2ef7a01259cef4bdf347aec307b603a4aa2a0)), closes [#11989](https://github.com/vuetifyjs/vuetify/issues/11989)
* **VBanner:** remove bottom-border on outlined banner ([#12548](https://github.com/vuetifyjs/vuetify/issues/12548)) ([49e25bb](https://github.com/vuetifyjs/vuetify/commit/49e25bb565030f65f7ceaacf86a5eb0d497ffb06)), closes [#12172](https://github.com/vuetifyjs/vuetify/issues/12172)
* **VBtn:** add hover effect radius inheritance ([#10956](https://github.com/vuetifyjs/vuetify/issues/10956)) ([001af08](https://github.com/vuetifyjs/vuetify/commit/001af08aeed2a65455429c3a928c9e56262c0882)), closes [#10671](https://github.com/vuetifyjs/vuetify/issues/10671)
* **VCalendar:** don't use nativeOn on native elements ([#11112](https://github.com/vuetifyjs/vuetify/issues/11112)) ([50d6047](https://github.com/vuetifyjs/vuetify/commit/50d60473fabbbc6ec2d22b355a051a56fc13ed39)), closes [#9999](https://github.com/vuetifyjs/vuetify/issues/9999)
* **VCalendar:** event ends midnight ([#11159](https://github.com/vuetifyjs/vuetify/issues/11159)) ([#11168](https://github.com/vuetifyjs/vuetify/issues/11168)) ([ab86223](https://github.com/vuetifyjs/vuetify/commit/ab86223fbbed752dca9da1fdc2d0586159cb1b8e))
* **VCalendar:** missing day-label slot for daily ([#11069](https://github.com/vuetifyjs/vuetify/issues/11069)) ([#11132](https://github.com/vuetifyjs/vuetify/issues/11132)) ([afc99df](https://github.com/vuetifyjs/vuetify/commit/afc99df7b9966379b22e1079c135b86f5189aa22))
* **VCalendar:** no event rendering without default slot ([#11090](https://github.com/vuetifyjs/vuetify/issues/11090)) ([#11131](https://github.com/vuetifyjs/vuetify/issues/11131)) ([e949427](https://github.com/vuetifyjs/vuetify/commit/e9494276cfaee9274ec4fc0e8cad1ba0ae457450))
* **VCalendar:** weekdays and day views conflict ([#11025](https://github.com/vuetifyjs/vuetify/issues/11025)) ([#11129](https://github.com/vuetifyjs/vuetify/issues/11129)) ([c4eb5da](https://github.com/vuetifyjs/vuetify/commit/c4eb5dadd4504a76a279cbe3de8eee0580ff04b3)), closes [#10123](https://github.com/vuetifyjs/vuetify/issues/10123) [#10123](https://github.com/vuetifyjs/vuetify/issues/10123)
* **VCard:** add !default flag to elevation variable ([7746da6](https://github.com/vuetifyjs/vuetify/commit/7746da665f78ad671d0000f672e545e37c949209)), closes [#10869](https://github.com/vuetifyjs/vuetify/issues/10869)
* **VCard:** increase css specificity for outlined hoverable cards ([#11711](https://github.com/vuetifyjs/vuetify/issues/11711)) ([c1ad4a6](https://github.com/vuetifyjs/vuetify/commit/c1ad4a6963fbd3a4e7ac7833f38b61a90ceb616e)), closes [#11672](https://github.com/vuetifyjs/vuetify/issues/11672)
* **VCard:** prevent re-render of first child when loading is toggled ([ac2f03d](https://github.com/vuetifyjs/vuetify/commit/ac2f03d7aea3ef40ada1afaa4be85a9b42b3a3a8)), closes [#10695](https://github.com/vuetifyjs/vuetify/issues/10695)
* **VCheckbox:** spacing issue with dense ([#10407](https://github.com/vuetifyjs/vuetify/issues/10407)) ([7aa8aa0](https://github.com/vuetifyjs/vuetify/commit/7aa8aa0c5555f00118678f57b634f6735ba8459d)), closes [#10336](https://github.com/vuetifyjs/vuetify/issues/10336)
* **VCheckbox,VRadio:** ripple color for colored selection control ([#11299](https://github.com/vuetifyjs/vuetify/issues/11299)) ([4b849fa](https://github.com/vuetifyjs/vuetify/commit/4b849fa4b00508634387715e7325957198d8ff65)), closes [#11290](https://github.com/vuetifyjs/vuetify/issues/11290)
* **VChip:** add close button aria-label ([#12384](https://github.com/vuetifyjs/vuetify/issues/12384)) ([9cd505d](https://github.com/vuetifyjs/vuetify/commit/9cd505d026a7f851f02a5b513a1d48fa2cc590d6))
* **VColorPicker:** center swatch grid ([#10650](https://github.com/vuetifyjs/vuetify/issues/10650)) ([5835890](https://github.com/vuetifyjs/vuetify/commit/58358900f29e4f89854c139944a5009f594beaa1))
* **VColorPicker:** extractColor util ([#12305](https://github.com/vuetifyjs/vuetify/issues/12305)) ([e7f63c5](https://github.com/vuetifyjs/vuetify/commit/e7f63c5fb068dbf094fd24f2b2409b47c3fb933b))
* **VColorPicker:** hide alpha input correctly ([#10411](https://github.com/vuetifyjs/vuetify/issues/10411)) ([33fff67](https://github.com/vuetifyjs/vuetify/commit/33fff6763ae62f9d11595da689e07a5876d4ae99)), closes [#10402](https://github.com/vuetifyjs/vuetify/issues/10402)
* **VColorPicker:** incorrect layout in RTL mode ([#10706](https://github.com/vuetifyjs/vuetify/issues/10706)) ([54ceff6](https://github.com/vuetifyjs/vuetify/commit/54ceff641532629ba4ceff7a812d1161322e8741)), closes [#10655](https://github.com/vuetifyjs/vuetify/issues/10655)
* **VColorPicker:** use theme color for color-picker inputs ([#12289](https://github.com/vuetifyjs/vuetify/issues/12289)) ([87137af](https://github.com/vuetifyjs/vuetify/commit/87137afbac967213a6c9ef428f14448fbcd2aa43)), closes [#12169](https://github.com/vuetifyjs/vuetify/issues/12169)
* **VCombobox:** blur on click outside when empty ([08c503e](https://github.com/vuetifyjs/vuetify/commit/08c503e2e6d3b10f9c9662b9386569826a258787)), closes [#10612](https://github.com/vuetifyjs/vuetify/issues/10612)
* **VCombobox:** don't try to get data from an empty clipboard event ([7106472](https://github.com/vuetifyjs/vuetify/commit/7106472e89fd8474958d28cd89d970fb0390cc6a)), closes [#11187](https://github.com/vuetifyjs/vuetify/issues/11187)
* **VDataFooter:** translate itemsPerPageText ([#12259](https://github.com/vuetifyjs/vuetify/issues/12259)) ([bcfe8ef](https://github.com/vuetifyjs/vuetify/commit/bcfe8efeb187be4138c37dbacca1032e512cbd9f)), closes [#12012](https://github.com/vuetifyjs/vuetify/issues/12012)
* **VDataIterator:** add missing isMobile property to custom item slot scope ([#10345](https://github.com/vuetifyjs/vuetify/issues/10345)) ([f4b4f0a](https://github.com/vuetifyjs/vuetify/commit/f4b4f0aceeda667a2196f799d0a182bc6aea0fbb)), closes [#8394](https://github.com/vuetifyjs/vuetify/issues/8394) [#9436](https://github.com/vuetifyjs/vuetify/issues/9436)
* **VDataIterator:** emit page-count event ([#10652](https://github.com/vuetifyjs/vuetify/issues/10652)) ([4d04771](https://github.com/vuetifyjs/vuetify/commit/4d04771d34bc40328b5f979746cb03b15e999bc0)), closes [#8886](https://github.com/vuetifyjs/vuetify/issues/8886)
* **VDataTable:** add padding for mobile rows ([#11865](https://github.com/vuetifyjs/vuetify/issues/11865)) ([ec2b4b9](https://github.com/vuetifyjs/vuetify/commit/ec2b4b9a2562ba5d007babb73e5eda5fbcd55895)), closes [#8411](https://github.com/vuetifyjs/vuetify/issues/8411) [#11325](https://github.com/vuetifyjs/vuetify/issues/11325)
* **VDataTable:** close multi-sort select when clicking on mobile ([#11332](https://github.com/vuetifyjs/vuetify/issues/11332)) ([6f8d84a](https://github.com/vuetifyjs/vuetify/commit/6f8d84aeecc180ffb023b1405b4dc86c543789a5)), closes [#10735](https://github.com/vuetifyjs/vuetify/issues/10735)
* **VDataTable:** emit pagination event when filtering ([#10651](https://github.com/vuetifyjs/vuetify/issues/10651)) ([7856dba](https://github.com/vuetifyjs/vuetify/commit/7856dbafac5e77fbcfcf7b2c1e0324c4c84acf6d)), closes [#10212](https://github.com/vuetifyjs/vuetify/issues/10212)
* **VDataTable:** group-by column should be included in search ([#10591](https://github.com/vuetifyjs/vuetify/issues/10591)) ([a40e8d3](https://github.com/vuetifyjs/vuetify/commit/a40e8d35db5f8c055274e38fd8daaae60c9c5d84)), closes [#10392](https://github.com/vuetifyjs/vuetify/issues/10392)
* **VDataTable:** group-by should use correct slot ([#10592](https://github.com/vuetifyjs/vuetify/issues/10592)) ([065e93c](https://github.com/vuetifyjs/vuetify/commit/065e93c0be611867c37daa3a5a7b9642289db685)), closes [#10289](https://github.com/vuetifyjs/vuetify/issues/10289)
* **VDataTable:** groups should be sorted according to groupDesc ([#10771](https://github.com/vuetifyjs/vuetify/issues/10771)) ([6471332](https://github.com/vuetifyjs/vuetify/commit/6471332a6ded4f069152f84dc16cbaec7a754d5c)), closes [#10627](https://github.com/vuetifyjs/vuetify/issues/10627)
* **VDataTable:** handle passing zero to itemsPerPage ([#10516](https://github.com/vuetifyjs/vuetify/issues/10516)) ([6cbcd7f](https://github.com/vuetifyjs/vuetify/commit/6cbcd7f3e55102bc74d45fe0dedc64e1c11cda9a)), closes [#10372](https://github.com/vuetifyjs/vuetify/issues/10372)
* **VDataTable:** header with divider rendered incorrectly in mobile sort select ([#11416](https://github.com/vuetifyjs/vuetify/issues/11416)) ([25001a0](https://github.com/vuetifyjs/vuetify/commit/25001a035818f510543c142082242169075ab1ac)), closes [#11399](https://github.com/vuetifyjs/vuetify/issues/11399)
* **VDataTable:** Loading Progress bar pushes content down ([#10169](https://github.com/vuetifyjs/vuetify/issues/10169)) ([6bb6238](https://github.com/vuetifyjs/vuetify/commit/6bb62381995a3bad8dfe45459eaae893b32b06a8))
* **VDataTable:** pagination event fires twice in a row ([#10769](https://github.com/vuetifyjs/vuetify/issues/10769)) ([cfee1b4](https://github.com/vuetifyjs/vuetify/commit/cfee1b4a8cd963f80a5e53d9a8b3e55d78fe9709)), closes [#10715](https://github.com/vuetifyjs/vuetify/issues/10715)
* **VDataTable:** remove hover on empty (no data) wrapper ([#10600](https://github.com/vuetifyjs/vuetify/issues/10600)) ([c978f11](https://github.com/vuetifyjs/vuetify/commit/c978f11e648fc05d76564a2d381772f0fbdd2373))
* **VDataTable:** set initial values for sort-desc and group-desc ([#11342](https://github.com/vuetifyjs/vuetify/issues/11342)) ([450357d](https://github.com/vuetifyjs/vuetify/commit/450357d023afbc35dca9cacd8d1c262ef8002406)), closes [#9685](https://github.com/vuetifyjs/vuetify/issues/9685)
* up-next functionality ([#8](https://github.com/vuetifyjs/vuetify/issues/8)) ([9bba623](https://github.com/vuetifyjs/vuetify/commit/9bba623eb04db8140607b2ca605b8fd1919d4b21))
* **VAutocomplete:** filter items without text values ([f8068ed](https://github.com/vuetifyjs/vuetify/commit/f8068ed6d4905c953463cf898150aae0b940fc3e))
* **VDataTable:** header with divider rendered incorrectly in mobile sort select ([#11416](https://github.com/vuetifyjs/vuetify/issues/11416)) ([d079b1d](https://github.com/vuetifyjs/vuetify/commit/d079b1d61b78a47a5605240f961937ae79ce45c9)), closes [#11399](https://github.com/vuetifyjs/vuetify/issues/11399)
* **VDataTable:** include rows that exclusively match custom filters ([#11181](https://github.com/vuetifyjs/vuetify/issues/11181)) ([239e238](https://github.com/vuetifyjs/vuetify/commit/239e238d69f35064db55e9f41db8fd832f347ab5)), closes [#9887](https://github.com/vuetifyjs/vuetify/issues/9887)
* **VDataTable:** respect mustSort property in options prop ([#11334](https://github.com/vuetifyjs/vuetify/issues/11334)) ([248300f](https://github.com/vuetifyjs/vuetify/commit/248300fdd9f99e1184dcc7f0b67d16be06d78c79)), closes [#10244](https://github.com/vuetifyjs/vuetify/issues/10244)
* **VDataTable:** set initial values for sort-desc and group-desc ([#11342](https://github.com/vuetifyjs/vuetify/issues/11342)) ([8a78533](https://github.com/vuetifyjs/vuetify/commit/8a785333a17a102f9b89dee5d64e25e0809ba6ad)), closes [#9685](https://github.com/vuetifyjs/vuetify/issues/9685)
* **VDataTable:** show correct aria-labels for sorting ([#9638](https://github.com/vuetifyjs/vuetify/issues/9638)) ([e3ea39d](https://github.com/vuetifyjs/vuetify/commit/e3ea39d3842ea14e03b809a5c4e6da2bb597114d)), closes [#4975](https://github.com/vuetifyjs/vuetify/issues/4975)
* **VDatePicker:** locale weeknumber calculation ([#10926](https://github.com/vuetifyjs/vuetify/issues/10926)) ([b7f830a](https://github.com/vuetifyjs/vuetify/commit/b7f830a68127aed058f48859dc22c4c012c751a5)), closes [#9764](https://github.com/vuetifyjs/vuetify/issues/9764)
* **VDatePicker:** set proper tableDate if showCurrent is set ([#11305](https://github.com/vuetifyjs/vuetify/issues/11305)) ([6aa01a7](https://github.com/vuetifyjs/vuetify/commit/6aa01a70bfcf4a9e7baf64ff6afc15ab9ac93980)), closes [#6714](https://github.com/vuetifyjs/vuetify/issues/6714)
* **VDatePicker:** unnecessarily emited change event in range picker ([874553e](https://github.com/vuetifyjs/vuetify/commit/874553ed53c5cd1bed2825590892f3e343246ace)), closes [#11056](https://github.com/vuetifyjs/vuetify/issues/11056)
* **VDialog:** allow more than 1 content node ([cc17fe1](https://github.com/vuetifyjs/vuetify/commit/cc17fe19751826d950ca5207749699935d227020))
* **VDialog:** close on esc when eager is not set ([0e31691](https://github.com/vuetifyjs/vuetify/commit/0e31691db0bcfe0f33cfe67bd43ef17b04ddfe0d)), closes [#11257](https://github.com/vuetifyjs/vuetify/issues/11257)
* **VDialog:** refocus previous element when dialog is closed ([700fd42](https://github.com/vuetifyjs/vuetify/commit/700fd4289d21f83ba17373fd390bf6bb6b52326b)), closes [#7907](https://github.com/vuetifyjs/vuetify/issues/7907)
* **VDialog:** show transition on close ([1491914](https://github.com/vuetifyjs/vuetify/commit/1491914bca565321fc9ef4b28603f48881b25ed3)), closes [#10506](https://github.com/vuetifyjs/vuetify/issues/10506)
* **VDialog:** use the origin prop ([8f6e931](https://github.com/vuetifyjs/vuetify/commit/8f6e9317eee9aa16c3383afe617952eaeffe115b)), closes [#7134](https://github.com/vuetifyjs/vuetify/issues/7134)
* **VFileInput:** avoid input field event capturing in safari ([#11897](https://github.com/vuetifyjs/vuetify/issues/11897)) ([d5800aa](https://github.com/vuetifyjs/vuetify/commit/d5800aad7dc9e62e7d398c890b7af6580e6060ce)), closes [#10832](https://github.com/vuetifyjs/vuetify/issues/10832)
* **VFooter:** only apply width when not using the inset prop ([a7381aa](https://github.com/vuetifyjs/vuetify/commit/a7381aa97c80cdd18b65354048e75397a22e4c36)), closes [#8128](https://github.com/vuetifyjs/vuetify/issues/8128)
* **VGrid:** correct row width in fill-height container ([#10241](https://github.com/vuetifyjs/vuetify/issues/10241)) ([9d69b75](https://github.com/vuetifyjs/vuetify/commit/9d69b752b64d5e8c7f18bbaacbb0d35282dfa400)), closes [#9773](https://github.com/vuetifyjs/vuetify/issues/9773)
* **VIcon:** add missing width attribute when rendering svg icons ([#10942](https://github.com/vuetifyjs/vuetify/issues/10942)) ([2112add](https://github.com/vuetifyjs/vuetify/commit/2112addbab8d8464d5b6671abe6b4f045b1350fa)), closes [#10938](https://github.com/vuetifyjs/vuetify/issues/10938)
* **VIcon:** add top and left to pseudo class for IE11 ([a3d0cf7](https://github.com/vuetifyjs/vuetify/commit/a3d0cf763f506856add1c0367857db1f16ab6338)), closes [#11686](https://github.com/vuetifyjs/vuetify/issues/11686)
* **VIcon:** change default icon svg size to match regular icon ([#10507](https://github.com/vuetifyjs/vuetify/issues/10507)) ([2045295](https://github.com/vuetifyjs/vuetify/commit/20452950e84a2593eeb0a4a7b67517f40e4f9912))
* **VIcon:** render a button element around clickable component icons ([#12148](https://github.com/vuetifyjs/vuetify/issues/12148)) ([7bddf2b](https://github.com/vuetifyjs/vuetify/commit/7bddf2b5d0b1aba7443fd2a3d3b798904751c8a1)), closes [#12143](https://github.com/vuetifyjs/vuetify/issues/12143)
* **VIcon:** revert opacity changes, only show focus ring ([de967ac](https://github.com/vuetifyjs/vuetify/commit/de967aca925d06f9af32907a3be1f0170e024e70))
* **VIcon:** use a button element for clickable icons ([#10439](https://github.com/vuetifyjs/vuetify/issues/10439)) ([1596e55](https://github.com/vuetifyjs/vuetify/commit/1596e55a885cb9c91e63bef5018f15c9f5a55ef2)), closes [#10265](https://github.com/vuetifyjs/vuetify/issues/10265) [#10391](https://github.com/vuetifyjs/vuetify/issues/10391) [#10398](https://github.com/vuetifyjs/vuetify/issues/10398)
* **VImg:** correctly pass options to intersect directive ([#10855](https://github.com/vuetifyjs/vuetify/issues/10855)) ([2133162](https://github.com/vuetifyjs/vuetify/commit/21331625b9707f19cc2004f2e0957b288a2ccad3)), closes [#10848](https://github.com/vuetifyjs/vuetify/issues/10848)
* **VInput:** show bottom border when loading prop is null ([0f9b034](https://github.com/vuetifyjs/vuetify/commit/0f9b03414b9d73e5a4501b1d9190d206c035a08d)), closes [#10828](https://github.com/vuetifyjs/vuetify/issues/10828)
* **VList:** use tag prop ([fb062bf](https://github.com/vuetifyjs/vuetify/commit/fb062bfa9e27d93cad6c10d095ae70c830deb6b9)), closes [#10529](https://github.com/vuetifyjs/vuetify/issues/10529)
* **VListItem:** vertical alignment on IE11 ([#10717](https://github.com/vuetifyjs/vuetify/issues/10717)) ([81dfbf8](https://github.com/vuetifyjs/vuetify/commit/81dfbf8e4ac6bf6fbbc0e61e121245a4e68f56bf)), closes [#10464](https://github.com/vuetifyjs/vuetify/issues/10464) [#10464](https://github.com/vuetifyjs/vuetify/issues/10464)
* **VMenu:** allow more than 1 content node ([#10525](https://github.com/vuetifyjs/vuetify/issues/10525)) ([5d8d487](https://github.com/vuetifyjs/vuetify/commit/5d8d4871c3b916090b11749ca83852616f49415b)), closes [#10522](https://github.com/vuetifyjs/vuetify/issues/10522)
* **VMenu:** remove events from old element when activator changes ([0a6946a](https://github.com/vuetifyjs/vuetify/commit/0a6946ae192a40ac9cfa80e86a3cc188b67c4a8e)), closes [#10430](https://github.com/vuetifyjs/vuetify/issues/10430)
* **VMenu:** set dimensions to 0 if content does not exist yet ([5358676](https://github.com/vuetifyjs/vuetify/commit/5358676771df99ef0adeca1c2d230f6374e5189a)), closes [#10606](https://github.com/vuetifyjs/vuetify/issues/10606)
* **VMessages/VCounter:** resolve layout jump caused by incorrect line-height ([5c8be69](https://github.com/vuetifyjs/vuetify/commit/5c8be69fc4044d9245cdec40c34a228f23c1339a))
* **VNavigationDrawer:** change closed navigation drawer visibility ([#10824](https://github.com/vuetifyjs/vuetify/issues/10824)) ([0a0f44d](https://github.com/vuetifyjs/vuetify/commit/0a0f44d13c25f7aa8c194a161b98b4bf5486bc41)), closes [#10821](https://github.com/vuetifyjs/vuetify/issues/10821)
* **VNavigationDrawer:** disable inherit value of background property ([#11419](https://github.com/vuetifyjs/vuetify/issues/11419)) ([9900388](https://github.com/vuetifyjs/vuetify/commit/9900388e126e77a5d76c500db7cb70f226c020b4)), closes [#11153](https://github.com/vuetifyjs/vuetify/issues/11153)
* **VNavigationDrawer:** dynamic expand-on-hover ([#10903](https://github.com/vuetifyjs/vuetify/issues/10903)) ([a4fe6f5](https://github.com/vuetifyjs/vuetify/commit/a4fe6f5bcf12c713d94760c360e83503345fb1b3)), closes [#10862](https://github.com/vuetifyjs/vuetify/issues/10862)
* **VNavigationDrawer:** scrolling in temporary hide-overlay ([#10759](https://github.com/vuetifyjs/vuetify/issues/10759)) ([8c99fee](https://github.com/vuetifyjs/vuetify/commit/8c99fee1aedc8517dbef1d2164c07782fb4a49f2)), closes [#10758](https://github.com/vuetifyjs/vuetify/issues/10758)
* **VPagination:** add interesectable support ([f245833](https://github.com/vuetifyjs/vuetify/commit/f245833a07e8a998a7312188620fd383069b8f8f)), closes [#2434](https://github.com/vuetifyjs/vuetify/issues/2434)
* **VProgressCircular:** dark theme background color clash ([#12192](https://github.com/vuetifyjs/vuetify/issues/12192)) ([a95840e](https://github.com/vuetifyjs/vuetify/commit/a95840eceb536de265c09deca30138ad826b8fa9))
* **VProgressLinear:** use both horizontal and vertical repeat ([#10876](https://github.com/vuetifyjs/vuetify/issues/10876)) ([583c811](https://github.com/vuetifyjs/vuetify/commit/583c8116fe3418428964ba29ba5b4da43c223d51)), closes [#10852](https://github.com/vuetifyjs/vuetify/issues/10852)
* **VRadioGroup:** apply legend style changes only when using row ([f0ceca0](https://github.com/vuetifyjs/vuetify/commit/f0ceca0e3050e684f9ffc82ba81dbf6429272fa0)), closes [#10403](https://github.com/vuetifyjs/vuetify/issues/10403)
* **VRangeSlider:** add unique id for inputs elements ([#10654](https://github.com/vuetifyjs/vuetify/issues/10654)) ([1244991](https://github.com/vuetifyjs/vuetify/commit/12449918fbe8d955de54cea43e74a008b4e46195)), closes [#6843](https://github.com/vuetifyjs/vuetify/issues/6843) [#6843](https://github.com/vuetifyjs/vuetify/issues/6843)
* **VRangeSlider:** incorrect slider width when disabled ([#11307](https://github.com/vuetifyjs/vuetify/issues/11307)) ([ee73538](https://github.com/vuetifyjs/vuetify/commit/ee73538d18bb3094c4c94dcb77468089ed37be5a)), closes [#11302](https://github.com/vuetifyjs/vuetify/issues/11302)
* **VRating:** remove tabindex from icons ([6e6d6b8](https://github.com/vuetifyjs/vuetify/commit/6e6d6b8c6ca3fc358b738138f22bde1cccc5758e)), closes [#10379](https://github.com/vuetifyjs/vuetify/issues/10379)
* **VRipple:** add keyboard trigger support ([#10304](https://github.com/vuetifyjs/vuetify/issues/10304)) ([b745d00](https://github.com/vuetifyjs/vuetify/commit/b745d006d05e2998c993152de826b5986ee13e58)), closes [#10285](https://github.com/vuetifyjs/vuetify/issues/10285)
* **VSelect:** add Y offset to menu to match material guidelines ([#10940](https://github.com/vuetifyjs/vuetify/issues/10940)) ([3586847](https://github.com/vuetifyjs/vuetify/commit/3586847f1ce45f424a40fe11bb65c812780bf70f)), closes [#10859](https://github.com/vuetifyjs/vuetify/issues/10859)
* **VSelect:** allow blur from outside click ([47b2535](https://github.com/vuetifyjs/vuetify/commit/47b25358be37df38d493dc34ffedadce8695622c))
* **VSelect:** allow tab key down on read-only ([#11431](https://github.com/vuetifyjs/vuetify/issues/11431)) ([66d37b3](https://github.com/vuetifyjs/vuetify/commit/66d37b3cdf344fc73de101c05b2406f0cd034167)), closes [#11430](https://github.com/vuetifyjs/vuetify/issues/11430)
* **VSelect:** do not open menu if clicking on selection item ([#12343](https://github.com/vuetifyjs/vuetify/issues/12343)) ([dcfbca6](https://github.com/vuetifyjs/vuetify/commit/dcfbca6e532a4591cd51dfc40dc075007322bdfd)), closes [#11824](https://github.com/vuetifyjs/vuetify/issues/11824)
* **VSelect:** don't close when a detachable child is clicked ([5077c3c](https://github.com/vuetifyjs/vuetify/commit/5077c3cd67875e7e2f3f158ab445bc0eed212b62)), closes [#12354](https://github.com/vuetifyjs/vuetify/issues/12354)
* allow $material-dark-elevation-colors to be overridden ([#12340](https://github.com/vuetifyjs/vuetify/issues/12340)) ([41cbb3a](https://github.com/vuetifyjs/vuetify/commit/41cbb3a30ff1f5eecadb6c0f6f4e59305ab14957))
* **VExpandTransition:** Properly trigger transition listeners ([#12019](https://github.com/vuetifyjs/vuetify/issues/12019)) ([b6e27f6](https://github.com/vuetifyjs/vuetify/commit/b6e27f6fa7d981ee4a79118aaaacabc08db7a2ae)), closes [#12018](https://github.com/vuetifyjs/vuetify/issues/12018)
* **VFileInput:** file-input-slot dense min-height ([#12570](https://github.com/vuetifyjs/vuetify/issues/12570)) ([3e65162](https://github.com/vuetifyjs/vuetify/commit/3e651624a9fbb55c63e1c14430481120b3df8c4b))
* **VIcon:** don't apply fill styles to component icons ([eaf2f1b](https://github.com/vuetifyjs/vuetify/commit/eaf2f1b21a0e1ffa1458c4dd5338d618dfeeee2f)), closes [#12378](https://github.com/vuetifyjs/vuetify/issues/12378) [#12148](https://github.com/vuetifyjs/vuetify/issues/12148)
* **VIcon:** set svg dimensions in style instead of attributes ([#12319](https://github.com/vuetifyjs/vuetify/issues/12319)) ([3576aa5](https://github.com/vuetifyjs/vuetify/commit/3576aa5b52c954b603e4897725dfabfd709b78f2)), closes [#12372](https://github.com/vuetifyjs/vuetify/issues/12372) [#12148](https://github.com/vuetifyjs/vuetify/issues/12148)
* **VInput:** use $label-letter-spacing variable ([#12546](https://github.com/vuetifyjs/vuetify/issues/12546)) ([915fbaa](https://github.com/vuetifyjs/vuetify/commit/915fbaa5d964c7f4563658779e02c7c4c9b29fb7))
* **VLinearProgress:** remove unnecessary z-index ([#12386](https://github.com/vuetifyjs/vuetify/issues/12386)) ([7c8b0b4](https://github.com/vuetifyjs/vuetify/commit/7c8b0b4076ec1042c1892cc49f0adc4ce1159472)), closes [#11847](https://github.com/vuetifyjs/vuetify/issues/11847)
* **VListitem:** disable mouse click in animating menu ([#12059](https://github.com/vuetifyjs/vuetify/issues/12059)) ([0b8ec25](https://github.com/vuetifyjs/vuetify/commit/0b8ec251b47bcc4f5b1924716c71805d49c3c1e5)), closes [#12021](https://github.com/vuetifyjs/vuetify/issues/12021)
* **VMenu:** open-on-hover does not close on-content-click ([#12566](https://github.com/vuetifyjs/vuetify/issues/12566)) ([389d023](https://github.com/vuetifyjs/vuetify/commit/389d023811c66f057a08ddb83f1f41bcf9080c08))
* **VPagination:** Add support for 0 totalVisible items ([#12456](https://github.com/vuetifyjs/vuetify/issues/12456)) ([53ba1d8](https://github.com/vuetifyjs/vuetify/commit/53ba1d830425d5746a803fefe02d928f12848db7))
* **VRadio:** do not use cursor pointer if disabled ([#12058](https://github.com/vuetifyjs/vuetify/issues/12058)) ([42c79b7](https://github.com/vuetifyjs/vuetify/commit/42c79b760650d50f37e710bf9e1e175b5a884d12)), closes [#12023](https://github.com/vuetifyjs/vuetify/issues/12023)
* **VRadioGroup:** label styles ([#12382](https://github.com/vuetifyjs/vuetify/issues/12382)) ([c61093f](https://github.com/vuetifyjs/vuetify/commit/c61093ff465fdf9c1d7b99d12ec973a9f7b83eb0))
* **VSelect:** do not deduplicate headers or dividers ([4a855cd](https://github.com/vuetifyjs/vuetify/commit/4a855cd8d940c35fc01c5a8521ff539c7491eda1)), closes [#12517](https://github.com/vuetifyjs/vuetify/issues/12517)
* **VSelect:** do not highlight search text without an item match ([#12163](https://github.com/vuetifyjs/vuetify/issues/12163)) ([148ecf5](https://github.com/vuetifyjs/vuetify/commit/148ecf522382dc8f3c32d092740d87810d0d5f39)), closes [#10843](https://github.com/vuetifyjs/vuetify/issues/10843)
* **VSimpleTable:** add border radius to first and last row  ([#12553](https://github.com/vuetifyjs/vuetify/issues/12553)) ([36080ca](https://github.com/vuetifyjs/vuetify/commit/36080caac7e4f49a5601ee7826f093df3c9bef62))
* **VSlider:** disable input tag ([#12630](https://github.com/vuetifyjs/vuetify/issues/12630)) ([36300b2](https://github.com/vuetifyjs/vuetify/commit/36300b2cadf3ebe93091d5df67cfa25dfb2c0348)), closes [#12620](https://github.com/vuetifyjs/vuetify/issues/12620)
* **VSnackbar:** remove transparent background with text/outlined props ([3dbd910](https://github.com/vuetifyjs/vuetify/commit/3dbd910ebebcb77077f0d90688523872a016dad3)), closes [#11835](https://github.com/vuetifyjs/vuetify/issues/11835)
* **VSparkline:** show path when all values are the same ([020e2e1](https://github.com/vuetifyjs/vuetify/commit/020e2e10bd47f0eae996dc471647cf84aef4b58e))
* **VTabs:** resize slider when icons-and-text prop changes ([#12525](https://github.com/vuetifyjs/vuetify/issues/12525)) ([aac7c54](https://github.com/vuetifyjs/vuetify/commit/aac7c54b053af96881c36efa222243d7206df73e)), closes [#12524](https://github.com/vuetifyjs/vuetify/issues/12524)
* **VTextField:** add background color to line on focus ([#12556](https://github.com/vuetifyjs/vuetify/issues/12556)) ([3e78556](https://github.com/vuetifyjs/vuetify/commit/3e78556d9c903f09382b7eaad68140ef559ee07f))
* **VTextField:** count characters instead of codepoints ([#12451](https://github.com/vuetifyjs/vuetify/issues/12451)) ([c048a77](https://github.com/vuetifyjs/vuetify/commit/c048a77660f47055676fd22d6b0b0957e0a47821))
* **VTextField:** count non-string types ([#12475](https://github.com/vuetifyjs/vuetify/issues/12475)) ([5dec772](https://github.com/vuetifyjs/vuetify/commit/5dec772bc64241aa1f9ceb9b971c19e215027b5d)), closes [#12451](https://github.com/vuetifyjs/vuetify/issues/12451)
* **VTextField:** remove erroneous white space for outlined style ([#11748](https://github.com/vuetifyjs/vuetify/issues/11748)) ([d723457](https://github.com/vuetifyjs/vuetify/commit/d723457218f35506aa8beb05c319dc45369c5e8b))
* **VTextField:** show label slot when filled prop is used ([#12371](https://github.com/vuetifyjs/vuetify/issues/12371)) ([d7d77a3](https://github.com/vuetifyjs/vuetify/commit/d7d77a3aef1d5e6699a4fdd797e3c3052b2954a6)), closes [#11533](https://github.com/vuetifyjs/vuetify/issues/11533)
* **VTextField:** use resize directive to recalculate elements width ([#11816](https://github.com/vuetifyjs/vuetify/issues/11816)) ([4efd18d](https://github.com/vuetifyjs/vuetify/commit/4efd18da09d816d5a4b1c9cc65e630f4a0985b7f))
* **VTimePicker:** add flex-basis property to container for safari 52 support ([#12239](https://github.com/vuetifyjs/vuetify/issues/12239)) ([98b510b](https://github.com/vuetifyjs/vuetify/commit/98b510b2d68a4b064fa2c4fa65f812a681450e38))
* **VToolbar:** v-toolbar sass variables typo ([#12547](https://github.com/vuetifyjs/vuetify/issues/12547)) ([11c746e](https://github.com/vuetifyjs/vuetify/commit/11c746e1005dc892d3c555f707f871d69d7bcad4))
* **VTreeView:** don't render filtered-out items ([45767d2](https://github.com/vuetifyjs/vuetify/commit/45767d2b5fcec06db3ac32f3f335f46849110e75)), closes [#11872](https://github.com/vuetifyjs/vuetify/issues/11872)
* **VVirtualScroll:** pass through native events ([c2734d3](https://github.com/vuetifyjs/vuetify/commit/c2734d3e7721ad794de84c89ce0486869580742c)), closes [#12077](https://github.com/vuetifyjs/vuetify/issues/12077)
* change curser:default selector to [aria-disabled="true"] ([#11467](https://github.com/vuetifyjs/vuetify/issues/11467)) ([04781b6](https://github.com/vuetifyjs/vuetify/commit/04781b65079935205ed2f81a30d100e6591e756c)), closes [#11003](https://github.com/vuetifyjs/vuetify/issues/11003)
* change type import paths ([#11314](https://github.com/vuetifyjs/vuetify/issues/11314)) ([2325dd9](https://github.com/vuetifyjs/vuetify/commit/2325dd9570b0fa543277304369010853c09034f8))
* do not render vuetify ads if there is no data ([#4](https://github.com/vuetifyjs/vuetify/issues/4)) ([f4315e4](https://github.com/vuetifyjs/vuetify/commit/f4315e46db3d3f1d48c3fd0d8b2c3ef9c19d2d26))
* markdown disappears on hmr update ([7035257](https://github.com/vuetifyjs/vuetify/commit/7035257f7e6a252c7156245b5c3884ff3cdb2d99))
* use $ssrContext instead of options.ssrContext ([5da64d2](https://github.com/vuetifyjs/vuetify/commit/5da64d2f1ab00e6a658f65cfb616de9abd61a1ce)), closes [#11935](https://github.com/vuetifyjs/vuetify/issues/11935)
* **_reset.css:** add removed overflow to html ([6663607](https://github.com/vuetifyjs/vuetify/commit/666360731830dc142b63a0b73f651bbece71e02e))
* **activatable:** stop activator event listener propagation ([be58395](https://github.com/vuetifyjs/vuetify/commit/be583953ed4cf9a5a374df2a09fe5aeb34937204)), closes [#3333](https://github.com/vuetifyjs/vuetify/issues/3333)
* **application-service:** overwrite location sizes when registering ([59a6bbf](https://github.com/vuetifyjs/vuetify/commit/59a6bbf8cf02a8e1565db6b268741c7c655c0176)), closes [#9797](https://github.com/vuetifyjs/vuetify/issues/9797)
* **bootable:** don't generate lazy content until it's rendered ([#8823](https://github.com/vuetifyjs/vuetify/issues/8823)) ([2b975f5](https://github.com/vuetifyjs/vuetify/commit/2b975f575f47ba75aa5d0dd9fba859595c7b9ba4)), closes [#8712](https://github.com/vuetifyjs/vuetify/issues/8712) [#8712](https://github.com/vuetifyjs/vuetify/issues/8712)
* **css-reset:** add missing comma for style declaration ([3a347a1](https://github.com/vuetifyjs/vuetify/commit/3a347a153e39cfe25f3ce6de1059c64a61ae7438)), closes [#9521](https://github.com/vuetifyjs/vuetify/issues/9521)
* **detachable:** change detach target ([6d001c7](https://github.com/vuetifyjs/vuetify/commit/6d001c7cf7b4ddd0059a127d3fed752b971949d1)), closes [#9906](https://github.com/vuetifyjs/vuetify/issues/9906)
* **form-controls:** fix disabled styles ([#10191](https://github.com/vuetifyjs/vuetify/issues/10191)) ([b4ad01a](https://github.com/vuetifyjs/vuetify/commit/b4ad01a4d1308616135fc158c85373ffe88707e6)), closes [#9488](https://github.com/vuetifyjs/vuetify/issues/9488) [#10154](https://github.com/vuetifyjs/vuetify/issues/10154)
* **framework:** update colors to match spec ([103becb](https://github.com/vuetifyjs/vuetify/commit/103becbc795c1870515ec703ba0b26447ba96e79))
* **helpers:** check if source property is object ([5a4578c](https://github.com/vuetifyjs/vuetify/commit/5a4578cde6f842b5e75362eacb88d712e7ea7c60)), closes [#10100](https://github.com/vuetifyjs/vuetify/issues/10100)
* **icons:** add missing faSvg type to iconfont ([#9996](https://github.com/vuetifyjs/vuetify/issues/9996)) ([12d03d7](https://github.com/vuetifyjs/vuetify/commit/12d03d7f7975a8fcdbe694495235b2419591b94f))
* **icons:** add support for font awesome svg icons ([#8092](https://github.com/vuetifyjs/vuetify/issues/8092)) ([37ce47b](https://github.com/vuetifyjs/vuetify/commit/37ce47be306678c66bf3d9662030e824df582266)), closes [#8016](https://github.com/vuetifyjs/vuetify/issues/8016)
* **icons:** add support for font awesome svg icons ([#8092](https://github.com/vuetifyjs/vuetify/issues/8092)) ([c4b7225](https://github.com/vuetifyjs/vuetify/commit/c4b722578855ceb78d3f00d3f6c0adb99b794106)), closes [#8016](https://github.com/vuetifyjs/vuetify/issues/8016)
* **locale:** Updated Turkish translation for Carousel ([a49dbb2](https://github.com/vuetifyjs/vuetify/commit/a49dbb2c468531cf28122e664d2c2435b855f509))
* **locales:** update hu-Hungarian 1i8n translations ([#11719](https://github.com/vuetifyjs/vuetify/issues/11719)) ([ed17793](https://github.com/vuetifyjs/vuetify/commit/ed177930cefeaf62433568c6c68d2313cfd4407b))
* **presets:** export interfaces ([#10161](https://github.com/vuetifyjs/vuetify/issues/10161)) ([843a875](https://github.com/vuetifyjs/vuetify/commit/843a87534bd229eba1346b7f105aa76c7fdd188b))
* **sass:** allow overriding $spacers ([6d913d3](https://github.com/vuetifyjs/vuetify/commit/6d913d32cf25e53abd2190fee19c25241500a8c3)), closes [#10303](https://github.com/vuetifyjs/vuetify/issues/10303)
* **sass variables:** add missing !default suffixes to numerous variables ([#11760](https://github.com/vuetifyjs/vuetify/issues/11760)) ([77a0a91](https://github.com/vuetifyjs/vuetify/commit/77a0a918378a33f18d48c381a7b7d20a1e41e943)), closes [#11751](https://github.com/vuetifyjs/vuetify/issues/11751)
* **selection-controls:** refactor click event handling ([f055c36](https://github.com/vuetifyjs/vuetify/commit/f055c3627f76fdd9f7b966dd9a6ba1868401a325)), closes [#5968](https://github.com/vuetifyjs/vuetify/issues/5968) [#9408](https://github.com/vuetifyjs/vuetify/issues/9408)
* **SelectionControls:** change selection-control disabled color ([f6ef33c](https://github.com/vuetifyjs/vuetify/commit/f6ef33c64c2fc453d4157524a3e2c587ad5de944)), closes [#9280](https://github.com/vuetifyjs/vuetify/issues/9280)
* **SelectionControls:** properly align slotted labels ([840f0ce](https://github.com/vuetifyjs/vuetify/commit/840f0ce54bd3946524908f374b5e7d6625714ef9)), closes [#10214](https://github.com/vuetifyjs/vuetify/issues/10214)
* **SelectionControls:** resolve height issues with wrapped labels in radios ([22aa469](https://github.com/vuetifyjs/vuetify/commit/22aa46965ca8a3e762d7e8c1c0f58bd689ab2571)), closes [#10360](https://github.com/vuetifyjs/vuetify/issues/10360)
* **ssr:** don't assume $el exists ([9f42467](https://github.com/vuetifyjs/vuetify/commit/9f424675829aea46b1cf4eb2a02922cc59722115)), closes [#11903](https://github.com/vuetifyjs/vuetify/issues/11903)
* **ssr:** use xs breakpoint on inital render when hydrating ([#11842](https://github.com/vuetifyjs/vuetify/issues/11842)) ([56f5668](https://github.com/vuetifyjs/vuetify/commit/56f5668d27b6ac0a52c792fb9745164155faa8e3)), closes [#3436](https://github.com/vuetifyjs/vuetify/issues/3436) [#7410](https://github.com/vuetifyjs/vuetify/issues/7410)
* **sw:** don't register the service worker is it's not available ([#75](https://github.com/vuetifyjs/vuetify/issues/75)) ([31f9eaa](https://github.com/vuetifyjs/vuetify/commit/31f9eaa53f370d48f82508f801c69c91c00d17fd))
* **TeamMembers:** fix md size ([#132](https://github.com/vuetifyjs/vuetify/issues/132)) ([940a5cc](https://github.com/vuetifyjs/vuetify/commit/940a5cc43e72d6342428f55c8dfc5d7ff9ef712f))
* **theme:** apply correct material theme for dark variants ([24c95f4](https://github.com/vuetifyjs/vuetify/commit/24c95f45e0b3821718ff62600ae876ebed7a4896))
* **theme:** resolve more dark variant inconsistences ([07a285f](https://github.com/vuetifyjs/vuetify/commit/07a285f9f72fdf97c7eb751baf532f3c8614c30b))
* **types:** add faSvg to icon's service IconFont type ([#10103](https://github.com/vuetifyjs/vuetify/issues/10103)) ([7235ff0](https://github.com/vuetifyjs/vuetify/commit/7235ff0366a8b3ba40b07ce016ddd58f24d19aec))
* **v-ripple:** remove the correct event listener ([#10062](https://github.com/vuetifyjs/vuetify/issues/10062)) ([e4c35ae](https://github.com/vuetifyjs/vuetify/commit/e4c35ae958ca56f62ccd00295085212ec6d06944))
* **VAlert:** fix transition irregularities ([5f35eff](https://github.com/vuetifyjs/vuetify/commit/5f35eff8d54fdf170ac5d2c18b57fa6e695eec25)), closes [#9033](https://github.com/vuetifyjs/vuetify/issues/9033)
* **VAlert:** pass events through to root element ([05e7d22](https://github.com/vuetifyjs/vuetify/commit/05e7d22d5f55d551afc77e69d9bc7131a0efc7e8)), closes [#11929](https://github.com/vuetifyjs/vuetify/issues/11929)
* **validatable:** properly handle boolean false as fn return ([2ac7392](https://github.com/vuetifyjs/vuetify/commit/2ac739221d43b2d9ada4a970e084263d2124561f)), closes [#9976](https://github.com/vuetifyjs/vuetify/issues/9976)
* **validatable:** validate on blur after value has persisted ([33132a2](https://github.com/vuetifyjs/vuetify/commit/33132a2277f50f3c20f56312a555e211dde30f25)), closes [#10174](https://github.com/vuetifyjs/vuetify/issues/10174)
* **VAutocomplete:** avoid setting selectedIndex to 0 after delete ([#10063](https://github.com/vuetifyjs/vuetify/issues/10063)) ([1d5ca2d](https://github.com/vuetifyjs/vuetify/commit/1d5ca2dceb71fe52d205cdb1e4e4d11e0e54e5cc)), closes [#10036](https://github.com/vuetifyjs/vuetify/issues/10036)
* **VAutocomplete:** property delete chip in single mode ([#9657](https://github.com/vuetifyjs/vuetify/issues/9657)) ([c5cddba](https://github.com/vuetifyjs/vuetify/commit/c5cddba13f7e112a4bb652f704a1aa86d962e654)), closes [#9654](https://github.com/vuetifyjs/vuetify/issues/9654)
* **VAutocomplete:** removeEventListener when destroyed ([#11811](https://github.com/vuetifyjs/vuetify/issues/11811)) ([e7c6ed5](https://github.com/vuetifyjs/vuetify/commit/e7c6ed504af01e8f87a6835cd4d955bcc7e3562e))
* **VAvatar:** hide overflow ([#10001](https://github.com/vuetifyjs/vuetify/issues/10001)) ([ecb0a73](https://github.com/vuetifyjs/vuetify/commit/ecb0a73877fb7e43734c13a2c21071ab27111c6d)), closes [#10000](https://github.com/vuetifyjs/vuetify/issues/10000)
* **VBadge:** oblong circle when using v-icon ([a5b9cbc](https://github.com/vuetifyjs/vuetify/commit/a5b9cbc17ed44e62ba65d14a364a13cdae8a0c70)), closes [#10054](https://github.com/vuetifyjs/vuetify/issues/10054)
* **VBadge:** re-enable pointer-events ([1583d7c](https://github.com/vuetifyjs/vuetify/commit/1583d7c127397e5b58d9fde979c135795da21993)), closes [#10144](https://github.com/vuetifyjs/vuetify/issues/10144) [#10125](https://github.com/vuetifyjs/vuetify/issues/10125)
* **VBadge:** re-enable pointer-events ([bc662b9](https://github.com/vuetifyjs/vuetify/commit/bc662b9e029c3cbc4250a95f0377a14e45ac080d)), closes [#10125](https://github.com/vuetifyjs/vuetify/issues/10125)
* **VBanner:** gated vuetify application support with sticky ([56d47f0](https://github.com/vuetifyjs/vuetify/commit/56d47f011362b1d6e38fa107973e6c5fbde78ee4))
* **VBanner:** hook up missing color support ([8f1ed83](https://github.com/vuetifyjs/vuetify/commit/8f1ed83424c7240ce1878c522d757eac32d3b149)), closes [#10216](https://github.com/vuetifyjs/vuetify/issues/10216)
* **VBanner:** pass attributes to v-banner element ([ddb2b9f](https://github.com/vuetifyjs/vuetify/commit/ddb2b9f980d497f2fa75fc8676bd15f07b46c89d)), closes [#9837](https://github.com/vuetifyjs/vuetify/issues/9837)
* **VBanner:** remove cached slot ([1d62d23](https://github.com/vuetifyjs/vuetify/commit/1d62d239e293f7a2963290e8839db0bae770928f))
* **VBottomSheet:** remove min-width and update flex ([22cf5a1](https://github.com/vuetifyjs/vuetify/commit/22cf5a195f50dd3085acc48f4f7040ebeadcd0f0)), closes [#10261](https://github.com/vuetifyjs/vuetify/issues/10261)
* **VBtn:** add back tile prop ([137186a](https://github.com/vuetifyjs/vuetify/commit/137186a7534c04743e5a36c6934a209a22854f30))
* **VBtn:** add missing sass variable for text-transform ([9cd96a8](https://github.com/vuetifyjs/vuetify/commit/9cd96a88e81c69e9fe2c8e20f518ab39a0ff21cc)), closes [#8619](https://github.com/vuetifyjs/vuetify/issues/8619)
* **VBtn:** normalize width behavior ([426dd02](https://github.com/vuetifyjs/vuetify/commit/426dd027dee22cfc875b3a099e299bd6799fd27d)), closes [#8699](https://github.com/vuetifyjs/vuetify/issues/8699)
* **VBtn:** remove max width ([e02a6d1](https://github.com/vuetifyjs/vuetify/commit/e02a6d1a5c5cbc91940356ffa3a20e8045da9941)), closes [#9968](https://github.com/vuetifyjs/vuetify/issues/9968)
* **VBtnToggle:** add missing RTL support in button groups ([#11849](https://github.com/vuetifyjs/vuetify/issues/11849)) ([75f2bf3](https://github.com/vuetifyjs/vuetify/commit/75f2bf39c667ae1c7d93451fdd937fed60c163c7)), closes [#11793](https://github.com/vuetifyjs/vuetify/issues/11793)
* **VCalendar:** validation, style, slot, event, and formatting fixes ([#9862](https://github.com/vuetifyjs/vuetify/issues/9862)) ([fc0ced9](https://github.com/vuetifyjs/vuetify/commit/fc0ced90a5763579815dd0fa9ed44d5fc8e0a4bd)), closes [#8429](https://github.com/vuetifyjs/vuetify/issues/8429) [#7992](https://github.com/vuetifyjs/vuetify/issues/7992) [#8870](https://github.com/vuetifyjs/vuetify/issues/8870) [#9208](https://github.com/vuetifyjs/vuetify/issues/9208) [#9154](https://github.com/vuetifyjs/vuetify/issues/9154) [#8971](https://github.com/vuetifyjs/vuetify/issues/8971) [#8525](https://github.com/vuetifyjs/vuetify/issues/8525) [#8849](https://github.com/vuetifyjs/vuetify/issues/8849) [#8342](https://github.com/vuetifyjs/vuetify/issues/8342) [#8668](https://github.com/vuetifyjs/vuetify/issues/8668) [#9114](https://github.com/vuetifyjs/vuetify/issues/9114)
* **VCalendar:** wait for animation frame before updating events ([b9809d2](https://github.com/vuetifyjs/vuetify/commit/b9809d2c3a0557898de45ba001e1b0d0bc15472b)), closes [#10168](https://github.com/vuetifyjs/vuetify/issues/10168)
* **VCard:** loading shouldn't disable the card ([#9892](https://github.com/vuetifyjs/vuetify/issues/9892)) ([bb12b96](https://github.com/vuetifyjs/vuetify/commit/bb12b961d392ac2cf12d84936faef1e62e55e233)), closes [#9889](https://github.com/vuetifyjs/vuetify/issues/9889)
* **VCard:** switched sass var values ([cfb90e2](https://github.com/vuetifyjs/vuetify/commit/cfb90e25f55cc363c4ece546ae537db4e490cb84))
* **VCardActions:** scope v-btn styles to direct children ([b33fa17](https://github.com/vuetifyjs/vuetify/commit/b33fa17421574fdb57d908cd8516103db9149151)), closes [#10118](https://github.com/vuetifyjs/vuetify/issues/10118)
* **VCheckbox:** properly style checkbox icon with fa iconfont ([2af8c6d](https://github.com/vuetifyjs/vuetify/commit/2af8c6d5c53cfecac79dc8d6cd603c4a5d17665f)), closes [#10157](https://github.com/vuetifyjs/vuetify/issues/10157)
* **VChip:** prevent navigation on close icon click ([c486693](https://github.com/vuetifyjs/vuetify/commit/c4866935a8949d1141f56d8f19d99b838cea6c52)), closes [#10166](https://github.com/vuetifyjs/vuetify/issues/10166)
* **VChip:** remove user-selection when used as link ([603496e](https://github.com/vuetifyjs/vuetify/commit/603496ec78327945407293930864b84a4ea495af)), closes [#9737](https://github.com/vuetifyjs/vuetify/issues/9737)
* **VChip:** resolve jumpy animation when toggling active state ([f703c9b](https://github.com/vuetifyjs/vuetify/commit/f703c9bb0f5f40a13c7fc829b937e3f03ccc2402))
* **VChip:** scope close icon styles ([4f151bb](https://github.com/vuetifyjs/vuetify/commit/4f151bbdf4388e76d92920ca19c6271c022e6c3f)), closes [#9451](https://github.com/vuetifyjs/vuetify/issues/9451)
* **VChipGroup:** remove unnecessary color declaration for v-icon ([2cbf929](https://github.com/vuetifyjs/vuetify/commit/2cbf929fca62cd1334cd6d65ad66ad5c3f2fd219)), closes [#9604](https://github.com/vuetifyjs/vuetify/issues/9604)
* **VCombobox:** do not add search to list when selecting items with keyboard ([#9866](https://github.com/vuetifyjs/vuetify/issues/9866)) ([78aa42f](https://github.com/vuetifyjs/vuetify/commit/78aa42f8f01d9175a9ef338b7de6c08b9155b868)), closes [#6697](https://github.com/vuetifyjs/vuetify/issues/6697) [vuetifyjs/vuetify#8841](https://github.com/vuetifyjs/vuetify/issues/8841) [/github.com/vuetifyjs/vuetify/pull/9866/files/ba3f8a40b327e7509272530fe40ffe726f016a02#r359313120](https://github.com/vuetifyjs//github.com/vuetifyjs/vuetify/pull/9866/files/ba3f8a40b327e7509272530fe40ffe726f016a02/issues/r359313120)
* **VDataIterator:** emit two item-selected events in single-select mode ([#9636](https://github.com/vuetifyjs/vuetify/issues/9636)) ([e7151f9](https://github.com/vuetifyjs/vuetify/commit/e7151f9a74a2ae818a796351e32ed2fa31016236)), closes [#8477](https://github.com/vuetifyjs/vuetify/issues/8477)
* **VDatatable:** add display style to <tr> when Mobile ([#9750](https://github.com/vuetifyjs/vuetify/issues/9750)) ([3d69508](https://github.com/vuetifyjs/vuetify/commit/3d69508d34d732742c49b4c8da471b9e5d80c2ca)), closes [#8799](https://github.com/vuetifyjs/vuetify/issues/8799)
* **VDataTable:** allow grouping by nested keys ([c8e9239](https://github.com/vuetifyjs/vuetify/commit/c8e92395dd6e342e94afe5d2fc45d45c5cf2d35c)), closes [#10323](https://github.com/vuetifyjs/vuetify/issues/10323)
* **VDataTable:** fix default table header color ([#10171](https://github.com/vuetifyjs/vuetify/issues/10171)) ([7d5d5be](https://github.com/vuetifyjs/vuetify/commit/7d5d5be89afde96a69e3cf6bf09bae45a4d1d3a9))
* **VDataTable:** respect hide-default-header prop on mobile ([#11732](https://github.com/vuetifyjs/vuetify/issues/11732)) ([bb6bfdf](https://github.com/vuetifyjs/vuetify/commit/bb6bfdf63f3db1687f686f6b4b473f2c9c58bbdd)), closes [#8774](https://github.com/vuetifyjs/vuetify/issues/8774)
* **VDatepicker:** emit change event when using the range prop ([#9761](https://github.com/vuetifyjs/vuetify/issues/9761)) ([941fe31](https://github.com/vuetifyjs/vuetify/commit/941fe31a8768bd0f8d06fc67122afe0389b85e04)), closes [#9656](https://github.com/vuetifyjs/vuetify/issues/9656)
* **VDatePicker:** allow null value for multiple date picker ([#11304](https://github.com/vuetifyjs/vuetify/issues/11304)) ([de7aacd](https://github.com/vuetifyjs/vuetify/commit/de7aacdcb879982d37422e220e4f4ef0d44e8413)), closes [#9529](https://github.com/vuetifyjs/vuetify/issues/9529)
* **VDatePicker:** range not working with month picker ([#9886](https://github.com/vuetifyjs/vuetify/issues/9886)) ([9f5747e](https://github.com/vuetifyjs/vuetify/commit/9f5747e97c4f60d78598d767f5e7cc5d5ce3a2be)), closes [#9885](https://github.com/vuetifyjs/vuetify/issues/9885)
* **VDatePicker:** restore event border radius to 50% ([9e4cfa9](https://github.com/vuetifyjs/vuetify/commit/9e4cfa9719c6bb29e39bd53c216714ada29a9666))
* **VDatePicker:** typo in sass variable name ([5997b95](https://github.com/vuetifyjs/vuetify/commit/5997b9500c065fc17c58ff735abadaa150e72db8))
* **VDatePicker, VDataTable:** incorrect date picker styling when in data table ([#11325](https://github.com/vuetifyjs/vuetify/issues/11325)) ([3fcc67e](https://github.com/vuetifyjs/vuetify/commit/3fcc67e2c6ab0a7de53577a80cf966d50522fa1b)), closes [#7384](https://github.com/vuetifyjs/vuetify/issues/7384)
* **VDateTable:** events alignment on current date ([#10367](https://github.com/vuetifyjs/vuetify/issues/10367)) ([fc2eaa5](https://github.com/vuetifyjs/vuetify/commit/fc2eaa53dd4269c03e2ca5eb8579eba19dd3d299)), closes [#8182](https://github.com/vuetifyjs/vuetify/issues/8182)
* **VDialog:** ignore outside clicks if this isn't the topmost dialog ([b3bf7ff](https://github.com/vuetifyjs/vuetify/commit/b3bf7ffd659fa4722df59dfe0d8d86bc78443913)), closes [#9907](https://github.com/vuetifyjs/vuetify/issues/9907)
* **VDialog:** prevent scroll on mobile devices ([#10149](https://github.com/vuetifyjs/vuetify/issues/10149)) ([183d79b](https://github.com/vuetifyjs/vuetify/commit/183d79bcbd717b19b36d6f6c053dbf11ef646886)), closes [#10086](https://github.com/vuetifyjs/vuetify/issues/10086)
* **VDialog:** remove unnecessary event.stopPropagation ([9ca0519](https://github.com/vuetifyjs/vuetify/commit/9ca05198fde724d149f7de315c53c0c40d9ad940)), closes [#10167](https://github.com/vuetifyjs/vuetify/issues/10167)
* **VEditDialog:** return returnValue on save ([#11740](https://github.com/vuetifyjs/vuetify/issues/11740)) ([2620930](https://github.com/vuetifyjs/vuetify/commit/262093062540afe3491ec5c207ce06f907f2f68f)), closes [#11736](https://github.com/vuetifyjs/vuetify/issues/11736)
* **VExpandTransition:** include collapsed margins in calculated  height ([046d4e0](https://github.com/vuetifyjs/vuetify/commit/046d4e01f3dbff7bc044b108a41bb0816589fe62))
* **VExpansionPanel:** remove rounded corners with tile and accordion ([30b8b9e](https://github.com/vuetifyjs/vuetify/commit/30b8b9e74908ed2c9ed2591d74e12ec09c22e797)), closes [#9643](https://github.com/vuetifyjs/vuetify/issues/9643)
* **VFileInput:** filter out values that are not instance of File ([ebdb4f6](https://github.com/vuetifyjs/vuetify/commit/ebdb4f64cdc3a1b118e61992f235c60b3586f168)), closes [#10281](https://github.com/vuetifyjs/vuetify/issues/10281)
* **VFileInput:** remove input from normal document flow ([7fa2e79](https://github.com/vuetifyjs/vuetify/commit/7fa2e7913939034599613ff9350311162047a0b2)), closes [#8931](https://github.com/vuetifyjs/vuetify/issues/8931)
* **VFileInput:** remove typeof filter in arrayValue, improve prop validator ([140d82c](https://github.com/vuetifyjs/vuetify/commit/140d82c4832d4f5d736b5c324214c65edfffcf89)), closes [#10306](https://github.com/vuetifyjs/vuetify/issues/10306)
* **VFileInput:** set value to undefined by default and on clear ([19bdb4c](https://github.com/vuetifyjs/vuetify/commit/19bdb4cdab427e4564f68901b73256f752b2ad57)), closes [#10287](https://github.com/vuetifyjs/vuetify/issues/10287)
* **VFooter:** add missing tag prop ([#11749](https://github.com/vuetifyjs/vuetify/issues/11749)) ([6160e46](https://github.com/vuetifyjs/vuetify/commit/6160e46f8c8a3eee0279f8b4ba19de845b866561)), closes [#11580](https://github.com/vuetifyjs/vuetify/issues/11580)
* **VGrid:** offset in RTL mode ([#11359](https://github.com/vuetifyjs/vuetify/issues/11359)) ([db52c0a](https://github.com/vuetifyjs/vuetify/commit/db52c0ae2d1aef7e087994830da07f4f84fa99db)), closes [#6317](https://github.com/vuetifyjs/vuetify/issues/6317)
* **VIcon:** apply default tabindex if click listener present ([86133ea](https://github.com/vuetifyjs/vuetify/commit/86133eabf01f3748056b6eae0a54d073e606f013)), closes [#10265](https://github.com/vuetifyjs/vuetify/issues/10265)
* **VIcon:** svg icon style when using the prominent prop ([#9831](https://github.com/vuetifyjs/vuetify/issues/9831)) ([abc8715](https://github.com/vuetifyjs/vuetify/commit/abc871581df3e460fd1b318781af942b133e4016)), closes [#9670](https://github.com/vuetifyjs/vuetify/issues/9670)
* **VIcon:** visibility transition delay ([#9962](https://github.com/vuetifyjs/vuetify/issues/9962)) ([55c67f4](https://github.com/vuetifyjs/vuetify/commit/55c67f47a6e564855be3d61b8240beab0689f1ad)), closes [#9541](https://github.com/vuetifyjs/vuetify/issues/9541)
* **VImg:** don't error when src is null ([e784284](https://github.com/vuetifyjs/vuetify/commit/e784284683474f0d72ed331208c5d22bc39fb7ad)), closes [#11831](https://github.com/vuetifyjs/vuetify/issues/11831)
* **VImg:** image entry animation ([1550862](https://github.com/vuetifyjs/vuetify/commit/155086241f575f02fbcf3c3c0b9417cd4cf12074))
* **VImg:** render gradient when src isn't provided ([c0fa6d5](https://github.com/vuetifyjs/vuetify/commit/c0fa6d5a90c12ca6a4f7141902effde3decb4e31)), closes [#11729](https://github.com/vuetifyjs/vuetify/issues/11729)
* **VImg:** resolve NaN value when computing normalizedSrc ([8d110bf](https://github.com/vuetifyjs/vuetify/commit/8d110bf2738cbde688d1244bec87ec768f920096))
* **VImg:** stop polling for size when loading fails ([be907b5](https://github.com/vuetifyjs/vuetify/commit/be907b5994df05ac7ce993ae23ad9a20fc874216)), closes [#11026](https://github.com/vuetifyjs/vuetify/issues/11026)
* **VInput:** apply correct placeholder color ([f6d0d61](https://github.com/vuetifyjs/vuetify/commit/f6d0d617e28aa28b696903647f2174469091a71c)), closes [#10221](https://github.com/vuetifyjs/vuetify/issues/10221)
* **VInput:** browser autocomplete default ([#9552](https://github.com/vuetifyjs/vuetify/issues/9552)) ([c060444](https://github.com/vuetifyjs/vuetify/commit/c0604449cb846b5651d03ac408e8c491ecdecf01)), closes [#9516](https://github.com/vuetifyjs/vuetify/issues/9516)
* **VItemGroup:** apply maximum width for use in flex containers ([6362eec](https://github.com/vuetifyjs/vuetify/commit/6362eec3495e3e675ee379906de2255099cf2067)), closes [#8752](https://github.com/vuetifyjs/vuetify/issues/8752)
* **VItemGroup:** update toggled item when the items array changes ([85f963e](https://github.com/vuetifyjs/vuetify/commit/85f963eea6f872a67761534737158519f0446df2)), closes [#9854](https://github.com/vuetifyjs/vuetify/issues/9854)
* **VItemGroup:** update value when using mandatory and multiple ([f4bc5bd](https://github.com/vuetifyjs/vuetify/commit/f4bc5bddb796a6b6d42fe23e02369085e27b1a2c)), closes [#10077](https://github.com/vuetifyjs/vuetify/issues/10077)
* **VListGroup:** added styles to prevent content overflow ([#10042](https://github.com/vuetifyjs/vuetify/issues/10042)) ([046fa5a](https://github.com/vuetifyjs/vuetify/commit/046fa5aff7a7fdb62731905e60192861b4bce451)), closes [#10008](https://github.com/vuetifyjs/vuetify/issues/10008)
* **VListGroup:** allow user to hide prepend-icon in subgroup ([172724e](https://github.com/vuetifyjs/vuetify/commit/172724e99fde064fd589516d31857656f120f89e)), closes [#8980](https://github.com/vuetifyjs/vuetify/issues/8980)
* **VListGroup:** remove empty div child selector ([60844a3](https://github.com/vuetifyjs/vuetify/commit/60844a32f51b3f4bd73811fd2b6997293744d099)), closes [#8823](https://github.com/vuetifyjs/vuetify/issues/8823)
* **VListItem:** only apply user-select style when using a link ([fbc8ed8](https://github.com/vuetifyjs/vuetify/commit/fbc8ed820d4072dd135e8934bf5d020def0160c0)), closes [#8648](https://github.com/vuetifyjs/vuetify/issues/8648)
* **VListItemAvatar:** apply correct margin according to spec ([97fc2de](https://github.com/vuetifyjs/vuetify/commit/97fc2de3577be3bae51aac7eb6c851b64d7806b0)), closes [#9789](https://github.com/vuetifyjs/vuetify/issues/9789)
* **VMain:** add existing v-content classes for backwards compatibility ([#11659](https://github.com/vuetifyjs/vuetify/issues/11659)) ([31912d7](https://github.com/vuetifyjs/vuetify/commit/31912d7ca86713bef54f7f10cdf038b550f4d18c))
* **VMenu:** remove unnecessary event.stopPropagation ([5af2cd1](https://github.com/vuetifyjs/vuetify/commit/5af2cd193927f20cb0df5ae492df01e9e1ed5d90)), closes [#6654](https://github.com/vuetifyjs/vuetify/issues/6654)
* **VNavigationDrawer:** apply a better default mini width ([d80e01f](https://github.com/vuetifyjs/vuetify/commit/d80e01f0c9ec9c54b066f155e642f0ca06021a17)), closes [#2830](https://github.com/vuetifyjs/vuetify/issues/2830)
* **VNavigationDrawer:** hide navigation drawer labels visually ([#10250](https://github.com/vuetifyjs/vuetify/issues/10250)) ([a28d03e](https://github.com/vuetifyjs/vuetify/commit/a28d03ea18bad5a0ce8300a894cb37eb5b1f50cf)), closes [#9741](https://github.com/vuetifyjs/vuetify/issues/9741)
* **VNavigationDrawer:** set proper border width ([9bc631a](https://github.com/vuetifyjs/vuetify/commit/9bc631a08d7d28a0d02d1daeb982972c9278cf52))
* **VOverlay:** enable touch interaction ([3365cac](https://github.com/vuetifyjs/vuetify/commit/3365cac74fea50b5b0b4c5e8dc6ce3023ff96c68))
* **VPicker:** content position in landscape / rtl mode ([#10371](https://github.com/vuetifyjs/vuetify/issues/10371)) ([92e77a2](https://github.com/vuetifyjs/vuetify/commit/92e77a2ad7dfb931568ecfab1f1432cf0f8bf542)), closes [#9258](https://github.com/vuetifyjs/vuetify/issues/9258)
* **VProgressCircular:** don't apply rotate animation to svg icon ([#11868](https://github.com/vuetifyjs/vuetify/issues/11868)) ([e2ed334](https://github.com/vuetifyjs/vuetify/commit/e2ed334a25ddd687aef72a5505a9964b42afb6ff)), closes [#11867](https://github.com/vuetifyjs/vuetify/issues/11867)
* **VProgressLinear:** resolve invalid sass transition variable reference ([fea155e](https://github.com/vuetifyjs/vuetify/commit/fea155e967359dcaa5e4af8517f929d7db379506)), closes [#10343](https://github.com/vuetifyjs/vuetify/issues/10343)
* **VRadioGroup:** overwrite inherited padding and vertical align label ([f81b639](https://github.com/vuetifyjs/vuetify/commit/f81b639dd8fca6a088dc2bbf578a2cbf0e9545f5)), closes [#10334](https://github.com/vuetifyjs/vuetify/issues/10334)
* **VRadioGroup:** properly scope selection control styles ([be965df](https://github.com/vuetifyjs/vuetify/commit/be965df0c8cd903f6c9d62e14ee25e7ade4518b4)), closes [#10131](https://github.com/vuetifyjs/vuetify/issues/10131)
* **VRadioGroup:** use correct element tags for a11y ([75f6197](https://github.com/vuetifyjs/vuetify/commit/75f6197629d6c8baf7ab86e2a8b0d12ec0d444d2)), closes [#9851](https://github.com/vuetifyjs/vuetify/issues/9851)
* **VRangeSlider:** resolve infinite loop when using NaN values ([35a654c](https://github.com/vuetifyjs/vuetify/commit/35a654c8d9b85d2c654e4199a2130aaf5b07a49b)), closes [#9818](https://github.com/vuetifyjs/vuetify/issues/9818)
* **VRating:** check if half-increments prop is used alongside rtl ([ddf3aec](https://github.com/vuetifyjs/vuetify/commit/ddf3aec89be545e3a89844ec8011530eb36a95bb)), closes [#10093](https://github.com/vuetifyjs/vuetify/issues/10093)
* **VResponsive:** apply rtl margin styles ([#10269](https://github.com/vuetifyjs/vuetify/issues/10269)) ([196bcdb](https://github.com/vuetifyjs/vuetify/commit/196bcdb01a2593ae6bb04642837f485564744807)), closes [#10268](https://github.com/vuetifyjs/vuetify/issues/10268)
* **VResponsive:** restructure elements to work with Firefox ([#10027](https://github.com/vuetifyjs/vuetify/issues/10027)) ([e92d6b7](https://github.com/vuetifyjs/vuetify/commit/e92d6b79115c28b6cae71b7bc70bbb295c12ef89)), closes [#9659](https://github.com/vuetifyjs/vuetify/issues/9659)
* **VResponsive:** tweak styles to work with Firefox ([#10095](https://github.com/vuetifyjs/vuetify/issues/10095)) ([c6d3cca](https://github.com/vuetifyjs/vuetify/commit/c6d3cca44ccfd8bcdc640401871d2027be7866a4)), closes [#9659](https://github.com/vuetifyjs/vuetify/issues/9659)
* **VSelect:** attach menu scroll handler when loading items async ([d9bb128](https://github.com/vuetifyjs/vuetify/commit/d9bb128a510d3887ca240111f15395f55d53367d)), closes [#11675](https://github.com/vuetifyjs/vuetify/issues/11675)
* **VSelect:** bind scroll listener to menu content ([972d188](https://github.com/vuetifyjs/vuetify/commit/972d1883ea4ada0735ef01d3b13331540b2eec26)), closes [#10485](https://github.com/vuetifyjs/vuetify/issues/10485)
* **VSelect:** change onMouseUp to handle menu toggle on mouse events ([#9476](https://github.com/vuetifyjs/vuetify/issues/9476)) ([49c47ec](https://github.com/vuetifyjs/vuetify/commit/49c47ecea3c87f0b351c1318d282d655fa7fd1e1)), closes [#6564](https://github.com/vuetifyjs/vuetify/issues/6564)
* **VSelect:** disable arrows on readonly select ([#11223](https://github.com/vuetifyjs/vuetify/issues/11223)) ([fd7a8b3](https://github.com/vuetifyjs/vuetify/commit/fd7a8b3f986f818edee99816ece45327f48fee8b)), closes [#11164](https://github.com/vuetifyjs/vuetify/issues/11164)
* **VSelect:** disable menu when readonly ([ba5cc58](https://github.com/vuetifyjs/vuetify/commit/ba5cc5892e3ab5346b447ff5f08f5a8cc1173e52)), closes [#9960](https://github.com/vuetifyjs/vuetify/issues/9960)
* **VSelect:** emit click event ([#10853](https://github.com/vuetifyjs/vuetify/issues/10853)) ([be86aac](https://github.com/vuetifyjs/vuetify/commit/be86aac7a51c8502804238a21c95ef556d5d2f61)), closes [#10839](https://github.com/vuetifyjs/vuetify/issues/10839)
* **VSelect:** emit keydown event ([6bf9eff](https://github.com/vuetifyjs/vuetify/commit/6bf9effe6b0709f4aedb2add9828fa1ba5875cd2)), closes [#10240](https://github.com/vuetifyjs/vuetify/issues/10240)
* **VSelect:** ensure VMenu's content has scroll listener added ([#11725](https://github.com/vuetifyjs/vuetify/issues/11725)) ([a406dd4](https://github.com/vuetifyjs/vuetify/commit/a406dd4476eaf864d15fdc478093edf7b3964f90)), closes [#11737](https://github.com/vuetifyjs/vuetify/issues/11737)
* **VSelect:** expose clickable icons to screen readers ([#10489](https://github.com/vuetifyjs/vuetify/issues/10489)) ([cee1404](https://github.com/vuetifyjs/vuetify/commit/cee14044d0a947f1952fd353d00770060995d494))
* **VSelect:** get menu content when needed ([bd2278f](https://github.com/vuetifyjs/vuetify/commit/bd2278f745ed27938b763f570d7ef5e8cb12ff72)), closes [#8823](https://github.com/vuetifyjs/vuetify/issues/8823)
* **VSelect:** incorrect dense height ([#10694](https://github.com/vuetifyjs/vuetify/issues/10694)) ([07fa3da](https://github.com/vuetifyjs/vuetify/commit/07fa3da9615b19ddf78b679d283022fbd23c79dd)), closes [#10635](https://github.com/vuetifyjs/vuetify/issues/10635)
* **VSelect:** make selection color white when using solo-inverted ([c8f2564](https://github.com/vuetifyjs/vuetify/commit/c8f2564abeba7313bee17a37e0be0bfbaf5a7582)), closes [#10617](https://github.com/vuetifyjs/vuetify/issues/10617)
* **VSelect:** normalize dense height ([#10892](https://github.com/vuetifyjs/vuetify/issues/10892)) ([1890bec](https://github.com/vuetifyjs/vuetify/commit/1890bec0389a357f3e7b2ab6d4332f77db483f22)), closes [#10877](https://github.com/vuetifyjs/vuetify/issues/10877)
* **VSelect:** propagate name attribute to hidden input ([#10327](https://github.com/vuetifyjs/vuetify/issues/10327)) ([f289b05](https://github.com/vuetifyjs/vuetify/commit/f289b05af9f7316c46c2e961a484528e7f15aa00)), closes [#10152](https://github.com/vuetifyjs/vuetify/issues/10152)
* **VSelect:** properly handle up and down arrows when focused ([f72db83](https://github.com/vuetifyjs/vuetify/commit/f72db83ca8545f00243e7919c9a108381af3f85b)), closes [#8361](https://github.com/vuetifyjs/vuetify/issues/8361)
* **VSelect:** remove duplicate item ids ([#9961](https://github.com/vuetifyjs/vuetify/issues/9961)) ([3e02eb2](https://github.com/vuetifyjs/vuetify/commit/3e02eb24f75acc815a4b1e51fa751a8eb191d0d4)), closes [#9819](https://github.com/vuetifyjs/vuetify/issues/9819)
* **VSelect:** scroll to newly selected item in long lists ([#10492](https://github.com/vuetifyjs/vuetify/issues/10492)) ([4a3d39b](https://github.com/vuetifyjs/vuetify/commit/4a3d39b4cf1305be9fc97e45a1020b105322af14)), closes [#10406](https://github.com/vuetifyjs/vuetify/issues/10406)
* **VSelect:** update inner input element value ([#9598](https://github.com/vuetifyjs/vuetify/issues/9598)) ([f4cda2b](https://github.com/vuetifyjs/vuetify/commit/f4cda2b87dd7a42a00cdbc01f4b7c9d79b5b93d1)), closes [#6310](https://github.com/vuetifyjs/vuetify/issues/6310)
* **VSelect/VMenu:** remove duplicate IDs, add aria-activedescendant ([#10226](https://github.com/vuetifyjs/vuetify/issues/10226)) ([b2e5691](https://github.com/vuetifyjs/vuetify/commit/b2e5691a747e5716aee2771c289b56757f8251de)), closes [#9680](https://github.com/vuetifyjs/vuetify/issues/9680) [#7385](https://github.com/vuetifyjs/vuetify/issues/7385)
* **VSimpleCheckbox:** pass listeners to component ([#11358](https://github.com/vuetifyjs/vuetify/issues/11358)) ([d937f5b](https://github.com/vuetifyjs/vuetify/commit/d937f5b36cdf9049ef51ea9d420494c2b10dd3f7)), closes [#11345](https://github.com/vuetifyjs/vuetify/issues/11345)
* **VSimpleTable:** bottom border of tbody th ([#10594](https://github.com/vuetifyjs/vuetify/issues/10594)) ([c014bdc](https://github.com/vuetifyjs/vuetify/commit/c014bdc4a765b4b6b1f5f88fbb5bb46cba2416ba))
* **VSimpleTable:** set max width to 100% ([#10707](https://github.com/vuetifyjs/vuetify/issues/10707)) ([905fc45](https://github.com/vuetifyjs/vuetify/commit/905fc45387075fca424fd0e2e9dd3830b0fcdaf1)), closes [#8993](https://github.com/vuetifyjs/vuetify/issues/8993)
* **VSkeletonLoader:** don't call the default slot if not used ([e0f3f08](https://github.com/vuetifyjs/vuetify/commit/e0f3f08fc28bafae52cb064702a9597c18e0207c)), closes [#10201](https://github.com/vuetifyjs/vuetify/issues/10201)
* **VSkeletonLoader:** properly animate incoming content after loading ([9ac1158](https://github.com/vuetifyjs/vuetify/commit/9ac1158f857fd1f531f1177ba623602973f81b55)), closes [#9459](https://github.com/vuetifyjs/vuetify/issues/9459)
* **VSkeletonLoader:** remove unnecessary border-radius on card style ([#10806](https://github.com/vuetifyjs/vuetify/issues/10806)) ([ac754ca](https://github.com/vuetifyjs/vuetify/commit/ac754ca057c490585451dc100c1f594169903ee9))
* **VSkeletonLoader:** use rgba transparency for animation on Safari ([#11714](https://github.com/vuetifyjs/vuetify/issues/11714)) ([f55db8d](https://github.com/vuetifyjs/vuetify/commit/f55db8d525aefd893c397fe8098672ebde9c2aa1)), closes [#10740](https://github.com/vuetifyjs/vuetify/issues/10740)
* **vslidegroup:** add display none to immediate child ([#10567](https://github.com/vuetifyjs/vuetify/issues/10567)) ([bb69192](https://github.com/vuetifyjs/vuetify/commit/bb69192b72d165c814cedf3f284a8d9639e9530b)), closes [#10310](https://github.com/vuetifyjs/vuetify/issues/10310)
* **VSlideGroup:** prevent thrashing DOM when available space < width ([0f3f4b5](https://github.com/vuetifyjs/vuetify/commit/0f3f4b5afc3fa21e6a42cd9b34b84e0b79077331)), closes [#11122](https://github.com/vuetifyjs/vuetify/issues/11122)
* **VSlider:** avoid unnecessary input event ([2f9b28f](https://github.com/vuetifyjs/vuetify/commit/2f9b28fb50bc2ffac6d633f1766b2ca417554cd0)), closes [#10018](https://github.com/vuetifyjs/vuetify/issues/10018)
* **VSlider:** prevent default when pressing slider dot ([7d2e162](https://github.com/vuetifyjs/vuetify/commit/7d2e1625b59033a7c267152acfed361347f9a5b6)), closes [#7241](https://github.com/vuetifyjs/vuetify/issues/7241)
* **VSlider:** readonly should apply only to slider control ([#10768](https://github.com/vuetifyjs/vuetify/issues/10768)) ([e089a7c](https://github.com/vuetifyjs/vuetify/commit/e089a7c9f6f0e325c6658cc933b28fb211b5a096)), closes [#10684](https://github.com/vuetifyjs/vuetify/issues/10684)
* **VSlider:** thumb shifting position when toggling disabled state ([#11306](https://github.com/vuetifyjs/vuetify/issues/11306)) ([1fa2f92](https://github.com/vuetifyjs/vuetify/commit/1fa2f9200dd9c1b16459d8a9e52a0b7760d44753)), closes [#11303](https://github.com/vuetifyjs/vuetify/issues/11303)
* **VSlider:** wrong tick labels positions in RTL mode ([#11317](https://github.com/vuetifyjs/vuetify/issues/11317)) ([225e82a](https://github.com/vuetifyjs/vuetify/commit/225e82ab2c92ee1133ddaaea7931cd1505ed6c6a)), closes [#11028](https://github.com/vuetifyjs/vuetify/issues/11028)
* **VSnackbar:** a11y and appearance improvements ([#10263](https://github.com/vuetifyjs/vuetify/issues/10263)) ([80b1568](https://github.com/vuetifyjs/vuetify/commit/80b1568ad5f2370166e33070ab6c9007629766ec)), closes [#10047](https://github.com/vuetifyjs/vuetify/issues/10047) [#10047](https://github.com/vuetifyjs/vuetify/issues/10047)
* **VSparkline:** avoid computing path total length if only 1 value provided ([f57b7a7](https://github.com/vuetifyjs/vuetify/commit/f57b7a7c6247e1b496ae87a1e4b4c014a7dcdc1d)), closes [#9426](https://github.com/vuetifyjs/vuetify/issues/9426)
* **VSparkline:** handle a divide by zero bug when all values are zero ([#11315](https://github.com/vuetifyjs/vuetify/issues/11315)) ([2dacec2](https://github.com/vuetifyjs/vuetify/commit/2dacec2955a9c00ecb9c9e5f7d136683c7bb2991)), closes [#11311](https://github.com/vuetifyjs/vuetify/issues/11311)
* **VSparkline:** remove duplicate id ([#11262](https://github.com/vuetifyjs/vuetify/issues/11262)) ([4a785ff](https://github.com/vuetifyjs/vuetify/commit/4a785ff964307759d8bf2625fb89b412c1a21d66))
* **VSparkline:** stop and fill color propagation ([#11102](https://github.com/vuetifyjs/vuetify/issues/11102)) ([4c50717](https://github.com/vuetifyjs/vuetify/commit/4c50717c6aeb4ad98d9f8e1d8d8276c8290cfd9b)), closes [#6387](https://github.com/vuetifyjs/vuetify/issues/6387)
* **VSpeedDial:** apply a baseline z-index ([1c42ed1](https://github.com/vuetifyjs/vuetify/commit/1c42ed113790cb1fff3d859dae79c582b678870d)), closes [#10194](https://github.com/vuetifyjs/vuetify/issues/10194)
* **VStepper:** adjust svg size to match icon font-size ([bc55564](https://github.com/vuetifyjs/vuetify/commit/bc55564b32019bfcc212cf53631447f86f6f86e1)), closes [#8665](https://github.com/vuetifyjs/vuetify/issues/8665)
* **VStepper:** allow numeric 0 value ([996a37f](https://github.com/vuetifyjs/vuetify/commit/996a37fc25580f4395145530ef39989fc27b1206)), closes [#10096](https://github.com/vuetifyjs/vuetify/issues/10096)
* **VStepper:** fix styles in RTL ([#10145](https://github.com/vuetifyjs/vuetify/issues/10145)) ([879adcc](https://github.com/vuetifyjs/vuetify/commit/879adcc1cd727074d686094766509edab05e8784)), closes [#10098](https://github.com/vuetifyjs/vuetify/issues/10098)
* **VTabs:** correct width of v-tab's bar and content with vertical ([df502ff](https://github.com/vuetifyjs/vuetify/commit/df502ffcc2c392bd2ab358f33c3227ecbf1fe94a)), closes [#10031](https://github.com/vuetifyjs/vuetify/issues/10031)
* **VTabs:** indent tabs on the correct with the right prop ([68a49c3](https://github.com/vuetifyjs/vuetify/commit/68a49c33d1bfa75af32d14e08296047b9b011da9)), closes [#8294](https://github.com/vuetifyjs/vuetify/issues/8294)
* **VTabs:** make buttons inside tab inherit current color of the tab ([#11183](https://github.com/vuetifyjs/vuetify/issues/11183)) ([ea68150](https://github.com/vuetifyjs/vuetify/commit/ea6815092ee93fb0b1ec8d786190e7cd140d7ff5)), closes [#11171](https://github.com/vuetifyjs/vuetify/issues/11171)
* **VTabs:** update to better match md2 spec ([a49f2c8](https://github.com/vuetifyjs/vuetify/commit/a49f2c844ba723dd9b3bd4eb2b8f08adf223f35e))
* **VTextarea:** adjust height for smaller rows and dense ([792f183](https://github.com/vuetifyjs/vuetify/commit/792f183795ac8c914d1d6fcf244d713f89d8f035)), closes [#9346](https://github.com/vuetifyjs/vuetify/issues/9346)
* **VTextarea:** make height of 1 row equal to v-text-field ([#9992](https://github.com/vuetifyjs/vuetify/issues/9992)) ([4a98297](https://github.com/vuetifyjs/vuetify/commit/4a982979e7d76aed231f67161e494d4363db653a))
* **VTextfield:** legend position with reverse and outlined prop ([#10278](https://github.com/vuetifyjs/vuetify/issues/10278)) ([55cbdbb](https://github.com/vuetifyjs/vuetify/commit/55cbdbb70f39ef431ba75c4bedf361ce9d099a29)), closes [#10277](https://github.com/vuetifyjs/vuetify/issues/10277)
* **VTextField:** add back accidentally removed transition property ([fa07fc5](https://github.com/vuetifyjs/vuetify/commit/fa07fc50f053640ecf648cb643a77fc32ea16d21)), closes [#10108](https://github.com/vuetifyjs/vuetify/issues/10108)
* **VTextField:** adjust label top position with solo prop ([7f95808](https://github.com/vuetifyjs/vuetify/commit/7f9580867904efa026c9077d2c0b546d488ea4b6))
* **VTextField:** adjust margin and css target for dense field prepend/append icons ([6603b05](https://github.com/vuetifyjs/vuetify/commit/6603b05cef207736c4d19c45c2a6b3fe6ed40bb2)), closes [#11011](https://github.com/vuetifyjs/vuetify/issues/11011)
* **VTextField:** apply different color logic for solo-inverted fields ([afa2647](https://github.com/vuetifyjs/vuetify/commit/afa264700fabbfc90aca0f04f9e1c0873b6af35c)), closes [#8827](https://github.com/vuetifyjs/vuetify/issues/8827)
* **VTextField:** autofocus when observed ([d846222](https://github.com/vuetifyjs/vuetify/commit/d84622280ec05cf03342c8bab405909a68fc2ece)), closes [#5487](https://github.com/vuetifyjs/vuetify/issues/5487) [#8845](https://github.com/vuetifyjs/vuetify/issues/8845)
* **VTextField:** calculate label width depending on the textfield width ([#10092](https://github.com/vuetifyjs/vuetify/issues/10092)) ([918b0cf](https://github.com/vuetifyjs/vuetify/commit/918b0cf513fdfd88cfc0266ca346758c6cca9596)), closes [#10030](https://github.com/vuetifyjs/vuetify/issues/10030)
* **VTextField:** fix style cascading when combinging multiple style props ([fc7b05a](https://github.com/vuetifyjs/vuetify/commit/fc7b05aaa74f4bb92366b9c2a36367c3ee720fd8)), closes [#8586](https://github.com/vuetifyjs/vuetify/issues/8586)
* **VTextField:** incorrectly displayed counter with hide-details=auto ([#10705](https://github.com/vuetifyjs/vuetify/issues/10705)) ([0e57814](https://github.com/vuetifyjs/vuetify/commit/0e57814c41d716b246b5422583aacebfb9aa5cd5)), closes [#10701](https://github.com/vuetifyjs/vuetify/issues/10701)
* **VTextField:** match spec height when using the dense prop ([e8be89a](https://github.com/vuetifyjs/vuetify/commit/e8be89a11049c5f37a768555f5cd8724dcf1dbfe)), closes [#10119](https://github.com/vuetifyjs/vuetify/issues/10119)
* **VTextField:** properly focus field when calling public "focus" method ([e783162](https://github.com/vuetifyjs/vuetify/commit/e78316267391e103a03d3c83f5290b6024858b79))
* **VTextField:** remove gap when outlined label changes to empty ([#11316](https://github.com/vuetifyjs/vuetify/issues/11316)) ([6b3562b](https://github.com/vuetifyjs/vuetify/commit/6b3562b9f5610cee3c1525257777f60fc1180604)), closes [#11269](https://github.com/vuetifyjs/vuetify/issues/11269)
* **VTextField:** remove hover effect when disabled ([#11363](https://github.com/vuetifyjs/vuetify/issues/11363)) ([bbc6b8c](https://github.com/vuetifyjs/vuetify/commit/bbc6b8cd5a8f459a4d40721f6545bec0c40529d7)), closes [#11338](https://github.com/vuetifyjs/vuetify/issues/11338) [#11338](https://github.com/vuetifyjs/vuetify/issues/11338)
* **VTextField:** remove inherit border-color and scope styles ([47c986a](https://github.com/vuetifyjs/vuetify/commit/47c986a157b86451ddda4993aa5ad944ec8f03bb)), closes [#10388](https://github.com/vuetifyjs/vuetify/issues/10388)
* **VTextField:** remove unnecessary margin on filled inputs ([130fa8e](https://github.com/vuetifyjs/vuetify/commit/130fa8e1cb08efcd6a8e7faa0d75b87301296b03))
* **VTextField:** resolve style issues in inverted solo fields ([cdd9eb1](https://github.com/vuetifyjs/vuetify/commit/cdd9eb14aedcee3f326beeeb9752f475d008b404)), closes [#9534](https://github.com/vuetifyjs/vuetify/issues/9534)
* **VTextField:** Skip value property update if IME composing string ([#11134](https://github.com/vuetifyjs/vuetify/issues/11134)) ([c02be82](https://github.com/vuetifyjs/vuetify/commit/c02be8273cca4a373eb3792e55850ff1d8409fef)), closes [#5748](https://github.com/vuetifyjs/vuetify/issues/5748)
* **VTextField:** specify border-collapse for outlined fieldset ([baed6d7](https://github.com/vuetifyjs/vuetify/commit/baed6d7a77b97f03bc486b2609ef296e93fe8db2))
* **VTextField:** update styles to better match spec ([44c86f4](https://github.com/vuetifyjs/vuetify/commit/44c86f4347abb2707a11814c16b6dd843ad7de60)), closes [#10133](https://github.com/vuetifyjs/vuetify/issues/10133) [#5097](https://github.com/vuetifyjs/vuetify/issues/5097)
* **VTextField:** update value on compositionend ([#11194](https://github.com/vuetifyjs/vuetify/issues/11194)) ([f51bef6](https://github.com/vuetifyjs/vuetify/commit/f51bef69294c2bbc13cacb7e9b3fcf5d446c34be)), closes [#11190](https://github.com/vuetifyjs/vuetify/issues/11190) [#5748](https://github.com/vuetifyjs/vuetify/issues/5748)
* **VTextField:** use intersect to recalculate elements width ([#9341](https://github.com/vuetifyjs/vuetify/issues/9341)) ([c34f35c](https://github.com/vuetifyjs/vuetify/commit/c34f35cfdffe05a75bcd1f7a18d6b3dea8149545)), closes [#9299](https://github.com/vuetifyjs/vuetify/issues/9299)
* **VTextField:** use text node for messages instead of escaped innerHTML ([81cb6a8](https://github.com/vuetifyjs/vuetify/commit/81cb6a81cd33a2707a6697f63377cbf2a1923d63)), closes [#9730](https://github.com/vuetifyjs/vuetify/issues/9730)
* **VTextField/VSelect:** don't focus clear icon if dirty ([#10461](https://github.com/vuetifyjs/vuetify/issues/10461)) ([cc7386b](https://github.com/vuetifyjs/vuetify/commit/cc7386b9010d07fba1e75bc74ce586e3a198b9ad))
* **VTextField/VTextarea:** change styles to match specification ([8242e05](https://github.com/vuetifyjs/vuetify/commit/8242e056a9f2f64f6f0102ce031dd6f0293ebcd0)), closes [#4639](https://github.com/vuetifyjs/vuetify/issues/4639)
* **VTimePicker:** AM/PM farsi translation and margins in RTL mode ([#10399](https://github.com/vuetifyjs/vuetify/issues/10399)) ([a6761a9](https://github.com/vuetifyjs/vuetify/commit/a6761a9fa092210457171eb861410a929cd415ef))
* **VTimePicker:** increase clock click accuracy ([#10400](https://github.com/vuetifyjs/vuetify/issues/10400)) ([50ed3ef](https://github.com/vuetifyjs/vuetify/commit/50ed3ef982e3a37de772650958d43feb7d993814)), closes [#7299](https://github.com/vuetifyjs/vuetify/issues/7299)
* **VTimePicker:** missing end circle in clock hand ([#10415](https://github.com/vuetifyjs/vuetify/issues/10415)) ([755c5b8](https://github.com/vuetifyjs/vuetify/commit/755c5b85c20cd02af789c7f15d177383183def2d))
* **VTimePicker:** missing update:period event when ampm clicked in title ([3a510e8](https://github.com/vuetifyjs/vuetify/commit/3a510e8af57d76da660c6b4a407f7940fefae5cb)), closes [#7027](https://github.com/vuetifyjs/vuetify/issues/7027)
* **VToolbar:** better scope v-tabs-bar background-color override ([6619c9c](https://github.com/vuetifyjs/vuetify/commit/6619c9cbd40ba94314ead2f82fcf077c4309564b)), closes [#10308](https://github.com/vuetifyjs/vuetify/issues/10308)
* **VToolbar:** prevent image overflow in webkit and trident ([25feaf9](https://github.com/vuetifyjs/vuetify/commit/25feaf97eb39503a6d82166c0b6d486699e2e729)), closes [#11873](https://github.com/vuetifyjs/vuetify/issues/11873)
* add missing i18n ([#125](https://github.com/vuetifyjs/vuetify/issues/125)) ([a179db4](https://github.com/vuetifyjs/vuetify/commit/a179db4cef4146696e4258ab01616bf104cb6fd6))
* code blocks always ltr ([eb82fe8](https://github.com/vuetifyjs/vuetify/commit/eb82fe8faedd704498aef7ca4970887b2e443937))
* **Drawer:** move drawer state to app module ([#21](https://github.com/vuetifyjs/vuetify/issues/21)) ([7df05a1](https://github.com/vuetifyjs/vuetify/commit/7df05a1b6a3481f2fe478829fa962cc6d6561742))
* **grid:** collapse vertical gutters ([d0f25fc](https://github.com/vuetifyjs/vuetify/commit/d0f25fc59b29c385a6910dc48a111df811da3bdf)), closes [#11408](https://github.com/vuetifyjs/vuetify/issues/11408)
* **grid:** don't halve gutters between v-rows ([#12916](https://github.com/vuetifyjs/vuetify/issues/12916)) ([f33d0c1](https://github.com/vuetifyjs/vuetify/commit/f33d0c1356c5eb3a685c86f754bdf85c5dd706d0)), closes [#12915](https://github.com/vuetifyjs/vuetify/issues/12915)
* **helpers:** coerce name value to string in groupItems ([#11970](https://github.com/vuetifyjs/vuetify/issues/11970)) ([b1c3f81](https://github.com/vuetifyjs/vuetify/commit/b1c3f81bb62bc218b1c18236f7252412722b32fc)), closes [#12069](https://github.com/vuetifyjs/vuetify/issues/12069) [#12501](https://github.com/vuetifyjs/vuetify/issues/12501)
* **inputs:** display title attribute on root element ([#12776](https://github.com/vuetifyjs/vuetify/issues/12776)) ([17bd263](https://github.com/vuetifyjs/vuetify/commit/17bd263fed490177d634bc8421bdfa8dbf6dc1ef)), closes [#11253](https://github.com/vuetifyjs/vuetify/issues/11253) [#12775](https://github.com/vuetifyjs/vuetify/issues/12775)
* **locales:** fa-Persian i18n translation ([#11679](https://github.com/vuetifyjs/vuetify/issues/11679)) ([f900795](https://github.com/vuetifyjs/vuetify/commit/f90079500ba47567d95f2d5f79b65e24f4f3ac2b))
* **locales:** update `sk` translation ([#13135](https://github.com/vuetifyjs/vuetify/issues/13135)) ([de9aa5d](https://github.com/vuetifyjs/vuetify/commit/de9aa5d905e03b42a8b8050de4e8d8ca15e4ed89))
* **menuable:** don't account for app offset in fixed context ([ec8fafa](https://github.com/vuetifyjs/vuetify/commit/ec8fafa9e785f6817bf6d0058a6953b0091a1370)), closes [#13740](https://github.com/vuetifyjs/vuetify/issues/13740)
* **Menuable:** correctly calculate position in embedded v-app ([#13670](https://github.com/vuetifyjs/vuetify/issues/13670)) ([9145a5e](https://github.com/vuetifyjs/vuetify/commit/9145a5e7e7d7336753b0349cbe41d96fae2f9e75)), closes [#7703](https://github.com/vuetifyjs/vuetify/issues/7703)
* **overlayable:** cancel animationFrame request on remove ([b640d6c](https://github.com/vuetifyjs/vuetify/commit/b640d6cf5ee3a30b60533e8724936c0660f23184)), closes [#10975](https://github.com/vuetifyjs/vuetify/issues/10975) [#9588](https://github.com/vuetifyjs/vuetify/issues/9588)
* **Ripple:** prevent bubbled events from triggering more ripples ([364fb8e](https://github.com/vuetifyjs/vuetify/commit/364fb8e5c2ae24cb3533e5f29b4f72e4a01c4a05)), closes [#7988](https://github.com/vuetifyjs/vuetify/issues/7988)
* **routable:** support exactPath ([8f4773c](https://github.com/vuetifyjs/vuetify/commit/8f4773cd7b58772c96f24829b34bc6846e789ee9)), closes [#13132](https://github.com/vuetifyjs/vuetify/issues/13132)
* **routes:** api pages were using documentation view ([57aafed](https://github.com/vuetifyjs/vuetify/commit/57aafed4f8e8b323c47d2ac5732dd401e461a769))
* **styles:** use math.div instead of `/` ([52c98d5](https://github.com/vuetifyjs/vuetify/commit/52c98d5706884704c33ef1d9f23c328fa9fdb061)), closes [#13694](https://github.com/vuetifyjs/vuetify/issues/13694) [#13704](https://github.com/vuetifyjs/vuetify/issues/13704)
* **types:** add component to IconsOptions ([235139a](https://github.com/vuetifyjs/vuetify/commit/235139a64901e576fa7b19b6685d19cf54da6e95)), closes [#13122](https://github.com/vuetifyjs/vuetify/issues/13122)
* **types:** add declaration for vuetify/lib/components ([#13395](https://github.com/vuetifyjs/vuetify/issues/13395)) ([d8a6cff](https://github.com/vuetifyjs/vuetify/commit/d8a6cff278faf2de2fb2bc9dc65ee0b406c50747))
* **types:** add missing `goTo` types ([#13812](https://github.com/vuetifyjs/vuetify/issues/13812)) ([9f6d0c0](https://github.com/vuetifyjs/vuetify/commit/9f6d0c02608d9029cc24e07dc30ae8a5b0c545a1)), closes [#9648](https://github.com/vuetifyjs/vuetify/issues/9648)
* **types:** add VVirtualScroll to lib.d.ts ([2c9ad3a](https://github.com/vuetifyjs/vuetify/commit/2c9ad3ac67df8b42215e3c186708a000aebc1dfe)), closes [#11701](https://github.com/vuetifyjs/vuetify/issues/11701)
* **types:** declare vuetify/lib/services/goto module ([#13838](https://github.com/vuetifyjs/vuetify/issues/13838)) ([4537798](https://github.com/vuetifyjs/vuetify/commit/4537798f619de9095fbe2a19774a9978deb38963))
* **types:** remove index signature from VuetifyParsedThemeItem ([b01e74a](https://github.com/vuetifyjs/vuetify/commit/b01e74af77d3cdd2306ebc668bd25d0e1e2b3fd4)), closes [#10863](https://github.com/vuetifyjs/vuetify/issues/10863)
* **VAutocomplete:** close mobile keyboard on blur ([#12921](https://github.com/vuetifyjs/vuetify/issues/12921)) ([82eca7e](https://github.com/vuetifyjs/vuetify/commit/82eca7e27c327d93b4bf5ea2dcc68f0b0b2b1559)), closes [#12912](https://github.com/vuetifyjs/vuetify/issues/12912)
* **VAutocomplete:** don't count search as dirty if it is empty ([#13152](https://github.com/vuetifyjs/vuetify/issues/13152)) ([28d1726](https://github.com/vuetifyjs/vuetify/commit/28d172641047a374ef3c29629fc836ac0258f2b0)), closes [#12958](https://github.com/vuetifyjs/vuetify/issues/12958)
* **VAutocomplete:** ignore home/end on menu unless ctrl is pressed ([865196b](https://github.com/vuetifyjs/vuetify/commit/865196b2f9a995e64ade27c24a713ab3a6d2234f)), closes [#13211](https://github.com/vuetifyjs/vuetify/issues/13211)
* **VAutocomplete:** return all filtered items, ensure itemText is present ([6432fb4](https://github.com/vuetifyjs/vuetify/commit/6432fb4bc8744edc7d0705b38d9c05c4ce4072ac)), closes [#11451](https://github.com/vuetifyjs/vuetify/issues/11451) [#11415](https://github.com/vuetifyjs/vuetify/issues/11415) [#11442](https://github.com/vuetifyjs/vuetify/issues/11442)
* **VChip:** outlined hover state ([#11628](https://github.com/vuetifyjs/vuetify/issues/11628)) ([d960a34](https://github.com/vuetifyjs/vuetify/commit/d960a348d2a84a4d57a4b0d2a64f52c5f2f7044f))
* **VSlider:** suppress change event on keydown ([d51d33f](https://github.com/vuetifyjs/vuetify/commit/d51d33fecaa5b5bdb1bd97be33dcd3a673562fe1)), closes [#11569](https://github.com/vuetifyjs/vuetify/issues/11569)
* **VVirtualscroll:** calculate child on mounted instead of created ([#11712](https://github.com/vuetifyjs/vuetify/issues/11712)) ([f3c8aa5](https://github.com/vuetifyjs/vuetify/commit/f3c8aa54a210b90c523ef7d6e6ca3f269fd0b611)), closes [#11707](https://github.com/vuetifyjs/vuetify/issues/11707)
* change curser:default selector to [aria-disabled=true] ([c64431b](https://github.com/vuetifyjs/vuetify/commit/c64431b08100921b4d31241caa5a4aa5345fdbc7)), closes [#11003](https://github.com/vuetifyjs/vuetify/issues/11003)
* fix color inversion ([#33](https://github.com/vuetifyjs/vuetify/issues/33)) ([9a15b5e](https://github.com/vuetifyjs/vuetify/commit/9a15b5e4e8f75ff6b5587d86ad0f5b9e1ec60ceb))
* **VAutocomplete:** select last item when pressing backspace with no index ([524c1e8](https://github.com/vuetifyjs/vuetify/commit/524c1e85d55618ef52e8b117ae75fa9829270525)), closes [#11639](https://github.com/vuetifyjs/vuetify/issues/11639)
* **VBadge:** add missing !default on border radius ([#13296](https://github.com/vuetifyjs/vuetify/issues/13296)) ([c273acb](https://github.com/vuetifyjs/vuetify/commit/c273acb0fc71d8dce7e103294d72b42bf913e012))
* **VBottomNavigation:** add missing tag functionality ([4d627e9](https://github.com/vuetifyjs/vuetify/commit/4d627e9d09e81a41fc3558d31f7792f15a2312ae)), closes [#11392](https://github.com/vuetifyjs/vuetify/issues/11392)
* **VBtn:** disabled state background-color ([#12892](https://github.com/vuetifyjs/vuetify/issues/12892)) ([edf13fe](https://github.com/vuetifyjs/vuetify/commit/edf13fe1c83841c26c3575bb5b052225d61e68ed)), closes [#12845](https://github.com/vuetifyjs/vuetify/issues/12845)
* **VBtn:** override icon font-size with left/right props ([#13120](https://github.com/vuetifyjs/vuetify/issues/13120)) ([5fca6ef](https://github.com/vuetifyjs/vuetify/commit/5fca6ef184f795a9ff3749afa3109882ff7b8d4c)), closes [#11294](https://github.com/vuetifyjs/vuetify/issues/11294)
* **VBtn:** show background on non-elevated buttons, fix color states ([#12908](https://github.com/vuetifyjs/vuetify/issues/12908)) ([a2a61c2](https://github.com/vuetifyjs/vuetify/commit/a2a61c24542e7c5b99560c222c10caa2b2867b77)), closes [#12903](https://github.com/vuetifyjs/vuetify/issues/12903) [#12892](https://github.com/vuetifyjs/vuetify/issues/12892) [#12845](https://github.com/vuetifyjs/vuetify/issues/12845)
* **VBtnToggle:** apply min-width to dense buttons ([6589ed8](https://github.com/vuetifyjs/vuetify/commit/6589ed8812468963f17523e2c8723a973f956a06)), closes [#13820](https://github.com/vuetifyjs/vuetify/issues/13820)
* **vcalendar:** object inheritance ([#12857](https://github.com/vuetifyjs/vuetify/issues/12857)) ([de3112a](https://github.com/vuetifyjs/vuetify/commit/de3112a3654516f7818e5a2a24bc17e6fe30c5c3))
* **VCalendar:** add support for string[] of categories ([#13270](https://github.com/vuetifyjs/vuetify/issues/13270)) ([1a12f12](https://github.com/vuetifyjs/vuetify/commit/1a12f12cbe3cc0f3d00ff2c0460115641b33bd3a)), closes [#12922](https://github.com/vuetifyjs/vuetify/issues/12922)
* **VCalendar:** display events ending at midnight ([#13667](https://github.com/vuetifyjs/vuetify/issues/13667)) ([9a48b0f](https://github.com/vuetifyjs/vuetify/commit/9a48b0fd30d1655393aed32357e9d8a3561786c8)), closes [#11767](https://github.com/vuetifyjs/vuetify/issues/11767) [#12223](https://github.com/vuetifyjs/vuetify/issues/12223)
* **VCalendar:** fix interval-style day when categoryDays > 1 ([#13384](https://github.com/vuetifyjs/vuetify/issues/13384)) ([434df3b](https://github.com/vuetifyjs/vuetify/commit/434df3b5a4d720a936b76d4e26554dcbb35c4623))
* **VCalendar:** missing events under certain circumstances ([#13763](https://github.com/vuetifyjs/vuetify/issues/13763)) ([8226cc9](https://github.com/vuetifyjs/vuetify/commit/8226cc96633537ebce84bf472e9e4bf3e6787db4)), closes [#13720](https://github.com/vuetifyjs/vuetify/issues/13720)
* **VCalendar:** resolve wrong relative day span for 4day ([#12687](https://github.com/vuetifyjs/vuetify/issues/12687)) ([d9138f5](https://github.com/vuetifyjs/vuetify/commit/d9138f5f880f93e2e9e89f9773cf33e5ad790b2f)), closes [#12666](https://github.com/vuetifyjs/vuetify/issues/12666)
* **VCalendar:** type category should display events ([2417f56](https://github.com/vuetifyjs/vuetify/commit/2417f56572e2b2c4a57797c7d2e1590e4dd6b389))
* **VCalendarCategory:** always render at least one day body per day ([c90fda6](https://github.com/vuetifyjs/vuetify/commit/c90fda641429be078dc813a823158cc5ee6878a7)), closes [#13155](https://github.com/vuetifyjs/vuetify/issues/13155)
* **VCalendarCategory:** category schedule for more than 1 day ([#13050](https://github.com/vuetifyjs/vuetify/issues/13050)) ([a2d014d](https://github.com/vuetifyjs/vuetify/commit/a2d014dfbd2367654e8c5eaf783d4dbac9e40979)), closes [#12967](https://github.com/vuetifyjs/vuetify/issues/12967)
* **VCard:** incorrect positioning for v-card-actions in v-dialog ([#12734](https://github.com/vuetifyjs/vuetify/issues/12734)) ([5ce3cd5](https://github.com/vuetifyjs/vuetify/commit/5ce3cd5950c6a23e2f8a4154e557e40c0239c128)), closes [#10605](https://github.com/vuetifyjs/vuetify/issues/10605) [#10605](https://github.com/vuetifyjs/vuetify/issues/10605)
* **VCard:** set correct radius for direct VAvatar children ([#13789](https://github.com/vuetifyjs/vuetify/issues/13789)) ([00b29ba](https://github.com/vuetifyjs/vuetify/commit/00b29ba06691b291b3d5fc4dcb72d97344d8e145))
* **VCard:** use a child combinator for v-card-subtitle color style ([a29b965](https://github.com/vuetifyjs/vuetify/commit/a29b9656d7d066d20e2c53d8843948195720d2ce)), closes [#13745](https://github.com/vuetifyjs/vuetify/issues/13745)
* **VCarousel:** incorrect transition direction when using touch ([#12357](https://github.com/vuetifyjs/vuetify/issues/12357)) ([2160daf](https://github.com/vuetifyjs/vuetify/commit/2160daf31f47161fbac85458383f529e90ca3d86)), closes [#11280](https://github.com/vuetifyjs/vuetify/issues/11280)
* **VCarousel:** prevent TypeError in v-if ([#13669](https://github.com/vuetifyjs/vuetify/issues/13669)) ([22db933](https://github.com/vuetifyjs/vuetify/commit/22db9334495802ed155ca52e519d342e5faf30bd)), closes [#13656](https://github.com/vuetifyjs/vuetify/issues/13656)
* **VCarousel:** stop event propagation for prev/next buttons ([#12678](https://github.com/vuetifyjs/vuetify/issues/12678)) ([07eb09e](https://github.com/vuetifyjs/vuetify/commit/07eb09e42a448b4dee2ae363826ec14dcac5af6e))
* **VChip:** icon size based on chip size prop ([#13412](https://github.com/vuetifyjs/vuetify/issues/13412)) ([f6866d4](https://github.com/vuetifyjs/vuetify/commit/f6866d4dbcea09ab100aec230d0ece9bf67c5ae5)), closes [#13248](https://github.com/vuetifyjs/vuetify/issues/13248)
* **VColorPicker:** Allow swatches to be disabled ([#13208](https://github.com/vuetifyjs/vuetify/issues/13208)) ([ed76169](https://github.com/vuetifyjs/vuetify/commit/ed76169e26795f9fd386d3b371af3c47ad70fb35)), closes [#13160](https://github.com/vuetifyjs/vuetify/issues/13160)
* **VCombobox:** clear search if matching item is selected ([#12896](https://github.com/vuetifyjs/vuetify/issues/12896)) ([6b92f53](https://github.com/vuetifyjs/vuetify/commit/6b92f531a20bd7825505a3b2552dc1cdba8ab1e9)), closes [#8842](https://github.com/vuetifyjs/vuetify/issues/8842)
* **VCombobox:** correctly handle duplicate items ([#13366](https://github.com/vuetifyjs/vuetify/issues/13366)) ([5fbea51](https://github.com/vuetifyjs/vuetify/commit/5fbea51840c399af5e7b32191b366e5121f4d4f8)), closes [#12351](https://github.com/vuetifyjs/vuetify/issues/12351)
* **VCombobox:** don't reset value to null if search is empty ([#12415](https://github.com/vuetifyjs/vuetify/issues/12415)) ([f1b621b](https://github.com/vuetifyjs/vuetify/commit/f1b621b3c400ef18c233850a1583ec0d0fa9f0ff)), closes [#12322](https://github.com/vuetifyjs/vuetify/issues/12322)
* **VCombobox:** fixed incorrect combobox behaviour ([#12806](https://github.com/vuetifyjs/vuetify/issues/12806)) ([fd339ed](https://github.com/vuetifyjs/vuetify/commit/fd339edfa780399a98cf4723e5a4f270a613eed3)), closes [#12781](https://github.com/vuetifyjs/vuetify/issues/12781)
* **VCombobox:** re-compute menu items before setting index ([#13825](https://github.com/vuetifyjs/vuetify/issues/13825)) ([8c0e2bc](https://github.com/vuetifyjs/vuetify/commit/8c0e2bcce1c9ccd64cbf5f5d085d2ca9becbac3c)), closes [#12567](https://github.com/vuetifyjs/vuetify/issues/12567)
* **VDataFooter:** show custom footer.page-text on empty data tables ([#12651](https://github.com/vuetifyjs/vuetify/issues/12651)) ([d9d3cb3](https://github.com/vuetifyjs/vuetify/commit/d9d3cb30fa5f86f94578cded02c5858e60b88b1b))
* **VDataIterator:** use itemKey instead of name for select ([#13679](https://github.com/vuetifyjs/vuetify/issues/13679)) ([b750730](https://github.com/vuetifyjs/vuetify/commit/b750730c1612a917b4c6f81f7799ddaebdca92bf)), closes [#13677](https://github.com/vuetifyjs/vuetify/issues/13677)
* **VDataTable:** clamp current page when filtering ([#13087](https://github.com/vuetifyjs/vuetify/issues/13087)) ([df75ad3](https://github.com/vuetifyjs/vuetify/commit/df75ad3555d5e30b743ad2697b91c0a7fcb2f252)), closes [#12732](https://github.com/vuetifyjs/vuetify/issues/12732)
* **VDataTable:** convert dates to timestamps before sorting ([3171d6f](https://github.com/vuetifyjs/vuetify/commit/3171d6f460ef41758817d54f18e20d6196ef05fb)), closes [#13829](https://github.com/vuetifyjs/vuetify/issues/13829)
* **VDataTable:** display as flex column on mobile ([4cc80ca](https://github.com/vuetifyjs/vuetify/commit/4cc80ca7bea963be875b3ab0f9ba03a8b21c4d92)), closes [#11337](https://github.com/vuetifyjs/vuetify/issues/11337)
* **VDataTable:** prevent NaN when itemsPerPage is 0 ([e57bd6d](https://github.com/vuetifyjs/vuetify/commit/e57bd6d78f26ea7ddddfce6b91d640651768d097)), closes [#13087](https://github.com/vuetifyjs/vuetify/issues/13087)
* **VDataTableHeader:** decrease sort icon line height ([#12868](https://github.com/vuetifyjs/vuetify/issues/12868)) ([da21feb](https://github.com/vuetifyjs/vuetify/commit/da21feb403b3282381c1b920eaecb3f0ad76400d)), closes [#12823](https://github.com/vuetifyjs/vuetify/issues/12823)
* **VDatePicker:** correctly show weeks and dates ([#13225](https://github.com/vuetifyjs/vuetify/issues/13225)) ([5ed2e0f](https://github.com/vuetifyjs/vuetify/commit/5ed2e0f1cb1e5c90a2b5f05d728cbcaaf17baa1d))
* **VDatePicker:** prevent scroll beyond max date with touchpad ([#13456](https://github.com/vuetifyjs/vuetify/issues/13456)) ([41e0311](https://github.com/vuetifyjs/vuetify/commit/41e03113eacf71a3dfa78cf3875f4f23fe70bdc6))
* **VDatePicker:** scroll not honoring min and max tableDate ([#12904](https://github.com/vuetifyjs/vuetify/issues/12904)) ([e91b288](https://github.com/vuetifyjs/vuetify/commit/e91b288cdaae40f52efb1ba1ec67903b090c1bea))
* **VDivider:** prevent wrapping in flex layouts ([f0892c3](https://github.com/vuetifyjs/vuetify/commit/f0892c3a14a6b8c2e49d953d60609ac309d897f1)), closes [#11973](https://github.com/vuetifyjs/vuetify/issues/11973)
* **VDivider:** vertical v-divider is not displayed when inside div and inline ([#12735](https://github.com/vuetifyjs/vuetify/issues/12735)) ([985ef44](https://github.com/vuetifyjs/vuetify/commit/985ef44d948bab4ab371191f539de5ad5c3a476b)), closes [#8656](https://github.com/vuetifyjs/vuetify/issues/8656)
* **VExpansionPanel:** don't boot before showing if opened externally ([0b8fc27](https://github.com/vuetifyjs/vuetify/commit/0b8fc27c6d9c02d4daced65ff966a8adfde93e33)), closes [#10140](https://github.com/vuetifyjs/vuetify/issues/10140)
* **VFileInput:** allow multiple to be bound as false ([08c1e89](https://github.com/vuetifyjs/vuetify/commit/08c1e8911ebe6f36114c9eb1bae7f449944bff78)), closes [#9530](https://github.com/vuetifyjs/vuetify/issues/9530)
* **VFileInput:** prevent label and placeholder overlap ([#12891](https://github.com/vuetifyjs/vuetify/issues/12891)) ([ff2fbb1](https://github.com/vuetifyjs/vuetify/commit/ff2fbb175d38e6c62f0b2366137d8f8c629a1d41)), closes [#12864](https://github.com/vuetifyjs/vuetify/issues/12864)
* **VImg:** default ratio to 1:1 for SVG images ([#12784](https://github.com/vuetifyjs/vuetify/issues/12784)) ([57b1e37](https://github.com/vuetifyjs/vuetify/commit/57b1e37b4852fe683f35ae42f2a9b2b35c704079)), closes [#11426](https://github.com/vuetifyjs/vuetify/issues/11426)
* **VImg:** SVG size wrong after uncached load ([#12825](https://github.com/vuetifyjs/vuetify/issues/12825)) ([a6e2e44](https://github.com/vuetifyjs/vuetify/commit/a6e2e44e718df4fa638620f561f58c8828b3ac66))
* **VLazy:** don't immediately show content if transition not set ([f1c2981](https://github.com/vuetifyjs/vuetify/commit/f1c2981987a93965e8abae6cf55fbfa11c737ced)), closes [#11801](https://github.com/vuetifyjs/vuetify/issues/11801)
* **VListGroup:** support regexp in the group prop ([43b0406](https://github.com/vuetifyjs/vuetify/commit/43b0406a89169dae8e53a705f5a7b20e03733591)), closes [#7812](https://github.com/vuetifyjs/vuetify/issues/7812)
* **VListItem:** use item role when in a group ([#13126](https://github.com/vuetifyjs/vuetify/issues/13126)) ([4974d74](https://github.com/vuetifyjs/vuetify/commit/4974d746720a0daea686448a273a310628a177b9)), closes [#13125](https://github.com/vuetifyjs/vuetify/issues/13125)
* **VMenu:** activator should not return non Element nodes ([#13774](https://github.com/vuetifyjs/vuetify/issues/13774)) ([25e80a1](https://github.com/vuetifyjs/vuetify/commit/25e80a11d4e61e5ceef8659e24b8c63c39f8469b)), closes [#13755](https://github.com/vuetifyjs/vuetify/issues/13755)
* **VMenu:** apply position:relative to v-app ([#13823](https://github.com/vuetifyjs/vuetify/issues/13823)) ([d8679b9](https://github.com/vuetifyjs/vuetify/commit/d8679b9e99a164059991b53e5defa6e6acddf7e1)), closes [#13821](https://github.com/vuetifyjs/vuetify/issues/13821)
* **VPagination:** add disabled attr to buttons ([#12953](https://github.com/vuetifyjs/vuetify/issues/12953)) ([#12990](https://github.com/vuetifyjs/vuetify/issues/12990)) ([0329e5b](https://github.com/vuetifyjs/vuetify/commit/0329e5b6b7730703bc01ff0df3fc7693e76b3231))
* **VPagination:** don't show ellipsis for one item ([#13560](https://github.com/vuetifyjs/vuetify/issues/13560)) ([bcd0379](https://github.com/vuetifyjs/vuetify/commit/bcd0379902d70e5e36e3b3905c4b45c153f86a57))
* **VProgressCircular:** prevent animation flicker ([944077e](https://github.com/vuetifyjs/vuetify/commit/944077e1695a4b4d776fbc973006710519d558a6)), closes [#12813](https://github.com/vuetifyjs/vuetify/issues/12813)
* **VRangeSlider:** properly use trackFillColor ([#12777](https://github.com/vuetifyjs/vuetify/issues/12777)) ([5cad5a0](https://github.com/vuetifyjs/vuetify/commit/5cad5a055523699b76e0b91f0a2cff802a273f96))
* **VRating:** add icon aria-label ([#12345](https://github.com/vuetifyjs/vuetify/issues/12345)) ([1be735c](https://github.com/vuetifyjs/vuetify/commit/1be735cf929126f271a677928b3d4ef7186524a4)), closes [#11590](https://github.com/vuetifyjs/vuetify/issues/11590)
* **VRating:** make icons tab-accessible ([#13098](https://github.com/vuetifyjs/vuetify/issues/13098)) ([9b1356a](https://github.com/vuetifyjs/vuetify/commit/9b1356a120109c57cc6df8621a504f8d4e5af3b2)), closes [#10820](https://github.com/vuetifyjs/vuetify/issues/10820)
* **VRipple:** hide ripple on blur ([#13264](https://github.com/vuetifyjs/vuetify/issues/13264)) ([2e95f6d](https://github.com/vuetifyjs/vuetify/commit/2e95f6d4c5fc77c8db1458e9d47550ae8e48618a)), closes [#13189](https://github.com/vuetifyjs/vuetify/issues/13189)
* **VRow:** increase specificity of no-gutters ([9892c6f](https://github.com/vuetifyjs/vuetify/commit/9892c6f5ed8f09b33289b78d24717586dddd9cb6)), closes [#13020](https://github.com/vuetifyjs/vuetify/issues/13020)
* **VSelect:** don't apply currentColor to selection slot ([c495ae8](https://github.com/vuetifyjs/vuetify/commit/c495ae87a95ef094c33adcd7ffcb63263708f30f)), closes [#11068](https://github.com/vuetifyjs/vuetify/issues/11068)
* **VSelect:** don't apply disabled styles to selections when readonly ([efe7116](https://github.com/vuetifyjs/vuetify/commit/efe711615eab08631aebd309dac0029590ab6d81)), closes [#11828](https://github.com/vuetifyjs/vuetify/issues/11828)
* **VSelect:** don't dispatch click event on arrow keys ([#12815](https://github.com/vuetifyjs/vuetify/issues/12815)) ([7fae557](https://github.com/vuetifyjs/vuetify/commit/7fae5577ae15fc590cd77191db220eaf29ed7ab7)), closes [#12769](https://github.com/vuetifyjs/vuetify/issues/12769) [#12723](https://github.com/vuetifyjs/vuetify/issues/12723)
* **VSelect:** don't resolve item values twice when emitting change ([6bdbc86](https://github.com/vuetifyjs/vuetify/commit/6bdbc86995ded07de5a657c0e22154d002745f0e)), closes [#13729](https://github.com/vuetifyjs/vuetify/issues/13729)
* **VSelect:** don't show placeholder when dirty ([ce2d5f8](https://github.com/vuetifyjs/vuetify/commit/ce2d5f82507c6e6869d3cb93959b736036246deb)), closes [#13131](https://github.com/vuetifyjs/vuetify/issues/13131)
* **VSelect:** ignore arrow up/down if no clickable tiles ([e1dd914](https://github.com/vuetifyjs/vuetify/commit/e1dd914daafc518c76161d3c3e478296f1598e96)), closes [#13084](https://github.com/vuetifyjs/vuetify/issues/13084)
* **VSelect:** show placeholder when using persistentPlaceholder ([44ef316](https://github.com/vuetifyjs/vuetify/commit/44ef3163d75d801ce1811812e3969644ed51896e)), closes [#13792](https://github.com/vuetifyjs/vuetify/issues/13792)
* **VSimpleCheckbox:** show ripple and hover ring ([7390484](https://github.com/vuetifyjs/vuetify/commit/739048495a8e4768794bee2a8517acef9e33c1fd)), closes [#12492](https://github.com/vuetifyjs/vuetify/issues/12492)
* **VSlideGroup:** fix scrollIntoView & arrows visibility ([#12318](https://github.com/vuetifyjs/vuetify/issues/12318)) ([f59279e](https://github.com/vuetifyjs/vuetify/commit/f59279ebec9b5fe9198e5bb8cf2e8c759bc90c0e))
* **VSlideGroup:** handle rounding issue if using browser zoom ([#13280](https://github.com/vuetifyjs/vuetify/issues/13280)) ([e35397c](https://github.com/vuetifyjs/vuetify/commit/e35397cdc7e25d5e365d137afdebb4d6bcb6623b)), closes [#13212](https://github.com/vuetifyjs/vuetify/issues/13212)
* **VSlider:** make slider drag respond to mousedown ([#12640](https://github.com/vuetifyjs/vuetify/issues/12640)) ([4133a76](https://github.com/vuetifyjs/vuetify/commit/4133a76f076783bb276088951cb9ef98abf99ba7))
* **VSlider:** only emit a single change event ([#13222](https://github.com/vuetifyjs/vuetify/issues/13222)) ([ed0b0ca](https://github.com/vuetifyjs/vuetify/commit/ed0b0ca7a0ab81671a0757d8d2c00b104c61b245)), closes [#13151](https://github.com/vuetifyjs/vuetify/issues/13151)
* **VSlider:** support touch and drag ([#13263](https://github.com/vuetifyjs/vuetify/issues/13263)) ([89b55e2](https://github.com/vuetifyjs/vuetify/commit/89b55e28750e39c4c6baab24d9b891e03eb35e8f)), closes [#13259](https://github.com/vuetifyjs/vuetify/issues/13259)
* **VSlider:** use a transition on the thumb when ticks are enabled ([eabff8a](https://github.com/vuetifyjs/vuetify/commit/eabff8a657e25100e0cfe063d0d950b1ec02466d)), closes [#12984](https://github.com/vuetifyjs/vuetify/issues/12984)
* **VSnackbar:** don't use !important for box-shadow ([11fd714](https://github.com/vuetifyjs/vuetify/commit/11fd714aad1913d6a7cf3b54952d68838db1c88d)), closes [#13438](https://github.com/vuetifyjs/vuetify/issues/13438)
* **VSnackbar:** set position of opposite direction values ([#12786](https://github.com/vuetifyjs/vuetify/issues/12786)) ([8c20c4f](https://github.com/vuetifyjs/vuetify/commit/8c20c4fc2b35c667ed5d278e663dc5d0356d8dd3)), closes [#11781](https://github.com/vuetifyjs/vuetify/issues/11781)
* **VTabs:** remove unused sass variables ([781370b](https://github.com/vuetifyjs/vuetify/commit/781370b9f718667c238558f4422e288dbab62851)), closes [#11217](https://github.com/vuetifyjs/vuetify/issues/11217)
* partially revert changes made in e83a203 ([8c650e4](https://github.com/vuetifyjs/vuetify/commit/8c650e48a53ac32ba44bd16d3f853a8b07810ff3)), closes [#11629](https://github.com/vuetifyjs/vuetify/issues/11629)
* remove unnecessary will-change ([a3ec892](https://github.com/vuetifyjs/vuetify/commit/a3ec892f2cd680dd8f7676559e3695dd2e675ba8)), closes [#12890](https://github.com/vuetifyjs/vuetify/issues/12890)
* **_reset.scss:** hide clear icon for search inputs ([eeb7492](https://github.com/vuetifyjs/vuetify/commit/eeb7492cf292e993de65080e5c482d82b1e643f7))
* **click-outside:** detect shadowRoot in handler ([#13462](https://github.com/vuetifyjs/vuetify/issues/13462)) ([708f8de](https://github.com/vuetifyjs/vuetify/commit/708f8de8e2055d6edf2e08492a9c8537b1672fec)), closes [#13275](https://github.com/vuetifyjs/vuetify/issues/13275)
* **intersect:** don't unbind until the element is intersecting ([#13593](https://github.com/vuetifyjs/vuetify/issues/13593)) ([806ac63](https://github.com/vuetifyjs/vuetify/commit/806ac63cd754f4e8cbfef62181094762c9f8d347))
* **locale:** improve ro translation ([#13402](https://github.com/vuetifyjs/vuetify/issues/13402)) ([ed6f621](https://github.com/vuetifyjs/vuetify/commit/ed6f621f9f9086382c2894ea695355ae0bdd1ab8))
* **locale:** update japanese translation ([#13413](https://github.com/vuetifyjs/vuetify/issues/13413)) ([427308d](https://github.com/vuetifyjs/vuetify/commit/427308d863bbddf976e002d9d4f7267228acc3d4))
* **Page:** increase max-width of page content ([#22](https://github.com/vuetifyjs/vuetify/issues/22)) ([fc82529](https://github.com/vuetifyjs/vuetify/commit/fc8252969374a490918b364286c8002adc850087))
* **theme:** convert color value to hex when not using variations ([172e852](https://github.com/vuetifyjs/vuetify/commit/172e852f70452108c356fa257def444dcc081be4))
* **transitions:** leaveAbsolute retains relative position and size ([b738de5](https://github.com/vuetifyjs/vuetify/commit/b738de5c279840a30eb640f73bf61a1c8ac2a7fd))
* **transitions:** make default transition !important ([d23ca5d](https://github.com/vuetifyjs/vuetify/commit/d23ca5d9cce7819de7e22abacdd47eeece2b4304)), closes [#9938](https://github.com/vuetifyjs/vuetify/issues/9938)
* **transitions:** remove absolute position after leave if leaveAbsolute ([2ad4586](https://github.com/vuetifyjs/vuetify/commit/2ad4586d0e45967e335dee8f50f5d25d681b2605))
* **typescript:** added missing VThemeProvider export in lib.d.ts ([#13642](https://github.com/vuetifyjs/vuetify/issues/13642)) ([8652b48](https://github.com/vuetifyjs/vuetify/commit/8652b482086ac661dc1e627abea242c2d38f6afd)), closes [#13578](https://github.com/vuetifyjs/vuetify/issues/13578)
* **v-intersect:** check for IntersectionObserver support ([b04dbba](https://github.com/vuetifyjs/vuetify/commit/b04dbba82fdd03c732f7b2e5ea144037f0b59b6a)), closes [#13644](https://github.com/vuetifyjs/vuetify/issues/13644)
* **VAlert:** increase margin for icon when using prominent and border ([4a33dfd](https://github.com/vuetifyjs/vuetify/commit/4a33dfdcb74d0689c9914b2f5f4276c84912d4a8))
* **VAlert:** reduce icon outline size for dense + prominent props ([d48eeb2](https://github.com/vuetifyjs/vuetify/commit/d48eeb24005d7704ac79d14e6e7510917e4e9ed9))
* **VAlert:** update prominent style ordering for specificity ([8e82aec](https://github.com/vuetifyjs/vuetify/commit/8e82aecd5793ddf7869e97cfd687f77972f6936a)), closes [#12181](https://github.com/vuetifyjs/vuetify/issues/12181)
* **validatable:** change logic for disabled and readonly inputs ([7e78d75](https://github.com/vuetifyjs/vuetify/commit/7e78d759a52e09f88ec8edcc3d817e054165141c)), closes [#11504](https://github.com/vuetifyjs/vuetify/issues/11504)
* **VAppBarTitle:** export VAppBarTitle types ([#13409](https://github.com/vuetifyjs/vuetify/issues/13409)) ([d20d124](https://github.com/vuetifyjs/vuetify/commit/d20d1241f1761040d785c27f4c090fd979c592fe)), closes [#13385](https://github.com/vuetifyjs/vuetify/issues/13385)
* **VAutocomplete:** compare current lazyValue before emiting update ([#13316](https://github.com/vuetifyjs/vuetify/issues/13316)) ([3024044](https://github.com/vuetifyjs/vuetify/commit/3024044342cdb06bbe63fca92cc41be31017b3bd))
* **VBadge:** fix icon size when using svg ([#13624](https://github.com/vuetifyjs/vuetify/issues/13624)) ([cd9a826](https://github.com/vuetifyjs/vuetify/commit/cd9a8264f52ce6cb39af5b12fa565b283786ff16)), closes [#13425](https://github.com/vuetifyjs/vuetify/issues/13425)
* **VBreadcrumbs:** remove duplicate scss var ([#13357](https://github.com/vuetifyjs/vuetify/issues/13357)) ([25f861c](https://github.com/vuetifyjs/vuetify/commit/25f861c69e32c2c4e767bf4c25b69010ab607754))
* **VCalendar:** apply explicit line-height to the .v-event div ([675d529](https://github.com/vuetifyjs/vuetify/commit/675d529aee1432116c28eb1903c4a63f25d7ece4))
* **VCarousel:** children inherit theme from carousel's parent ([faeb8df](https://github.com/vuetifyjs/vuetify/commit/faeb8dfb8b1361f2195ea89785b747bca3e24672)), closes [#8392](https://github.com/vuetifyjs/vuetify/issues/8392)
* **VCheckbox:** add variable checkbox-dense-padding-top ([#13420](https://github.com/vuetifyjs/vuetify/issues/13420)) ([f69d1a6](https://github.com/vuetifyjs/vuetify/commit/f69d1a6bf2d08386cb1d0667f11be349d03f5c3a))
* **VCombobox:** don't add empty values ([#13298](https://github.com/vuetifyjs/vuetify/issues/13298)) ([d2a042b](https://github.com/vuetifyjs/vuetify/commit/d2a042bea7debf2cc3b28700c64aea14db09783e)), closes [#13274](https://github.com/vuetifyjs/vuetify/issues/13274)
* **VCombobox:** reset editingIndex after clear ([#13382](https://github.com/vuetifyjs/vuetify/issues/13382)) ([335b39f](https://github.com/vuetifyjs/vuetify/commit/335b39f33dec7688efe049e6eb860bf9fafd7f01))
* **VContent:** display proper deprecated message ([#11589](https://github.com/vuetifyjs/vuetify/issues/11589)) ([0489e64](https://github.com/vuetifyjs/vuetify/commit/0489e64b0ac4686ff0154cb051f05408150d4a54))
* **VData:** allow group-by to be used with disable-sort ([#13027](https://github.com/vuetifyjs/vuetify/issues/13027)) ([560b52c](https://github.com/vuetifyjs/vuetify/commit/560b52cfde5f4467d48ba24967dc64e7495fba6b))
* **VDataTable:** union column filter with search results ([#11575](https://github.com/vuetifyjs/vuetify/issues/11575)) ([f15dbc4](https://github.com/vuetifyjs/vuetify/commit/f15dbc413741ebc881b2854bea556643a7763e78)), closes [#11402](https://github.com/vuetifyjs/vuetify/issues/11402)
* **VDataTable:** update child combinator selectors for dense & fixed-header props ([#11568](https://github.com/vuetifyjs/vuetify/issues/11568)) ([93a8aac](https://github.com/vuetifyjs/vuetify/commit/93a8aac33601883fabbb8687436cbdc871bc1496)), closes [#11566](https://github.com/vuetifyjs/vuetify/issues/11566) [#11567](https://github.com/vuetifyjs/vuetify/issues/11567)
* **VDatePicker:** consider allowed-dates in range ([#11592](https://github.com/vuetifyjs/vuetify/issues/11592)) ([49f15a7](https://github.com/vuetifyjs/vuetify/commit/49f15a7fead26d27c8257e1828a5e9d9db286544)), closes [#10639](https://github.com/vuetifyjs/vuetify/issues/10639)
* **VDatePicker:** throttle scroll with using scrollable prop ([#11372](https://github.com/vuetifyjs/vuetify/issues/11372)) ([bb18234](https://github.com/vuetifyjs/vuetify/commit/bb18234d172698ffd97df1631856aac6c8f04773)), closes [#5546](https://github.com/vuetifyjs/vuetify/issues/5546)
* **VDatePicker:** touch not honoring min and max tableDate ([#13436](https://github.com/vuetifyjs/vuetify/issues/13436)) ([a77d19f](https://github.com/vuetifyjs/vuetify/commit/a77d19f7ec4b1a28ab8dc31f78e267bb87ac42a1))
* **VDialog:** don't try to focus disabled elements ([238f361](https://github.com/vuetifyjs/vuetify/commit/238f3612c0463cd83a08941b52e0f0f696607721)), closes [#11547](https://github.com/vuetifyjs/vuetify/issues/11547)
* **VExpansionPanelHeader:** add missing aria-expanded attribute ([#13355](https://github.com/vuetifyjs/vuetify/issues/13355)) ([4b58e9c](https://github.com/vuetifyjs/vuetify/commit/4b58e9ca8e9a72997ac341f2b8d76eeeac527066))
* **VExpansionPanels:** change aria-expanded to use isActive ([#13361](https://github.com/vuetifyjs/vuetify/issues/13361)) ([4c1a9ad](https://github.com/vuetifyjs/vuetify/commit/4c1a9ad11c3be899bc11dc7e5d9dbd0b10ef9871))
* **VIcon:** support fontawsome kits ([1f1a07c](https://github.com/vuetifyjs/vuetify/commit/1f1a07c7ed12fd7441d700ef262bf77ff9660a17)), closes [#13649](https://github.com/vuetifyjs/vuetify/issues/13649)
* **VImg:** set srcset before src ([0a0bd5e](https://github.com/vuetifyjs/vuetify/commit/0a0bd5e6fb8c91ce7c888229dbf478ec892b65c6)), closes [#13423](https://github.com/vuetifyjs/vuetify/issues/13423)
* **VNavigationDrawer:** disable inherit value of background property ([#11419](https://github.com/vuetifyjs/vuetify/issues/11419)) ([2974f15](https://github.com/vuetifyjs/vuetify/commit/2974f157407931a5db798cff6406e1345dc53a0d)), closes [#11153](https://github.com/vuetifyjs/vuetify/issues/11153)
* **VProgressLinear:** limit buffer width to positive numbers ([1d6a916](https://github.com/vuetifyjs/vuetify/commit/1d6a916a160eb88177a11870129e66eac766c459)), closes [#13616](https://github.com/vuetifyjs/vuetify/issues/13616)
* **VSelect:** add min-width for overflowed selection items ([#11532](https://github.com/vuetifyjs/vuetify/issues/11532)) ([5ecebfc](https://github.com/vuetifyjs/vuetify/commit/5ecebfcb4aaf4baa59cc82313eebf5e2182fe187)), closes [#11524](https://github.com/vuetifyjs/vuetify/issues/11524)
* **VSelect:** allow tab key down on read-only ([#11431](https://github.com/vuetifyjs/vuetify/issues/11431)) ([1c6de0c](https://github.com/vuetifyjs/vuetify/commit/1c6de0c54877e9d5686afe9827b4b9d0a29f2460)), closes [#11430](https://github.com/vuetifyjs/vuetify/issues/11430)
* **VSelect:** compare object values before emitting change ([#13664](https://github.com/vuetifyjs/vuetify/issues/13664)) ([7ddf113](https://github.com/vuetifyjs/vuetify/commit/7ddf113f048688dc192a27d2b87c0b4bb635c31a)), closes [#13658](https://github.com/vuetifyjs/vuetify/issues/13658)
* **VSelect:** make CSS order-independent ([#13150](https://github.com/vuetifyjs/vuetify/issues/13150)) ([d285435](https://github.com/vuetifyjs/vuetify/commit/d28543579ccb5d42af160968f186410b06b75b13)), closes [#13149](https://github.com/vuetifyjs/vuetify/issues/13149)
* **VSelect:** resolve "Expected identifier." error ([#13439](https://github.com/vuetifyjs/vuetify/issues/13439)) ([99e6738](https://github.com/vuetifyjs/vuetify/commit/99e673832cce88ff52ccb69de95601bbab802fa4))
* **VSelect:** specify min-height 10px ([#13101](https://github.com/vuetifyjs/vuetify/issues/13101)) ([846a96d](https://github.com/vuetifyjs/vuetify/commit/846a96d6823d7932b5e831bb7971924b6522dee8))
* **VSimpleTable:** change css selector for fixed-header dense tables ([1ec7de8](https://github.com/vuetifyjs/vuetify/commit/1ec7de809d064ff917d1088f0b70b1678453690a)), closes [#11525](https://github.com/vuetifyjs/vuetify/issues/11525)
* **VSimpleTable:** reset table line-height and  adjust td dense height ([d634514](https://github.com/vuetifyjs/vuetify/commit/d6345149029e816802ff79eac05b3c61b84b956c))
* **VSlideGroup:** detect horizontal/vertical swipe intent ([#13005](https://github.com/vuetifyjs/vuetify/issues/13005)) ([f6124be](https://github.com/vuetifyjs/vuetify/commit/f6124be8790d5294354b6c808edcde6abc3f7b2e))
* **VSlideGroup:** revert deprecation of show-arrows true ([1085c02](https://github.com/vuetifyjs/vuetify/commit/1085c02f0caac82a604d9e4b0433961efd653cfe)), closes [#11620](https://github.com/vuetifyjs/vuetify/issues/11620)
* **VVirtualScroll:** provide correct item index to default slot ([#11643](https://github.com/vuetifyjs/vuetify/issues/11643)) ([4dbaec1](https://github.com/vuetifyjs/vuetify/commit/4dbaec19f1a4b1ca19d6fa861a8176669aefd393)), closes [#11622](https://github.com/vuetifyjs/vuetify/issues/11622)
* pass env to md.parse() ([ba82d29](https://github.com/vuetifyjs/vuetify/commit/ba82d291033cca9f803c2a1b28bf9bded3891cc0))
* **VSlideGroup:** vertical scroll lock for touch ([#11571](https://github.com/vuetifyjs/vuetify/issues/11571)) ([76d5862](https://github.com/vuetifyjs/vuetify/commit/76d5862ab0a9937f9fd5fdd6a42d5d5bf158b0cd)), closes [#10673](https://github.com/vuetifyjs/vuetify/issues/10673)
* **VSlider:** add mouseup event emit ([#11594](https://github.com/vuetifyjs/vuetify/issues/11594)) ([fb5e393](https://github.com/vuetifyjs/vuetify/commit/fb5e393bea4eb81f37275afc52303edcf65e7130)), closes [#11577](https://github.com/vuetifyjs/vuetify/issues/11577)
* **VSnackbar:** add missing size prop integration ([#13340](https://github.com/vuetifyjs/vuetify/issues/13340)) ([cbfad79](https://github.com/vuetifyjs/vuetify/commit/cbfad7974920a000307cc69ac952016021db2dbe)), closes [#11632](https://github.com/vuetifyjs/vuetify/issues/11632)
* **VTabs:** right aligned tabs in vertical mode ([#13012](https://github.com/vuetifyjs/vuetify/issues/13012)) ([18c2d6c](https://github.com/vuetifyjs/vuetify/commit/18c2d6ce95978cd2b75a6eaace45141deaa7dbad))
* **VTabsItems:** keep rounded corners during animations ([#11983](https://github.com/vuetifyjs/vuetify/issues/11983)) ([107bd32](https://github.com/vuetifyjs/vuetify/commit/107bd328e33f66646787fbdd0821d9f274543663))
* **VTextField:** add padding-top custom variable to details ([#12661](https://github.com/vuetifyjs/vuetify/issues/12661)) ([47e190e](https://github.com/vuetifyjs/vuetify/commit/47e190eb2ca20e2bafaa65ea221382f0e29b6500)), closes [#12660](https://github.com/vuetifyjs/vuetify/issues/12660)
* **VTextField:** align dense mode text field prefix and content ([#12759](https://github.com/vuetifyjs/vuetify/issues/12759)) ([e90e07a](https://github.com/vuetifyjs/vuetify/commit/e90e07acfd53409237bcaee60a725785d0c0827f)), closes [#12743](https://github.com/vuetifyjs/vuetify/issues/12743) [#12743](https://github.com/vuetifyjs/vuetify/issues/12743) [#12743](https://github.com/vuetifyjs/vuetify/issues/12743)
* **VTextField:** allow numeric input starting with -0  ([#11454](https://github.com/vuetifyjs/vuetify/issues/11454)) ([ef677fb](https://github.com/vuetifyjs/vuetify/commit/ef677fb3df3faf23e1905621f5d006fa920e0a16)), closes [#9368](https://github.com/vuetifyjs/vuetify/issues/9368) [#9368](https://github.com/vuetifyjs/vuetify/issues/9368)
* **VTextField:** detect activeElement from shadowRoot ([#13053](https://github.com/vuetifyjs/vuetify/issues/13053)) ([dc19b82](https://github.com/vuetifyjs/vuetify/commit/dc19b82e2b9178ddf553b42a981208d6f2d811ac)), closes [#7622](https://github.com/vuetifyjs/vuetify/issues/7622)
* **VTextField:** fix click dead zone when using clearable ([#13576](https://github.com/vuetifyjs/vuetify/issues/13576)) ([67346db](https://github.com/vuetifyjs/vuetify/commit/67346dbb02cfd7f69076098b326d591738df8cbf)), closes [#10965](https://github.com/vuetifyjs/vuetify/issues/10965)
* **VTextField:** hide-details auto animation ([#12554](https://github.com/vuetifyjs/vuetify/issues/12554)) ([07ef4e1](https://github.com/vuetifyjs/vuetify/commit/07ef4e1b98e9f47e6320a6f44a8e53d4704fe176))
* **VTextField:** legend position not aligned with reverse prop ([#13051](https://github.com/vuetifyjs/vuetify/issues/13051)) ([9e93f7d](https://github.com/vuetifyjs/vuetify/commit/9e93f7de116625c4821d2be35588d8b05e50973e)), closes [#10798](https://github.com/vuetifyjs/vuetify/issues/10798)
* **VTimePickerClock:** race condition between event and $refs ([#13648](https://github.com/vuetifyjs/vuetify/issues/13648)) ([a536e15](https://github.com/vuetifyjs/vuetify/commit/a536e15eb649f8ec19dd65d6228ccc2a18b6987f))
* **VTooltip:** don't add role:button to activator ([#12428](https://github.com/vuetifyjs/vuetify/issues/12428)) ([ec15822](https://github.com/vuetifyjs/vuetify/commit/ec158223e4be38a8eff1a0cc04f96dee29fd72e4)), closes [#12360](https://github.com/vuetifyjs/vuetify/issues/12360)
* **VTooltip:** lazy without transition ([2e55652](https://github.com/vuetifyjs/vuetify/commit/2e556524435bde7bd5a0ac7adb01bbe9411f9892))
* **VTreeview:** disabled items should be ignored when selecting parent ([#11232](https://github.com/vuetifyjs/vuetify/issues/11232)) ([3184f7e](https://github.com/vuetifyjs/vuetify/commit/3184f7e4a9706ae244da98cba03936bc9e526fff)), closes [#8244](https://github.com/vuetifyjs/vuetify/issues/8244)
* **VTreeview:** do not set indeterminate on new leafs ([adbb374](https://github.com/vuetifyjs/vuetify/commit/adbb3746b5775d6d954c8573350afc0b7c688409)), closes [#8256](https://github.com/vuetifyjs/vuetify/issues/8256)
* **VTreeview:** emit opened nodes when using load-children ([#11339](https://github.com/vuetifyjs/vuetify/issues/11339)) ([4a0916f](https://github.com/vuetifyjs/vuetify/commit/4a0916f34892b7001095545e785932b71afc8b2c)), closes [#9693](https://github.com/vuetifyjs/vuetify/issues/9693)
* **VTreeview:** incorrect alignment of nodes ([#9640](https://github.com/vuetifyjs/vuetify/issues/9640)) ([6e368ed](https://github.com/vuetifyjs/vuetify/commit/6e368edf57455d20a0d8c19945ee831bb9b24ca8)), closes [#8212](https://github.com/vuetifyjs/vuetify/issues/8212)
* **VTreeview:** independent children should be selectable when parent is disabled ([#11233](https://github.com/vuetifyjs/vuetify/issues/11233)) ([06a7af3](https://github.com/vuetifyjs/vuetify/commit/06a7af374f6eddcca12a170b2ba2852712fc0979)), closes [#10770](https://github.com/vuetifyjs/vuetify/issues/10770) [#10990](https://github.com/vuetifyjs/vuetify/issues/10990)
* **VTreeview:** load initial selection when using return-object ([#9633](https://github.com/vuetifyjs/vuetify/issues/9633)) ([9b20cd5](https://github.com/vuetifyjs/vuetify/commit/9b20cd5a037f986ac869308b1cd267c557757c37)), closes [#8709](https://github.com/vuetifyjs/vuetify/issues/8709)
* **VTreeview:** respect selection-type when rebuilding tree ([#10653](https://github.com/vuetifyjs/vuetify/issues/10653)) ([10087bb](https://github.com/vuetifyjs/vuetify/commit/10087bbe11cb4d4a89a5bb9b62ee001aad607e66)), closes [#8720](https://github.com/vuetifyjs/vuetify/issues/8720)
* **VTreeview.sass:** center vertically treeview items on IE11 ([#10816](https://github.com/vuetifyjs/vuetify/issues/10816)) ([f39a93d](https://github.com/vuetifyjs/vuetify/commit/f39a93d019abf9b4ba8968120e2d0d07ce1f94d1)), closes [#10534](https://github.com/vuetifyjs/vuetify/issues/10534)
* **VVirtualScroll:** re-calculate scroll area when height changes ([e601345](https://github.com/vuetifyjs/vuetify/commit/e601345f5ddcab0198958f724fd9b05cf13a327e)), closes [#11665](https://github.com/vuetifyjs/vuetify/issues/11665)
* **VVirtualScroller:** properly key children to avoid re-render ([#11327](https://github.com/vuetifyjs/vuetify/issues/11327)) ([14ce2f1](https://github.com/vuetifyjs/vuetify/commit/14ce2f15f53fbd0d44d7ac47e6e1a46712101ced))
* **VWindow:** apply correct transition when using the reverse prop ([51d61d2](https://github.com/vuetifyjs/vuetify/commit/51d61d27d09f8534979c97236f052a6408abd2d0)), closes [#10182](https://github.com/vuetifyjs/vuetify/issues/10182)
* **VWindow:** fix wrong reverse animation logic for only 2 items ([#12685](https://github.com/vuetifyjs/vuetify/issues/12685)) ([be00b92](https://github.com/vuetifyjs/vuetify/commit/be00b92cf61cf6f177edd72dcdf2fe9b9a79b904)), closes [#12672](https://github.com/vuetifyjs/vuetify/issues/12672)
* **VWindow:** transition in RTL mode ([#9464](https://github.com/vuetifyjs/vuetify/issues/9464)) ([90b5f3d](https://github.com/vuetifyjs/vuetify/commit/90b5f3d4e0eb075968b6522c8b2136a169e46d5b))
* **VWindow:** transition snap with different content height ([#13611](https://github.com/vuetifyjs/vuetify/issues/13611)) ([4a0d349](https://github.com/vuetifyjs/vuetify/commit/4a0d3498ad5c44cb085180ed9dcaa92ef82ad1ae)), closes [#13360](https://github.com/vuetifyjs/vuetify/issues/13360)
* add missing ltr() rules ([#9649](https://github.com/vuetifyjs/vuetify/issues/9649)) ([8f772a7](https://github.com/vuetifyjs/vuetify/commit/8f772a78ecae407f1038095aa01e055a65ed8f2e)), closes [#7586](https://github.com/vuetifyjs/vuetify/issues/7586)
* don't use nativeOn on native elements ([#11228](https://github.com/vuetifyjs/vuetify/issues/11228)) ([6168845](https://github.com/vuetifyjs/vuetify/commit/61688457776c30a69882ba5a76f989181d707a03)), closes [#9999](https://github.com/vuetifyjs/vuetify/issues/9999)
* **#6962:** Fix race conditions in VWindowItem.ts during transition. ([#8205](https://github.com/vuetifyjs/vuetify/issues/8205)) ([1523cf6](https://github.com/vuetifyjs/vuetify/commit/1523cf68f3d9a0decb058392bbb3ffca04c8b981)), closes [#6962](https://github.com/vuetifyjs/vuetify/issues/6962)
* **bind-attrs:** fix transition-group animation ([#9224](https://github.com/vuetifyjs/vuetify/issues/9224)) ([356034a](https://github.com/vuetifyjs/vuetify/commit/356034ad8862512576b64c662b68420f6583f462)), closes [#9171](https://github.com/vuetifyjs/vuetify/issues/9171)
* **breakpoint:** allow 0 value for scrollBarWidth ([#9401](https://github.com/vuetifyjs/vuetify/issues/9401)) ([a169612](https://github.com/vuetifyjs/vuetify/commit/a1696123089bd7c278fd6f3f2ce13e696c6ec3d4))
* **detachable:** detach when lazy and inititally open ([19bf5d3](https://github.com/vuetifyjs/vuetify/commit/19bf5d319bf810a5ca97efef84e90df01dfd9edb)), closes [#9175](https://github.com/vuetifyjs/vuetify/issues/9175)
* **docs:** remove gutters from nav drawers ([#9567](https://github.com/vuetifyjs/vuetify/issues/9567)) ([6f9b2f8](https://github.com/vuetifyjs/vuetify/commit/6f9b2f8d8831979798cf988b0218be5318007ab3))
* **goTo:** get clientHeight from <html> when target is <body> ([854c826](https://github.com/vuetifyjs/vuetify/commit/854c8265af5970c38d8809804d9aad708593b219)), closes [#6914](https://github.com/vuetifyjs/vuetify/issues/6914)
* **goTo:** goTo scrolls to container top ([#8687](https://github.com/vuetifyjs/vuetify/issues/8687)) ([e520433](https://github.com/vuetifyjs/vuetify/commit/e5204338def6720b6870724e89d47dc995a06030)), closes [#8662](https://github.com/vuetifyjs/vuetify/issues/8662) [#6933](https://github.com/vuetifyjs/vuetify/issues/6933)
* **grid:** allow binding style strings ([3279945](https://github.com/vuetifyjs/vuetify/commit/327994562f1aa67e931f8372aacbeb2ad469e750)), closes [#8328](https://github.com/vuetifyjs/vuetify/issues/8328)
* **icons:** use correct fa4 radioOn icon ([d14dcc9](https://github.com/vuetifyjs/vuetify/commit/d14dcc90c7d4d3878fb7ca8083b94ede37a80e12)), closes [#8201](https://github.com/vuetifyjs/vuetify/issues/8201)
* **locale:** add missing Italian translations ([#9022](https://github.com/vuetifyjs/vuetify/issues/9022)) ([2d51ae1](https://github.com/vuetifyjs/vuetify/commit/2d51ae1011812996bc7f2525f25b3b59e8fa12c9))
* **locale:** complete hebrew translation ([e711fbf](https://github.com/vuetifyjs/vuetify/commit/e711fbfeb658570b85c1a1662b4df1bb7556f452))
* **locale:** fix ko translation of noDataText ([#9305](https://github.com/vuetifyjs/vuetify/issues/9305)) ([058b1fe](https://github.com/vuetifyjs/vuetify/commit/058b1fe857d3aab1dbdb2143a69e66b9435dc1e9))
* **locale:** update japanese translation ([#9238](https://github.com/vuetifyjs/vuetify/issues/9238)) ([d7b8e5a](https://github.com/vuetifyjs/vuetify/commit/d7b8e5a3e87700601c4f2446f49dfb04c8125f69))
* **locale:** update Portuguese translation ([#9683](https://github.com/vuetifyjs/vuetify/issues/9683)) ([dd3acaf](https://github.com/vuetifyjs/vuetify/commit/dd3acaf51d3a7193099d49b1de7f822226931e9b))
* **locale:** update Russian translation ([#9563](https://github.com/vuetifyjs/vuetify/issues/9563)) ([bbae296](https://github.com/vuetifyjs/vuetify/commit/bbae2961810fa59c765bb5285d4f5808fa83a001))
* **locale:** update Thai translation. ([#9292](https://github.com/vuetifyjs/vuetify/issues/9292)) ([5d5241c](https://github.com/vuetifyjs/vuetify/commit/5d5241cc84bda46feedc8894a28a27151851cc15))
* **locale:** update Turkish translations ([#9183](https://github.com/vuetifyjs/vuetify/issues/9183)) ([72959c4](https://github.com/vuetifyjs/vuetify/commit/72959c4375044436712b7abe79bbb5a47d25c471))
* **locale:** update Ukrainian translation ([#9562](https://github.com/vuetifyjs/vuetify/issues/9562)) ([ddb90b1](https://github.com/vuetifyjs/vuetify/commit/ddb90b1c0654f6142773e428391926e86ebc2ef6))
* **overlayable:** get root element's z-index if activeIndex is not available ([db84347](https://github.com/vuetifyjs/vuetify/commit/db84347f242fe73288b72c7e72a1af04b09c9434)), closes [#8473](https://github.com/vuetifyjs/vuetify/issues/8473)
* **perf:** avoid useless re-render on parent update ([#8822](https://github.com/vuetifyjs/vuetify/issues/8822)) ([1017af7](https://github.com/vuetifyjs/vuetify/commit/1017af711c32610b360ec8ba3c1fd3b075d1fb79)), closes [#6201](https://github.com/vuetifyjs/vuetify/issues/6201) [vuejs/vue#7257](https://github.com/vuejs/vue/issues/7257) [vuejs/vue#10115](https://github.com/vuejs/vue/issues/10115) [vuejs/vue-test-utils#1130](https://github.com/vuejs/vue-test-utils/issues/1130)
* **SelectionControls:** better scope css selector for input ([d7d1ae3](https://github.com/vuetifyjs/vuetify/commit/d7d1ae30fc009b5d7e783c093c74cf7d589df0ad)), closes [#8523](https://github.com/vuetifyjs/vuetify/issues/8523)
* **SelectionControls:** fix dense styles ([#9505](https://github.com/vuetifyjs/vuetify/issues/9505)) ([1279c52](https://github.com/vuetifyjs/vuetify/commit/1279c52d837bc027896edff21e23fe1824eb9a97)), closes [#9381](https://github.com/vuetifyjs/vuetify/issues/9381)
* **sortItems:** continue to next sorter if custom sorter returns 0 ([#8433](https://github.com/vuetifyjs/vuetify/issues/8433)) ([620d87a](https://github.com/vuetifyjs/vuetify/commit/620d87a4c3f2c5855fa4d39c8974caf227347ca0)), closes [#8408](https://github.com/vuetifyjs/vuetify/issues/8408)
* **style:** bring back .v-application scope to utility classes ([#7921](https://github.com/vuetifyjs/vuetify/issues/7921)) ([bf15ab7](https://github.com/vuetifyjs/vuetify/commit/bf15ab75579a225fe6aa20c5555b17509f25cb7b))
* **styles:** add missing text-start and text-end classes ([#7958](https://github.com/vuetifyjs/vuetify/issues/7958)) ([8865c9a](https://github.com/vuetifyjs/vuetify/commit/8865c9a4d8d59090bc73911560be4108cd47a606))
* **theme:** fix vue-meta theme on page navigation ([#8234](https://github.com/vuetifyjs/vuetify/issues/8234)) ([9324ec7](https://github.com/vuetifyjs/vuetify/commit/9324ec7be5f137e4ea3a547010d674728d399229)), closes [#7879](https://github.com/vuetifyjs/vuetify/issues/7879)
* **Theme:** fix issues for spa with vue-meta ([#8566](https://github.com/vuetifyjs/vuetify/issues/8566)) ([1386cbb](https://github.com/vuetifyjs/vuetify/commit/1386cbb1b69808829c6fb97e0f2db3735a2cfd58))
* **Theme:** fix theme issue when using Vue Meta without SSR  ([#8079](https://github.com/vuetifyjs/vuetify/issues/8079)) ([681051d](https://github.com/vuetifyjs/vuetify/commit/681051dcaad24f2f6db83bd4c9c7bdc0bff17a95))
* **transitions:** correctly merge event listeners ([ad1f6ce](https://github.com/vuetifyjs/vuetify/commit/ad1f6ce8cf5261b60665222b2854615bcef7c2f3)), closes [#9691](https://github.com/vuetifyjs/vuetify/issues/9691)
* **transitions:** on.leave can be undefined ([3098590](https://github.com/vuetifyjs/vuetify/commit/3098590335e594a2c174be519799c952784fc87a))
* **types:** add missing component declarations ([#9652](https://github.com/vuetifyjs/vuetify/issues/9652)) ([50e66da](https://github.com/vuetifyjs/vuetify/commit/50e66daa39e3fe2fcb2da1af59406c123097c16d)), closes [#9364](https://github.com/vuetifyjs/vuetify/issues/9364)
* **types:** avoid importing from src, update for v2 ([#7878](https://github.com/vuetifyjs/vuetify/issues/7878)) ([64056b4](https://github.com/vuetifyjs/vuetify/commit/64056b45fedb8781c9415812117923b0c83f505b)), closes [#7040](https://github.com/vuetifyjs/vuetify/issues/7040) [#7387](https://github.com/vuetifyjs/vuetify/issues/7387) [#7964](https://github.com/vuetifyjs/vuetify/issues/7964)
* **types:** fix lang option name in preset ([#9169](https://github.com/vuetifyjs/vuetify/issues/9169)) ([06d17cf](https://github.com/vuetifyjs/vuetify/commit/06d17cfdf73eeb54c92e124e8e6473036c5a81bb))
* **types:** missing currentTheme in Theme interface ([#9697](https://github.com/vuetifyjs/vuetify/issues/9697)) ([b7701dc](https://github.com/vuetifyjs/vuetify/commit/b7701dc632d6f5798c325946f0c3ce763055816d)), closes [#9546](https://github.com/vuetifyjs/vuetify/issues/9546)
* **types:** missing VCardSubtitle declaration ([2a3d380](https://github.com/vuetifyjs/vuetify/commit/2a3d3802e50fb8c9bc428226f7d21b0c482b95f9))
* **types:** remove VToolbarSideIcon ([#7949](https://github.com/vuetifyjs/vuetify/issues/7949)) ([244cd64](https://github.com/vuetifyjs/vuetify/commit/244cd6437c5336e5953fb1f6a35cc2c4a120c30c))
* **Typescript:** update declaration file ([#9320](https://github.com/vuetifyjs/vuetify/issues/9320)) ([886c8a3](https://github.com/vuetifyjs/vuetify/commit/886c8a3aa280786c1f26a6ce58db3ab4872063c7))
* **VAlert:** adjust dimissible btn margins, decrease size ([d3bfccb](https://github.com/vuetifyjs/vuetify/commit/d3bfccbae23c1f3f420c3eba2529c30e95da4b4f))
* **VAlert:** only apply border radius when not using tile prop ([eefa18c](https://github.com/vuetifyjs/vuetify/commit/eefa18c28b5fe9ac4e5b40fc6c23b88935645fbb))
* **VAlert:** properly inherit/pass down border-radius ([7800d56](https://github.com/vuetifyjs/vuetify/commit/7800d5693bdb78b483fcd82abd5be44ad36b17c7))
* **VAppBar:** avoid screen jump when using scrollbar techniques ([899c75d](https://github.com/vuetifyjs/vuetify/commit/899c75d1bf0d88faddc2afc1f3726e8357b03914))
* **VAppBar:** fix elevation issue when extended ([#8519](https://github.com/vuetifyjs/vuetify/issues/8519)) ([f676454](https://github.com/vuetifyjs/vuetify/commit/f67645489bb2e8a21b37c5b9ea595348ce17d451)), closes [#8516](https://github.com/vuetifyjs/vuetify/issues/8516)
* **VAppBar:** v-model control when using elevate-on-scroll ([#8584](https://github.com/vuetifyjs/vuetify/issues/8584)) ([74b3270](https://github.com/vuetifyjs/vuetify/commit/74b32702de6eedc1442ef348f7d8ae7a79d78315)), closes [#8583](https://github.com/vuetifyjs/vuetify/issues/8583)
* **VAppBar/VToolbar:** use max-width to avoid overflow ([9cc7546](https://github.com/vuetifyjs/vuetify/commit/9cc7546e5a092e1c11005e41d4451ac903010381)), closes [#8364](https://github.com/vuetifyjs/vuetify/issues/8364)
* **VAutocomplete:** default broswer autocomplete to disabled ([3387708](https://github.com/vuetifyjs/vuetify/commit/3387708182ea6e2b7a39e5d9fe90bc14e201c80f))
* **VAutocomplete:** disable browser autocomplete by default ([#9246](https://github.com/vuetifyjs/vuetify/issues/9246)) ([c01f564](https://github.com/vuetifyjs/vuetify/commit/c01f564d7e03161911cad28257de122e2b59b04f)), closes [#8395](https://github.com/vuetifyjs/vuetify/issues/8395)
* **VAutocomplete:** move eventlisteners to focus watcher ([#9273](https://github.com/vuetifyjs/vuetify/issues/9273)) ([6d77ea0](https://github.com/vuetifyjs/vuetify/commit/6d77ea0333076ec578f4c8d488c8653844e86c94)), closes [#9204](https://github.com/vuetifyjs/vuetify/issues/9204)
* **VAutocomplete/VCombobox:** reset search when selecting same item ([eab8d32](https://github.com/vuetifyjs/vuetify/commit/eab8d329c33bf9eb8c22b1038e614c105c7b05d9)), closes [#7259](https://github.com/vuetifyjs/vuetify/issues/7259)
* **VAvatar:** force v-img to inherit avatar height/width ([de68a07](https://github.com/vuetifyjs/vuetify/commit/de68a070dadd12c54b20d8d0822820c4f7ca7e32)), closes [#8056](https://github.com/vuetifyjs/vuetify/issues/8056)
* **VBottomNavigation:** increase specificity of **v-bottom-navigation** styles ([#8073](https://github.com/vuetifyjs/vuetify/issues/8073)) ([0ffc14c](https://github.com/vuetifyjs/vuetify/commit/0ffc14c27432bddd37ce1a5774b0aa712b119e01)), closes [#7998](https://github.com/vuetifyjs/vuetify/issues/7998)
* **VBtn:** correct font-size for different VBtn sizes ([#8385](https://github.com/vuetifyjs/vuetify/issues/8385)) ([c67b666](https://github.com/vuetifyjs/vuetify/commit/c67b666417347baa94837f4a775385fc222d26ff)), closes [#8358](https://github.com/vuetifyjs/vuetify/issues/8358)
* **VBtn:** correct larger size button font-size ([d775278](https://github.com/vuetifyjs/vuetify/commit/d7752786ac9d62867c60aff7b0ffe011afa3f608))
* **VBtn:** keep border of outlined button when focused ([cad50e2](https://github.com/vuetifyjs/vuetify/commit/cad50e2c247e2b6b36f0175911d57c9b45573897)), closes [#9603](https://github.com/vuetifyjs/vuetify/issues/9603)
* **VBtn:** re-add support for non-fab absolutely positioned buttons ([23c8518](https://github.com/vuetifyjs/vuetify/commit/23c8518650950ceb5d4710ad17d8579b2844e948)), closes [#7948](https://github.com/vuetifyjs/vuetify/issues/7948)
* **VBtn/VToolbar:** better scope default v-btn size ([c3812fa](https://github.com/vuetifyjs/vuetify/commit/c3812fa7c576dae21eca8d995ec13a49dfcaa91a)), closes [#8035](https://github.com/vuetifyjs/vuetify/issues/8035)
* **VBtnToggle:** allow individual v-btn color override ([#9250](https://github.com/vuetifyjs/vuetify/issues/9250)) ([9fc9393](https://github.com/vuetifyjs/vuetify/commit/9fc9393796691209aa85f462f0cc9b787c51ac7d)), closes [#9226](https://github.com/vuetifyjs/vuetify/issues/9226)
* **VBtnToggle :** fix borders between buttons ([#8024](https://github.com/vuetifyjs/vuetify/issues/8024)) ([4934e1e](https://github.com/vuetifyjs/vuetify/commit/4934e1e81cb8ade83e0bdeb635692221e7b7b22c))
* **VCalendar:** end date and ripple errors ([#8189](https://github.com/vuetifyjs/vuetify/issues/8189)) ([bd793e9](https://github.com/vuetifyjs/vuetify/commit/bd793e9f8228a949f1678e913fd52dc8105e007a)), closes [#8096](https://github.com/vuetifyjs/vuetify/issues/8096) [#8175](https://github.com/vuetifyjs/vuetify/issues/8175)
* **VCalendar:** fix event-more labels in month view ([#8866](https://github.com/vuetifyjs/vuetify/issues/8866)) ([9eb7ddb](https://github.com/vuetifyjs/vuetify/commit/9eb7ddb8bba216308ae23b28f3c080a613836cdd)), closes [#8263](https://github.com/vuetifyjs/vuetify/issues/8263)
* **VCalendar:** fixed day width in month view on Firefox ([#9092](https://github.com/vuetifyjs/vuetify/issues/9092)) ([5ff3941](https://github.com/vuetifyjs/vuetify/commit/5ff3941c71b69f578b9bc51889be63f3edd7646c)), closes [#9058](https://github.com/vuetifyjs/vuetify/issues/9058)
* **VCalendar:** proper week height in month view on Firefox ([#8932](https://github.com/vuetifyjs/vuetify/issues/8932)) ([2faacd9](https://github.com/vuetifyjs/vuetify/commit/2faacd948a056e4d50e349beac0d648d9e55b4e2)), closes [#8319](https://github.com/vuetifyjs/vuetify/issues/8319)
* **VCalendar:** timed event sorting ([#7806](https://github.com/vuetifyjs/vuetify/issues/7806)) ([e38a763](https://github.com/vuetifyjs/vuetify/commit/e38a763a0fa7535d6d0c4e69443b42a17247b4fe)), closes [#7777](https://github.com/vuetifyjs/vuetify/issues/7777) [#7777](https://github.com/vuetifyjs/vuetify/issues/7777)
* **VCard:** properly break words in titles and text ([81af19d](https://github.com/vuetifyjs/vuetify/commit/81af19dbd46aa34d017a292f89bc7d91b19bf9ee)), closes [#8513](https://github.com/vuetifyjs/vuetify/issues/8513) [#8333](https://github.com/vuetifyjs/vuetify/issues/8333)
* **VCard:** properly remove border radius with **tile** prop ([3905b28](https://github.com/vuetifyjs/vuetify/commit/3905b288f0af40bb496b0f9711172af467515cbc))
* **VCardActions:** update icon boundary when using v-btn in v-card-actions ([6517b58](https://github.com/vuetifyjs/vuetify/commit/6517b5839d9be4ae30cfbe5d6e1a7f63b68d9796)), closes [#8042](https://github.com/vuetifyjs/vuetify/issues/8042)
* **VCarousel:** always respect original internal height ([#8838](https://github.com/vuetifyjs/vuetify/issues/8838)) ([21afb13](https://github.com/vuetifyjs/vuetify/commit/21afb13a7c772e12195661b77df9b4f18979b023))
* **VCarousel:** avoid resetting group internal height on change ([2246337](https://github.com/vuetifyjs/vuetify/commit/2246337cbcf64a5b13b26c33f18727c531a4bb30))
* **VCarousel:** correct prev/next buttons size ([#8122](https://github.com/vuetifyjs/vuetify/issues/8122)) ([823cb2c](https://github.com/vuetifyjs/vuetify/commit/823cb2c6fb0b78b4e3e1a14a2a14911b91ea3358))
* **VCarousel:** pass mandatory prop to the delimiters ([#8639](https://github.com/vuetifyjs/vuetify/issues/8639)) ([6c086cb](https://github.com/vuetifyjs/vuetify/commit/6c086cbf9b990a750f482fcfd13c4ad905434fce)), closes [#8273](https://github.com/vuetifyjs/vuetify/issues/8273)
* **VCarouselItem:** pass through placeholder slot ([56edbdc](https://github.com/vuetifyjs/vuetify/commit/56edbdcea5678f71f25cdbd7233f540013a651ce)), closes [#8452](https://github.com/vuetifyjs/vuetify/issues/8452)
* **VCheckbox:** use correct unchecked checkbox icon using FA4 ([75280f0](https://github.com/vuetifyjs/vuetify/commit/75280f02cee75d0b1de67dd335856ad0e24f8f30)), closes [#8998](https://github.com/vuetifyjs/vuetify/issues/8998)
* **VCheckbox:** wait for dom to process before changing indeterminate state ([7080ed4](https://github.com/vuetifyjs/vuetify/commit/7080ed41f17ba535962bce6a92a30f16b17f60bc)), closes [#8270](https://github.com/vuetifyjs/vuetify/issues/8270)
* **VColorPicker:** allow null as initial value ([#9616](https://github.com/vuetifyjs/vuetify/issues/9616)) ([2246e6b](https://github.com/vuetifyjs/vuetify/commit/2246e6b00808e14bd0f69bbe8fa244e0308aff61)), closes [#9472](https://github.com/vuetifyjs/vuetify/issues/9472)
* **VCombobox:** compare vs null/undefined as opposed to falsey in selectItem ([f53cb81](https://github.com/vuetifyjs/vuetify/commit/f53cb81bc3e586ae813b66d8e5d31305e52fcc0c)), closes [#8476](https://github.com/vuetifyjs/vuetify/issues/8476)
* **VComboBox:** disallow items editing when readonly ([#9429](https://github.com/vuetifyjs/vuetify/issues/9429)) ([22d1bd7](https://github.com/vuetifyjs/vuetify/commit/22d1bd7350a169cc4beaca2ca0b39d0902e23a99)), closes [#8867](https://github.com/vuetifyjs/vuetify/issues/8867)
* **VContainer:** import new grid styles ([0315233](https://github.com/vuetifyjs/vuetify/commit/031523394ea867c745ae193e0a20e92992c3288a)), closes [#7978](https://github.com/vuetifyjs/vuetify/issues/7978)
* **VContainer:** propagate id ([4d575f8](https://github.com/vuetifyjs/vuetify/commit/4d575f82cb09fe3c2acf4f7481924fe20d7b44d2)), closes [#7919](https://github.com/vuetifyjs/vuetify/issues/7919)
* **VContainer:** reduce max width on breakpoints ([84b39d3](https://github.com/vuetifyjs/vuetify/commit/84b39d313c4c3fef89c42d59b154ebf2d900cdc2)), closes [#8517](https://github.com/vuetifyjs/vuetify/issues/8517)
* **VDataFooter:** better handle custom item options ([#8029](https://github.com/vuetifyjs/vuetify/issues/8029)) ([8b7a25b](https://github.com/vuetifyjs/vuetify/commit/8b7a25b3a838d038a64ff6923d34d68d797927ff)), closes [#8026](https://github.com/vuetifyjs/vuetify/issues/8026)
* **VDataFooter:** disable last page button if there's no items ([#8590](https://github.com/vuetifyjs/vuetify/issues/8590)) ([2277942](https://github.com/vuetifyjs/vuetify/commit/2277942577687a3bea0ac8fa8874ac2877f3ab16)), closes [#8577](https://github.com/vuetifyjs/vuetify/issues/8577)
* **VDataTable:** allow custom header icons ([#7918](https://github.com/vuetifyjs/vuetify/issues/7918)) ([e6c448f](https://github.com/vuetifyjs/vuetify/commit/e6c448f51bb7712f90a9284f68c20b8cf014fe6f)), closes [#7647](https://github.com/vuetifyjs/vuetify/issues/7647)
* **VDataTable:** center and disabled no-data/no-results text ([#8106](https://github.com/vuetifyjs/vuetify/issues/8106)) ([63d3e00](https://github.com/vuetifyjs/vuetify/commit/63d3e00f1e5073165d214380238b24ea281cce0b)), closes [#8102](https://github.com/vuetifyjs/vuetify/issues/8102)
* **VDataTable:** change page when items length decreases ([#9634](https://github.com/vuetifyjs/vuetify/issues/9634)) ([18365e0](https://github.com/vuetifyjs/vuetify/commit/18365e086b17a4954a0b9513438e548082faf908)), closes [#9010](https://github.com/vuetifyjs/vuetify/issues/9010)
* **VDataTable:** default to first itemsPerPage option ([#8578](https://github.com/vuetifyjs/vuetify/issues/8578)) ([cb045a2](https://github.com/vuetifyjs/vuetify/commit/cb045a2736541eacd2c6745e95106293e462d642)), closes [#8184](https://github.com/vuetifyjs/vuetify/issues/8184)
* **VDataTable:** detect changes in options prop ([#8719](https://github.com/vuetifyjs/vuetify/issues/8719)) ([df9e3ff](https://github.com/vuetifyjs/vuetify/commit/df9e3ffd82c943a3c96f422a3b44b30f2bea469e)), closes [#8707](https://github.com/vuetifyjs/vuetify/issues/8707)
* **VDataTable:** display non-string item values ([#8562](https://github.com/vuetifyjs/vuetify/issues/8562)) ([c3789d9](https://github.com/vuetifyjs/vuetify/commit/c3789d92b102fd02d6687a4d1c279d69a648263a)), closes [#8554](https://github.com/vuetifyjs/vuetify/issues/8554)
* **VDataTable:** fixed table row classes ([#8443](https://github.com/vuetifyjs/vuetify/issues/8443)) ([7c875d8](https://github.com/vuetifyjs/vuetify/commit/7c875d8cb272f5ed5feec79f73763da234407709)), closes [#8368](https://github.com/vuetifyjs/vuetify/issues/8368)
* **VDataTable:** footer.page-text slot not being used ([#8509](https://github.com/vuetifyjs/vuetify/issues/8509)) ([5f33175](https://github.com/vuetifyjs/vuetify/commit/5f3317577e509232242dc323f230a3ea27ce7a81)), closes [#8120](https://github.com/vuetifyjs/vuetify/issues/8120)
* **VDataTable:** handle items-per-page-options with objects ([#8819](https://github.com/vuetifyjs/vuetify/issues/8819)) ([81703af](https://github.com/vuetifyjs/vuetify/commit/81703af758385e28228c2e12007cdce16dfb1ed0)), closes [#8817](https://github.com/vuetifyjs/vuetify/issues/8817)
* **VDataTable:** hide items-per-page select if only one value ([#8598](https://github.com/vuetifyjs/vuetify/issues/8598)) ([a05a0bb](https://github.com/vuetifyjs/vuetify/commit/a05a0bbaafd560c23cc7e503f2a5fc71773da77e)), closes [#8097](https://github.com/vuetifyjs/vuetify/issues/8097)
* **VDataTable:** items-per-page event should not emit immediately ([#9615](https://github.com/vuetifyjs/vuetify/issues/9615)) ([cbcd8e4](https://github.com/vuetifyjs/vuetify/commit/cbcd8e4dbde89b5252533c0b009500a37d58673c)), closes [#9599](https://github.com/vuetifyjs/vuetify/issues/9599)
* **VDataTable:** mismatch of nodes when using ssr ([#8508](https://github.com/vuetifyjs/vuetify/issues/8508)) ([82a369c](https://github.com/vuetifyjs/vuetify/commit/82a369cfd68b88867db3b0e67d0bc8af2ff3312f)), closes [#7410](https://github.com/vuetifyjs/vuetify/issues/7410)
* **VDataTable:** overlapping text in mobile rows ([#9639](https://github.com/vuetifyjs/vuetify/issues/9639)) ([0f84349](https://github.com/vuetifyjs/vuetify/commit/0f84349f4534406ed60d8e8af4772c0f381e077e)), closes [#8761](https://github.com/vuetifyjs/vuetify/issues/8761)
* **VDataTable:** page resets when server-items-length is zero ([#8594](https://github.com/vuetifyjs/vuetify/issues/8594)) ([39f9d8b](https://github.com/vuetifyjs/vuetify/commit/39f9d8b765bcdf071982959d6c0b37291ec6b31e)), closes [#8359](https://github.com/vuetifyjs/vuetify/issues/8359)
* **VDataTable:** properly display divider in headers ([#9635](https://github.com/vuetifyjs/vuetify/issues/9635)) ([b43716c](https://github.com/vuetifyjs/vuetify/commit/b43716c0b3270327e0fb272df4bd780e6d924365)), closes [#8514](https://github.com/vuetifyjs/vuetify/issues/8514) [#7411](https://github.com/vuetifyjs/vuetify/issues/7411)
* **VDataTable:** revert to non locale sensitive number sort  ([a54a21d](https://github.com/vuetifyjs/vuetify/commit/a54a21d647e53e2edd31e2fdabc9bd84a89d91e6)), closes [#9515](https://github.com/vuetifyjs/vuetify/issues/9515)
* **VDataTable:** use convertToUnit in table header width styles ([#8592](https://github.com/vuetifyjs/vuetify/issues/8592)) ([4a52142](https://github.com/vuetifyjs/vuetify/commit/4a52142fd81f3c50ceb948ce5ba14a3d2ed25e32)), closes [#8591](https://github.com/vuetifyjs/vuetify/issues/8591)
* **VDataTable, VSimpleTable:** missing rtl styles, other minor tweaks ([#8200](https://github.com/vuetifyjs/vuetify/issues/8200)) ([5a45ecf](https://github.com/vuetifyjs/vuetify/commit/5a45ecf6833b381af90a3063c652da66ebd0c908))
* **VDataTableHeaderMobile:** don't show disabled header in sort select ([#8081](https://github.com/vuetifyjs/vuetify/issues/8081)) ([2666cca](https://github.com/vuetifyjs/vuetify/commit/2666cca410ca6745d212ed57badbc74e9b58875f)), closes [#8036](https://github.com/vuetifyjs/vuetify/issues/8036)
* **VDataTableHeaderMobile:** translate "Sort by" ([6c49128](https://github.com/vuetifyjs/vuetify/commit/6c491286b0bbda6d7b29334804094c2327071297)), closes [#8083](https://github.com/vuetifyjs/vuetify/issues/8083)
* **VDatePicker:** improve scroll position of years selector ([#8512](https://github.com/vuetifyjs/vuetify/issues/8512)) ([7fc73f6](https://github.com/vuetifyjs/vuetify/commit/7fc73f64b5c90688a7bd7d0480d7353c1d5b6a61))
* **VDialog:** animate click outside with persistent prop ([652ba11](https://github.com/vuetifyjs/vuetify/commit/652ba11e1c62742b0f433122bd726ace36ad2b4b))
* **VDialog:** check if element is already focused on focusin event ([fa0a893](https://github.com/vuetifyjs/vuetify/commit/fa0a8936be2411f0739259c7762fec350bd9e082)), closes [#8459](https://github.com/vuetifyjs/vuetify/issues/8459)
* **VDialog:** correct v-card-subtitle positioning ([a178ac1](https://github.com/vuetifyjs/vuetify/commit/a178ac175596ea53142675a7e7ebb232d3d7f218)), closes [#9468](https://github.com/vuetifyjs/vuetify/issues/9468)
* **VDialog:** dialog is not focusing on first open ([#8716](https://github.com/vuetifyjs/vuetify/issues/8716)) ([970ac5a](https://github.com/vuetifyjs/vuetify/commit/970ac5aee2404407a62ff1b6aa0c1f52e550e173)), closes [#8220](https://github.com/vuetifyjs/vuetify/issues/8220)
* **VDialog:** don't apply tabindex if dialog is not active ([#8717](https://github.com/vuetifyjs/vuetify/issues/8717)) ([d07e5f3](https://github.com/vuetifyjs/vuetify/commit/d07e5f33e96dc17f7020bd0ac1afcaa856642ceb))
* **VDialog:** fix dialog error when clicking on overlay ([#8246](https://github.com/vuetifyjs/vuetify/issues/8246)) ([400542f](https://github.com/vuetifyjs/vuetify/commit/400542f0833738bad5c7b8923c11ea91b75ce206)), closes [#8240](https://github.com/vuetifyjs/vuetify/issues/8240)
* **VDialog:** inherit listeners ([#8491](https://github.com/vuetifyjs/vuetify/issues/8491)) ([3c7092e](https://github.com/vuetifyjs/vuetify/commit/3c7092e9d643771ed268015b4954587e0156681b)), closes [#3358](https://github.com/vuetifyjs/vuetify/issues/3358)
* **VDialog:** make first child always span 100% width ([0e5a192](https://github.com/vuetifyjs/vuetify/commit/0e5a192e7c62c2bc6a57809d79a9f9bc9b4c7ea9)), closes [#7253](https://github.com/vuetifyjs/vuetify/issues/7253)
* **VDialog:** only emit click:outside once ([f11d845](https://github.com/vuetifyjs/vuetify/commit/f11d8454320a671392bf96c9076b2f39d29d11e6)), closes [#9682](https://github.com/vuetifyjs/vuetify/issues/9682)
* **VDialog/VMenu/VTooltip:** hide wrapper element when not attached ([#9163](https://github.com/vuetifyjs/vuetify/issues/9163)) ([5a100ac](https://github.com/vuetifyjs/vuetify/commit/5a100acdd8353a67d6fde5889ba1443b58bc8504)), closes [#6951](https://github.com/vuetifyjs/vuetify/issues/6951)
* **VDialog/VMenu/VTooltip:** make all activators inline elements ([b40fa43](https://github.com/vuetifyjs/vuetify/commit/b40fa4329a4cbc9f3b5de09cafb670640208f575)), closes [#6951](https://github.com/vuetifyjs/vuetify/issues/6951)
* **VExpansionPanels:** constrain content wrap to 100% width ([79d4512](https://github.com/vuetifyjs/vuetify/commit/79d4512df26c088e1a7de7aeb0e12945a773cf27)), closes [#8352](https://github.com/vuetifyjs/vuetify/issues/8352)
* **VExpansionPanels:** outer panels styles cascade to inner panels ([#9696](https://github.com/vuetifyjs/vuetify/issues/9696)) ([c27b42d](https://github.com/vuetifyjs/vuetify/commit/c27b42df445675c37964e023e9a4d3329a923f2a)), closes [#9692](https://github.com/vuetifyjs/vuetify/issues/9692)
* **VFileInput:** bug in Safari where file is not added ([#8498](https://github.com/vuetifyjs/vuetify/issues/8498)) ([0b4a970](https://github.com/vuetifyjs/vuetify/commit/0b4a9701f7d9d83e516e7836fc2f578ed5e18625)), closes [#7941](https://github.com/vuetifyjs/vuetify/issues/7941)
* **VFileInput:** fix rogue change events ([#8193](https://github.com/vuetifyjs/vuetify/issues/8193)) ([3568df3](https://github.com/vuetifyjs/vuetify/commit/3568df36a2bd88de054213e07ca06416ba701cad)), closes [#8167](https://github.com/vuetifyjs/vuetify/issues/8167)
* **VFileInput:** issues selecting files in ie/edge ([#8718](https://github.com/vuetifyjs/vuetify/issues/8718)) ([3ca386d](https://github.com/vuetifyjs/vuetify/commit/3ca386df5cbfd368e75629a8c6a90e418576bd97)), closes [#8693](https://github.com/vuetifyjs/vuetify/issues/8693)
* **VFileInput:** replace hardcoded string boundary with computed ([#9036](https://github.com/vuetifyjs/vuetify/issues/9036)) ([8ba982d](https://github.com/vuetifyjs/vuetify/commit/8ba982d529b032e75d462d786d18893dbf6fca95)), closes [#9026](https://github.com/vuetifyjs/vuetify/issues/9026)
* **VFileInput:** unindent input when icon is empty ([#8078](https://github.com/vuetifyjs/vuetify/issues/8078)) ([d1a67ab](https://github.com/vuetifyjs/vuetify/commit/d1a67abb3a6870af39ef2ec2cec1ee0be294635e)), closes [#8049](https://github.com/vuetifyjs/vuetify/issues/8049)
* **VForm:** apply grid-list-lg to nested containers ([d77f136](https://github.com/vuetifyjs/vuetify/commit/d77f1364565368ea96b01b4d8701262978ca4f06)), closes [#7891](https://github.com/vuetifyjs/vuetify/issues/7891)
* **VGrid:** add max-width for row in container and fill-height ([#9731](https://github.com/vuetifyjs/vuetify/issues/9731)) ([3b4d26c](https://github.com/vuetifyjs/vuetify/commit/3b4d26c93348ac286af91aeb6ee0ee1a30443857))
* **VIcon:** remove the ability for a user to select ([3ece815](https://github.com/vuetifyjs/vuetify/commit/3ece815c60683ab986bca4b16017f5722f00cd57)), closes [#8344](https://github.com/vuetifyjs/vuetify/issues/8344)
* **VImg:** properly update image on src change ([6eb5e6e](https://github.com/vuetifyjs/vuetify/commit/6eb5e6e2b2da7d0c8dbb7c61ae496967ed21514d)), closes [#9210](https://github.com/vuetifyjs/vuetify/issues/9210)
* **VImg:** remove observer once init ([1700d57](https://github.com/vuetifyjs/vuetify/commit/1700d5754ed27bbd7e9a1417be466d7872956eb4)), closes [#9490](https://github.com/vuetifyjs/vuetify/issues/9490)
* **VInput:** add role alert to success/error messages ([#8681](https://github.com/vuetifyjs/vuetify/issues/8681)) ([049fbf9](https://github.com/vuetifyjs/vuetify/commit/049fbf9036be4cce5ebf47b6d7c848e5a45f2126))
* **VList:** keep circular ripple on checkboxes in shaped list items ([f8f46d5](https://github.com/vuetifyjs/vuetify/commit/f8f46d57d6e3df7571345d3765005b2debe04ca9))
* **VList/VListGroup:** add missing rtl margins and paddings (v2.0) ([#7861](https://github.com/vuetifyjs/vuetify/issues/7861)) ([e1ba658](https://github.com/vuetifyjs/vuetify/commit/e1ba658ad836e1ff8ea676157d5e242668e63ff0)), closes [#8125](https://github.com/vuetifyjs/vuetify/issues/8125)
* **VListGroup:** adjust nested item padding only for nav/dense ([d98a227](https://github.com/vuetifyjs/vuetify/commit/d98a227321123fc283c0dcb6f7ddb6a48a97e72b))
* **VListGroup:** ensure append-icon is always vertically centered ([b1bdbad](https://github.com/vuetifyjs/vuetify/commit/b1bdbad929db8222b45a0881cd2afcf4835eb35e)), closes [#8340](https://github.com/vuetifyjs/vuetify/issues/8340)
* **VListGroup:** fade hover/focus effect when active ([a9283e7](https://github.com/vuetifyjs/vuetify/commit/a9283e76a17091c8860a6259ae6a1103ffbe6a31)), closes [#8115](https://github.com/vuetifyjs/vuetify/issues/8115)
* **VListGroup:** remove unnecessary css from header ([055c246](https://github.com/vuetifyjs/vuetify/commit/055c2465dd11740931e6993dbfa4b176cce0a6a1)), closes [#8222](https://github.com/vuetifyjs/vuetify/issues/8222)
* **VListItem:** add default active color ([#8327](https://github.com/vuetifyjs/vuetify/issues/8327)) ([#8694](https://github.com/vuetifyjs/vuetify/issues/8694)) ([e31b582](https://github.com/vuetifyjs/vuetify/commit/e31b58214cae5ae977ae29e6e33ff219ac398316))
* **VListItem:** change text color implementation ([d32c0fd](https://github.com/vuetifyjs/vuetify/commit/d32c0fd30721a8df46ae96b3a775f1f7772f1119)), closes [#8327](https://github.com/vuetifyjs/vuetify/issues/8327)
* **VListItem:** only apply role attribute when needed ([#9080](https://github.com/vuetifyjs/vuetify/issues/9080)) ([6e02c05](https://github.com/vuetifyjs/vuetify/commit/6e02c05747e53da29794ad62142c213fda13a56a)), closes [#9060](https://github.com/vuetifyjs/vuetify/issues/9060)
* **VMenu:** only use the activator slot in getActivator if it exists ([0c6175f](https://github.com/vuetifyjs/vuetify/commit/0c6175f9b27495fcc31595070efa04b7e530b9db))
* **VMenu:** prefer the activator slot over a click event ([baeb7ba](https://github.com/vuetifyjs/vuetify/commit/baeb7babbfc7571d5a5fe0200707ba70aee08a94)), closes [#6906](https://github.com/vuetifyjs/vuetify/issues/6906)
* **VMenu:** set border-radius to 4px for spec ([bf2cb0e](https://github.com/vuetifyjs/vuetify/commit/bf2cb0e97560dbdb8bdbf61ca6602e7367a66c43))
* **VMessages:** apply escapeHTML to provided values ([c0a81f1](https://github.com/vuetifyjs/vuetify/commit/c0a81f193743df261905a214de037ed1d183d9e4)), closes [#9491](https://github.com/vuetifyjs/vuetify/issues/9491)
* **VNavigationDrawer:** conditionally apply clipped z-index ([15e554d](https://github.com/vuetifyjs/vuetify/commit/15e554d4c3b5ab3a8987bdfce875627d51174b23))
* **VNavigationDrawer:** display overlay over app bar ([6255bf5](https://github.com/vuetifyjs/vuetify/commit/6255bf5001e0f67bf43aa3d9abf4320e75fe579c)), closes [#8040](https://github.com/vuetifyjs/vuetify/issues/8040)
* **VNavigationDrawer:** emit update:mini-variant event ([#8768](https://github.com/vuetifyjs/vuetify/issues/8768)) ([bfd80a7](https://github.com/vuetifyjs/vuetify/commit/bfd80a7fb02e5dffb50a525f9b478bf5de856870)), closes [#8133](https://github.com/vuetifyjs/vuetify/issues/8133)
* **VOverlay:** fix second dialog overlay animation problems ([#8490](https://github.com/vuetifyjs/vuetify/issues/8490)) ([82721b6](https://github.com/vuetifyjs/vuetify/commit/82721b6482718464d491e0e355fe8640f2351363)), closes [#2984](https://github.com/vuetifyjs/vuetify/issues/2984)
* **VPagination:** display length if maxButtons is less than 1 ([7f7391d](https://github.com/vuetifyjs/vuetify/commit/7f7391d76dc44f7f7d64f30ad7e0e429c85597c8)), closes [#8558](https://github.com/vuetifyjs/vuetify/issues/8558)
* **VProgressCircular:** center inner content vertically and horizontally ([4288072](https://github.com/vuetifyjs/vuetify/commit/4288072c1c6de1c912dfb2ae7f47103f4b5d6a20)), closes [#8232](https://github.com/vuetifyjs/vuetify/issues/8232)
* **VProgressLinear:** invalid background position in RTL mode ([#8421](https://github.com/vuetifyjs/vuetify/issues/8421)) ([a870dfa](https://github.com/vuetifyjs/vuetify/commit/a870dfa4b4669a38c01fff5e3317b16096dfa000)), closes [#8419](https://github.com/vuetifyjs/vuetify/issues/8419)
* **VProgressLinear:** make progress not overlapped by buffer ([b36e27f](https://github.com/vuetifyjs/vuetify/commit/b36e27f38f852bb505ee000e9dbd318d50e48839)), closes [#8114](https://github.com/vuetifyjs/vuetify/issues/8114)
* **VRangeSlider:** do not emit change twice if thumb was dragged ([6e4f083](https://github.com/vuetifyjs/vuetify/commit/6e4f0838cd84fae8b73dc974d8a74a17ab490548)), closes [#7915](https://github.com/vuetifyjs/vuetify/issues/7915)
* **VSelect:** remove reference to missing variable ([73e08a8](https://github.com/vuetifyjs/vuetify/commit/73e08a8ab3cf6547590d3ce0ac27e199190d6d17)), closes [#8417](https://github.com/vuetifyjs/vuetify/issues/8417)
* **VSelect/Autocomplete:** fix filled prop height with dense ([fd25779](https://github.com/vuetifyjs/vuetify/commit/fd257791adc1915f8a3d084d209d36de2e0e82fe))
* **VSelect/VChip:** improve chip overflow behavior inside of selects ([ccae369](https://github.com/vuetifyjs/vuetify/commit/ccae3697986040cc0f9eb76d64cd19f8e7fcedd3)), closes [#8797](https://github.com/vuetifyjs/vuetify/issues/8797) [#8642](https://github.com/vuetifyjs/vuetify/issues/8642)
* **VSheet:** add removed border-radius sass variable ([0949763](https://github.com/vuetifyjs/vuetify/commit/0949763c114dc589d6ac608f4f8c37813317f66f))
* **VSheet:** remove default transition, display and position ([fbcb008](https://github.com/vuetifyjs/vuetify/commit/fbcb00895d61a54979a28ef7995b344a4a39e43b)), closes [#8272](https://github.com/vuetifyjs/vuetify/issues/8272)
* **VSkeletonLoader:** avatar is not rounded ([#9708](https://github.com/vuetifyjs/vuetify/issues/9708)) ([5f073b5](https://github.com/vuetifyjs/vuetify/commit/5f073b582dacad401d43db71ab7e4f062a274208)), closes [#9447](https://github.com/vuetifyjs/vuetify/issues/9447)
* **VSlideGroup:** move tabs css for next/prev to slide-group ([5329514](https://github.com/vuetifyjs/vuetify/commit/5329514763e7fab11994c4303aa601346e17104c))
* **VSlider:** disable label in readonly slider ([#9709](https://github.com/vuetifyjs/vuetify/issues/9709)) ([89050b9](https://github.com/vuetifyjs/vuetify/commit/89050b9afd1edcb8a959f3623d7ffe6eef1d98af)), closes [#9660](https://github.com/vuetifyjs/vuetify/issues/9660)
* apply correct opacity for secondary text ([#9495](https://github.com/vuetifyjs/vuetify/issues/9495)) ([bdb9f0a](https://github.com/vuetifyjs/vuetify/commit/bdb9f0a441491c601717c89d1961b2a3927d00f4)), closes [#9366](https://github.com/vuetifyjs/vuetify/issues/9366)
* **activatable:** get activator element from event or nested component ([#9294](https://github.com/vuetifyjs/vuetify/issues/9294)) ([4b73dd2](https://github.com/vuetifyjs/vuetify/commit/4b73dd2889a7b9b34b141a70247dbf50f8a16ad7)), closes [#8846](https://github.com/vuetifyjs/vuetify/issues/8846)
* **locale:** update Norwegian translation ([#9455](https://github.com/vuetifyjs/vuetify/issues/9455)) ([051399a](https://github.com/vuetifyjs/vuetify/commit/051399ad187bee86c140924501baa7b2e9193577))
* **overlayable:** avoid overlay generation toggle if not active ([4c61674](https://github.com/vuetifyjs/vuetify/commit/4c616747b1142e2ad88a22994971ec5a27070f80)), closes [#8142](https://github.com/vuetifyjs/vuetify/issues/8142)
* **sass:** move global style imports to component variable files ([63f128f](https://github.com/vuetifyjs/vuetify/commit/63f128fb6315a5660a54dfed1fbbfe5b3f2b673d)), closes [#9323](https://github.com/vuetifyjs/vuetify/issues/9323)
* **theme:** use new vue-meta api ([#9268](https://github.com/vuetifyjs/vuetify/issues/9268)) ([6d829ef](https://github.com/vuetifyjs/vuetify/commit/6d829efff05ff6d491a719b21f3ea88f5ce1aeaf))
* **VAlert:** remove pointer events from psuedo element ([1958333](https://github.com/vuetifyjs/vuetify/commit/1958333d502848aac1f23d3499e2314da7e84f5b)), closes [#9407](https://github.com/vuetifyjs/vuetify/issues/9407)
* **VAlert:** typo in computedIcon ([#9390](https://github.com/vuetifyjs/vuetify/issues/9390)) ([15ba83b](https://github.com/vuetifyjs/vuetify/commit/15ba83bb6c81b683c7bc4d9092676da8d9a05faf)), closes [#9386](https://github.com/vuetifyjs/vuetify/issues/9386)
* **VAutocomplete:** avoid changing selected index if not using multiple ([8580c7b](https://github.com/vuetifyjs/vuetify/commit/8580c7bb59945158c1b9e8df7da6979a9a394fec))
* **VAutocomplete:** show selection color when navigating selection items ([9992116](https://github.com/vuetifyjs/vuetify/commit/9992116ac327cf67731760e4039202ae2611f999))
* **vcalendar:** escape html of event name ([#9387](https://github.com/vuetifyjs/vuetify/issues/9387)) ([283d601](https://github.com/vuetifyjs/vuetify/commit/283d601329281d6bde623634804359ade17efe0f))
* **VCard:** resolved clashing border-radius, adjust to match md2 spec ([0799040](https://github.com/vuetifyjs/vuetify/commit/079904031b93b17e7c6bcd2a14405bc2bf4e91a4))
* **VCarousel:** add missing aria-labels on delimiters ([#9332](https://github.com/vuetifyjs/vuetify/issues/9332)) ([bfd25af](https://github.com/vuetifyjs/vuetify/commit/bfd25af63d9d4aff837e9c3caba7733e408a8d3a)), closes [#7996](https://github.com/vuetifyjs/vuetify/issues/7996)
* **VContainer:** adjust container fill-height ([#9189](https://github.com/vuetifyjs/vuetify/issues/9189)) ([87e8a53](https://github.com/vuetifyjs/vuetify/commit/87e8a53741306867520a7c976f1522587d912e48)), closes [#8680](https://github.com/vuetifyjs/vuetify/issues/8680)
* **VDataTable:** add toggle and remove functions to group header slots ([#9236](https://github.com/vuetifyjs/vuetify/issues/9236)) ([f6abce8](https://github.com/vuetifyjs/vuetify/commit/f6abce837fbee31e28a704e75f2e312a2681194f))
* **VDataTable:** adjust filter & sort functions to use Intl.Collator ([#7805](https://github.com/vuetifyjs/vuetify/issues/7805)) ([43adae8](https://github.com/vuetifyjs/vuetify/commit/43adae8591f9b48b05c022e1f7c93abeddc76a4f)), closes [#3672](https://github.com/vuetifyjs/vuetify/issues/3672) [#4622](https://github.com/vuetifyjs/vuetify/issues/4622)
* **VDatePicker:** fix min date ([#9097](https://github.com/vuetifyjs/vuetify/issues/9097)) ([45c07c5](https://github.com/vuetifyjs/vuetify/commit/45c07c5fa93d1c96c6f75bd5fee16684254034dd)), closes [#9039](https://github.com/vuetifyjs/vuetify/issues/9039)
* **VDatePicker:** improve range performance ([#9128](https://github.com/vuetifyjs/vuetify/issues/9128)) ([349ae88](https://github.com/vuetifyjs/vuetify/commit/349ae88e64da48930197772be6fd37589004f479)), closes [#9120](https://github.com/vuetifyjs/vuetify/issues/9120)
* **vdialog:** fix close on outside click with persist and hide-overlay ([#9304](https://github.com/vuetifyjs/vuetify/issues/9304)) ([ba99a45](https://github.com/vuetifyjs/vuetify/commit/ba99a45ca7341bcc6802621e1fefe57a42a6ec96)), closes [#8697](https://github.com/vuetifyjs/vuetify/issues/8697) [#8697](https://github.com/vuetifyjs/vuetify/issues/8697)
* **VExpansionPanels:** stop parent active class propagation ([#9227](https://github.com/vuetifyjs/vuetify/issues/9227)) ([23fd69d](https://github.com/vuetifyjs/vuetify/commit/23fd69d9dd2ea56a648382c5de13b812da325c4d)), closes [#8677](https://github.com/vuetifyjs/vuetify/issues/8677)
* **VFileInput:** trigger onInput after value has changed ([#9091](https://github.com/vuetifyjs/vuetify/issues/9091)) ([507f1b0](https://github.com/vuetifyjs/vuetify/commit/507f1b0ed26c1b3b8ee0f7472afb68f86570567f)), closes [#9045](https://github.com/vuetifyjs/vuetify/issues/9045)
* **VIcon:** dense font-size selector ([#9494](https://github.com/vuetifyjs/vuetify/issues/9494)) ([1ae752e](https://github.com/vuetifyjs/vuetify/commit/1ae752ea1a2de821b1510baa07be2025b65c1edf))
* **VImg:** do not lazy load if intersection observer is not supported ([22e23e2](https://github.com/vuetifyjs/vuetify/commit/22e23e2f07125492609cc7e65570c03fdf6ac9b6)), closes [#9412](https://github.com/vuetifyjs/vuetify/issues/9412)
* **VLazy:** properly show transition on activation ([ac7136d](https://github.com/vuetifyjs/vuetify/commit/ac7136dd98ec6eea52840643d6f79ac61c5dceba))
* **vlistitem:** fix to misplaced small icon in dense list ([#9395](https://github.com/vuetifyjs/vuetify/issues/9395)) ([f5b5e98](https://github.com/vuetifyjs/vuetify/commit/f5b5e9847969f716659d83613f61e5b1fbedce97))
* **VPagination:** max length ([#9423](https://github.com/vuetifyjs/vuetify/issues/9423)) ([1394b6c](https://github.com/vuetifyjs/vuetify/commit/1394b6c24b006596c49375d808210264fa9920ae))
* **VRangeSlider:** allow handles on same value ([#9218](https://github.com/vuetifyjs/vuetify/issues/9218)) ([3ab0f67](https://github.com/vuetifyjs/vuetify/commit/3ab0f67c79f08fbae7a50c6476020b47ac5386dc)), closes [#8756](https://github.com/vuetifyjs/vuetify/issues/8756)
* **VRating:** pass in x-small icon size ([#9351](https://github.com/vuetifyjs/vuetify/issues/9351)) ([28b0b5b](https://github.com/vuetifyjs/vuetify/commit/28b0b5bdcdcb701c18818a4b3e624df5de27a715))
* **VSheet:** add missing !default declaration for sass variable ([487ebfe](https://github.com/vuetifyjs/vuetify/commit/487ebfe5ad892685d650cf308fa30e494507936a))
* **VSheet:** default border radius ([#9405](https://github.com/vuetifyjs/vuetify/issues/9405)) ([ade8707](https://github.com/vuetifyjs/vuetify/commit/ade8707bfea1c11de4167591f359bf5b4fa6db30))
* **VSkeletonLoader:** properly cascade border-radius ([74bc901](https://github.com/vuetifyjs/vuetify/commit/74bc9011152b61b36b636249d38a6b9c367d5e99))
* **VSparkline:** add label color for light/dark theme (fix [#8557](https://github.com/vuetifyjs/vuetify/issues/8557)) ([#8613](https://github.com/vuetifyjs/vuetify/issues/8613)) ([3a89a0d](https://github.com/vuetifyjs/vuetify/commit/3a89a0dbd2dac51266c1471e8933f5f579d3ecdd))
* **VStepper:** fix transition in RTL ([#9018](https://github.com/vuetifyjs/vuetify/issues/9018)) ([87dbc7b](https://github.com/vuetifyjs/vuetify/commit/87dbc7bb055074af5395d59a0b9e4a18316f70b6))
* **VStepper:** Increase selector priority .v-icon ([#9262](https://github.com/vuetifyjs/vuetify/issues/9262)) ([d650e7e](https://github.com/vuetifyjs/vuetify/commit/d650e7e4e2008f8a8818ad276653763f25b188e6)), closes [vuetifyjs/vuetify#9261](https://github.com/vuetifyjs/vuetify/issues/9261)
* **VSwitch:** allow override vars definition ([#8771](https://github.com/vuetifyjs/vuetify/issues/8771)) ([6e6f92b](https://github.com/vuetifyjs/vuetify/commit/6e6f92bd057ebbf897b135334e2d153b93efb2b3))
* **VSwitch/VCheckbox:** color not applied if value is 0/false ([#9431](https://github.com/vuetifyjs/vuetify/issues/9431)) ([9856ca7](https://github.com/vuetifyjs/vuetify/commit/9856ca7b7e3f2001132ec5e2a7c5321f9b5c9a88))
* **VTab:** properly wrap and center text ([b45b67c](https://github.com/vuetifyjs/vuetify/commit/b45b67cd055c3fb3299fbf9fe974e0fa78e0e880)), closes [#7804](https://github.com/vuetifyjs/vuetify/issues/7804)
* **VTabs:** only indent tabs if overflowing ([dc2850f](https://github.com/vuetifyjs/vuetify/commit/dc2850f0893a7b197fa2f44e5a697702b15ed33c)), closes [#8540](https://github.com/vuetifyjs/vuetify/issues/8540)
* **VTabs:** properly position slider after resize, fix align-with-title prop ([a8c3f2a](https://github.com/vuetifyjs/vuetify/commit/a8c3f2aa0000a3810000076b05589f858214081e)), closes [#8621](https://github.com/vuetifyjs/vuetify/issues/8621) [#8653](https://github.com/vuetifyjs/vuetify/issues/8653)
* **VTabs:** scope tab white-space to horizontal only ([a173b95](https://github.com/vuetifyjs/vuetify/commit/a173b9539c1658621f207e11761f8fb2ae9a982e)), closes [#8981](https://github.com/vuetifyjs/vuetify/issues/8981)
* **VTabs:** slider hides behind the colored tab ([#8600](https://github.com/vuetifyjs/vuetify/issues/8600)) ([f74b70a](https://github.com/vuetifyjs/vuetify/commit/f74b70a3c8534481b22d736c2d955a292892719a)), closes [#8596](https://github.com/vuetifyjs/vuetify/issues/8596)
* **VTextArea:** fix clear icon overlapped by the scrollbar ([#9190](https://github.com/vuetifyjs/vuetify/issues/9190)) ([1c21d76](https://github.com/vuetifyjs/vuetify/commit/1c21d76710c55ca1569abf99177105f33a4a0236)), closes [#8910](https://github.com/vuetifyjs/vuetify/issues/8910)
* **VTextField:** add check for $refs.input before focusing ([6b0ee22](https://github.com/vuetifyjs/vuetify/commit/6b0ee22e0ebc0dff9f70f04d60a75a9fc5614ef0))
* **VTextField:** better scope hover styles for outlined text-fields ([9ddb4db](https://github.com/vuetifyjs/vuetify/commit/9ddb4dbf7ecf4f502d29df74c9e777250f62b881)), closes [#8546](https://github.com/vuetifyjs/vuetify/issues/8546)
* **VTextField:** blur should fire once ([#8455](https://github.com/vuetifyjs/vuetify/issues/8455)) ([#8723](https://github.com/vuetifyjs/vuetify/issues/8723)) ([8db1566](https://github.com/vuetifyjs/vuetify/commit/8db1566fc793635ffa67713200395b987b7767ab))
* **VTextField:** dense filled & outlined ([#9403](https://github.com/vuetifyjs/vuetify/issues/9403)) ([2283635](https://github.com/vuetifyjs/vuetify/commit/228363596bfdc7727e3cbdf4c4b43cf7f44a3a40))
* **VTextField:** remove !important flag for bg-color ([#8652](https://github.com/vuetifyjs/vuetify/issues/8652)) ([83e1c9a](https://github.com/vuetifyjs/vuetify/commit/83e1c9ad2371d22ff13d7f0e387bfe77c227c1c0))
* **VTextField:** should respect events in correct order ([#7916](https://github.com/vuetifyjs/vuetify/issues/7916)) ([#8724](https://github.com/vuetifyjs/vuetify/issues/8724)) ([b222c90](https://github.com/vuetifyjs/vuetify/commit/b222c90cad49fb4cf8901d9ec6a754c1a09fb13b))
* **VTextField:** show label on dense ([#9116](https://github.com/vuetifyjs/vuetify/issues/9116)) ([1e62a4e](https://github.com/vuetifyjs/vuetify/commit/1e62a4e89e75cee349408a27b8818902ebe64605)), closes [#9105](https://github.com/vuetifyjs/vuetify/issues/9105)
* **VTextField:** use scrollWidth to calculate label width ([#9286](https://github.com/vuetifyjs/vuetify/issues/9286)) ([0f3fa6a](https://github.com/vuetifyjs/vuetify/commit/0f3fa6a9204688abe23996d2df2be665f52a7e18))
* **VTimePicker:** center clock element ([#9059](https://github.com/vuetifyjs/vuetify/issues/9059)) ([142ef11](https://github.com/vuetifyjs/vuetify/commit/142ef11ee11039bf317ecb6fa7d06f9a66045c25))
* **VTimePicker:** reset margin on full width ([#9139](https://github.com/vuetifyjs/vuetify/issues/9139)) ([b983ea5](https://github.com/vuetifyjs/vuetify/commit/b983ea5550bc8c18b840ea11fb88cca15de5f05e)), closes [#9119](https://github.com/vuetifyjs/vuetify/issues/9119) [#9141](https://github.com/vuetifyjs/vuetify/issues/9141)
* **VTimePicker:** RTL Time Title ([#9052](https://github.com/vuetifyjs/vuetify/issues/9052)) ([0c8921c](https://github.com/vuetifyjs/vuetify/commit/0c8921c987583d8826bc7f67fa02281d5e213c22))
* **VToolbar:** fix collapsed border-radius in RTL ([c0ad16d](https://github.com/vuetifyjs/vuetify/commit/c0ad16d135123b4d30c988a230ff73fc2f657741)), closes [#9049](https://github.com/vuetifyjs/vuetify/issues/9049)
* **VToolbar:** remove overflow when collapsed ([35b0fb1](https://github.com/vuetifyjs/vuetify/commit/35b0fb136b0ab84efe33b010f956f1eefa954ba2))
* **VTreeview:** stuttering animation of toggle icon when loading ([#9705](https://github.com/vuetifyjs/vuetify/issues/9705)) ([b729afc](https://github.com/vuetifyjs/vuetify/commit/b729afc03f12b9a45254cf8f96a7f4c2fc34798e)), closes [#9475](https://github.com/vuetifyjs/vuetify/issues/9475)
* force re-version ([17116c6](https://github.com/vuetifyjs/vuetify/commit/17116c6c56445394c24076f3e5a1f18bb27bb358))
* provide backward compatibility for vue-meta@1 ([#8922](https://github.com/vuetifyjs/vuetify/issues/8922)) ([21e44d4](https://github.com/vuetifyjs/vuetify/commit/21e44d4bac1f7b935af6ebc9856e04164068f25c))
* update hebrew translation ([#8930](https://github.com/vuetifyjs/vuetify/issues/8930)) ([4464455](https://github.com/vuetifyjs/vuetify/commit/4464455d0a60f743c7f60347fd685a14d1d464a2))
* **activatable:** add listeners for custom activators ([#8121](https://github.com/vuetifyjs/vuetify/issues/8121)) ([3beea7c](https://github.com/vuetifyjs/vuetify/commit/3beea7c9107da273465b0d65f4cde3f8fbc1b7bc)), closes [#7944](https://github.com/vuetifyjs/vuetify/issues/7944) [#5890](https://github.com/vuetifyjs/vuetify/issues/5890) [#5860](https://github.com/vuetifyjs/vuetify/issues/5860)
* **Theme:** fix issues for spa with vue-meta ([#8412](https://github.com/vuetifyjs/vuetify/issues/8412)) ([9a5c333](https://github.com/vuetifyjs/vuetify/commit/9a5c333bf3e409330e11e4cffc8dfd08a5b3cc71))
* **validatable:** allow focus/blur validation to process when readonly ([9fed066](https://github.com/vuetifyjs/vuetify/commit/9fed066611d7179d8a2c056650fe0e570c10d345)), closes [#8020](https://github.com/vuetifyjs/vuetify/issues/8020)
* **VAppBar:** adjust transforms when using the **bottom** prop ([13a99c9](https://github.com/vuetifyjs/vuetify/commit/13a99c9393fddd8484901b20eaf3eae08d939950)), closes [#8337](https://github.com/vuetifyjs/vuetify/issues/8337)
* **VAvatar:** properly render when using a svg ([#8423](https://github.com/vuetifyjs/vuetify/issues/8423)) ([2cc5a4a](https://github.com/vuetifyjs/vuetify/commit/2cc5a4a3832d26f398138f65db9594fe5ef6b418)), closes [#8367](https://github.com/vuetifyjs/vuetify/issues/8367)
* **VBadge:** enable unused variable (-top, -right) ([#8282](https://github.com/vuetifyjs/vuetify/issues/8282)) ([811803b](https://github.com/vuetifyjs/vuetify/commit/811803b79ae27e661cdba26e265fef1086441b7e))
* **VBtn:** don't add color classes when disabled ([d1755df](https://github.com/vuetifyjs/vuetify/commit/d1755df2c6627cbb57e518409e0366c3c8ccdbb2)), closes [#8030](https://github.com/vuetifyjs/vuetify/issues/8030)
* **VBtn:** remove fab designation with **icon** prop ([4c4b109](https://github.com/vuetifyjs/vuetify/commit/4c4b1092608aefdeddecf314e060f99424ec034c))
* **VCard:** explicitly define white-space ([f5db05d](https://github.com/vuetifyjs/vuetify/commit/f5db05d01cff2f750db15e3d7ac7953076961cd0)), closes [#8333](https://github.com/vuetifyjs/vuetify/issues/8333)
* **VCard:** fix word wrapping & color ([#8380](https://github.com/vuetifyjs/vuetify/issues/8380)) ([68cc268](https://github.com/vuetifyjs/vuetify/commit/68cc268ce6d66c18478641f10798c183bed7daad)), closes [#7920](https://github.com/vuetifyjs/vuetify/issues/7920) [#7730](https://github.com/vuetifyjs/vuetify/issues/7730)
* **VCarousel:** wrong position of arrows on hover in rtl mode ([#8458](https://github.com/vuetifyjs/vuetify/issues/8458)) ([8de535f](https://github.com/vuetifyjs/vuetify/commit/8de535f6edd2cb9635d9823db7ca4ac4e7211aba)), closes [#8457](https://github.com/vuetifyjs/vuetify/issues/8457)
* **VColorPicker:** alpha controls showing when they shouldnt ([#8427](https://github.com/vuetifyjs/vuetify/issues/8427)) ([31ed439](https://github.com/vuetifyjs/vuetify/commit/31ed43998af2d79252c2e6bf09f666c5214ef949)), closes [#8390](https://github.com/vuetifyjs/vuetify/issues/8390)
* **VDataTable:** add missing index variable in item scoped slot ([#8283](https://github.com/vuetifyjs/vuetify/issues/8283)) ([313f634](https://github.com/vuetifyjs/vuetify/commit/313f634c95eaf17154f6941c6dbcfdc8580b7a04)), closes [#8199](https://github.com/vuetifyjs/vuetify/issues/8199)
* **VDataTable:** fix header column widths not being respected ([#8296](https://github.com/vuetifyjs/vuetify/issues/8296)) ([a18cc68](https://github.com/vuetifyjs/vuetify/commit/a18cc680e597653224cfe116da3fc09c29316e7e)), closes [#5072](https://github.com/vuetifyjs/vuetify/issues/5072) [#7623](https://github.com/vuetifyjs/vuetify/issues/7623)
* **VDataTable:** fix options prop not setting initial values ([#8280](https://github.com/vuetifyjs/vuetify/issues/8280)) ([6a3b32d](https://github.com/vuetifyjs/vuetify/commit/6a3b32d967ca505b6c8d244468a4a96aca381ac4)), closes [#8266](https://github.com/vuetifyjs/vuetify/issues/8266)
* **VDataTable:** fix passing kebab-cased footer props ([#8286](https://github.com/vuetifyjs/vuetify/issues/8286)) ([b04d853](https://github.com/vuetifyjs/vuetify/commit/b04d85336393ba443aee6ca84a46001d99657490)), closes [#8254](https://github.com/vuetifyjs/vuetify/issues/8254)
* **VDataTable:** remove pointer-events: none for empty wrapper ([#8493](https://github.com/vuetifyjs/vuetify/issues/8493)) ([7f41ee5](https://github.com/vuetifyjs/vuetify/commit/7f41ee5a19cfa275082d6aa13208bb5d97c08dd2)), closes [#8492](https://github.com/vuetifyjs/vuetify/issues/8492)
* **VDataTable:** remove unnecessary colspan in mobile view ([#8444](https://github.com/vuetifyjs/vuetify/issues/8444)) ([f56e2d8](https://github.com/vuetifyjs/vuetify/commit/f56e2d821d1c85a366743578c454ece1b5e5da63))
* **VDataTable:** replace hardcoded icons for presets in grouped rows ([#8285](https://github.com/vuetifyjs/vuetify/issues/8285)) ([014910a](https://github.com/vuetifyjs/vuetify/commit/014910a0dc9fa48f554ffc470883bb2498c0e6cf)), closes [#8255](https://github.com/vuetifyjs/vuetify/issues/8255)
* **VDataTable:** workaround for chrome colspan border-collapse bug ([#8297](https://github.com/vuetifyjs/vuetify/issues/8297)) ([bff228e](https://github.com/vuetifyjs/vuetify/commit/bff228e9c151a05d84aed6fddf6659a1201fb287)), closes [#8251](https://github.com/vuetifyjs/vuetify/issues/8251)
* **VDialog:** fix style of component to follow material spec ([#8382](https://github.com/vuetifyjs/vuetify/issues/8382)) ([34d3483](https://github.com/vuetifyjs/vuetify/commit/34d34832d52a41447d70cf100a98e6bd55f168dd)), closes [#7773](https://github.com/vuetifyjs/vuetify/issues/7773)
* **VDivider:** missing rtl styles ([#8406](https://github.com/vuetifyjs/vuetify/issues/8406)) ([e629f12](https://github.com/vuetifyjs/vuetify/commit/e629f129c48ef9d23513a47382819c2e2098b66f)), closes [#8397](https://github.com/vuetifyjs/vuetify/issues/8397)
* **VEditDialog:** fix editability of VEditDialog ([#8466](https://github.com/vuetifyjs/vuetify/issues/8466)) ([8f5388f](https://github.com/vuetifyjs/vuetify/commit/8f5388fafe19ff2bfba9d2313c530c668f9c2b2f)), closes [#8465](https://github.com/vuetifyjs/vuetify/issues/8465)
* **VFileInput:** add missing type in types/lib.d.ts ([#8258](https://github.com/vuetifyjs/vuetify/issues/8258)) ([4eb7cf6](https://github.com/vuetifyjs/vuetify/commit/4eb7cf61ad0ff67f4462e4c553657405e61b8c0c))
* **VFileInput:** counter should update for null and value type ([#8375](https://github.com/vuetifyjs/vuetify/issues/8375)) ([add1add](https://github.com/vuetifyjs/vuetify/commit/add1add595a39bf7e07d8bd16682893734cdc286)), closes [#8372](https://github.com/vuetifyjs/vuetify/issues/8372)
* **VFileInput:** use internalArrayValue ([#8371](https://github.com/vuetifyjs/vuetify/issues/8371)) ([359125d](https://github.com/vuetifyjs/vuetify/commit/359125df8f47b8f3b655603e03d130ea002642e1))
* **VList:** missing rtl styles ([#8407](https://github.com/vuetifyjs/vuetify/issues/8407)) ([ce19073](https://github.com/vuetifyjs/vuetify/commit/ce190730c04eda853ce9e5fe8e792c32086db637)), closes [#8403](https://github.com/vuetifyjs/vuetify/issues/8403) [#8378](https://github.com/vuetifyjs/vuetify/issues/8378)
* **VMenu:** ignore click outside if component is being destroyed ([#8470](https://github.com/vuetifyjs/vuetify/issues/8470)) ([2ad27f6](https://github.com/vuetifyjs/vuetify/commit/2ad27f604fb1e3f228224bf6e046c81ec067eca8)), closes [#6976](https://github.com/vuetifyjs/vuetify/issues/6976)
* **VRangeSlider:** fix focus/blur events not emitting ([#8295](https://github.com/vuetifyjs/vuetify/issues/8295)) ([56c7e65](https://github.com/vuetifyjs/vuetify/commit/56c7e653aeb2e8377682e497d14b6a933849a569)), closes [#8290](https://github.com/vuetifyjs/vuetify/issues/8290)
* **VSelect:** ignore keypress when readonly ([#8194](https://github.com/vuetifyjs/vuetify/issues/8194)) ([0f92fc9](https://github.com/vuetifyjs/vuetify/commit/0f92fc9e61d300dca7e650271179a9c700c043cd))
* **VSelect/VRadio:** apply externally bound $listeners ([ecde38e](https://github.com/vuetifyjs/vuetify/commit/ecde38e35ae69410dcffdde29eecbdeb938f6ace)), closes [#8387](https://github.com/vuetifyjs/vuetify/issues/8387)
* **VSlideGroup:** re-calculate width when children length changes ([f2c206d](https://github.com/vuetifyjs/vuetify/commit/f2c206d47cb11724d6d8af0feec2ee4882af189e)), closes [#8330](https://github.com/vuetifyjs/vuetify/issues/8330)
* **VTextField:** update label width on label change ([#8409](https://github.com/vuetifyjs/vuetify/issues/8409)) ([8b8a966](https://github.com/vuetifyjs/vuetify/commit/8b8a966c1df330c0fe96b037a62d950eafb6557c)), closes [#8393](https://github.com/vuetifyjs/vuetify/issues/8393)
* **VTimeline:** display flat cards correctly ([9b1b1b8](https://github.com/vuetifyjs/vuetify/commit/9b1b1b8af4ec555fb3241dc4461b3c25abcb37bf)), closes [#8420](https://github.com/vuetifyjs/vuetify/issues/8420)
* **VTimeline:** position small and large dots correctly ([41059c4](https://github.com/vuetifyjs/vuetify/commit/41059c40c50d5f10ccb3376be7677889efeba74c)), closes [#8437](https://github.com/vuetifyjs/vuetify/issues/8437)
* polish translation of dataTable.sortBy ([4f5d329](https://github.com/vuetifyjs/vuetify/commit/4f5d32970646cf8c1d6df3bbceb461568e22da5c))
* **VRating:** flip in RTL ([d0eb357](https://github.com/vuetifyjs/vuetify/commit/d0eb35795933549f2394d3b5c6c314ef17058761)), closes [#7381](https://github.com/vuetifyjs/vuetify/issues/7381)
* **VSelect:** tweak default menu max-height value ([#8225](https://github.com/vuetifyjs/vuetify/issues/8225)) ([7932d7a](https://github.com/vuetifyjs/vuetify/commit/7932d7a3fbf40ca586f6e6e2b1f02f4dcc495c5b))
* **VSimpleTable:** fix hover ([#8165](https://github.com/vuetifyjs/vuetify/issues/8165)) ([13816f1](https://github.com/vuetifyjs/vuetify/commit/13816f144f9fe493df0dbfd3258d4258e91bb105))
* **VSnackbar:** properly assign width on mobile devices ([c54ccbe](https://github.com/vuetifyjs/vuetify/commit/c54ccbe5dc828a765290a16d77332748248f7150)), closes [#8224](https://github.com/vuetifyjs/vuetify/issues/8224)
* **VSpeedDial:** fix transition for tooltips ([e8dbd0b](https://github.com/vuetifyjs/vuetify/commit/e8dbd0be1c19ef2ad699557c93465c01bf08d516)), closes [#8159](https://github.com/vuetifyjs/vuetify/issues/8159)
* **VSpeedDial:** make speed dial non-clickable when it's closing ([c158d04](https://github.com/vuetifyjs/vuetify/commit/c158d04e2145d50042763c43e56ebb4903ec9c7b)), closes [#8203](https://github.com/vuetifyjs/vuetify/issues/8203)
* **VSwitch:** inset styling in RTL ([#8188](https://github.com/vuetifyjs/vuetify/issues/8188)) ([d53c43c](https://github.com/vuetifyjs/vuetify/commit/d53c43c4ec4fa822b1e488ead8e22a58e8f3bdb6)), closes [#8130](https://github.com/vuetifyjs/vuetify/issues/8130)
* **VTabs:** margins in RTL mode ([#8123](https://github.com/vuetifyjs/vuetify/issues/8123)) ([e5e5f76](https://github.com/vuetifyjs/vuetify/commit/e5e5f76910b33df1cf64b9d57f658ff54e7664d4))
* **VTabs:** prevent prop style bleed ([8f126b8](https://github.com/vuetifyjs/vuetify/commit/8f126b8b836976f089db5862490ad14c32c70a07)), closes [#8303](https://github.com/vuetifyjs/vuetify/issues/8303)
* **VTabs:** set correct offset on touchend with rtl ([1565a8e](https://github.com/vuetifyjs/vuetify/commit/1565a8edc6e6929b95fd6a1b0b3d594d3b494786)), closes [#8116](https://github.com/vuetifyjs/vuetify/issues/8116)
* add missing components to $_vuetify_subcomponents ([#8080](https://github.com/vuetifyjs/vuetify/issues/8080)) ([8aff65a](https://github.com/vuetifyjs/vuetify/commit/8aff65aed2629a07a4d75967b0bda4d82da1adfe)), closes [#8047](https://github.com/vuetifyjs/vuetify/issues/8047)
* **VForm:** when validate is manually called, properly validate all inputs ([b411be4](https://github.com/vuetifyjs/vuetify/commit/b411be4ebaec38d5c4b6359ca464ed6d33b4c458)), closes [#7999](https://github.com/vuetifyjs/vuetify/issues/7999)
* **VIcon:** add missing x-small prop functionality ([9b77c73](https://github.com/vuetifyjs/vuetify/commit/9b77c734523a03261436df056a2d1535a5b67980)), closes [#7873](https://github.com/vuetifyjs/vuetify/issues/7873)
* **VImg:** limit width to 100% ([78fbc32](https://github.com/vuetifyjs/vuetify/commit/78fbc321583cac2ae845e6c3ddc55048b9f9e806)), closes [#5788](https://github.com/vuetifyjs/vuetify/issues/5788) [#7327](https://github.com/vuetifyjs/vuetify/issues/7327)
* **VList:** disabled pointer events for disabled item ([71771da](https://github.com/vuetifyjs/vuetify/commit/71771daaec7eacd3fa6378a41409bdc47a1a81be))
* **VListItem:** update css selector for list-item-avatar styles ([a689c03](https://github.com/vuetifyjs/vuetify/commit/a689c03184b615b1714f98a810098b3306985a55)), closes [#7930](https://github.com/vuetifyjs/vuetify/issues/7930)
* **VPagination:** restrict totalVisible to maxButtons ([8195ac7](https://github.com/vuetifyjs/vuetify/commit/8195ac7728ecd1fb319c52436ec8f084a2f882fd)), closes [#7947](https://github.com/vuetifyjs/vuetify/issues/7947)
* **VSelect:** add selection padding for outlined style ([9566d4d](https://github.com/vuetifyjs/vuetify/commit/9566d4daa008a1d29c1abd3db2e242b517065715))
* **VSnackbar:** add correct exit animation ([0efd2a1](https://github.com/vuetifyjs/vuetify/commit/0efd2a13aa39424d6ba53559af4f872fd66b4494)), closes [#7981](https://github.com/vuetifyjs/vuetify/issues/7981)
* **VSpeedDial:** apply even padding on speed-dial list ([4091792](https://github.com/vuetifyjs/vuetify/commit/4091792b347877cd4478c395c33f488d798e1c36)), closes [#8039](https://github.com/vuetifyjs/vuetify/issues/8039)
* **VSpeedDialg:** change spacing between list and fab from margin to padding ([4bfd0b4](https://github.com/vuetifyjs/vuetify/commit/4bfd0b495747aab9f301d84bf9ed80c4cd22be98)), closes [#8015](https://github.com/vuetifyjs/vuetify/issues/8015)
* **VSystemBar:** propagate listeners to root element ([c14aae7](https://github.com/vuetifyjs/vuetify/commit/c14aae7f4c701d960923130999973d40ebf37a46)), closes [#7960](https://github.com/vuetifyjs/vuetify/issues/7960)
* **VTabs:** add proper indentation for mobile scrollable and align-with-title ([f380842](https://github.com/vuetifyjs/vuetify/commit/f3808423a055ab6d4cfbc30f571722519e38fb03)), closes [#6932](https://github.com/vuetifyjs/vuetify/issues/6932)
* **VTabs:** allow proper adjustment of sldier size ([c31b01d](https://github.com/vuetifyjs/vuetify/commit/c31b01d7c4aeee3b4f75b7b7949021d2522ced27)), closes [#8014](https://github.com/vuetifyjs/vuetify/issues/8014)
* hyphenate remaining event names ([#7917](https://github.com/vuetifyjs/vuetify/issues/7917)) ([6fac25d](https://github.com/vuetifyjs/vuetify/commit/6fac25d8fef351f79c7309dc596cd57a2ed71758))
* **docs:** import directives with lowercase ([#7508](https://github.com/vuetifyjs/vuetify/issues/7508)) ([7d663f5](https://github.com/vuetifyjs/vuetify/commit/7d663f52dd1403425bc20ce17cb8c134f1ff46da))
* **elevatable:** allow elevation value of numeric 0 ([e690b23](https://github.com/vuetifyjs/vuetify/commit/e690b2307a54a77d45a7b0b390cfda46bf5a7816))
* **getObjectValueByPath:** fix getObjectValueByPath ([#7543](https://github.com/vuetifyjs/vuetify/issues/7543)) ([02f5471](https://github.com/vuetifyjs/vuetify/commit/02f547121743b29ac0fc036350121032b86079f5)), closes [#7302](https://github.com/vuetifyjs/vuetify/issues/7302)
* **input-controls:** properly associate labels with inputs for a11y ([7c4a1ad](https://github.com/vuetifyjs/vuetify/commit/7c4a1adfc028b2ca5f74e18b5b92fce805acf36f)), closes [#6178](https://github.com/vuetifyjs/vuetify/issues/6178)
* **Inputs:** fix multiple a11y issues ([f7b2443](https://github.com/vuetifyjs/vuetify/commit/f7b2443788ebefa173dd5bb6ee1fb9f047ec1783))
* **install:** add property to Vue object to avoid memory leak ([#7497](https://github.com/vuetifyjs/vuetify/issues/7497)) ([c7cbdc5](https://github.com/vuetifyjs/vuetify/commit/c7cbdc51618bcdce26393d434c832c9b0fa4e255)), closes [vuejs/vue#5089](https://github.com/vuejs/vue/issues/5089)
* **locale:** Japanese translation of DataTable ([#7596](https://github.com/vuetifyjs/vuetify/issues/7596)) ([c6e0327](https://github.com/vuetifyjs/vuetify/commit/c6e0327b93e632dcb5c2f56aaf862930f439ae2a))
* **locale:** update fa locale ([#7439](https://github.com/vuetifyjs/vuetify/issues/7439)) ([70180b8](https://github.com/vuetifyjs/vuetify/commit/70180b816b6db493aa37e3470112baa1e825aac4))
* **locale:** update polish translations to 2.0 ([2a57376](https://github.com/vuetifyjs/vuetify/commit/2a57376615b72ac29ed89da2a7c5ed694660d434))
* **locale:** update ru locale ([#7437](https://github.com/vuetifyjs/vuetify/issues/7437)) ([dbf4a9e](https://github.com/vuetifyjs/vuetify/commit/dbf4a9ed8a119ed25beb2a7f2ca591df59b4117c))
* **locale:** update translation files structure to 2.0 ([#7367](https://github.com/vuetifyjs/vuetify/issues/7367)) ([87b1844](https://github.com/vuetifyjs/vuetify/commit/87b1844f8b68bb36a27f77eaaf8e6e48d078de5d))
* **Overlayable:** do not remove overlay if is still active after transitionend ([dc30560](https://github.com/vuetifyjs/vuetify/commit/dc30560a0f4e967d5f9f606c4c4146c75053b5f9)), closes [#7798](https://github.com/vuetifyjs/vuetify/issues/7798)
* **Ripple:** add ripple property to denote touch enabled ([#7619](https://github.com/vuetifyjs/vuetify/issues/7619)) ([985c634](https://github.com/vuetifyjs/vuetify/commit/985c634bb288664726e0169f888e92ad03d2288f)), closes [#7605](https://github.com/vuetifyjs/vuetify/issues/7605)
* **scripts:** invalid path to jest binary in debug:test ([509b297](https://github.com/vuetifyjs/vuetify/commit/509b29743d393c94aa5f6755e41d62ffaa850eed)), closes [#7350](https://github.com/vuetifyjs/vuetify/issues/7350)
* **Selectable:** update hasColor data property on value change ([818077f](https://github.com/vuetifyjs/vuetify/commit/818077f2f0a596acbc8b4cf5d82ef9637cbb77fe)), closes [#7855](https://github.com/vuetifyjs/vuetify/issues/7855)
* **SelectionControls:** toggle model when clicking label ([90b7188](https://github.com/vuetifyjs/vuetify/commit/90b718819584a4cc46c3d7bc04826912059d8bc2)), closes [#7744](https://github.com/vuetifyjs/vuetify/issues/7744)
* **SelectionControls:** tweak styles to properly match spec ([7fab4bc](https://github.com/vuetifyjs/vuetify/commit/7fab4bcdeddbdee69e320733a444e5e203d9d281))
* **styles:** broken rtl spacing and text-alignment classes ([6c79093](https://github.com/vuetifyjs/vuetify/commit/6c790939a906f1f014304431fa9014a24e70608c))
* **styles:** missing elevation-0 ([111d777](https://github.com/vuetifyjs/vuetify/commit/111d7773122f0c79703a0b58b2430cb43f0e7816)), closes [#7652](https://github.com/vuetifyjs/vuetify/issues/7652)
* **theme:** add .v-application prefix to theme/color/typography/etc rules ([#7768](https://github.com/vuetifyjs/vuetify/issues/7768)) ([c5dae24](https://github.com/vuetifyjs/vuetify/commit/c5dae24d87204e50ae31907f6d6d6c8b79d6531d)), closes [#7517](https://github.com/vuetifyjs/vuetify/issues/7517)
* **types:** give explicit type to empty arrays ([#7557](https://github.com/vuetifyjs/vuetify/issues/7557)) ([121c694](https://github.com/vuetifyjs/vuetify/commit/121c69478986b0ea5e418342ca545ae6d1c70bd0))
* **typescript:** added vuetify constructor declaration ([#7760](https://github.com/vuetifyjs/vuetify/issues/7760)) ([5a22747](https://github.com/vuetifyjs/vuetify/commit/5a22747d8242fe9d46f1e76810db3c5c3b8229cf))
* **typescript:** export directives in PascalCase ([#7767](https://github.com/vuetifyjs/vuetify/issues/7767)) ([aee87c0](https://github.com/vuetifyjs/vuetify/commit/aee87c0ed48837e6fbc83175311ecc5695cc2096)), closes [#7684](https://github.com/vuetifyjs/vuetify/issues/7684)
* **utilities:** allow multi-dimensional values ([9ac0d11](https://github.com/vuetifyjs/vuetify/commit/9ac0d111e9d258852897944209dd5347da42b0d3))
* **VAlert:** add proper a11y role ([6006ffa](https://github.com/vuetifyjs/vuetify/commit/6006ffa919bf1c0b445fa9bd22ddb2244ee2c863))
* **validatable:** setup proper validation state coloring on all inputs ([#7810](https://github.com/vuetifyjs/vuetify/issues/7810)) ([62e8fe0](https://github.com/vuetifyjs/vuetify/commit/62e8fe0424c67030ded1b20c79fafe77637b79ca))
* **VApp:** add missing theme propagation from $vuetify object ([2589d0c](https://github.com/vuetifyjs/vuetify/commit/2589d0c456099ca08a83455c8555370781cd0eef))
* **VAppBar:** remove width declaration on fixed bar ([cf73093](https://github.com/vuetifyjs/vuetify/commit/cf73093fa41eef4d8b9a2a97e4a6423a30bdddda))
* **VAutocomplete:** don't reset search to both undefined and null ([071ae76](https://github.com/vuetifyjs/vuetify/commit/071ae76d7b16c7d9af70e248bb74886091e6b83e)), closes [#7344](https://github.com/vuetifyjs/vuetify/issues/7344)
* **VAutocomplete:** remove space preventDefault ([7583d79](https://github.com/vuetifyjs/vuetify/commit/7583d7976d5a21ec32c865652ce1d0c62693dc56))
* **VAvatar:** ensure text is always aligned properly ([cf94c0b](https://github.com/vuetifyjs/vuetify/commit/cf94c0bd9ba3d2b591bcd1942cd6fc9fe7b06ab2))
* **VBadge:** ensure text is always aligned properly ([7f5b257](https://github.com/vuetifyjs/vuetify/commit/7f5b2579eac740850414e841189136f0c1b31bad))
* **VBadge:** fix delay on closing badge if transition is disabled ([#7287](https://github.com/vuetifyjs/vuetify/issues/7287)) ([98d9a3a](https://github.com/vuetifyjs/vuetify/commit/98d9a3a03446db4c3df5c47d9591ebe7a44c78f6))
* **VBottomNavigation:** adjust styles for inner buttons ([3ae30e5](https://github.com/vuetifyjs/vuetify/commit/3ae30e50403a4dad665e691b3e4e664dcbd370fe))
* **VBottomNavigation:** decrease specificity of icon margin ([85ac7d4](https://github.com/vuetifyjs/vuetify/commit/85ac7d47b5c9c20bc12c86c6f4543fdd1dcd0238)), closes [#7568](https://github.com/vuetifyjs/vuetify/issues/7568)
* **VBtn:** add letter-indent to combat off center caused by letter-spacing ([606dfd5](https://github.com/vuetifyjs/vuetify/commit/606dfd5c830283a50b36536946ff76984e9404ed))
* **VBtn:** adjust icon margin and size calculation to properly match spec ([45df4b3](https://github.com/vuetifyjs/vuetify/commit/45df4b3756f13449c5c7ffb68ef2ee44192c385c))
* **VBtn:** adjust large button sizes to be consistent ([#7536](https://github.com/vuetifyjs/vuetify/issues/7536)) ([7e2e2a4](https://github.com/vuetifyjs/vuetify/commit/7e2e2a425986a5a8636db21530294bfd8fb8d1a4))
* **VBtn:** adjust style declaration for v-icon color inheritance ([0b6784d](https://github.com/vuetifyjs/vuetify/commit/0b6784d781b93d34b98e66b62969129d850621c5))
* **VBtn:** correct md2 fab sizes ([f787b46](https://github.com/vuetifyjs/vuetify/commit/f787b469afde7da7fb1be8a6a45879002e31b63b)), closes [#7785](https://github.com/vuetifyjs/vuetify/issues/7785)
* **VBtn:** ensure .v-btn__content extends full width ([aa30554](https://github.com/vuetifyjs/vuetify/commit/aa305540c8ac2f67578db392748a263afc668c62)), closes [#7580](https://github.com/vuetifyjs/vuetify/issues/7580)
* **VBtn:** fix style application for text/outlined variants ([4d995c9](https://github.com/vuetifyjs/vuetify/commit/4d995c96b2a700e274c08534a56c6b05b75396f0))
* **VBtn:** make tile prop work ([#7751](https://github.com/vuetifyjs/vuetify/issues/7751)) ([49292c8](https://github.com/vuetifyjs/vuetify/commit/49292c8b0f6ae7e7f4e682c71695d61508a44a61)), closes [#7750](https://github.com/vuetifyjs/vuetify/issues/7750)
* **VBtn/Tab:** normalize vertical alignment ([e2fc06b](https://github.com/vuetifyjs/vuetify/commit/e2fc06b101b59a4f5fff08bd2d3c50a3bb472aa1)), closes [#7832](https://github.com/vuetifyjs/vuetify/issues/7832)
* **VBtnToggle:** restructure styles, improve v-btn color override ([#7515](https://github.com/vuetifyjs/vuetify/issues/7515)) ([4b4b1a1](https://github.com/vuetifyjs/vuetify/commit/4b4b1a1ce3d98232d430b0ea35da18354fb50954)), closes [#7420](https://github.com/vuetifyjs/vuetify/issues/7420)
* **VCalendar:** ellipsis weekday names when overflowed ([d400b2c](https://github.com/vuetifyjs/vuetify/commit/d400b2cf249fe4d56a10355e091de140a131b022))
* **VCalendar:** proper fix for using next/prev with irregular weekdays ([1222e2a](https://github.com/vuetifyjs/vuetify/commit/1222e2ad2bd45a0a4568c32ff6cabd7d8ac3ccc4)), closes [#7155](https://github.com/vuetifyjs/vuetify/issues/7155)
* **VCalendar:** throw error when no days available ([#7675](https://github.com/vuetifyjs/vuetify/issues/7675)) ([032aadc](https://github.com/vuetifyjs/vuetify/commit/032aadc42f7e7ba520a4e397ab0b5d27189eaebe)), closes [#7155](https://github.com/vuetifyjs/vuetify/issues/7155)
* **VCalendar:** update scoped slot names to kebab-case ([#7673](https://github.com/vuetifyjs/vuetify/issues/7673)) ([7835965](https://github.com/vuetifyjs/vuetify/commit/78359658800bb6631794bce43ab3865c44047860)), closes [#6704](https://github.com/vuetifyjs/vuetify/issues/6704)
* **VCard:** prevent overflow in flex containers ([18b9bf0](https://github.com/vuetifyjs/vuetify/commit/18b9bf081ff9f465350afaf1fb022f69d9712ec2))
* **VCheckbox:** add missing input classes ([b64dafc](https://github.com/vuetifyjs/vuetify/commit/b64dafcd353cffc438af0c5b177d03814ed2d036)), closes [#7509](https://github.com/vuetifyjs/vuetify/issues/7509)
* **VCheckbox:** normalize indeterminate behavior with native checkbox input ([f7cd045](https://github.com/vuetifyjs/vuetify/commit/f7cd0459f41ad71368d3cc3580681f41063bdc31))
* **VChip:** add active prop to replace existing value functionality ([f9eadbe](https://github.com/vuetifyjs/vuetify/commit/f9eadbe9b8919be73e6a14ac388dc054fdf1ebad)), closes [#7715](https://github.com/vuetifyjs/vuetify/issues/7715)
* **VChip:** increase css specificity for outlined styles ([7667a54](https://github.com/vuetifyjs/vuetify/commit/7667a54c5d0530ca32a794acd4c074e4050409c6))
* **VChip:** show ripple ([61b0b31](https://github.com/vuetifyjs/vuetify/commit/61b0b315dfb1eed62b805769e49177f93a880f3b)), closes [#7863](https://github.com/vuetifyjs/vuetify/issues/7863)
* **VCombobox:** properly enable auto-select-first ([c84c2fb](https://github.com/vuetifyjs/vuetify/commit/c84c2fb3229382a57ea04268d95ab0ccf793736c)), closes [#6607](https://github.com/vuetifyjs/vuetify/issues/6607)
* **VData:** typo in ts interface name ([e4e01e9](https://github.com/vuetifyjs/vuetify/commit/e4e01e9ee42e8c21c8c4bfd0eb90c7835c591c77))
* **VDataFooter:** add missing translation ([#7561](https://github.com/vuetifyjs/vuetify/issues/7561)) ([372c314](https://github.com/vuetifyjs/vuetify/commit/372c3148db4da8f30664baa8f717a04a14b0ada3))
* **VDataTable:** add theme styles for group header ([a8634d6](https://github.com/vuetifyjs/vuetify/commit/a8634d6bbf38b38f29bb06836bfe2b2f9cb224a9)), closes [#7853](https://github.com/vuetifyjs/vuetify/issues/7853)
* **VDataTable:** disable header sorting if disable-sort is true ([#7665](https://github.com/vuetifyjs/vuetify/issues/7665)) ([1809a1c](https://github.com/vuetifyjs/vuetify/commit/1809a1c89eaf6296a086808e58c06a139e6880cd)), closes [#7657](https://github.com/vuetifyjs/vuetify/issues/7657)
* **VDataTable:** enable use of expanded-item slot when using item slot ([a98dde5](https://github.com/vuetifyjs/vuetify/commit/a98dde50550a258524fc469d1ed91e6800e14d8b))
* **VDataTable:** missing styles for headers ([eed1e2f](https://github.com/vuetifyjs/vuetify/commit/eed1e2f4462ff569952606c230bec8e60e08e16f))
* **VDataTable:** mobile rows did not use available slots ([3f7ecd6](https://github.com/vuetifyjs/vuetify/commit/3f7ecd6cbd34c719692018a44f39cfea6d3a89a4))
* **VDataTable:** safari bug where background color was not applied ([018f44c](https://github.com/vuetifyjs/vuetify/commit/018f44cd2d339eb9855e63cd6b4644cd96cc195b)), closes [#6766](https://github.com/vuetifyjs/vuetify/issues/6766)
* **VDataTable:** updated mobile row test ([9c62db6](https://github.com/vuetifyjs/vuetify/commit/9c62db6ae2df19afa3228cf40088197f51735de0))
* **VDataTable:** virtual table should re-render rows when items change ([#7427](https://github.com/vuetifyjs/vuetify/issues/7427)) ([50a5dbf](https://github.com/vuetifyjs/vuetify/commit/50a5dbfb81a0679855ab18051402dc7607d4c973)), closes [#7336](https://github.com/vuetifyjs/vuetify/issues/7336)
* **VDataTableHeader:** remove icon opacity ([bf0a9e4](https://github.com/vuetifyjs/vuetify/commit/bf0a9e45199412f6d172ed748522385c02687654)), closes [#6647](https://github.com/vuetifyjs/vuetify/issues/6647)
* **VDialog:** adjust flex properties for scrollable ([8877942](https://github.com/vuetifyjs/vuetify/commit/8877942cede7f6b7f5d25fc1e91e567ca0b11b8e)), closes [#6754](https://github.com/vuetifyjs/vuetify/issues/6754)
* **VDialog:** fixed event variable ref in onFocusin ([#7498](https://github.com/vuetifyjs/vuetify/issues/7498)) ([db94b73](https://github.com/vuetifyjs/vuetify/commit/db94b73854ecdb7c5861df2824b3ab78df32719f))
* **VExpansionPanel:** set proper button type in header ([cf0da4b](https://github.com/vuetifyjs/vuetify/commit/cf0da4b54a5db9b59d85468bfd1824580112b123)), closes [#7471](https://github.com/vuetifyjs/vuetify/issues/7471)
* **VIcon:** fix a11y with SVG ([1866aca](https://github.com/vuetifyjs/vuetify/commit/1866aca328415211136c0afc55a820f91fbb71fd)), closes [#7428](https://github.com/vuetifyjs/vuetify/issues/7428)
* **VIcon:** missing default icons ([796a22c](https://github.com/vuetifyjs/vuetify/commit/796a22c1bca403ad5d2be68bf5385b6951129350))
* **VInput:** attrs should be applied on input not root element ([#7579](https://github.com/vuetifyjs/vuetify/issues/7579)) ([318553a](https://github.com/vuetifyjs/vuetify/commit/318553a7a76e7b9004f11e35db9aa1dec1ba01d6)), closes [#5412](https://github.com/vuetifyjs/vuetify/issues/5412)
* **VList:** pass in measureable styles ([#7570](https://github.com/vuetifyjs/vuetify/issues/7570)) ([0fa7e73](https://github.com/vuetifyjs/vuetify/commit/0fa7e73ad86fc99904b15cbdef1f584b38c877c1))
* **VListItem:** add missing disabled styles ([ddc4e65](https://github.com/vuetifyjs/vuetify/commit/ddc4e65a5ca519eb69735db183e161262effc4aa))
* **VMenu:** avoid potential stack overflow with no clickable tiles ([7d3b8e9](https://github.com/vuetifyjs/vuetify/commit/7d3b8e9c3efc65499b9884356204c3bdc3bf56e8))
* **VMenu:** ignore elements with 0 or NaN z-index ([#7532](https://github.com/vuetifyjs/vuetify/issues/7532)) ([df96de0](https://github.com/vuetifyjs/vuetify/commit/df96de0b6d68912bf53d8546f1ac8d2c0905d3f8)), closes [#5351](https://github.com/vuetifyjs/vuetify/issues/5351)
* **VMenu/Selects:** properly configure a11y ([#7385](https://github.com/vuetifyjs/vuetify/issues/7385)) ([e9a816d](https://github.com/vuetifyjs/vuetify/commit/e9a816dd38a0ebe2c683e2bf4fac92cc44dcf6ff))
* **VPicker:** fix width in landscape mode ([5075e43](https://github.com/vuetifyjs/vuetify/commit/5075e43bcf165e2e3d9b744ed07acd7138af5114))
* **VSelect:** set input type to hidden to fix potential layout issues ([#7544](https://github.com/vuetifyjs/vuetify/issues/7544)) ([bd35bee](https://github.com/vuetifyjs/vuetify/commit/bd35bee9e8bedce66e381d6ff14567a25602a92a)), closes [#5614](https://github.com/vuetifyjs/vuetify/issues/5614)
* **VSelectList:** wrong class for masked characters ([d8fbd1e](https://github.com/vuetifyjs/vuetify/commit/d8fbd1e89cbc3015c07fd48088bc0ec7e1a11724))
* **VSparkline:** negative values, labels being cut off ([#7664](https://github.com/vuetifyjs/vuetify/issues/7664)) ([30348c8](https://github.com/vuetifyjs/vuetify/commit/30348c8fe8b1253a7dc2116f19037ef275d69926))
* normalize component active/hover/focus states ([#7519](https://github.com/vuetifyjs/vuetify/issues/7519)) ([3ab588a](https://github.com/vuetifyjs/vuetify/commit/3ab588ab52e3a9ca8f3b883e995ed2cedb8e79d9))
* **VDataTable:** added isMobile boolean to body slot props ([953a757](https://github.com/vuetifyjs/vuetify/commit/953a7577753515b08dcfa9bf34aa696cac1c8942))
* **VDataTable:** make custom filter function more user friendly ([#7885](https://github.com/vuetifyjs/vuetify/issues/7885)) ([132ac8e](https://github.com/vuetifyjs/vuetify/commit/132ac8e02f6ce7e24deb135b48e1aa16e408f46a))
* **VDatePicker:** increased css specificity ([51e49cf](https://github.com/vuetifyjs/vuetify/commit/51e49cfccb860d01a875fc74475994cbff6bf338))
* **VDialog:** add missing a11y roles ([1ee52bd](https://github.com/vuetifyjs/vuetify/commit/1ee52bd27a9523c9cf5467c236bad30ef624a481))
* **VExpansionPanel:** increase specificity for active header icon rotate ([8f83745](https://github.com/vuetifyjs/vuetify/commit/8f83745a0812fc1dc49112fdef8eb29f10f27c8c)), closes [#7809](https://github.com/vuetifyjs/vuetify/issues/7809)
* **VExpansionPanel:** remove flex style designation to v-item-group children ([d526302](https://github.com/vuetifyjs/vuetify/commit/d526302638913f6353b9ddf83c664e528d1246ae)), closes [#7524](https://github.com/vuetifyjs/vuetify/issues/7524)
* **VExpansionPanels:** increase specificity of accordion style to avoid css leak ([78c806a](https://github.com/vuetifyjs/vuetify/commit/78c806a2d5ec46f5dd148a8a65552d68671842f6)), closes [#7809](https://github.com/vuetifyjs/vuetify/issues/7809)
* **VFileInput:** properly clear file input ([dfc8948](https://github.com/vuetifyjs/vuetify/commit/dfc8948d78416d64343658be0e369aaf5c2bff20)), closes [#7848](https://github.com/vuetifyjs/vuetify/issues/7848)
* **VIcon:** add notranslate ([0c9b5f3](https://github.com/vuetifyjs/vuetify/commit/0c9b5f3672a75d2b478071a54a717bfc716a9540)), closes [#7689](https://github.com/vuetifyjs/vuetify/issues/7689)
* **VIcon:** fix race condition with material icons ([4b19e34](https://github.com/vuetifyjs/vuetify/commit/4b19e3485fc80810a550f8ce43a80855d4f5ded6)), closes [#7746](https://github.com/vuetifyjs/vuetify/issues/7746)
* **VIcon:** normalize icon styles ([3d9dc50](https://github.com/vuetifyjs/vuetify/commit/3d9dc507ecaeedb3def0b93f7ad41ba6d2419a45))
* **VList:** add missing - in nav class styles ([7eab403](https://github.com/vuetifyjs/vuetify/commit/7eab403c511749d3c21de16c9daaa35ae73f8f20))
* **VList:** center title in nav/rouneded list's items ([b899bb7](https://github.com/vuetifyjs/vuetify/commit/b899bb78318882857564614db670ead61fa9209a))
* **VListGroup:** add missing click event propagation ([204dcc6](https://github.com/vuetifyjs/vuetify/commit/204dcc6a8b3e1b6a472a6d55f12d96999e440327))
* **VPagination:** remove ul padding from base ([1ab51bf](https://github.com/vuetifyjs/vuetify/commit/1ab51bfe1c338911c0d7f9912f9d17d49e0cf66e))
* **VSelect:** allow new item creation after one is selected ([e809466](https://github.com/vuetifyjs/vuetify/commit/e8094661ca582dbdf42441ade7235f653d8fcfdb))
* **VSelect:** pass attrs through scoped slot ([b70434b](https://github.com/vuetifyjs/vuetify/commit/b70434b82b4a7cfbe1e89b658aab4959776572f3))
* **VSelect:** resolve bug in safari/ie11 with event order disparity ([5fa6a68](https://github.com/vuetifyjs/vuetify/commit/5fa6a682634a0c159cf7c37897535bc2894131b9)), closes [#6608](https://github.com/vuetifyjs/vuetify/issues/6608) [#5913](https://github.com/vuetifyjs/vuetify/issues/5913)
* **VSelect:** tab selection ([4963f72](https://github.com/vuetifyjs/vuetify/commit/4963f72fac3e5fbe1a6bfbfae132ddfa736a6a74)), closes [#5614](https://github.com/vuetifyjs/vuetify/issues/5614) [#7544](https://github.com/vuetifyjs/vuetify/issues/7544)
* **VSelect/VChip:** selected state in input fields ([4dabf8b](https://github.com/vuetifyjs/vuetify/commit/4dabf8b5508b4fa86f1b3ce732c0e3d2a5eab27d)), closes [#7719](https://github.com/vuetifyjs/vuetify/issues/7719)
* **VSelectList:** move selection listener to simple-checkbox ([80d8884](https://github.com/vuetifyjs/vuetify/commit/80d8884dcb823be80abefb97805d267535f22433)), closes [#7692](https://github.com/vuetifyjs/vuetify/issues/7692)
* **VSnackbar:** update to better match md2 spec ([9f12df7](https://github.com/vuetifyjs/vuetify/commit/9f12df767034a7b73d8697d776b54d1b245e63fa)), closes [#7772](https://github.com/vuetifyjs/vuetify/issues/7772)
* **VSparkline:** adjust label position depending on line width ([69bebc3](https://github.com/vuetifyjs/vuetify/commit/69bebc3543ebbdace1e99b6443d3c5196b602cdc))
* **VSparkline:** filled line should not obscure labels ([b4fc0bd](https://github.com/vuetifyjs/vuetify/commit/b4fc0bd818257ffb298f027af52b302d797c8c5f)), closes [#7473](https://github.com/vuetifyjs/vuetify/issues/7473)
* **VSparkline:** incorrect bar lengths ([#7766](https://github.com/vuetifyjs/vuetify/issues/7766)) ([b31c749](https://github.com/vuetifyjs/vuetify/commit/b31c74935568f7eea7a6ea78d1fa8a01157b1018)), closes [#7762](https://github.com/vuetifyjs/vuetify/issues/7762)
* **VSparkline:** show custom labels when using bars ([#7642](https://github.com/vuetifyjs/vuetify/issues/7642)) ([454235d](https://github.com/vuetifyjs/vuetify/commit/454235d53f157ef9fdc3669dc2e88970d148ed61)), closes [#7584](https://github.com/vuetifyjs/vuetify/issues/7584)
* **VSparkline:** trend with equal values generates NaN ([a375292](https://github.com/vuetifyjs/vuetify/commit/a375292e3fb3f90ba39b9a4133e407d6c7c07f04)), closes [#7753](https://github.com/vuetifyjs/vuetify/issues/7753)
* **VSpeedDial:** add correct margin between btns inside of the dial list ([5146c85](https://github.com/vuetifyjs/vuetify/commit/5146c85d6938d822a7a4eb9f5d27b4cf043bfe13))
* **VSpeedDial:** fix absolute styles and list separation from activator ([c7bc9b0](https://github.com/vuetifyjs/vuetify/commit/c7bc9b08fdf6984357d25ce907b924c78ff6ad9a))
* **VTab:** increase specificity of color ([a9376db](https://github.com/vuetifyjs/vuetify/commit/a9376db0e46a7a98ac4210e78d8be136aa541ead))
* **VTabs:** add missing theme classes ([32048c1](https://github.com/vuetifyjs/vuetify/commit/32048c1f1458a18f75638977a8c8384109b5d698))
* **VTabs:** ensure v-tabs doesn't force overflow in flex elements ([5532ac5](https://github.com/vuetifyjs/vuetify/commit/5532ac51e23886e8ff85aba31d91076591f6248e)), closes [#7720](https://github.com/vuetifyjs/vuetify/issues/7720)
* **VTabs:** normal tabs inside vertical tabs are vertical ([#7357](https://github.com/vuetifyjs/vuetify/issues/7357)) ([290c353](https://github.com/vuetifyjs/vuetify/commit/290c3530d7710896a8d371a5b248f20a4fc8c6bc)), closes [#7355](https://github.com/vuetifyjs/vuetify/issues/7355)
* **VTabs:** properly set height when provided ([1f446b4](https://github.com/vuetifyjs/vuetify/commit/1f446b4760126e25774ac7c14e41889e71bcd89c)), closes [#7345](https://github.com/vuetifyjs/vuetify/issues/7345)
* **VTabs:** remove swiping propagation for tab touch events ([#7607](https://github.com/vuetifyjs/vuetify/issues/7607)) ([9d3937f](https://github.com/vuetifyjs/vuetify/commit/9d3937f737a1358c99dbb2d540190faaf82d96bf)), closes [#6462](https://github.com/vuetifyjs/vuetify/issues/6462) [#6801](https://github.com/vuetifyjs/vuetify/issues/6801)
* **VTabs:** resolve broken link association for a11y ([186eec1](https://github.com/vuetifyjs/vuetify/commit/186eec16e3fbdc80477f065644736fee3dc60d78))
* **VTabs:** tabs default color ([79016c3](https://github.com/vuetifyjs/vuetify/commit/79016c380576baa7e3eaa97f06d402e262b94ed6))
* **VTabs:** typo in var name, changed max width to match md specs ([47689ca](https://github.com/vuetifyjs/vuetify/commit/47689caa5b653ccccb66740ea2e40bbe3fbfa652))
* **VTabsItems:** change inferred theme variant ([cf180d4](https://github.com/vuetifyjs/vuetify/commit/cf180d465a4c55fc41cfc6090d12e79be4219b3a))
* **VTextarea:** apply single-line when using the full-width option ([aad5156](https://github.com/vuetifyjs/vuetify/commit/aad5156d29d507fcfafded01a54948fd9e7caf6e)), closes [#7442](https://github.com/vuetifyjs/vuetify/issues/7442)
* **VTextarea:** recalculate height on model update ([#7363](https://github.com/vuetifyjs/vuetify/issues/7363)) ([94a8344](https://github.com/vuetifyjs/vuetify/commit/94a834466de515473b2dcb677e8f2c683364391a)), closes [#4683](https://github.com/vuetifyjs/vuetify/issues/4683) [#6978](https://github.com/vuetifyjs/vuetify/issues/6978)
* **VTextarea:** recalculate textarea height when row-height changes ([489ce4c](https://github.com/vuetifyjs/vuetify/commit/489ce4c02f852e89aae00cf5470fd8cd6fc2e39a)), closes [#7671](https://github.com/vuetifyjs/vuetify/issues/7671)
* **VTextField:** add nowrap for prefix/suffix ([dd31808](https://github.com/vuetifyjs/vuetify/commit/dd318080b7643908bec9871e12aa8b40b978227b)), closes [#6922](https://github.com/vuetifyjs/vuetify/issues/6922)
* **VTextField:** improve text-field prop combination styling ([d0e5060](https://github.com/vuetifyjs/vuetify/commit/d0e5060210116f0f63992b2a05ca0ad3362d5bec)), closes [#7711](https://github.com/vuetifyjs/vuetify/issues/7711)
* **VTextField:** remove filled variant border override ([7e98189](https://github.com/vuetifyjs/vuetify/commit/7e98189d77c2ec3aa6c1557570fee6cf62bf0345))
* **VTextField, VSelect:** check the existence of input before focusing ([f9139ec](https://github.com/vuetifyjs/vuetify/commit/f9139eceb42caf43e07593612133e132fe8e4389)), closes [#7059](https://github.com/vuetifyjs/vuetify/issues/7059)
* **VTimePicker:** improve title look in landscape mode ([bc19a28](https://github.com/vuetifyjs/vuetify/commit/bc19a28db5038df01de9b8d3e1f3db09d598ea7c))
* **VToolbar:** always apply increased size to v-btn with the icon prop ([3a1fc40](https://github.com/vuetifyjs/vuetify/commit/3a1fc40e89defd00c9c7e1739af4dcffde09f9d0)), closes [#7400](https://github.com/vuetifyjs/vuetify/issues/7400)
* **VToolbar:** give proper default tag and allow for a custom one ([47d56b2](https://github.com/vuetifyjs/vuetify/commit/47d56b2ade2ef0ec4626ea38bac089199bb57599))
* **VToolbar:** resolve missing background image ([162149f](https://github.com/vuetifyjs/vuetify/commit/162149f473b00b733c9af62af5642a08846271f3))
* **VToolbar:** reverts fix in [#7499](https://github.com/vuetifyjs/vuetify/issues/7499) in favor of flex property ([8d9b25e](https://github.com/vuetifyjs/vuetify/commit/8d9b25e3b6ca18313c2a4db2b5a6dd9e34ac4eb5))
* **VToolbar/VAppBar:** properly show background on all browsers ([f6c5cce](https://github.com/vuetifyjs/vuetify/commit/f6c5cce78be19020d11e2485610effca04ce8cec)), closes [#7742](https://github.com/vuetifyjs/vuetify/issues/7742)
* **VTreeview:** don't emit events on mount ([#7546](https://github.com/vuetifyjs/vuetify/issues/7546)) ([023e596](https://github.com/vuetifyjs/vuetify/commit/023e596a174101a44da6f4d160fd0caf626fb563)), closes [#7296](https://github.com/vuetifyjs/vuetify/issues/7296)
* **VTreeview:** propagate item-disabled to child nodes ([52b6413](https://github.com/vuetifyjs/vuetify/commit/52b6413ea165dcafd001f0eb7d4c955e1f60d083))
* **VWindow:** hide overflow when using show-arrows-on-hover prop ([af003b6](https://github.com/vuetifyjs/vuetify/commit/af003b67055007193f36423d90b7e72fb19f2658)), closes [#7542](https://github.com/vuetifyjs/vuetify/issues/7542)
* **VWindowItem:** resolve content jumping on transition (not scroll related) ([46b563b](https://github.com/vuetifyjs/vuetify/commit/46b563b13538ecbb2b6d77b9a0dfee7092541998)), closes [#6206](https://github.com/vuetifyjs/vuetify/issues/6206)
* prevent duplicated theme stylesheet id ([#7443](https://github.com/vuetifyjs/vuetify/issues/7443)) ([6b7e7b1](https://github.com/vuetifyjs/vuetify/commit/6b7e7b192094ecbd6e53b7d2dee24b202e3b6951))
* **bootable:** proper deprecation since eager is not a replacement ([#7156](https://github.com/vuetifyjs/vuetify/issues/7156)) ([213d300](https://github.com/vuetifyjs/vuetify/commit/213d300038cce2a266c6907000232fcaa530ae0e))
* **typescript:** missing components in lib.d.ts ([#7293](https://github.com/vuetifyjs/vuetify/issues/7293)) ([a090fe1](https://github.com/vuetifyjs/vuetify/commit/a090fe1bc386a3317f2f4f562d42c541f88a092e)), closes [#7267](https://github.com/vuetifyjs/vuetify/issues/7267)
* **VAlert:** adjust improperly aligned icons and incorrect border radius on bordered type ([ea1fed8](https://github.com/vuetifyjs/vuetify/commit/ea1fed8f642a192bb4d0ccf1c0851bd55f2698ec))
* **VAlert:** update derived icon logic ([fa409fb](https://github.com/vuetifyjs/vuetify/commit/fa409fbf938099378ec057703ce096a4ccad3b22))
* **validatable:** VuetifyRuleValidator can return string | bolean ([b152757](https://github.com/vuetifyjs/vuetify/commit/b1527574c296b0eabbdb8d69f850686fb0866194))
* **VBottomNavigation:** add missing change emit ([d113245](https://github.com/vuetifyjs/vuetify/commit/d113245c495da3b39f7c37f23e3a52c36889bcb5))
* **VDataIterator:** it should now emit event when toggling all selected ([#7240](https://github.com/vuetifyjs/vuetify/issues/7240)) ([134f019](https://github.com/vuetifyjs/vuetify/commit/134f0197c8a397c34f60d9f99c42be05bfb03d79)), closes [#7115](https://github.com/vuetifyjs/vuetify/issues/7115)
* **VDataIterator:** resolve type check error ([4c65efd](https://github.com/vuetifyjs/vuetify/commit/4c65efd662c6d43ad32faef3f00b73d290fc35ca))
* **VDataTable:** correctly handle custom items per page options ([#7234](https://github.com/vuetifyjs/vuetify/issues/7234)) ([cde39dd](https://github.com/vuetifyjs/vuetify/commit/cde39dd9146a29e6382ed4e55b57a715c7d9ed4f))
* **VDataTable:** fix header color ([#7341](https://github.com/vuetifyjs/vuetify/issues/7341)) ([b040ff3](https://github.com/vuetifyjs/vuetify/commit/b040ff38b37a0180cbbb2cc019eae04fcd6bd086)), closes [#7334](https://github.com/vuetifyjs/vuetify/issues/7334)
* **VDataTable:** header icons should respect icon type (svg/non-svg) ([#7342](https://github.com/vuetifyjs/vuetify/issues/7342)) ([f8cfff5](https://github.com/vuetifyjs/vuetify/commit/f8cfff5813e03409aa77919c062aeaa5f3e7f012)), closes [#7338](https://github.com/vuetifyjs/vuetify/issues/7338)
* **VDataTable:** import ripple into datatable and header ([#7308](https://github.com/vuetifyjs/vuetify/issues/7308)) ([1be65e7](https://github.com/vuetifyjs/vuetify/commit/1be65e75f7e10baf31a5fc8443da3688ee1c3649))
* **VDataTable:** server side selection ([#7270](https://github.com/vuetifyjs/vuetify/issues/7270)) ([4f3adf1](https://github.com/vuetifyjs/vuetify/commit/4f3adf142dab9b742ad9c8b1494503c6b4d72ed7))
* **VDialog:** remove console error on escape keypress ([#7030](https://github.com/vuetifyjs/vuetify/issues/7030)) ([f2303f1](https://github.com/vuetifyjs/vuetify/commit/f2303f1daac83a9ea0a25800b8f96aebcc7a322f))
* **VEditDialog:** update for new activator changes ([0d10bd1](https://github.com/vuetifyjs/vuetify/commit/0d10bd14bcc6dbb974fdaa61204335c7f020258d))
* **VGrid:** wrap gutter equation in parentheses ([6f09b23](https://github.com/vuetifyjs/vuetify/commit/6f09b23d49196bfe1295fc1e5e2a7c281c7bddf0))
* **VListTileTitle:** don't cut badge ([#7161](https://github.com/vuetifyjs/vuetify/issues/7161)) ([f20cc01](https://github.com/vuetifyjs/vuetify/commit/f20cc01c228cc4b8a427f66f42db75f3991a2fd7)), closes [#7117](https://github.com/vuetifyjs/vuetify/issues/7117)
* **VMessages:** update min-height to avoid screen jitter ([96f874e](https://github.com/vuetifyjs/vuetify/commit/96f874e3f88d9b66838e7d221a9033eca5fa4c6b))
* **VSelect:** update selected color ([#7079](https://github.com/vuetifyjs/vuetify/issues/7079)) ([8a5760c](https://github.com/vuetifyjs/vuetify/commit/8a5760c6b6a184c9c8f41cbfebf079dbaa3ccc43)), closes [#6685](https://github.com/vuetifyjs/vuetify/issues/6685)
* **VSlider:** fixed issue when value is NaN ([bf83b6f](https://github.com/vuetifyjs/vuetify/commit/bf83b6f5a4f6f86a81949a22a608610926d6d69b))
* **VSlider:** set correct value when using negative min and 0 ([928a518](https://github.com/vuetifyjs/vuetify/commit/928a518f57eeebac44d6546ddeaba370fabcdbe0)), closes [#7320](https://github.com/vuetifyjs/vuetify/issues/7320)
* remove pointer events in &:before hover ([c1b0a25](https://github.com/vuetifyjs/vuetify/commit/c1b0a2569b49fb9f6743a1743ccb2248766d759e)), closes [#7335](https://github.com/vuetifyjs/vuetify/issues/7335)
* **VParallax:** show image if no translation is available ([#7042](https://github.com/vuetifyjs/vuetify/issues/7042)) ([c6f3a2c](https://github.com/vuetifyjs/vuetify/commit/c6f3a2cd396f70abe9e2c85e5fe1352646d20bf6)), closes [#7010](https://github.com/vuetifyjs/vuetify/issues/7010)
* **VSelect:** fix entry animation and positioning ([ae8f92a](https://github.com/vuetifyjs/vuetify/commit/ae8f92a34927e6378a94ad116571c07497f16a18))
* **VSlider:** floating thumb slider in IE11 ([#7158](https://github.com/vuetifyjs/vuetify/issues/7158)) ([dd19a45](https://github.com/vuetifyjs/vuetify/commit/dd19a45d502dff3178ff7bb9deb653200828ef0d))
* **VTabs:** cursor on tab without to/href ([86eecaa](https://github.com/vuetifyjs/vuetify/commit/86eecaa6e8e12dd62dadd6d63defbf816624a656))
* **VTabs:** do not hardcode v-tabs text color to white when in dark mode ([#7220](https://github.com/vuetifyjs/vuetify/issues/7220)) ([e4c8ceb](https://github.com/vuetifyjs/vuetify/commit/e4c8cebcb35a97c1f5d4da7ced5062e2ce74b9b6))
* **VTextField:** clearable should respect readonly=true ([#7175](https://github.com/vuetifyjs/vuetify/issues/7175)) ([d30d072](https://github.com/vuetifyjs/vuetify/commit/d30d07205eae28acff5fc76b89e83c72c63fe7f9)), closes [#7111](https://github.com/vuetifyjs/vuetify/issues/7111)
* **VTextField:** correct border-radius when using outlined and shaped ([de63ebc](https://github.com/vuetifyjs/vuetify/commit/de63ebce72ba5bfd181d397ef6ed38e021a074e5))
* **VTextField:** re-calculate label width on outlined change ([6a9ab1d](https://github.com/vuetifyjs/vuetify/commit/6a9ab1df1f05b5f1e00416ddf02bdd5a4e1b22ff))
* ensure required typescript folders are included during packaging ([#7229](https://github.com/vuetifyjs/vuetify/issues/7229)) ([7fbc0f6](https://github.com/vuetifyjs/vuetify/commit/7fbc0f618ed8283b8da20d25ca857a69d276c5e4))
* tabs in RTL mode ([#7292](https://github.com/vuetifyjs/vuetify/issues/7292)) ([48f325d](https://github.com/vuetifyjs/vuetify/commit/48f325dc9e61967d64b0d0e460b8374d08a81f92)), closes [#7245](https://github.com/vuetifyjs/vuetify/issues/7245)
* vue-devtools when using nuxt ([#7162](https://github.com/vuetifyjs/vuetify/issues/7162)) ([e30053e](https://github.com/vuetifyjs/vuetify/commit/e30053e3435d385547e1bb6a3e114613706f5f97))
* **elevation:** style mixin should use important ([0d08de1](https://github.com/vuetifyjs/vuetify/commit/0d08de1c862f1c9ef0f61717f051f6396050e1f0))
* **helpers:** check for window before adding listeners ([8f477e6](https://github.com/vuetifyjs/vuetify/commit/8f477e6dd24ea6eb3a1f34f9adbf68043e9319ac)), closes [#6952](https://github.com/vuetifyjs/vuetify/issues/6952)
* **locale:** update carousel.next/prev translation ([#6993](https://github.com/vuetifyjs/vuetify/issues/6993)) ([50874af](https://github.com/vuetifyjs/vuetify/commit/50874af77924d1ef32954a95a360cac3ebb86e46))
* **overlayable:** check browser support for passive events ([#6710](https://github.com/vuetifyjs/vuetify/issues/6710)) ([bb9c47e](https://github.com/vuetifyjs/vuetify/commit/bb9c47eb00f6d503485f399a982f2590411383c6)), closes [#6617](https://github.com/vuetifyjs/vuetify/issues/6617)
* **prefix position:** provide margin-top ([#6956](https://github.com/vuetifyjs/vuetify/issues/6956)) ([0160a40](https://github.com/vuetifyjs/vuetify/commit/0160a40220a754a5cd1b72620a085bbadbcbf1e8)), closes [#6942](https://github.com/vuetifyjs/vuetify/issues/6942)
* **ssr:** apply theme with vue-meta when available ([#6878](https://github.com/vuetifyjs/vuetify/issues/6878)) ([02e4e90](https://github.com/vuetifyjs/vuetify/commit/02e4e90791ae69135306a5888e45ba699af3d3c8))
* **v-messages:** increase line-height of inputs messages ([#6868](https://github.com/vuetifyjs/vuetify/issues/6868)) ([5f88487](https://github.com/vuetifyjs/vuetify/commit/5f884878964afa2d48cc4d53e47a1f35958379c9))
* **v-ripple:** check for existance of _ripple ([fb79ea8](https://github.com/vuetifyjs/vuetify/commit/fb79ea8eb2c087333cd1c9c995b5786cfe691f04))
* **VAlert:** allow the removal of a contextual icon ([eccc6ac](https://github.com/vuetifyjs/vuetify/commit/eccc6ac60003fc7d52f36d4536268245c6df299e))
* **VAvatar:** squishing inside flex containers ([c3ee291](https://github.com/vuetifyjs/vuetify/commit/c3ee291ce87de0ce4bb9cc451a17a7c5ec6762be))
* **VBtn:** limit FAB icon transition to direct children ([a76ef42](https://github.com/vuetifyjs/vuetify/commit/a76ef42346a5518d78c7c5e00bfe764f44b14aa3))
* **VBtn:** remove font-size overwrite by typography css ([#6975](https://github.com/vuetifyjs/vuetify/issues/6975)) ([189cbd2](https://github.com/vuetifyjs/vuetify/commit/189cbd20330be6e42ed190ebe3cfd9b26295c51b)), closes [#6974](https://github.com/vuetifyjs/vuetify/issues/6974)
* **VBtn:** remove line-height and references to old class and variables ([2a94fb1](https://github.com/vuetifyjs/vuetify/commit/2a94fb1532163f4f771e99fcff375b581f8d5c41))
* **VCard:** avoid being rendered on a different layer ([926ab0d](https://github.com/vuetifyjs/vuetify/commit/926ab0d077772a7f5bf5397abcf55a00ed3ce200))
* **VChip:** increase outline transparent specificity ([639756a](https://github.com/vuetifyjs/vuetify/commit/639756ada972f3e0d158ad208b0d0dd474803237))
* **VChip:** override `v-avatar` min-width added in c3ee291 ([cb212b4](https://github.com/vuetifyjs/vuetify/commit/cb212b432139fd71ef5474628a189fb844da672a))
* **VDialog:** propagate value to isActive ([140137f](https://github.com/vuetifyjs/vuetify/commit/140137f2adf291a518e42264cd11a4a10947a005))
* **VListGroup:** change lifecycle hook for init ([8fe4f6f](https://github.com/vuetifyjs/vuetify/commit/8fe4f6f4f81dda1636a77b66bde74a5af4c72999))
* **VListItem:** fix for usage with external value ([9c4c0f9](https://github.com/vuetifyjs/vuetify/commit/9c4c0f98246cb90b4591a827f722dcec2385a055))
* **VListItemAvatar:** use proper spacing to line-up title text ([2ddbaff](https://github.com/vuetifyjs/vuetify/commit/2ddbaffd66666099a21af7dbabaaa5d49208fc56))
* **VOoverflowBtn:** remove top border ([#6984](https://github.com/vuetifyjs/vuetify/issues/6984)) ([aa14ca8](https://github.com/vuetifyjs/vuetify/commit/aa14ca8b65694e4da4a9b5c4d697988342000cd6)), closes [#6960](https://github.com/vuetifyjs/vuetify/issues/6960)
* **VOverflowBtn:** remove pointless method override ([0a5aa74](https://github.com/vuetifyjs/vuetify/commit/0a5aa74c55b0c356c13147ad63759aada3d29569)), closes [#4533](https://github.com/vuetifyjs/vuetify/issues/4533)
* **VSelect:** avoid potential use of non-primitive for key value ([f29354a](https://github.com/vuetifyjs/vuetify/commit/f29354a79bda4eb8ac3a1db266a0102a3b64d451))
* **VSelect:** highlight newly selected item on keypress ([495ffaa](https://github.com/vuetifyjs/vuetify/commit/495ffaa2d5f451c5f3994cfd9cd042c07d6df61c)), closes [#6856](https://github.com/vuetifyjs/vuetify/issues/6856)
* **VSlider:** unfriendly UX behavior ([41df699](https://github.com/vuetifyjs/vuetify/commit/41df69901ec5a4bd59887026eb098956c2e64566))
* **VSpeedDial:** add check for componentOptions existing on slot ([#6905](https://github.com/vuetifyjs/vuetify/issues/6905)) ([58a8725](https://github.com/vuetifyjs/vuetify/commit/58a8725f69b0ae04c0b29da8b3a37c3ceb2e02a0)), closes [#6901](https://github.com/vuetifyjs/vuetify/issues/6901)
* **VTabs:** dark variant tab styles inactive opacity ([2eb6c96](https://github.com/vuetifyjs/vuetify/commit/2eb6c96dd04c9c8bf658341fbcebc51df3e01eb5))
* **VTextField:** fix color of prefix/suffix when disabled ([#7189](https://github.com/vuetifyjs/vuetify/issues/7189)) ([7bc4a08](https://github.com/vuetifyjs/vuetify/commit/7bc4a08b4a02aef326732601175c874332cfbae4))
* **VTextField:** prevent TypeError when color is an empty string ([#6982](https://github.com/vuetifyjs/vuetify/issues/6982)) ([fc6a66b](https://github.com/vuetifyjs/vuetify/commit/fc6a66bb4df21ed7157e14f27ee64e2d9a524e17)), closes [#6981](https://github.com/vuetifyjs/vuetify/issues/6981)
* **VTextField:** remove legend width when single-line ([5ccafef](https://github.com/vuetifyjs/vuetify/commit/5ccafefc183355e73428fe66bad19b2609f6cab0))
* **VTimePicker:** don't allow 0 hour/minute when it's not allowed ([c49ff47](https://github.com/vuetifyjs/vuetify/commit/c49ff47e60a5ad2b526dadc03cdff081aedeaae3))
* **VTimePickerClock:** fix sass indent ([#6907](https://github.com/vuetifyjs/vuetify/issues/6907)) ([f76b6f1](https://github.com/vuetifyjs/vuetify/commit/f76b6f1e974bed4d51b7c7fd2b975348251772db))
* **VToolbar:** fix **flat** prop not removing shadow ([e930399](https://github.com/vuetifyjs/vuetify/commit/e93039966aaaa1ebf8f75f9f7a68ac2fec3e8d8f))
* **VToolbar/VAppBar:** explicitly set line-height, adjust title padding ([136866f](https://github.com/vuetifyjs/vuetify/commit/136866f790a7b56c8e68a3ae0d73b10c01ae1b62))
* properly implement bootable logic/styles ([03de717](https://github.com/vuetifyjs/vuetify/commit/03de7176527ad0ea4d9b65f18658e7b897c39f1b))
* **VTreeView:** add height limitation on v-treeview-node__root ([#6894](https://github.com/vuetifyjs/vuetify/issues/6894)) ([563e3f4](https://github.com/vuetifyjs/vuetify/commit/563e3f4268887f4d9ddb001836ac0646e283f6ea))
* babel-transform-sass-paths ([#6876](https://github.com/vuetifyjs/vuetify/issues/6876)) ([68c28b7](https://github.com/vuetifyjs/vuetify/commit/68c28b7e1d23b02840538ee9b29b7615d0b0ce07))
* **_theme:** fix font family ([d5123e9](https://github.com/vuetifyjs/vuetify/commit/d5123e9ff028cbd6eebcc77a6e59b28f5eb421c6))
* **_variables:** remove conflicting sheet variable ([070ec41](https://github.com/vuetifyjs/vuetify/commit/070ec417f04c4c11b7ee0d8977e90c4317759f0b))
* **api:** updated api-generator mapping ([15e7829](https://github.com/vuetifyjs/vuetify/commit/15e7829d94df1273a1ff68209411fc92ccca1b99)), closes [#254](https://github.com/vuetifyjs/vuetify/issues/254)
* **colorable:** remove Boolean from color prop ([820f8a3](https://github.com/vuetifyjs/vuetify/commit/820f8a321fa8b8ad1c7d1a1ad8f954863671deae))
* **detachable:** check for non-scoped activator slot first ([4fe2d02](https://github.com/vuetifyjs/vuetify/commit/4fe2d0222eb15242c5168ec55a8784faa2bfbb2e))
* **detachable:** extract all elements from activator scoped slot ([3f9ad9b](https://github.com/vuetifyjs/vuetify/commit/3f9ad9bfffb7897a2ad57289bdeb4e76cdc7e824))
* **goTo:** allow standalone call ([#6324](https://github.com/vuetifyjs/vuetify/issues/6324)) ([012693a](https://github.com/vuetifyjs/vuetify/commit/012693ae143937e6395216e58ec7ec06de3660a6))
* **goTo:** avoid negative numbers creating a scrollLock ([f11e21c](https://github.com/vuetifyjs/vuetify/commit/f11e21cc151605f6cf206551b2e79e59d6a660ef))
* **kitchen:** add .vue extension to the edit path ([fbc9146](https://github.com/vuetifyjs/vuetify/commit/fbc9146c8e4b2caa5892028ae8affa3c122dd883))
* **kitchen:** don't display edit button on the home page ([693558f](https://github.com/vuetifyjs/vuetify/commit/693558fc4b8fe0b7b3561de02ae0041bf68adef0))
* **kitchen:** edit link should point to next instead of master ([#6214](https://github.com/vuetifyjs/vuetify/issues/6214)) ([7bed285](https://github.com/vuetifyjs/vuetify/commit/7bed28590de427e103c2a46f5b2de248054e3457))
* **kitchen:** move all FABs to right ([#6213](https://github.com/vuetifyjs/vuetify/issues/6213)) ([16de882](https://github.com/vuetifyjs/vuetify/commit/16de882e2882c47a117770d98e1d1c20df077eaa))
* **menuable:** positioning when overflowing viewport ([#6412](https://github.com/vuetifyjs/vuetify/issues/6412)) ([912380f](https://github.com/vuetifyjs/vuetify/commit/912380f5d3e1091e6083d49dce702539117dd4b7)), closes [#6294](https://github.com/vuetifyjs/vuetify/issues/6294)
* **overlayable:** make hide-overlay prop reactive ([#6347](https://github.com/vuetifyjs/vuetify/issues/6347)) ([71334ef](https://github.com/vuetifyjs/vuetify/commit/71334ef07d61a576d79fe3ea2cb45b270c225902)), closes [#6346](https://github.com/vuetifyjs/vuetify/issues/6346)
* **ripple:** make event listeners passive ([12c410e](https://github.com/vuetifyjs/vuetify/commit/12c410e0b603d45da141f996af42e1fb0fbba0d4)), closes [#6407](https://github.com/vuetifyjs/vuetify/issues/6407)
* **ripple:** retain ripple on hold, show on touchstart ([79d4504](https://github.com/vuetifyjs/vuetify/commit/79d45048036e89416e86f31c559abdc7a6a79feb)), closes [#6241](https://github.com/vuetifyjs/vuetify/issues/6241)
* **ripple:** show warning when bound to an inline element ([0099f14](https://github.com/vuetifyjs/vuetify/commit/0099f14a9f11c059a9d358b46ae05509824a35b9)), closes [#6245](https://github.com/vuetifyjs/vuetify/issues/6245)
* **v-ripple:** skip mouse events if triggered by touch ([#6445](https://github.com/vuetifyjs/vuetify/issues/6445)) ([34d265e](https://github.com/vuetifyjs/vuetify/commit/34d265ed57e7661f99522ea0507e2bc795ac4634)), closes [#6418](https://github.com/vuetifyjs/vuetify/issues/6418)
* **VAlert:** fix border with dense prop ([#6217](https://github.com/vuetifyjs/vuetify/issues/6217)) ([3a47ba9](https://github.com/vuetifyjs/vuetify/commit/3a47ba9b7fc112a1449236ca48f54576a337fa27))
* **VAlert:** fix border-radius bleedover ([231e753](https://github.com/vuetifyjs/vuetify/commit/231e753ed3d07e7645e2e2b92dd18bdd34ab6636))
* **validatable:** re-check validation after reset ([4cc8b8c](https://github.com/vuetifyjs/vuetify/commit/4cc8b8c4e1e4cfbac1751da132daa4a69311e0a1)), closes [#5877](https://github.com/vuetifyjs/vuetify/issues/5877)
* **validatable:** reset validation on resetValidation call ([3eddb56](https://github.com/vuetifyjs/vuetify/commit/3eddb56dc693f28fb2e0058b2c56fba992afa62c))
* **VAutocomplete:** may not show menu with hide-selected ([#6091](https://github.com/vuetifyjs/vuetify/issues/6091)) ([8799c48](https://github.com/vuetifyjs/vuetify/commit/8799c48f9939a4592c09f9b0ca780796cecc54a7)), closes [#4580](https://github.com/vuetifyjs/vuetify/issues/4580)
* **VAutocomplete:** remove search when tabbing out of input ([df1b11e](https://github.com/vuetifyjs/vuetify/commit/df1b11efe469a1a86b580b0a8ceff416730c57a9))
* **VAutocomplete:** retain search value on multi selection ([#6342](https://github.com/vuetifyjs/vuetify/issues/6342)) ([5a5a6e2](https://github.com/vuetifyjs/vuetify/commit/5a5a6e286a783921ba04b983142b1a60ee399230)), closes [#5926](https://github.com/vuetifyjs/vuetify/issues/5926)
* **VAutocomplete:** update dynamically when itemText is updated ([#6431](https://github.com/vuetifyjs/vuetify/issues/6431)) ([50f0264](https://github.com/vuetifyjs/vuetify/commit/50f0264bd8fb024ba95c54f0b1f3bf3d0345a140)), closes [#6368](https://github.com/vuetifyjs/vuetify/issues/6368) [#6368](https://github.com/vuetifyjs/vuetify/issues/6368)
* **VAutocomplete:** use toLocaleLowerCase when filtering items ([#6333](https://github.com/vuetifyjs/vuetify/issues/6333)) ([997c329](https://github.com/vuetifyjs/vuetify/commit/997c329224fbc51a3e5608e9fe1957d277828faf)), closes [#4811](https://github.com/vuetifyjs/vuetify/issues/4811)
* **vbtn:** remove style error ([62bfa77](https://github.com/vuetifyjs/vuetify/commit/62bfa772e5772474f8b6e2e40184e10bcf022913))
* **VBtn:** actually hook up real rounded prop ([470628a](https://github.com/vuetifyjs/vuetify/commit/470628a351cf3ac7a4c498f522fd549712456c70))
* **VBtn:** change content tag ([505179f](https://github.com/vuetifyjs/vuetify/commit/505179fdbd9d54515d59fdd7e816eebcafa2b145))
* **VBtn:** change min-height to height ([a57a298](https://github.com/vuetifyjs/vuetify/commit/a57a298692fcd87c8e4992b76f2e1c39a275882b))
* **VCard:** remove computedElevation usage ([cfcff04](https://github.com/vuetifyjs/vuetify/commit/cfcff04c1e1108952df9670753790c1a1a4ba77b)), closes [#6098](https://github.com/vuetifyjs/vuetify/issues/6098)
* **VCarousel:** prevent container recreation ([#5948](https://github.com/vuetifyjs/vuetify/issues/5948)) ([f9ca3ec](https://github.com/vuetifyjs/vuetify/commit/f9ca3ec7843913d44cb1b1eebf95a349ceedcfa0))
* **VCarouselItem:** auto change height ([#6340](https://github.com/vuetifyjs/vuetify/issues/6340)) ([c6f422b](https://github.com/vuetifyjs/vuetify/commit/c6f422b5e10be2de8a353409d8ba298824133ab6)), closes [#6337](https://github.com/vuetifyjs/vuetify/issues/6337)
* **VCheckbox:** add `for` attribute on checkbox's related label ([#6179](https://github.com/vuetifyjs/vuetify/issues/6179)) ([86077df](https://github.com/vuetifyjs/vuetify/commit/86077df9960bf1a181854d153b8ce32be462f4ad)), closes [#6178](https://github.com/vuetifyjs/vuetify/issues/6178) [#6178](https://github.com/vuetifyjs/vuetify/issues/6178)
* **VChip:** Removes transparent border ([#5956](https://github.com/vuetifyjs/vuetify/issues/5956)) ([88c7b35](https://github.com/vuetifyjs/vuetify/commit/88c7b35ed10e4a96cf5e432682a0e91995d26bb4)), closes [#5619](https://github.com/vuetifyjs/vuetify/issues/5619)
* **VDatePicker:** fixed disabled styles ([1f66831](https://github.com/vuetifyjs/vuetify/commit/1f668314d9d4b6c9525e7e13a7199928757c77fb))
* **VDatePicker:** incorrect behaviour with year < 1000 ([0558fb7](https://github.com/vuetifyjs/vuetify/commit/0558fb7718c5c8c671535684fb8c9244a0516edc)), closes [#6298](https://github.com/vuetifyjs/vuetify/issues/6298)
* **VDatePicker:** unwanted form submission on header click. ([#6350](https://github.com/vuetifyjs/vuetify/issues/6350)) ([9ad76b6](https://github.com/vuetifyjs/vuetify/commit/9ad76b6505efa7fba2df21cb1188baa1b48cb5b7))
* **VDatePicker:** updated button classes ([cb3bbcf](https://github.com/vuetifyjs/vuetify/commit/cb3bbcfface901b7e0b4b9dbf37aeed1a3954caa))
* **VDialog:** allow the use of scrollable with forms ([f90c8b9](https://github.com/vuetifyjs/vuetify/commit/f90c8b9b5abcc945bf266d7421499eb579ab7dc6)), closes [#3713](https://github.com/vuetifyjs/vuetify/issues/3713)
* **VDialog:** make scroll listener non-passive ([3c9b8b6](https://github.com/vuetifyjs/vuetify/commit/3c9b8b6b5588644e0f81e9b28f2b283a99d022a3)), closes [#6263](https://github.com/vuetifyjs/vuetify/issues/6263)
* **VDialog:** prevent scrollable card from overflowing horizontally ([b0dfdc4](https://github.com/vuetifyjs/vuetify/commit/b0dfdc4c2a5321fb2ca4ab61b039bdfa2ac71d11)), closes [#6420](https://github.com/vuetifyjs/vuetify/issues/6420)
* **VDialog:** properly check for activator scopedSlot ([2acf2ff](https://github.com/vuetifyjs/vuetify/commit/2acf2ff6c17cf28762cc16b8c267a72a9cda09a6)), closes [#6115](https://github.com/vuetifyjs/vuetify/issues/6115)
* **VDialog,VMenu,VTooltip:** work around vue 2.6.2 $slots change ([82a9b67](https://github.com/vuetifyjs/vuetify/commit/82a9b677c4789ea6f00c337d6fe838a81b6521a5)), closes [vuejs/vue#9421](https://github.com/vuejs/vue/issues/9421)
* **VExpandTransition:** reflow DOM before closing ([5d8b0df](https://github.com/vuetifyjs/vuetify/commit/5d8b0dfc798a532c0f5e366bf681a50403b225c5)), closes [#6049](https://github.com/vuetifyjs/vuetify/issues/6049) [#6102](https://github.com/vuetifyjs/vuetify/issues/6102)
* **VExpansionPanel:** fix lazy animation ([#6222](https://github.com/vuetifyjs/vuetify/issues/6222)) ([d3bcdb1](https://github.com/vuetifyjs/vuetify/commit/d3bcdb1a44e167c0258795182c370d33393a0627))
* **VExpansionPanel:** fix lazy entry animation ([d3937e0](https://github.com/vuetifyjs/vuetify/commit/d3937e05228474844d764c55ef6c23ca0a58dfb1)), closes [#6190](https://github.com/vuetifyjs/vuetify/issues/6190)
* **VFooter:** center content when v-navigation-drawer exists on the right ([#5911](https://github.com/vuetifyjs/vuetify/issues/5911)) ([7e289cc](https://github.com/vuetifyjs/vuetify/commit/7e289cc30c96796a7c2ba8822d2551c29853fb97))
* **VHover:** exception in events binding ([#6335](https://github.com/vuetifyjs/vuetify/issues/6335)) ([79bf76e](https://github.com/vuetifyjs/vuetify/commit/79bf76eafa33e6bb909e21b6326fe1133eba74f1))
* **VHover, VItem:** check for scoped slot array length with vue 2.6 ([9856ed6](https://github.com/vuetifyjs/vuetify/commit/9856ed69bab846bf5fae2d9fe1f412ad58c68c92))
* **VIcon:** trim whitespace in icon name ([#6408](https://github.com/vuetifyjs/vuetify/issues/6408)) ([dc9547b](https://github.com/vuetifyjs/vuetify/commit/dc9547b608cb6658c5ad1798e5280e3d6a0b9635)), closes [#6404](https://github.com/vuetifyjs/vuetify/issues/6404)
* **VLabel:** merge VNode data ([9b6de46](https://github.com/vuetifyjs/vuetify/commit/9b6de466828684720fa067db07d301b4bb726c56)), closes [#6245](https://github.com/vuetifyjs/vuetify/issues/6245)
* **VMenu:** don't close on tab if child element has focus ([#5716](https://github.com/vuetifyjs/vuetify/issues/5716)) ([ad182c2](https://github.com/vuetifyjs/vuetify/commit/ad182c267db245c36ff40acd8ac87c3233387667)), closes [#5103](https://github.com/vuetifyjs/vuetify/issues/5103)
* **VMenu:** don't prevent default on keydown unless action taken ([#6339](https://github.com/vuetifyjs/vuetify/issues/6339)) ([cf2ba83](https://github.com/vuetifyjs/vuetify/commit/cf2ba83d66755e52d22b3ea4a9ba68ab495572d2)), closes [#2988](https://github.com/vuetifyjs/vuetify/issues/2988)
* **VMenu:** improve position when using offset, width and attach props ([#6193](https://github.com/vuetifyjs/vuetify/issues/6193)) ([bfad3d8](https://github.com/vuetifyjs/vuetify/commit/bfad3d8fe146cb7f6b16840f8816f48cac4ddd42)), closes [#5498](https://github.com/vuetifyjs/vuetify/issues/5498)
* **VMenu:** initial computation of NaN ([7093d3d](https://github.com/vuetifyjs/vuetify/commit/7093d3d6068b51cf021672f2e260df88fd0441df))
* **VMenu:** prevent scroll on keydown ([#5872](https://github.com/vuetifyjs/vuetify/issues/5872)) ([cfe48d7](https://github.com/vuetifyjs/vuetify/commit/cfe48d7a8a9be48186a71c55c777540f6e6194cb)), closes [#5714](https://github.com/vuetifyjs/vuetify/issues/5714)
* **VMenu:** show menu if value isActive on mount ([094a85e](https://github.com/vuetifyjs/vuetify/commit/094a85e4a0a2bac1f706620fd74052f4efe25d70)), closes [#6034](https://github.com/vuetifyjs/vuetify/issues/6034)
* **VMenu:** update position dynamically ([#6330](https://github.com/vuetifyjs/vuetify/issues/6330)) ([349e2b1](https://github.com/vuetifyjs/vuetify/commit/349e2b1924db6abce51741f57cbd6234db88bbb9)), closes [#4956](https://github.com/vuetifyjs/vuetify/issues/4956)
* **VNavigationDrawer:** remove max-height style when undefined ([7e310db](https://github.com/vuetifyjs/vuetify/commit/7e310db858721d00676630d4441da964742d737c))
* **VRadio:** fix `focus` event ([#5905](https://github.com/vuetifyjs/vuetify/issues/5905)) ([ea30e13](https://github.com/vuetifyjs/vuetify/commit/ea30e1361b1444af9bc43085febf1f2e0c39db4d))
* **VSelect:** don't emit change event when clicked on the selected item  ([#6054](https://github.com/vuetifyjs/vuetify/issues/6054)) ([a032214](https://github.com/vuetifyjs/vuetify/commit/a032214406176b4534cbdff946cd09bcaffd0675))
* **VSelect:** don't render a list tile if provided by item slot ([e19189c](https://github.com/vuetifyjs/vuetify/commit/e19189c4e7c237835599f35ab485a4bb33c02904)), closes [#6376](https://github.com/vuetifyjs/vuetify/issues/6376)
* **VSelect:** emit change after input event ([d7b8288](https://github.com/vuetifyjs/vuetify/commit/d7b82889c31f7695e73a9e0ba321ed9138f885ab)), closes [#6136](https://github.com/vuetifyjs/vuetify/issues/6136)
* **VSelect:** remove tabindex on chips ([f19a207](https://github.com/vuetifyjs/vuetify/commit/f19a2071d69c1cf3669d447e3e0d12282426d94a))
* **VSheet:** add missing transition ([6d782bb](https://github.com/vuetifyjs/vuetify/commit/6d782bb7b5cebef86bc43ed0451440446405b8f6))
* **VSparkline:** fix bar type ([#6370](https://github.com/vuetifyjs/vuetify/issues/6370)) ([fe03a7a](https://github.com/vuetifyjs/vuetify/commit/fe03a7a57da7b0262613f51950fe5ed546728b74))
* **VTextField:** correct styles with **full-width** prop ([9d964b3](https://github.com/vuetifyjs/vuetify/commit/9d964b385a0e5f292671328dd40520ccd0c82764)), closes [#4544](https://github.com/vuetifyjs/vuetify/issues/4544)
* **VTimePicker:** emit change event after clicking minutes/seconds ([#6079](https://github.com/vuetifyjs/vuetify/issues/6079)) ([e9c9b58](https://github.com/vuetifyjs/vuetify/commit/e9c9b584372c7c25eac0a3a52dbc3d699483f90b)), closes [#5951](https://github.com/vuetifyjs/vuetify/issues/5951)
* **VTimePicker:** remove unnecessary mixins prop ([fab2488](https://github.com/vuetifyjs/vuetify/commit/fab24887c14fd1813fd8f30b372640dd5a118d01))
* **VTooltip:** Update tooltip position dynamically ([#5967](https://github.com/vuetifyjs/vuetify/issues/5967)) ([84e5807](https://github.com/vuetifyjs/vuetify/commit/84e580775a63b5c619e8d02708700b50484ec85a)), closes [#4396](https://github.com/vuetifyjs/vuetify/issues/4396)
* **VTreeview:** correcly handle updating items array of equal size ([#6202](https://github.com/vuetifyjs/vuetify/issues/6202)) ([4177931](https://github.com/vuetifyjs/vuetify/commit/41779317121c30e6d386cccc098af02b055c79ce)), closes [#6181](https://github.com/vuetifyjs/vuetify/issues/6181)
* lint comments ([db99b47](https://github.com/vuetifyjs/vuetify/commit/db99b470ac6eb339c50695b027b213affc0ce814))
* **Btn:** add `v-tab` link functionality to `v-btn` ([0f041ec](https://github.com/vuetifyjs/vuetify/commit/0f041ec6749ed61b478f7e0f5dc027d681badffa)), closes [#5537](https://github.com/vuetifyjs/vuetify/issues/5537)
* **build:** update webpack config for hoisting ([f798f93](https://github.com/vuetifyjs/vuetify/commit/f798f93d8afcf457fb29e61a8ee0c2ca39d86e16))
* **Carousel:** deprecate input event ([a3348e8](https://github.com/vuetifyjs/vuetify/commit/a3348e85380b83ae099c78836443367937e8c6c2)), closes [#5561](https://github.com/vuetifyjs/vuetify/issues/5561)
* **DataTable:** correctly center the selection controls ([#5542](https://github.com/vuetifyjs/vuetify/issues/5542)) ([5b6b76a](https://github.com/vuetifyjs/vuetify/commit/5b6b76a0aef12480fd217fe271dbfa691d682bfe))
* **DataTable:** support nested values for item key ([#5241](https://github.com/vuetifyjs/vuetify/issues/5241)) ([0de73ea](https://github.com/vuetifyjs/vuetify/commit/0de73eaecf2d34ea0f92d04883c25bdb9e76e40c))
* **Dialog:** add/remove overlay and scroll when fullscreen is changed ([#5707](https://github.com/vuetifyjs/vuetify/issues/5707)) ([76db39d](https://github.com/vuetifyjs/vuetify/commit/76db39d6e0937888df8b67db351b0a3934a1f2b4)), closes [#2201](https://github.com/vuetifyjs/vuetify/issues/2201)
* **expand-transition:** remove delay, prevent layout jump when toggling ([a967ef7](https://github.com/vuetifyjs/vuetify/commit/a967ef7e7a765ab96c6d7d936fe01f337a541243))
* **expand-transition:** use a proper FLIP animation w/ offsetHeight ([#5709](https://github.com/vuetifyjs/vuetify/issues/5709)) ([cb605ac](https://github.com/vuetifyjs/vuetify/commit/cb605ac9d73f8f585e0a23591b4d54241950101e)), closes [#5607](https://github.com/vuetifyjs/vuetify/issues/5607)
* **ListTile:** remove duplicate event listeners ([62362c5](https://github.com/vuetifyjs/vuetify/commit/62362c5752167513939f4e9745169ab3dddebc38)), closes [#5383](https://github.com/vuetifyjs/vuetify/issues/5383)
* **Progress:** parse values as floats instead of ints ([454476c](https://github.com/vuetifyjs/vuetify/commit/454476c834eda268191bae876eb14c24f06bbc61)), closes [#5591](https://github.com/vuetifyjs/vuetify/issues/5591)
* **ProgressLinear:** use valid transition function ([f587f7c](https://github.com/vuetifyjs/vuetify/commit/f587f7c64813e7ce75da090ac13bb9fa336b2b71)), closes [#3678](https://github.com/vuetifyjs/vuetify/issues/3678)
* **ripple:** avoid reading back el.style.width ([1058210](https://github.com/vuetifyjs/vuetify/commit/10582102088a65756bb4313ff51bf5d88d6a1114)), closes [#5340](https://github.com/vuetifyjs/vuetify/issues/5340)
* **Select:** add scopeId to VSelectList ([#5574](https://github.com/vuetifyjs/vuetify/issues/5574)) ([49c1e6a](https://github.com/vuetifyjs/vuetify/commit/49c1e6af4d32d781c79b712b7bfce3aa30ab9d60)), closes [#5568](https://github.com/vuetifyjs/vuetify/issues/5568)
* **Select:** remove colon from menu-props suggestion with booleans only ([9cc06fd](https://github.com/vuetifyjs/vuetify/commit/9cc06fda0c641fefc4e7beabadcad76aec18c707))
* **selection-controls:** use ripple even when disabled ([#5710](https://github.com/vuetifyjs/vuetify/issues/5710)) ([2150554](https://github.com/vuetifyjs/vuetify/commit/215055423b9da1ecbe530b5464b4f770c9a2375b)), closes [#5653](https://github.com/vuetifyjs/vuetify/issues/5653)
* **SelectionControls:** increased css specificity for margin ([31f12b9](https://github.com/vuetifyjs/vuetify/commit/31f12b9b58c1cd5a0c367457e4741c8840ab0faf)), closes [#5404](https://github.com/vuetifyjs/vuetify/issues/5404)
* **Spacing:** add missing !important declaration ([862d593](https://github.com/vuetifyjs/vuetify/commit/862d5936c440f8579663b0e2fbbf621e3718a576))
* **TextField:** use correct color for prefix in disabled ([#5648](https://github.com/vuetifyjs/vuetify/issues/5648)) ([13814bd](https://github.com/vuetifyjs/vuetify/commit/13814bdd5cb0eee3142f715fe11b853948030dcd)), closes [#5481](https://github.com/vuetifyjs/vuetify/issues/5481)
* **Treeview:** empty children expand icon ([#5442](https://github.com/vuetifyjs/vuetify/issues/5442)) ([c636f6c](https://github.com/vuetifyjs/vuetify/commit/c636f6cc1b9fba82e1686f5e52e96a5e8e083305)), closes [#5357](https://github.com/vuetifyjs/vuetify/issues/5357)
* **v-expansion-panel:** remove entry animation ([97053db](https://github.com/vuetifyjs/vuetify/commit/97053db366b0c120a1e216f004ae8b8e19100a75)), closes [#4483](https://github.com/vuetifyjs/vuetify/issues/4483)
* **v-menu:** position problem with horizontal scrolling ([#5527](https://github.com/vuetifyjs/vuetify/issues/5527)) ([4acd24d](https://github.com/vuetifyjs/vuetify/commit/4acd24d17b3adea6d4b5406260aee2569bc51d6c))
* **Validatable:** remove validation when readonly or disabled ([945ab47](https://github.com/vuetifyjs/vuetify/commit/945ab473c4f96c8712990212881d3f9c9201b0a5)), closes [#5362](https://github.com/vuetifyjs/vuetify/issues/5362)
* **VAutocomplete:** inherit pointer-events ([592d4c9](https://github.com/vuetifyjs/vuetify/commit/592d4c96b0fdc489b1c65707bc82a570afac56a5)), closes [#5615](https://github.com/vuetifyjs/vuetify/issues/5615)
* **VButton:** removed background from diabled outline btn ([31cfae6](https://github.com/vuetifyjs/vuetify/commit/31cfae6167977a95e4c43a27f25f392bc88f51df))
* **VChip:** avatar size in small chips ([eefc276](https://github.com/vuetifyjs/vuetify/commit/eefc2768742507f95abc6050f96e761e0f6e9cb1)), closes [#3225](https://github.com/vuetifyjs/vuetify/issues/3225)
* **VExpansionPanel:** pass boolean value to toggle method ([ebc5aaf](https://github.com/vuetifyjs/vuetify/commit/ebc5aafeec27d3a299b2912168b47bda425fe380)), closes [#5703](https://github.com/vuetifyjs/vuetify/issues/5703)
* **VMenu:** auto positioning with dense prop ([#5448](https://github.com/vuetifyjs/vuetify/issues/5448)) ([6f75590](https://github.com/vuetifyjs/vuetify/commit/6f755909119c899a57569c8afb42735d2d2ae53d)), closes [#5149](https://github.com/vuetifyjs/vuetify/issues/5149)
* **VSelect:** don't handle mouseup if there was no mousedown ([e984bf3](https://github.com/vuetifyjs/vuetify/commit/e984bf33533010e563a4acd567d9cea0c8842074)), closes [#5665](https://github.com/vuetifyjs/vuetify/issues/5665)
* re-emit click events ([390d289](https://github.com/vuetifyjs/vuetify/commit/390d2897e6147b78fdaebb4155e1b81439800a5f)), closes [#2477](https://github.com/vuetifyjs/vuetify/issues/2477)
* **DataIterator:** bug when given items smaller than current items ([#5440](https://github.com/vuetifyjs/vuetify/issues/5440)) ([c9b52d1](https://github.com/vuetifyjs/vuetify/commit/c9b52d156f8ef4beb1f6227df59dbcbe3e8ae661)), closes [#5426](https://github.com/vuetifyjs/vuetify/issues/5426)
* **Dialog:** fix IE11 issue with nested flexbox on scrollable dialog ([dfcedde](https://github.com/vuetifyjs/vuetify/commit/dfcedde9bc3861d29555508a45023cc5143943cf))
* **kitchen:** fix some issues with VBtn pan ([3257648](https://github.com/vuetifyjs/vuetify/commit/32576480bb3715f78d8427974eeed275ece86d30))
* **kitchen:** fix VImg pan name ([b6f5fee](https://github.com/vuetifyjs/vuetify/commit/b6f5fee4af56fecef647fefc236446910867d10e))
* **kitchen:** seperate alert v-models ([e6978ef](https://github.com/vuetifyjs/vuetify/commit/e6978ef3564dfc7f5219adca3b8baa5f08393c73))
* **menuable:** set correct position with left+attach+offset-x ([f561ca2](https://github.com/vuetifyjs/vuetify/commit/f561ca2c13748211905bc2af8ec5805d13929df8)), closes [#5318](https://github.com/vuetifyjs/vuetify/issues/5318)
* **ripple:** fix in transition ([46da381](https://github.com/vuetifyjs/vuetify/commit/46da381bb048b9a1848f7875373868cfb03b5bcf))
* **scss:** fixed build error ([dfedf80](https://github.com/vuetifyjs/vuetify/commit/dfedf8093fcf7ce30b055cb0a7c949fa0d74e361))
* **snackbar:** add rtl to snackbar ([#6013](https://github.com/vuetifyjs/vuetify/issues/6013)) ([4f18a8c](https://github.com/vuetifyjs/vuetify/commit/4f18a8c03fb17df7611bb3b11939c7dec5448edb))
* **snackbar:** fixed deleted rtl style [#6013](https://github.com/vuetifyjs/vuetify/issues/6013) ([24c47f4](https://github.com/vuetifyjs/vuetify/commit/24c47f4de83a24680749199779d052e4ffba435c))
* **SponsorBtn:** update to prop value ([e070107](https://github.com/vuetifyjs/vuetify/commit/e07010745e65f87dade43e5b4078671eea839ed7))
* **text-field:** text-field's label overlap with long prefix. ([a438ccd](https://github.com/vuetifyjs/vuetify/commit/a438ccde106ba198bee1c4f46e9288adee8b419a)), closes [#3485](https://github.com/vuetifyjs/vuetify/issues/3485)
* **theme:** make theme work properly ([7238812](https://github.com/vuetifyjs/vuetify/commit/7238812996cfe23c4689068d8e5de57eefcce9e3))
* **v-tabs:** fix slider entry time ([50dd6a4](https://github.com/vuetifyjs/vuetify/commit/50dd6a4a525d392c1a44c4df8f96b8963fc6c898)), closes [#5371](https://github.com/vuetifyjs/vuetify/issues/5371) [#5371](https://github.com/vuetifyjs/vuetify/issues/5371)
* **validatable:** update external messages to accept null value ([eef7d4f](https://github.com/vuetifyjs/vuetify/commit/eef7d4f7bba55fb91080fda448df38bac4b761e7)), closes [#6025](https://github.com/vuetifyjs/vuetify/issues/6025)
* **VBtn:** add block display property ([87f6b09](https://github.com/vuetifyjs/vuetify/commit/87f6b09e797673acd223d4de81c773374d9fcc1e))
* **VBtn:** add elevation functionality, fix unit tests ([6861a5f](https://github.com/vuetifyjs/vuetify/commit/6861a5f5b7a721ba166df93cc6aae94f9b6b16c7))
* **VBtn:** apply correct color to text ([262d691](https://github.com/vuetifyjs/vuetify/commit/262d6917474da095488cb89dbc1d81480a576d67))
* **VBtn:** enable parent activeClass if present ([433ca20](https://github.com/vuetifyjs/vuetify/commit/433ca20f6076dac15446c49ff673c6ba6edae25d))
* **VBtn:** outline color should be [#0000001](https://github.com/vuetifyjs/vuetify/issues/0000001)e ([01eba83](https://github.com/vuetifyjs/vuetify/commit/01eba832fdc993fa82b84e11f3c4b7f782af8ae9))
* **VBtn:** remove background-color style from depressed btn ([7828e1d](https://github.com/vuetifyjs/vuetify/commit/7828e1d6bbfafbeed629f282fa1ee340b4fcde7a))
* **VBtn:** remove contained if user provides elevation ([b2e5c82](https://github.com/vuetifyjs/vuetify/commit/b2e5c8288ab1ba921642a48e1d7ddcbcbed42cfe))
* **VBtn:** remove shadow from disabled btn ([c569a83](https://github.com/vuetifyjs/vuetify/commit/c569a83ce3a9fa92003e6bf9d43f4798fd601d1b))
* **VChip:** dark mode ([#5449](https://github.com/vuetifyjs/vuetify/issues/5449)) ([3e9673e](https://github.com/vuetifyjs/vuetify/commit/3e9673eea03cf0225877dfa1a8987c09bfd221c9)), closes [#5074](https://github.com/vuetifyjs/vuetify/issues/5074)
* **VEditDialog:** use text VBtn style instead of deprecated flat style ([f41bf38](https://github.com/vuetifyjs/vuetify/commit/f41bf38d1e13599d823525547b41596b9c78b268))
* **VList:** hide input messages only when in .v-list__tile__action ([#5578](https://github.com/vuetifyjs/vuetify/issues/5578)) ([78e76ff](https://github.com/vuetifyjs/vuetify/commit/78e76ff424f328f8aa468deaf4f5590704ebdd04)), closes [#5553](https://github.com/vuetifyjs/vuetify/issues/5553)
* **VList:** rtl ([#5464](https://github.com/vuetifyjs/vuetify/issues/5464)) ([f5aeb00](https://github.com/vuetifyjs/vuetify/commit/f5aeb0088f09574d2e082a2d7b3722a8362c276b)), closes [#4606](https://github.com/vuetifyjs/vuetify/issues/4606)
* **VListGroup:** text overflow ([#5451](https://github.com/vuetifyjs/vuetify/issues/5451)) ([8bd9ce1](https://github.com/vuetifyjs/vuetify/commit/8bd9ce152515997bb4f475b4af11a04a820e959d)), closes [#3038](https://github.com/vuetifyjs/vuetify/issues/3038)
* **VOverflowBtn:** apply correct cursor ([#5943](https://github.com/vuetifyjs/vuetify/issues/5943)) ([6cf3287](https://github.com/vuetifyjs/vuetify/commit/6cf328753dbcbbf193f50a73b3302993c7cc36a6))
* **VOverflowBtn:** remove top padding to fix alignment ([86290be](https://github.com/vuetifyjs/vuetify/commit/86290bec6864a279885ef26c673a5b3128395af4))
* **VPicker:** landscape layout bug ([e180e9e](https://github.com/vuetifyjs/vuetify/commit/e180e9e85fdb442abff769e481cd8c96ec900193))
* **VRadioGroup:** main label spacing ([#5463](https://github.com/vuetifyjs/vuetify/issues/5463)) ([ab03b4d](https://github.com/vuetifyjs/vuetify/commit/ab03b4d0601f9193ac6aeb666b9849601e77475d)), closes [#5455](https://github.com/vuetifyjs/vuetify/issues/5455)
* **VSelect:** dont open menu on keydown when readonly ([#5450](https://github.com/vuetifyjs/vuetify/issues/5450)) ([773f119](https://github.com/vuetifyjs/vuetify/commit/773f119cba2392edf1da854dd972b296bd9c3e47)), closes [#5005](https://github.com/vuetifyjs/vuetify/issues/5005)
* **VSelect:** fix rendering without attrs ([#5973](https://github.com/vuetifyjs/vuetify/issues/5973)) ([a55ff28](https://github.com/vuetifyjs/vuetify/commit/a55ff28ded0699bfb4066b4b358f1f29e0f39548))
* **VSelect:** stop keydown.esc propagation ([#5579](https://github.com/vuetifyjs/vuetify/issues/5579)) ([6657fe7](https://github.com/vuetifyjs/vuetify/commit/6657fe78a34dc5e358d371fdef25f4654dd513c2)), closes [#5560](https://github.com/vuetifyjs/vuetify/issues/5560)
* **VTextField:** outline border color in error state ([#5447](https://github.com/vuetifyjs/vuetify/issues/5447)) ([02b9e79](https://github.com/vuetifyjs/vuetify/commit/02b9e7972104129bbc3f26ddea4e879f43d8ea7a)), closes [#5274](https://github.com/vuetifyjs/vuetify/issues/5274)
* **VTextField:** use available space for active label ([#5577](https://github.com/vuetifyjs/vuetify/issues/5577)) ([161222c](https://github.com/vuetifyjs/vuetify/commit/161222cc2b3bedec18e64b1223116d0bc8c03c30)), closes [#5555](https://github.com/vuetifyjs/vuetify/issues/5555)
* **VTreeview:** arrow direction in rtl ([#5535](https://github.com/vuetifyjs/vuetify/issues/5535)) ([e65ed5b](https://github.com/vuetifyjs/vuetify/commit/e65ed5b923ef2ea4374403fdf2a5d5cf4d7c9bd8)), closes [#5534](https://github.com/vuetifyjs/vuetify/issues/5534)
* added comment to generated file ([795babc](https://github.com/vuetifyjs/vuetify/commit/795babc6edd91d6a7d611903fe702b18505ba381))
* added grid component props to map ([202b7b7](https://github.com/vuetifyjs/vuetify/commit/202b7b7dea2d9f60c62678c5ad499ad41b351e2c))
* added missing mdi icons for codepen ([09243df](https://github.com/vuetifyjs/vuetify/commit/09243df9527f3783c6e66000f0b18351e1be5376)), closes [#655](https://github.com/vuetifyjs/vuetify/issues/655)
* added speed-dial slots to map ([dc77902](https://github.com/vuetifyjs/vuetify/commit/dc77902cdc09eec9429948b33368ba8d1d00e49f))
* added v-text-field label slot ([b8db800](https://github.com/vuetifyjs/vuetify/commit/b8db800814d575b55f2f5e6ab7c8026790994fff))
* bind empty object to prop default function ([9a1756f](https://github.com/vuetifyjs/vuetify/commit/9a1756feb6fdcb3b9f1cc211cd64f6bdd829ea8e))
* fix bootable transition ([9a7be1f](https://github.com/vuetifyjs/vuetify/commit/9a7be1f164dacded2b98f57808ee003be4de761e))
* make tests pass ([9b2dce8](https://github.com/vuetifyjs/vuetify/commit/9b2dce82e3e5421411244243bd175abe8792905d))
* **a-la-carte:** fix section id ([1a73ed4](https://github.com/vuetifyjs/vuetify/commit/1a73ed422c4073cc104eb93f31cf4500e60d76e8)), closes [#518](https://github.com/vuetifyjs/vuetify/issues/518)
* **ads:** change dom position ([a5c881c](https://github.com/vuetifyjs/vuetify/commit/a5c881c51267b899ae8ae8c8c59715d766963ad1))
* **ads:** hide on home page ([04b870c](https://github.com/vuetifyjs/vuetify/commit/04b870c8b1f6d820c6fec669131ff8ab520dff11))
* **analytics:** fix double collect on page load ([c24a42d](https://github.com/vuetifyjs/vuetify/commit/c24a42d2e2f0740224156c075d6d82d614ef549d))
* **api-explorer:** fix 500 ([4fab45f](https://github.com/vuetifyjs/vuetify/commit/4fab45f843661c8b35065b132f6873975377605e))
* **backers:** fix backers ([ef787e6](https://github.com/vuetifyjs/vuetify/commit/ef787e6d5a9f2c5c416a394837e495273fdcc2b1))
* **Btn:** avoid setting bg with disabled and color prop ([#5734](https://github.com/vuetifyjs/vuetify/issues/5734)) ([069558a](https://github.com/vuetifyjs/vuetify/commit/069558a00a573d0ce46bdaee834f533e096501ec)), closes [#5720](https://github.com/vuetifyjs/vuetify/issues/5720)
* **carousel-model:** fix default type ([8b04e37](https://github.com/vuetifyjs/vuetify/commit/8b04e37ddecd675d3bc3106b5a24256712f7968d))
* **checkout:** fix ability to checkout ([925ccea](https://github.com/vuetifyjs/vuetify/commit/925ccea3fe910ad0eddca630f3215ebb0486004d))
* **components:** fixed doc-subtitle and helpers-markdown ([4588750](https://github.com/vuetifyjs/vuetify/commit/45887509b0ac9baf756f1d33ce44071efe79c60a))
* **components.json:** added missing `v-btn-toggle` ([6e11b48](https://github.com/vuetifyjs/vuetify/commit/6e11b4885fa170e35135d8ade1ee6ce4b552e000))
* **example:** fix expand code ([b7c8989](https://github.com/vuetifyjs/vuetify/commit/b7c8989efc361ecab367dd454f68c4fffb593590))
* **Example:** make source expansion panel lazy ([28cac3f](https://github.com/vuetifyjs/vuetify/commit/28cac3f64f68d08dd6355c169180c9662ceedad1))
* **ExampleView:** hide current tab if selected component has no api ([a3533e7](https://github.com/vuetifyjs/vuetify/commit/a3533e7fdd167d7d5e9690eaa3ae60e25ebc7ffc))
* remove pug string literal ([f9b90ff](https://github.com/vuetifyjs/vuetify/commit/f9b90ffddd3c93e45ef593a1c4391f84fff7ee0f))
* **examples:** place other code above component instance ([6106920](https://github.com/vuetifyjs/vuetify/commit/610692081ca160825dc1103c4a645e687580adad))
* **examples:** remove drawer transition in image ratio example ([7b73149](https://github.com/vuetifyjs/vuetify/commit/7b73149ba5495271c64091d9632c400f50ed5bfa))
* **expand-transition:** reset initial state when cancelled ([a039846](https://github.com/vuetifyjs/vuetify/commit/a0398467479c094a0faa35d549082f4a4246e381))
* **faq:** markup ([2b7603d](https://github.com/vuetifyjs/vuetify/commit/2b7603d10df40a1b56e12270572e9fae06cb1fbf))
* **footer-alt:** fix mobile display ([462e510](https://github.com/vuetifyjs/vuetify/commit/462e510c385f43fe146d2686ee8b9bd4f99e7ed5))
* **forms:** simplify regexp ([a56be72](https://github.com/vuetifyjs/vuetify/commit/a56be72c549798594aaa6a87b67381e72f3ca7ec)), closes [#512](https://github.com/vuetifyjs/vuetify/issues/512)
* **kbd:** fix `kbd` background color ([#5864](https://github.com/vuetifyjs/vuetify/issues/5864)) ([28f61b5](https://github.com/vuetifyjs/vuetify/commit/28f61b51586fd0a940f392d73ee5c56c07d1720a))
* **manifest:** icon pathing in manifest ([4738ca0](https://github.com/vuetifyjs/vuetify/commit/4738ca00e92eda13c3eb9d8880fc6cfd61332835))
* **markup:** icon font colour and highlighting in examples ([a3ac135](https://github.com/vuetifyjs/vuetify/commit/a3ac1351d4910a850e498ca0ed5f71a22a422f9e))
* **menuable:** account for top+left ([50ab611](https://github.com/vuetifyjs/vuetify/commit/50ab6111b3c5f17c270c43be435e8f6c76033bec)), closes [#5318](https://github.com/vuetifyjs/vuetify/issues/5318)
* **meta:** fix facebook meta tags ([b4da0c8](https://github.com/vuetifyjs/vuetify/commit/b4da0c87f3a0fbf592d00842f10389cf6c1a2831))
* **store-toolbar:** adjust height ([b781993](https://github.com/vuetifyjs/vuetify/commit/b78199342bf0961f9390aa72f8cfc68408a1646b))
* **text-fields:** update example ([2584cae](https://github.com/vuetifyjs/vuetify/commit/2584cae866856c79652b1989e56df43268045201))
* **transitions-page:** fix example display ([b2550e9](https://github.com/vuetifyjs/vuetify/commit/b2550e9e6f2cf802d6584032dbdcfc21838c97b6))
* **translatable:** fix 500 on build ([6a010b8](https://github.com/vuetifyjs/vuetify/commit/6a010b88f7afa4f288215deb5da787dfe42b95e2))
* **translations:** rename component ([82b2483](https://github.com/vuetifyjs/vuetify/commit/82b2483f2e4d32ce94bc2ca4934253fa774d8f3e))
* **v-tabs:** update structure ([b04db2c](https://github.com/vuetifyjs/vuetify/commit/b04db2cacb35b181a5420f40b0136960b2383dcf))
* **v-textarea:** fix example ([4c69670](https://github.com/vuetifyjs/vuetify/commit/4c69670b1a1ec58a24bc724e1037e930ed290deb))
* **v-treeview:** add missing headerText ([36578ff](https://github.com/vuetifyjs/vuetify/commit/36578ff265222dfb3a1f2adfa9b1b40d9c9a9998))
* **VImg:** add link to vuetify-loader ([2a417ba](https://github.com/vuetifyjs/vuetify/commit/2a417bab0e536ceb63dbc632f83f531f3ee25dc3))
* broken cdn url ([de3425e](https://github.com/vuetifyjs/vuetify/commit/de3425eaa6fffefe84ced9877e75fe3934c94684))
* Change home image to load from cdn ([#562](https://github.com/vuetifyjs/vuetify/issues/562)) ([3fdfc35](https://github.com/vuetifyjs/vuetify/commit/3fdfc3598cbd50d1881e461e0010f9b9d7ff2314))
* extend wrapped components to correctly resolve options ([2b3405e](https://github.com/vuetifyjs/vuetify/commit/2b3405ea7112388eb1c1a4002ab8fee4afbf4a81))
* font weight on themes and quick start page ([#5474](https://github.com/vuetifyjs/vuetify/issues/5474)) ([a76c44d](https://github.com/vuetifyjs/vuetify/commit/a76c44d0c19fc18665e754993e18def564159e32))
* goto and v-scroll pages were showing the same content ([3ab7370](https://github.com/vuetifyjs/vuetify/commit/3ab7370aef77094cdd05cb64b9851e255a38f887))
* only render ad and toc on client ([5afa9a4](https://github.com/vuetifyjs/vuetify/commit/5afa9a48bcb2a55c41dc992ed32a1eecf4a6fd9f))
* path to github ([055cd84](https://github.com/vuetifyjs/vuetify/commit/055cd8483103ddf85a61444f6227b76cd1833b0b)), closes [#515](https://github.com/vuetifyjs/vuetify/issues/515)
* prevent infinite loop in validation example ([07850b5](https://github.com/vuetifyjs/vuetify/commit/07850b5de15bf9ddf9ed63188135ae598225fc74)), closes [vuetifyjs/vuetify#4640](https://github.com/vuetifyjs/vuetify/issues/4640)
* update search inputs in pre-defined layouts ([f5225e3](https://github.com/vuetifyjs/vuetify/commit/f5225e3bd87c213bc9d543bda767d13d8cacde7b))
* use combobox in chips in select example ([e610429](https://github.com/vuetifyjs/vuetify/commit/e61042906a526e4c53613905d7a53acdadbd4c8a))
* **toc/ad:** remove render on sm-and-down ([f6ff433](https://github.com/vuetifyjs/vuetify/commit/f6ff433b6e95afd37e122b2eb71311ae63ac423f))
* **VBadge:** rtl mode ([#5801](https://github.com/vuetifyjs/vuetify/issues/5801)) ([7eadc37](https://github.com/vuetifyjs/vuetify/commit/7eadc378888344b9b0cd13b756839c49f959d065)), closes [#5684](https://github.com/vuetifyjs/vuetify/issues/5684)
* **VBottomNav:** correct inactive colors ([#5822](https://github.com/vuetifyjs/vuetify/issues/5822)) ([205feed](https://github.com/vuetifyjs/vuetify/commit/205feedd53dd5c078cd4f6644a316caa17fd2dac)), closes [#2685](https://github.com/vuetifyjs/vuetify/issues/2685)
* **VCard:** add missing hover styles ([c1e8a99](https://github.com/vuetifyjs/vuetify/commit/c1e8a99539cb68ec07dbf79cb11e6f8898f47def)), closes [#5815](https://github.com/vuetifyjs/vuetify/issues/5815)
* **VCarousel:** pass `value` property to controls ([#5758](https://github.com/vuetifyjs/vuetify/issues/5758)) ([deb28c4](https://github.com/vuetifyjs/vuetify/commit/deb28c40af44b95c9829d7ca1c7766b3f5a8dc6a))
* **VChip:** rtl mode ([#5802](https://github.com/vuetifyjs/vuetify/issues/5802)) ([45da2ea](https://github.com/vuetifyjs/vuetify/commit/45da2eaae11ae4ada404e2fffef113685a72b405)), closes [#5782](https://github.com/vuetifyjs/vuetify/issues/5782)
* **VCombobox:** menu position may not update if multiple ([#5888](https://github.com/vuetifyjs/vuetify/issues/5888)) ([a1065ca](https://github.com/vuetifyjs/vuetify/commit/a1065ca639b71e51ad30911413b27fe9a165c515))
* **VDataIterator:** pagination width regression ([e015ee3](https://github.com/vuetifyjs/vuetify/commit/e015ee3524ef69341a6c86fb5237345038fca41a)), closes [#4500](https://github.com/vuetifyjs/vuetify/issues/4500)
* **VDataIterator:** select is too tall in IE11 ([#5656](https://github.com/vuetifyjs/vuetify/issues/5656)) ([68a9aec](https://github.com/vuetifyjs/vuetify/commit/68a9aecdb448b13852c150e031228fa3e40ff92e)), closes [#5655](https://github.com/vuetifyjs/vuetify/issues/5655)
* **VDatePicker:** change clickable area of month/year in header ([#5816](https://github.com/vuetifyjs/vuetify/issues/5816)) ([6eca62e](https://github.com/vuetifyjs/vuetify/commit/6eca62e04c9783b7f742c8ee7aa48f41ac29ecca)), closes [#5725](https://github.com/vuetifyjs/vuetify/issues/5725)
* **VDatePicker:** display proper year when model is null ([#5672](https://github.com/vuetifyjs/vuetify/issues/5672)) ([78339a3](https://github.com/vuetifyjs/vuetify/commit/78339a3c2695bbeb3c13cef35be424691401003e)), closes [#5663](https://github.com/vuetifyjs/vuetify/issues/5663)
* **VDialog/VMenu:** enable pointer-events for disabled activator ([#5511](https://github.com/vuetifyjs/vuetify/issues/5511)) ([90d0af9](https://github.com/vuetifyjs/vuetify/commit/90d0af9e5ac3d487c414a1607a665629c07114df)), closes [#5472](https://github.com/vuetifyjs/vuetify/issues/5472)
* **VExpandTransition:** check for parent existence before adding class ([8f15d16](https://github.com/vuetifyjs/vuetify/commit/8f15d1672f17922c4c18d9203b9c4c22119d1fdf)), closes [#5742](https://github.com/vuetifyjs/vuetify/issues/5742)
* **VExpansionPanel:** hide v-card box-shadow ([c639b06](https://github.com/vuetifyjs/vuetify/commit/c639b06c6ab461fb05d072498de5c1843c2843c9))
* **VExpansionPanelContent:** add default value for header destructure ([5d9dcf9](https://github.com/vuetifyjs/vuetify/commit/5d9dcf996defa748b2997a93e4183217873e53a7))
* **VList:** sync icon and text transition ([0781323](https://github.com/vuetifyjs/vuetify/commit/07813232e341d060715c6f4ede2509d994388516)), closes [#4689](https://github.com/vuetifyjs/vuetify/issues/4689)
* **VMenu:** hover stuck open when mouse exits page ([#5844](https://github.com/vuetifyjs/vuetify/issues/5844)) ([62ecb91](https://github.com/vuetifyjs/vuetify/commit/62ecb914f164bb3c8003a6188aca16c808b6bd7c)), closes [#5843](https://github.com/vuetifyjs/vuetify/issues/5843)
* **VProgressCircular:** fix type check for `width` prop ([#5875](https://github.com/vuetifyjs/vuetify/issues/5875)) ([e7eccfc](https://github.com/vuetifyjs/vuetify/commit/e7eccfcd2f98196fe5d6dfce7ebf76bdf16032d0))
* **VSelect:** close menu on tab out ([8a2a1a1](https://github.com/vuetifyjs/vuetify/commit/8a2a1a1b6974ec264e974866b0775f2820dc3503)), closes [#5774](https://github.com/vuetifyjs/vuetify/issues/5774)
* **VSelect:** fix VSelect behavior when switching to another tab ([#5780](https://github.com/vuetifyjs/vuetify/issues/5780)) ([980142f](https://github.com/vuetifyjs/vuetify/commit/980142f5fdd7461fc902710fab7003f195ac2d5e)), closes [#5774](https://github.com/vuetifyjs/vuetify/issues/5774)
* **VSparkline:** adjust gridX calculation ([8fc5dfb](https://github.com/vuetifyjs/vuetify/commit/8fc5dfb7422bdbc318b5ca6502dda5ea3633b8cb))
* **VSparkline:** adjust width and height calculations ([b99d3a4](https://github.com/vuetifyjs/vuetify/commit/b99d3a4466e2a2e3ab5e1ed3f8adb89f5e09b7af))
* **VSparkline:** de-reference points from helper methods ([ca529a4](https://github.com/vuetifyjs/vuetify/commit/ca529a4681be3ccc804b199ea4db38785da40a93))
* **VSparkline:** deconstruct props to avoid mutation error ([f1bdb5f](https://github.com/vuetifyjs/vuetify/commit/f1bdb5fb824ee395022a39224cc6e4dc87d2ea8b))
* **VTabs:** explicitly define tabs bar border-radius ([29a3b08](https://github.com/vuetifyjs/vuetify/commit/29a3b084afcd48fbf6dfe4d32f98998b8ca8c1bd)), closes [#2926](https://github.com/vuetifyjs/vuetify/issues/2926)
* **VTabs:** text field icon in example ([fca09f9](https://github.com/vuetifyjs/vuetify/commit/fca09f906e1ac9b522d709cf0b81dd65f615e8d0))
* **VTextField:** add missing css selector ([4efdee7](https://github.com/vuetifyjs/vuetify/commit/4efdee770eec622fa840b6c7cf5edfb610004fb4)), closes [/github.com/vuetifyjs/vuetify/commit/37c46b6#diff-eeae1149068732892197e1bb41df68fcR62](https://github.com/vuetifyjs//github.com/vuetifyjs/vuetify/commit/37c46b6/issues/diff-eeae1149068732892197e1bb41df68fcR62)
* **VTreeview:** rtl mode ([#5465](https://github.com/vuetifyjs/vuetify/issues/5465)) ([7f534a1](https://github.com/vuetifyjs/vuetify/commit/7f534a1bd9c1617f990f376362def4032d6df8dd)), closes [#5462](https://github.com/vuetifyjs/vuetify/issues/5462)
* **vuetify:** fixed import ([98693e5](https://github.com/vuetifyjs/vuetify/commit/98693e5aaaf816235a699ea19a0b5d00b1adc378))
* **vuetifyjs.com:** update eslint, fix new errors ([1ce344d](https://github.com/vuetifyjs/vuetify/commit/1ce344d3c51946fb92209abd2aced6791b9a2134))
* **WindowItem:** calculate height on leave ([#5590](https://github.com/vuetifyjs/vuetify/issues/5590)) ([af9bbd1](https://github.com/vuetifyjs/vuetify/commit/af9bbd1c80895749a03e4f2c02a43f08b1471aa5)), closes [#5582](https://github.com/vuetifyjs/vuetify/issues/5582)
* **WindowItem:** change how transitionend is processed ([ceddbce](https://github.com/vuetifyjs/vuetify/commit/ceddbce9a16c64d2a1e243b3038e789c4a83750f))
* adds link to issue creator on contributing page ([bef0e94](https://github.com/vuetifyjs/vuetify/commit/bef0e947adb7ee83f69a2eb0218d26ae31803e89)), closes [#383](https://github.com/vuetifyjs/vuetify/issues/383)
* allow card to grow in tealFooter example ([63ae083](https://github.com/vuetifyjs/vuetify/commit/63ae083ffcc4e418f10fa98ff60acde60e877416))
* correct thumbnail URLs on layout/pre-defined ([8d8cccb](https://github.com/vuetifyjs/vuetify/commit/8d8cccbcba26cc10c10d88d280f79c30a7748dd6))
* create dist if not exists ([7b4dd09](https://github.com/vuetifyjs/vuetify/commit/7b4dd09eb0865461c50b720e8f6b49fcdc120fbf))
* don't crash if the url contains "product" ([4302f3f](https://github.com/vuetifyjs/vuetify/commit/4302f3f8e1c03d8d3f4802e65afd64f06452c5fa))
* duplicated keys in v-for ([0f75588](https://github.com/vuetifyjs/vuetify/commit/0f75588e545c57faaf423ac5b69a1621c957cd58)), closes [#377](https://github.com/vuetifyjs/vuetify/issues/377)
* emit correct literal types ([650ad7a](https://github.com/vuetifyjs/vuetify/commit/650ad7a9be4c9e78fa3acfff7c06501f85635b5e))
* get props from depply-extended components ([0298528](https://github.com/vuetifyjs/vuetify/commit/0298528559f5e81b1fe64bbee5f7861e9db17056))
* material design icons css file name ([787a0a1](https://github.com/vuetifyjs/vuetify/commit/787a0a16fc8d7ea7ccfde16cfeaaab42ceb2a08d)), closes [#449](https://github.com/vuetifyjs/vuetify/issues/449)
* removes hover prop from v-btn ([56c5524](https://github.com/vuetifyjs/vuetify/commit/56c552458582e71efe6e5267a5096ef58848f2c7)), closes [#435](https://github.com/vuetifyjs/vuetify/issues/435)
* sort things alphabetically in output ([e1a7eb0](https://github.com/vuetifyjs/vuetify/commit/e1a7eb04eea18a767f946388447a9f613a0f3f02))
* stylus var name (possible breaking change introduced by [#5802](https://github.com/vuetifyjs/vuetify/issues/5802)) ([9e893dd](https://github.com/vuetifyjs/vuetify/commit/9e893ddbd1f42c335f3bae9d95091474dc340be8))
* typescript lint errors ([#5520](https://github.com/vuetifyjs/vuetify/issues/5520)) ([8691e57](https://github.com/vuetifyjs/vuetify/commit/8691e57d988c3761319f9c587150992af7e5b745))
* update async example ([#633](https://github.com/vuetifyjs/vuetify/issues/633)) ([61a9922](https://github.com/vuetifyjs/vuetify/commit/61a992201ede0446b13d7025f770e00cbe04b591))
* update v-breadcrumbs examples and doc test ([#641](https://github.com/vuetifyjs/vuetify/issues/641)) ([11196b5](https://github.com/vuetifyjs/vuetify/commit/11196b550dcb8ddb69f2ed39b68ccb4a83a9092d))
* updated map, added hacky fix for wrapped components ([3d8072b](https://github.com/vuetifyjs/vuetify/commit/3d8072bce9d68257a445aaef09fe14c54f11bf6f))
* updated parsing ([98fd92e](https://github.com/vuetifyjs/vuetify/commit/98fd92eb9c8fd97c8a0079746c1d4782534840ad))
* updated scoped slots, functions and signatures ([c7caaa3](https://github.com/vuetifyjs/vuetify/commit/c7caaa3479a9f883f3e01446e4dfa790d7afa9f4))
* use hyphenate function from Vue ([694f0fd](https://github.com/vuetifyjs/vuetify/commit/694f0fdcddd51528db9895377d9d384802d6b8e7))
* v-progress-* description ([5ca8a5d](https://github.com/vuetifyjs/vuetify/commit/5ca8a5d45d72c894b81946b734bfa7e65f74b00e)), closes [#350](https://github.com/vuetifyjs/vuetify/issues/350)
* **$carousel-example:** updated example to use custom transition ([c51730b](https://github.com/vuetifyjs/vuetify/commit/c51730b42ce302024b66590fa23e610f1d0fa6c7))
* **$carousel-examples:** fixed `customTransition` example ([4470c86](https://github.com/vuetifyjs/vuetify/commit/4470c8627df17ff9f181ef92490d9caf62606243)), closes [#332](https://github.com/vuetifyjs/vuetify/issues/332)
* **$google-contacts:** updated example to use lgAndUp ([b05d778](https://github.com/vuetifyjs/vuetify/commit/b05d7787f0c9bf4f6724e1dbddda03b50edbee78))
* **$home-page:** added missing ref and ga events ([2ad7f67](https://github.com/vuetifyjs/vuetify/commit/2ad7f67eb1474a8d480e74c6f52445b336d8e622))
* **$home-page:** adjusted logo size on mobile ([494be64](https://github.com/vuetifyjs/vuetify/commit/494be642f7b150a36c7163bf8ef350050e529965))
* **$home-page:** fixed feature cards ([19079a8](https://github.com/vuetifyjs/vuetify/commit/19079a8fdb9dd9e96118f23a16a683eef8cb6022))
* **$home-page:** fixed logo size and image hydration ([3428e88](https://github.com/vuetifyjs/vuetify/commit/3428e88f80a19f4c0fd583141b4fe59e0cb5a5ee))
* **$home-page:** removed conditional image size ([d4ea6b9](https://github.com/vuetifyjs/vuetify/commit/d4ea6b997cd84d8bde77a607b40bdae1e9a784fc))
* **api:** updated lists, improved api process ([54038a7](https://github.com/vuetifyjs/vuetify/commit/54038a7ad3b6e8df61dd13c6198b19d937bc8aa7))
* **app-toolbar:** added max-height for smaller screens ([f7ae146](https://github.com/vuetifyjs/vuetify/commit/f7ae146720ab6d07e94f6b5eced399d96a7238ca))
* **codepen:** remove self-closing elements from examples ([4dfb1f5](https://github.com/vuetifyjs/vuetify/commit/4dfb1f5ebee05c48526e3010a414dd429b5b0776))
* **example:** update process for displaying example information ([7a09ecd](https://github.com/vuetifyjs/vuetify/commit/7a09ecdbf60d8b612e14f8b527ee1baffa062ac2))
* **goTo:** add dummy easings object for codepen ([3ff4d0c](https://github.com/vuetifyjs/vuetify/commit/3ff4d0c89aeca879c716898fe6f00553ad3ae0e7))
* **grid-example:** updated markup to fix text wrapping ([327b3ce](https://github.com/vuetifyjs/vuetify/commit/327b3cea8c0b7b84196147c05ae6e4817511c8a4)), closes [#233](https://github.com/vuetifyjs/vuetify/issues/233)
* **lint:** fix lint ([1c22ed3](https://github.com/vuetifyjs/vuetify/commit/1c22ed308db81b2be16882e45ddf5d7c51931c75))
* **product:** fixed in doc navigation product resolution ([79d861f](https://github.com/vuetifyjs/vuetify/commit/79d861fdc4f9cf02589dd5275c0f8314adbcd248))
* **subheaders:** add missing spacer to list example ([#430](https://github.com/vuetifyjs/vuetify/issues/430)) ([75f3d51](https://github.com/vuetifyjs/vuetify/commit/75f3d517c93a1eb887044089ffd61d9ac065d2c4))
* **VTextField:** border color in error state ([d6d65f3](https://github.com/vuetifyjs/vuetify/commit/d6d65f334ecdb78c99117499dff95501b3a96fdf)), closes [#5738](https://github.com/vuetifyjs/vuetify/issues/5738)
* **VTextField:** css rules were applied to checkboxes in v-select menu ([#5595](https://github.com/vuetifyjs/vuetify/issues/5595)) ([37c46b6](https://github.com/vuetifyjs/vuetify/commit/37c46b62b4896a79440e500ed5acb37d1fab7cab)), closes [#5508](https://github.com/vuetifyjs/vuetify/issues/5508)
* **VTimePicker:** adjust inner/outer circle click detection in 24hr ([f148646](https://github.com/vuetifyjs/vuetify/commit/f1486465806da60977c74262e431483c7da8e38a))
* **VTimePicker:** emit proper value in change event ([#5680](https://github.com/vuetifyjs/vuetify/issues/5680)) ([8e67ed7](https://github.com/vuetifyjs/vuetify/commit/8e67ed7f18180ea7bde08b8c6efa5086cb2d3c9a)), closes [#5266](https://github.com/vuetifyjs/vuetify/issues/5266)
* **VToolbarTitle:** rtl mode ([#5642](https://github.com/vuetifyjs/vuetify/issues/5642)) ([993fa6d](https://github.com/vuetifyjs/vuetify/commit/993fa6dc9b67e9993730f5f88a275a5ef14ea054))
* **VTreeview:** active-class applies to node and all its children ([98bf6f9](https://github.com/vuetifyjs/vuetify/commit/98bf6f9f140b696f26904a77830bb0534946fd3e))
* **VTreeview:** active-class applies to node and all its children ([#5978](https://github.com/vuetifyjs/vuetify/issues/5978)) ([3920f0e](https://github.com/vuetifyjs/vuetify/commit/3920f0e19d5512899ac68bcb63ad63e74dfd1c55)), closes [#5854](https://github.com/vuetifyjs/vuetify/issues/5854)
* **VTreeview:** async loading using custom children key ([#5977](https://github.com/vuetifyjs/vuetify/issues/5977)) ([ca3e464](https://github.com/vuetifyjs/vuetify/commit/ca3e4640a64f50f77533072ce8ed0b96c7e42ba3)), closes [#5550](https://github.com/vuetifyjs/vuetify/issues/5550)
* **VTreeview:** bug when removing and adding children ([#5991](https://github.com/vuetifyjs/vuetify/issues/5991)) ([3f2bb42](https://github.com/vuetifyjs/vuetify/commit/3f2bb42ac6ddd49dd6554bf6fa0d5eb0d3b00e1b)), closes [#5719](https://github.com/vuetifyjs/vuetify/issues/5719)
* **VTreeview:** open-all not working with some item keys ([#5976](https://github.com/vuetifyjs/vuetify/issues/5976)) ([d5f8266](https://github.com/vuetifyjs/vuetify/commit/d5f82663f0cd76af9c49a29956738c0da4a98fb2)), closes [#5711](https://github.com/vuetifyjs/vuetify/issues/5711)
* **VWindowItem:** ensure afterEnter fires with no transition ([8a1b483](https://github.com/vuetifyjs/vuetify/commit/8a1b48304b64ff001e9feda3c64a23883448d76b)), closes [#5683](https://github.com/vuetifyjs/vuetify/issues/5683)
* correct current language flag URL ([921a58b](https://github.com/vuetifyjs/vuetify/commit/921a58bc0da1abbded271b1200004509e19d41ce))
* markdown on treeview headers ([7c8c189](https://github.com/vuetifyjs/vuetify/commit/7c8c189b6319706ffe31d4b6db6ca541e954873b))
* only cache succesful requests ([dbe18b4](https://github.com/vuetifyjs/vuetify/commit/dbe18b4981ba13964a8c4b68966d6ae714168a64))
* remove spaces from closing tags ([0380a26](https://github.com/vuetifyjs/vuetify/commit/0380a266ee035e7e349eabbd7c8ff5dadecf9b26))
* update some missed fa icons ([0806b71](https://github.com/vuetifyjs/vuetify/commit/0806b710f3ffe2549451a9c604997eb7c13aebf7)), closes [#341](https://github.com/vuetifyjs/vuetify/issues/341)
* uppercased hover ([1ac34c7](https://github.com/vuetifyjs/vuetify/commit/1ac34c7c90cea11e048df094b45a280edf8836a2))
* **application:** update types ([03afa59](https://github.com/vuetifyjs/vuetify/commit/03afa59f2ba82fa78e3d371b2a8fd7f9eafc4833))
* **dependent/v-dialog:** add v-dialog to dependency chain ([475d5e5](https://github.com/vuetifyjs/vuetify/commit/475d5e5537687e532252728bbf6d833c2fe9cda1)), closes [#4585](https://github.com/vuetifyjs/vuetify/issues/4585)
* **directives:** remove name ([214e561](https://github.com/vuetifyjs/vuetify/commit/214e56106ad4dbbdbd730cbdfe91102eacb09c94))
* **dividers:** prevent from growing in the wrong direction ([6754fc4](https://github.com/vuetifyjs/vuetify/commit/6754fc4d77dd3dbd99372373740f53a78b6f53d5)), closes [#4641](https://github.com/vuetifyjs/vuetify/issues/4641) [#4615](https://github.com/vuetifyjs/vuetify/issues/4615)
* **helpers:** change priority of padding and margin helpers ([#4559](https://github.com/vuetifyjs/vuetify/issues/4559)) ([3e72c8f](https://github.com/vuetifyjs/vuetify/commit/3e72c8f24854a669c66412e322656fcb9a0fcf2c))
* **index.d.ts:** added footer to VuetifyApplication ([7df6316](https://github.com/vuetifyjs/vuetify/commit/7df63160e65f18274ee4d54d30c60296404f1a2d))
* **inputs:** don't override aria-label attribute ([098d07b](https://github.com/vuetifyjs/vuetify/commit/098d07be773bc5272518c90d99bf85929aa9f979)), closes [#4642](https://github.com/vuetifyjs/vuetify/issues/4642)
* **inputs:** emit icon click events correctly ([1040ccd](https://github.com/vuetifyjs/vuetify/commit/1040ccda152e0f6de897322bdff7292462ee6c8d)), closes [#4647](https://github.com/vuetifyjs/vuetify/issues/4647) [#4545](https://github.com/vuetifyjs/vuetify/issues/4545)
* **inputs:** tweak vertical alignment ([#4803](https://github.com/vuetifyjs/vuetify/issues/4803)) ([c45b600](https://github.com/vuetifyjs/vuetify/commit/c45b6003f5c084a7463f1e51ce4070fa4f8770be))
* **lang:** corrected spelling ([50bff57](https://github.com/vuetifyjs/vuetify/commit/50bff573d6201781eeece4b9b9e76edd86655245))
* **overlayable:** add check for contenteditable ([a82c492](https://github.com/vuetifyjs/vuetify/commit/a82c492db03d3ee85057384fe119863191ecf14b)), closes [#4715](https://github.com/vuetifyjs/vuetify/issues/4715)
* **overlayable:** check for overlay after animationFrame ([94b3666](https://github.com/vuetifyjs/vuetify/commit/94b3666d2a2e1fabc165010e18c8e1d00695985a)), closes [#4678](https://github.com/vuetifyjs/vuetify/issues/4678)
* **readme:** replace broken images ([4395c3b](https://github.com/vuetifyjs/vuetify/commit/4395c3b66ace8b6f4e52380a34aceb0702d95e21))
* **select:** updated minWidth description ([b67efde](https://github.com/vuetifyjs/vuetify/commit/b67efde8dbb1f7a26dcd4b9778c77555e27545c5)), closes [#232](https://github.com/vuetifyjs/vuetify/issues/232)
* **selectable:** pass disabled prop to internal input ([d5cfdc2](https://github.com/vuetifyjs/vuetify/commit/d5cfdc2bc125c2e3e7739d50f9087a86b30a6386)), closes [#4796](https://github.com/vuetifyjs/vuetify/issues/4796) [#4797](https://github.com/vuetifyjs/vuetify/issues/4797)
* **sizeable:** add name for api-generator ([109319e](https://github.com/vuetifyjs/vuetify/commit/109319e68020cbb361b5bda2c2b9837ec9585e6d))
* **snackbars:** fixed snackbars not being shown on docs ([84a1241](https://github.com/vuetifyjs/vuetify/commit/84a1241e0cc27578d67840118f0853bdb9f5d735)), closes [#179](https://github.com/vuetifyjs/vuetify/issues/179)
* **theme:** added documentation on custom theme options ([573e920](https://github.com/vuetifyjs/vuetify/commit/573e920a7be9df433524cd1aaed409c4b0ccbd04)), closes [#202](https://github.com/vuetifyjs/vuetify/issues/202)
* **theme:** lighten-1 should be darker than lighten-5 ([7f38e4a](https://github.com/vuetifyjs/vuetify/commit/7f38e4a7f173fcb2f34e84fa25d89abf90097ce6)), closes [#4751](https://github.com/vuetifyjs/vuetify/issues/4751)
* **toolbar-logo:** fixed size for ie11 ([4f0826a](https://github.com/vuetifyjs/vuetify/commit/4f0826a1900b90f225a02832556224bdfecbfa62)), closes [#227](https://github.com/vuetifyjs/vuetify/issues/227)
* **touch:** update types ([6d9c35e](https://github.com/vuetifyjs/vuetify/commit/6d9c35ef56a69a2183581a18b117331aebe23d5d))
* **types:** prevent type leak in Toggleable, add $el to VBtn ([#4598](https://github.com/vuetifyjs/vuetify/issues/4598)) ([da5b902](https://github.com/vuetifyjs/vuetify/commit/da5b902ae90a7aa16eaffa89ab65b88284e385b7))
* **v-btn:** fix outline height ([7abf1aa](https://github.com/vuetifyjs/vuetify/commit/7abf1aa1cea8dad76543f3d554c1d702e81f70cf)), closes [#3068](https://github.com/vuetifyjs/vuetify/issues/3068) [#3127](https://github.com/vuetifyjs/vuetify/issues/3127)
* **v-combobox:** change logic for updating combobox ([37bfe03](https://github.com/vuetifyjs/vuetify/commit/37bfe032dcbe5acf37df6627867f46a75a000e1f)), closes [#4595](https://github.com/vuetifyjs/vuetify/issues/4595)
* **v-data-table:** fix icon alignment for mdi ([e22e24e](https://github.com/vuetifyjs/vuetify/commit/e22e24e51ac011bbc0d4dc77ad44f6375590277f))
* **v-expansion-panel:** assume auto height if no scroll height ([e084f27](https://github.com/vuetifyjs/vuetify/commit/e084f2787e922772e77e961efc31d8b104486818))
* **v-footer:** fix application size ([deaf2c8](https://github.com/vuetifyjs/vuetify/commit/deaf2c87cbf071cb12fee11e85a0114a7d007528))
* **v-form:** restore ability to work with inputs through $refs ([#4593](https://github.com/vuetifyjs/vuetify/issues/4593)) ([52f7357](https://github.com/vuetifyjs/vuetify/commit/52f73573285423fe46f0623d3d6be66efb53804e))
* **v-list:** fix group dividers ([e003a55](https://github.com/vuetifyjs/vuetify/commit/e003a55db02c73aa6092d3a6c052a0da37b8496c))
* **v-navigation-drawer:** fix application interaction ([cc4959f](https://github.com/vuetifyjs/vuetify/commit/cc4959f0f68487d9359d8bec48f14e36a42e7cf2)), closes [#2901](https://github.com/vuetifyjs/vuetify/issues/2901) [#3928](https://github.com/vuetifyjs/vuetify/issues/3928) [#4390](https://github.com/vuetifyjs/vuetify/issues/4390) [#4384](https://github.com/vuetifyjs/vuetify/issues/4384)
* **v-navigation-drawer:** fix maxHeight value ([517e64a](https://github.com/vuetifyjs/vuetify/commit/517e64aba7b60391fc9e255a3b8eba49876a3436))
* **v-responsive:** pass listeners to render ([585798d](https://github.com/vuetifyjs/vuetify/commit/585798d17ef7e2cc8078f80469836c37517e446e))
* **v-select:** apply custom nudgeBottom ([9b345eb](https://github.com/vuetifyjs/vuetify/commit/9b345ebb48684114e051c3726f341e8368b1390f)), closes [#4713](https://github.com/vuetifyjs/vuetify/issues/4713)
* **v-select:** fix chip editing functionality ([daeae40](https://github.com/vuetifyjs/vuetify/commit/daeae40dcd7b0afdc541742bd8d0c3766d099268)), closes [#4571](https://github.com/vuetifyjs/vuetify/issues/4571)
* **v-select:** fix reverse styles ([85b240e](https://github.com/vuetifyjs/vuetify/commit/85b240eff5298fbf830b004e6869261eb24c2810)), closes [#4699](https://github.com/vuetifyjs/vuetify/issues/4699)
* **v-select:** remove change event ([8b4e1f4](https://github.com/vuetifyjs/vuetify/commit/8b4e1f436d1da10fea7e5f80e6d8977fc80c0759))
* **v-text-field(box):** fix state colors ([af9660f](https://github.com/vuetifyjs/vuetify/commit/af9660f3e5084456a1b0099fb548ef5b881afcee))
* **v-toolbar:** fix a fix ([0a1a8f6](https://github.com/vuetifyjs/vuetify/commit/0a1a8f69e2dda9a05c6525ea288b8b9ede43204d))
* **validatable:** don't validate if rules content hasn't changed ([53ad130](https://github.com/vuetifyjs/vuetify/commit/53ad13075fed9ad4df8863556721e86e66d6a77c)), closes [#4688](https://github.com/vuetifyjs/vuetify/issues/4688)
* **validatable:** revalidate on rules change ([#4640](https://github.com/vuetifyjs/vuetify/issues/4640)) ([0693334](https://github.com/vuetifyjs/vuetify/commit/0693334f8ee0c6e9ebf40f5b117191b89629ffeb)), closes [#4635](https://github.com/vuetifyjs/vuetify/issues/4635)
* **validatable:** show success state without having focused ([525a2f6](https://github.com/vuetifyjs/vuetify/commit/525a2f6f18887745faf627eae491e0bc61c28b23))
* **VAutocomplete:** show menu when hideNoData changes ([0ae2c1d](https://github.com/vuetifyjs/vuetify/commit/0ae2c1dd2812f13929abd90c426375c1901e13a0)), closes [#4822](https://github.com/vuetifyjs/vuetify/issues/4822)
* **VAvatar:** crop v-img ([cac1ee3](https://github.com/vuetifyjs/vuetify/commit/cac1ee38fe9e41db81e8c967d80faae421d89174)), closes [#4777](https://github.com/vuetifyjs/vuetify/issues/4777)
* **VBottomNav:** shrink buttons when too narrow ([bd63a95](https://github.com/vuetifyjs/vuetify/commit/bd63a950bc53273c3cfd54a1004132a1356aaba1)), closes [#4643](https://github.com/vuetifyjs/vuetify/issues/4643) [#4547](https://github.com/vuetifyjs/vuetify/issues/4547)
* **VBtn:** remove text colour from themed buttons ([2d3f0da](https://github.com/vuetifyjs/vuetify/commit/2d3f0da7a0059afe23b7b3ef5cf96006feb8d049)), closes [#4812](https://github.com/vuetifyjs/vuetify/issues/4812)
* **VBtn:** set shrink factor to 0 ([#4547](https://github.com/vuetifyjs/vuetify/issues/4547)) ([c78753c](https://github.com/vuetifyjs/vuetify/commit/c78753c42909efa50d37297230727bb417a78a29)), closes [#3412](https://github.com/vuetifyjs/vuetify/issues/3412)
* **VCheckbox:** prevent input when readonly ([b55f5d1](https://github.com/vuetifyjs/vuetify/commit/b55f5d13a3acb1cd5dc21a83d13cdbe26ebbf7f5)), closes [#4827](https://github.com/vuetifyjs/vuetify/issues/4827)
* **VEditDialog:** show backbround color ([d40e2ff](https://github.com/vuetifyjs/vuetify/commit/d40e2ff6de99456ff9634dd9c789f38b1baf7755)), closes [#4856](https://github.com/vuetifyjs/vuetify/issues/4856)
* **version dropdown:** updated directed path ([853ac49](https://github.com/vuetifyjs/vuetify/commit/853ac495bb5b460bbffe981096af6f040df917a3)), closes [#195](https://github.com/vuetifyjs/vuetify/issues/195)
* added button to switch between hex codes and colors object in ThemeGenerator ([982bffd](https://github.com/vuetifyjs/vuetify/commit/982bffdda521de922f28b11e9bc109d862cda970))
* added grow prop to grow example ([cd9732a](https://github.com/vuetifyjs/vuetify/commit/cd9732afe6f5b59078a61bb5ece3fc1e54b0227c))
* added missing props ([e4d87cb](https://github.com/vuetifyjs/vuetify/commit/e4d87cb851dc13b1cab866b5bb9873ac44847073))
* added missing props for v-expansion-panel ([9628d7b](https://github.com/vuetifyjs/vuetify/commit/9628d7b0454b8678a13a8283d3fe859da1592317))
* added rippleable and bootable mixins ([cb6ebfe](https://github.com/vuetifyjs/vuetify/commit/cb6ebfe2d47bacfb6ce6003cf1f25efa24688588))
* bug in export theme ([2a61994](https://github.com/vuetifyjs/vuetify/commit/2a6199422de3c8d08c7b9c1355f6fa71eae2ae86)), closes [#196](https://github.com/vuetifyjs/vuetify/issues/196)
* correct HTML in masks table ([f99266a](https://github.com/vuetifyjs/vuetify/commit/f99266ade83b47a31030c98a00e53a7cdaead5a8)), closes [#230](https://github.com/vuetifyjs/vuetify/issues/230)
* correct more HTML in masks table ([cd73b3a](https://github.com/vuetifyjs/vuetify/commit/cd73b3ab1490cc01292aa9222a798960766b08c5)), closes [#230](https://github.com/vuetifyjs/vuetify/issues/230)
* duplicated key warning on /components/lists ([2379c6c](https://github.com/vuetifyjs/vuetify/commit/2379c6c13746f2a4ced32d954bb8108ecf12c694))
* forgot to remove renamed file ([baa58e9](https://github.com/vuetifyjs/vuetify/commit/baa58e9fa06220bf3d9361964533d0b6ec7bbf93))
* moved support text to i18n ([20c2be5](https://github.com/vuetifyjs/vuetify/commit/20c2be5e3fdd77c1e0ed3b8c4d96c2121b2ea0ca)), closes [#156](https://github.com/vuetifyjs/vuetify/issues/156)
* page-head header disappeared if no translation available ([c1be94c](https://github.com/vuetifyjs/vuetify/commit/c1be94c4990dade5af8ae4894646c906784238cc))
* removed centered prop from generator component ([198d454](https://github.com/vuetifyjs/vuetify/commit/198d4545f28337317f49890497d2f3643f496bc9))
* removed placeholders from translations menu ([afca665](https://github.com/vuetifyjs/vuetify/commit/afca665a49c1274037d6c021a0656be8297a380e))
* render example markup as soon as it's available ([23713aa](https://github.com/vuetifyjs/vuetify/commit/23713aa53c28045ec31642b408a8a01b47ae7331))
* set the correct drawer state when changing routes ([96a3e95](https://github.com/vuetifyjs/vuetify/commit/96a3e950ec1bd71124a4288cf13bf0957b3e9a11))
* spelling in SSR guide ([687caf4](https://github.com/vuetifyjs/vuetify/commit/687caf4672a892b899b3c65fb647561a731bfe54))
* switched order of supported browsers ([e01ade8](https://github.com/vuetifyjs/vuetify/commit/e01ade86615f28f49a8605d433286bc5e4cd39c9))
* updated a-la-carte text ([1ad5114](https://github.com/vuetifyjs/vuetify/commit/1ad5114990e3c73058c9b1217f721359026341e7)), closes [#217](https://github.com/vuetifyjs/vuetify/issues/217)
* **drawer-examples:** fixed display issues with temporary and dark theme examples ([0724b8c](https://github.com/vuetifyjs/vuetify/commit/0724b8c23f8f1a92b1cf0ec041f43f1bfbab32f5))
* **examples:** fixed snackbar being hidden ([ce1c3e0](https://github.com/vuetifyjs/vuetify/commit/ce1c3e060014496369fcc2dbef20940f4734cacd)), closes [#179](https://github.com/vuetifyjs/vuetify/issues/179)
* incorrect grid offset on home page ([984c137](https://github.com/vuetifyjs/vuetify/commit/984c137ed5ef02bcae2885483503ea35ad74b26e))
* removed duplicate markup ([0ddb833](https://github.com/vuetifyjs/vuetify/commit/0ddb83385fc08543346278cb7c2160cffc580067))
* tab bug in api section ([4ce62eb](https://github.com/vuetifyjs/vuetify/commit/4ce62eb915dec4e6cdd0afcb208c8e435ada3775))
* updated a-la-carte page ([665e59d](https://github.com/vuetifyjs/vuetify/commit/665e59d39a94f9f6a24b5ab7f1b4ecd3216ac47a))
* updated api file ([3f39a99](https://github.com/vuetifyjs/vuetify/commit/3f39a9948aaa271e83b5953a4b31c7c2c096c6fe))
* updated badge documentation ([49db8f4](https://github.com/vuetifyjs/vuetify/commit/49db8f4ed36393af80cdeff00e93f172e0a97f49))
* updated form page ([88b7428](https://github.com/vuetifyjs/vuetify/commit/88b7428f79f16672f6c1331853fdad1aa072d7e6))
* updated header text for roadmap ([94c14f3](https://github.com/vuetifyjs/vuetify/commit/94c14f3c80f5ce1b3ee9289d751cc7d4aac31ac0))
* updated Parameters component ([c4c1eab](https://github.com/vuetifyjs/vuetify/commit/c4c1eab411cd1b3576dc1b7821ca0965fcce2ad3))
* updated pre-made-themes page ([4e43510](https://github.com/vuetifyjs/vuetify/commit/4e43510890031b925cb026cbd70e59105d6bbe05))
* updated tabs component names ([9092cd8](https://github.com/vuetifyjs/vuetify/commit/9092cd8cd47c02a0b4ad1ef1cf1d9fb4bf0de38e))
* updated text on home page ([66bae3a](https://github.com/vuetifyjs/vuetify/commit/66bae3a170d3170685838a16665bd255270ca22f))
* updated toolbar page, added example ([c64bbf2](https://github.com/vuetifyjs/vuetify/commit/c64bbf24e33e927a07d85e97a089a494ec362b7c))
* updated tooltip examples ([cb6dd00](https://github.com/vuetifyjs/vuetify/commit/cb6dd00583991b7fef1f3b1eea2b7db739374ea7)), closes [#115](https://github.com/vuetifyjs/vuetify/issues/115)
* various small things ([cd89fa1](https://github.com/vuetifyjs/vuetify/commit/cd89fa16a4e859d7f6ebb65612d5925606244bdf))
* **.prettierrc:** fix file ([73aab98](https://github.com/vuetifyjs/vuetify/commit/73aab98d07b5c07db6181c4a1237556d44a06751))
* **goTo:** miscalculated target offset ([#4236](https://github.com/vuetifyjs/vuetify/issues/4236)) ([cdeba95](https://github.com/vuetifyjs/vuetify/commit/cdeba95e3a3e288f842440ce09cc4171e0477e97)), closes [#4226](https://github.com/vuetifyjs/vuetify/issues/4226)
* **goTo:** scrollY => pageYOffset (IE11) ([f09dc31](https://github.com/vuetifyjs/vuetify/commit/f09dc31bd9cf9e11db9549d56fc9b8ec5ea768ac)), closes [#4245](https://github.com/vuetifyjs/vuetify/issues/4245)
* **grid:** set v-flex max-width in column layouts ([#4321](https://github.com/vuetifyjs/vuetify/issues/4321)) ([ba4e434](https://github.com/vuetifyjs/vuetify/commit/ba4e4345271741c1f4121fb9caac3e24dc466968)), closes [#4258](https://github.com/vuetifyjs/vuetify/issues/4258)
* **grid:** too loose selector for fill-height ([#4003](https://github.com/vuetifyjs/vuetify/issues/4003)) ([099c6cd](https://github.com/vuetifyjs/vuetify/commit/099c6cda10b8e53655c968f359150b9b9a7b5649))
* **ie11:** fix styles ([999acb0](https://github.com/vuetifyjs/vuetify/commit/999acb097292faef66ea1e45b604de59d17eac27))
* **inputs:** fix styles ([4b63773](https://github.com/vuetifyjs/vuetify/commit/4b63773cd1eef34e21e6e9621267b1675e82c387))
* **inputs:** remove line-height override ([e08cde1](https://github.com/vuetifyjs/vuetify/commit/e08cde174543b249a9d99921aaf2a98692f64fc0))
* **jest:** configure from base ([510fe32](https://github.com/vuetifyjs/vuetify/commit/510fe324754abd032654e2dbf5bc9054dd9c2288))
* **selectable:** use custom true- and false-value correctly ([#4259](https://github.com/vuetifyjs/vuetify/issues/4259)) ([c1e8312](https://github.com/vuetifyjs/vuetify/commit/c1e8312521ba5337eed0e71f338d9a9d96202030)), closes [#3845](https://github.com/vuetifyjs/vuetify/issues/3845) [#4230](https://github.com/vuetifyjs/vuetify/issues/4230)
* **selection-controls:** fix disabled styles ([215f921](https://github.com/vuetifyjs/vuetify/commit/215f9218c76a6f8a295d046779e0d7516c29c2d4)), closes [#3487](https://github.com/vuetifyjs/vuetify/issues/3487)
* **sliders:** remove deprecated stylus variable ([2480215](https://github.com/vuetifyjs/vuetify/commit/248021523032e8b807c5372ee8fd49ae0dc17540)), closes [#5340](https://github.com/vuetifyjs/vuetify/issues/5340)
* **snapshots:** update snapshots ([ed2af05](https://github.com/vuetifyjs/vuetify/commit/ed2af05ae83cf5b913422df088607c8b26f8ece9))
* **solo-inverted:** fix styling on focus ([c2fc42c](https://github.com/vuetifyjs/vuetify/commit/c2fc42c9d5f036b6473bd0aca5efcf6f38a049cd)), closes [#3878](https://github.com/vuetifyjs/vuetify/issues/3878)
* **types:** export components for use with object spread ([6ac1b0b](https://github.com/vuetifyjs/vuetify/commit/6ac1b0ba2d9d9b7e677abef5412c1499629cf96c))
* **v-autocomplete:** avoid search reset ([c06c353](https://github.com/vuetifyjs/vuetify/commit/c06c35379df01de5fedfff6839066daf6682b431)), closes [#4273](https://github.com/vuetifyjs/vuetify/issues/4273)
* **v-autocomplete:** disable delete on disabled ([9442a21](https://github.com/vuetifyjs/vuetify/commit/9442a21a442acd4abdf683f3c5d5d1f2bf83b01f)), closes [#3097](https://github.com/vuetifyjs/vuetify/issues/3097)
* **v-bottom-sheets:** fix animation ([168defa](https://github.com/vuetifyjs/vuetify/commit/168defaf4e558a6b943c3cd6b1dd82693e079e9b))
* **v-data-table:** fix input styles ([0950067](https://github.com/vuetifyjs/vuetify/commit/095006725e09358135a81782a4215d23a09f52fe))
* **v-data-table:** incorrect colspan when not using headers prop ([#3920](https://github.com/vuetifyjs/vuetify/issues/3920)) ([134ac63](https://github.com/vuetifyjs/vuetify/commit/134ac6393b0787d6f81346b77fe2c4e82d4bf74b)), closes [#3419](https://github.com/vuetifyjs/vuetify/issues/3419) [#3338](https://github.com/vuetifyjs/vuetify/issues/3338)
* **v-date-picker:** disallow selecting disabled dates with keyboard ([#4200](https://github.com/vuetifyjs/vuetify/issues/4200)) ([9c4a570](https://github.com/vuetifyjs/vuetify/commit/9c4a570966c5a5b98993ea1d6e87626fb3fad265)), closes [#4151](https://github.com/vuetifyjs/vuetify/issues/4151)
* **v-input:** fix loader styles ([60a53cf](https://github.com/vuetifyjs/vuetify/commit/60a53cfaa554f71af8a5c155c48ecafe350dedf0))
* **v-input:** hint in rtl ([#4255](https://github.com/vuetifyjs/vuetify/issues/4255)) ([9a3fe86](https://github.com/vuetifyjs/vuetify/commit/9a3fe86c1f46151fdd6126d5d9057eb422cc9c3a)), closes [#4248](https://github.com/vuetifyjs/vuetify/issues/4248)
* **v-list:** align list action button ([#4110](https://github.com/vuetifyjs/vuetify/issues/4110)) ([ea128dd](https://github.com/vuetifyjs/vuetify/commit/ea128dd573afbb97c4b002101190e8e1c3e05ba5))
* **v-list:** fix hover styles ([030a9b8](https://github.com/vuetifyjs/vuetify/commit/030a9b835d6c542622dd43541e6a166f5c152d26))
* **v-menu:** add border offset ([2b5c7bc](https://github.com/vuetifyjs/vuetify/commit/2b5c7bc353c10a850b96d80859363d9a43314aaa))
* **v-menu:** fix auto calculations ([84c9abe](https://github.com/vuetifyjs/vuetify/commit/84c9abecebe49b0a378307c3fe60aee00971e9de))
* **v-menu:** fix auto style bleed ([fef9a0a](https://github.com/vuetifyjs/vuetify/commit/fef9a0a2219d8de242417b52edd48a96aed7fbf4))
* **v-range-slider:** enable always-dirty prop ([ac817fe](https://github.com/vuetifyjs/vuetify/commit/ac817febaa96d34b4be99bda6047b54912de2e0b))
* **v-select:** change import syntax ([425302b](https://github.com/vuetifyjs/vuetify/commit/425302b9ca99fadf1ff0edd8385906ea59a3265e))
* **v-select:** fix attach functionality ([725cb26](https://github.com/vuetifyjs/vuetify/commit/725cb269548ebb17926b9ec4ac5e642aea2473cb))
* **v-select:** fix hide-selected behavior ([2f29e58](https://github.com/vuetifyjs/vuetify/commit/2f29e58cb29e4014cde0f50574b92a312b792fa9)), closes [#3532](https://github.com/vuetifyjs/vuetify/issues/3532)
* **v-select:** fix input wrapping ([08a4473](https://github.com/vuetifyjs/vuetify/commit/08a447316ccd69e18610927700ada797670eebdc))
* **v-select:** update selected items logic ([2773c94](https://github.com/vuetifyjs/vuetify/commit/2773c94b4c1f5bf9d35ec4c896c8c8557b854d3e)), closes [#4264](https://github.com/vuetifyjs/vuetify/issues/4264)
* **v-slider:** fixed disabled style ([9a66781](https://github.com/vuetifyjs/vuetify/commit/9a667813cace03736bc8e3ae062877c56c89a1e5))
* **v-slider:** incorrect initial lazyValue if value is 0 ([135fcc7](https://github.com/vuetifyjs/vuetify/commit/135fcc70204e71f09762909b22a5c98e58a03797))
* **v-slider:** ticks not showing when active ([4795044](https://github.com/vuetifyjs/vuetify/commit/47950449849a22f8c1e53cf09343cf30837be2e6))
* **v-tabs:** reset scrollOffset if not overflowing ([#3781](https://github.com/vuetifyjs/vuetify/issues/3781)) ([4e94fc9](https://github.com/vuetifyjs/vuetify/commit/4e94fc905b00f09e4f0aa7580780dd4c10314cd2)), closes [#3294](https://github.com/vuetifyjs/vuetify/issues/3294)
* **v-text-field:** add **full-width** support ([ded7cae](https://github.com/vuetifyjs/vuetify/commit/ded7caecf5148a22a9a2ac0345ba3c0d3dbf6125))
* **v-text-field:** fix input overflow ([09a872e](https://github.com/vuetifyjs/vuetify/commit/09a872e44d660323bd5c3c67235e1799821ca79a))
* **v-text-field:** fix label translate ([fd6edb6](https://github.com/vuetifyjs/vuetify/commit/fd6edb679897a7de9141c7508622f7dbb8cd8444))
* **v-text-field:** fix outline styles ([0201375](https://github.com/vuetifyjs/vuetify/commit/02013754226b4e7bdbb37417258051b9babee30f))
* **v-text-field:** wrong label position in empty time input ([#4213](https://github.com/vuetifyjs/vuetify/issues/4213)) ([3feaa64](https://github.com/vuetifyjs/vuetify/commit/3feaa640dfd8099170ff00b8626466bdb5bef477)), closes [#4187](https://github.com/vuetifyjs/vuetify/issues/4187)
* **v-text-field/area:** fix solo-inverted ([7eea1c1](https://github.com/vuetifyjs/vuetify/commit/7eea1c14ef09a12b3e7d4bd06d06c8454348e0fe))
* **v-textarea:** fix scroll top on input ([f06ae31](https://github.com/vuetifyjs/vuetify/commit/f06ae313c445d838288ae6097643c58af9640aaf)), closes [#3082](https://github.com/vuetifyjs/vuetify/issues/3082)
* **v-toolbar:** align title and buttons ([#4111](https://github.com/vuetifyjs/vuetify/issues/4111)) ([51d0736](https://github.com/vuetifyjs/vuetify/commit/51d0736d8252176f8138292d8b6c4856b9515d2b))
* **VAutocomplete:** combobox - show no-data slot if provided ([#4303](https://github.com/vuetifyjs/vuetify/issues/4303)) ([e23b870](https://github.com/vuetifyjs/vuetify/commit/e23b87064961f7601ab4d2018d57ee2a6138734d)), closes [#4220](https://github.com/vuetifyjs/vuetify/issues/4220)
* **VAutocomplete:** pass correct props in through the VSelect wrapper ([30b0ab4](https://github.com/vuetifyjs/vuetify/commit/30b0ab4a0b4e87153c0b787cc40283fc204b556e))
* **VAutocomplete:** reset selected index when input is clicked ([8407053](https://github.com/vuetifyjs/vuetify/commit/84070531213762ad13a7ffa3233cab7bf5e50bbf))
* **VAutocomplete:** update input value when items change ([#4261](https://github.com/vuetifyjs/vuetify/issues/4261)) ([99b6741](https://github.com/vuetifyjs/vuetify/commit/99b6741e9f0db27e8adbf5c4873b06e2deefc98d))
* **VDivider:** add missed v- prefixes ([3b70321](https://github.com/vuetifyjs/vuetify/commit/3b70321be5562693e0bc8982297c5428130b0881)), closes [#3752](https://github.com/vuetifyjs/vuetify/issues/3752) [#3763](https://github.com/vuetifyjs/vuetify/issues/3763)
* **VExpansionPanel:** reverse child warning message ([#4153](https://github.com/vuetifyjs/vuetify/issues/4153)) ([c580dd1](https://github.com/vuetifyjs/vuetify/commit/c580dd15f617bfe8788524878a0cb1f8741c398b))
* **VInput:** emitting click:append-outer event ([#4281](https://github.com/vuetifyjs/vuetify/issues/4281)) ([e8ceabb](https://github.com/vuetifyjs/vuetify/commit/e8ceabb04aa579d54ee2aeda4f2126b4068548aa)), closes [#4279](https://github.com/vuetifyjs/vuetify/issues/4279)
* **VInput:** prefix width ([#4292](https://github.com/vuetifyjs/vuetify/issues/4292)) ([6473444](https://github.com/vuetifyjs/vuetify/commit/6473444b3a356af24aec45320f97a008d035a807)), closes [#4271](https://github.com/vuetifyjs/vuetify/issues/4271)
* **VMenu:** add missed v- prefix to default transition name ([049d5c7](https://github.com/vuetifyjs/vuetify/commit/049d5c7b821b9c3cb02485ea0035cf5ef6b8e071)), closes [#3885](https://github.com/vuetifyjs/vuetify/issues/3885)
* **VMessage:** added overflow:hidden to prevent scrollbar ([#4262](https://github.com/vuetifyjs/vuetify/issues/4262)) ([6f7194d](https://github.com/vuetifyjs/vuetify/commit/6f7194db2683686a307d726016ccd18f64692b95)), closes [#4256](https://github.com/vuetifyjs/vuetify/issues/4256)
* **VMessages:** break long words in FF ([2388874](https://github.com/vuetifyjs/vuetify/commit/23888743866cf7c74568f3810d937bc99fbe8b10))
* **VOverflowBtn:** fix spacing (again) ([0565d37](https://github.com/vuetifyjs/vuetify/commit/0565d371e4fcc560a5da0ff7f2f159735497941b))
* **VOverflowBtn:** get correct item value and ignore search unless editable ([d1abfe6](https://github.com/vuetifyjs/vuetify/commit/d1abfe682c8af2df23c7b28ce117d31f14ad9837))
* **VSelect:** pass the attach prop through properly ([352b105](https://github.com/vuetifyjs/vuetify/commit/352b105ed00e59f396b70ede00eedf78cc1d4b31)), closes [#3616](https://github.com/vuetifyjs/vuetify/issues/3616)
* **VSelectList:** use noDataText if item slot is provided ([#4297](https://github.com/vuetifyjs/vuetify/issues/4297)) ([9d45982](https://github.com/vuetifyjs/vuetify/commit/9d45982b9ff0d89102d85ce1a0453549d2279b9d)), closes [#4217](https://github.com/vuetifyjs/vuetify/issues/4217)
* **VStepper:** Use name instead of tag name ([#4165](https://github.com/vuetifyjs/vuetify/issues/4165)) ([72b7324](https://github.com/vuetifyjs/vuetify/commit/72b7324ebda9f1feab02751ac04bb5bc6a780606))
* **VTextarea:** resize handler position ([#4293](https://github.com/vuetifyjs/vuetify/issues/4293)) ([d50953d](https://github.com/vuetifyjs/vuetify/commit/d50953d7c84ec4fb9360524c57937fc4193660c3)), closes [#4232](https://github.com/vuetifyjs/vuetify/issues/4232)
* **VTextField:** do not apply hover when hovering prepend/append icon ([#4316](https://github.com/vuetifyjs/vuetify/issues/4316)) ([f3dcd8a](https://github.com/vuetifyjs/vuetify/commit/f3dcd8aa73479381076478b00d0e7a2cc79bac7e)), closes [#4278](https://github.com/vuetifyjs/vuetify/issues/4278)
* **VTextField:** ensure comparing booleans ([a68649a](https://github.com/vuetifyjs/vuetify/commit/a68649aab8b0d1d7c54a202a53e7a2f8417c62d3))
* **VTextField:** prefix and label position tweaks ([4d6cd7b](https://github.com/vuetifyjs/vuetify/commit/4d6cd7b296643ef2ebc4dec87e52568e6e85b04f))
* enable downLevelIteration ([aee0b6a](https://github.com/vuetifyjs/vuetify/commit/aee0b6addf45cdffe0dd328d2945ed8faacfbd44))
* quotes in package.json ([dcd12d8](https://github.com/vuetifyjs/vuetify/commit/dcd12d8a9c2240513b9173d59422bf69de32a3a9))
* **btn:** Allow VBtn custom padding and fix focus effect ([#3962](https://github.com/vuetifyjs/vuetify/issues/3962)) ([6350730](https://github.com/vuetifyjs/vuetify/commit/63507301943cdcdc76c8dc4df28987446593e8fc))
* **colors:** remove duplicate mixins and fix variable scope ([02f3ad8](https://github.com/vuetifyjs/vuetify/commit/02f3ad8f565846540daad5f50b6f6620937e5b07)), closes [#3965](https://github.com/vuetifyjs/vuetify/issues/3965)
* **dev:** only use externals in production builds ([627f87f](https://github.com/vuetifyjs/vuetify/commit/627f87fe51ab32110d32f1e54c523ff56ab25908))
* **grid:** fix slot class ([6a4a598](https://github.com/vuetifyjs/vuetify/commit/6a4a59899e0b1c69424d36d816a54778b3d66521)), closes [#3946](https://github.com/vuetifyjs/vuetify/issues/3946)
* **inputs:** move styles from icon ([9bcccf3](https://github.com/vuetifyjs/vuetify/commit/9bcccf3c354049a23b6478dde9014dcc7b083d35))
* **mixins:** use mixin.options when calling directly ([1a2c54c](https://github.com/vuetifyjs/vuetify/commit/1a2c54c9eb197d2e2b60ebc540eaac0a72024bfe))
* **selectable:** add id to input ([68f1101](https://github.com/vuetifyjs/vuetify/commit/68f11017ceed6f71637b7278c9ed3bcdf3f3496e)), closes [#2119](https://github.com/vuetifyjs/vuetify/issues/2119)
* **selection_slot:** added flex ([9845859](https://github.com/vuetifyjs/vuetify/commit/984585929f4dd2dbffafb58b3e05acadf20bf8b1))
* **text-field/slider:** add/fix ([ab00c4a](https://github.com/vuetifyjs/vuetify/commit/ab00c4a7d4637c50ea98cefd3ecf49a31335eb1f)), closes [#3137](https://github.com/vuetifyjs/vuetify/issues/3137)
* **text-field/textarea:** fix styles ([18b0faf](https://github.com/vuetifyjs/vuetify/commit/18b0faf72e8972227934dba28f06751c2b5d9dac)), closes [#3821](https://github.com/vuetifyjs/vuetify/issues/3821) [#3135](https://github.com/vuetifyjs/vuetify/issues/3135) [#1829](https://github.com/vuetifyjs/vuetify/issues/1829)
* **types:** remove Partial type ([6813ddc](https://github.com/vuetifyjs/vuetify/commit/6813ddc2f627b05a137fcfbd565b71463594e890))
* **v-autocomplete:** fix multiple styles ([7704d89](https://github.com/vuetifyjs/vuetify/commit/7704d89e94167c7fe6f038a352d34299172329a7))
* **v-form:** fix validation ([468b55d](https://github.com/vuetifyjs/vuetify/commit/468b55df04135b69dcd98f852a152b75935c5dbe)), closes [#2948](https://github.com/vuetifyjs/vuetify/issues/2948)
* **v-layout:** removed max-width, added min ([2b88885](https://github.com/vuetifyjs/vuetify/commit/2b8888594b5a37c5d1b80bee6beecb0fd8d14bed)), closes [#3873](https://github.com/vuetifyjs/vuetify/issues/3873)
* **v-slider:** logic mistake ([1462546](https://github.com/vuetifyjs/vuetify/commit/1462546cda97391aee304e2d9d671bb3536ee139))
* **v-slider:** should not move thumbs when click-dragging on track ([848c244](https://github.com/vuetifyjs/vuetify/commit/848c244336fe40bc3cfde3628440b6432c91c369))
* **v-tabs:** fix centered style ([fded35b](https://github.com/vuetifyjs/vuetify/commit/fded35b8e0d50bb4e2fb49f5327c520bfa4c49bb)), closes [#3934](https://github.com/vuetifyjs/vuetify/issues/3934)
* **v-text-field:** fire change event ([47c73e6](https://github.com/vuetifyjs/vuetify/commit/47c73e69f82ac4c553e8148e1737ae35315bdb47)), closes [#2982](https://github.com/vuetifyjs/vuetify/issues/2982)
* **v-text-field:** fix box styles ([b2edce2](https://github.com/vuetifyjs/vuetify/commit/b2edce21ddbc015aca5184b0467ee8c13569e582))
* **v-textarea:** fix inner icon ([eae2b9f](https://github.com/vuetifyjs/vuetify/commit/eae2b9fe9b5ad4375c875420ce3ef451201fcffe))
* **v-textarea:** fix resize handle ([188f200](https://github.com/vuetifyjs/vuetify/commit/188f2005ea68a583affbea98789378254b610058))
* **VBreadcrumbs:** don't reuse divider VNodes ([b330fc6](https://github.com/vuetifyjs/vuetify/commit/b330fc67e250e6b951357fc879eb5a83add76cf9)), closes [#3874](https://github.com/vuetifyjs/vuetify/issues/3874)
* **VBtn:** set type of value prop to any ([afbdee5](https://github.com/vuetifyjs/vuetify/commit/afbdee563c2b204cff41eb5039c78db173807d81))
* Prevent stylus variable vs. animation name collision ("query") ([#3965](https://github.com/vuetifyjs/vuetify/issues/3965)) ([7fefff3](https://github.com/vuetifyjs/vuetify/commit/7fefff3794cb2712ca397ec6969dc383d0c8699c))
* **validatable:** change beforeMount conditional ([ad663e6](https://github.com/vuetifyjs/vuetify/commit/ad663e66499469665ce6313fbb9559e99ada882f))
* **vChip:** Border radius when inside a v-card ([#3937](https://github.com/vuetifyjs/vuetify/issues/3937)) ([661f37e](https://github.com/vuetifyjs/vuetify/commit/661f37eb0dd53d25d7dae02b051185f7e89e0add))
* **VIcon:** create a default array for children ([514c1b2](https://github.com/vuetifyjs/vuetify/commit/514c1b25052c0e95bbb07f85114e27342467a51f))
* **VMenu:** add missed v- prefix in toolbars and dialogs ([bfb503c](https://github.com/vuetifyjs/vuetify/commit/bfb503cd4dafce92da2e07b17be45d98317712d5)), closes [#3885](https://github.com/vuetifyjs/vuetify/issues/3885)
* **VSnackbar:** add missed v- prefix to transition name ([27cbe4d](https://github.com/vuetifyjs/vuetify/commit/27cbe4d9d21ea820c55c65c6805bf06659eb67a2)), closes [#3801](https://github.com/vuetifyjs/vuetify/issues/3801)
* **VTextField wrapper:** rebuild children from context.slots ([1196a7c](https://github.com/vuetifyjs/vuetify/commit/1196a7cbe4d5a0ac0c332f80c6adb9baf4204b90))
* **vTooltip:** missing lazy behavior ([#3959](https://github.com/vuetifyjs/vuetify/issues/3959)) ([700c319](https://github.com/vuetifyjs/vuetify/commit/700c31998c43c64b6b3955ef2f86df60fb1146fd))
* expand-transition error ([#3852](https://github.com/vuetifyjs/vuetify/issues/3852)) ([6dea196](https://github.com/vuetifyjs/vuetify/commit/6dea196bbdc232e2336aa349436add09865c15c3)), closes [#3812](https://github.com/vuetifyjs/vuetify/issues/3812) [#3050](https://github.com/vuetifyjs/vuetify/issues/3050)
* missed css prefix ([78c8c7b](https://github.com/vuetifyjs/vuetify/commit/78c8c7b79d83540889b0c40d9b1086e9a96f3a8a))
* missing css due to v- prefix rename ([e79df2a](https://github.com/vuetifyjs/vuetify/commit/e79df2a3f58570c9cb363bc12800aa1dec2e47c9))
* typo (del => delete) ([20df1dc](https://github.com/vuetifyjs/vuetify/commit/20df1dc582c16823c7459b03228e7401802ca600))
* **3688:** twice emitted `update:returnValue` event ([#3690](https://github.com/vuetifyjs/vuetify/issues/3690)) ([bbc2403](https://github.com/vuetifyjs/vuetify/commit/bbc24037bd1cf84242c7bf17eb9801a2b5064e22)), closes [#3688](https://github.com/vuetifyjs/vuetify/issues/3688)
* **detachable:** apply lazy behavior to initDetach ([#3593](https://github.com/vuetifyjs/vuetify/issues/3593)) ([ee2f21f](https://github.com/vuetifyjs/vuetify/commit/ee2f21f868c7f1b1778884a5a2a12cfd26b314ca)), closes [#3570](https://github.com/vuetifyjs/vuetify/issues/3570)
* **goTo:** validate target correctly when vue is minified ([#3638](https://github.com/vuetifyjs/vuetify/issues/3638)) ([568248f](https://github.com/vuetifyjs/vuetify/commit/568248f64d7ec5554825e628d61469b1f14db569)), closes [#3611](https://github.com/vuetifyjs/vuetify/issues/3611)
* **icons:** added missing key ([7b1d18f](https://github.com/vuetifyjs/vuetify/commit/7b1d18fdde3812e7ab6ac4a06ff1a91c32c8c1e8))
* **rippleable:** added explicit click event ([#3556](https://github.com/vuetifyjs/vuetify/issues/3556)) ([2aa07de](https://github.com/vuetifyjs/vuetify/commit/2aa07de115c4c03c9d45f6f6ad782ef566a5b2e5)), closes [#3554](https://github.com/vuetifyjs/vuetify/issues/3554)
* **styles:** fixed missed merge ([be91db9](https://github.com/vuetifyjs/vuetify/commit/be91db98a246d3cd9f51a0cacad70736226668ae))
* **tabs:** fixed twice emit input ([#3561](https://github.com/vuetifyjs/vuetify/issues/3561)) ([2cf0ba2](https://github.com/vuetifyjs/vuetify/commit/2cf0ba26116d6b5d263a30d6ce93cbe400cc0e07))
* **v-menu:** changed implementation for 15a5d76 ([45d4fa9](https://github.com/vuetifyjs/vuetify/commit/45d4fa91e2d9fafc9e14b4517b427b0c9f43df19)), closes [#3653](https://github.com/vuetifyjs/vuetify/issues/3653)
* **v-message:** fixed transition between items ([fd28679](https://github.com/vuetifyjs/vuetify/commit/fd28679a3c573b714546ae73245c2dc7ca5e8352))
* **v-messages:** fixed transition ([78ec288](https://github.com/vuetifyjs/vuetify/commit/78ec28855431fe6cffa1d36470701beae911cdf9))
* **v-pagination:** fixed responsive pagination ([#3843](https://github.com/vuetifyjs/vuetify/issues/3843)) ([cf32d90](https://github.com/vuetifyjs/vuetify/commit/cf32d903f630fe0e7675ba72dd4a395056d67d0d)), closes [#3759](https://github.com/vuetifyjs/vuetify/issues/3759)
* **v-radio-group:** added missing functionality ([78964e3](https://github.com/vuetifyjs/vuetify/commit/78964e36893f34021989feb9e588d23dac0b76f9))
* **VBreadcrumbs:** only create dividers for v-breadcrumbs-item ([#3854](https://github.com/vuetifyjs/vuetify/issues/3854)) ([9ab4645](https://github.com/vuetifyjs/vuetify/commit/9ab4645df8596b2a637238cc4df891311dd1aa6c))
* zero-width activator when edit-dialog input is empty ([#3848](https://github.com/vuetifyjs/vuetify/issues/3848)) ([662eaa0](https://github.com/vuetifyjs/vuetify/commit/662eaa0492aa00c4e7025c684a55504d402a05a9)), closes [#1795](https://github.com/vuetifyjs/vuetify/issues/1795)
* **v-menu:** fixed locking scroll ([15a5d76](https://github.com/vuetifyjs/vuetify/commit/15a5d761d66e4fc557580619451f217f15e68686))
* **v-radio-group:** fixed row wrap on smaller screens ([5ccad87](https://github.com/vuetifyjs/vuetify/commit/5ccad8796115f976a17fce33adfae809cc546570))
* **v-select-list:** avatar prop requires boolean ([b43b3cf](https://github.com/vuetifyjs/vuetify/commit/b43b3cf061425f671d674d2837d867afb3f597b6))
* **v-slider:** hide label if none provided ([a094c07](https://github.com/vuetifyjs/vuetify/commit/a094c0741a798438a0e7da5feea3b0a83b1fa5e3))
* **v-tab:** fixed resolve comparison and args ([#3667](https://github.com/vuetifyjs/vuetify/issues/3667)) ([9cc70e4](https://github.com/vuetifyjs/vuetify/commit/9cc70e458962d3c0e73903c9dcf2721db0e60eef)), closes [#3654](https://github.com/vuetifyjs/vuetify/issues/3654)
* **v-tab:** updated logic for determining action ([#3575](https://github.com/vuetifyjs/vuetify/issues/3575)) ([2874fa3](https://github.com/vuetifyjs/vuetify/commit/2874fa341beaf35b0f4edd2f26918280835e9ee5)), closes [#3418](https://github.com/vuetifyjs/vuetify/issues/3418)
* **v-tabs:** avoid referencing undefined obj ([06df9b1](https://github.com/vuetifyjs/vuetify/commit/06df9b121f15a29ac16e73b50584f14627200296)), closes [#3581](https://github.com/vuetifyjs/vuetify/issues/3581)
* **v-tabs:** fixed dynamic arrows ([#3623](https://github.com/vuetifyjs/vuetify/issues/3623)) ([fb840bf](https://github.com/vuetifyjs/vuetify/commit/fb840bf7d989c1faab522c57f1330b717cd12028)), closes [#3620](https://github.com/vuetifyjs/vuetify/issues/3620)
* **v-tabs:** moved setWidths call location ([9239c89](https://github.com/vuetifyjs/vuetify/commit/9239c89115ca6c37ff10e9bfaca64d0ca5b18b93)), closes [#3838](https://github.com/vuetifyjs/vuetify/issues/3838)
* **v-tabs:** recalculate overflow on tabs change ([#3728](https://github.com/vuetifyjs/vuetify/issues/3728)) ([46c7335](https://github.com/vuetifyjs/vuetify/commit/46c73351d56345013d60d34177e55769d6369064)), closes [#3643](https://github.com/vuetifyjs/vuetify/issues/3643)
* **v-text-field:** fixed icon generation logic ([579e417](https://github.com/vuetifyjs/vuetify/commit/579e4176b32200dd44ce141fc9fca9edddd439e1))
* **VMenu:** use will-change instead of translate hack ([9e044d5](https://github.com/vuetifyjs/vuetify/commit/9e044d5fd387d443262b5f0abe90e2cac1953660))
* missing args in text field wrapper render function ([5a6a861](https://github.com/vuetifyjs/vuetify/commit/5a6a861b7314769cd3ec550e4fa2dd7f2d151c99))
* missing args in text field wrapper render function ([35ad4df](https://github.com/vuetifyjs/vuetify/commit/35ad4df1d80a9917f44f458ec90af56ca13e3a1d))
* **v-text-field:** added proper text wrap ([a5c2fa6](https://github.com/vuetifyjs/vuetify/commit/a5c2fa6f3b801776a4827816af68809bc03f7e16))
* **VDialog:** inherit z-index from wrapper ([#3639](https://github.com/vuetifyjs/vuetify/issues/3639)) ([d6e6611](https://github.com/vuetifyjs/vuetify/commit/d6e66113a1cc0ec9c6f610e2fdf2f804262ad252)), closes [#2111](https://github.com/vuetifyjs/vuetify/issues/2111)
* **VProgressCircular:** width relative to progress size ([#3661](https://github.com/vuetifyjs/vuetify/issues/3661)) ([b79f721](https://github.com/vuetifyjs/vuetify/commit/b79f72183041c07c3e70281b63d246199caa1ebc)), closes [#3557](https://github.com/vuetifyjs/vuetify/issues/3557)
* **VTabs:** update slider position after resize timeout ([#3640](https://github.com/vuetifyjs/vuetify/issues/3640)) ([7cd4ad8](https://github.com/vuetifyjs/vuetify/commit/7cd4ad8780914fe7dcb3c294d96c4587a85f42a4)), closes [#3637](https://github.com/vuetifyjs/vuetify/issues/3637)
* [#3625](https://github.com/vuetifyjs/vuetify/issues/3625) - image-links with parentheses aren't recognized ([#3626](https://github.com/vuetifyjs/vuetify/issues/3626)) ([5a1b0c8](https://github.com/vuetifyjs/vuetify/commit/5a1b0c8f1547ad1b146486f1ca781b8ae636c474))
* **$data-iterator:** changed watcher ([#3513](https://github.com/vuetifyjs/vuetify/issues/3513)) ([e57229d](https://github.com/vuetifyjs/vuetify/commit/e57229d09e33a920575f0fdaa3c4b2edff513d4f)), closes [#3511](https://github.com/vuetifyjs/vuetify/issues/3511)
* **$goTo:** fixed negative scroll and cleaned up process ([#3542](https://github.com/vuetifyjs/vuetify/issues/3542)) ([db7fa2a](https://github.com/vuetifyjs/vuetify/commit/db7fa2afefbc3bd460ac0288d3d6b6e55f739647)), closes [#3384](https://github.com/vuetifyjs/vuetify/issues/3384)
* **$stepper-step:** removed import from merge ([d631741](https://github.com/vuetifyjs/vuetify/commit/d6317419f3e4ee4561475b6ee935f112ba52e506))
* **applicationable:** updated process ([#3365](https://github.com/vuetifyjs/vuetify/issues/3365)) ([19281b1](https://github.com/vuetifyjs/vuetify/commit/19281b17a89d895948c2b6de5838a52c10827ad0)), closes [#3347](https://github.com/vuetifyjs/vuetify/issues/3347)
* **build:** remove CSS sourcemaps from production builds ([#3441](https://github.com/vuetifyjs/vuetify/issues/3441)) ([6273097](https://github.com/vuetifyjs/vuetify/commit/62730974723d448737ceeda2bf9f8dffdadc56ea)), closes [#3403](https://github.com/vuetifyjs/vuetify/issues/3403)
* **build:** use babel-transform-define instead of webpack.DefinePlugin ([f22e9aa](https://github.com/vuetifyjs/vuetify/commit/f22e9aaec57513c73ee9469abd52c3db60438a27)), closes [vuetifyjs/nuxt#27](https://github.com/vuetifyjs/nuxt/issues/27) [vuetifyjs/nuxt#28](https://github.com/vuetifyjs/nuxt/issues/28) [vuetifyjs/webpack#5](https://github.com/vuetifyjs/webpack/issues/5)
* **click-outside:** check clicked element instead of position ([559c579](https://github.com/vuetifyjs/vuetify/commit/559c5799ebc383ec1de7c4780facbece3ec6992b))
* **DataIterable:** Update selection when items change. ([#6097](https://github.com/vuetifyjs/vuetify/issues/6097)) ([33f4033](https://github.com/vuetifyjs/vuetify/commit/33f403342d3eccbd1a445c4c676bf8b02bce8303))
* **dependent:** don't close if a child's overlay is clicked ([dbe3213](https://github.com/vuetifyjs/vuetify/commit/dbe3213d7322e115526251be2dca61b66f756a2e)), closes [#5310](https://github.com/vuetifyjs/vuetify/issues/5310)
* **detachable:** allow any object in the attach prop ([#3241](https://github.com/vuetifyjs/vuetify/issues/3241)) ([cc0092e](https://github.com/vuetifyjs/vuetify/commit/cc0092e18b23e064155e0d51e407934a5c7887f6))
* **detachable:** remove detached activator element on destroy ([8875f68](https://github.com/vuetifyjs/vuetify/commit/8875f68fbd0d8b4a1691bc4aeac7e3cd020ceff8)), closes [#6568](https://github.com/vuetifyjs/vuetify/issues/6568)
* **dialog:** flex ignores width with scrollable dialogs([#6480](https://github.com/vuetifyjs/vuetify/issues/6480)) ([592e3f4](https://github.com/vuetifyjs/vuetify/commit/592e3f4c57fcea14f65ae064768c357b1c7b4a02))
* **divider:** resolve sass variable build error ([05c79e9](https://github.com/vuetifyjs/vuetify/commit/05c79e9e33d4973a632c61bb240ff7332d5be2f9))
* **entry-lib:** fix directives export ([635537e](https://github.com/vuetifyjs/vuetify/commit/635537e3f8e43e2adaa42b058d59f3c55dcf5bda))
* **grid:** partial revert of [#3491](https://github.com/vuetifyjs/vuetify/issues/3491) ([c4775e4](https://github.com/vuetifyjs/vuetify/commit/c4775e4d9ecb749b45fb53ac125f5f32b3c44218))
* **grid:** prevent .flex from growing instead of using max-width ([#3491](https://github.com/vuetifyjs/vuetify/issues/3491)) ([8e83ce6](https://github.com/vuetifyjs/vuetify/commit/8e83ce627abe898704157b21550b23fc2efd77cb)), closes [#3470](https://github.com/vuetifyjs/vuetify/issues/3470)
* **helpers:** detect legacy non-scoped slots correctly ([0d3ab63](https://github.com/vuetifyjs/vuetify/commit/0d3ab63fd335d87cc86b4fa7d535c9fe68843e4b))
* **locale:** improve polish translation ([eb64675](https://github.com/vuetifyjs/vuetify/commit/eb64675b44e9f1e474184e626ba2c1a5cfb20f92))
* **menuable:** use activatorNode.elm if activated externally ([8bf9e28](https://github.com/vuetifyjs/vuetify/commit/8bf9e28feddd5351f6414f24d05a6a7c8dc2876d))
* **progressbar:** center inner content ([#6712](https://github.com/vuetifyjs/vuetify/issues/6712)) ([27c3242](https://github.com/vuetifyjs/vuetify/commit/27c32422a3cd37b26e55b6a64ba97033beab98a3))
* **ripple:** allow getComputedStyle to return null ([#6639](https://github.com/vuetifyjs/vuetify/issues/6639)) ([0bf395c](https://github.com/vuetifyjs/vuetify/commit/0bf395caed281ed32941bff6a7eb14f566705200))
* **ripple:** check for undefined el._ripple ([#6698](https://github.com/vuetifyjs/vuetify/issues/6698)) ([3310920](https://github.com/vuetifyjs/vuetify/commit/3310920a80bc31858bc9517ed7a43dbe499c6f74)), closes [#6477](https://github.com/vuetifyjs/vuetify/issues/6477)
* **ripple:** ensure _ripple data exists ([#6476](https://github.com/vuetifyjs/vuetify/issues/6476)) ([0cd5671](https://github.com/vuetifyjs/vuetify/commit/0cd56717b0b4334c78e8e99dc7bad6b7dc479d0b))
* **snackbar:** don't allow buttons to grow ([94de39f](https://github.com/vuetifyjs/vuetify/commit/94de39f0f6fb357dedf9eb3a556c094af374af8b)), closes [#3363](https://github.com/vuetifyjs/vuetify/issues/3363)
* **speed-dial:** add z-index and remove btn margin when fixed ([#3489](https://github.com/vuetifyjs/vuetify/issues/3489)) ([f2d2139](https://github.com/vuetifyjs/vuetify/commit/f2d2139ecca3b805ab014f82a8d52a7bf40c23a5)), closes [#3414](https://github.com/vuetifyjs/vuetify/issues/3414)
* **ssr:** allow theme to be applied with vue-meta ([#3314](https://github.com/vuetifyjs/vuetify/issues/3314)) ([2256b13](https://github.com/vuetifyjs/vuetify/commit/2256b136dd7f923ec37ff1421c499a436a9700b1)), closes [#3329](https://github.com/vuetifyjs/vuetify/issues/3329)
* **stackable:** move stack classes to explicit values ([7dad5e9](https://github.com/vuetifyjs/vuetify/commit/7dad5e9df9cfdfb49cc4a3a5e12b63c066398ca3)), closes [#5141](https://github.com/vuetifyjs/vuetify/issues/5141)
* **stackable:** return a z-index of 0 in SSR) ([ee7ad4f](https://github.com/vuetifyjs/vuetify/commit/ee7ad4f61b1c78acf34d2a5a5633da1556aa3c78)), closes [#3242](https://github.com/vuetifyjs/vuetify/issues/3242)
* **tabs:** fixed twice call tabClick ([#3494](https://github.com/vuetifyjs/vuetify/issues/3494)) ([d8faedc](https://github.com/vuetifyjs/vuetify/commit/d8faedc46fcb084ffd5939ec6486410199f3f268))
* **tabs:** render all other elements in the tabs container ([#3442](https://github.com/vuetifyjs/vuetify/issues/3442)) ([b14ab29](https://github.com/vuetifyjs/vuetify/commit/b14ab298ef778e2655bca0d1e683d2370f9a22c1)), closes [#3434](https://github.com/vuetifyjs/vuetify/issues/3434)
* **text:** don't cut off bottom parts of letters with text-truncate ([8161cc0](https://github.com/vuetifyjs/vuetify/commit/8161cc0ec1d1650b2a3f04516a7b68a9e1b99263)), closes [#6488](https://github.com/vuetifyjs/vuetify/issues/6488)
* **text-field:** add color and file to dirty types ([#3490](https://github.com/vuetifyjs/vuetify/issues/3490)) ([b083b4e](https://github.com/vuetifyjs/vuetify/commit/b083b4e3cf60c6eea54bd1a3e79511909a8585eb)), closes [#3467](https://github.com/vuetifyjs/vuetify/issues/3467)
* **theme:** only apply theme to head element when not using vue-meta ([#3440](https://github.com/vuetifyjs/vuetify/issues/3440)) ([be3b233](https://github.com/vuetifyjs/vuetify/commit/be3b233b26353ca58dd0c2fe5db051b4ab2b4fc4)), closes [#3405](https://github.com/vuetifyjs/vuetify/issues/3405)
* **v-btn:** added missing component import ([ee3f9bd](https://github.com/vuetifyjs/vuetify/commit/ee3f9bd4b50200c8c5cc934b3c9f7f1da31512ad)), closes [#3391](https://github.com/vuetifyjs/vuetify/issues/3391)
* **v-btn:** properly hooked up active-class ([f0a0ca0](https://github.com/vuetifyjs/vuetify/commit/f0a0ca0f80518d5fc2a5e071a89fe375c4ebb2cf))
* **v-list-tile:** force remove pointer-events ([c7c3df3](https://github.com/vuetifyjs/vuetify/commit/c7c3df38c1e0eb34bd918ee48ac112f39a85cdac)), closes [#3387](https://github.com/vuetifyjs/vuetify/issues/3387)
* **v-select:** removed useless operation ([#3231](https://github.com/vuetifyjs/vuetify/issues/3231)) ([acb2e66](https://github.com/vuetifyjs/vuetify/commit/acb2e66f98dd5658b2f79c79a73737813bd6f980)), closes [#3151](https://github.com/vuetifyjs/vuetify/issues/3151)
* **v-tab:** added back removed nextTick ([#3232](https://github.com/vuetifyjs/vuetify/issues/3232)) ([3e3ae40](https://github.com/vuetifyjs/vuetify/commit/3e3ae40e50b30cb7bd58a8e4d8e68ab184044aba)), closes [#3203](https://github.com/vuetifyjs/vuetify/issues/3203)
* **v-tabs:** updated booting process ([#3234](https://github.com/vuetifyjs/vuetify/issues/3234)) ([3fc70d8](https://github.com/vuetifyjs/vuetify/commit/3fc70d8fa7eee94a63a86ede7767be71bfa4478b)), closes [#3174](https://github.com/vuetifyjs/vuetify/issues/3174)
* **v-tabs:** updated computed prop ([fcb0b4b](https://github.com/vuetifyjs/vuetify/commit/fcb0b4bfdd82c5ae59b0cd5624483cba2b7ff2f2)), closes [#3270](https://github.com/vuetifyjs/vuetify/issues/3270)
* **v-toolbar:** added back missing functionality ([1822153](https://github.com/vuetifyjs/vuetify/commit/1822153bc4763dc30b3bb704107bf1f6f97ae5ec)), closes [#3484](https://github.com/vuetifyjs/vuetify/issues/3484)
* **v-tooltip:** fix alignment issue caused by `v-tooltip` ([becd484](https://github.com/vuetifyjs/vuetify/commit/becd4843fdd766e4a59ee2dbd99760f18db7d340)), closes [#3222](https://github.com/vuetifyjs/vuetify/issues/3222) [#3267](https://github.com/vuetifyjs/vuetify/issues/3267) [#3272](https://github.com/vuetifyjs/vuetify/issues/3272)
* **v-tooltip:** fixed tooltip height ([#3222](https://github.com/vuetifyjs/vuetify/issues/3222)) ([f021e5b](https://github.com/vuetifyjs/vuetify/commit/f021e5b37b676aa460da8fd143a89a8aba5c76f6)), closes [#3205](https://github.com/vuetifyjs/vuetify/issues/3205)
* **VAppBar:** allow menu to overflow ([ff4cfd3](https://github.com/vuetifyjs/vuetify/commit/ff4cfd3ff2494621f2788ab0dff635471c222e24))
* **VAppBar:** let elevate-on-scroll and hide-on-scroll work together ([8581e19](https://github.com/vuetifyjs/vuetify/commit/8581e1919d9f87b6844b90a518aa70f9ff8c60b6))
* **VAutocomplete:** retain filtered list on item selection ([#6388](https://github.com/vuetifyjs/vuetify/issues/6388)) ([3b184b4](https://github.com/vuetifyjs/vuetify/commit/3b184b40df314ca301eb19a54840acab13e47cfe)), closes [#6260](https://github.com/vuetifyjs/vuetify/issues/6260)
* **VBadge:** fix invalid height when wrapping spans ([ae12eaf](https://github.com/vuetifyjs/vuetify/commit/ae12eafaea7ea1df7b4eed846751ac9dfe29ea31))
* **VBanner:** flexbox related issues with IE11 ([#6686](https://github.com/vuetifyjs/vuetify/issues/6686)) ([748e480](https://github.com/vuetifyjs/vuetify/commit/748e4803953bcbad3e1a6edbe36ef0c1b806652e))
* **VBreadcrumbs:** remove deprecated method ([20cf338](https://github.com/vuetifyjs/vuetify/commit/20cf338d49f85d8b46945cfd1e2332c331d98793))
* **VBreadcrumbs:** v-for key error when two items have identical texts ([#6642](https://github.com/vuetifyjs/vuetify/issues/6642)) ([2146ca8](https://github.com/vuetifyjs/vuetify/commit/2146ca88409eb30d42cab1328803295835faeb04)), closes [#5454](https://github.com/vuetifyjs/vuetify/issues/5454)
* **VBtn:** correct fab box-shadow ([#3525](https://github.com/vuetifyjs/vuetify/issues/3525)) ([dfa671a](https://github.com/vuetifyjs/vuetify/commit/dfa671a535e6408b1309027ecdc2d6e521439b0a)), closes [#3524](https://github.com/vuetifyjs/vuetify/issues/3524)
* **VBtn:** hide hover overlay on touch devices ([6ed5cc6](https://github.com/vuetifyjs/vuetify/commit/6ed5cc6142423df131df490030e30dae4c28918b)), closes [#2178](https://github.com/vuetifyjs/vuetify/issues/2178)
* **VBtn:** use correct icon color with **icon** prop ([e27a6f5](https://github.com/vuetifyjs/vuetify/commit/e27a6f540d62e62d18473a5246843f7b0b30fe15))
* **VCalendar:** fix snapshots ([9cca725](https://github.com/vuetifyjs/vuetify/commit/9cca7250f51ae46972b18e3b9771cc55f6859d2f))
* **VCalendar:** fix tests ([9426508](https://github.com/vuetifyjs/vuetify/commit/942650893aa6b0604fa5a0989b982dce3fab76aa))
* **VCalendar:** input generates correct type ([#6434](https://github.com/vuetifyjs/vuetify/issues/6434)) ([#6482](https://github.com/vuetifyjs/vuetify/issues/6482)) ([620b823](https://github.com/vuetifyjs/vuetify/commit/620b823c8973be76fc6daf582f951bc41108322b))
* **VCarousel:** add aria-label on controls ([#6498](https://github.com/vuetifyjs/vuetify/issues/6498)) ([d61ee0e](https://github.com/vuetifyjs/vuetify/commit/d61ee0e2d14efc1cb959194686a4cfe16e787a23))
* **VCarousel:** transition direction when outside button click ([#6515](https://github.com/vuetifyjs/vuetify/issues/6515)) ([6219ad0](https://github.com/vuetifyjs/vuetify/commit/6219ad0e4ca243e0ed5ec47b36d97d800c74cfd9))
* **VDataTable:** add horizontal overflow scroll ([bde7c8f](https://github.com/vuetifyjs/vuetify/commit/bde7c8fa4631b6e6baec9ae70d63c562b3bff34f))
* **VDataTable:** update lang function ([a73e076](https://github.com/vuetifyjs/vuetify/commit/a73e0764be4fce051a9808b2d6ce7bcfd2f086b2))
* **VDatePicker:** tableDate gets invalid value when changing year ([262a702](https://github.com/vuetifyjs/vuetify/commit/262a702eb66bdd9bad9802c3cc1b5f8d456e3385)), closes [#6689](https://github.com/vuetifyjs/vuetify/issues/6689)
* **VDatePicker:** wrong date when changing month in reactive picker ([7885aaf](https://github.com/vuetifyjs/vuetify/commit/7885aafa0e14d703e553e225d7fbe7f3b1b59226)), closes [#6461](https://github.com/vuetifyjs/vuetify/issues/6461)
* **VDatePickerYears:** year picker is not scrolled to the selected year ([a41f23d](https://github.com/vuetifyjs/vuetify/commit/a41f23db2eba683ede4f3ed9a7c8d57ccc1f0415)), closes [#6367](https://github.com/vuetifyjs/vuetify/issues/6367)
* **VDialog:** close when escape is pressed ([c64ed2a](https://github.com/vuetifyjs/vuetify/commit/c64ed2aa91d333dd8d7f8f6df2b19ec5655af31c)), closes [#6352](https://github.com/vuetifyjs/vuetify/issues/6352)
* **VDialog:** focus the first child when tab leaves the dialog ([2d5d72b](https://github.com/vuetifyjs/vuetify/commit/2d5d72b83e42ac086b793f34301926d660c511a0)), closes [#2538](https://github.com/vuetifyjs/vuetify/issues/2538)
* **VDialog, VMenu:** focus activator when closed with esc ([cef2d1d](https://github.com/vuetifyjs/vuetify/commit/cef2d1d09ecd5eec1c2a5598ba79d5c9bd0987e5))
* **VDialog,VMenu,VTooltip:** work around vue 2.6.4 $slots change ([a865794](https://github.com/vuetifyjs/vuetify/commit/a865794bb4187074c51f2a804e813c06a711e0f7)), closes [#6440](https://github.com/vuetifyjs/vuetify/issues/6440)
* **VFooter:** update application after mount when using auto height ([#3295](https://github.com/vuetifyjs/vuetify/issues/3295)) ([c968a9a](https://github.com/vuetifyjs/vuetify/commit/c968a9a06be362522505156221e47e589b325201))
* **VGrid:** apply !important to helper classes ([4893523](https://github.com/vuetifyjs/vuetify/commit/48935235d71766864e7a9dd4bf68aa371a407107))
* **VIcon:** fix theme ([8f04200](https://github.com/vuetifyjs/vuetify/commit/8f042008dbcca09d3e5d92daaf2455ec225f619d))
* **VItemGroup:** return proper selected values when value is undefined ([054edba](https://github.com/vuetifyjs/vuetify/commit/054edbadbe05d2c9e137b0fb57b492760cabc558))
* **VItemGroup:** select first non-disabled item with **mandatory** prop ([6d1615f](https://github.com/vuetifyjs/vuetify/commit/6d1615f52567378cfae89801b7906a870b342b17))
* **VList:** resize `v-subheader` children when using **dense** prop ([663c584](https://github.com/vuetifyjs/vuetify/commit/663c5848dd7c866149b60f92d28aff3324047be6))
* **VListItem:** text-cutoff on title ([c1bcc05](https://github.com/vuetifyjs/vuetify/commit/c1bcc05609ff20812a2963a02f0a4c46e8304135))
* **VMenu:** account for minWidth when setting initial position ([591779a](https://github.com/vuetifyjs/vuetify/commit/591779ac5856038df3b9839439b8b7801aa6204a)), closes [#3438](https://github.com/vuetifyjs/vuetify/issues/3438)
* **VMenu:** delay closing when save is called ([74e0bd1](https://github.com/vuetifyjs/vuetify/commit/74e0bd16d815f45d237a6320432976b46923a661)), closes [#5200](https://github.com/vuetifyjs/vuetify/issues/5200)
* **VMenu:** limit to screen width ([d19ddba](https://github.com/vuetifyjs/vuetify/commit/d19ddbae06d8790cf3871e87a585ec3016f21393))
* **VMenu:** respond to keydown when using scoped activator slot ([1b4dbae](https://github.com/vuetifyjs/vuetify/commit/1b4dbae58cbfdeda4edbc14104a53ce9c0a36f62)), closes [#6621](https://github.com/vuetifyjs/vuetify/issues/6621)
* **VMenu, VTooltip:** detect when activator has position:fixed ([#6460](https://github.com/vuetifyjs/vuetify/issues/6460)) ([700bb49](https://github.com/vuetifyjs/vuetify/commit/700bb49e87fc144063ea93c3d82d1113f0b66e85)), closes [#6471](https://github.com/vuetifyjs/vuetify/issues/6471) [#1551](https://github.com/vuetifyjs/vuetify/issues/1551)
* **VPagination:** remove unnecessary outline for circle pagination buttons. ([#6513](https://github.com/vuetifyjs/vuetify/issues/6513)) ([b00abfe](https://github.com/vuetifyjs/vuetify/commit/b00abfe26b8aead84230cc6c94cd3363f5174c76))
* **VSelect:** disable the menu transition with false instead of '' ([#3527](https://github.com/vuetifyjs/vuetify/issues/3527)) ([b8c6db4](https://github.com/vuetifyjs/vuetify/commit/b8c6db48165e867230eeed311991dba25a89de29)), closes [#3526](https://github.com/vuetifyjs/vuetify/issues/3526)
* **VSelect:** keep menu closed when removing chip items. ([#6845](https://github.com/vuetifyjs/vuetify/issues/6845)) ([a4761cb](https://github.com/vuetifyjs/vuetify/commit/a4761cb341a64749a33b8a2312f3ecd6be3843d6)), closes [#6844](https://github.com/vuetifyjs/vuetify/issues/6844)
* **VSheet:** listen to events ([#6573](https://github.com/vuetifyjs/vuetify/issues/6573)) ([66ca89d](https://github.com/vuetifyjs/vuetify/commit/66ca89dd942bfaeb5b971c9cab7705d314fcb709)), closes [#6572](https://github.com/vuetifyjs/vuetify/issues/6572)
* **VSheet/ripple:** ensure sheets are always block level elements ([f67f17f](https://github.com/vuetifyjs/vuetify/commit/f67f17f32f40b1ceaf435d8ed681772c567dcfef))
* **VSheet/VCard:** animate on elevation change ([152874e](https://github.com/vuetifyjs/vuetify/commit/152874ecae22bf770e0d4345072a34d237489af1))
* **VSlider:** make sure stars do not wrap ([c92e569](https://github.com/vuetifyjs/vuetify/commit/c92e569ab0446ad9276e640c90d67a6744a45957)), closes [#6481](https://github.com/vuetifyjs/vuetify/issues/6481)
* **VSlider:** set value to min if it's less than min ([#6604](https://github.com/vuetifyjs/vuetify/issues/6604)) ([#6605](https://github.com/vuetifyjs/vuetify/issues/6605)) ([91eb0db](https://github.com/vuetifyjs/vuetify/commit/91eb0db075040a837d627beed3803789d9adbdf6))
* **VSpeedDial:** fixed transition animation ([#6373](https://github.com/vuetifyjs/vuetify/issues/6373)) ([7e0a521](https://github.com/vuetifyjs/vuetify/commit/7e0a521e29f12c2e62b5ce0525452e00fa401f81))
* **VTextField:** allow error container to shrink ([#3529](https://github.com/vuetifyjs/vuetify/issues/3529)) ([6feb183](https://github.com/vuetifyjs/vuetify/commit/6feb183440ecd1d56ab20b36a24eda8866c95905)), closes [#3381](https://github.com/vuetifyjs/vuetify/issues/3381)
* **VTextField:** force validation with validate-on-blur ([#4260](https://github.com/vuetifyjs/vuetify/issues/4260)) ([0f6be51](https://github.com/vuetifyjs/vuetify/commit/0f6be518b388845ee7d270193d3df782d7c0bc88)), closes [#4247](https://github.com/vuetifyjs/vuetify/issues/4247)
* **VTextField:** invalid label position with placeholder ([#4270](https://github.com/vuetifyjs/vuetify/issues/4270)) ([d881d44](https://github.com/vuetifyjs/vuetify/commit/d881d44d1631510b110197c91b318cedb0bc51f2))
* **VTextField:** properly align suffix in filled variant ([126f891](https://github.com/vuetifyjs/vuetify/commit/126f8918208a06f86e99188d216abcd251ef9570)), closes [#7871](https://github.com/vuetifyjs/vuetify/issues/7871)
* **VTextField:** recalculate prefix on change ([f9049b3](https://github.com/vuetifyjs/vuetify/commit/f9049b3e0e858a72d25c1fe12d5bc46e232f2ebd)), closes [#8268](https://github.com/vuetifyjs/vuetify/issues/8268)
* **VTextField:** show correct deprecation notices for icon props ([fcefbcb](https://github.com/vuetifyjs/vuetify/commit/fcefbcb2a97e5f63ad213f69ddd449b54ef378fa)), closes [#4254](https://github.com/vuetifyjs/vuetify/issues/4254)
* **VTimePickerClock:** dont switch to minutes if clicked disabled hour ([#4304](https://github.com/vuetifyjs/vuetify/issues/4304)) ([aaeca1f](https://github.com/vuetifyjs/vuetify/commit/aaeca1f808794b6d60066de93aa996ab2f9d71ef)), closes [#4196](https://github.com/vuetifyjs/vuetify/issues/4196)
* **VTimePickerClock:** invalid values can be selected ([d41f1c1](https://github.com/vuetifyjs/vuetify/commit/d41f1c18547b7cf189a2c804a88d6d57d45c5d85)), closes [#5897](https://github.com/vuetifyjs/vuetify/issues/5897)
* **VToolbar:** use computed height for root element ([6332259](https://github.com/vuetifyjs/vuetify/commit/63322596699c91d9726d76423e9bf7c1ba1fff35)), closes [#8101](https://github.com/vuetifyjs/vuetify/issues/8101)
* **VTooltip:** bring back automatic fixed positioning ([#8887](https://github.com/vuetifyjs/vuetify/issues/8887)) ([57c084a](https://github.com/vuetifyjs/vuetify/commit/57c084a66f3a58b5ec590d3dcb71b829976789a0)), closes [#8894](https://github.com/vuetifyjs/vuetify/issues/8894) [#6460](https://github.com/vuetifyjs/vuetify/issues/6460)
* **VTooltip:** min width is not applied ([#6622](https://github.com/vuetifyjs/vuetify/issues/6622)) ([b95b76e](https://github.com/vuetifyjs/vuetify/commit/b95b76ef5fa4cc158ed8d3a0baad31a532089d61))
* **VTreeviewNode:** allow empty children item to behave as leaf ([#9082](https://github.com/vuetifyjs/vuetify/issues/9082)) ([8555450](https://github.com/vuetifyjs/vuetify/commit/855545064a5fa5acec7fa517eea4d68c63f2a3c0)), closes [#9043](https://github.com/vuetifyjs/vuetify/issues/9043)
* **Vuetify:** reintroduced browser installation of Vuetify ([7892e0a](https://github.com/vuetifyjs/vuetify/commit/7892e0a87557c1f46812225b02289b0c18200e09))
* **VuetifyGoToOptions:** add missing properties to types ([ee1078f](https://github.com/vuetifyjs/vuetify/commit/ee1078f27b99cfb745e1c74ba7abbabd7ba9deaf))
* add names back to mixins ([3e5ffa2](https://github.com/vuetifyjs/vuetify/commit/3e5ffa2e3c7c2505862f81d4e1d59dfb235c3442))
* add non-default exports for single components ([70dfc11](https://github.com/vuetifyjs/vuetify/commit/70dfc11d25ca8b22350487e81ffaa923e39933c5)), closes [#4149](https://github.com/vuetifyjs/vuetify/issues/4149)
* cast version parts to string before comparing ([39e0641](https://github.com/vuetifyjs/vuetify/commit/39e064145ede222420d55ca6058a18a3ed58e9ef))
* centers active year in date picker ([#4046](https://github.com/vuetifyjs/vuetify/issues/4046)) ([78cda73](https://github.com/vuetifyjs/vuetify/commit/78cda7319932f741f54a12d4822f6545b1a69c94)), closes [#3828](https://github.com/vuetifyjs/vuetify/issues/3828)
* correct type definition for $vuetidy.goTo ([c5cb1db](https://github.com/vuetifyjs/vuetify/commit/c5cb1db35f0a5616e9cfb6a4a8a9601c685a8a50)), closes [#3200](https://github.com/vuetifyjs/vuetify/issues/3200)
* don't switch to hours after selecting minutes ([#4198](https://github.com/vuetifyjs/vuetify/issues/4198)) ([97db26d](https://github.com/vuetifyjs/vuetify/commit/97db26d03b809ea7d85c3f98dd6e109ecdf10fdc)), closes [#3371](https://github.com/vuetifyjs/vuetify/issues/3371)
* export vuetify class from entry-lib ([314eb8a](https://github.com/vuetifyjs/vuetify/commit/314eb8afe40522754f794c03d1bd9c505d0ac112))
* **app-theme:** add csp nonce to vueMeta ([1715f2d](https://github.com/vuetifyjs/vuetify/commit/1715f2d8e60085b55afc6125604197cccff940bc)), closes [#4159](https://github.com/vuetifyjs/vuetify/issues/4159)
* **build:** don't import Vue ([4890c83](https://github.com/vuetifyjs/vuetify/commit/4890c83e94041bc0cf06608fc9e307acd132836d))
* **build:** import Vue again ([ff27d02](https://github.com/vuetifyjs/vuetify/commit/ff27d025fdd6ed222a1258c29ee8cba04129d152))
* **data-iterable:** fix pagination sync ([78a273e](https://github.com/vuetifyjs/vuetify/commit/78a273ee0c4bab62b6ee5dfa209ff6c58e737697)), closes [#4122](https://github.com/vuetifyjs/vuetify/issues/4122)
* **form-inputs:** fix input irregularities ([5268dc4](https://github.com/vuetifyjs/vuetify/commit/5268dc467122426609f1471997ac00c8b0123798)), closes [#4078](https://github.com/vuetifyjs/vuetify/issues/4078)
* **inputs:** set correct error label color ([31233c2](https://github.com/vuetifyjs/vuetify/commit/31233c2f863314615f86d3cd2a4ee4f061afd0f0))
* **stylus:** allow re-defining $grid-gutter ([#4095](https://github.com/vuetifyjs/vuetify/issues/4095)) ([ed4a176](https://github.com/vuetifyjs/vuetify/commit/ed4a1768852a149f6f5388c744e39ea04dd14601))
* **theme:** add CSP nonce with vue ssr ([589de09](https://github.com/vuetifyjs/vuetify/commit/589de094df6ae98a13ccafe9abeb0129fe69f8b4)), closes [#4159](https://github.com/vuetifyjs/vuetify/issues/4159)
* **types:** correct colors.d.ts exports ([#4155](https://github.com/vuetifyjs/vuetify/issues/4155)) ([40907c1](https://github.com/vuetifyjs/vuetify/commit/40907c10bf51119e2a79909b65e44be4babe662d))
* **v-autocomplete:** add content-class ([874aad1](https://github.com/vuetifyjs/vuetify/commit/874aad18d3264da96dd196f37ca66a95776f07f8)), closes [#4088](https://github.com/vuetifyjs/vuetify/issues/4088)
* **v-bottom-nav:** update styles ([0fb69d2](https://github.com/vuetifyjs/vuetify/commit/0fb69d2f12eab9929da5efdd6a08a696753636f2))
* **v-btn:** fix transition styles ([a11be7a](https://github.com/vuetifyjs/vuetify/commit/a11be7a80290835762dae263154894dd073d864c))
* **v-btn:** fix v-icon styles ([cde0588](https://github.com/vuetifyjs/vuetify/commit/cde058862b35d6b4965530c39959525d14b7d476)), closes [#4134](https://github.com/vuetifyjs/vuetify/issues/4134)
* **v-btn:** resolve router-link issue ([2d1e00e](https://github.com/vuetifyjs/vuetify/commit/2d1e00e048ef335be32c1872f4c3568d16ea8152))
* **v-data-table:** add *:key* to <tr> ([#3968](https://github.com/vuetifyjs/vuetify/issues/3968)) ([f75b952](https://github.com/vuetifyjs/vuetify/commit/f75b95242a11acb3a6aa93316afe9b77957c8761)), closes [#3967](https://github.com/vuetifyjs/vuetify/issues/3967)
* **v-dialog:** update animation condition ([74e77d0](https://github.com/vuetifyjs/vuetify/commit/74e77d04c443da186b80fbab4074366e11dc0802))
* **v-dialog/selection-controls:** style updates ([#4170](https://github.com/vuetifyjs/vuetify/issues/4170)) ([2f6006f](https://github.com/vuetifyjs/vuetify/commit/2f6006f5d99e87837fba7ea25f7fee321fdf47f6)), closes [#4168](https://github.com/vuetifyjs/vuetify/issues/4168)
* **v-divider:** add minimum width ([efb5425](https://github.com/vuetifyjs/vuetify/commit/efb54250c649bf74f8eb74ee9c45ca36fef8ae9f))
* **v-list-tile:** remove pointer events ([34c6b43](https://github.com/vuetifyjs/vuetify/commit/34c6b436ce873aef0a6019ad83a7de48e6bc2a85)), closes [#4152](https://github.com/vuetifyjs/vuetify/issues/4152)
* **v-list-tile:** remove pointless style ([540f9e4](https://github.com/vuetifyjs/vuetify/commit/540f9e410eb70185a5fe5beee3cc56cf380367e9)), closes [#4140](https://github.com/vuetifyjs/vuetify/issues/4140)
* **v-messages:** fix transition exit ([bf6ff3f](https://github.com/vuetifyjs/vuetify/commit/bf6ff3f12dbb402feefb14db9630baff672719ed))
* **v-messages:** remove absolute position ([1db80eb](https://github.com/vuetifyjs/vuetify/commit/1db80eb11aca71568891c42863f0f0dc7e01ea37)), closes [#4147](https://github.com/vuetifyjs/vuetify/issues/4147)
* **v-navigation-drawer:** change event type ([cce9ffa](https://github.com/vuetifyjs/vuetify/commit/cce9ffa33593b4583f77c23c8756d1090c996517)), closes [#4031](https://github.com/vuetifyjs/vuetify/issues/4031)
* **v-radio-group:** add back label ([da1b64e](https://github.com/vuetifyjs/vuetify/commit/da1b64eb05cdcb3c86dd6dd1dd6df1d7fa70d3da)), closes [#4146](https://github.com/vuetifyjs/vuetify/issues/4146)
* **v-select:** update style ([591e4ff](https://github.com/vuetifyjs/vuetify/commit/591e4ffb0d701554d788ab65d3ceaddddf3e5d73))
* **v-slider:** update readonly ([34ae4c2](https://github.com/vuetifyjs/vuetify/commit/34ae4c2285899a48c524bff108fcd3aaa66d8e47)), closes [#4177](https://github.com/vuetifyjs/vuetify/issues/4177)
* **v-text-field:** fix enclosed loaders ([aaf6865](https://github.com/vuetifyjs/vuetify/commit/aaf6865901a604c6234e7f5417e5f72665aef6bf)), closes [#4141](https://github.com/vuetifyjs/vuetify/issues/4141)
* **validatable:** fix error-messages comparison ([4be1512](https://github.com/vuetifyjs/vuetify/commit/4be1512e87bdd16d677c50921bfcf1c5e17d8e38)), closes [#4130](https://github.com/vuetifyjs/vuetify/issues/4130)
* **VSelect:** use scopedSlots.selection instead of slots.item ([1cb54dc](https://github.com/vuetifyjs/vuetify/commit/1cb54dcc47b5c609aad5636ac772a94ad8cc68a9)), closes [#4104](https://github.com/vuetifyjs/vuetify/issues/4104)
* **VSlider:** allow step to be set to 0 ([#4124](https://github.com/vuetifyjs/vuetify/issues/4124)) ([55aafc7](https://github.com/vuetifyjs/vuetify/commit/55aafc7d63c9a890a046d74808683635a4146143))
* **VTextArea:** add no-resize styles ([b419066](https://github.com/vuetifyjs/vuetify/commit/b4190667922e500b15591c0a8e4ead99df8581c3))
* incorrect variable name ([dd08b98](https://github.com/vuetifyjs/vuetify/commit/dd08b9800fbb2bb98732a9e491a21a0e58f20a1d))
* **form-inputs:** fix styles and match spec ([cf43a19](https://github.com/vuetifyjs/vuetify/commit/cf43a19d0cec33a88a5411d4a300ded22cb27903))
* **helpers:** fixed variable name ([423d315](https://github.com/vuetifyjs/vuetify/commit/423d315c3d0072e572e9ac4a17703f2d1a0357ad))
* **ripple:** convert to ts, only remove the last ripple ([#4040](https://github.com/vuetifyjs/vuetify/issues/4040)) ([bd1993a](https://github.com/vuetifyjs/vuetify/commit/bd1993a516ef9d0221c71abfb949b5abd85f2f37))
* **selection-controls:** fix alignment ([7fb9c79](https://github.com/vuetifyjs/vuetify/commit/7fb9c79254c5e55b982f8f3b1b79ffebf2bd3bc2))
* **stackable:** fix z-index ([3c2ee99](https://github.com/vuetifyjs/vuetify/commit/3c2ee99b91a93e2103e17988d84f53762ddbf403))
* **v-autocomplete:** add missing functionality ([d724779](https://github.com/vuetifyjs/vuetify/commit/d724779defded93f887afb257869063fc22d0b43))
* **v-autocomplete:** fix displayed text ([b349463](https://github.com/vuetifyjs/vuetify/commit/b349463940fa4ae4c8434ce5f248cdc73bc6ed3f))
* **v-autocomplete:** fix hideNoData logic ([1eb9363](https://github.com/vuetifyjs/vuetify/commit/1eb9363899bdb230bd85a7054243ae3ab3356b83))
* **v-autocomplete:** refactor combobox experience ([3996f27](https://github.com/vuetifyjs/vuetify/commit/3996f27bf1c5331abc762fcc4c515a2aff31820f)), closes [#4032](https://github.com/vuetifyjs/vuetify/issues/4032)
* **v-flex:** add max-width ([a4b5ce8](https://github.com/vuetifyjs/vuetify/commit/a4b5ce8826063cf86f62d71fa035971cbdf0b516))
* **v-input:** adjust pointer-events ([df52046](https://github.com/vuetifyjs/vuetify/commit/df52046bb47a4531d03629cbdb8331db1adf1a9c)), closes [#4034](https://github.com/vuetifyjs/vuetify/issues/4034)
* **v-input:** change min-height of slot ([bf08da0](https://github.com/vuetifyjs/vuetify/commit/bf08da03607d817ce08976731104c8d74fa9793f))
* **v-input:** fix input color ([db1fd09](https://github.com/vuetifyjs/vuetify/commit/db1fd091f508a988051c225b66189929e89a45d8))
* **v-label:** fix pointer-events ([68bf3d8](https://github.com/vuetifyjs/vuetify/commit/68bf3d8fdace3bd00461f7c9cfddcd2ae2148d3a)), closes [#4013](https://github.com/vuetifyjs/vuetify/issues/4013)
* **v-navigation-drawer:** change event type ([db8e638](https://github.com/vuetifyjs/vuetify/commit/db8e638ed760a6a0f1823c764776dfb17bdae5d5)), closes [#4031](https://github.com/vuetifyjs/vuetify/issues/4031)
* **v-overflow-btn:** align labels in ie11 ([9f17663](https://github.com/vuetifyjs/vuetify/commit/9f1766333ea407dd01af7ba034af0943a485aaad))
* **v-select:** add back fake virtualization ([#4025](https://github.com/vuetifyjs/vuetify/issues/4025)) ([339863a](https://github.com/vuetifyjs/vuetify/commit/339863a62a95fc4ca9e78f8f09498267b2867dd5))
* **v-select:** add width ([2256bea](https://github.com/vuetifyjs/vuetify/commit/2256bead9636879c67c32e66ab6fa1326be28ebd))
* **v-select:** change close conditional ([297c80e](https://github.com/vuetifyjs/vuetify/commit/297c80e6463fbb7e8f195e4d0256e98aa26c3a00)), closes [#4023](https://github.com/vuetifyjs/vuetify/issues/4023)
* **v-select:** hide cursor ([37c9e53](https://github.com/vuetifyjs/vuetify/commit/37c9e539b2f3701aa42b68c1e2f6cac1544bafec))
* **v-select:** improve chip styles ([0708cee](https://github.com/vuetifyjs/vuetify/commit/0708cee252e6e928b06bcf7de16255246c6318de))
* data-table issues ([#3857](https://github.com/vuetifyjs/vuetify/issues/3857)) ([5113291](https://github.com/vuetifyjs/vuetify/commit/511329179271f2e4baa1e59deec5178e33fbfcf4)), closes [#3766](https://github.com/vuetifyjs/vuetify/issues/3766) [#3511](https://github.com/vuetifyjs/vuetify/issues/3511) [#3585](https://github.com/vuetifyjs/vuetify/issues/3585) [#3766](https://github.com/vuetifyjs/vuetify/issues/3766) [#3585](https://github.com/vuetifyjs/vuetify/issues/3585)
* data-table pagination did not update when using custom-filter ([#3850](https://github.com/vuetifyjs/vuetify/issues/3850)) ([8a14daa](https://github.com/vuetifyjs/vuetify/commit/8a14daaf34542ed0de22bbbbdbb8ddc444a1d549)), closes [#3770](https://github.com/vuetifyjs/vuetify/issues/3770)
* data-table selection now works with nested item-key ([#3849](https://github.com/vuetifyjs/vuetify/issues/3849)) ([2e43d7d](https://github.com/vuetifyjs/vuetify/commit/2e43d7d0a9ceae5e01797f1dbac17bffaa9474c9)), closes [#3714](https://github.com/vuetifyjs/vuetify/issues/3714)
* **grid:** update desktop/mobile gutters ([9a5aef6](https://github.com/vuetifyjs/vuetify/commit/9a5aef6c3d2dad9b0d275143038f2d40002884ad))
* **select/autocomplete:** update no data available logic ([3a2c67a](https://github.com/vuetifyjs/vuetify/commit/3a2c67a682291ed37c126882b845f237f2548aa3)), closes [#2081](https://github.com/vuetifyjs/vuetify/issues/2081)
* **v-autocomplete:** disable onInput when selecting index ([fb89744](https://github.com/vuetifyjs/vuetify/commit/fb8974460c035e9fc3bcc7c39d626055777ed7d9)), closes [#2834](https://github.com/vuetifyjs/vuetify/issues/2834)
* **v-autocomplete:** fix index evaluation ([34d96e7](https://github.com/vuetifyjs/vuetify/commit/34d96e73fed0793ca161ab419177b32ed635d5b0))
* **v-autocomplete:** set search on init ([3fc9787](https://github.com/vuetifyjs/vuetify/commit/3fc97870218b88bbc9c646921e3687e71432053e))
* **v-dialog:** remove overflow ([33d46ce](https://github.com/vuetifyjs/vuetify/commit/33d46ced850bb159ece0ec778dd4f1465b8b4d63)), closes [#4066](https://github.com/vuetifyjs/vuetify/issues/4066)
* **v-input:** fix loader styles ([0e59fa7](https://github.com/vuetifyjs/vuetify/commit/0e59fa78c1e776b3bf0185e16384318d931a02d5))
* **v-input:** fix toolbar styles ([c604bc0](https://github.com/vuetifyjs/vuetify/commit/c604bc072858ff9c84415039beac357290f5eea3))
* **v-input:** update progress styles ([2b02a3d](https://github.com/vuetifyjs/vuetify/commit/2b02a3dd0d32f08003e8829afd7d6a19c475ccde))
* **v-radio:** fix label position ([3aa738c](https://github.com/vuetifyjs/vuetify/commit/3aa738c078620a918877fe876dcc538cef9703f2))
* **v-radio-group:** add test for issue ([e6baef8](https://github.com/vuetifyjs/vuetify/commit/e6baef81028115864e1531a611d28f0b6539e91c)), closes [#3299](https://github.com/vuetifyjs/vuetify/issues/3299)
* **v-select:** add all items ([87062ac](https://github.com/vuetifyjs/vuetify/commit/87062ac0b52311d7cc52f052be2b3dc45a3c6df6))
* **v-select:** add specificity to input alignment ([33fc90a](https://github.com/vuetifyjs/vuetify/commit/33fc90a69f1af4fdfb4ed731b92852db369467b5))
* **v-select:** adjust input flex alignment ([36a7461](https://github.com/vuetifyjs/vuetify/commit/36a7461c77b22140019441c72452fdfaee0b595b))
* **v-select:** fix auto menu positioning ([f685b72](https://github.com/vuetifyjs/vuetify/commit/f685b721d16b678d013ceabbcd87277b34be3716))
* **v-select:** fix comma selection spacing ([053dba3](https://github.com/vuetifyjs/vuetify/commit/053dba30e5ce0cfb0e67e74f329e4f4ca47a9d06))
* **v-select:** fix open on clear ([5d3c15e](https://github.com/vuetifyjs/vuetify/commit/5d3c15e8f6176e3785a6b22675d63560cca15739))
* **v-select:** hide placeholder when dirty ([e2915c8](https://github.com/vuetifyjs/vuetify/commit/e2915c86b4d57b797b3821927935074f9d168a77))
* **v-select:** refactor keyboard functionality ([5022b80](https://github.com/vuetifyjs/vuetify/commit/5022b80c3397d8a64cbacdfff1fbe2bbf2770798)), closes [#3973](https://github.com/vuetifyjs/vuetify/issues/3973)
* **v-select:** update change event ([c9bd680](https://github.com/vuetifyjs/vuetify/commit/c9bd68091cb364de32fe78543c89fa8170ba5206)), closes [#3457](https://github.com/vuetifyjs/vuetify/issues/3457)
* **v-select-list:** fix hide-selected logic ([3b5f7b2](https://github.com/vuetifyjs/vuetify/commit/3b5f7b2175678503574f77a8eb4d716c36d58413))
* **v-slider:** add missing input-groups import ([#4047](https://github.com/vuetifyjs/vuetify/issues/4047)) ([c769cb8](https://github.com/vuetifyjs/vuetify/commit/c769cb8609324727c7e382b3e87bd2d81e41a055))
* **v-slider:** added missing style import ([6fd21f6](https://github.com/vuetifyjs/vuetify/commit/6fd21f6fe2595c0b19af988e6062869a11b170ac))
* **v-slider:** revert incorrect fix ([89f97d2](https://github.com/vuetifyjs/vuetify/commit/89f97d2257a6fe353e83e90c4d6a349a4d0c4429))
* **v-subheader:** fix broken styles ([b355155](https://github.com/vuetifyjs/vuetify/commit/b3551558c79cdbc48297023f77c22d700a188d6c))
* **v-text-field:** adjust suffix logic ([4c8c5e6](https://github.com/vuetifyjs/vuetify/commit/4c8c5e697f8fcf366303acb633259ae966f11f15))
* **v-text-field:** improve long suffixes ([91b3cf0](https://github.com/vuetifyjs/vuetify/commit/91b3cf0ea21474f797bb7fe42220be584ea3dfd7))
* **v-text-field:** remove clearable ([81f73c1](https://github.com/vuetifyjs/vuetify/commit/81f73c168c69cb77debe81fa7c98fa1effff09ae))
* **v-text-field:** remove duplicate clear icon ([913c2ab](https://github.com/vuetifyjs/vuetify/commit/913c2abfa1316c22d37ec50ac3fd09008b48a32e))
* **v-text-field:** remove full-width margin ([7e06f6c](https://github.com/vuetifyjs/vuetify/commit/7e06f6c4b5de022c6d9f8600de20bae375bc1457))
* **v-text-field:** updated box styles ([7781a71](https://github.com/vuetifyjs/vuetify/commit/7781a71b7dca2e0dee80f0e8076d0b5b4acadaf4))
* **v-text-field/area:** add keydown events ([57597a3](https://github.com/vuetifyjs/vuetify/commit/57597a3e4fdb346650406a108f38c85cbbd43cba)), closes [#3545](https://github.com/vuetifyjs/vuetify/issues/3545)
* **v-textarea:** add overflow ([6fcea3b](https://github.com/vuetifyjs/vuetify/commit/6fcea3b9617967ba2f104f13e7828feed385f113)), closes [#4012](https://github.com/vuetifyjs/vuetify/issues/4012)
* **v-textarea:** adjust details top ([17bd969](https://github.com/vuetifyjs/vuetify/commit/17bd969c0edabd7e91b44d295639745c1c87714b))
* **validatable:** update shouldValidate logic ([404eba3](https://github.com/vuetifyjs/vuetify/commit/404eba3fed74a9c3f7c166118fa54c279c618133))
* **VBreadcrumbs:** don't reuse divider VNodes ([f679af6](https://github.com/vuetifyjs/vuetify/commit/f679af6f09537752b015f52a9a7946c5794907e1)), closes [#3874](https://github.com/vuetifyjs/vuetify/issues/3874)
* **VInput:** allow input to fill width when in a flex container ([#4029](https://github.com/vuetifyjs/vuetify/issues/4029)) ([2a09896](https://github.com/vuetifyjs/vuetify/commit/2a098960f8c6bd541523f68eb89dc2345177d11c)), closes [#4022](https://github.com/vuetifyjs/vuetify/issues/4022)
* **VInput:** allow messages to contain HTML ([e7ad8fe](https://github.com/vuetifyjs/vuetify/commit/e7ad8fe973cdf00666829f2407718eb78f26b9a8))
* **VInput:** grow properly in IE ([f092c71](https://github.com/vuetifyjs/vuetify/commit/f092c7103b90303ce40cb2b23f81573e90290fff)), closes [#4029](https://github.com/vuetifyjs/vuetify/issues/4029)
* **VLabel:** correct Colorable call ([2037b18](https://github.com/vuetifyjs/vuetify/commit/2037b1853d75e936563c9021eb6d6ac2b3cfb518))
* **VRadio:** set correct checked attribute on internal input ([b34922e](https://github.com/vuetifyjs/vuetify/commit/b34922ed1ac25fd315f2e1eca44fdb8fa2a9df27))
* **VSelect:** toggle menu when dropdown arrow is clicked ([#4036](https://github.com/vuetifyjs/vuetify/issues/4036)) ([e66d513](https://github.com/vuetifyjs/vuetify/commit/e66d513281d5e9f47c5627463a019a9a8906824b)), closes [#4033](https://github.com/vuetifyjs/vuetify/issues/4033)
* **VSlider,VSelect:** hide input on IE and android ([641426c](https://github.com/vuetifyjs/vuetify/commit/641426c2b24374d5f35d45585327acd2032070d7))
* hide selection control's input in IE11 ([#4035](https://github.com/vuetifyjs/vuetify/issues/4035)) ([f57a775](https://github.com/vuetifyjs/vuetify/commit/f57a77535d6a98b8a449144aa9ac78cddd5bd912))
* **VTextField:** add back focus and blur methods ([#4030](https://github.com/vuetifyjs/vuetify/issues/4030)) ([d6870a4](https://github.com/vuetifyjs/vuetify/commit/d6870a472d2b6720d73fa137bb1b485eb16afb94))
* **VTextField:** fix error state with external validation ([#4010](https://github.com/vuetifyjs/vuetify/issues/4010)) ([33064ee](https://github.com/vuetifyjs/vuetify/commit/33064ee76ce5a5dc1d5ffaf178a9cc4f447796c6))
* increase specificity of outline chips to override theme background ([#3449](https://github.com/vuetifyjs/vuetify/issues/3449)) ([2038293](https://github.com/vuetifyjs/vuetify/commit/2038293395a513cbf68c933d6e4653eb98f16596)), closes [#3374](https://github.com/vuetifyjs/vuetify/issues/3374)
* reset page when changing sort order ([b2df69d](https://github.com/vuetifyjs/vuetify/commit/b2df69dd53b08e27d6b8a63c5edf838459b6461c))
* **VSelect:** add tags with tab when the menu is open ([#3240](https://github.com/vuetifyjs/vuetify/issues/3240)) ([cfbf262](https://github.com/vuetifyjs/vuetify/commit/cfbf262f3c7326b28876eea1ad23f5def62c3333))
* reset page to 1 when sorting changes ([3655f27](https://github.com/vuetifyjs/vuetify/commit/3655f27f99eadd06d14cfaffa4aa0b13508faa68))
* update $vuetify.application when created instead of mounted ([#3156](https://github.com/vuetifyjs/vuetify/issues/3156)) ([4518ccf](https://github.com/vuetifyjs/vuetify/commit/4518ccf435890a3ab5950ca0b124e3114a3c20d0))
* **application:** abstracting applicationable functionality ([#2703](https://github.com/vuetifyjs/vuetify/issues/2703)) ([b8d72ab](https://github.com/vuetifyjs/vuetify/commit/b8d72ab11f471ca2bdc531c433c04e341a847533))
* **bootable:** added check for active status ([#3132](https://github.com/vuetifyjs/vuetify/issues/3132)) ([77e119a](https://github.com/vuetifyjs/vuetify/commit/77e119a039184a30978221c413b7b579394b8363)), closes [#3084](https://github.com/vuetifyjs/vuetify/issues/3084)
* **date-picker:** allow external switching between date and month view ([d6935aa](https://github.com/vuetifyjs/vuetify/commit/d6935aa52a35d0b02b247efb8214d9de0fcf4ed4)), closes [#2809](https://github.com/vuetifyjs/vuetify/issues/2809)
* **date-picker:** incorrect button styles ([2e9d6af](https://github.com/vuetifyjs/vuetify/commit/2e9d6af4fabaee724c112837f8cc224bd53939ea)), closes [#2812](https://github.com/vuetifyjs/vuetify/issues/2812)
* **detachable:** fixed pug bug ([fcaf99c](https://github.com/vuetifyjs/vuetify/commit/fcaf99c9a68916ee3510b19ec3b10b15dce856ad))
* **detachable:** Hide when deactivated ([#2780](https://github.com/vuetifyjs/vuetify/issues/2780)) ([210813f](https://github.com/vuetifyjs/vuetify/commit/210813fae4eaa16504db1140d1f00fcc8fe1f03d)), closes [#2480](https://github.com/vuetifyjs/vuetify/issues/2480)
* **directives:** fixed a memory leak ([5b1ad97](https://github.com/vuetifyjs/vuetify/commit/5b1ad97dc32c5dc36f53e7dd64839116df97ae03)), closes [#2779](https://github.com/vuetifyjs/vuetify/issues/2779)
* **directives:** fixed a memory leak ([9d8d9d6](https://github.com/vuetifyjs/vuetify/commit/9d8d9d676cdb6935d6d3970fe3e839758fb828d5)), closes [#2779](https://github.com/vuetifyjs/vuetify/issues/2779)
* **display-helpers:** added !important to property declaration ([020d442](https://github.com/vuetifyjs/vuetify/commit/020d44206c276cad9903019aaa2c83505077cdf2))
* **maskable:** will now mask a value on mount ([aae73b7](https://github.com/vuetifyjs/vuetify/commit/aae73b75d699418303f6bd135f7389d3494e464a)), closes [#2722](https://github.com/vuetifyjs/vuetify/issues/2722)
* **menuable:** Enforce the check that $refs.content exist in sneakPeek ([#2721](https://github.com/vuetifyjs/vuetify/issues/2721)) ([9df0881](https://github.com/vuetifyjs/vuetify/commit/9df088191cbc76c951fbae7c6e6377e0b30cb672))
* **menuable:** removed margin, added functionality to parse margin ([dc44b0b](https://github.com/vuetifyjs/vuetify/commit/dc44b0b030fd6c44b21526ee7277f39a841f93ac)), closes [#2760](https://github.com/vuetifyjs/vuetify/issues/2760)
* **selection-controls:** removed pointer events when disabled ([67342c7](https://github.com/vuetifyjs/vuetify/commit/67342c7b6e463bc6aff35dc950d3ca20404026a6)), closes [#2670](https://github.com/vuetifyjs/vuetify/issues/2670)
* **tests:** all tests were failing after latest dependency bump ([#2817](https://github.com/vuetifyjs/vuetify/issues/2817)) ([caaa22a](https://github.com/vuetifyjs/vuetify/commit/caaa22a2e1971937ca4825d4b3d7503c142daa06))
* **text-field:** fixed bad styles causing issues ([50cfa89](https://github.com/vuetifyjs/vuetify/commit/50cfa89439a9f4c3df307479a11d3ea422c93ac2))
* **text-field/select:** set **input** to 100% width ([5453fd6](https://github.com/vuetifyjs/vuetify/commit/5453fd6b3be781abaff913d6212af45da0798c6f))
* **toolbar:** fixed scroll threshold ([8936e19](https://github.com/vuetifyjs/vuetify/commit/8936e19acf8209166597033eb3a1581d4a260333))
* **v-alert:** close icon now inherits color ([edf7860](https://github.com/vuetifyjs/vuetify/commit/edf786079e010f55c43364b77d08eeef98c7a2c0)), closes [#2762](https://github.com/vuetifyjs/vuetify/issues/2762)
* **v-avatar:** removed class overwrite ([ffec22b](https://github.com/vuetifyjs/vuetify/commit/ffec22bce0b6e4280266a3f3d44038ccd7d6ef3e))
* **v-bottom-nav:** fixed `v-btn` not being highlighted ([a7ff53a](https://github.com/vuetifyjs/vuetify/commit/a7ff53adfcfd27ef8ed344e8a99e6205ffccac04)), closes [#2801](https://github.com/vuetifyjs/vuetify/issues/2801)
* **v-btn:** fixed fab styles in ie11 ([#3127](https://github.com/vuetifyjs/vuetify/issues/3127)) ([251fe7b](https://github.com/vuetifyjs/vuetify/commit/251fe7bb445ce75a6a5ddaf3abf3785ce7b11482)), closes [#3068](https://github.com/vuetifyjs/vuetify/issues/3068)
* **v-chip:** updated for spec ([d5154ad](https://github.com/vuetifyjs/vuetify/commit/d5154ad2e555001fb17234fe79c9ff1610069045))
* **v-date-picker:** adjusted styles and markup ([#2966](https://github.com/vuetifyjs/vuetify/issues/2966)) ([01c306a](https://github.com/vuetifyjs/vuetify/commit/01c306ad11552cc4ea16cb910eac715b3d356d78))
* **v-date-picker:** fixed prop definition ([f37fe83](https://github.com/vuetifyjs/vuetify/commit/f37fe8391fea26d556b02eb468880c8ae94efd73))
* **v-date-picker-title:** fixed improper comparison for transition ([#3160](https://github.com/vuetifyjs/vuetify/issues/3160)) ([76a6043](https://github.com/vuetifyjs/vuetify/commit/76a604375800c5875a23b521913911d09c19cfb7))
* **v-expansion-panel:** add max-width to resolve overflow issues ([#2975](https://github.com/vuetifyjs/vuetify/issues/2975)) ([143e501](https://github.com/vuetifyjs/vuetify/commit/143e501cd64d67537d8c8a6b69a0b0a9cbd0b0dd))
* **v-list:** remove ability to select icons in list tiles ([9f17ac0](https://github.com/vuetifyjs/vuetify/commit/9f17ac0206f7ce39387f7b64ce4da8a3edd6e65f))
* **v-select:** fixed event call on empty value when blurring ([0985915](https://github.com/vuetifyjs/vuetify/commit/09859151e8bd708de4a70d6b7ab618af20ae37ef))
* **v-select:** fixed select keyboard functionality ([#3134](https://github.com/vuetifyjs/vuetify/issues/3134)) ([44ba15f](https://github.com/vuetifyjs/vuetify/commit/44ba15fa5eb3f90b57ef974fc0e553de9be67216)), closes [#3069](https://github.com/vuetifyjs/vuetify/issues/3069)
* **v-tab:** changed how active link is derived ([#3126](https://github.com/vuetifyjs/vuetify/issues/3126)) ([f262d1e](https://github.com/vuetifyjs/vuetify/commit/f262d1e781ec3bb09cfec7aade2cde3d1738fa07)), closes [#3010](https://github.com/vuetifyjs/vuetify/issues/3010)
* all color names are now lowercase ([350f01e](https://github.com/vuetifyjs/vuetify/commit/350f01e6f63a2fbe921afce47f7fcfca914d45e4))
* allow to override the elevation’s Stylus variables ([#3098](https://github.com/vuetifyjs/vuetify/issues/3098)) ([1e9b555](https://github.com/vuetifyjs/vuetify/commit/1e9b5552ad67f3b170b3f95aa104167fd01e6cc9))
* append/prepend icon position for switch and checkbox ([#2483](https://github.com/vuetifyjs/vuetify/issues/2483)) ([6317673](https://github.com/vuetifyjs/vuetify/commit/631767373b2848e1c7fe68beb236f9ec19854bb8)), closes [#2418](https://github.com/vuetifyjs/vuetify/issues/2418)
* Avoid high CPU usage in Safari ([#2958](https://github.com/vuetifyjs/vuetify/issues/2958)) ([88eacdd](https://github.com/vuetifyjs/vuetify/commit/88eacddb45b391e2f16d7298929a7e1dfdc857bd)), closes [#2773](https://github.com/vuetifyjs/vuetify/issues/2773)
* eventColor prop definition ([9264513](https://github.com/vuetifyjs/vuetify/commit/926451319965f9bcd600b6c23f3d4a0aed1a2b53))
* expansion-panel can't find nested content ([#3040](https://github.com/vuetifyjs/vuetify/issues/3040)) ([fc466fe](https://github.com/vuetifyjs/vuetify/commit/fc466fe9a0d29318c0f72c1e6f6287acee2a39d5)), closes [#2617](https://github.com/vuetifyjs/vuetify/issues/2617)
* generate row in data-table no-data slot ([#3106](https://github.com/vuetifyjs/vuetify/issues/3106)) ([a67f3b1](https://github.com/vuetifyjs/vuetify/commit/a67f3b17814152965a5cabcdef9a4261f7b73795)), closes [#3088](https://github.com/vuetifyjs/vuetify/issues/3088)
* hide slider when hideSlider is true ([#3014](https://github.com/vuetifyjs/vuetify/issues/3014)) ([4323cf6](https://github.com/vuetifyjs/vuetify/commit/4323cf6ea1074e7b8f0541766e277d62c9b8c45a)), closes [#2949](https://github.com/vuetifyjs/vuetify/issues/2949)
* make input error full width ([#3077](https://github.com/vuetifyjs/vuetify/issues/3077)) ([5fa860c](https://github.com/vuetifyjs/vuetify/commit/5fa860c47c970b2a7d0451e10fc443f24c075aa3))
* padStart polyfill implementation bug ([be0418c](https://github.com/vuetifyjs/vuetify/commit/be0418ca889af0702939c4fc8eba81b52b86c24a))
* picker title transition for month picker ([001bfd7](https://github.com/vuetifyjs/vuetify/commit/001bfd7268f9c16567c08df32c358c0520bd1c47))
* replaced throw with consoleError ([8b96ef9](https://github.com/vuetifyjs/vuetify/commit/8b96ef9340af81da931587822fd359682c32de53))
* selected date button is invisible with color prop applied ([d89e950](https://github.com/vuetifyjs/vuetify/commit/d89e95082211233ae7cffd76a69c72569a73b761))
* stepper style bleed ([#3096](https://github.com/vuetifyjs/vuetify/issues/3096)) ([cb2d597](https://github.com/vuetifyjs/vuetify/commit/cb2d597358198765e756a98fa0c26abcc0f06dc6)), closes [#3094](https://github.com/vuetifyjs/vuetify/issues/3094)
* stopped dialog activator event propagation ([#3105](https://github.com/vuetifyjs/vuetify/issues/3105)) ([d68ba24](https://github.com/vuetifyjs/vuetify/commit/d68ba24aed15df42bacba9f4d5935ddc04856bc6)), closes [#2942](https://github.com/vuetifyjs/vuetify/issues/2942)
* **babelrc:** transform harmony exports ([#3054](https://github.com/vuetifyjs/vuetify/issues/3054)) ([111c49d](https://github.com/vuetifyjs/vuetify/commit/111c49d5592854c1d698c1bfabd7f9ac23930879))
* **click-outside:** adjusted logic for determining click-outside state ([#3034](https://github.com/vuetifyjs/vuetify/issues/3034)) ([1e1d364](https://github.com/vuetifyjs/vuetify/commit/1e1d3640905b7d8d3db83f079d24046f8d2b267e)), closes [#3021](https://github.com/vuetifyjs/vuetify/issues/3021)
* **color-utils:** refactored **intToHex** function ([7b7cb19](https://github.com/vuetifyjs/vuetify/commit/7b7cb19a84e1fe3ed1c8178353807effb2318352)), closes [#3042](https://github.com/vuetifyjs/vuetify/issues/3042)
* **directives:** fixed memory leak ([#2997](https://github.com/vuetifyjs/vuetify/issues/2997)) ([355a0d1](https://github.com/vuetifyjs/vuetify/commit/355a0d15b8a1d3a416b2a6f1a5a4e7c905af384e))
* **menu:** clean up from the multiple renames in [#2716](https://github.com/vuetifyjs/vuetify/issues/2716) ([41c163f](https://github.com/vuetifyjs/vuetify/commit/41c163f3068f265daadbe3c831439c17f1bade9f)), closes [#1989](https://github.com/vuetifyjs/vuetify/issues/1989)
* **routable:** added default to **exact** prop ([faf2c39](https://github.com/vuetifyjs/vuetify/commit/faf2c3936214505126891ef0058a2c67750f823d)), closes [#2485](https://github.com/vuetifyjs/vuetify/issues/2485)
* **ssr:** use requestAnimationFrame for bootable instead of setTimeout ([ce04349](https://github.com/vuetifyjs/vuetify/commit/ce0434997bfebb22c8c3240081fe8b5bfbf7dfd5))
* **theme:** warn when invalid strings are used + add more formats ([991c262](https://github.com/vuetifyjs/vuetify/commit/991c26231988828bdcd0cf6a34c8be584a6156f0)), closes [#2995](https://github.com/vuetifyjs/vuetify/issues/2995)
* **v-btn:** fixed absent click event with using router ([be7fef1](https://github.com/vuetifyjs/vuetify/commit/be7fef1ecc599be118d248686f73e5b669e9caf0))
* **v-chip:** fixed focus styles in ie11 ([c02bb83](https://github.com/vuetifyjs/vuetify/commit/c02bb8390bbe7df0d8cb50eccf4514e957b1c611))
* **v-data-table:** adjustment for implicit alignment ([37595d3](https://github.com/vuetifyjs/vuetify/commit/37595d30aa119e456f39d88be514a30f27c0525a))
* **v-icon:** fixed render statement length for lint ([c9917be](https://github.com/vuetifyjs/vuetify/commit/c9917befe111e2fe9ab4a2a892b383d048ca1c7e))
* **v-jumbotron:** added missing transition ([cb1c3c3](https://github.com/vuetifyjs/vuetify/commit/cb1c3c37b0be33b7abb9eee32670353de4cfc127))
* **v-jumbotron:** fixed improperly styled images ([a368a5e](https://github.com/vuetifyjs/vuetify/commit/a368a5e8b85c93e2967e1b7d075f169c104e06d4)), closes [#2751](https://github.com/vuetifyjs/vuetify/issues/2751)
* **v-lists:** fixed improper hover style ([88a5ddd](https://github.com/vuetifyjs/vuetify/commit/88a5ddd522652b89348a2023b3936a8ea2c6404b)), closes [#2914](https://github.com/vuetifyjs/vuetify/issues/2914)
* **v-navigation-drawer:** adjusted logic for route watcher ([f629416](https://github.com/vuetifyjs/vuetify/commit/f6294162f297caebd4aa7d126c9e9440a9b799a1))
* **v-pagination:** removed overflow-x hide ([49df844](https://github.com/vuetifyjs/vuetify/commit/49df84448acefb02a6bd9b2ddf3efe462eafcd2a))
* **v-progress-circular:** removed unused prop fill ([7cd0f31](https://github.com/vuetifyjs/vuetify/commit/7cd0f31de96e7a189bc9477e9b2386973d701104))
* **v-scroll:** check if property exists before destructuring ([575d717](https://github.com/vuetifyjs/vuetify/commit/575d71711213173de5c7ab549a806369a91fe877))
* **v-select:** corrected search comparison ([98e15ca](https://github.com/vuetifyjs/vuetify/commit/98e15ca4b2748f4ebe7680afc089efa4b2ceed5b)), closes [#2754](https://github.com/vuetifyjs/vuetify/issues/2754)
* **v-select:** fixed menu positioning when filtering ([b44e5b4](https://github.com/vuetifyjs/vuetify/commit/b44e5b49c6050f6d6d32529f4707661b4d84640c))
* **v-select:** removed top and bottom padding for **chips** prop ([0deb043](https://github.com/vuetifyjs/vuetify/commit/0deb0433bfa85364e79ab9d21e4cfccc0037e5ae))
* **v-speed-dial:** renamed hover prop to open-on-hover ([#2903](https://github.com/vuetifyjs/vuetify/issues/2903)) ([6389663](https://github.com/vuetifyjs/vuetify/commit/6389663ebb00fcbd2971f764fde96807b2594171))
* **v-tab:** moved text specific styling to parent ([002b261](https://github.com/vuetifyjs/vuetify/commit/002b26148a1f5e50900b1fa688bfe7b1b5cb1049)), closes [#2909](https://github.com/vuetifyjs/vuetify/issues/2909)
* **v-tabs:** fixed error when using routes and tabs ([604faa6](https://github.com/vuetifyjs/vuetify/commit/604faa6df7af53fbff7f643672727b97791e0731)), closes [#2921](https://github.com/vuetifyjs/vuetify/issues/2921)
* **v-tabs:** moved css property ([7a39fb1](https://github.com/vuetifyjs/vuetify/commit/7a39fb133a0d2acd84ad4d20482402173da58219))
* **v-toolbar:** toolbar was applying incorrect application top ([743ba06](https://github.com/vuetifyjs/vuetify/commit/743ba06548002061732b0f5112037892c0af90c3))
* **VTextField:** only use valid domProps ([#3078](https://github.com/vuetifyjs/vuetify/issues/3078)) ([3344ddd](https://github.com/vuetifyjs/vuetify/commit/3344dddf2b02f604a4f5e8868f3111f13413b761)), closes [#3072](https://github.com/vuetifyjs/vuetify/issues/3072)
* add missing boolean operator ([3941758](https://github.com/vuetifyjs/vuetify/commit/394175890711fd2625d9cdecb99fe11e3503108f))
* added Colorable mixin to VAvatar ([d714af9](https://github.com/vuetifyjs/vuetify/commit/d714af95f4b2f764e2e26ce39810e5cd59621efc))
* do not apply ripple on disabled routable ([#2899](https://github.com/vuetifyjs/vuetify/issues/2899)) ([ec9fcae](https://github.com/vuetifyjs/vuetify/commit/ec9fcae39d982eddb0b51f866684eb85682c8ba8))
* fixed right aligned tabs ([ca1973d](https://github.com/vuetifyjs/vuetify/commit/ca1973d84d9b0224bc36940885ed37bf02594c39))
* flex-grow for tabs_container ([114f6fa](https://github.com/vuetifyjs/vuetify/commit/114f6fa3ee927f0ec8eb1f925f03441185c58dd7))
* move stylus with side-effects from tools to generic ([3d36d83](https://github.com/vuetifyjs/vuetify/commit/3d36d8352948a697061727762e1b55ad4f2a5916))
* remove old tooltip import from app.styl ([a8ad157](https://github.com/vuetifyjs/vuetify/commit/a8ad15711583c5ff148ebf020709cd005eadc95f))
* ripple prop as an object is passed as a bool to ripple directive ([7c18ae8](https://github.com/vuetifyjs/vuetify/commit/7c18ae8eb6c396d75fc143084be5aa933ae9a284))
* **v-stepper-content:** height not being set to auto ([f0fd28b](https://github.com/vuetifyjs/vuetify/commit/f0fd28b6a7562b1ae55abd7daa678d3f9a7e559e)), closes [#2870](https://github.com/vuetifyjs/vuetify/issues/2870)
* **v-tabs:** added flex-grow to centered tabs ([351eb82](https://github.com/vuetifyjs/vuetify/commit/351eb823632fb363efb23f4be2945d49c9affc32))
* **v-tabs:** fixed-tabs needed the container to grow ([66e8629](https://github.com/vuetifyjs/vuetify/commit/66e86292f983a551b9217869ddb16f0a9a660316))
* **v-toolbar:** corrected directive arguments ([d14f367](https://github.com/vuetifyjs/vuetify/commit/d14f367fce85eb6fb9d006bc902fffaff373a6cc))
* **VNavigationDrawer:** only close on route change when mobile/temporary ([99efccc](https://github.com/vuetifyjs/vuetify/commit/99efcccfacc4ef2f8201bdb38a422d0b869bf4ee)), closes [#2894](https://github.com/vuetifyjs/vuetify/issues/2894)
* **VSelect:** refresh menu position when filteredItems changes ([#2829](https://github.com/vuetifyjs/vuetify/issues/2829)) ([d6b1351](https://github.com/vuetifyjs/vuetify/commit/d6b13514e6d5899a6e26ea5006fb29b2f019ee1c)), closes [#2269](https://github.com/vuetifyjs/vuetify/issues/2269)
* **VTabs:** use new value as an index if tab action isn't found ([39f6717](https://github.com/vuetifyjs/vuetify/commit/39f671737384949b072cf05cb4aa453e5cba2fa0))
* application not updating top on screen resize ([#2782](https://github.com/vuetifyjs/vuetify/issues/2782)) ([68b7d8d](https://github.com/vuetifyjs/vuetify/commit/68b7d8de325995f5001936a4208514da43aa9988)), closes [#2781](https://github.com/vuetifyjs/vuetify/issues/2781)
* fixed bug where drawer would close on any touch event ([d7aa97e](https://github.com/vuetifyjs/vuetify/commit/d7aa97e4f42c4bfd40d27d102184a869439f3e38))
* removed unnecessary prop ([34d5e07](https://github.com/vuetifyjs/vuetify/commit/34d5e07883bc9ec9c0d7da64c7df057e8cd275ff))
* typo in prop definition ([65129b9](https://github.com/vuetifyjs/vuetify/commit/65129b910cfbbc8502c9b3f88e801ed44138dedf)), closes [#2803](https://github.com/vuetifyjs/vuetify/issues/2803)
* **input-groups:** added themeable for the **solo** prop ([e0a376d](https://github.com/vuetifyjs/vuetify/commit/e0a376dc14b0e4640be381ffd5140b9024cc5560)), closes [#2705](https://github.com/vuetifyjs/vuetify/issues/2705)
* **menuable:** removed position reset ([df2eec8](https://github.com/vuetifyjs/vuetify/commit/df2eec868c598c748822337c76d153619c3a161e)), closes [#2634](https://github.com/vuetifyjs/vuetify/issues/2634)
* **overlayable:** only check Elements for a scrollbar ([a5023be](https://github.com/vuetifyjs/vuetify/commit/a5023be65d51cb0c5a3f2eee8689e9e13c2bb83c)), closes [#2586](https://github.com/vuetifyjs/vuetify/issues/2586)
* **speed-dial:** Allow any element inside the activator button ([#2650](https://github.com/vuetifyjs/vuetify/issues/2650)) ([9066fb1](https://github.com/vuetifyjs/vuetify/commit/9066fb1a30eed2ea0774a160e045b93597300b8d))
* **tests:** downgrade babel-jest back to 21.0.2 ([405d121](https://github.com/vuetifyjs/vuetify/commit/405d12117e7ef0cba3ee16713e56323472f8bbed))
* **theme, ssr:** create $ssrContext._styles if it doesn't exist ([a082374](https://github.com/vuetifyjs/vuetify/commit/a0823746c8699a5cf0074b2e5e16e73e633acd34))
* **v-card:** fixed border radius when in card ([d7215d0](https://github.com/vuetifyjs/vuetify/commit/d7215d071e575be20afe909bc67ba2f6ab45a93c))
* **v-data-table:** adjusted icon size ([5b6dec6](https://github.com/vuetifyjs/vuetify/commit/5b6dec6b1338345a0477fcaf084c501a965327a1))
* **v-data-table:** removed key assignment to slotted tr ([2cf08d7](https://github.com/vuetifyjs/vuetify/commit/2cf08d71a9d32311d79846828ecb076d0c978758))
* **v-jumbotron:** added width 100% to image ([77dbf9f](https://github.com/vuetifyjs/vuetify/commit/77dbf9f44c0745167c5e37d80ebc3d1903c7bcf9)), closes [#2751](https://github.com/vuetifyjs/vuetify/issues/2751)
* **v-list:** fixed list display issue caused by a45089a6c646811a7fd08a6df66eb2f2e6d01a83 ([b9625af](https://github.com/vuetifyjs/vuetify/commit/b9625afa4ce1ad53e01760b55e6d8fa73f8b8c3e))
* **v-list:** fixed spacing in mini drawer ([a45089a](https://github.com/vuetifyjs/vuetify/commit/a45089a6c646811a7fd08a6df66eb2f2e6d01a83)), closes [#2746](https://github.com/vuetifyjs/vuetify/issues/2746)
* **v-list:** fixed top and bottom borders showing when active ([4e1a7de](https://github.com/vuetifyjs/vuetify/commit/4e1a7de014f6db7647b30a80130df16ac8673a73))
* **v-list-tile-action:** fixed alignment of selection-controls ([4f9d982](https://github.com/vuetifyjs/vuetify/commit/4f9d982980c8a86b38008687446b50fe973734ae)), closes [#2684](https://github.com/vuetifyjs/vuetify/issues/2684)
* **v-navigation-drawer:** added check for element before attempting to scrollTop ([efdbd80](https://github.com/vuetifyjs/vuetify/commit/efdbd80c6390b5f770b0e75956e396218c5a834c))
* **v-navigation-drawer:** resizing from mobile to desktop not updating layout ([2b40331](https://github.com/vuetifyjs/vuetify/commit/2b403314fa81a772907c216bd656c0dfe5d7dc28))
* **v-navigation-drawer:** revert lazy styles ([#2719](https://github.com/vuetifyjs/vuetify/issues/2719)) ([9fdf43d](https://github.com/vuetifyjs/vuetify/commit/9fdf43dd3d1d9fa0d71187b511638bae91d3cafa))
* **v-pagination:** change keys to use array index ([#2718](https://github.com/vuetifyjs/vuetify/issues/2718)) ([e371b81](https://github.com/vuetifyjs/vuetify/commit/e371b81df473f130d1cd7b4ef502e7e4fa2ea354))
* **v-progress-linear:** fixed active/inactive animation ([c2c114c](https://github.com/vuetifyjs/vuetify/commit/c2c114c3e4bdafcf90fd8a6d47b5abd3ffe0a7b5))
* **v-radio:** added error functionality ([60868e1](https://github.com/vuetifyjs/vuetify/commit/60868e19a8ef98750fe2dfa674b93f1d56c1161a)), closes [#2212](https://github.com/vuetifyjs/vuetify/issues/2212)
* **v-select:** fixed bug clearing value on tabout ([72ca1b9](https://github.com/vuetifyjs/vuetify/commit/72ca1b9bd7cd8b35a47c44055d9431c7b9c6217a)), closes [#2697](https://github.com/vuetifyjs/vuetify/issues/2697)
* **v-select:** fixed currentRange not properly evaluating integers ([496ff2c](https://github.com/vuetifyjs/vuetify/commit/496ff2c2f15270cd97d1acf50f7636fda8977bc5))
* **v-select:** fixed on blur value for combobox ([e9c405a](https://github.com/vuetifyjs/vuetify/commit/e9c405a643a0c47c4da7cf9529e387c2db09f69c))
* **v-select:** Initial items passed via prop should be cached too ([#2667](https://github.com/vuetifyjs/vuetify/issues/2667)) ([ea4f74a](https://github.com/vuetifyjs/vuetify/commit/ea4f74a0ec46cdc87bfb1482212b1e6a967b90ef))
* **v-select:** updated nudge top values for various props ([d78aac6](https://github.com/vuetifyjs/vuetify/commit/d78aac6cee745db52ba11914c755da29baaf63f6)), closes [#2626](https://github.com/vuetifyjs/vuetify/issues/2626)
* **v-select:** updated to handle integer 0 ([e05a390](https://github.com/vuetifyjs/vuetify/commit/e05a390e9530f22763552ab0aec7d4b1e67d4eba))
* **v-stepper:** fixed transition being cancelled early in certain situations ([eb19639](https://github.com/vuetifyjs/vuetify/commit/eb19639ef961caf3019d91361c8c0fa485e3999e)), closes [#2410](https://github.com/vuetifyjs/vuetify/issues/2410)
* **v-toolbar:** allow dynamic changing of **scroll-off-screen** ([11d0a5e](https://github.com/vuetifyjs/vuetify/commit/11d0a5e35b3eeeaa4b7dfa81bca2490690344682))
* **v-toolbar:** fixed a bug where scrolling to top would bring back a manual-scrolled toolbar ([36bc2a1](https://github.com/vuetifyjs/vuetify/commit/36bc2a16c0d4a78b1b20ce7a6a09cab66c9dde7b))
* **v-toolbar:** fixed false positive when scrolling ([d152334](https://github.com/vuetifyjs/vuetify/commit/d1523342850c0239e755187943024f749dc599c3))
* **v-toolbar:** re-evaluate application when **inverted-scroll** changes ([6ad1113](https://github.com/vuetifyjs/vuetify/commit/6ad1113c8d35fc6ed41ba7efe3dfe87fcb13dbf1))
* **v-toolbar/v-system-bar:** fixed the usage of `v-toolbar` and `v-system-bar` when using the **app* ([d89401a](https://github.com/vuetifyjs/vuetify/commit/d89401a2b3d91c3f0376e13420a6304ea9deccdf))
* **VBtn:** override padding on icon buttons ([8d6c8b7](https://github.com/vuetifyjs/vuetify/commit/8d6c8b7a782a5eba341cdf5aee172940cdf4bf16)), closes [#2558](https://github.com/vuetifyjs/vuetify/issues/2558)
* **VDataTable:** reset expanded value to object instead of array ([#2666](https://github.com/vuetifyjs/vuetify/issues/2666)) ([21268c8](https://github.com/vuetifyjs/vuetify/commit/21268c885bda40941d2c5c4156ef44815fa8f7d9))
* **VDialog:** prevent scrollable dialog content from being cut off in IE ([#2720](https://github.com/vuetifyjs/vuetify/issues/2720)) ([3f089fa](https://github.com/vuetifyjs/vuetify/commit/3f089fa36d19b97af1cf95291055598f4334230b)), closes [#2654](https://github.com/vuetifyjs/vuetify/issues/2654)
* **Vicon:** merge custom inline styles ([e4c1166](https://github.com/vuetifyjs/vuetify/commit/e4c1166e092abc59e835f6bfd0b4a3b925613df5)), closes [#2764](https://github.com/vuetifyjs/vuetify/issues/2764)
* **VSelect:** don't open the menu if readonly or disabled ([64b7e9e](https://github.com/vuetifyjs/vuetify/commit/64b7e9ee2754ee5f1aee759e501f0bbc8e4657c4)), closes [#2690](https://github.com/vuetifyjs/vuetify/issues/2690)
* accent button text color ([#2589](https://github.com/vuetifyjs/vuetify/issues/2589)) ([d74b138](https://github.com/vuetifyjs/vuetify/commit/d74b13843ff35f685917e660e1aa7f8059fa26fb)), closes [#2581](https://github.com/vuetifyjs/vuetify/issues/2581)
* added keys to stuff ([#2630](https://github.com/vuetifyjs/vuetify/issues/2630)) ([f09a516](https://github.com/vuetifyjs/vuetify/commit/f09a5165b77ead7b7e81e61a977a39d60e5c849c))
* **a-la-carte:** add missing exports ([#2473](https://github.com/vuetifyjs/vuetify/issues/2473)) ([888cbc5](https://github.com/vuetifyjs/vuetify/commit/888cbc5990d6d3783bf149f484a1a6900f40ada1)), closes [#2472](https://github.com/vuetifyjs/vuetify/issues/2472)
* **drawer:** convert isMobile to a computed property ([#2569](https://github.com/vuetifyjs/vuetify/issues/2569)) ([7430503](https://github.com/vuetifyjs/vuetify/commit/743050378ef09208ff44b5a3125a89908956a0c0)), closes [#2559](https://github.com/vuetifyjs/vuetify/issues/2559)
* **drawer:** only update layout when isActive changes ([b521ada](https://github.com/vuetifyjs/vuetify/commit/b521ada40f18299c17ea04988ebd7958c00bd7e8)), closes [#2512](https://github.com/vuetifyjs/vuetify/issues/2512)
* **drawer:** set correct content padding when temporary is toggled ([fe4eaba](https://github.com/vuetifyjs/vuetify/commit/fe4eaba21f6a5c9b850e1e7ba29b654dade8b48b))
* **v-list-tile-avatar:** refactored v-list-tile-avatar ([#2554](https://github.com/vuetifyjs/vuetify/issues/2554)) ([af1f9e4](https://github.com/vuetifyjs/vuetify/commit/af1f9e458f0c27e2293dbc9cb20c34467af35ac9)), closes [#1805](https://github.com/vuetifyjs/vuetify/issues/1805)
* display progress with headers slot ([#2479](https://github.com/vuetifyjs/vuetify/issues/2479)) ([50023ab](https://github.com/vuetifyjs/vuetify/commit/50023abec4a9f662d166f0e866f1551e6ac306b4)), closes [#2471](https://github.com/vuetifyjs/vuetify/issues/2471)
* remove extra padding from text field hint with prepended icon ([189954f](https://github.com/vuetifyjs/vuetify/commit/189954f71556ddccddf3d4fd2809f8b1f00f8785)), closes [#2063](https://github.com/vuetifyjs/vuetify/issues/2063) [#895](https://github.com/vuetifyjs/vuetify/issues/895) [#2517](https://github.com/vuetifyjs/vuetify/issues/2517)
* TypeScript export default class ([#2440](https://github.com/vuetifyjs/vuetify/issues/2440)) ([c352b71](https://github.com/vuetifyjs/vuetify/commit/c352b71966bf304758d4ae762e99dd2a7adeb9ee))
* **chip:** Move chip__content in front of background ([#2505](https://github.com/vuetifyjs/vuetify/issues/2505)) ([abb00d6](https://github.com/vuetifyjs/vuetify/commit/abb00d6afd5c87827c5dbb4f04bde8154d9c3bdc)), closes [#2501](https://github.com/vuetifyjs/vuetify/issues/2501)
* **stylus:** removed deprecated variable ([a08a37d](https://github.com/vuetifyjs/vuetify/commit/a08a37d2ccc6f71bfe9d698c5aa91385f5bd6659)), closes [#2497](https://github.com/vuetifyjs/vuetify/issues/2497)
* **subheader:** use correct text color ([872ade1](https://github.com/vuetifyjs/vuetify/commit/872ade15731715e647bca8dfcf223c0b2b0c72f0)), closes [#2054](https://github.com/vuetifyjs/vuetify/issues/2054)
* **tabs:** scroll controls were visible on mobile ([d438347](https://github.com/vuetifyjs/vuetify/commit/d43834752bbf0903fed1e4603dc8981b5919cf86))
* **text-field:** update lazyValue when bound value is changed by keydown ([#2503](https://github.com/vuetifyjs/vuetify/issues/2503)) ([f0b26ec](https://github.com/vuetifyjs/vuetify/commit/f0b26eccad393ffce152d4e477ef4fe987e82128))
* **theme:** generate theme stylesheet with SSR ([#2486](https://github.com/vuetifyjs/vuetify/issues/2486)) ([a39d01d](https://github.com/vuetifyjs/vuetify/commit/a39d01d6da9a2c93ff9333f08cffa71141260b86))
* **toolbar:** set correct mobile landscape height ([bc82fd5](https://github.com/vuetifyjs/vuetify/commit/bc82fd514f30849380c96a992fc43e70b25b6a99)), closes [#2447](https://github.com/vuetifyjs/vuetify/issues/2447)
* **v-bottom-nav:** added **app** support ([09791da](https://github.com/vuetifyjs/vuetify/commit/09791da95d4a82e6a59f72cb7145c1719fe17ba5)), closes [#2423](https://github.com/vuetifyjs/vuetify/issues/2423)
* **v-chip:** adjusted styling for proper spacing and colors ([38f84be](https://github.com/vuetifyjs/vuetify/commit/38f84be0028220908bf4cc4cabcebfd6070773d8)), closes [#2236](https://github.com/vuetifyjs/vuetify/issues/2236)
* **v-chip:** fixed overlay position on focus ([1fc2663](https://github.com/vuetifyjs/vuetify/commit/1fc26634a8a68883d0812a0479a6c0c432ce3448)), closes [#2539](https://github.com/vuetifyjs/vuetify/issues/2539)
* **v-dialog:** compare target on outside click ([0ef59de](https://github.com/vuetifyjs/vuetify/commit/0ef59de322641d1a1d08380918f073ddc4d23209)), closes [#2463](https://github.com/vuetifyjs/vuetify/issues/2463)
* **v-list:** changed markup to use proper tags ([8a55cc0](https://github.com/vuetifyjs/vuetify/commit/8a55cc0038358e3c63d723012e3aed2dfb1c9b78)), closes [#2301](https://github.com/vuetifyjs/vuetify/issues/2301)
* **v-menu:** added proper calculation for content min width ([d8d7b33](https://github.com/vuetifyjs/vuetify/commit/d8d7b3396a30c9c6a283b8397fcc98501eb5376a)), closes [#2416](https://github.com/vuetifyjs/vuetify/issues/2416)
* **v-navigation-drawer:** added stateless prop, fixed booting logic ([e7bc6e2](https://github.com/vuetifyjs/vuetify/commit/e7bc6e224866b73b0db32ec09b6973efdb0c8374))
* **v-navigation-drawer:** added temporary check in init ([e1759f1](https://github.com/vuetifyjs/vuetify/commit/e1759f1d24cbe2c5f042bc19db88bc331918725d))
* **v-navigation-drawer:** update drawer states reactivity with permanent ([#2495](https://github.com/vuetifyjs/vuetify/issues/2495)) ([10c64e3](https://github.com/vuetifyjs/vuetify/commit/10c64e3163fce752d4e81f4529cb45595c97270d)), closes [#2493](https://github.com/vuetifyjs/vuetify/issues/2493) [vuejs/vue#7063](https://github.com/vuejs/vue/issues/7063)
* **v-select:** adjusted nudge top based upon **hide-details** prop ([e2e11ba](https://github.com/vuetifyjs/vuetify/commit/e2e11ba6a6153422bf421c03af1423d3eed28dfa)), closes [#2377](https://github.com/vuetifyjs/vuetify/issues/2377)
* **v-tabs:** abort evaluation if there are no more items ([eb51034](https://github.com/vuetifyjs/vuetify/commit/eb51034eb49e56182a4c1d0f50e9e53b31aecbf3))
* **v-text-field:** stop propagation of return key when using **multi-line** prop ([8fce320](https://github.com/vuetifyjs/vuetify/commit/8fce320bf28eca51ba4ec2d312344cf622eb905d)), closes [#2506](https://github.com/vuetifyjs/vuetify/issues/2506)
* **VNavigationDrawer:** update application when miniVariant changes ([fc06302](https://github.com/vuetifyjs/vuetify/commit/fc0630267dc279d365e7e107a3a66cd61f49b6cb)), closes [#2534](https://github.com/vuetifyjs/vuetify/issues/2534) [#2547](https://github.com/vuetifyjs/vuetify/issues/2547)
* block next button when value equals to length ([0589c15](https://github.com/vuetifyjs/vuetify/commit/0589c1513c8938d5592a7850cc44930ace4a9254)), closes [#2433](https://github.com/vuetifyjs/vuetify/issues/2433) [#2460](https://github.com/vuetifyjs/vuetify/issues/2460)
* disabled pagination next button if length=0 ([#2460](https://github.com/vuetifyjs/vuetify/issues/2460)) ([50fc653](https://github.com/vuetifyjs/vuetify/commit/50fc65312896e21ee70441f5471ab4838633e53a)), closes [#2433](https://github.com/vuetifyjs/vuetify/issues/2433)
* Don't let cssnano mess with z-indexes ([e748769](https://github.com/vuetifyjs/vuetify/commit/e748769426391e55f65db7a62e50aa1f58928461)), closes [#2449](https://github.com/vuetifyjs/vuetify/issues/2449)
* **VDataTable:** customFilter function now only filters on header values ([#2287](https://github.com/vuetifyjs/vuetify/issues/2287)) ([648e03f](https://github.com/vuetifyjs/vuetify/commit/648e03faf89fb2a68ed5d6fb59accfc5869800cc)), closes [#1045](https://github.com/vuetifyjs/vuetify/issues/1045)
* clip progress bar on loading input groups ([aba924a](https://github.com/vuetifyjs/vuetify/commit/aba924a7e159fe703b3fd1ceae895ac0220f6e10)), closes [#2063](https://github.com/vuetifyjs/vuetify/issues/2063)
* picker header color in dark theme ([#2402](https://github.com/vuetifyjs/vuetify/issues/2402)) ([5bfd110](https://github.com/vuetifyjs/vuetify/commit/5bfd1102b85030717980fe1e8fe159f5a4dccd7c))
* removed javascript:; declarations ([#2450](https://github.com/vuetifyjs/vuetify/issues/2450)) ([b2b1a4a](https://github.com/vuetifyjs/vuetify/commit/b2b1a4a96bf87d938c415ffbc8197131e67b276f)), closes [#2321](https://github.com/vuetifyjs/vuetify/issues/2321)
* updated link specificity ([6c2adf4](https://github.com/vuetifyjs/vuetify/commit/6c2adf4447b8d2d81779fdef988e2498a3c978f6)), closes [#2437](https://github.com/vuetifyjs/vuetify/issues/2437)
* **VForm:** don't show native validation errors on submit ([c58cf66](https://github.com/vuetifyjs/vuetify/commit/c58cf66a64b88a6165ee4ccf0e373ec6ca72f68f)), closes [#2445](https://github.com/vuetifyjs/vuetify/issues/2445)
* escape item text in select menu ([#2391](https://github.com/vuetifyjs/vuetify/issues/2391)) ([d6a2582](https://github.com/vuetifyjs/vuetify/commit/d6a25820a9a6bc7adf89349f2e811dfcfceb88f6))
* **v-select:** removed dev code ([b0b8707](https://github.com/vuetifyjs/vuetify/commit/b0b87072c2c6b7b5a0bd3316f01f1f7de460d280))
* **v-select:** updated logic for determining menu active state ([da6bec6](https://github.com/vuetifyjs/vuetify/commit/da6bec67881039482867e144b340694dd8974ff5)), closes [#2103](https://github.com/vuetifyjs/vuetify/issues/2103)
* [#2342](https://github.com/vuetifyjs/vuetify/issues/2342) ([#2344](https://github.com/vuetifyjs/vuetify/issues/2344)) ([df230ed](https://github.com/vuetifyjs/vuetify/commit/df230edb1273f608295ed9cebefdc12b8feb1ee5))
* **input:** removed generation of messages with prop ([3eb8c4a](https://github.com/vuetifyjs/vuetify/commit/3eb8c4a9a4518ea6570390e14b92f03d030a37a3)), closes [#2417](https://github.com/vuetifyjs/vuetify/issues/2417)
* invalid textfield behaviour with number value ([#2360](https://github.com/vuetifyjs/vuetify/issues/2360)) ([f12c7ef](https://github.com/vuetifyjs/vuetify/commit/f12c7ef233220641761db7990c9923a613d6daf1)), closes [#2359](https://github.com/vuetifyjs/vuetify/issues/2359)
* **chips:** prevent changing the size of an element in outline mode ([#2394](https://github.com/vuetifyjs/vuetify/issues/2394)) ([8dd82f6](https://github.com/vuetifyjs/vuetify/commit/8dd82f6b2edfa4a805c902e732b50569b4d1b6aa))
* (VExpansionPanel) use component name instead of private property _componentTag ([#2312](https://github.com/vuetifyjs/vuetify/issues/2312)) ([1face80](https://github.com/vuetifyjs/vuetify/commit/1face802cec0d339dcc9de183bf44c65c32d43a7))
* **layout:** fix layout regression from [#2298](https://github.com/vuetifyjs/vuetify/issues/2298) ([#2328](https://github.com/vuetifyjs/vuetify/issues/2328)) ([7203c7d](https://github.com/vuetifyjs/vuetify/commit/7203c7d41a03de2078e8a094cfbf7c57055232c6))
* **layout:** make .application the root element again ([1825d2a](https://github.com/vuetifyjs/vuetify/commit/1825d2ac7a7593bafc9d198b3fd5ac6dbbc92e4f))
* **perf:** gpu accelerate time picker hand ([1f89d64](https://github.com/vuetifyjs/vuetify/commit/1f89d64b11670f9ac0fef56e7cc7ba6167382e90))
* **perf:** Make date pickers slightly faster ([5e5b40e](https://github.com/vuetifyjs/vuetify/commit/5e5b40ef96408873b6180aba0a39ed8e1d3877fd))
* **ripple:** size the ripple correctly to its activator ([16cfdec](https://github.com/vuetifyjs/vuetify/commit/16cfdec37327a131f1fb57d7b018960b9bdb855f))
* **v-badge:** fixed text vertical position ([7072183](https://github.com/vuetifyjs/vuetify/commit/7072183625ae048fd057a65800796c0172267eda))
* **v-chip:** fixed sizing bug in `v-chip` when using the **small** prop ([08284ac](https://github.com/vuetifyjs/vuetify/commit/08284aca73cf49d0d68d748947d5b03832b2ff3d))
* **v-icon:** updated style specificity for color ([efe74f3](https://github.com/vuetifyjs/vuetify/commit/efe74f309510e90b6c9c8fab2b0eb4d8874de708))
* **v-navigation-drawer:** fixed `v-navigation-drawer` with **temporary** prop ([676d4a3](https://github.com/vuetifyjs/vuetify/commit/676d4a306e2b7a5c794cd1c4ccef7e674b85252c))
* **v-select:** fixed combobox functionality ([e6993e5](https://github.com/vuetifyjs/vuetify/commit/e6993e5aac5ec4bd417841365e416d54778a1b0d))
* **v-tabs:** fixed ssr-bug, remove default background declaration ([bd0ce95](https://github.com/vuetifyjs/vuetify/commit/bd0ce959c3e3877c3f00478f3ff9585c5acb7bf2))
* **v-tabs-item:** added theme colors ([ada1d09](https://github.com/vuetifyjs/vuetify/commit/ada1d09c50d1c5e6703c3960e183765821d8285a))
* **v-text-field:** fixed **internalChange** prop not resetting ([0414fc6](https://github.com/vuetifyjs/vuetify/commit/0414fc62b9a71fb2f609c55607da5fd12ff5a216))
* adds quotes to background image ([#2349](https://github.com/vuetifyjs/vuetify/issues/2349)) ([f26b660](https://github.com/vuetifyjs/vuetify/commit/f26b660163ef74bf0c91c152d5eec05930896219)), closes [#2346](https://github.com/vuetifyjs/vuetify/issues/2346)
* **btn:** fixed fab and outline styling ([a2bd0f2](https://github.com/vuetifyjs/vuetify/commit/a2bd0f2c9197bd0866b506adff02a1cd56e1c701))
* **v-select:** fixed auto menu position ([c52bf1f](https://github.com/vuetifyjs/vuetify/commit/c52bf1f448dda10e6fee9f9cbaaabb58b8fde187))
* allow string for mobileBreakPoint in v-navigation-drawer ([4cc9c01](https://github.com/vuetifyjs/vuetify/commit/4cc9c01549cb6111fae256f973b24cd29ba4996f))
* Allow text fields to have an initial value of 0 ([95b7f83](https://github.com/vuetifyjs/vuetify/commit/95b7f834688eeb486ca3e922945a50c89e4a47bc)), closes [#2136](https://github.com/vuetifyjs/vuetify/issues/2136)
* arrow up/down not working in inputs in dialog ([#2350](https://github.com/vuetifyjs/vuetify/issues/2350)) ([aa8684a](https://github.com/vuetifyjs/vuetify/commit/aa8684a3567353c587cc97932ec7b4e4faa0103a)), closes [#2319](https://github.com/vuetifyjs/vuetify/issues/2319)
* auto height of data table expanded row ([#2275](https://github.com/vuetifyjs/vuetify/issues/2275)) ([9e4d92b](https://github.com/vuetifyjs/vuetify/commit/9e4d92bac9c2afd569b28981be0a959281b7d497))
* background color for segmented button ([#2183](https://github.com/vuetifyjs/vuetify/issues/2183)) ([5500c0b](https://github.com/vuetifyjs/vuetify/commit/5500c0bfe87b06e3ea7facae7b57c4d49be699b3)), closes [#2126](https://github.com/vuetifyjs/vuetify/issues/2126)
* clearable icon behaviour in autocomplete ([#2263](https://github.com/vuetifyjs/vuetify/issues/2263)) ([eb1879d](https://github.com/vuetifyjs/vuetify/commit/eb1879d85d15cc57def091150305e76295c93a28)), closes [#2200](https://github.com/vuetifyjs/vuetify/issues/2200)
* disable focusing slider when disabled ([e44c079](https://github.com/vuetifyjs/vuetify/commit/e44c07959f7e10e3ccd1dac370f103f3226f51fe))
* don't setSelectionRange if the input doesn't exist any more ([0a406e9](https://github.com/vuetifyjs/vuetify/commit/0a406e9751e395b1d092482eda4af6ad39d2f25f)), closes [#2219](https://github.com/vuetifyjs/vuetify/issues/2219)
* don't trigger click-outside when click() is called programmaticaly ([#2229](https://github.com/vuetifyjs/vuetify/issues/2229)) ([50d3b8b](https://github.com/vuetifyjs/vuetify/commit/50d3b8b8ee9ede65834e07eb767f9b4925987431)), closes [#2092](https://github.com/vuetifyjs/vuetify/issues/2092)
* proper unbinding of touch events ([#2286](https://github.com/vuetifyjs/vuetify/issues/2286)) ([b29b7a5](https://github.com/vuetifyjs/vuetify/commit/b29b7a55dc6031c19c6aa622bf418760a9726f7d)), closes [#2248](https://github.com/vuetifyjs/vuetify/issues/2248)
* remove necessity of <main> ([#2298](https://github.com/vuetifyjs/vuetify/issues/2298)) ([3744603](https://github.com/vuetifyjs/vuetify/commit/3744603d3107c7e1a244f8b9224b723d6e32a87f))
* **menuable:** added comparison logic for shown ([8792777](https://github.com/vuetifyjs/vuetify/commit/879277771ff201269e6c07cc5d5d6e7588250d08))
* **v-select:** fixed tests from [#2243](https://github.com/vuetifyjs/vuetify/issues/2243) PR ([efebc93](https://github.com/vuetifyjs/vuetify/commit/efebc93e416504f388f0e31ba91881a7af04c13f))
* **v-tooltip:** increased flex width of tooltip ([#2206](https://github.com/vuetifyjs/vuetify/issues/2206)) ([a1265fa](https://github.com/vuetifyjs/vuetify/commit/a1265fa51e5c46fbcedb02aa0afaaadcb0c89518)), closes [#2171](https://github.com/vuetifyjs/vuetify/issues/2171)
* **VDialog:** focus dialog__content when opened ([4bcda35](https://github.com/vuetifyjs/vuetify/commit/4bcda358dc12647e8255d7622bd685e5712eca40)), closes [#2261](https://github.com/vuetifyjs/vuetify/issues/2261)
* don't setSelectionRange if the input doesn't exist any more ([b35c446](https://github.com/vuetifyjs/vuetify/commit/b35c446ebe8a254f62a6571ceab48a3663d8c8b0)), closes [#2219](https://github.com/vuetifyjs/vuetify/issues/2219)
* prevent race condition when VSelect is destroyed after mount ([4695b21](https://github.com/vuetifyjs/vuetify/commit/4695b21eeb8922866b74fe97266ac74dacc3e0ca)), closes [#2194](https://github.com/vuetifyjs/vuetify/issues/2194)
* set proper expanded row height ([#2220](https://github.com/vuetifyjs/vuetify/issues/2220)) ([992bd59](https://github.com/vuetifyjs/vuetify/commit/992bd59a483539a7eb2e492df82228268b9e5e1a)), closes [#2215](https://github.com/vuetifyjs/vuetify/issues/2215)
* **VDialog:** only disable scrolling when active ([ce4e44c](https://github.com/vuetifyjs/vuetify/commit/ce4e44c2b1fda75c9ccac4bf72c021536a9cf72d)), closes [#2262](https://github.com/vuetifyjs/vuetify/issues/2262)
* set proper expanded row height ([#2220](https://github.com/vuetifyjs/vuetify/issues/2220)) ([7d4b463](https://github.com/vuetifyjs/vuetify/commit/7d4b463827d1f8489401082b02c6f1ee4cee98c7)), closes [#2215](https://github.com/vuetifyjs/vuetify/issues/2215)
* **VSelect:** check for addEventListener in isBooted watcher ([0c710b0](https://github.com/vuetifyjs/vuetify/commit/0c710b0bee18fccad9223312cab421ff7eb6dd09)), closes [#2213](https://github.com/vuetifyjs/vuetify/issues/2213) [#1821](https://github.com/vuetifyjs/vuetify/issues/1821)
* **VSelect:** check for addEventListener in isBooted watcher ([a2a3533](https://github.com/vuetifyjs/vuetify/commit/a2a35330169a8c7b9abbcfcbdacb91a0b995fcab)), closes [#2213](https://github.com/vuetifyjs/vuetify/issues/2213) [#1821](https://github.com/vuetifyjs/vuetify/issues/1821)
* **VSelect:** don't hide the text field when not dirty ([3592f5e](https://github.com/vuetifyjs/vuetify/commit/3592f5ef23f74b4ca7e0b2244530c467c6227639)), closes [#2214](https://github.com/vuetifyjs/vuetify/issues/2214) [#2172](https://github.com/vuetifyjs/vuetify/issues/2172)
* **VSelect:** don't hide the text field when not dirty ([f146c49](https://github.com/vuetifyjs/vuetify/commit/f146c49d1b0215c40c30cb28f87d68377833da13)), closes [#2214](https://github.com/vuetifyjs/vuetify/issues/2214) [#2172](https://github.com/vuetifyjs/vuetify/issues/2172)
* background color for segmented button ([#2183](https://github.com/vuetifyjs/vuetify/issues/2183)) ([49f4823](https://github.com/vuetifyjs/vuetify/commit/49f482381b2545d66e684f97e9ee4f52206a47d0)), closes [#2126](https://github.com/vuetifyjs/vuetify/issues/2126)
* data iterator items should not be filtered with empty search ([#2635](https://github.com/vuetifyjs/vuetify/issues/2635)) ([85bd400](https://github.com/vuetifyjs/vuetify/commit/85bd400867c7e5715f035d1d919bdf7636e49ffe)), closes [#2590](https://github.com/vuetifyjs/vuetify/issues/2590)
* do not render bootable content if not active ([#2347](https://github.com/vuetifyjs/vuetify/issues/2347)) ([8a9ec36](https://github.com/vuetifyjs/vuetify/commit/8a9ec365a42594af533257de9112da8cf59d176f)), closes [#2305](https://github.com/vuetifyjs/vuetify/issues/2305) [#2080](https://github.com/vuetifyjs/vuetify/issues/2080)
* don't select date when changing year and date not allowed ([#2612](https://github.com/vuetifyjs/vuetify/issues/2612)) ([9a3ae44](https://github.com/vuetifyjs/vuetify/commit/9a3ae44177251091f4309500090fa252259ce78e)), closes [#2611](https://github.com/vuetifyjs/vuetify/issues/2611)
* Don't show 'undefined' in empty v-selects with Vue 2.5.0 ([b7940c4](https://github.com/vuetifyjs/vuetify/commit/b7940c40794d726737453dc60c74ce30db9bf32d))
* Don't show 'undefined' in empty v-selects with Vue 2.5.0 ([f581177](https://github.com/vuetifyjs/vuetify/commit/f5811774f8ec34c68eba40256600583a8a3311a7))
* don't update inputDate if new date is not allowed ([#2198](https://github.com/vuetifyjs/vuetify/issues/2198)) ([79272bf](https://github.com/vuetifyjs/vuetify/commit/79272bf74e45e2fd9e37157fc57579356cedd4cc)), closes [#2106](https://github.com/vuetifyjs/vuetify/issues/2106)
* duplicated entries when using cache-items with return-object ([#2195](https://github.com/vuetifyjs/vuetify/issues/2195)) ([9c4da4a](https://github.com/vuetifyjs/vuetify/commit/9c4da4a9ff69fcc1d07b1926a95f2bec28d661b2))
* duplicated entries when using cache-items with return-object ([#2195](https://github.com/vuetifyjs/vuetify/issues/2195)) ([d3dddd8](https://github.com/vuetifyjs/vuetify/commit/d3dddd8e626ca49619dbe42c24dffd51be2e2529))
* fixed bug where drawer would close on any touch event ([5acd07e](https://github.com/vuetifyjs/vuetify/commit/5acd07e2c8822f00eddd155eb557d0999309f613))
* styles for buttons in bottom navigation ([#2182](https://github.com/vuetifyjs/vuetify/issues/2182)) ([bbaa09d](https://github.com/vuetifyjs/vuetify/commit/bbaa09d7d26beb0edbb82311d1b34d1ec690b998)), closes [#2015](https://github.com/vuetifyjs/vuetify/issues/2015)
* styles for buttons in bottom navigation ([#2182](https://github.com/vuetifyjs/vuetify/issues/2182)) ([94564d6](https://github.com/vuetifyjs/vuetify/commit/94564d6685a886c39fb6f50285829c214fe8f8f7)), closes [#2015](https://github.com/vuetifyjs/vuetify/issues/2015)
* **textarea:** Match border transition with the label ([25c56a3](https://github.com/vuetifyjs/vuetify/commit/25c56a3c53271c875a47c1cc532bdf6e686a4989))
* **v-dialog:** always remove scrollbar when fullscreen ([ff5d07b](https://github.com/vuetifyjs/vuetify/commit/ff5d07b6cd78d23312a924cc45269ea9818318b0)), closes [#3101](https://github.com/vuetifyjs/vuetify/issues/3101)
* **v-item-group:** avoid unregistration process when destroyed ([cd18540](https://github.com/vuetifyjs/vuetify/commit/cd18540d6f7a34443b00a7789f69e52f56dab729)), closes [#5384](https://github.com/vuetifyjs/vuetify/issues/5384)
* **v-item-group:** handle initial item state on registration ([4af99de](https://github.com/vuetifyjs/vuetify/commit/4af99de2e979ade669d3f479346101e530f5cddc)), closes [#5410](https://github.com/vuetifyjs/vuetify/issues/5410)
* **v-item-group:** invoke state update on nextTick ([b9a5e64](https://github.com/vuetifyjs/vuetify/commit/b9a5e649508965de761cf4473b35573899710a25)), closes [#5352](https://github.com/vuetifyjs/vuetify/issues/5352)
* **v-item-group:** update item model on register ([b6ec287](https://github.com/vuetifyjs/vuetify/commit/b6ec287d8ed3fc4b555df8d6b3f2868c82582d46)), closes [#5222](https://github.com/vuetifyjs/vuetify/issues/5222)
* **v-radio-group:** change radio margin selector ([08cac48](https://github.com/vuetifyjs/vuetify/commit/08cac4872d1643c5e96902fe42032ad121474861)), closes [#5255](https://github.com/vuetifyjs/vuetify/issues/5255)
* **v-rating:** switched from using offsetX to calculate half-increments ([#5374](https://github.com/vuetifyjs/vuetify/issues/5374)) ([e43441d](https://github.com/vuetifyjs/vuetify/commit/e43441d3f91dde84f8bc0832e61f4c0a792533e7)), closes [#5240](https://github.com/vuetifyjs/vuetify/issues/5240)
* **v-ripple:** decrease click target size on selection control ripple ([#5250](https://github.com/vuetifyjs/vuetify/issues/5250)) ([26af9bf](https://github.com/vuetifyjs/vuetify/commit/26af9bfea5b7b53b217e9bd9063e0e34699e3e6e)), closes [#2661](https://github.com/vuetifyjs/vuetify/issues/2661)
* **v-ripple:** only modify position if current one is static ([#5249](https://github.com/vuetifyjs/vuetify/issues/5249)) ([85bfe20](https://github.com/vuetifyjs/vuetify/commit/85bfe20c27205960dd2a2188185771583809b3cd)), closes [#2573](https://github.com/vuetifyjs/vuetify/issues/2573)
* **v-select:** change isDisabled conditional ([5cfaeba](https://github.com/vuetifyjs/vuetify/commit/5cfaeba0b7277823fb83ba5be4ec792009eace5d)), closes [#5051](https://github.com/vuetifyjs/vuetify/issues/5051)
* **v-select:** move progress loader ([43cb35f](https://github.com/vuetifyjs/vuetify/commit/43cb35f6f676d0f185f61af43d8ce9e30ad78a20)), closes [#5365](https://github.com/vuetifyjs/vuetify/issues/5365)
* **v-stepper:** add registrable mixin ([f7b17e7](https://github.com/vuetifyjs/vuetify/commit/f7b17e78b66420046382b8ad8a64b2ee7b0bcf7d)), closes [#3330](https://github.com/vuetifyjs/vuetify/issues/3330)
* **v-stepper:** remove deprecated fn call ([e454bba](https://github.com/vuetifyjs/vuetify/commit/e454bbafa9d081e6981fcd923ee194ff35a84b63))
* **v-tabs:** re-enable tests ([bb69dd5](https://github.com/vuetifyjs/vuetify/commit/bb69dd58d142078f57eb1e68dd0a12860010b2c2))
* **v-tabs:** remove arbitrary delay on init ([6810169](https://github.com/vuetifyjs/vuetify/commit/6810169ec01fcc7205e45ee0b421deecf6742ec0))
* **VImg:** load image after mount ([d72ea8d](https://github.com/vuetifyjs/vuetify/commit/d72ea8d91b710a427f2b36df5e0e08d8180e88d4)), closes [#5153](https://github.com/vuetifyjs/vuetify/issues/5153)
* VPagination acts as submit in forms ([#5212](https://github.com/vuetifyjs/vuetify/issues/5212)) ([#5229](https://github.com/vuetifyjs/vuetify/issues/5229)) ([cb29f21](https://github.com/vuetifyjs/vuetify/commit/cb29f210895c5ddb2585d792707bbf456636d94c))
* **v-item-group:** remove default flex-grow ([1fb9e58](https://github.com/vuetifyjs/vuetify/commit/1fb9e5848f847acca3a19963cfa33c9d4c22abd1)), closes [#5337](https://github.com/vuetifyjs/vuetify/issues/5337)
* **v-tabs:** scroll tab into view when model changes ([51e917c](https://github.com/vuetifyjs/vuetify/commit/51e917cb8e372516e0756ab5036ea4735496c993)), closes [#5052](https://github.com/vuetifyjs/vuetify/issues/5052)
* **VTab:** remove theme override ([2b2e06d](https://github.com/vuetifyjs/vuetify/commit/2b2e06d7657239501c3b639d4bc82c2aa3170364)), closes [#5349](https://github.com/vuetifyjs/vuetify/issues/5349)
* readded catalan locale ([932349a](https://github.com/vuetifyjs/vuetify/commit/932349ace32e6f74f4dc9ba2d3a69120cb2ec12d)), closes [#5348](https://github.com/vuetifyjs/vuetify/issues/5348)
* remove VBreadcrumbs.js ([5bc327b](https://github.com/vuetifyjs/vuetify/commit/5bc327bd02827ab760b6117b49545d19956ce2d2))
* **DatePicker:** Title spacing when month === August ([#5027](https://github.com/vuetifyjs/vuetify/issues/5027)) ([046d284](https://github.com/vuetifyjs/vuetify/commit/046d2840b3d0150c2cd42c642fa54e35e136988f))
* **directives:** register by key instead of name ([a443828](https://github.com/vuetifyjs/vuetify/commit/a4438289867621101748601ba06f05ff3d324e93)), closes [#4667](https://github.com/vuetifyjs/vuetify/issues/4667) [#4871](https://github.com/vuetifyjs/vuetify/issues/4871)
* **iterable:** rows-per-page selector not inheriting theme ([a81310f](https://github.com/vuetifyjs/vuetify/commit/a81310f6433dca9a78c1efd23eb75a21872da9e4))
* **selectable:** only emit change event once ([94c4b2e](https://github.com/vuetifyjs/vuetify/commit/94c4b2e9d02608ad0e462d59d1f9cebc555b4afb)), closes [#4886](https://github.com/vuetifyjs/vuetify/issues/4886)
* **theme:** work around vue-meta bug ([190274f](https://github.com/vuetifyjs/vuetify/commit/190274fc58125803108a3cf0a3374059c7b61b07)), closes [#4958](https://github.com/vuetifyjs/vuetify/issues/4958)
* **transitions:** fix scroll-y ([49a8cbe](https://github.com/vuetifyjs/vuetify/commit/49a8cbec3a7246e3d4ae7327c8159795f6ddcc03))
* **transitions:** fix slide-y-reverse-transition ([91f0fb3](https://github.com/vuetifyjs/vuetify/commit/91f0fb3095b329bc5a9ed6160a11f76b0febf084)), closes [#4971](https://github.com/vuetifyjs/vuetify/issues/4971) [#4978](https://github.com/vuetifyjs/vuetify/issues/4978)
* **translatable:** partially revert 5f661a3 ([ffc3c9c](https://github.com/vuetifyjs/vuetify/commit/ffc3c9c501ff8e7dfcc43ace58e2734ec49e395c)), closes [#4847](https://github.com/vuetifyjs/vuetify/issues/4847)
* **v-autocomplete:** add conditional for single-line ([d74624c](https://github.com/vuetifyjs/vuetify/commit/d74624ca1bd2304e20c2a7774eaedf510e31a410)), closes [#5076](https://github.com/vuetifyjs/vuetify/issues/5076)
* **v-autocomplete:** allow setSearch for numeric 0 ([488f0d6](https://github.com/vuetifyjs/vuetify/commit/488f0d602cb1c055b7757e91423f7696eba3e093)), closes [#5110](https://github.com/vuetifyjs/vuetify/issues/5110)
* **v-combobox:** prevent default action ([259da33](https://github.com/vuetifyjs/vuetify/commit/259da33bff5627b7f5d9a79e0b4b9627883f6be5)), closes [#4974](https://github.com/vuetifyjs/vuetify/issues/4974)
* **v-combobox:** update onEnterDown logic ([6179807](https://github.com/vuetifyjs/vuetify/commit/61798076229021e5b61a34c22c60bf05fc9dabe3)), closes [#5008](https://github.com/vuetifyjs/vuetify/issues/5008)
* **v-divider:** fix **vertical** prop display ([96c4391](https://github.com/vuetifyjs/vuetify/commit/96c43910b83cf22d8ffb7e7c80135c30971df52c))
* **v-divider:** fix vertical styles ([04a8b86](https://github.com/vuetifyjs/vuetify/commit/04a8b8659a02c0419d63f9e5789df6dc69d74687)), closes [#4976](https://github.com/vuetifyjs/vuetify/issues/4976)
* **v-expand-transition:** fix replaced height ([9412890](https://github.com/vuetifyjs/vuetify/commit/94128903d535752bc64260d7735bb22cdf888799))
* **v-expand-transition:** remove height afterLeave ([f90d17b](https://github.com/vuetifyjs/vuetify/commit/f90d17be03531526614edb59a76ade238472949c)), closes [#4808](https://github.com/vuetifyjs/vuetify/issues/4808)
* **v-expansion-panel:** remove explicit height ([3b7adf3](https://github.com/vuetifyjs/vuetify/commit/3b7adf38a8a0928a968e17f797b65c6772fdf7c2)), closes [#4977](https://github.com/vuetifyjs/vuetify/issues/4977)
* **v-expansion-transition:** do not overwrite user defined height ([44ac40d](https://github.com/vuetifyjs/vuetify/commit/44ac40d34aa6abc0e19e929143d11f8b0694e406))
* **v-footer:** fix applicationProperty update ([bdb5060](https://github.com/vuetifyjs/vuetify/commit/bdb506050c88eee12cb9a5292b35ffe9c170e6cd)), closes [#4686](https://github.com/vuetifyjs/vuetify/issues/4686)
* **v-item:** add value prop ([fba1631](https://github.com/vuetifyjs/vuetify/commit/fba163111cf94d53c24f357234f677b12acb9cc3))
* **v-list-tile-action:** add support for v-html ([f3b4192](https://github.com/vuetifyjs/vuetify/commit/f3b4192d18e7657be515c65da12f957c84f5b0e3)), closes [#5037](https://github.com/vuetifyjs/vuetify/issues/5037)
* **v-menu:** remove activator height ([2f38cfa](https://github.com/vuetifyjs/vuetify/commit/2f38cfa3a82273be5dafd034e1a132a11d2df037)), closes [#4942](https://github.com/vuetifyjs/vuetify/issues/4942)
* **v-messages:** change assigned key ([6fc95a5](https://github.com/vuetifyjs/vuetify/commit/6fc95a532792f35b3cb9e4ea351a18ba88673187)), closes [#4880](https://github.com/vuetifyjs/vuetify/issues/4880)
* **v-navigation-drawer:** pull in Dependent mixin for click-outside ([d7318a6](https://github.com/vuetifyjs/vuetify/commit/d7318a6764438445b9b3c735d7116b55509eb50a))
* **v-radio:** remove bottom margin ([439bf67](https://github.com/vuetifyjs/vuetify/commit/439bf6792002188cf6ebb4db6697d362c590988d)), closes [#5162](https://github.com/vuetifyjs/vuetify/issues/5162)
* **v-radio-group:** change radio margin selector ([a7d9d6e](https://github.com/vuetifyjs/vuetify/commit/a7d9d6e766588aba7f0e08e8db0bc07e0f1f5b44)), closes [#5255](https://github.com/vuetifyjs/vuetify/issues/5255)
* **v-select:** add genProgress ([646a3ee](https://github.com/vuetifyjs/vuetify/commit/646a3eeb4421a8db5ae5d7049379927a9fa2d813)), closes [#4805](https://github.com/vuetifyjs/vuetify/issues/4805) [#5279](https://github.com/vuetifyjs/vuetify/issues/5279)
* **v-select:** remove change event for external changes ([545b20c](https://github.com/vuetifyjs/vuetify/commit/545b20ca827eeeb2f2ee7a0a2c4f3f0e10578e24)), closes [#5006](https://github.com/vuetifyjs/vuetify/issues/5006)
* **v-slider:** remove duplicate change event ([86eca2b](https://github.com/vuetifyjs/vuetify/commit/86eca2baa42788c2e5a74652048dc9591c701cfc)), closes [#4996](https://github.com/vuetifyjs/vuetify/issues/4996)
* **v-stepper-content:** visibility desync ([#4859](https://github.com/vuetifyjs/vuetify/issues/4859)) ([67b3c97](https://github.com/vuetifyjs/vuetify/commit/67b3c976bb07aaf4f63a525681d85f27e6515560))
* **v-tab:** fix mixin duplication bug ([d19c3b2](https://github.com/vuetifyjs/vuetify/commit/d19c3b2c65c4777e660fe30a9831d459eb7176a4))
* **v-tab-item:** add backwards compat for id ([64b1fbb](https://github.com/vuetifyjs/vuetify/commit/64b1fbb45e7d4c9bd5877046ca9e4f369fe0d801))
* **v-tabs:** cleanup and improve feel ([648c02d](https://github.com/vuetifyjs/vuetify/commit/648c02dc71e56212b2b8c46b2b701d9045d17c90))
* **v-tabs:** fix broken tests ([37502c7](https://github.com/vuetifyjs/vuetify/commit/37502c79a2d67ffb8170c494850603598587db3f))
* **v-tabs:** watch change of items ([bc6bd60](https://github.com/vuetifyjs/vuetify/commit/bc6bd60acc057899f9396e2ee00004ebafed3a92)), closes [#52222](https://github.com/vuetifyjs/vuetify/issues/52222)
* **v-text-field:** change mouseup focus to conditional ([5b1f3b4](https://github.com/vuetifyjs/vuetify/commit/5b1f3b41f41c88a47cee200fb56e14f57e1f1455)), closes [#5018](https://github.com/vuetifyjs/vuetify/issues/5018)
* **v-text-field/v-select:** remove explicit height ([#4902](https://github.com/vuetifyjs/vuetify/issues/4902)) ([65edb1c](https://github.com/vuetifyjs/vuetify/commit/65edb1c96883c3beeb9bde594e4386c9b60d4a2b)), closes [#4456](https://github.com/vuetifyjs/vuetify/issues/4456)
* **v-toolbar:** correct automatic height on landscape views ([f18b54e](https://github.com/vuetifyjs/vuetify/commit/f18b54ea5d8723f921e77ae4b08794770ef6f7fb)), closes [#3990](https://github.com/vuetifyjs/vuetify/issues/3990)
* **v-treeview:** propagate checkbox color ([48b1ec7](https://github.com/vuetifyjs/vuetify/commit/48b1ec7fe2be90531b79cf8f00769ab700047320))
* **VBtn:** don't change text color on outlined buttons ([ee3f6df](https://github.com/vuetifyjs/vuetify/commit/ee3f6dff5c8a8369c332bae475f26a00199b8950))
* **VDataTable:** ensure expand slot is always an array ([0398263](https://github.com/vuetifyjs/vuetify/commit/03982635304159aa4238878776d56b43a385f620)), closes [#4948](https://github.com/vuetifyjs/vuetify/issues/4948)
* **VDatePicker:** height of year selector ([977fd7d](https://github.com/vuetifyjs/vuetify/commit/977fd7d29f17d490b00241dfe3a8dd6b2688701f))
* **VEditDialog:** apply theme classes to content ([#5152](https://github.com/vuetifyjs/vuetify/issues/5152)) ([cf94d46](https://github.com/vuetifyjs/vuetify/commit/cf94d461db8ee1a2febe88c3a20b0461d9da412c)), closes [#5127](https://github.com/vuetifyjs/vuetify/issues/5127)
* **VEditDialog:** display action buttons in 1 line ([e0d39fe](https://github.com/vuetifyjs/vuetify/commit/e0d39feaabd4063e2ea9d0205119c28959684748)), closes [#4450](https://github.com/vuetifyjs/vuetify/issues/4450)
* **VImg:** allow transition to be disabled ([b01094d](https://github.com/vuetifyjs/vuetify/commit/b01094d89b3df224c03f7bf786377bafd1110519))
* **VImg:** fall back to image.src in IE and safari ([50e1043](https://github.com/vuetifyjs/vuetify/commit/50e10433f68e85dbc890fa727933cd9ff6a7361b))
* **VImg:** update src anyway if decode fails ([4341ce0](https://github.com/vuetifyjs/vuetify/commit/4341ce0292e4867804c5813d2ae7694abbe08d3d)), closes [#4969](https://github.com/vuetifyjs/vuetify/issues/4969)
* **VLinearProgress:** invalid class applied when using css color ([1f56645](https://github.com/vuetifyjs/vuetify/commit/1f566457b1494e6dcdbd4c8105fb1a718d6c9cfd))
* add .css to sideEffects ([5b8c19f](https://github.com/vuetifyjs/vuetify/commit/5b8c19fc5a5f89c11008b9643999e66735f9eb4b))
* small css issue with treeview labels ([550cbfa](https://github.com/vuetifyjs/vuetify/commit/550cbfa865c9dc7c6b855620bca11cfeb7c28742))
* v-treeview infinite loop bug ([6d0f035](https://github.com/vuetifyjs/vuetify/commit/6d0f03549a3c110214a719041ca335a5597b36c9))
* v-treeview margins ([04d7a50](https://github.com/vuetifyjs/vuetify/commit/04d7a50f1650226c94b8053e410026ac17df96a1))
* **v-window:** add mandatory true default ([e774214](https://github.com/vuetifyjs/vuetify/commit/e774214c883ea978f10a052af040504e40d3afc6))
* **v-window:** remove entry animation ([db316cd](https://github.com/vuetifyjs/vuetify/commit/db316cd3b9abe462453905b3fa2e0662f8d48202))
* **VBreadcrumbs:** add Themeable classes ([37858db](https://github.com/vuetifyjs/vuetify/commit/37858db67b4aaecd600a3823f5220a4a9991e8b8)), closes [#4986](https://github.com/vuetifyjs/vuetify/issues/4986)
* **VInput:** themeable label, icon, counter, messages ([#4457](https://github.com/vuetifyjs/vuetify/issues/4457)) ([abf7007](https://github.com/vuetifyjs/vuetify/commit/abf7007ac8c731044a6e7255dc522f34fa9f4dd1)), closes [#4453](https://github.com/vuetifyjs/vuetify/issues/4453)
* **VMenu:** inherit light/dark from v-app ([9bf02af](https://github.com/vuetifyjs/vuetify/commit/9bf02afc57fe639151c1250e28ef0c5dc1492cc8))
* **VMenu:** make detached provide reactive ([acf90be](https://github.com/vuetifyjs/vuetify/commit/acf90be4de5c68bccd4066aa8ab8d32e80215b49)), closes [#5010](https://github.com/vuetifyjs/vuetify/issues/5010)
* **VMenu, VDialog:** allow content theme to be overridden ([6e242cb](https://github.com/vuetifyjs/vuetify/commit/6e242cb37c02a83f9cb9c862ad40a595e612d027))
* **VNavigationDrawer:** unbind old side when applicationProperty changes ([3561a70](https://github.com/vuetifyjs/vuetify/commit/3561a7053da009586da9e339b4bd74b29e2526dc)), closes [#4617](https://github.com/vuetifyjs/vuetify/issues/4617)
* **VPagination:** fix v-pagination misbehavior ([#3636](https://github.com/vuetifyjs/vuetify/issues/3636)) ([#4651](https://github.com/vuetifyjs/vuetify/issues/4651)) ([8d1724a](https://github.com/vuetifyjs/vuetify/commit/8d1724a803e15723bf951d873be250580ffd0a54))
* **VRadioGroup:** emit the new value when reset ([25ae6b3](https://github.com/vuetifyjs/vuetify/commit/25ae6b30039c06daf54f4d4aacb337fde90e9f79)), closes [#4752](https://github.com/vuetifyjs/vuetify/issues/4752)
* **VSelect:** allow null values to be selected ([#4649](https://github.com/vuetifyjs/vuetify/issues/4649)) ([43a18b6](https://github.com/vuetifyjs/vuetify/commit/43a18b613f5b2716d8356069093eb8be917ca9c1)), closes [#4431](https://github.com/vuetifyjs/vuetify/issues/4431)
* **VSelect:** don't show menu if readonly ([f37e961](https://github.com/vuetifyjs/vuetify/commit/f37e961f0245ceed5a3ab31a996b2cd292e222fe)), closes [#4815](https://github.com/vuetifyjs/vuetify/issues/4815)
* **VSelect:** remove 'auto' prop definition, update deprecation notice ([5f01466](https://github.com/vuetifyjs/vuetify/commit/5f0146656ea9c2c2d50f6f58958b2ae18a004051)), closes [#4881](https://github.com/vuetifyjs/vuetify/issues/4881)
* **VSelect:** show falsy items in the list ([5172f68](https://github.com/vuetifyjs/vuetify/commit/5172f686cb635464fe7974febe3cf41612a17ed1)), closes [#4431](https://github.com/vuetifyjs/vuetify/issues/4431) [#4649](https://github.com/vuetifyjs/vuetify/issues/4649)
* **VSelect:** show pointer cursor on the correct element ([2e96f22](https://github.com/vuetifyjs/vuetify/commit/2e96f2249dc889d7d1f72262a6d878a9d06f43fe)), closes [#4851](https://github.com/vuetifyjs/vuetify/issues/4851)
* **VStepperStep:** use colorable mixin ([5032c8a](https://github.com/vuetifyjs/vuetify/commit/5032c8a9af577299428080cc1cc5022541b33b80)), closes [#5183](https://github.com/vuetifyjs/vuetify/issues/5183)
* added themeable mixin, organized imports ([3f2be2a](https://github.com/vuetifyjs/vuetify/commit/3f2be2a1b877fb564d89423bd3d275a0ad893a15))
* always apply margin-top to v-input--slider ([#4899](https://github.com/vuetifyjs/vuetify/issues/4899)) ([2c0a3a9](https://github.com/vuetifyjs/vuetify/commit/2c0a3a92fc74bc267310cfe10409128b3df4761e))
* icon button's height in toolbar items ([#4907](https://github.com/vuetifyjs/vuetify/issues/4907)) ([ca6a44e](https://github.com/vuetifyjs/vuetify/commit/ca6a44e8497e23717f4304436afd658373ab85a4))
* updated tests ([f4a7722](https://github.com/vuetifyjs/vuetify/commit/f4a772279be3396d3fcb7b222400516b738bb2c3))
* **VMenu, VDialog:** inherit content theme from v-app instead of parent ([9f61a81](https://github.com/vuetifyjs/vuetify/commit/9f61a817a0df6d1ffe6bb060c16a737529bcfade))
* **VMenu, VDialog:** show multiple elements in the default slot ([f90d631](https://github.com/vuetifyjs/vuetify/commit/f90d6312e987519fe1ae2e59269bebe8cf91078a))
* **VPagination:** add themeable ([9461ba2](https://github.com/vuetifyjs/vuetify/commit/9461ba2b495f5730f73e1c43365520faa15c6b94))
* **VResponsive:** prevent content overflow ([a7ffbfe](https://github.com/vuetifyjs/vuetify/commit/a7ffbfeeafdbdef20272fdd8247b44f617eb6be5))
* **VTabs:** don't provide own theme ([93ee3c7](https://github.com/vuetifyjs/vuetify/commit/93ee3c76ec341858b6afb860347b5b392af10401))
* **VTabs:** make theme reactive, provide to icons ([7d55184](https://github.com/vuetifyjs/vuetify/commit/7d5518488452170c18ce45f492993e1b59f6f00d))
* **VTabs:** pass parent theme to items ([d3def0b](https://github.com/vuetifyjs/vuetify/commit/d3def0bc6a09cfdb924c2439f6a42322543f8de1))
* **VTabs:** pass parent theme to items ([08b67a7](https://github.com/vuetifyjs/vuetify/commit/08b67a7a1b857e0705255d447b557c1200c19b7f))
* **VTextField:** allow input to shrink below the base width ([60cf038](https://github.com/vuetifyjs/vuetify/commit/60cf038292b69286788949aa1f316b63ce0f863a)), closes [#4768](https://github.com/vuetifyjs/vuetify/issues/4768)
* **VTextField:** preserve VNode.data.model ([e34e48b](https://github.com/vuetifyjs/vuetify/commit/e34e48bb0d22c7d4150c02725789da74d748522b)), closes [#4460](https://github.com/vuetifyjs/vuetify/issues/4460)
* [#4825](https://github.com/vuetifyjs/vuetify/issues/4825) - icon alignment in fab broken ([#4833](https://github.com/vuetifyjs/vuetify/issues/4833)) ([3c5604d](https://github.com/vuetifyjs/vuetify/commit/3c5604d4c236c1cec8bcd1d27dd26c414a7424d9))
* [#4826](https://github.com/vuetifyjs/vuetify/issues/4826) - Data Table Progress bar overlaps table header border ([#4835](https://github.com/vuetifyjs/vuetify/issues/4835)) ([c483398](https://github.com/vuetifyjs/vuetify/commit/c483398ccc804883a3f13bfd15dffd2840874341))
* **VDataTable:** duplicate key ([#4294](https://github.com/vuetifyjs/vuetify/issues/4294)) ([3970ba6](https://github.com/vuetifyjs/vuetify/commit/3970ba609f474c7a4675c978b328636fab9f8d39)), closes [#3841](https://github.com/vuetifyjs/vuetify/issues/3841)
* **VNavigationDrawer:** transition width and transform ([c83f935](https://github.com/vuetifyjs/vuetify/commit/c83f935b0f4561af7571cf4ace890353c101ef84))
* **VRadio:** set correct name and value on input element ([15012f8](https://github.com/vuetifyjs/vuetify/commit/15012f85f157823fea2953279299543f08b1218c)), closes [#4719](https://github.com/vuetifyjs/vuetify/issues/4719)
* **VSelect:** don't show underline in checkboxes when attached ([4bb8bfb](https://github.com/vuetifyjs/vuetify/commit/4bb8bfb345fddb8b1da04ddbef3747ba92d316e6)), closes [#4754](https://github.com/vuetifyjs/vuetify/issues/4754)
* **VSlider:** use a text input internally ([33d1652](https://github.com/vuetifyjs/vuetify/commit/33d16523254db0cf144444ec56e89ceddf7f6403)), closes [#4464](https://github.com/vuetifyjs/vuetify/issues/4464)
* **VTextField:** blur internal input when blur() is called ([1b6463a](https://github.com/vuetifyjs/vuetify/commit/1b6463acd504ab7a4c23e7e2e690fb6f79683bdb)), closes [#3009](https://github.com/vuetifyjs/vuetify/issues/3009)
* **VTextField:** prevent pointer events on the label ([74ff691](https://github.com/vuetifyjs/vuetify/commit/74ff6916c85b1ab43cc18855557066e2c101d24e))
* don't change month autmatically when deselecting date ([09eeb6c](https://github.com/vuetifyjs/vuetify/commit/09eeb6cee7a74910452a4721534efb8d71c42a63))
* **VTextField:** show dashed underline when disabled ([2dec42a](https://github.com/vuetifyjs/vuetify/commit/2dec42ac474071c7e7cf7da75f9512c77e00a2ba)), closes [#4615](https://github.com/vuetifyjs/vuetify/issues/4615)
* added default value to items prop ([d5f67ab](https://github.com/vuetifyjs/vuetify/commit/d5f67ab85c0e0adc1699b01fca0e1deaed78b46b))
* added key ([c2d2dfc](https://github.com/vuetifyjs/vuetify/commit/c2d2dfcda977f89ac2611a885d94370589e95a5f))
* don't reduce animation keyframes ([#4564](https://github.com/vuetifyjs/vuetify/issues/4564)) ([0c5eb5b](https://github.com/vuetifyjs/vuetify/commit/0c5eb5baafe5f075d4f2a6ba1442bbe20a6372ba))
* thin lines are rendered inconsistently ([#4615](https://github.com/vuetifyjs/vuetify/issues/4615)) ([7cd89ea](https://github.com/vuetifyjs/vuetify/commit/7cd89ea7f7acd823aa5c9ee0cca0217e29c077ed)), closes [#3847](https://github.com/vuetifyjs/vuetify/issues/3847) [#3588](https://github.com/vuetifyjs/vuetify/issues/3588) [#3090](https://github.com/vuetifyjs/vuetify/issues/3090)
* **VSelect:** blur called after input is destroyed ([33785e6](https://github.com/vuetifyjs/vuetify/commit/33785e6758258f743b075af4d47a57eeb5824834))
* **VSelect:** don't register click-outside if not focused ([b730f14](https://github.com/vuetifyjs/vuetify/commit/b730f149e215e88d47b2793e13fbf3f31fa4c5ce))
* **webpack:** fix stylus usage in dev ([166b489](https://github.com/vuetifyjs/vuetify/commit/166b4896fa9bfc277a411705d9b58930229aee9c)), closes [/github.com/vuejs/vue-loader/issues/1273#issuecomment-385492783](https://github.com/vuetifyjs//github.com/vuejs/vue-loader/issues/1273/issues/issuecomment-385492783)
* removed unused variables ([1749e99](https://github.com/vuetifyjs/vuetify/commit/1749e999c1af74567ff137e63989f7946f5a3c4a))
* replace no-unused-variable with noUnusedLocals, enable noImplicitReturns ([af7e505](https://github.com/vuetifyjs/vuetify/commit/af7e505f38500ea8b56896cd8bb1efdfd94d40f9))
* **inputs:** fix cursor styles ([f875c9d](https://github.com/vuetifyjs/vuetify/commit/f875c9d27e6f8686a0d31358622e2232abce28af)), closes [#4404](https://github.com/vuetifyjs/vuetify/issues/4404)
* **v-autocomplete:** add cursor style ([bb5859d](https://github.com/vuetifyjs/vuetify/commit/bb5859d2e1f4d24dd4f12d4631ce980559de45b4)), closes [#4404](https://github.com/vuetifyjs/vuetify/issues/4404)
* **v-autocomplete:** change setSearch logic ([c2f861e](https://github.com/vuetifyjs/vuetify/commit/c2f861efbb5bd3b36d0e164031426b2d76fdde0c)), closes [#4403](https://github.com/vuetifyjs/vuetify/issues/4403)
* **v-autocomplete:** fix onBlur functionality ([d8cb90a](https://github.com/vuetifyjs/vuetify/commit/d8cb90ad05fd0d1444a68fc1478b61ed9c28be6f)), closes [#4407](https://github.com/vuetifyjs/vuetify/issues/4407)
* **v-combobox:** fix updateCombobox logic ([750821b](https://github.com/vuetifyjs/vuetify/commit/750821b58c5d74d76785e2447678f03cd8d2b279)), closes [#4448](https://github.com/vuetifyjs/vuetify/issues/4448)
* **v-divider:** fix vertical prop in flex ([3d7fc2a](https://github.com/vuetifyjs/vuetify/commit/3d7fc2acdf3af3d205499d0c1796e74651608ab2))
* **v-icon:** fix link specificity ([b7f1efc](https://github.com/vuetifyjs/vuetify/commit/b7f1efcd42a7a42d7dcdfa4078352e64edbd3c30))
* **v-overflow-btn:** placeholder text ([cc5a9b8](https://github.com/vuetifyjs/vuetify/commit/cc5a9b87aedb949c4a20923a5356d448fd803847))
* **v-select-list:** normalize hasItem check ([0b550c5](https://github.com/vuetifyjs/vuetify/commit/0b550c5801757878c641467be2722ef7cb83746b))
* **v-switch:** add part key ([6885681](https://github.com/vuetifyjs/vuetify/commit/6885681e9dd3bb36d548afaba5d925f0978fb0b4))
* **v-tabs:** update active comparison ([#4406](https://github.com/vuetifyjs/vuetify/issues/4406)) ([33ab338](https://github.com/vuetifyjs/vuetify/commit/33ab3380d6a948dc3ad54de0e4defefe0f9b283a)), closes [#4397](https://github.com/vuetifyjs/vuetify/issues/4397)
* **VChip:** cursor on close icon ([9a9b718](https://github.com/vuetifyjs/vuetify/commit/9a9b71872477dd3372067a61494d841d98ffad10)), closes [#4517](https://github.com/vuetifyjs/vuetify/issues/4517)
* **VChip:** styles for disabled chips ([#4531](https://github.com/vuetifyjs/vuetify/issues/4531)) ([fa0ebff](https://github.com/vuetifyjs/vuetify/commit/fa0ebff97f8ddf2774323fdda904f2e3a1827092)), closes [#4442](https://github.com/vuetifyjs/vuetify/issues/4442)
* **VDataTable:** added missing v- prefix ([96d262d](https://github.com/vuetifyjs/vuetify/commit/96d262d2d85827ab2d3f3645d02cef3864a29696)), closes [#4458](https://github.com/vuetifyjs/vuetify/issues/4458)
* **VDialog:** use overlay with persistent and hide-overlay props ([#4529](https://github.com/vuetifyjs/vuetify/issues/4529)) ([b7b14f1](https://github.com/vuetifyjs/vuetify/commit/b7b14f1293ead25b9ec5eebeed5e0bf96c8fb593)), closes [#4466](https://github.com/vuetifyjs/vuetify/issues/4466)
* **VDialog,VMenu:** cursor on activator ([447447e](https://github.com/vuetifyjs/vuetify/commit/447447ee48968d8df68aced42ad4230ba1a2fc8d)), closes [#3996](https://github.com/vuetifyjs/vuetify/issues/3996)
* **VProgressCircular:** add vertical alignment ([#4339](https://github.com/vuetifyjs/vuetify/issues/4339)) ([a81f293](https://github.com/vuetifyjs/vuetify/commit/a81f293810dc06298414ff865fd486661c73d6d2)), closes [#4285](https://github.com/vuetifyjs/vuetify/issues/4285)
* **VRadio:** don't override negative tabindex ([d119455](https://github.com/vuetifyjs/vuetify/commit/d11945584cb1c9181032230c5b2bb20016ca4c37)), closes [#4490](https://github.com/vuetifyjs/vuetify/issues/4490)
* **VSelect:** don't generate append slot if append-icon is empty ([149bed7](https://github.com/vuetifyjs/vuetify/commit/149bed7555e2c489ecc275a45efa73298a0d11c2)), closes [#4477](https://github.com/vuetifyjs/vuetify/issues/4477)
* **VSelect:** override v-text-field's blur method ([#4441](https://github.com/vuetifyjs/vuetify/issues/4441)) ([c047a21](https://github.com/vuetifyjs/vuetify/commit/c047a21536fdeffe6481ce18b00c12183539963b))
* **VSelect:** pass attach prop to menu when not true ([77d25c7](https://github.com/vuetifyjs/vuetify/commit/77d25c7b2489646745aa16d6c7cb2b2a0e85cd5d))
* **VSelect:** prevent emitting change again on blur ([#4539](https://github.com/vuetifyjs/vuetify/issues/4539)) ([0f4f649](https://github.com/vuetifyjs/vuetify/commit/0f4f64974d1c5a4e0770cce6e714b051402fe0dd)), closes [#4481](https://github.com/vuetifyjs/vuetify/issues/4481)
* **VTabs:** tab width in IE11 ([#4526](https://github.com/vuetifyjs/vuetify/issues/4526)) ([ac49887](https://github.com/vuetifyjs/vuetify/commit/ac49887d7c8dcd17f3370a87fad20f1c9d163128)), closes [#4489](https://github.com/vuetifyjs/vuetify/issues/4489)
* **VTextField:** border radius for solo field ([d6bdc94](https://github.com/vuetifyjs/vuetify/commit/d6bdc94679fdc2d456dd914215ba25ce58600761)), closes [#4463](https://github.com/vuetifyjs/vuetify/issues/4463)
* **VTextField:** counter with v-model.number ([#4524](https://github.com/vuetifyjs/vuetify/issues/4524)) ([291e8bd](https://github.com/vuetifyjs/vuetify/commit/291e8bdefb0091894f5d3a02316719612082e948)), closes [#4475](https://github.com/vuetifyjs/vuetify/issues/4475)
* **VTextField:** only call rules on blur with validateOnBlur set ([f5f7667](https://github.com/vuetifyjs/vuetify/commit/f5f76678532712f802df384678c77f92f36444c5)), closes [#4494](https://github.com/vuetifyjs/vuetify/issues/4494)
* prevent double emit from wrapping components ([6e8b6b7](https://github.com/vuetifyjs/vuetify/commit/6e8b6b76bf65c1d5aa55140f4222bf4849d9b4f0)), closes [vuejs/vue#8436](https://github.com/vuejs/vue/issues/8436)
* prevent selection controls' labels from growing ([#4430](https://github.com/vuetifyjs/vuetify/issues/4430)) ([20af23c](https://github.com/vuetifyjs/vuetify/commit/20af23cb46a454421d3503c88c4089d80bc2d5cc))
* typo in transition name ([a5e302e](https://github.com/vuetifyjs/vuetify/commit/a5e302ee241e9ddb3a023678f9fd425d5bb845f8))
* v-btn classes cleanup ([#4371](https://github.com/vuetifyjs/vuetify/issues/4371)) ([da33df0](https://github.com/vuetifyjs/vuetify/commit/da33df0fcf36f7eda2eaf9dbecdc3f5bcae6c0ff))
* v-tabs should now update v-model if swiping on v-tab ([#4515](https://github.com/vuetifyjs/vuetify/issues/4515)) ([a7a65a1](https://github.com/vuetifyjs/vuetify/commit/a7a65a1fc27e39da5920353a7d0eae6a96af5910)), closes [#4402](https://github.com/vuetifyjs/vuetify/issues/4402)
* **VTextField:** prefix/suffix cursor ([#4525](https://github.com/vuetifyjs/vuetify/issues/4525)) ([6a34c5d](https://github.com/vuetifyjs/vuetify/commit/6a34c5dd32af1ce3ded53ee7d284954540943e56)), closes [#4478](https://github.com/vuetifyjs/vuetify/issues/4478)
* various issues with overflow-btn ([4dfa633](https://github.com/vuetifyjs/vuetify/commit/4dfa633fd525747211ce7baa1af6ebaaa35f3fed))
* **RTL:** next/prev icons and transitions in picker, pagination, carousel, iterable ([#4328](https://github.com/vuetifyjs/vuetify/issues/4328)) ([4ca0f0f](https://github.com/vuetifyjs/vuetify/commit/4ca0f0ffc344467190e631457652cecd7bee6332)), closes [#4327](https://github.com/vuetifyjs/vuetify/issues/4327)
* **selection-controls:** add cursor styles ([f15f851](https://github.com/vuetifyjs/vuetify/commit/f15f85174668370b49adb488544cd8cd330ac829))
* **selection-controls:** label height and IE11 layout issues ([#4323](https://github.com/vuetifyjs/vuetify/issues/4323)) ([eb8b710](https://github.com/vuetifyjs/vuetify/commit/eb8b7106ce07aaeffc4088f495c5a2016afc0ef9)), closes [#4314](https://github.com/vuetifyjs/vuetify/issues/4314)
* **translatable:** removed normalizedHeight ([#4301](https://github.com/vuetifyjs/vuetify/issues/4301)) ([3c9a7a1](https://github.com/vuetifyjs/vuetify/commit/3c9a7a160d946c0824a84bba5d010a3c16d9ad5e))
* **v-autocomplete:** fix single select styles ([345975d](https://github.com/vuetifyjs/vuetify/commit/345975d9255eb2e5f9931598af7991459a6a41fc))
* **v-autocomplete:** remove onEnterKey call ([3f80d8e](https://github.com/vuetifyjs/vuetify/commit/3f80d8eb4309f63d6967ecd3b1d81d3c37470d80))
* **v-autocomplete:** show menu when items update ([d4732ec](https://github.com/vuetifyjs/vuetify/commit/d4732ec0b8b5d80578c4c6d8ce0cc4bf3447a307))
* **v-btn:** increase specificity of transition ([e28325e](https://github.com/vuetifyjs/vuetify/commit/e28325eb789a16a5dc40d23dc668817030aa0ab0))
* **v-card-actions:** remove style ([1144530](https://github.com/vuetifyjs/vuetify/commit/114453002a15cbfca8620f0ac3e09299382140ec)), closes [#4215](https://github.com/vuetifyjs/vuetify/issues/4215)
* **v-data-table:** change css selector ([075e426](https://github.com/vuetifyjs/vuetify/commit/075e426a940c85e23c5093dff0afd40343e9b4cd)), closes [#4350](https://github.com/vuetifyjs/vuetify/issues/4350)
* **v-icon:** fix vertical styling ([52a5f07](https://github.com/vuetifyjs/vuetify/commit/52a5f077f2bbdcf7d7c850376f54a8057c11e269))
* **v-input:** remove ff styles ([9642a13](https://github.com/vuetifyjs/vuetify/commit/9642a13985aeb5f167857f50e9187d209b926cd3)), closes [#4379](https://github.com/vuetifyjs/vuetify/issues/4379)
* **v-radio:** fix readonly styles ([e3f1601](https://github.com/vuetifyjs/vuetify/commit/e3f16015adf5ab1bc453447c0927394a0aa90b8b)), closes [#4349](https://github.com/vuetifyjs/vuetify/issues/4349)
* **v-select:** destructure object properties ([2934435](https://github.com/vuetifyjs/vuetify/commit/2934435768560fbb33c63fddbbfb3fe211b67f71)), closes [#4359](https://github.com/vuetifyjs/vuetify/issues/4359)
* **v-select:** fix item wrapping ([b543e3a](https://github.com/vuetifyjs/vuetify/commit/b543e3a2b74c83fd561831646a937c9dabb7b9c8)), closes [#4275](https://github.com/vuetifyjs/vuetify/issues/4275)
* **v-select:** fix menu alignment ([667d3f0](https://github.com/vuetifyjs/vuetify/commit/667d3f07419df23dcdd3871f11b45fee558bc65d))
* **v-select:** revert b543e3a ([78c0fe0](https://github.com/vuetifyjs/vuetify/commit/78c0fe0bb192a384cf541795b39bddf3f2c96c7e)), closes [#4275](https://github.com/vuetifyjs/vuetify/issues/4275)
* **v-select-list:** remove disabled ([5162c3d](https://github.com/vuetifyjs/vuetify/commit/5162c3d1047f1c2989885311a81affa25ef26bac))
* **v-tabs:** improve model comparison ([158424f](https://github.com/vuetifyjs/vuetify/commit/158424fc546c07d11fa732f60bd92c9a99e20817)), closes [#3641](https://github.com/vuetifyjs/vuetify/issues/3641)
* **v-text-field:** remove enclosed margin ([fa3842d](https://github.com/vuetifyjs/vuetify/commit/fa3842de724c8df90c83d7ff8209809bbab1feb9))
* **v-toolbar:** add back missing styles ([3c29d75](https://github.com/vuetifyjs/vuetify/commit/3c29d75f8c565a86fc2cc6d122a348ff639230d4)), closes [#4331](https://github.com/vuetifyjs/vuetify/issues/4331)
* **v-toolbar:** fix alignment with tooltip and menu ([48dad2d](https://github.com/vuetifyjs/vuetify/commit/48dad2d133df2ffa10e43066d055635424d9c688))
* **v-toolbar:** fix toolbar list alignment ([#4343](https://github.com/vuetifyjs/vuetify/issues/4343)) ([05c4d95](https://github.com/vuetifyjs/vuetify/commit/05c4d95fd842cedc301f025a83a424aef08eafbe))
* **v-window:** fix example ([88383ae](https://github.com/vuetifyjs/vuetify/commit/88383ae5d51d7dd0631a64832f3a83d989e42b49))
* **VCard, converToUnit:** set proper styles with falsy height prop ([#4348](https://github.com/vuetifyjs/vuetify/issues/4348)) ([88e0ead](https://github.com/vuetifyjs/vuetify/commit/88e0ead6cc80a7921629dffea975268b08cf7728)), closes [#4344](https://github.com/vuetifyjs/vuetify/issues/4344)
* **VF-34:** pass query string through language redirects ([c40d498](https://github.com/vuetifyjs/vuetify/commit/c40d49878f1a37849704ad004dbc862756d4c428))
* **VInput:** remove red outline in FF for invalid fields ([af69aea](https://github.com/vuetifyjs/vuetify/commit/af69aea27745296c089610e07f874851086bd996))
* **VPicker:** added picker body z-index ([aa15e0d](https://github.com/vuetifyjs/vuetify/commit/aa15e0dbcb91e615f92d55353efe7544f6d9aa2d)), closes [#4391](https://github.com/vuetifyjs/vuetify/issues/4391)
* **VRadio:** inject disabled/readonly from VRadioGroup ([#4388](https://github.com/vuetifyjs/vuetify/issues/4388)) ([5385038](https://github.com/vuetifyjs/vuetify/commit/538503838840797608dc7ae834510c294490433b)), closes [#4349](https://github.com/vuetifyjs/vuetify/issues/4349)
* **VRadioGroup:** fixed last fix, ripple, user-select, label padding ([5dfc927](https://github.com/vuetifyjs/vuetify/commit/5dfc92792ffcc428531b55dc70aad09a966634c1))
* **VRadioGroup:** removed pointer cursor from main label ([33a72be](https://github.com/vuetifyjs/vuetify/commit/33a72be78a318bb5ae683f72de18c7800ef04cde))
* **vtextfield:** check input change before mask logic ([#6758](https://github.com/vuetifyjs/vuetify/issues/6758)) ([9b354fd](https://github.com/vuetifyjs/vuetify/commit/9b354fd9aa9c5a15ec9b23c80dad677bb6430820)), closes [#4290](https://github.com/vuetifyjs/vuetify/issues/4290) [#5223](https://github.com/vuetifyjs/vuetify/issues/5223)
* **Vuetify:** adjust install pattern for proper treeshaking ([51d5aaf](https://github.com/vuetifyjs/vuetify/commit/51d5aaf6332bd04dd67e545c1dcc74fa4a28a8e4))
* fixed a bug where icons inside of a toolbar had improper styles - ([ee19f03](https://github.com/vuetifyjs/vuetify/commit/ee19f03d932cd4e5d5751824d0baa06abfeb962a)), closes [#2093](https://github.com/vuetifyjs/vuetify/issues/2093) [#2093](https://github.com/vuetifyjs/vuetify/issues/2093)
* Fixed select blur in Edge ([#2162](https://github.com/vuetifyjs/vuetify/issues/2162)) ([2d32d3c](https://github.com/vuetifyjs/vuetify/commit/2d32d3c8e5464ebabf18a50da0546b84ee9191e4)), closes [#2152](https://github.com/vuetifyjs/vuetify/issues/2152)
* Fixed select blur in Edge ([#2162](https://github.com/vuetifyjs/vuetify/issues/2162)) ([5c05519](https://github.com/vuetifyjs/vuetify/commit/5c05519a8360966d24193d45f32db62f0d7bf2a7)), closes [#2152](https://github.com/vuetifyjs/vuetify/issues/2152)
* Fixed/added logic to better handle different situations ([5eb1743](https://github.com/vuetifyjs/vuetify/commit/5eb17434cfb58957e96c5d79ee13a45efe5012e6)), closes [#2067](https://github.com/vuetifyjs/vuetify/issues/2067)
* Hide text field in blurred autocomplete v-selects ([#2172](https://github.com/vuetifyjs/vuetify/issues/2172)) ([382432d](https://github.com/vuetifyjs/vuetify/commit/382432d1e5ec28c9d21e6c9713f84b6c031788f3)), closes [#1691](https://github.com/vuetifyjs/vuetify/issues/1691)
* Hide text field in blurred autocomplete v-selects ([#2172](https://github.com/vuetifyjs/vuetify/issues/2172)) ([08c4da8](https://github.com/vuetifyjs/vuetify/commit/08c4da809ea3ec9019f23888afa24f465136670a)), closes [#1691](https://github.com/vuetifyjs/vuetify/issues/1691)
* icon colors ([92d3c1f](https://github.com/vuetifyjs/vuetify/commit/92d3c1f6282a09ce5d23d0e5265a5423c4848b66)), closes [#2353](https://github.com/vuetifyjs/vuetify/issues/2353)
* ignore clicks if pagination button is disabled ([1c0a64c](https://github.com/vuetifyjs/vuetify/commit/1c0a64c75cc68a9f49a9b047ccad6107ad0e0a6a))
* improve date picker performance ([#2332](https://github.com/vuetifyjs/vuetify/issues/2332)) ([a15e0ca](https://github.com/vuetifyjs/vuetify/commit/a15e0ca19156a02d0f4c4252d262a986050c084d)), closes [#2308](https://github.com/vuetifyjs/vuetify/issues/2308)
* jest toHaveBeenWarned matched ([040f5ed](https://github.com/vuetifyjs/vuetify/commit/040f5edc8180807ae8fbe3c6fae03b543069ba6c))
* make sure this.$attrs is defined ([b3e818d](https://github.com/vuetifyjs/vuetify/commit/b3e818d135c85003d25d0d192095219b3082e0e7))
* nested v-data-table thead ([a37b73f](https://github.com/vuetifyjs/vuetify/commit/a37b73f7000b6d6d2bd9883cdf1f1a63dc13332a))
* prevent race condition when VSelect is destroyed after mount ([bbdd418](https://github.com/vuetifyjs/vuetify/commit/bbdd41809005dde09a328416f511bcf9a85162aa)), closes [#2194](https://github.com/vuetifyjs/vuetify/issues/2194)
* proper installation of Vuetify component for testing ([#2367](https://github.com/vuetifyjs/vuetify/issues/2367)) ([867e5e3](https://github.com/vuetifyjs/vuetify/commit/867e5e352a3b74b2ddde3e7512a95e389d68462a))
* remove duplicated styles in dev ([c53cc0e](https://github.com/vuetifyjs/vuetify/commit/c53cc0e931c5bd74140a049f7f0148edabb353c5))
* Remove stylus [@extend](https://github.com/extend) for stylus block level import ([#1902](https://github.com/vuetifyjs/vuetify/issues/1902)) ([#2209](https://github.com/vuetifyjs/vuetify/issues/2209)) ([77b5af4](https://github.com/vuetifyjs/vuetify/commit/77b5af4ffa7e5665476255e3aee890a0f29ebce9))
* set proper color for textarea placeholder ([#2180](https://github.com/vuetifyjs/vuetify/issues/2180)) ([1c77a5d](https://github.com/vuetifyjs/vuetify/commit/1c77a5da5014fe1058d1e38e7e913739f273c02b)), closes [#2143](https://github.com/vuetifyjs/vuetify/issues/2143)
* set proper color for textarea placeholder ([#2180](https://github.com/vuetifyjs/vuetify/issues/2180)) ([061fd35](https://github.com/vuetifyjs/vuetify/commit/061fd35c8386b31263fddad5887e39bc0f7bfe9f)), closes [#2143](https://github.com/vuetifyjs/vuetify/issues/2143)
* strip non-numbers when checking vue version ([435b83f](https://github.com/vuetifyjs/vuetify/commit/435b83f0ef022c873fa27b5f31438f37a536b2d0))
* table items should not be filtered if the search if empty ([#2590](https://github.com/vuetifyjs/vuetify/issues/2590)) ([acaa6af](https://github.com/vuetifyjs/vuetify/commit/acaa6afb9e8ce2bbc95c16add041bd0fd6f7020f))
* tooltip not initially visiable when v-model is true ([#2595](https://github.com/vuetifyjs/vuetify/issues/2595)) ([f20278d](https://github.com/vuetifyjs/vuetify/commit/f20278dd78086954c51178ba46ffefcecfa57d33)), closes [#2000](https://github.com/vuetifyjs/vuetify/issues/2000)
* trigger swipe events only for proper swiping angle ([#2181](https://github.com/vuetifyjs/vuetify/issues/2181)) ([3875fef](https://github.com/vuetifyjs/vuetify/commit/3875fef24097706f9a8b7bfde3786da5a07177f0)), closes [#2125](https://github.com/vuetifyjs/vuetify/issues/2125)
* trigger swipe events only for proper swiping angle ([#2181](https://github.com/vuetifyjs/vuetify/issues/2181)) ([37fdced](https://github.com/vuetifyjs/vuetify/commit/37fdced596a0b47f86f4fb1fb18b227b3269321d)), closes [#2125](https://github.com/vuetifyjs/vuetify/issues/2125)
* typo in prop definition ([cbfc455](https://github.com/vuetifyjs/vuetify/commit/cbfc455d85eef9a2e7e61fbbdc59af68c55d74e7))
* use accent color for selection controls ([#2207](https://github.com/vuetifyjs/vuetify/issues/2207)) ([e408974](https://github.com/vuetifyjs/vuetify/commit/e4089745bbaff6c2a77479e9ccc037e2c8ac0346)), closes [#2003](https://github.com/vuetifyjs/vuetify/issues/2003)
* use actual folder containing file ([5182ee4](https://github.com/vuetifyjs/vuetify/commit/5182ee4c595d393a57bad2c757ed75bbd7a2793d))
* v-content size desync with SSR ([fb77f5c](https://github.com/vuetifyjs/vuetify/commit/fb77f5ce5425977a98b8e9f9a09ff4ac7752655c))
* v-content size desync with SSR ([10eb8e2](https://github.com/vuetifyjs/vuetify/commit/10eb8e25af3e4df57d2c7d5efc28ba302a21784d))
* **$browser:** Improperly styled nested expansion-panels ([7ebf61d](https://github.com/vuetifyjs/vuetify/commit/7ebf61d5ad11f0ed573d944c2611f0b3daeccc47)), closes [#2141](https://github.com/vuetifyjs/vuetify/issues/2141)
* **v-select:** adjusted selected items functionality ([5b1a408](https://github.com/vuetifyjs/vuetify/commit/5b1a40885ccf2f0abd20d7823223b053dffff257))
* **v-select:** adjusted selected items functionality ([9db604a](https://github.com/vuetifyjs/vuetify/commit/9db604a5f585b5c2b093ec73577274de5e96bc82))
* **v-select:** fixed a bug introduced by [#2183](https://github.com/vuetifyjs/vuetify/issues/2183) ([24f5680](https://github.com/vuetifyjs/vuetify/commit/24f5680f307d8cc66e4b9060543fb39a713b7763)), closes [#2126](https://github.com/vuetifyjs/vuetify/issues/2126) [#2126](https://github.com/vuetifyjs/vuetify/issues/2126)
* **v-select:** fixed menu auto position (again) ([78ce200](https://github.com/vuetifyjs/vuetify/commit/78ce200bd7988db9478ad66c08502f5e33add2e2))
* **v-tabs:** slider not re-positioning ([fc9c5df](https://github.com/vuetifyjs/vuetify/commit/fc9c5df7f4f86baf21aabe7bf560545ae6b4d930)), closes [#684](https://github.com/vuetifyjs/vuetify/issues/684)
* **v-tabs:** slider not re-positioning ([574e0d6](https://github.com/vuetifyjs/vuetify/commit/574e0d634bbe16140fe0659b17643d78cb6e2227)), closes [#684](https://github.com/vuetifyjs/vuetify/issues/684)
* **v-time-picker:** in addition to 18f6aad ([fb9646a](https://github.com/vuetifyjs/vuetify/commit/fb9646a1f7a09b98daf2b26d181c72cff5572266)), closes [#1916](https://github.com/vuetifyjs/vuetify/issues/1916)
* **v-toolbar:** fixed **scroll-off-screen** prop ([9956d9b](https://github.com/vuetifyjs/vuetify/commit/9956d9b34f1e17baf6763519c82af2549820d453))
* **VDialog:** don't create overlay on initially open fullscreen dialogs ([b84cbca](https://github.com/vuetifyjs/vuetify/commit/b84cbca797ff2be03383c58782460c4652a61b61))
* **VDialog:** don't create overlay on initially open fullscreen dialogs ([993bcb3](https://github.com/vuetifyjs/vuetify/commit/993bcb33ee3533e7d10d829a9c68c4603f27bbc8))
* **VNavigationDrawer:** update application when destroyed ([f51e2ab](https://github.com/vuetifyjs/vuetify/commit/f51e2ab4151b8872941c0a3931e0b9ba10b6ae1c))
* **VSelect:** better null check on menu ref ([0b97231](https://github.com/vuetifyjs/vuetify/commit/0b972318554a1951a40ce341dfb598ca489c3e06))
* **VSelect:** show input placeholder ([#4098](https://github.com/vuetifyjs/vuetify/issues/4098)) ([54d1612](https://github.com/vuetifyjs/vuetify/commit/54d1612d8542286916b22345efe5dcbf7644e6e1))
* **VTextField:** apply flat to the correct element when solo ([6257e6d](https://github.com/vuetifyjs/vuetify/commit/6257e6d511409b54b57c12333def09a31b63080d))
* **VTextField:** don't show v-counter if counter is null/undefined ([#4337](https://github.com/vuetifyjs/vuetify/issues/4337)) ([10b1d34](https://github.com/vuetifyjs/vuetify/commit/10b1d3442cbcf922ed05fc92793985e25d6621cd))
* **VTimePicker:** better sizing ([#4905](https://github.com/vuetifyjs/vuetify/issues/4905)) ([3ba2f89](https://github.com/vuetifyjs/vuetify/commit/3ba2f89c8b29620cffedb68331de2a2e0a2904b0)), closes [#3123](https://github.com/vuetifyjs/vuetify/issues/3123)
* **VToolbar:** remove margin from lists ([1ba4a17](https://github.com/vuetifyjs/vuetify/commit/1ba4a17902fd458ba5848bb8c6a1469260326331)), closes [#4111](https://github.com/vuetifyjs/vuetify/issues/4111)
* **vuetify:** fixed a memory leak ([3d9438a](https://github.com/vuetifyjs/vuetify/commit/3d9438a82cac71a593618ede55f35f482895c8bf))
* **VWindow:** select first non-disabled window-item when using touch swipe ([1938ee7](https://github.com/vuetifyjs/vuetify/commit/1938ee790862323ddfd29a2f14c7248a89e77d71)), closes [#5000](https://github.com/vuetifyjs/vuetify/issues/5000)
* Import Touch directive in VTabsItems ([9b6b0fd](https://github.com/vuetifyjs/vuetify/commit/9b6b0fd321c98d4e7001d13099ed3f762253857a)), closes [#2157](https://github.com/vuetifyjs/vuetify/issues/2157)
* textarea border should match chosen color ([79c8900](https://github.com/vuetifyjs/vuetify/commit/79c890080bf6a70986aa682f86d9eb90efdedc9a)), closes [#2140](https://github.com/vuetifyjs/vuetify/issues/2140)


* **framework:** remove deprecated stylus ([#6879](https://github.com/vuetifyjs/vuetify/issues/6879)) ([7d615eb](https://github.com/vuetifyjs/vuetify/commit/7d615eb12edd374c921c0292d92416b346e96cac))
* **kitchen:** remove from build process ([1df6a6f](https://github.com/vuetifyjs/vuetify/commit/1df6a6f4d08ecd1576cfa1abffaf77464ee72437))
* **routable/VItemGroup:** normalize behavior ([#7249](https://github.com/vuetifyjs/vuetify/issues/7249)) ([2bb3ec0](https://github.com/vuetifyjs/vuetify/commit/2bb3ec068154f53c83d8be5fded2a436adb078ca))
* **VApp:** scope component styles ([ec7b2e4](https://github.com/vuetifyjs/vuetify/commit/ec7b2e4dacacd247becf15f3f29f5f9fb3e64ba3))
* **VBottomNav:** update to md2 ([#6741](https://github.com/vuetifyjs/vuetify/issues/6741)) ([897b367](https://github.com/vuetifyjs/vuetify/commit/897b367e4eac5307b46f327277889cf46a4c855e))
* **VBottomSheet:** update for v2 ([#6786](https://github.com/vuetifyjs/vuetify/issues/6786)) ([568216b](https://github.com/vuetifyjs/vuetify/commit/568216b083217a277a4d511a018576b329526dc0))
* **VDataTable:** disable virtual-rows ([8284ef5](https://github.com/vuetifyjs/vuetify/commit/8284ef577e602a871719a747874212d9f3bc77bf))
* **VTextField:** remove browser-autocomplete prop ([68f85d6](https://github.com/vuetifyjs/vuetify/commit/68f85d6194fe006758a3316e3ca3376a758993d7))
* remove avoriaz, update to jest 24 ([#6972](https://github.com/vuetifyjs/vuetify/issues/6972)) ([84fc538](https://github.com/vuetifyjs/vuetify/commit/84fc53861297c0b76119b99ddd0d03e39cb6de14))
* use a single theme mixin ([#6889](https://github.com/vuetifyjs/vuetify/issues/6889)) ([04c4adc](https://github.com/vuetifyjs/vuetify/commit/04c4adcd976bea7b5e20ca399f3a929f6499e571))

## 3.0.0 (2021-07-14)


### ⚠ BREAKING CHANGES

* **styles:** requires sass@1.33.0
* **VMessages:** Rules for all inputs are now escaped. A scoped slot has been added for users who
need to customize the styling of messages.
* **kitchen:** was failing with an Assertion error, signal SIGABRT when building kitchen sometimes
in CI
* **grid:** css specificity reduced on `.layout.reverse`
* **VDataTable:** the virtual-rows prop (from alpha/beta) will no longer work
* all ma-x etc. helpers need to be changed

before: 0 4 8 16 24 48
after:  0 4 8 12 16 20 24 28 32 36 40 44 48

* refactor(VCol): remove redundant col prop

* fix(VCol): apply class when breakpoints specified

* feat: merge legacy-grid back into vuetify

v-layout and v-flex now coexist with the new components

some styles will still change from 1.x as there is some overlap between
the two systems, but the overall upgrade workload should be less

* docs: update classes

* feat: add back start/end spacing helpers for rtl

* feat: revert space-between -> between breaking change

* style: fix lint

* test: update snapshots

* docs: revert space-between -> between breaking change

partially reverts fc21169bc

* chore(ci): build before lint

eslint-plugin-vuetify needs to import from dist

* style: fix lint

* fix(VDataTable): replace text-xs-start

* style: fix lint

* fix(VRow): add flex-grow for IE11
* **validatable:** all form inputs default to white when using the dark prop
* **VApp:** the dark and light prop no longer have an effect on application theme variants
* **VApp:** the v-app component classes have been prepended with v-
* **VChip:** the value prop is now active, @input is now @active.sync
* **VList/Item/Group:** the item scoped slot value of { tile } is now { attrs, on }. is now bound similar
to the v-menu activator slot
* **VTextField:** `v-select` no longer has a default autocomplete of "on"
* **routable/VItemGroup:** activeClass items must now control their active-state colors through classes

* refactor(routable): change tabindex logic

* chore(VChip): remove deprecated style

* refactor(routable): remove arguments from generation method

* refactor(ItemGroups): add support for color over active-class

* refactor: update colors, change how bottom nav derives color

continue to normalize behavior between multiple components
* **routable/VItemGroup:** VBottomNavigation color now applies text color, adds new background color prop,
removed default color from VListGroup

* docs: update examples

* chore: add comment on types for routable

Co-Authored-By: Dmitry Sharshakov <d3dx12.xx@gmail.com>

* refactor: improvements from code review

* refactor(routable): remove unnecessary activeClass designation

* refactor(VBreadcrumbsItem): normalize ripple type

* refactor(VListItem): remove duplicated activeClass designation

* refactor(routable): only explicitly apply proxy/active class if not a router link

* refactor(VTabs): normalize how VTab derives its activeClass

make similar to other implementations

* docs(VListItemGroup): improve example
* **activatable:** all activator slots must be bound with v-slot

* refactor(VMenu): remove genActivator method

* docs(Core/SpecBtn): update slot structure

* refactor(activatable): update getActivator logic

use activatorNode of available

* refactor(VTooltip): update to properly use activatable

* refactor(activatable): change ordering of getActivator conditional

favor event over activatorNode

* refactor(activatable): change logic for activator slot bind error

* test(activatable): fix tests

* fix(activatable/VMenu): properly handle dynamic activators

* chore(VMenu): remove deprecated message

* fix(menuable): add support for disabling open-on-click

* style(menuable): remove explicit type declaration

* chore: remove unused props from tests
* No way to use this function any more

* refactor(test helpers): convert to TS

* chore: remove avoriaz

* chore: update to jest 24

* test(jest): convert jest globals into module

* Update packages/vuetify/src/components/VSlideGroup/__tests__/VSlideGroup.spec.ts

Co-Authored-By: sh7dm <sh7dm@outlook.com>
Co-Authored-By: John Leider <john@vuetifyjs.com>

* Update jest.config.js
* **VCarousel:** The **cycle** prop is no longer implicit, must be defined in order to have screens
switch

* refactor(VCarousel/VWindow): clean-up styles

* fix(VWindow): update default for **show-arrows** prop

* docs(VCarousel): add new **cycle** example

* docs(VCarousel): update example

* docs(VCarousel): update **customTransition** example

* refactor(VCarousel): remove duplicated (essentially) render function

* refactor(VWindow): abstract **show-arrows-on-hover** from `v-carousel`

* feat(VCarousel): add **progress** prop

* refactor(VWindow): reduce control margin

* refactor(VWindow): reduce size of controls

* refactor(VCarousel): **progres-color** is inferred as default from `v-progress-linear`

* feat(VCarousel): add **vertical-delmiiters** prop
* requires dart-sass or an unreleased version of libsass
* **framework:** no more Stylus

* build: remove all stylus processing (loaders)
* **framework:** no availibility to transform stylus

* chore: remove .styl files from .eslintignore and sideEffects

* chore(kitchen): remove stylus and stylus-loader

* docs: replace Stylus custimization guide with Sass one

Co-authored-by: Pedro Vieira <peluprvi@gmail.com>

* build(docs): transpile Sass

* docs: replace node-sass with sass

* refactor(docs): use Sass, not SCSS

* build(framework): use sass everywhere instead of node-sass

* chore: fix warnings

* refactor(VSlider): change variables type

should be .scss to match rest of framework

* docs: replace mentions of node-sass with sass
* **VBottomSheet:** the `v-bottom-sheet-transition` component has been removed
* **VExpansionPanel:** many components have been renamed and props moved
v-expansion-panel         => v-expansion-panels
v-expansion-panel-content => v-expansion-panel
new component                v-expansion-panel-header
new component                v-expansion-panel-content

* style(VExpansionPanel): clean-up styles

* fix: add vertical padding to header

* docs(VExpansionPanels): update examples to new structure

* fix(VExpansionPanelHeader): use correct css selector for **disabled** prop

* fix(VExpansionPanelHeader): add proper focus support for a11y

* docs(VExpansionPanel): add advanced example

* refactor(VExpansionPanel): clean-up files

* test(VExpansionPanel): fix existing tests and expand coverage

* docs: remove unused variable from example

* fix: prevent disabled panels from being toggled

* docs: combine repetitive examples, update props and language

* docs: :man_facepalming:

* docs(VExpansionPanels): remove prop from api entirely

no property deprecations for 2.0

* test(VExpansionPanelHeader): update snapshots

* test(VExpansionPanel): fix tests from bootable update
* **VBottomNav:** `v-bottom-nav` is now `v-bottom-navigation`

* fix(VBottomNavigation): add missing sync update for input-value

* docs(VBottomNavigation): add missing language for api

* style(VBottomNavigation): add font-size variable
* **bootable:** **lazy** now has no effect

* test: fix existing broken tests

* docs(bootable): update language
* **VTabs:** fixes #5636

* test(VTabs): fix tests

* fix(VTabs): move pseudo to :before

was making other items not clickable

* fix(VItemGroup): derive item index in real time

* chore(VTabs): add comments throughout

* refactor(VTabs): improve scroll arrow functionality

utilize existing computed property, updated tests to accommodate

* feat(VSlideGroup): add rtl support
* **VChip/Group:** **value** no longer controls visibility. **input** event emitted when clicking
close is now **click:close**

* refactor(VChip): fix cursor styles

* test(VSelect/VChip): fix unit tests

* docs(CoreItem): use new chip style for xsmall

* refactor(VChip): improve styling within v-chip-group

add keys to append/prepend to support dynamic swapping of column/row

* docs(VChipGroup): add documentation and examples

* feat(VChip): add filter styles, improve existing selection styles
* **validatable:** fixes #5877

### Features

* **activatable:** add value to slot scope ([#7288](https://github.com/vuetifyjs/vuetify/issues/7288)) ([b5dafc4](https://github.com/vuetifyjs/vuetify/commit/b5dafc4e78f802fe3f1dfe8cdce04e7524e4f47e))
* **docs:** refactored api-gen, moved away from md tables for API ([#12184](https://github.com/vuetifyjs/vuetify/issues/12184)) ([a04426f](https://github.com/vuetifyjs/vuetify/commit/a04426fdd756c9ea8036d16ef1d32df906213145))
* **grid:** remove useless .layout.row class ([3f435b5](https://github.com/vuetifyjs/vuetify/commit/3f435b5a3bc6e0686c19009c4429164910a5949e))
* **locale:** add Azerbaijani locale ([#12084](https://github.com/vuetifyjs/vuetify/issues/12084)) ([a2267b2](https://github.com/vuetifyjs/vuetify/commit/a2267b2bda827545290c4eef69440d0501367831))
* **locale:** add Czech translation ([#8228](https://github.com/vuetifyjs/vuetify/issues/8228)) ([8ec6f05](https://github.com/vuetifyjs/vuetify/commit/8ec6f05073f64347fa916057bb4bed2cdea20fad))
* **locale:** add Korean locale files ([#7366](https://github.com/vuetifyjs/vuetify/issues/7366)) ([f1cf81e](https://github.com/vuetifyjs/vuetify/commit/f1cf81ebfab7cf7605af129918dc9eeb879dc942))
* **locale:** add Norwegian translation ([#7587](https://github.com/vuetifyjs/vuetify/issues/7587)) ([b78fe28](https://github.com/vuetifyjs/vuetify/commit/b78fe28dc7c025391610f5195fe95e6830c44753))
* **locale:** add Serbian Latin translation and fix Cyrilic [#13015](https://github.com/vuetifyjs/vuetify/issues/13015) ([#13016](https://github.com/vuetifyjs/vuetify/issues/13016)) ([5650695](https://github.com/vuetifyjs/vuetify/commit/5650695841018c7802679a0e92036503183d4eca))
* **styles:** add rtl/ltr start/end spacing and alignment ([#7448](https://github.com/vuetifyjs/vuetify/issues/7448)) ([3a51619](https://github.com/vuetifyjs/vuetify/commit/3a5161948a1d9c1667760f490733f7081d2f9e4d)), closes [#4660](https://github.com/vuetifyjs/vuetify/issues/4660)
* **styles:** added text-pre-line utility class ([53cc6de](https://github.com/vuetifyjs/vuetify/commit/53cc6de3f8f91a44950113f0fbfcd6f54bd8c800))
* **styles:** float classes breakpointed ([#7922](https://github.com/vuetifyjs/vuetify/issues/7922)) ([26ad2e5](https://github.com/vuetifyjs/vuetify/commit/26ad2e534d68c9a57a5cd59fa38ec5e8fbc77776)), closes [#7921](https://github.com/vuetifyjs/vuetify/issues/7921)
* **theme:** add anchor color support ([#7455](https://github.com/vuetifyjs/vuetify/issues/7455)) ([40f3df8](https://github.com/vuetifyjs/vuetify/commit/40f3df8cc1b3a13fd34187c804905b48effcdb1f)), closes [#6360](https://github.com/vuetifyjs/vuetify/issues/6360)
* **transitions:** add dialog-top-transition ([#12751](https://github.com/vuetifyjs/vuetify/issues/12751)) ([09ddab5](https://github.com/vuetifyjs/vuetify/commit/09ddab59453f15d06d1fb93f19ed3743dcaad4fa))
* **typography:** add text-pre helper class ([7a03376](https://github.com/vuetifyjs/vuetify/commit/7a0337646c1231218e10b876fe67ce01d0168657))
* **Typography:** add text-pre-wrap utility class ([#11772](https://github.com/vuetifyjs/vuetify/issues/11772)) ([bf78f62](https://github.com/vuetifyjs/vuetify/commit/bf78f6288d7ab5e57a9349a7e5d92c928b122b83)), closes [#11761](https://github.com/vuetifyjs/vuetify/issues/11761)
* **Typography:** improve <code> styles ([7877bef](https://github.com/vuetifyjs/vuetify/commit/7877beff68013bb46c4c8d34d4a33c69ca1115c7))
* **VAppBar:** don't truncate title with shrink-on-scroll ([#12516](https://github.com/vuetifyjs/vuetify/issues/12516)) ([8c5ee02](https://github.com/vuetifyjs/vuetify/commit/8c5ee0268dcc78d4cde57f36a90bc68ec1656639)), closes [#12514](https://github.com/vuetifyjs/vuetify/issues/12514)
* **VBreadcrumbs:** support aria ([0e8ca8f](https://github.com/vuetifyjs/vuetify/commit/0e8ca8f48a8d0d9fffc8efb817c339a4e382ecaf))
* **VBtn:** add new styling property plain ([#12814](https://github.com/vuetifyjs/vuetify/issues/12814)) ([bae707c](https://github.com/vuetifyjs/vuetify/commit/bae707c211eb1572d3f2d8a16bfeac48576d0f6b)), closes [#3026](https://github.com/vuetifyjs/vuetify/issues/3026)
* **VBtn:** inherit justify-items from root ([c028904](https://github.com/vuetifyjs/vuetify/commit/c028904c3ad884546f959506c327c74e3f42f26f)), closes [#7896](https://github.com/vuetifyjs/vuetify/issues/7896)
* **VCalendar:** add support for object categories ([#12518](https://github.com/vuetifyjs/vuetify/issues/12518)) ([806864c](https://github.com/vuetifyjs/vuetify/commit/806864cdf1076990bf48a1051145f25308df42a6))
* **VCalendar:** events improvements ([#6475](https://github.com/vuetifyjs/vuetify/issues/6475)) ([964a750](https://github.com/vuetifyjs/vuetify/commit/964a7502f17d5b340ecd3cb30ed558ac5bcc3c88)), closes [#6511](https://github.com/vuetifyjs/vuetify/issues/6511) [#7406](https://github.com/vuetifyjs/vuetify/issues/7406) [#7308](https://github.com/vuetifyjs/vuetify/issues/7308) [#7152](https://github.com/vuetifyjs/vuetify/issues/7152) [#7213](https://github.com/vuetifyjs/vuetify/issues/7213) [#7270](https://github.com/vuetifyjs/vuetify/issues/7270) [#7271](https://github.com/vuetifyjs/vuetify/issues/7271) [#7318](https://github.com/vuetifyjs/vuetify/issues/7318) [#7337](https://github.com/vuetifyjs/vuetify/issues/7337) [#7335](https://github.com/vuetifyjs/vuetify/issues/7335) [#7320](https://github.com/vuetifyjs/vuetify/issues/7320) [#7341](https://github.com/vuetifyjs/vuetify/issues/7341) [#7334](https://github.com/vuetifyjs/vuetify/issues/7334) [#7342](https://github.com/vuetifyjs/vuetify/issues/7342) [#7338](https://github.com/vuetifyjs/vuetify/issues/7338) [#7343](https://github.com/vuetifyjs/vuetify/issues/7343) [#7345](https://github.com/vuetifyjs/vuetify/issues/7345) [#7340](https://github.com/vuetifyjs/vuetify/issues/7340) [#7330](https://github.com/vuetifyjs/vuetify/issues/7330) [#7350](https://github.com/vuetifyjs/vuetify/issues/7350) [#7287](https://github.com/vuetifyjs/vuetify/issues/7287) [#7349](https://github.com/vuetifyjs/vuetify/issues/7349) [#7059](https://github.com/vuetifyjs/vuetify/issues/7059) [#7362](https://github.com/vuetifyjs/vuetify/issues/7362) [#7363](https://github.com/vuetifyjs/vuetify/issues/7363) [#4683](https://github.com/vuetifyjs/vuetify/issues/4683) [#6978](https://github.com/vuetifyjs/vuetify/issues/6978) [#7346](https://github.com/vuetifyjs/vuetify/issues/7346) [#7368](https://github.com/vuetifyjs/vuetify/issues/7368) [#6178](https://github.com/vuetifyjs/vuetify/issues/6178) [#7373](https://github.com/vuetifyjs/vuetify/issues/7373) [#7380](https://github.com/vuetifyjs/vuetify/issues/7380) [#7366](https://github.com/vuetifyjs/vuetify/issues/7366) [#7367](https://github.com/vuetifyjs/vuetify/issues/7367) [#7344](https://github.com/vuetifyjs/vuetify/issues/7344) [#7408](https://github.com/vuetifyjs/vuetify/issues/7408) [#7452](https://github.com/vuetifyjs/vuetify/issues/7452)
* **VCalendar:** update parser to return full category ([#12638](https://github.com/vuetifyjs/vuetify/issues/12638)) ([e2200c3](https://github.com/vuetifyjs/vuetify/commit/e2200c34d4ffab8806308f70eed16a2a76690949))
* **vcolorpicker:** add hideSliders prop ([#12618](https://github.com/vuetifyjs/vuetify/issues/12618)) ([e35d79b](https://github.com/vuetifyjs/vuetify/commit/e35d79b5012d3c0b445c1b9d5beb7f547345696f)), closes [#11138](https://github.com/vuetifyjs/vuetify/issues/11138)
* **VColorPicker:** add a new component ([#6988](https://github.com/vuetifyjs/vuetify/issues/6988)) ([a5a1102](https://github.com/vuetifyjs/vuetify/commit/a5a11023019a13e5ccb8519b5c6a3a913ec33412))
* **VDataTable:** add `foot` and `footer.prepend` slots ([#13081](https://github.com/vuetifyjs/vuetify/issues/13081)) ([1c81605](https://github.com/vuetifyjs/vuetify/commit/1c81605cef397d946e75a13fb4c28461e7ce7c33)), closes [#8767](https://github.com/vuetifyjs/vuetify/issues/8767) [#9695](https://github.com/vuetifyjs/vuetify/issues/9695)
* **VDataTable:** add cellClass property to headers ([#11775](https://github.com/vuetifyjs/vuetify/issues/11775)) ([8d06d45](https://github.com/vuetifyjs/vuetify/commit/8d06d4573237b0d2134c03e763a0f36aa2986b06))
* **VDataTable:** Add checkboxColor prop ([#11975](https://github.com/vuetifyjs/vuetify/issues/11975)) ([4c469fd](https://github.com/vuetifyjs/vuetify/commit/4c469fd945c45fc4323f1846dc055babc794655e)), closes [#8348](https://github.com/vuetifyjs/vuetify/issues/8348)
* **VDataTable:** Add shift key logic for multiple selection ([#11921](https://github.com/vuetifyjs/vuetify/issues/11921)) ([bb252c1](https://github.com/vuetifyjs/vuetify/commit/bb252c126fdd7640f50b49d1f7dfa9543d0a43b7)), closes [#9958](https://github.com/vuetifyjs/vuetify/issues/9958)
* **VDataTable:** change data-table scoped slot props structure ([#7585](https://github.com/vuetifyjs/vuetify/issues/7585)) ([878be3e](https://github.com/vuetifyjs/vuetify/commit/878be3e9de715e01d76aa45761ba7acb5d14568e))
* **VDataTable:** index prop in item* slots ([#12605](https://github.com/vuetifyjs/vuetify/issues/12605)) ([9daeb16](https://github.com/vuetifyjs/vuetify/commit/9daeb1691d7cc0ecd64289033a2d4ec96f6f4b80)), closes [#10646](https://github.com/vuetifyjs/vuetify/issues/10646)
* **VDataTable:** isMobile prop in scoped slots ([#12604](https://github.com/vuetifyjs/vuetify/issues/12604)) ([e1720a8](https://github.com/vuetifyjs/vuetify/commit/e1720a8d5d0361fc223a4113588caf6f32ce1e59)), closes [#11330](https://github.com/vuetifyjs/vuetify/issues/11330)
* **VDatePicker:** `show-adjacent-months` prop ([#12603](https://github.com/vuetifyjs/vuetify/issues/12603)) ([8f1cf64](https://github.com/vuetifyjs/vuetify/commit/8f1cf64691d05c673306563366e5ee794e8b75de)), closes [#12237](https://github.com/vuetifyjs/vuetify/issues/12237)
* **VDatePicker:** activePicker prop ([#12754](https://github.com/vuetifyjs/vuetify/issues/12754)) ([42b56bb](https://github.com/vuetifyjs/vuetify/commit/42b56bbfdfb5ae218661adcf4441984237beb558)), closes [#11576](https://github.com/vuetifyjs/vuetify/issues/11576)
* **VDialog:** add retainFocus prop ([3681cd5](https://github.com/vuetifyjs/vuetify/commit/3681cd59fe82bd1716a46038245236b2922923db)), closes [#6892](https://github.com/vuetifyjs/vuetify/issues/6892)
* **VIcon:** specify a global default icon component ([#12244](https://github.com/vuetifyjs/vuetify/issues/12244)) ([41fd082](https://github.com/vuetifyjs/vuetify/commit/41fd082dc2ae59a35b399e5d86cf4d66729ec63b)), closes [#7821](https://github.com/vuetifyjs/vuetify/issues/7821)
* **VImg:** add loadstart event ([c057c92](https://github.com/vuetifyjs/vuetify/commit/c057c929fa8be1d5e1914d826ed25acff84e55f5))
* **VStepper:** extend VSheet functionality ([ae51c07](https://github.com/vuetifyjs/vuetify/commit/ae51c07600c2ee746aa9a2fed58ce933cbbb8b5d)), closes [#4076](https://github.com/vuetifyjs/vuetify/issues/4076)
* `float-<bp>-start` and `float-<bp>-end` utility classes ([#12753](https://github.com/vuetifyjs/vuetify/issues/12753)) ([13ab192](https://github.com/vuetifyjs/vuetify/commit/13ab192c573a8401c5f4c52d4b0d3b1bf5f3c349)), closes [#11874](https://github.com/vuetifyjs/vuetify/issues/11874)
* **locale:** add Central Kurdish locale ([#12100](https://github.com/vuetifyjs/vuetify/issues/12100)) ([e121bc2](https://github.com/vuetifyjs/vuetify/commit/e121bc249f1ecd1f23bc778f899882c344ef348c))
* add 404 page ([#126](https://github.com/vuetifyjs/vuetify/issues/126)) ([8dbd662](https://github.com/vuetifyjs/vuetify/commit/8dbd6624e45ad4b2c1d6a16ecfa2a471f1232103))
* add error handling when loading example ([#14](https://github.com/vuetifyjs/vuetify/issues/14)) ([72ecab6](https://github.com/vuetifyjs/vuetify/commit/72ecab6794cd504cc56def66b73a78f2e314b443))
* detect user preferred color theme as default ([#76](https://github.com/vuetifyjs/vuetify/issues/76)) ([991ca90](https://github.com/vuetifyjs/vuetify/commit/991ca909ecc1545659c9e295277970e08d1f89b4))
* **a11y:** add visually hidden css utility classes ([#11258](https://github.com/vuetifyjs/vuetify/issues/11258)) ([9e4c3c8](https://github.com/vuetifyjs/vuetify/commit/9e4c3c8995425aa8f398908063cfa586a40cd702)), closes [#10914](https://github.com/vuetifyjs/vuetify/issues/10914)
* **api:** re-build api pages when source data changes ([#24](https://github.com/vuetifyjs/vuetify/issues/24)) ([eba2631](https://github.com/vuetifyjs/vuetify/commit/eba2631731ecb4a6d3178e2264a273f6793813c0))
* **breakpoint:** add global variables/mixin ([#11480](https://github.com/vuetifyjs/vuetify/issues/11480)) ([9f6f5a5](https://github.com/vuetifyjs/vuetify/commit/9f6f5a58481e5de6e95f8e7a84242cced940d70c)), closes [#6945](https://github.com/vuetifyjs/vuetify/issues/6945) [#9272](https://github.com/vuetifyjs/vuetify/issues/9272)
* **directives:** expose all options to templates ([#10905](https://github.com/vuetifyjs/vuetify/issues/10905)) ([a8d0def](https://github.com/vuetifyjs/vuetify/commit/a8d0def2f29affaf7c14162503d0343bf39c94f2)), closes [#4654](https://github.com/vuetifyjs/vuetify/issues/4654)
* **DocumentationDrawer:** add alphabetical sorting mode ([#25](https://github.com/vuetifyjs/vuetify/issues/25)) ([34ddb2e](https://github.com/vuetifyjs/vuetify/commit/34ddb2e7f30517f32ba5e7a70c1fccb31d10dff1))
* **loaders:** improve loading styles for table and cards ([c2c1d6a](https://github.com/vuetifyjs/vuetify/commit/c2c1d6ac8bb78e783243ca3d7fdb8390b25235ba))
* **Ripple:** hide effect for touch scroll events ([#7887](https://github.com/vuetifyjs/vuetify/issues/7887)) ([#10596](https://github.com/vuetifyjs/vuetify/issues/10596)) ([337fd24](https://github.com/vuetifyjs/vuetify/commit/337fd248ac75c99adeb3c33a29ce441eefce724b))
* **Spacing:** add support for 16 sizes of margin/padding ([bbfe878](https://github.com/vuetifyjs/vuetify/commit/bbfe8783ac2341ff9b28c18763c6b39791f94c1c)), closes [#10675](https://github.com/vuetifyjs/vuetify/issues/10675)
* **theme:** add new option to disable variation generation ([d4c311e](https://github.com/vuetifyjs/vuetify/commit/d4c311e4c892da726e1491a702219436aef9c413))
* **types:** add DataItemProps and DataTableItemProps interfaces ([#11593](https://github.com/vuetifyjs/vuetify/issues/11593)) ([e0d0296](https://github.com/vuetifyjs/vuetify/commit/e0d0296a7a6b4cd2d2fb4332ef66adf2f63a58ab))
* **v-data-table:** add item-class property ([#11254](https://github.com/vuetifyjs/vuetify/issues/11254)) ([7d1489a](https://github.com/vuetifyjs/vuetify/commit/7d1489aee79793407f2ede280af71cdac1c8eb90)), closes [#8643](https://github.com/vuetifyjs/vuetify/issues/8643)
* **VAvatar:** integrate roundable mixin ([#11435](https://github.com/vuetifyjs/vuetify/issues/11435)) ([8d1eac0](https://github.com/vuetifyjs/vuetify/commit/8d1eac0c1a7ecf7c4306a137f276a8d61126dc55))
* **VCalendar:** general improvements & category view ([#11198](https://github.com/vuetifyjs/vuetify/issues/11198)) ([5ab3d41](https://github.com/vuetifyjs/vuetify/commit/5ab3d416ce9bf41ae6c3aea03d6abeca0a8170af)), closes [#8667](https://github.com/vuetifyjs/vuetify/issues/8667) [#11080](https://github.com/vuetifyjs/vuetify/issues/11080) [#11093](https://github.com/vuetifyjs/vuetify/issues/11093) [#11133](https://github.com/vuetifyjs/vuetify/issues/11133) [#11182](https://github.com/vuetifyjs/vuetify/issues/11182)
* **VCalendar:** show week numbers in month-view ([#10928](https://github.com/vuetifyjs/vuetify/issues/10928)) ([39177c2](https://github.com/vuetifyjs/vuetify/commit/39177c283438097b4fa5905c4a4042f8e9e45385)), closes [#9117](https://github.com/vuetifyjs/vuetify/issues/9117)
* **VDataTable:** add groupable property to header items ([#11361](https://github.com/vuetifyjs/vuetify/issues/11361)) ([e0215ff](https://github.com/vuetifyjs/vuetify/commit/e0215ffb8509852fb24f38ef15299307e23b16e2)), closes [#10889](https://github.com/vuetifyjs/vuetify/issues/10889)
* **VDatePicker:** native events on day/month/year ([#11126](https://github.com/vuetifyjs/vuetify/issues/11126)) ([e706660](https://github.com/vuetifyjs/vuetify/commit/e706660aebe3f11f7869204fee1cee8b62952650)), closes [#5598](https://github.com/vuetifyjs/vuetify/issues/5598)
* **VDatePicker:** prev/next month/year icon aria label ([#10366](https://github.com/vuetifyjs/vuetify/issues/10366)) ([9c2a8b5](https://github.com/vuetifyjs/vuetify/commit/9c2a8b5764131d463a660e62733e24f7f4edbc45)), closes [#9694](https://github.com/vuetifyjs/vuetify/issues/9694)
* **VFileInput:** add new prop hide-input ([#11031](https://github.com/vuetifyjs/vuetify/issues/11031)) ([0b256c9](https://github.com/vuetifyjs/vuetify/commit/0b256c92804021f2006b596065b87cbc9fcfbf14)), closes [#10886](https://github.com/vuetifyjs/vuetify/issues/10886)
* **VForm:** add form level disabled prop ([#10325](https://github.com/vuetifyjs/vuetify/issues/10325)) ([ccf25e8](https://github.com/vuetifyjs/vuetify/commit/ccf25e82b41afe41887d859bc590372d476d1ee0)), closes [#1707](https://github.com/vuetifyjs/vuetify/issues/1707)
* **VItemGroup:** add tag prop to component ([#12771](https://github.com/vuetifyjs/vuetify/issues/12771)) ([e3378fc](https://github.com/vuetifyjs/vuetify/commit/e3378fc2d7a4a8e9ccf5b4d622e9b570382dbd92)), closes [#11392](https://github.com/vuetifyjs/vuetify/issues/11392)
* **VMain:** create new component from v-content ([7a85220](https://github.com/vuetifyjs/vuetify/commit/7a852200604b5755a63e6fecd0a773d5e4c4a59f))
* **VMenu:** add jump to first/last item keyboard navigation ([#12348](https://github.com/vuetifyjs/vuetify/issues/12348)) ([181d337](https://github.com/vuetifyjs/vuetify/commit/181d33763bb3dca0cd6a47787e20a1ab4bf65f4a))
* **VMenu:** add rounded support to menu content ([#11447](https://github.com/vuetifyjs/vuetify/issues/11447)) ([ea52a89](https://github.com/vuetifyjs/vuetify/commit/ea52a8933ac4d1efc2843a27f6987b4f3d5cd3af)), closes [#10397](https://github.com/vuetifyjs/vuetify/issues/10397)
* **VParallax:** add srcset support ([e72e78f](https://github.com/vuetifyjs/vuetify/commit/e72e78f3e9872c65589cfbdd197d23c214c8426e)), closes [#1535](https://github.com/vuetifyjs/vuetify/issues/1535)
* **VProgress:** only play animations when visible ([#13136](https://github.com/vuetifyjs/vuetify/issues/13136)) ([4485598](https://github.com/vuetifyjs/vuetify/commit/448559817b5bea8d8feae11ca84ccfdd8a0c6e39)), closes [#12731](https://github.com/vuetifyjs/vuetify/issues/12731)
* **VResponsive:** add contentClass prop ([71b8854](https://github.com/vuetifyjs/vuetify/commit/71b8854a27eac53876252163a906fc7172960920)), closes [#10982](https://github.com/vuetifyjs/vuetify/issues/10982)
* **VSheet:** refactor style propagation ([#11335](https://github.com/vuetifyjs/vuetify/issues/11335)) ([cbaf955](https://github.com/vuetifyjs/vuetify/commit/cbaf955fccdceb7d8bf70fdbe4091a1ee27c0c82))
* **VSnackbar:** add applicationable support ([#11448](https://github.com/vuetifyjs/vuetify/issues/11448)) ([6098e5f](https://github.com/vuetifyjs/vuetify/commit/6098e5f732856a693f459f8fd71697605cb30903)), closes [#4468](https://github.com/vuetifyjs/vuetify/issues/4468)
* **VSnackbar:** add new properties and improve md2 spec ([#11542](https://github.com/vuetifyjs/vuetify/issues/11542)) ([d44b590](https://github.com/vuetifyjs/vuetify/commit/d44b590e51d23e54fda6d99ea69540bdade192af)), closes [#5865](https://github.com/vuetifyjs/vuetify/issues/5865) [#10935](https://github.com/vuetifyjs/vuetify/issues/10935)
* **VSnackbar:** keep snackbar open while mouseover ([#12599](https://github.com/vuetifyjs/vuetify/issues/12599)) ([8808d98](https://github.com/vuetifyjs/vuetify/commit/8808d98ce0f4ab4882f9ab21625263d2c309c0a1)), closes [#12494](https://github.com/vuetifyjs/vuetify/issues/12494)
* **VTextField:** add `counter` scoped slot ([#12634](https://github.com/vuetifyjs/vuetify/issues/12634)) ([ed46cfb](https://github.com/vuetifyjs/vuetify/commit/ed46cfb70ef3b34c03f217aa28caf338f81b7b78)), closes [#9548](https://github.com/vuetifyjs/vuetify/issues/9548)
* **VTextField:** add persistentPlaceholder prop ([#13001](https://github.com/vuetifyjs/vuetify/issues/13001)) ([005d56d](https://github.com/vuetifyjs/vuetify/commit/005d56d43924efc17db54fd419e5f8a241f82a14)), closes [#12839](https://github.com/vuetifyjs/vuetify/issues/12839)
* **VTextField:** only show placeholder on focus if label is set ([#12635](https://github.com/vuetifyjs/vuetify/issues/12635)) ([ff500ba](https://github.com/vuetifyjs/vuetify/commit/ff500ba38592f3db1288c7552000260cedadd4e0)), closes [#12499](https://github.com/vuetifyjs/vuetify/issues/12499)
* **VWindow,VCarousel:** **prev** and **next** slots ([#12602](https://github.com/vuetifyjs/vuetify/issues/12602)) ([a0140b0](https://github.com/vuetifyjs/vuetify/commit/a0140b0268c0bc5cebfa0d66d3705d74ead68514)), closes [#3235](https://github.com/vuetifyjs/vuetify/issues/3235)
* add pwa/http-server ([bfcfe7c](https://github.com/vuetifyjs/vuetify/commit/bfcfe7c6799c1572e0d6c3ce4c38f35a326625c1))
* add vue-i18n ([#5](https://github.com/vuetifyjs/vuetify/issues/5)) ([eed47fe](https://github.com/vuetifyjs/vuetify/commit/eed47fec4094817b95c6befc83fbd714f73709c0))
* allow all console messages to be disabled ([#10909](https://github.com/vuetifyjs/vuetify/issues/10909)) ([7f99918](https://github.com/vuetifyjs/vuetify/commit/7f99918095c690974855271f85594a18523e78c0)), closes [#10888](https://github.com/vuetifyjs/vuetify/issues/10888)
* dynamically generate drawer items ([#3](https://github.com/vuetifyjs/vuetify/issues/3)) ([776294f](https://github.com/vuetifyjs/vuetify/commit/776294f9e17d586fc78a0b1a149d1492307a432d))
* use component syntax for alerts instead of blockquoute ([73fb18a](https://github.com/vuetifyjs/vuetify/commit/73fb18adb7cd97f116f12ef130b19677d851b0b5))
* **colorable:** add support for CSS custom props ([#9637](https://github.com/vuetifyjs/vuetify/issues/9637)) ([ac58e80](https://github.com/vuetifyjs/vuetify/commit/ac58e80c35a14499305263fc7d3efa236c10328b))
* **directives:** add color directive ([#10866](https://github.com/vuetifyjs/vuetify/issues/10866)) ([bf3799b](https://github.com/vuetifyjs/vuetify/commit/bf3799be2abaeb35414df0f3e3071301e0f1e557))
* **framework:** create new decoration helper classes ([#11035](https://github.com/vuetifyjs/vuetify/issues/11035)) ([bf3fad2](https://github.com/vuetifyjs/vuetify/commit/bf3fad2c4ccacadd4da9ef30dc1e35ebd05c7aa3))
* **i18n:** translate Sort by to Norwegian ([#8762](https://github.com/vuetifyjs/vuetify/issues/8762)) ([6eb70a7](https://github.com/vuetifyjs/vuetify/commit/6eb70a71174968ba13e2967c2f35c5fabc7fb443))
* **kbd/code:** update colors/style, added new variables ([47042cd](https://github.com/vuetifyjs/vuetify/commit/47042cd55d2cd6d343635dfa1d6761bc2fc9aca7))
* **locale:** add Finnish translation ([#10381](https://github.com/vuetifyjs/vuetify/issues/10381)) ([0ce1a66](https://github.com/vuetifyjs/vuetify/commit/0ce1a66851162385f89f144d69411b9966ab777c))
* **locale:** add Lithuanian translation ([#8605](https://github.com/vuetifyjs/vuetify/issues/8605)) ([6216517](https://github.com/vuetifyjs/vuetify/commit/6216517e4477ad61637f74ce09ea3e1dd704e531))
* **locale:** add Slovak translation ([#10328](https://github.com/vuetifyjs/vuetify/issues/10328)) ([59b8422](https://github.com/vuetifyjs/vuetify/commit/59b8422b3a3cd5048f990c1ccd636f0f5b89cd16))
* **mutate:** add a new directive ([#9148](https://github.com/vuetifyjs/vuetify/issues/9148)) ([51de110](https://github.com/vuetifyjs/vuetify/commit/51de110c71d6145e54507216bbaa1448f4b454a4))
* **presets:** add new service ([#9894](https://github.com/vuetifyjs/vuetify/issues/9894)) ([5c0a67c](https://github.com/vuetifyjs/vuetify/commit/5c0a67c1dff1ceb4b84168dd42a80f1beeb70e8f))
* **rounded:** add border-radius helper classes ([82dbdbf](https://github.com/vuetifyjs/vuetify/commit/82dbdbf58a0caf3ade7d0d5c2ffa4c42800caad6))
* **sass:** create more preset variables ([#9766](https://github.com/vuetifyjs/vuetify/issues/9766)) ([2c901ba](https://github.com/vuetifyjs/vuetify/commit/2c901ba806db5a20af342c0eaa2b28634b114924))
* **types:** expose public interfaces for props and slots ([#9763](https://github.com/vuetifyjs/vuetify/issues/9763)) ([b03b507](https://github.com/vuetifyjs/vuetify/commit/b03b507fc811ce4657a8cdbc3993ed58932cbab6))
* **typography:** add break-point functionality to new type classes ([#11033](https://github.com/vuetifyjs/vuetify/issues/11033)) ([e83a203](https://github.com/vuetifyjs/vuetify/commit/e83a203c8dc13c02eb75792d1de9404c8e998798))
* **typography:** add new variables for font-family ([fb84327](https://github.com/vuetifyjs/vuetify/commit/fb8432741ebe4bb4c84cf40c65826e72896c39d2))
* **v-scroll:** add self modifier to target the bound element ([#11244](https://github.com/vuetifyjs/vuetify/issues/11244)) ([9748731](https://github.com/vuetifyjs/vuetify/commit/9748731c072f6d83ce326666d2315fc275ed1333))
* **VAlert:** add closeIcon prop ([#11124](https://github.com/vuetifyjs/vuetify/issues/11124)) ([ec151b3](https://github.com/vuetifyjs/vuetify/commit/ec151b3ae11bfc7b410d21b41916ddead440d807))
* **VAutocomplete:** make items copy-pasteable ([#7759](https://github.com/vuetifyjs/vuetify/issues/7759)) ([c72f902](https://github.com/vuetifyjs/vuetify/commit/c72f902aadaf6963c530b709e1bf479756940728)), closes [#6226](https://github.com/vuetifyjs/vuetify/issues/6226)
* **VBadge:** refactor for v2.2 ([#9328](https://github.com/vuetifyjs/vuetify/issues/9328)) ([b7fe7c2](https://github.com/vuetifyjs/vuetify/commit/b7fe7c2b8493428fcc612fd2066142f5bb1ac123)), closes [#8245](https://github.com/vuetifyjs/vuetify/issues/8245)
* **VBanner:** allow banner text to extend full-width ([a3466e0](https://github.com/vuetifyjs/vuetify/commit/a3466e0ec9d7b7bb9bd1f28a9f608257b73a71d2))
* **VBtn:** add retainFocusOnClick property ([#9046](https://github.com/vuetifyjs/vuetify/issues/9046)) ([14a0acd](https://github.com/vuetifyjs/vuetify/commit/14a0acd8ad8fc4d856457ca299f8c889985cce6e))
* **VBtnToggle:** add new variants ([#7582](https://github.com/vuetifyjs/vuetify/issues/7582)) ([33f031a](https://github.com/vuetifyjs/vuetify/commit/33f031a3b2219237a2cd0a159238b31227a82935)), closes [#4325](https://github.com/vuetifyjs/vuetify/issues/4325)
* **VCalendar:** redo event overlap logic ([#9974](https://github.com/vuetifyjs/vuetify/issues/9974)) ([20a7a1a](https://github.com/vuetifyjs/vuetify/commit/20a7a1a06a683b696921bc0a877d814e6f76bdc0)), closes [#8826](https://github.com/vuetifyjs/vuetify/issues/8826) [#8928](https://github.com/vuetifyjs/vuetify/issues/8928) [#8620](https://github.com/vuetifyjs/vuetify/issues/8620) [#8396](https://github.com/vuetifyjs/vuetify/issues/8396) [#8792](https://github.com/vuetifyjs/vuetify/issues/8792) [#8937](https://github.com/vuetifyjs/vuetify/issues/8937) [#8565](https://github.com/vuetifyjs/vuetify/issues/8565) [#8400](https://github.com/vuetifyjs/vuetify/issues/8400)
* **VCard:** add elevation SASS variable ([575acbd](https://github.com/vuetifyjs/vuetify/commit/575acbda788a1332ebd124c4d74484870c9bfe8b))
* **VCard:** add new shaped prop ([18d732d](https://github.com/vuetifyjs/vuetify/commit/18d732d24fa0b912f1bca731b9de8b56717f31b2))
* **VCard:** increase hover effect when focusing ([#8143](https://github.com/vuetifyjs/vuetify/issues/8143)) ([5dc3345](https://github.com/vuetifyjs/vuetify/commit/5dc3345e2a73765ea844ac33b4a4f2ebd41d85eb))
* **VCol:** add justify-self property ([1ba5f82](https://github.com/vuetifyjs/vuetify/commit/1ba5f829cb727452343abc7db03b440da78a6357))
* **vdata:** custom grouping functions ([#9253](https://github.com/vuetifyjs/vuetify/issues/9253)) ([87f22c2](https://github.com/vuetifyjs/vuetify/commit/87f22c2d5e742c2c87df65c258f5576fefd9081a))
* **VDataFooter:** added page-text prop ([#8511](https://github.com/vuetifyjs/vuetify/issues/8511)) ([d00534f](https://github.com/vuetifyjs/vuetify/commit/d00534f2ad9902ace931b150cfacc1dba3171821)), closes [#8110](https://github.com/vuetifyjs/vuetify/issues/8110)
* **VDataIterator:** add current items to toggle-select-all event ([#9641](https://github.com/vuetifyjs/vuetify/issues/9641)) ([ab28d72](https://github.com/vuetifyjs/vuetify/commit/ab28d728e63ebbc134f543806b64e0aa99e9d752)), closes [#8532](https://github.com/vuetifyjs/vuetify/issues/8532)
* **VDataIterator:** emit the page-count event from VData ([#10588](https://github.com/vuetifyjs/vuetify/issues/10588)) ([db98a1e](https://github.com/vuetifyjs/vuetify/commit/db98a1e2bc6b544abf9583c6a454bca718ae0894))
* **VDataIterator:** items can now be made unselectable ([#9645](https://github.com/vuetifyjs/vuetify/issues/9645)) ([65256b2](https://github.com/vuetifyjs/vuetify/commit/65256b256dad0f0c2d69a7e173d91b46f252519b)), closes [#8915](https://github.com/vuetifyjs/vuetify/issues/8915)
* **VDataIterator:** propagate and add toggle-select-all event ([#8975](https://github.com/vuetifyjs/vuetify/issues/8975)) ([c9b00db](https://github.com/vuetifyjs/vuetify/commit/c9b00dbd845783be3849ac712f0c943e23981eb7)), closes [#8974](https://github.com/vuetifyjs/vuetify/issues/8974)
* **VDatatable:** add isOpen to group.header slot parameters ([#9721](https://github.com/vuetifyjs/vuetify/issues/9721)) ([bb26a2e](https://github.com/vuetifyjs/vuetify/commit/bb26a2ee0a6e9a13bdf468bee12711cade78537d))
* **VDataTable:** add contexmenu:row event for data table ([#10989](https://github.com/vuetifyjs/vuetify/issues/10989)) ([26c9ec9](https://github.com/vuetifyjs/vuetify/commit/26c9ec9bb60429b422a93ebf96a1c52c3113274e)), closes [#9382](https://github.com/vuetifyjs/vuetify/issues/9382)
* **VDataTable:** added filterable property to header items ([#8439](https://github.com/vuetifyjs/vuetify/issues/8439)) ([00c6a73](https://github.com/vuetifyjs/vuetify/commit/00c6a73b867702574673358e622492822f3db4a3)), closes [#8242](https://github.com/vuetifyjs/vuetify/issues/8242)
* **VDataTable:** expose expand/select functionality ([#9642](https://github.com/vuetifyjs/vuetify/issues/9642)) ([587edf9](https://github.com/vuetifyjs/vuetify/commit/587edf964cb3c9148184c775d17611b94103cacb)), closes [#8008](https://github.com/vuetifyjs/vuetify/issues/8008)
* **VDataTable:** hide sort by select on mobile if not needed ([#9215](https://github.com/vuetifyjs/vuetify/issues/9215)) ([665ebe3](https://github.com/vuetifyjs/vuetify/commit/665ebe34473606be487b7d55ec0ccaf0fc856fed)), closes [#9209](https://github.com/vuetifyjs/vuetify/issues/9209)
* **VDatePicker:** pick date range ([#8891](https://github.com/vuetifyjs/vuetify/issues/8891)) ([64867ba](https://github.com/vuetifyjs/vuetify/commit/64867ba6274548d4aec7b979386fb0e31ce155ea)), closes [#1646](https://github.com/vuetifyjs/vuetify/issues/1646)
* **VExpansionPanels:** implement flat, tile, hover, and color props ([#9643](https://github.com/vuetifyjs/vuetify/issues/9643)) ([39d7e1e](https://github.com/vuetifyjs/vuetify/commit/39d7e1e3bcad6daf7abffd6797c492a041474997)), closes [#8939](https://github.com/vuetifyjs/vuetify/issues/8939)
* **VIcon:** add font awesome duotone support ([#9170](https://github.com/vuetifyjs/vuetify/issues/9170)) ([629b595](https://github.com/vuetifyjs/vuetify/commit/629b595312136ec98c86fc399946b57e3956c55e)), closes [#8398](https://github.com/vuetifyjs/vuetify/issues/8398)
* **VIcon:** shorter iconName prefix ([#7672](https://github.com/vuetifyjs/vuetify/issues/7672)) ([952f561](https://github.com/vuetifyjs/vuetify/commit/952f561bb9d2278f5920f202fb8be8932d5dfe73))
* **VImg:** add lazy loading functionality ([0df5f42](https://github.com/vuetifyjs/vuetify/commit/0df5f4290f2338066af3fe032cadf10f22fbf5ad))
* **VImg:** add themeable support ([#11034](https://github.com/vuetifyjs/vuetify/issues/11034)) ([5e13729](https://github.com/vuetifyjs/vuetify/commit/5e137292f54ebe9ae6ab1b76926c01373bf71d41))
* **VImg:** add themeable support ([#9805](https://github.com/vuetifyjs/vuetify/issues/9805)) ([5d180dd](https://github.com/vuetifyjs/vuetify/commit/5d180dd235b8801545ec49db2a701cd14fdea051))
* **VImg:** remove error logging ([755dc3d](https://github.com/vuetifyjs/vuetify/commit/755dc3d0380ac9a02d6e67a77a8603f222238169)), closes [#6755](https://github.com/vuetifyjs/vuetify/issues/6755)
* **VInput:** add dense prop ([#8810](https://github.com/vuetifyjs/vuetify/issues/8810)) ([5bfc87e](https://github.com/vuetifyjs/vuetify/commit/5bfc87e23f6d664276d78dfb93593a3a0f851def)), closes [#1846](https://github.com/vuetifyjs/vuetify/issues/1846)
* **VInput:** auto hiding details if no messages/counter ([#7472](https://github.com/vuetifyjs/vuetify/issues/7472)) ([7a9080a](https://github.com/vuetifyjs/vuetify/commit/7a9080a0dd856be67d74c53476ae7363e4df65be)), closes [#7434](https://github.com/vuetifyjs/vuetify/issues/7434)
* **VIntersect:** add new directive ([#9071](https://github.com/vuetifyjs/vuetify/issues/9071)) ([9aee2d6](https://github.com/vuetifyjs/vuetify/commit/9aee2d6f6c63af30a9be7c1d4ef605d8fe15b526))
* **VLazy:** add measurable mixin ([a3a4e67](https://github.com/vuetifyjs/vuetify/commit/a3a4e678f63594dac4c761deeeb7d6ddae86a66e))
* **VLazy:** add new component ([86590b4](https://github.com/vuetifyjs/vuetify/commit/86590b468bb7b936238015dd7c5068ebd4bf9df5))
* **VLazy:** add tag prop ([00fb555](https://github.com/vuetifyjs/vuetify/commit/00fb5558766614314ebe5b9f0a089cf41786aec5)), closes [#9191](https://github.com/vuetifyjs/vuetify/issues/9191)
* **VListItem:** add selectable prop ([#8622](https://github.com/vuetifyjs/vuetify/issues/8622)) ([b6c4f15](https://github.com/vuetifyjs/vuetify/commit/b6c4f15c764861fff90fc98152ae991f5831fb30)), closes [#8464](https://github.com/vuetifyjs/vuetify/issues/8464)
* **VPagination:** add a11y support ([#9926](https://github.com/vuetifyjs/vuetify/issues/9926)) ([042a4bd](https://github.com/vuetifyjs/vuetify/commit/042a4bd47d508fcd86dc06b60bf7c5a31c46dc60)), closes [#9849](https://github.com/vuetifyjs/vuetify/issues/9849)
* **VPicker:** `flat` and `elevation` props for pickers ([#10362](https://github.com/vuetifyjs/vuetify/issues/10362)) ([e557759](https://github.com/vuetifyjs/vuetify/commit/e5577598156dd877f64b11e321e14b678a821a1a)), closes [#6006](https://github.com/vuetifyjs/vuetify/issues/6006)
* **VProgressLinear:** add new **reverse** prop ([#11259](https://github.com/vuetifyjs/vuetify/issues/11259)) ([b4e16c6](https://github.com/vuetifyjs/vuetify/commit/b4e16c6668e14889570c8daa014aa8829d95b4fa)), closes [#11245](https://github.com/vuetifyjs/vuetify/issues/11245)
* **VSelect:** add prop for disabling keyboard lookup ([#9297](https://github.com/vuetifyjs/vuetify/issues/9297)) ([b0a7c30](https://github.com/vuetifyjs/vuetify/commit/b0a7c300009ee07c2f93b53bf7e7a92b83026037)), closes [#9271](https://github.com/vuetifyjs/vuetify/issues/9271)
* **VSelect:** emit selected listIndex event ([#7828](https://github.com/vuetifyjs/vuetify/issues/7828)) ([b795145](https://github.com/vuetifyjs/vuetify/commit/b7951455defba24d39476d5acb846a54fa27cbac)), closes [#7808](https://github.com/vuetifyjs/vuetify/issues/7808)
* **VSkeletonLoader:** add new component ([#9037](https://github.com/vuetifyjs/vuetify/issues/9037)) ([160c7e8](https://github.com/vuetifyjs/vuetify/commit/160c7e8e94f540ce841cc771c60e704b777dab7f))
* **VSnackbar:** add border-radius sass variable ([5b7341e](https://github.com/vuetifyjs/vuetify/commit/5b7341e82208511297c9600eca8b26e1e8c915ab))
* **VTabs:** add new bar-background-color variable ([72f46dc](https://github.com/vuetifyjs/vuetify/commit/72f46dc52ca50f7544f4cc248b6854f6bafcb031))
* **VTextField:** add $text-field-filled-border-radius sass variable ([d1a0189](https://github.com/vuetifyjs/vuetify/commit/d1a0189faccf1a5d323a1d4c68e2bebd3c8845a3))
* **VTextField:** add customizable counter value ([#8802](https://github.com/vuetifyjs/vuetify/issues/8802)) ([9aa761e](https://github.com/vuetifyjs/vuetify/commit/9aa761e87722188b07f4e275b57ffbac3f0e2a89)), closes [#8788](https://github.com/vuetifyjs/vuetify/issues/8788)
* **VThemeProvider:** add new component ([#9804](https://github.com/vuetifyjs/vuetify/issues/9804)) ([2dba817](https://github.com/vuetifyjs/vuetify/commit/2dba817f046d61d6eb05a7ed27d0893040f84b67))
* **VTimePicker:** show am/pm indicator in title and in clock ([#10364](https://github.com/vuetifyjs/vuetify/issues/10364)) ([279af0e](https://github.com/vuetifyjs/vuetify/commit/279af0e8bd24df7d08885ceff5d2baa258dfa921)), closes [#9572](https://github.com/vuetifyjs/vuetify/issues/9572)
* added color and opacity props to overlayable mixin ([#8861](https://github.com/vuetifyjs/vuetify/issues/8861)) ([fc7697d](https://github.com/vuetifyjs/vuetify/commit/fc7697df2cd889d8dbe0d01517787317d911bb15)), closes [#8301](https://github.com/vuetifyjs/vuetify/issues/8301)
* **VTimePicker:** am/pm i18n. ([#9032](https://github.com/vuetifyjs/vuetify/issues/9032)) ([0b8fa7c](https://github.com/vuetifyjs/vuetify/commit/0b8fa7c9a0d92908c35c4883dd091cb386f604d2))
* **VVirtualScroll :** add new component ([#10944](https://github.com/vuetifyjs/vuetify/issues/10944)) ([a1423cd](https://github.com/vuetifyjs/vuetify/commit/a1423cd9bb147a2d6e313ab8b6ad2feeb8ea1ed5))
* use a bootstrap-style grid system ([#7327](https://github.com/vuetifyjs/vuetify/issues/7327)) ([9c122fe](https://github.com/vuetifyjs/vuetify/commit/9c122fe71b421d0509cec745bafb7277fdf8f317)), closes [#1434](https://github.com/vuetifyjs/vuetify/issues/1434) [#5168](https://github.com/vuetifyjs/vuetify/issues/5168) [#5272](https://github.com/vuetifyjs/vuetify/issues/5272) [#6020](https://github.com/vuetifyjs/vuetify/issues/6020) [#7733](https://github.com/vuetifyjs/vuetify/issues/7733)
* **locale:** remove obsolete gr.ts locale ([f0a3b23](https://github.com/vuetifyjs/vuetify/commit/f0a3b23877c7531e1707cbfa1c57cde8e8dcfbc0))
* **VAlert:** add text variant ([76d70e3](https://github.com/vuetifyjs/vuetify/commit/76d70e3219ae0dade2887ff3841e620e9243b414))
* **VAlert:** refactor for v2 ([#6107](https://github.com/vuetifyjs/vuetify/issues/6107)) ([c889973](https://github.com/vuetifyjs/vuetify/commit/c88997356cb5dda6974f81c0843b7ad3f1cdad9d)), closes [#6126](https://github.com/vuetifyjs/vuetify/issues/6126) [#3768](https://github.com/vuetifyjs/vuetify/issues/3768) [#6125](https://github.com/vuetifyjs/vuetify/issues/6125) [#6064](https://github.com/vuetifyjs/vuetify/issues/6064) [#5881](https://github.com/vuetifyjs/vuetify/issues/5881) [#6088](https://github.com/vuetifyjs/vuetify/issues/6088) [#6080](https://github.com/vuetifyjs/vuetify/issues/6080)
* **VAvatar:** update to md2 ([#6433](https://github.com/vuetifyjs/vuetify/issues/6433)) ([b19947e](https://github.com/vuetifyjs/vuetify/commit/b19947ea694d03d397e3114df3dfaf4c5629236a))
* **VBadge:** update to md2 ([#6514](https://github.com/vuetifyjs/vuetify/issues/6514)) ([f5c9a9d](https://github.com/vuetifyjs/vuetify/commit/f5c9a9d5d5012c19f9f95221868a159e59c9e02e))
* **VBanner:** add new component ([#6520](https://github.com/vuetifyjs/vuetify/issues/6520)) ([043fff0](https://github.com/vuetifyjs/vuetify/commit/043fff01e3554ffd0f3c7d848b9c9eb1f56457c2))
* **VCalendar:** add new component ([#6092](https://github.com/vuetifyjs/vuetify/issues/6092)) ([1f3dd1e](https://github.com/vuetifyjs/vuetify/commit/1f3dd1ebfa0e57a74e199d55f5b4fc8bead6c672))
* **VCalendar:** use $vuetify.lang.current as default language ([#6613](https://github.com/vuetifyjs/vuetify/issues/6613)) ([5bd9708](https://github.com/vuetifyjs/vuetify/commit/5bd97081c42176c5594a9fb6c8b70531c650240f))
* **VChip/Group:** add v-chip-group and update to md2 ([#6303](https://github.com/vuetifyjs/vuetify/issues/6303)) ([a317d8b](https://github.com/vuetifyjs/vuetify/commit/a317d8b246d05a2df7c681206f69df4dc2157ccd)), closes [#6270](https://github.com/vuetifyjs/vuetify/issues/6270) [#6279](https://github.com/vuetifyjs/vuetify/issues/6279) [#6286](https://github.com/vuetifyjs/vuetify/issues/6286) [#6297](https://github.com/vuetifyjs/vuetify/issues/6297) [#6299](https://github.com/vuetifyjs/vuetify/issues/6299) [#6301](https://github.com/vuetifyjs/vuetify/issues/6301) [#6302](https://github.com/vuetifyjs/vuetify/issues/6302)
* **VDataTable:** add row click event ([#7578](https://github.com/vuetifyjs/vuetify/issues/7578)) ([e3e494a](https://github.com/vuetifyjs/vuetify/commit/e3e494a3f310de249e34e6e2b5bd471c6e44e43e)), closes [#7491](https://github.com/vuetifyjs/vuetify/issues/7491)
* **VDataTable:** column filtering ([#7271](https://github.com/vuetifyjs/vuetify/issues/7271)) ([60a5a09](https://github.com/vuetifyjs/vuetify/commit/60a5a09658da679ce0c39ffa347a88cd64a169ae))
* **VDataTable:** enable customization of select/expand headers ([#7235](https://github.com/vuetifyjs/vuetify/issues/7235)) ([f047b6f](https://github.com/vuetifyjs/vuetify/commit/f047b6f59aa71c7e97b378d69552ffbfe67557a6)), closes [#3376](https://github.com/vuetifyjs/vuetify/issues/3376)
* **VDatePicker:** selected items count translation ([#7361](https://github.com/vuetifyjs/vuetify/issues/7361)) ([dac2af9](https://github.com/vuetifyjs/vuetify/commit/dac2af9a883853fe669812eb176c0108b4da317a)), closes [#7070](https://github.com/vuetifyjs/vuetify/issues/7070)
* **VDatePicker:** use $vuetify.lang.current ([#6320](https://github.com/vuetifyjs/vuetify/issues/6320)) ([814a372](https://github.com/vuetifyjs/vuetify/commit/814a3728f7eb86511296a6300fa11bfc9aba6d4b)), closes [#5618](https://github.com/vuetifyjs/vuetify/issues/5618)
* **VDivider:** adds a11y attributes ([#7708](https://github.com/vuetifyjs/vuetify/issues/7708)) ([83bc365](https://github.com/vuetifyjs/vuetify/commit/83bc365d8c6cb38cb766f82e0484bf7fb3668778))
* **VDivider:** update to md2 ([#6582](https://github.com/vuetifyjs/vuetify/issues/6582)) ([5adf0ea](https://github.com/vuetifyjs/vuetify/commit/5adf0ea04d380bca401721270e915886f7473ccf))
* **VFileInput:** add new component ([#7654](https://github.com/vuetifyjs/vuetify/issues/7654)) ([1d4dd66](https://github.com/vuetifyjs/vuetify/commit/1d4dd66d5591e2bca0c314320d1625d4a9281998)), closes [#238](https://github.com/vuetifyjs/vuetify/issues/238)
* **VGrid:** add grow-shrink-0 ([#6538](https://github.com/vuetifyjs/vuetify/issues/6538)) ([2db5690](https://github.com/vuetifyjs/vuetify/commit/2db569080a41c048e7a706d2730344d1be0bf0e6)), closes [#6530](https://github.com/vuetifyjs/vuetify/issues/6530)
* **VGrid:** pass down data-* attributes ([#6208](https://github.com/vuetifyjs/vuetify/issues/6208)) ([198a3d4](https://github.com/vuetifyjs/vuetify/commit/198a3d460cfb169d0333ec0ed4fec181aad3ef00))
* **VIcon:** Accessible icon button ([#7198](https://github.com/vuetifyjs/vuetify/issues/7198)) ([3e8d0ac](https://github.com/vuetifyjs/vuetify/commit/3e8d0ac8a6bb65a193f6f7d0895755f6d28a0cab)), closes [#4770](https://github.com/vuetifyjs/vuetify/issues/4770)
* **VIcon:** update to md2 ([#6439](https://github.com/vuetifyjs/vuetify/issues/6439)) ([aca9ba5](https://github.com/vuetifyjs/vuetify/commit/aca9ba5c0b1ebf463cd5b687901b59bc6511096d))
* **VItemGroup:** update to md2 ([#6631](https://github.com/vuetifyjs/vuetify/issues/6631)) ([2d6d90c](https://github.com/vuetifyjs/vuetify/commit/2d6d90c865e7da9ccf2809fcac26c0921471ae11))
* **VLabel:** update to md2 ([#6584](https://github.com/vuetifyjs/vuetify/issues/6584)) ([4dd4c9b](https://github.com/vuetifyjs/vuetify/commit/4dd4c9bddd171f245c843c2bb893175fd89b8b5d))
* **VList/Item/Group:** improve a11y ([#7651](https://github.com/vuetifyjs/vuetify/issues/7651)) ([5928b65](https://github.com/vuetifyjs/vuetify/commit/5928b651780d562b96cf2f3ebd396c3301da0fb2))
* **VMessages:** update to md2 ([#6585](https://github.com/vuetifyjs/vuetify/issues/6585)) ([30a174f](https://github.com/vuetifyjs/vuetify/commit/30a174f60e117d49bc092723c5937220844313b2))
* **VRating:** convert to md2 ([bc91c41](https://github.com/vuetifyjs/vuetify/commit/bc91c411da2fa26323ea48e375042f49bd373edd))
* **VSparkline:** render negative values in bar mode ([f8d180c](https://github.com/vuetifyjs/vuetify/commit/f8d180cd9891090a7acb9cafc3882f318b076d0a))
* **VTabs:** center-active prop ([#7238](https://github.com/vuetifyjs/vuetify/issues/7238)) ([bd4a873](https://github.com/vuetifyjs/vuetify/commit/bd4a873d1f6b891d71a196306ea426172cece142))
* **VTextField:** remove mask functionality ([#7304](https://github.com/vuetifyjs/vuetify/issues/7304)) ([0cecd4a](https://github.com/vuetifyjs/vuetify/commit/0cecd4a5dc3aed38470ba2a5cf4ab6672d306ac1))
* **VTextField:** update to md2 ([#7157](https://github.com/vuetifyjs/vuetify/issues/7157)) ([32c77ee](https://github.com/vuetifyjs/vuetify/commit/32c77ee07213c64dacfa6921b12003a96796a5f9))
* **VTreeview:** **color** prop ([#7617](https://github.com/vuetifyjs/vuetify/issues/7617)) ([b60b094](https://github.com/vuetifyjs/vuetify/commit/b60b0943e8fef9aede30075ac1f8507055a0243f)), closes [#7613](https://github.com/vuetifyjs/vuetify/issues/7613)
* **VTreeview:** **dense** prop, css tweaks ([#7518](https://github.com/vuetifyjs/vuetify/issues/7518)) ([3bdffae](https://github.com/vuetifyjs/vuetify/commit/3bdffaecf994df07be7146ab8606817a9a3b78d7)), closes [#7475](https://github.com/vuetifyjs/vuetify/issues/7475)
* **VTreeview:** **item-disabled** prop ([#7618](https://github.com/vuetifyjs/vuetify/issues/7618)) ([ae15ed8](https://github.com/vuetifyjs/vuetify/commit/ae15ed825837eac0134b336ed4219cc33faff9bb))
* **VTreeview:** **rounded**/**shaped** props ([#7616](https://github.com/vuetifyjs/vuetify/issues/7616)) ([acfdef7](https://github.com/vuetifyjs/vuetify/commit/acfdef7bec8dd521d2ea87382276c25f016fc84f)), closes [#7614](https://github.com/vuetifyjs/vuetify/issues/7614)
* **VTreeview:** add selectionType prop ([#7575](https://github.com/vuetifyjs/vuetify/issues/7575)) ([2ecec4a](https://github.com/vuetifyjs/vuetify/commit/2ecec4ab0d95b5c879334cb8871039d9638e39a5)), closes [#6903](https://github.com/vuetifyjs/vuetify/issues/6903)
* add arabic locale ([#6291](https://github.com/vuetifyjs/vuetify/issues/6291)) ([3c600da](https://github.com/vuetifyjs/vuetify/commit/3c600daa2cc29723bce5e78ed63249cc272761bc))
* add Japanese locale ([#6274](https://github.com/vuetifyjs/vuetify/issues/6274)) ([1a02856](https://github.com/vuetifyjs/vuetify/commit/1a02856cb35964bb7f234f22a97aec8ab1aa5349))
* add slovenian locale ([#6345](https://github.com/vuetifyjs/vuetify/issues/6345)) ([941389f](https://github.com/vuetifyjs/vuetify/commit/941389f24847ab80775f406e38393d3f00172864))
* add turkish locale ([#6384](https://github.com/vuetifyjs/vuetify/issues/6384)) ([20d2332](https://github.com/vuetifyjs/vuetify/commit/20d2332da0d13dea10c3a3a71fb65e6fe3d64d8b))
* create v-expand-x-transition ([e0efefe](https://github.com/vuetifyjs/vuetify/commit/e0efefe6f5c24559e63670d50b01d836fd42ce76))
* include helper json in built dist folder ([#7551](https://github.com/vuetifyjs/vuetify/issues/7551)) ([ce8538f](https://github.com/vuetifyjs/vuetify/commit/ce8538f8e1ab0b19967b4ce02355b885d4686280))
* **a-la-carte:** add type defs for vuetify/lib ([eb27425](https://github.com/vuetifyjs/vuetify/commit/eb27425806983591c2e6e09da3f45bb826a4c425))
* **activatable:** create new mixin ([#7037](https://github.com/vuetifyjs/vuetify/issues/7037)) ([553a0d8](https://github.com/vuetifyjs/vuetify/commit/553a0d8c1e5e98014451ef7d2253778712bbfec8))
* **bootable:** update for v2 ([#6735](https://github.com/vuetifyjs/vuetify/issues/6735)) ([5cc2d07](https://github.com/vuetifyjs/vuetify/commit/5cc2d07e4267066468b1695fe71637efceddd7bc))
* **locale:** add Hebrew locale files ([#6872](https://github.com/vuetifyjs/vuetify/issues/6872)) ([184512c](https://github.com/vuetifyjs/vuetify/commit/184512c69a112b0657156fc48571e5d760c23631))
* **theme:** add reactivity ([#6882](https://github.com/vuetifyjs/vuetify/issues/6882)) ([7261bdc](https://github.com/vuetifyjs/vuetify/commit/7261bdc3c0d3d54bc1de0b70cd45e7cda6320be9))
* **theme:** add setTheme and resetTheme methods ([6b4d2a9](https://github.com/vuetifyjs/vuetify/commit/6b4d2a9bc91a61dd6e41520f54841f901e855222))
* **typography:** change root font size, update caption rem size ([bee34ca](https://github.com/vuetifyjs/vuetify/commit/bee34ca3ba3fcbc176b35d0834e3efa7ba01a1f1))
* **typography:** update typography font weight to md2 ([#6653](https://github.com/vuetifyjs/vuetify/issues/6653)) ([1f8b620](https://github.com/vuetifyjs/vuetify/commit/1f8b620f101a56f90758b4362c271abd32af1a6c))
* **v-dialog:** adds click:outside call ([#6719](https://github.com/vuetifyjs/vuetify/issues/6719)) ([aa64854](https://github.com/vuetifyjs/vuetify/commit/aa648546aedaf0f7039e18bfb2708be07646196c))
* **VAppBar:** update application state on scrolling effects change ([358c62c](https://github.com/vuetifyjs/vuetify/commit/358c62ca4ce4512f2ef9b3f4694f9e541d9b0769)), closes [#3820](https://github.com/vuetifyjs/vuetify/issues/3820)
* **VBadge:** add support for more characters ([494bb28](https://github.com/vuetifyjs/vuetify/commit/494bb2833cb13e6d50280e63e5b972ab3c33e404)), closes [#4934](https://github.com/vuetifyjs/vuetify/issues/4934)
* **VCard:** update to md2 ([#6788](https://github.com/vuetifyjs/vuetify/issues/6788)) ([a63b300](https://github.com/vuetifyjs/vuetify/commit/a63b300842c191c65ed646b61bb6f3bf4388c588)), closes [#3925](https://github.com/vuetifyjs/vuetify/issues/3925)
* **VCarousel:** v2 update ([#6924](https://github.com/vuetifyjs/vuetify/issues/6924)) ([5c06f4d](https://github.com/vuetifyjs/vuetify/commit/5c06f4dfc58aab16c7011176b30260f7e6ac88d1)), closes [#6158](https://github.com/vuetifyjs/vuetify/issues/6158) [#6067](https://github.com/vuetifyjs/vuetify/issues/6067) [#6261](https://github.com/vuetifyjs/vuetify/issues/6261) [#6696](https://github.com/vuetifyjs/vuetify/issues/6696)
* **VExpansionPanel:** update to v2 ([#6720](https://github.com/vuetifyjs/vuetify/issues/6720)) ([f891304](https://github.com/vuetifyjs/vuetify/commit/f89130422fc0f328972ff2cedc72d42ad77cda2b)), closes [#6663](https://github.com/vuetifyjs/vuetify/issues/6663) [#6290](https://github.com/vuetifyjs/vuetify/issues/6290)
* **VFooter:** update for v2 ([#6711](https://github.com/vuetifyjs/vuetify/issues/6711)) ([959f074](https://github.com/vuetifyjs/vuetify/commit/959f07440fedb76473dedb71b1b0766d238a8531)), closes [#5444](https://github.com/vuetifyjs/vuetify/issues/5444) [#4872](https://github.com/vuetifyjs/vuetify/issues/4872)
* **VIcon:** Add 'tag' prop to VIcon that sets a custom tag to be used ([#6899](https://github.com/vuetifyjs/vuetify/issues/6899)) ([6504a7a](https://github.com/vuetifyjs/vuetify/commit/6504a7a8573d2881c8d9a459035375c86df85a58))
* **VIcon:** add svg path support and update default iconfont ([#6815](https://github.com/vuetifyjs/vuetify/issues/6815)) ([3997c53](https://github.com/vuetifyjs/vuetify/commit/3997c5394a1036ed0910e6c89523e1caf71c835e))
* **VIcon:** remove the need for svg- prefix ([#7019](https://github.com/vuetifyjs/vuetify/issues/7019)) ([e6a291d](https://github.com/vuetifyjs/vuetify/commit/e6a291dc86d8bd2adf3a895e63c2aad64eb17886))
* **VImg:** use inherent width from image ([#5788](https://github.com/vuetifyjs/vuetify/issues/5788)) ([09725fc](https://github.com/vuetifyjs/vuetify/commit/09725fc8f27d1ec543fced9236b033629c940b8c)), closes [#5757](https://github.com/vuetifyjs/vuetify/issues/5757)
* **VList:** add **rounded** prop ([fa8bb1b](https://github.com/vuetifyjs/vuetify/commit/fa8bb1b70c5853b9b23c9281f37862f5b06119ec))
* **VList:** add right padding for shaped list-items ([26a47a2](https://github.com/vuetifyjs/vuetify/commit/26a47a2fec0a15be1204e20be254b395c1a66cf5))
* **VList:** update to md2 ([#6648](https://github.com/vuetifyjs/vuetify/issues/6648)) ([afed09a](https://github.com/vuetifyjs/vuetify/commit/afed09acc90718f612e455b23c54ea1473273543)), closes [#4180](https://github.com/vuetifyjs/vuetify/issues/4180) [#3597](https://github.com/vuetifyjs/vuetify/issues/3597) [#6455](https://github.com/vuetifyjs/vuetify/issues/6455)
* **VListGroup:** add indent for **no-action** sub-groups ([79c9825](https://github.com/vuetifyjs/vuetify/commit/79c98251c809f8fae088deecd80108dc003de556))
* **VNavigationDrawer:** update to md2 ([#6947](https://github.com/vuetifyjs/vuetify/issues/6947)) ([f8a6c20](https://github.com/vuetifyjs/vuetify/commit/f8a6c20deaa07efca2aec5ae08c1a93515d26a5b)), closes [#6283](https://github.com/vuetifyjs/vuetify/issues/6283) [#3919](https://github.com/vuetifyjs/vuetify/issues/3919) [#6926](https://github.com/vuetifyjs/vuetify/issues/6926) [#2606](https://github.com/vuetifyjs/vuetify/issues/2606) [#4233](https://github.com/vuetifyjs/vuetify/issues/4233) [#6652](https://github.com/vuetifyjs/vuetify/issues/6652)
* **VOverlay:** create new component ([#6768](https://github.com/vuetifyjs/vuetify/issues/6768)) ([69b15cf](https://github.com/vuetifyjs/vuetify/commit/69b15cf0ee9d5d3c7b52016a71c4e185f22c4d4b))
* **VProgressLinear:** update to md2 ([#7057](https://github.com/vuetifyjs/vuetify/issues/7057)) ([fa69676](https://github.com/vuetifyjs/vuetify/commit/fa69676d1b136723ee6e7617f94e7937dd951d95)), closes [#5147](https://github.com/vuetifyjs/vuetify/issues/5147)
* **VSlider:** update to md2 spec ([#6424](https://github.com/vuetifyjs/vuetify/issues/6424)) ([5e7b72f](https://github.com/vuetifyjs/vuetify/commit/5e7b72ffdd4e3d4a343e29f2bb6c0c017a29636a)), closes [#5650](https://github.com/vuetifyjs/vuetify/issues/5650)
* **VSwitch:** update to md2 ([#6851](https://github.com/vuetifyjs/vuetify/issues/6851)) ([72b5895](https://github.com/vuetifyjs/vuetify/commit/72b58953037f59d2925bc6b22b703a4e119e9d3d))
* **VTabs:** update to md2 ([#6606](https://github.com/vuetifyjs/vuetify/issues/6606)) ([f22d754](https://github.com/vuetifyjs/vuetify/commit/f22d754e4eac04b1266b406137242af3fd14f4f3)), closes [#6575](https://github.com/vuetifyjs/vuetify/issues/6575) [#5398](https://github.com/vuetifyjs/vuetify/issues/5398) [#6505](https://github.com/vuetifyjs/vuetify/issues/6505) [#3971](https://github.com/vuetifyjs/vuetify/issues/3971) [#4420](https://github.com/vuetifyjs/vuetify/issues/4420)
* **VTimeline:** add reverse functionality, convert to md2 ([#6656](https://github.com/vuetifyjs/vuetify/issues/6656)) ([deb3e3d](https://github.com/vuetifyjs/vuetify/commit/deb3e3d2f4e250a19925c3ab83c61d24146b9fd8)), closes [#5437](https://github.com/vuetifyjs/vuetify/issues/5437)
* **VTimePicker:** update to md2 ([#6869](https://github.com/vuetifyjs/vuetify/issues/6869)) ([da54462](https://github.com/vuetifyjs/vuetify/commit/da54462f7003c085e0e2945832b87692807c840d))
* add Latvian locale ([#6784](https://github.com/vuetifyjs/vuetify/issues/6784)) ([ee1ac86](https://github.com/vuetifyjs/vuetify/commit/ee1ac86680a02649082c400428c77c60cb635893))
* **VToolbar/VAppBar:** update to md2 spec ([#6701](https://github.com/vuetifyjs/vuetify/issues/6701)) ([fc8c2ed](https://github.com/vuetifyjs/vuetify/commit/fc8c2ede01c380a0053a26bd91d752ae8c55f92f)), closes [#5369](https://github.com/vuetifyjs/vuetify/issues/5369) [#3938](https://github.com/vuetifyjs/vuetify/issues/3938) [#4985](https://github.com/vuetifyjs/vuetify/issues/4985)
* restructure core, add services ([#6464](https://github.com/vuetifyjs/vuetify/issues/6464)) ([09c2617](https://github.com/vuetifyjs/vuetify/commit/09c26170d9ddf9a4e3f80ff1b2cd429b29d3404d))
* **detachable:** add activator scoped slot ([#5318](https://github.com/vuetifyjs/vuetify/issues/5318)) ([a025093](https://github.com/vuetifyjs/vuetify/commit/a0250938d07b54b76f8e99bd4c68f880f706ef2c)), closes [#2489](https://github.com/vuetifyjs/vuetify/issues/2489) [#3030](https://github.com/vuetifyjs/vuetify/issues/3030) [#3107](https://github.com/vuetifyjs/vuetify/issues/3107) [#4428](https://github.com/vuetifyjs/vuetify/issues/4428) [#5193](https://github.com/vuetifyjs/vuetify/issues/5193)
* **drawer:** update drawer structure ([9a03bac](https://github.com/vuetifyjs/vuetify/commit/9a03bac8a85c0cd917b13ad1b3f0cae328c71b1e))
* **home-page:** update structure ([34f584e](https://github.com/vuetifyjs/vuetify/commit/34f584e59c14f597fcde32ffc69f6e320c01aeb2))
* **kitchen:** add avatars ([ba7790a](https://github.com/vuetifyjs/vuetify/commit/ba7790a5cd5e8ae457ae888315d004a4885157b4))
* **kitchen:** add home page ([878369b](https://github.com/vuetifyjs/vuetify/commit/878369baa90a8313d68ff57e11d71e89d85c8eb3))
* **kitchen:** add more avatar sizes ([ceb811b](https://github.com/vuetifyjs/vuetify/commit/ceb811b6ab4f9d3f4d00fe1a5df91f43d85f84ca))
* **kitchen:** add parallax pan ([26e88a8](https://github.com/vuetifyjs/vuetify/commit/26e88a80e06ac4d4c69a737e65bcdaec8b39336b))
* **kitchen:** add VChip ([387f12e](https://github.com/vuetifyjs/vuetify/commit/387f12ed64c9f61236f2b4533ba932762e701fe5))
* **kitchen:** add VSparkline pan ([a60a584](https://github.com/vuetifyjs/vuetify/commit/a60a584c77fc317ac7e93b371364b2eb302228a3))
* **List:** improve aria support ([#5671](https://github.com/vuetifyjs/vuetify/issues/5671)) ([3024566](https://github.com/vuetifyjs/vuetify/commit/3024566ab5d1aa980a83289e1530844a6d64392c)), closes [#5667](https://github.com/vuetifyjs/vuetify/issues/5667)
* **locale:** add Estonian translation ([#5995](https://github.com/vuetifyjs/vuetify/issues/5995)) ([5e7afd4](https://github.com/vuetifyjs/vuetify/commit/5e7afd44a9ec1a7cf01cb3393700f70b38a4e43b))
* **measurable:** add min width and height props ([c8ecf7f](https://github.com/vuetifyjs/vuetify/commit/c8ecf7fb81ac18f1fdea764c4d06d344780d0bc2))
* **playground:** add new package ([80dcce1](https://github.com/vuetifyjs/vuetify/commit/80dcce1f2d446df326fb32f8bad26c7cb48c45d3))
* **styles:** converted base vbtn styles ([a1fec67](https://github.com/vuetifyjs/vuetify/commit/a1fec67c51d36a17788b8d4819a5ef561719e935))
* **Theme:** change default warning color ([e0888d3](https://github.com/vuetifyjs/vuetify/commit/e0888d37be0a571884075aee626c9931a0eb8623)), closes [#1693](https://github.com/vuetifyjs/vuetify/issues/1693)
* **Typography:** add text-transform: none helper class ([0902491](https://github.com/vuetifyjs/vuetify/commit/0902491aa61c6e652bfde7c779828c579559b6c8)), closes [#5503](https://github.com/vuetifyjs/vuetify/issues/5503)
* **VAutocomplete:** add autoSelectFirst prop ([#4208](https://github.com/vuetifyjs/vuetify/issues/4208)) ([3c807b6](https://github.com/vuetifyjs/vuetify/commit/3c807b662aa39928c9083c768a5cc79ae2dcdf0d)), closes [#4207](https://github.com/vuetifyjs/vuetify/issues/4207)
* **VBtn:** convert to md2 ([18c8355](https://github.com/vuetifyjs/vuetify/commit/18c8355ece3c539211ef511c7368959b662a6045))
* **VBtnToggle:** convert to sass ([3e44471](https://github.com/vuetifyjs/vuetify/commit/3e44471486119a8fc243067b041d7e577504ab34))
* **VDatePicker:** month events ([#5502](https://github.com/vuetifyjs/vuetify/issues/5502)) ([64c0427](https://github.com/vuetifyjs/vuetify/commit/64c0427a72903f908c4615e50538acc241bcf20b)), closes [#5113](https://github.com/vuetifyjs/vuetify/issues/5113)
* **VDatePicker:** mouse events - click/dblclick ([#5832](https://github.com/vuetifyjs/vuetify/issues/5832)) ([3139768](https://github.com/vuetifyjs/vuetify/commit/3139768c69a481044f6ecbfbbfddf93efda21e69)), closes [#3023](https://github.com/vuetifyjs/vuetify/issues/3023) [#4884](https://github.com/vuetifyjs/vuetify/issues/4884)
* **VDatePicker:** multiple event indicators ([#5512](https://github.com/vuetifyjs/vuetify/issues/5512)) ([1d6737b](https://github.com/vuetifyjs/vuetify/commit/1d6737b87048042ad6aec8f9c92c4520ce471b19))
* **VDatePicker:** show week number ([#5678](https://github.com/vuetifyjs/vuetify/issues/5678)) ([6007897](https://github.com/vuetifyjs/vuetify/commit/6007897e6e7ceb12b0d5f60f5461f3459c68d260)), closes [#5077](https://github.com/vuetifyjs/vuetify/issues/5077)
* **VIcon:** add svg support ([#4910](https://github.com/vuetifyjs/vuetify/issues/4910)) ([6c0b89d](https://github.com/vuetifyjs/vuetify/commit/6c0b89d30ba624030d71034b71bf4e456f8c8e7c))
* **VImg:** use inherent width from image ([#5783](https://github.com/vuetifyjs/vuetify/issues/5783)) ([98fa2ed](https://github.com/vuetifyjs/vuetify/commit/98fa2ed5a66ea883a27b144422405f1bb40a8b61)), closes [#5757](https://github.com/vuetifyjs/vuetify/issues/5757)
* **VMenu:** disable-keys prop ([#5138](https://github.com/vuetifyjs/vuetify/issues/5138)) ([d6b3297](https://github.com/vuetifyjs/vuetify/commit/d6b32973f92bb73971e584bcfb5e611add3e8ca4)), closes [#5103](https://github.com/vuetifyjs/vuetify/issues/5103)
* **VProgressLinear:** add support for content inside progress bar ([#6126](https://github.com/vuetifyjs/vuetify/issues/6126)) ([7d357e8](https://github.com/vuetifyjs/vuetify/commit/7d357e80449136e2ecbd272207da42a1df0e116f)), closes [#3768](https://github.com/vuetifyjs/vuetify/issues/3768)
* **VSelect:** replicate html select hotkeys ([#6086](https://github.com/vuetifyjs/vuetify/issues/6086)) ([dd9cd63](https://github.com/vuetifyjs/vuetify/commit/dd9cd6343fb64f95d5a6972a9f4690ea59fb923b)), closes [#4853](https://github.com/vuetifyjs/vuetify/issues/4853)
* **VSlideGroup:** create new component ([#6240](https://github.com/vuetifyjs/vuetify/issues/6240)) ([7026f34](https://github.com/vuetifyjs/vuetify/commit/7026f3451aff2279857ac1f7a1ba6012a1e596dc))
* **VSparkline:** add bar type ([#6080](https://github.com/vuetifyjs/vuetify/issues/6080)) ([3f17eab](https://github.com/vuetifyjs/vuetify/commit/3f17eabcdf2c3b25bb0b0ec8c607bfc5b5aa887c))
* **VSparkline:** add fill property ([#6132](https://github.com/vuetifyjs/vuetify/issues/6132)) ([54c3f83](https://github.com/vuetifyjs/vuetify/commit/54c3f839a000c7a918d0933cfa2d6fafbcc97508))
* **VTimePicker:** emit click:xxx events ([#6321](https://github.com/vuetifyjs/vuetify/issues/6321)) ([58c45b0](https://github.com/vuetifyjs/vuetify/commit/58c45b078c3199e32df1d3023780c5563dabbe34)), closes [#6163](https://github.com/vuetifyjs/vuetify/issues/6163)
* **VTreeItem:** add itemFilter prop, remove customFilter prop ([#6349](https://github.com/vuetifyjs/vuetify/issues/6349)) ([ba35207](https://github.com/vuetifyjs/vuetify/commit/ba352075339d93dd25696db33d76eb52ede9992c))
* **VTreeview:** add return-object prop ([#6064](https://github.com/vuetifyjs/vuetify/issues/6064)) ([65317e5](https://github.com/vuetifyjs/vuetify/commit/65317e56fe76a954ef3be22fd7d1dbf14899cbe8)), closes [#5881](https://github.com/vuetifyjs/vuetify/issues/5881)
* **VTreeview:** add search functionality ([#6124](https://github.com/vuetifyjs/vuetify/issues/6124)) ([75bbcc5](https://github.com/vuetifyjs/vuetify/commit/75bbcc5cbf1090c99393fa69355000f98edbe2ef)), closes [#5621](https://github.com/vuetifyjs/vuetify/issues/5621)
* **VTreeview:** updateAll public method ([#6363](https://github.com/vuetifyjs/vuetify/issues/6363)) ([3fb72ba](https://github.com/vuetifyjs/vuetify/commit/3fb72ba4407bfc2d2ec2ede055d5176d3cd40696))
* add Afrikaans locale ([#5385](https://github.com/vuetifyjs/vuetify/issues/5385)) ([62f7bb3](https://github.com/vuetifyjs/vuetify/commit/62f7bb31e8da898d8c404b3f93de6a63a5d6319e))
* add croatian locale ([#6125](https://github.com/vuetifyjs/vuetify/issues/6125)) ([267ecca](https://github.com/vuetifyjs/vuetify/commit/267ecca2a9717d50b5e7cb3039bc98191da86ece))
* add d-none helper class ([#5396](https://github.com/vuetifyjs/vuetify/issues/5396)) ([3242321](https://github.com/vuetifyjs/vuetify/commit/32423213930c249635740c9b8a46cf9256f2a56f))
* add display breakpoints for printing ([#5747](https://github.com/vuetifyjs/vuetify/issues/5747)) ([d1e3f7d](https://github.com/vuetifyjs/vuetify/commit/d1e3f7d5c1361c52da4d525a7bbc9790934a8bb0))
* add how to async load fonts ([#5473](https://github.com/vuetifyjs/vuetify/issues/5473)) ([da0cdec](https://github.com/vuetifyjs/vuetify/commit/da0cdec9a4a0a7282e402530b28a56a2f017aaf2))
* add spanish locale ([#5359](https://github.com/vuetifyjs/vuetify/issues/5359)) ([dd3f7c8](https://github.com/vuetifyjs/vuetify/commit/dd3f7c8f6a02885dd9f9160a07829659ee105baf))
* added back missing treeview page ([b2a6102](https://github.com/vuetifyjs/vuetify/commit/b2a6102edd6304ad6562e7d09d4065a20401759f))
* locales index ([#5425](https://github.com/vuetifyjs/vuetify/issues/5425)) ([6b501c2](https://github.com/vuetifyjs/vuetify/commit/6b501c294410e2826ebf1f355d386ca5f4b7ad09))
* override breakpoint thresholds ([#5666](https://github.com/vuetifyjs/vuetify/issues/5666)) ([4906f03](https://github.com/vuetifyjs/vuetify/commit/4906f03297d1bd28bc919dac441b2ecc1f0ff18f))
* update tooltip design ([#6111](https://github.com/vuetifyjs/vuetify/issues/6111)) ([2d2312a](https://github.com/vuetifyjs/vuetify/commit/2d2312a220713c88484a03532e8cebae98dd0d45))
* update typography to md2 ([#6644](https://github.com/vuetifyjs/vuetify/issues/6644)) ([71e9dd1](https://github.com/vuetifyjs/vuetify/commit/71e9dd1e487339d3b123029df2da9368ed893618))
* **$docs:** updated home-page, updated backers ([1acd46d](https://github.com/vuetifyjs/vuetify/commit/1acd46d25bfff3cfacf500aa178778451c58c0f1))
* **$home-page:** changed layout ([4398494](https://github.com/vuetifyjs/vuetify/commit/43984945c061dc102b097eebed19ccbb5c03bbfd))
* **$license:** added LICENSE.md ([00b1da4](https://github.com/vuetifyjs/vuetify/commit/00b1da427b544ab20f9237de6813f4949cc3db37)), closes [#333](https://github.com/vuetifyjs/vuetify/issues/333)
* **ad:** change ad service to codefund ([4e5567c](https://github.com/vuetifyjs/vuetify/commit/4e5567cf4c6493bf0cdca7c53cdf82e5fe70446d))
* **ad-interface:** upgrade ad and toc functionality ([08bc7bc](https://github.com/vuetifyjs/vuetify/commit/08bc7bc9df9b436b46f970389218e17467e33bda))
* **alacarte:** update guide for 1.3 and vuetify-loader ([3e6bcd1](https://github.com/vuetifyjs/vuetify/commit/3e6bcd1fa79ce3cffb9d65b7eb76b23e8617d323))
* **api-generator:** update paths ([2276e6e](https://github.com/vuetifyjs/vuetify/commit/2276e6e738f08d941487f882ea4a7c8833683821))
* **app:** add examples, new paths/functionality for drawer ([0566235](https://github.com/vuetifyjs/vuetify/commit/0566235c9115e0ff890e5c66b47b36437de2e5c3))
* **app:** changed toolbar behavior, moved snackbar ([30e03fb](https://github.com/vuetifyjs/vuetify/commit/30e03fb597d5f1501640cb20015f54bb71a4e596))
* **app:** improve mobile experience ([c13309e](https://github.com/vuetifyjs/vuetify/commit/c13309ec898bc86d9ada33deaad6c6c85c879ac0))
* **app:** update snackbar ([d90a68e](https://github.com/vuetifyjs/vuetify/commit/d90a68efe9a9ce9a71e5391b67c10351f79e5cdb))
* **app-toolbar:** add dynamic sale tag ([f1b1827](https://github.com/vuetifyjs/vuetify/commit/f1b1827de4efcd1deff5db786f4c6df77a42dc85))
* **application-layout:** move patrons ([244d772](https://github.com/vuetifyjs/vuetify/commit/244d772aabbe832548bf2696716e97961f659e87))
* **assets:** change image locations ([d06620a](https://github.com/vuetifyjs/vuetify/commit/d06620a0b491ffd1be566d2315989d55ae189188))
* **at-a-glance:** added component api page ([c00aee8](https://github.com/vuetifyjs/vuetify/commit/c00aee8ebef37b62ba201f0f2b9f9856fee2f80b))
* **backer:** add digital-maas ([cfc2200](https://github.com/vuetifyjs/vuetify/commit/cfc2200384a42bf9443f66a75c21ab2cb63ec4cf))
* **build:** create separate entry for /lib, flatten components export ([0646cfe](https://github.com/vuetifyjs/vuetify/commit/0646cfed9fc4c0ae175efbdb8419098f2b5afd12))
* **cta:** add sale to cta ([be3ace5](https://github.com/vuetifyjs/vuetify/commit/be3ace55d954a1628a421957b3dc4c40156ad990))
* **deployment:** added automatic ci deployment ([28ab126](https://github.com/vuetifyjs/vuetify/commit/28ab126ef757625389f9a960726562362ac866ec))
* **docs:** move hashes around ([5d94491](https://github.com/vuetifyjs/vuetify/commit/5d944910b1c343db9e72259fb3efcfd9eb42da6d))
* **dynamic-async:** make components dynamic and async ([5d3def0](https://github.com/vuetifyjs/vuetify/commit/5d3def088a614f4baaec1f749f80e66bf69d525c))
* **ecosystem:** added reddit ([ed93b33](https://github.com/vuetifyjs/vuetify/commit/ed93b339c45146cbcbd37b2bf32bd194bc6f4240))
* **elevatable:** create new mixin ([85f249c](https://github.com/vuetifyjs/vuetify/commit/85f249cfdcc0eaceb29cfc4bfec48a7217e65cdd))
* **fakeComponents:** generate .js and .ts ([5f6cfda](https://github.com/vuetifyjs/vuetify/commit/5f6cfdace411ad820f549d84d86fe19e3c7d18ea))
* **flags:** add mx flag ([1c700b3](https://github.com/vuetifyjs/vuetify/commit/1c700b3586c653bb07e31f9dbefd7091317a95c0))
* **flags:** move to cdn ([b9a8345](https://github.com/vuetifyjs/vuetify/commit/b9a8345819870a05816a981da5f0c8b6ba6de7bf))
* **framework/icons:** add fontawesome info ([463951c](https://github.com/vuetifyjs/vuetify/commit/463951c93538fa385b2ee22482e3cf747cb80e9b)), closes [#509](https://github.com/vuetifyjs/vuetify/issues/509)
* **gitignore:** ignore yarn-error files ([9be53b2](https://github.com/vuetifyjs/vuetify/commit/9be53b2a82e0a0ad5682e7778b1c05a500dfa291))
* **groupable:** turn into factory function ([6f2f73e](https://github.com/vuetifyjs/vuetify/commit/6f2f73eca2eec5d79324accba73784b6c61fdfd9))
* **img:** optimized image ([47a9b5e](https://github.com/vuetifyjs/vuetify/commit/47a9b5e69cb43cfd84ddbfc4c83039331a42bb74))
* **layouts:** added codepens ([4d321d8](https://github.com/vuetifyjs/vuetify/commit/4d321d8dcc47e8f05bd91e7359423d9611a913db)), closes [#157](https://github.com/vuetifyjs/vuetify/issues/157)
* **package.json:** add setup script ([3d34450](https://github.com/vuetifyjs/vuetify/commit/3d344502c390f6f0aaf19c85bca762b9de18b5cd))
* added moment and date-fns examples ([#650](https://github.com/vuetifyjs/vuetify/issues/650)) ([fccac58](https://github.com/vuetifyjs/vuetify/commit/fccac581e1f14cd91f66fc057814974d87a157e6)), closes [#218](https://github.com/vuetifyjs/vuetify/issues/218)
* fake components generator for webstorm ([969c404](https://github.com/vuetifyjs/vuetify/commit/969c4040eeb82fd68e917adca3c25ecfd674fbda)), closes [vuetifyjs/vuetify#4590](https://github.com/vuetifyjs/vuetify/issues/4590)
* **groups:** update group pages ([14727c3](https://github.com/vuetifyjs/vuetify/commit/14727c308ad70a17d6f34a774b97d495c566433a))
* **patrons:** updated supporters ([9b5b8ad](https://github.com/vuetifyjs/vuetify/commit/9b5b8ad3079014094da1324148c3bf6c0b6686d3))
* **pm2:** add process file ([b0be640](https://github.com/vuetifyjs/vuetify/commit/b0be64011de7d160046057d0706653dd06b9c30d))
* **product-images:** update src ([e0e0bf4](https://github.com/vuetifyjs/vuetify/commit/e0e0bf4a77fcf066088914b699471856a911795e))
* **progress:** added missing language ([4019796](https://github.com/vuetifyjs/vuetify/commit/4019796dc10c91ac2dee84ceb42e570dc8944a31))
* **roadmap:** mark v1.3 as complete ([f516bbe](https://github.com/vuetifyjs/vuetify/commit/f516bbe469fef4dde0f19796e4fa4569535296a9))
* **roadmap:** update roadmap ([4ab1a69](https://github.com/vuetifyjs/vuetify/commit/4ab1a69397efbc93482c54d73d013231f5f16a3f))
* **snackbar:** update app snack ([1120e62](https://github.com/vuetifyjs/vuetify/commit/1120e6202308dd69a39bce60bc6e3e9ab122f8a8))
* **snackbar:** update message ([3ed32a4](https://github.com/vuetifyjs/vuetify/commit/3ed32a4737f119d4e49458fb12a9ffbcff70e48d))
* **toolbar:** add v1 link ([5a07151](https://github.com/vuetifyjs/vuetify/commit/5a0715105400778c92141cda192cfeb2219a10ff))
* **v-hover:** add mappings ([63cab04](https://github.com/vuetifyjs/vuetify/commit/63cab04f01ea6f59c9cd2725bf1d5b0c9e45bee1))
* add a-la-carte limitations section ([0fde3a0](https://github.com/vuetifyjs/vuetify/commit/0fde3a082e135ec171dcc3045ee35de4ef9f548e))
* add esm build, enable sideEffects ([c3c61a9](https://github.com/vuetifyjs/vuetify/commit/c3c61a9fab5dc286b476cbf1e244cee190ac8b1f))
* add hreflang meta tags ([db06523](https://github.com/vuetifyjs/vuetify/commit/db06523101931ea7340935cd79537f213be8c440))
* added $vuetify object to api.js output ([62211ec](https://github.com/vuetifyjs/vuetify/commit/62211ec057183c118bbc1e4ac7668633869c235d))
* added source property to output ([b412c20](https://github.com/vuetifyjs/vuetify/commit/b412c203fd1510167546d6128634677166dbeb22))
* added tags/attributes output ([eeee218](https://github.com/vuetifyjs/vuetify/commit/eeee2185ca09741cdcd9aa365943c56be5861551))
* allow users to cache html responses ([53a240e](https://github.com/vuetifyjs/vuetify/commit/53a240ee012bcc71a90795367e8bdff1b7ade4a0))
* parse extended components ([d7df5f8](https://github.com/vuetifyjs/vuetify/commit/d7df5f841a2bea2774d80be4902434f0b9b9e07c))
* parse wrapped components and ExtendedVue mixins ([daa44c3](https://github.com/vuetifyjs/vuetify/commit/daa44c339aa8671f523f02c447ffc37b9a16dd1d))
* **a-la-carte:** Enable global single components in plugin ([#4667](https://github.com/vuetifyjs/vuetify/issues/4667)) ([765c5c2](https://github.com/vuetifyjs/vuetify/commit/765c5c21d85a6e2dd9ab856e2f2c64c563fe6856))
* **backers:** update current sponsors/backers ([61cbd22](https://github.com/vuetifyjs/vuetify/commit/61cbd22f9266c2484dff17059b5e6289466b6cfb))
* **colorable:** convert to ts ([77c9598](https://github.com/vuetifyjs/vuetify/commit/77c95981cd076075429988286d96a7d63325feff))
* **colorable:** hex colors ([#4342](https://github.com/vuetifyjs/vuetify/issues/4342)) ([29e05dc](https://github.com/vuetifyjs/vuetify/commit/29e05dc0e14c5434c9d70108fb9dd14f8accaad9)), closes [#3416](https://github.com/vuetifyjs/vuetify/issues/3416)
* **components-index:** convert to ts ([db4c8f1](https://github.com/vuetifyjs/vuetify/commit/db4c8f1e9863542f5acae63795d831281a3e6002))
* **dependent:** convert to ts ([9ff9b47](https://github.com/vuetifyjs/vuetify/commit/9ff9b475073e5bd3a15a2ad4fc69f4b129d73833))
* **filterable:** convert to ts ([a2d344f](https://github.com/vuetifyjs/vuetify/commit/a2d344fccc0b70bc589a6ad9e1d83e03447841aa))
* **helper-classes:** added missing helper classes ([0ed01dd](https://github.com/vuetifyjs/vuetify/commit/0ed01ddc00042bf166d66221b3c3a915925aa56a))
* **locale:** chinese ([#4747](https://github.com/vuetifyjs/vuetify/issues/4747)) ([ce15db7](https://github.com/vuetifyjs/vuetify/commit/ce15db7e143b0df59b4d44bc30cde8476f69840f))
* **locale:** farsi ([#4903](https://github.com/vuetifyjs/vuetify/issues/4903)) ([342774b](https://github.com/vuetifyjs/vuetify/commit/342774b70360ac500aa7647c2e922f6eab8e286b))
* **measurable:** add new mixin ([b6c34b7](https://github.com/vuetifyjs/vuetify/commit/b6c34b70a33f234946bb12d44a6e18077e37f7b4))
* **proxyable:** create new mixin ([0a2e9ca](https://github.com/vuetifyjs/vuetify/commit/0a2e9cabe52ade10e4e372425ad92e1aff6f2d55))
* **returnable:** convert to ts ([a90b427](https://github.com/vuetifyjs/vuetify/commit/a90b427dec39273fb225ddb09cd16fcfbbf92604))
* **roadmap:** update language ([7f5984d](https://github.com/vuetifyjs/vuetify/commit/7f5984d8d2b86cd08b9a7a804ade77d9ced8c34f))
* **selection-controls:** use native input change event ([#4804](https://github.com/vuetifyjs/vuetify/issues/4804)) ([e32e48d](https://github.com/vuetifyjs/vuetify/commit/e32e48d699839b2587290f7471ebe83c27c456c8)), closes [#4627](https://github.com/vuetifyjs/vuetify/issues/4627)
* **snackbar:** added new message ([21c1328](https://github.com/vuetifyjs/vuetify/commit/21c1328785f70c880d511ed9f55015d10f87d9a9))
* **snackbar:** update msg ([5462b21](https://github.com/vuetifyjs/vuetify/commit/5462b2177459adaf2ca10ee0ad5f197de8c793aa))
* **snackbar:** updated snackbar ([87fb339](https://github.com/vuetifyjs/vuetify/commit/87fb33909acf11bb9500323331246b65af5ac39a))
* **sponsors-and-backers:** added patron ([2bd680c](https://github.com/vuetifyjs/vuetify/commit/2bd680cfc1bebea36a899f982450a1f8fe124bb1))
* **store:** add loader to front ([cc912b5](https://github.com/vuetifyjs/vuetify/commit/cc912b515671d4c1dce670fd00865a17b5a5d869))
* **store:** added banner ([7ce2b1a](https://github.com/vuetifyjs/vuetify/commit/7ce2b1a0c029fdadcf6a1da588068f4d331bd30f))
* **store:** added sale chips, carousel ([6bdab08](https://github.com/vuetifyjs/vuetify/commit/6bdab08cec585c97e84e4e857031080a1716ee2e))
* **store:** update front-page ([a32fb28](https://github.com/vuetifyjs/vuetify/commit/a32fb28d916bded481f924614eb39487bb9f3522))
* **store:** update product-page ([ba51ed9](https://github.com/vuetifyjs/vuetify/commit/ba51ed993674a4dcd0771573a8c815e9ed6773ab))
* **store-images:** update angryman ([54c6988](https://github.com/vuetifyjs/vuetify/commit/54c6988c02af6c0380629b1ed663c1d5a4c124dd))
* **store-toolbar:** add dynamic cart icon ([b70075c](https://github.com/vuetifyjs/vuetify/commit/b70075cfb8d6dfe61d8ad1a8accb3c0596a058e3))
* **text-fields:** updated language ([9ebd29c](https://github.com/vuetifyjs/vuetify/commit/9ebd29cd706bcf0be0787d424deb653eb71c571d))
* **tidelift:** add tidelift to homepage ([5a98d9e](https://github.com/vuetifyjs/vuetify/commit/5a98d9ed3f29110fc8dff462b1167607a644609f))
* **typography:** add font weights ([c287461](https://github.com/vuetifyjs/vuetify/commit/c28746125e15a039baf72963600936bcb33c8a04))
* **v-navigation-drawer:** added nested example ([91328ff](https://github.com/vuetifyjs/vuetify/commit/91328ff28e9eec15ea20858d23cf556944f17f6b))
* **v-navigation-drawer:** added new example ([34e0dea](https://github.com/vuetifyjs/vuetify/commit/34e0dea4064f3d0e873e78e34de8a4b7bfd58e69))
* **v-slider:** add new example ([642d02c](https://github.com/vuetifyjs/vuetify/commit/642d02c83dff50df0b49c9b95062f4a44b377653))
* **v-slider:** update language for metronome example ([d8c5e47](https://github.com/vuetifyjs/vuetify/commit/d8c5e4786407c7fdd48ae887d0afc2f35f83886e))
* **v-textarea:** add new example ([2f060af](https://github.com/vuetifyjs/vuetify/commit/2f060afc30c0ed2dc2410db075c97648a27d16ab))
* **v-timeline:** add doc page ([#595](https://github.com/vuetifyjs/vuetify/issues/595)) ([2742d21](https://github.com/vuetifyjs/vuetify/commit/2742d21b1f6023d40a31caf7664d27aca871dbba))
* **v-treeview:** add new example ([#615](https://github.com/vuetifyjs/vuetify/issues/615)) ([2aa735f](https://github.com/vuetifyjs/vuetify/commit/2aa735f12703c5f2bceeb05b74cfa8a890a11456))
* **v-treeview:** update page/add examples ([f893a08](https://github.com/vuetifyjs/vuetify/commit/f893a080a6ee99aa96c04d414b2e496f68471b7e))
* **vue-markdown:** dynamically load ([0731cc5](https://github.com/vuetifyjs/vuetify/commit/0731cc5407e2da52216c066df812d0484411563c))
* added support for functions in api section ([f027922](https://github.com/vuetifyjs/vuetify/commit/f027922778e0dff4043205fc55a4908415773b19))
* **faq:** added markdown support ([5c80a5b](https://github.com/vuetifyjs/vuetify/commit/5c80a5bca2956b726b782a5b7cb74c215bfbb07e)), closes [#148](https://github.com/vuetifyjs/vuetify/issues/148)
* ThemeGenerator now exports using color names instead of hex ([0046937](https://github.com/vuetifyjs/vuetify/commit/00469370903601ea6ebf1d27354e9dafc5cc5ce0))
* **quick-start:** started to setup page ([29d6ac3](https://github.com/vuetifyjs/vuetify/commit/29d6ac3906d1890d8a1980a813844d380158be93))
* **repository:** convert to mono-repo ([bb3ef96](https://github.com/vuetifyjs/vuetify/commit/bb3ef969b0bbfda631219822c315d572bdaff6fe))
* **selection-controls:** overwrite selection control container width ([caace72](https://github.com/vuetifyjs/vuetify/commit/caace7224fc316b135fca206bfaf7987ee5c0438))
* **theme:** accept color objects ([#4751](https://github.com/vuetifyjs/vuetify/issues/4751)) ([1617c38](https://github.com/vuetifyjs/vuetify/commit/1617c38ce89f521b123ef9a269160d787207a8b0)), closes [#4408](https://github.com/vuetifyjs/vuetify/issues/4408)
* **theme:** css vars ([#4774](https://github.com/vuetifyjs/vuetify/issues/4774)) ([dabaaa9](https://github.com/vuetifyjs/vuetify/commit/dabaaa941f6fa8edaee511ef2dcd9913c1d066d8))
* **themeable:** use provide/inject ([#4386](https://github.com/vuetifyjs/vuetify/issues/4386)) ([22a5a29](https://github.com/vuetifyjs/vuetify/commit/22a5a29d9520b158c0de5afd7bbd3de980b5b05d))
* **transitions:** improve interaction with groups ([bca41c6](https://github.com/vuetifyjs/vuetify/commit/bca41c6f03f0a6392ff78a049789e5c41beed228))
* **transitions:** spring cleaning ([8a4b59d](https://github.com/vuetifyjs/vuetify/commit/8a4b59d21b1e5853094a14cf46940c822387547b))
* **types:** add definitions for vuetify/lib ([7085754](https://github.com/vuetifyjs/vuetify/commit/7085754564a3058e889b8c92754898c491fa06c6))
* **v-bottom-nav:** converted to use v-btn-toggle ([ffe5a90](https://github.com/vuetifyjs/vuetify/commit/ffe5a901de520bc9e498fce7e2cd040630e3423b))
* **v-btn-toggle:** refactor to use v-item-group ([6218e94](https://github.com/vuetifyjs/vuetify/commit/6218e94ed76f2cbac2920a9bcce0810321a0a683))
* **v-card:** convert to extend v-paper ([737d8d7](https://github.com/vuetifyjs/vuetify/commit/737d8d7b5f6abda557cc8a9aac89e91cb8610189))
* **v-carousel:** convert to ts ([9ce0a8c](https://github.com/vuetifyjs/vuetify/commit/9ce0a8cf3c21aea44b7faac4a51a7083baf19138))
* **v-carousel:** convert to use item-group functionality ([beb16d2](https://github.com/vuetifyjs/vuetify/commit/beb16d2079762cde6a1cf8797f90030fe8b6480e))
* **v-img:** add gradient prop ([c7c463f](https://github.com/vuetifyjs/vuetify/commit/c7c463f6926ca05bcec5076b41ac16648a45625e))
* **v-item-group:** separate provide from instance ([ce8a708](https://github.com/vuetifyjs/vuetify/commit/ce8a708e8ae9821df29d6a049364bca165bc9335))
* **v-paper:** create new component ([120eb31](https://github.com/vuetifyjs/vuetify/commit/120eb3185403bf88f34c3a164d679b82d1f6a8e0))
* **v-select:** additional slots before/after options list ([#4179](https://github.com/vuetifyjs/vuetify/issues/4179)) ([0ea55ca](https://github.com/vuetifyjs/vuetify/commit/0ea55cab7c4354a8c6779c5b1f8ce191f74e6ecf))
* **v-tabs:** convert to use item/group ([#5022](https://github.com/vuetifyjs/vuetify/issues/5022)) ([a9475f4](https://github.com/vuetifyjs/vuetify/commit/a9475f40f2474a8b92c11ca5a0027b11d2b2c001))
* **v-tabs:** update to use v-window ([5e7f01b](https://github.com/vuetifyjs/vuetify/commit/5e7f01b142b86cbdc38a068553c80e4e20b63c33))
* **v-window:** add new touch prop ([a5fc8e4](https://github.com/vuetifyjs/vuetify/commit/a5fc8e4f626dd67a05257d1e3058e325d0a7ec66)), closes [#4813](https://github.com/vuetifyjs/vuetify/issues/4813)
* **v-window:** add proxyable model support ([02ee27f](https://github.com/vuetifyjs/vuetify/commit/02ee27fe574f56aa2c72221ebdf72d36c64a5c9c))
* **v-window:** add reverse prop ([bdcfc60](https://github.com/vuetifyjs/vuetify/commit/bdcfc60a86d4a0aa3ab4293ce6f7b6f69e7b0166))
* **v-window:** create new component ([ffc6317](https://github.com/vuetifyjs/vuetify/commit/ffc63171ae765e63f924f73215e826378d0799cd))
* **v-window:** integrate item-group ([1f4347f](https://github.com/vuetifyjs/vuetify/commit/1f4347f7fc7cb361f0fb2bea91989b3db036b6dc))
* **VDatePicker:** add weekdayFormat prop ([#5257](https://github.com/vuetifyjs/vuetify/issues/5257)) ([6fde964](https://github.com/vuetifyjs/vuetify/commit/6fde964555bf36ad40529d1be87604611933c7f1)), closes [#5020](https://github.com/vuetifyjs/vuetify/issues/5020)
* **VIcon:** apply left/right even if not in a button ([f8de29d](https://github.com/vuetifyjs/vuetify/commit/f8de29dba0cca41ee6fd01c188cf1c8f1071b243))
* **VSwitch:** add loading prop ([#4805](https://github.com/vuetifyjs/vuetify/issues/4805)) ([91ad55b](https://github.com/vuetifyjs/vuetify/commit/91ad55b915fc7eb1ecf954ef6e455b99ca489107))
* **VTimePicker, VDatePicker:** disabled prop ([#5685](https://github.com/vuetifyjs/vuetify/issues/5685)) ([0b13705](https://github.com/vuetifyjs/vuetify/commit/0b13705ef28acb5166ea3a6c7458e0122cfb97de)), closes [#5631](https://github.com/vuetifyjs/vuetify/issues/5631)
* create v-timeline ([#3912](https://github.com/vuetifyjs/vuetify/issues/3912)) ([228e1e9](https://github.com/vuetifyjs/vuetify/commit/228e1e9d4265e18874f819b8171caed5a018eb76))
* **VForm:** add public resetValidation method ([#4763](https://github.com/vuetifyjs/vuetify/issues/4763)) ([01f5c66](https://github.com/vuetifyjs/vuetify/commit/01f5c66f85b0442378281af33e988037bbc3aea8)), closes [#3316](https://github.com/vuetifyjs/vuetify/issues/3316)
* **VListTile:** add themeable ([5ac572b](https://github.com/vuetifyjs/vuetify/commit/5ac572b4ed47b2473adc45901ef247418b73a512))
* **VProgress:** normalized value and buffer, add a11y ([#4953](https://github.com/vuetifyjs/vuetify/issues/4953)) ([9a526d8](https://github.com/vuetifyjs/vuetify/commit/9a526d845ed8ce3997be7f9a0dac20b282b749dc))
* **VRating:** add dense prop ([#4924](https://github.com/vuetifyjs/vuetify/issues/4924)) ([700cd75](https://github.com/vuetifyjs/vuetify/commit/700cd75cb997e67841f584a2c2709ddfa6cd2ac8))
* **VResponsive:** add width props ([6b8d7bb](https://github.com/vuetifyjs/vuetify/commit/6b8d7bb62563bd3f698b14c51c531af1fe89f6cb))
* **VSelect:** add menu-props prop, deprecate everything else ([#4795](https://github.com/vuetifyjs/vuetify/issues/4795)) ([f5a3f82](https://github.com/vuetifyjs/vuetify/commit/f5a3f8296906fc63c87a60ca63c4ed9397bbe37c))
* **VTimePicker:** readonly prop ([#4890](https://github.com/vuetifyjs/vuetify/issues/4890)) ([c158dec](https://github.com/vuetifyjs/vuetify/commit/c158dec6b242c890ff60280b8b431d113b7287cb)), closes [#3715](https://github.com/vuetifyjs/vuetify/issues/3715)
* **vuetify-package:** remove eslint-local rules, move files around, finish setup ([96961d9](https://github.com/vuetifyjs/vuetify/commit/96961d9c9970f124849771c27dfd58084c802016))
* create v-hover component, add group prop to transitions ([#4841](https://github.com/vuetifyjs/vuetify/issues/4841)) ([2313f55](https://github.com/vuetifyjs/vuetify/commit/2313f55fac25d2a72d4f9102f6114ff85f2929d4))
* **bootable:** removes animation on boot for ssr components ([b75f243](https://github.com/vuetifyjs/vuetify/commit/b75f243977164d19f72cc840d3aa75dbac595945))
* **locale:** german ([#4694](https://github.com/vuetifyjs/vuetify/issues/4694)) ([501ea17](https://github.com/vuetifyjs/vuetify/commit/501ea17a272baa5a07cd756a2855013f85a851b6))
* **locale:** greek ([#4718](https://github.com/vuetifyjs/vuetify/issues/4718)) ([1e66ec4](https://github.com/vuetifyjs/vuetify/commit/1e66ec44ea9060a8e2dc45542ab5cdede7379fae))
* **locale:** portuguese ([#4680](https://github.com/vuetifyjs/vuetify/issues/4680)) ([97bfcba](https://github.com/vuetifyjs/vuetify/commit/97bfcbaf394884eeb191756a9a755e04a92f89a9))
* add french locale ([#4685](https://github.com/vuetifyjs/vuetify/issues/4685)) ([0a5c9c6](https://github.com/vuetifyjs/vuetify/commit/0a5c9c638efded6ace42c129d84083675d5a4786))
* add ukrainian locale ([#4435](https://github.com/vuetifyjs/vuetify/issues/4435)) ([d3d6ee4](https://github.com/vuetifyjs/vuetify/commit/d3d6ee463b25768506a29f4caafe2f51be35a6a5))
* create v-img and v-responsive components ([#4472](https://github.com/vuetifyjs/vuetify/issues/4472)) ([c03f506](https://github.com/vuetifyjs/vuetify/commit/c03f506a6188a1758f9b7b9d7f834cb2d25f23ab))
* **detachable:** pass through scoped style attribute from parent ([#4282](https://github.com/vuetifyjs/vuetify/issues/4282)) ([8dc4ef5](https://github.com/vuetifyjs/vuetify/commit/8dc4ef5e89ee4d2dcc4a118a271a5a32ff5fdb48))
* **inputs:** emit events instead of using callback props on icons ([#4254](https://github.com/vuetifyjs/vuetify/issues/4254)) ([eaf0e93](https://github.com/vuetifyjs/vuetify/commit/eaf0e931f6eac5848837b6377a38a3e0fc12df0e))
* **inputs:** remove icon slots ([#4252](https://github.com/vuetifyjs/vuetify/issues/4252)) ([8defef1](https://github.com/vuetifyjs/vuetify/commit/8defef167ad508669b6b7ef0e01462c86ebce588))
* **locale:** polish ([#4437](https://github.com/vuetifyjs/vuetify/issues/4437)) ([7ac60f7](https://github.com/vuetifyjs/vuetify/commit/7ac60f7df1cc86e4d0ba7903edcdd54abe551dbb))
* **pm2:** add process file ([8c6b250](https://github.com/vuetifyjs/vuetify/commit/8c6b250c77f8df6d18e478f464a8120c050400fd))
* add russian locale ([#4425](https://github.com/vuetifyjs/vuetify/issues/4425)) ([0e7e0bc](https://github.com/vuetifyjs/vuetify/commit/0e7e0bcd661a60257b72b9f07268d3ae353bdc32))
* **a-la-carte:** add types and sourcemaps ([10c86d1](https://github.com/vuetifyjs/vuetify/commit/10c86d1c855af9031fde65f3532e1897c71dc9e8))
* **playground:** add mdi ([55fd507](https://github.com/vuetifyjs/vuetify/commit/55fd5076ec6bc01945b99c6fae72d680cf692c08))
* **tags:** add new delimiters prop ([349423e](https://github.com/vuetifyjs/vuetify/commit/349423e6ee8cff7a7509320fdb61c0b35be6c315)), closes [#3287](https://github.com/vuetifyjs/vuetify/issues/3287)
* **text/font:** added new helpers ([#3598](https://github.com/vuetifyjs/vuetify/issues/3598)) ([5ad4846](https://github.com/vuetifyjs/vuetify/commit/5ad48468f826500e4364b303b24ce206c7d8d3e9))
* **types:** add definition for a-la-carte directives ([c646c66](https://github.com/vuetifyjs/vuetify/commit/c646c66409c5753c65f028c191b71c87f8318c2a))
* **v-autocomplete:** add chip editing ([5f6aaaa](https://github.com/vuetifyjs/vuetify/commit/5f6aaaa487cd93afc24be443686fbb5f62191d67))
* **v-autocomplete:** add new **hide-no-data** prop ([20228a5](https://github.com/vuetifyjs/vuetify/commit/20228a5ece31745e2553de1898b9aef3585de753)), closes [#2613](https://github.com/vuetifyjs/vuetify/issues/2613)
* **v-autocomplete:** add no-filter prop ([ba6472a](https://github.com/vuetifyjs/vuetify/commit/ba6472aa6c5a561f6f6b44e7b46058ed6a35afe2)), closes [#2767](https://github.com/vuetifyjs/vuetify/issues/2767)
* **v-data-iterator:** add header slot ([#3922](https://github.com/vuetifyjs/vuetify/issues/3922)) ([070903e](https://github.com/vuetifyjs/vuetify/commit/070903e6a82c32491e7a72aaa7a1da8b26f8ff6d)), closes [#2748](https://github.com/vuetifyjs/vuetify/issues/2748)
* **v-form:** improve grid styles ([4a2e85d](https://github.com/vuetifyjs/vuetify/commit/4a2e85d0c09eebc703ac8bae9957dde61b871c14))
* **v-input:** add v-label state animation ([4975c1a](https://github.com/vuetifyjs/vuetify/commit/4975c1aaa06c5ddfdfe2da7327c56f3aa54a74f7))
* **v-input:** improve loader styles ([3dd6ff9](https://github.com/vuetifyjs/vuetify/commit/3dd6ff9a925ce363c2daa2146a28ae45528b3b1f)), closes [#2399](https://github.com/vuetifyjs/vuetify/issues/2399)
* **v-radio-group:** improve list func ([f57cacd](https://github.com/vuetifyjs/vuetify/commit/f57cacd36a8ec5d6bab861ff5920de490b87e333)), closes [#2345](https://github.com/vuetifyjs/vuetify/issues/2345)
* **v-select:** change display order ([e4cb7f3](https://github.com/vuetifyjs/vuetify/commit/e4cb7f378af926018df93ff9340dc9799bee9593)), closes [#4082](https://github.com/vuetifyjs/vuetify/issues/4082)
* **v-select:** change fallback ([495e413](https://github.com/vuetifyjs/vuetify/commit/495e4136d0052d2af8b44bf6b921c5fe02ea0e3f))
* **v-time-picker-clock:** allows scrollable with allowed-values ([#4202](https://github.com/vuetifyjs/vuetify/issues/4202)) ([8e6784a](https://github.com/vuetifyjs/vuetify/commit/8e6784a4782f2fa3c95e736082233e5aad1c5f51)), closes [#4195](https://github.com/vuetifyjs/vuetify/issues/4195)
* **v-toolbar:** normalize gutter functionality ([#4305](https://github.com/vuetifyjs/vuetify/issues/4305)) ([b77bec4](https://github.com/vuetifyjs/vuetify/commit/b77bec4ce88f297a101dfe1eef1a251e6d50dee9)), closes [#4315](https://github.com/vuetifyjs/vuetify/issues/4315)
* **VExpansionPanel:** add disabled and readonly props ([#3969](https://github.com/vuetifyjs/vuetify/issues/3969)) ([c2fc0fd](https://github.com/vuetifyjs/vuetify/commit/c2fc0fd74b27c943a3395beda082f8e6e9fded8d))
* **VLabel:** add aria-hidden ([a691511](https://github.com/vuetifyjs/vuetify/commit/a691511048ceaced40cd4fc98e6f318d59466c94))
* **VTextField:** add background-color ([#4353](https://github.com/vuetifyjs/vuetify/issues/4353)) ([1d79e5b](https://github.com/vuetifyjs/vuetify/commit/1d79e5bb0ad7742555ebf531848a9526892bfb70))
* create v-overflow-btn ([#3992](https://github.com/vuetifyjs/vuetify/issues/3992)) ([7010263](https://github.com/vuetifyjs/vuetify/commit/70102630ea19784e54c2482870544578c1d38b59))
* Specify custom translation function ([#4319](https://github.com/vuetifyjs/vuetify/issues/4319)) ([5c5fb84](https://github.com/vuetifyjs/vuetify/commit/5c5fb844c698ff00765a6d499702add4e101623e))
* VCombobox ([#4309](https://github.com/vuetifyjs/vuetify/issues/4309)) ([c0d3492](https://github.com/vuetifyjs/vuetify/commit/c0d3492268816346e5be94b925f09bb4467001a1))
* **grids:** remove variable padding ([5a4635c](https://github.com/vuetifyjs/vuetify/commit/5a4635cb1b17027a749e1acbfa25539e9852d662)), closes [#2264](https://github.com/vuetifyjs/vuetify/issues/2264)
* **input-controls:** updated styles, various updates ([45c3c3d](https://github.com/vuetifyjs/vuetify/commit/45c3c3da4825ada70bbd1ec8bf6de5f21b47db0f))
* **rtl:** adapted v-slider for rtl ([1c0007c](https://github.com/vuetifyjs/vuetify/commit/1c0007c3bce31faee4dc0403a24aad417fe2d109))
* **rtl:** added more rtl support ([e133a67](https://github.com/vuetifyjs/vuetify/commit/e133a67ac8b96adeeb039591170652d30010cac4))
* **selection-controls:** move icons to props ([e334898](https://github.com/vuetifyjs/vuetify/commit/e3348987532f6555a432ae9a601be640cdf6891b)), closes [#2784](https://github.com/vuetifyjs/vuetify/issues/2784)
* **v-autocomplete:** implement tags ([db6c118](https://github.com/vuetifyjs/vuetify/commit/db6c118a514ea8aa5376139462d8aab64f0e9a67))
* **v-select:** improve chips ([9f4ea6b](https://github.com/vuetifyjs/vuetify/commit/9f4ea6b832ae6cf6a59fafff24b2c3cc71bf88c9)), closes [#2933](https://github.com/vuetifyjs/vuetify/issues/2933)
* goTo returns a Promise ([#3832](https://github.com/vuetifyjs/vuetify/issues/3832)) ([550fa80](https://github.com/vuetifyjs/vuetify/commit/550fa8092a818fdd96fc96d45e484609b17a9c7f)), closes [#3748](https://github.com/vuetifyjs/vuetify/issues/3748)
* **grid:** added grow/shrink helper classes ([23dbfa2](https://github.com/vuetifyjs/vuetify/commit/23dbfa27c2eaa223ed69100dae70c93d83d147de))
* **inputs:** abstracted more functionality, moved code around ([d2126a1](https://github.com/vuetifyjs/vuetify/commit/d2126a1a74736b7aa98b9aa89efec6ca01351361))
* **routable:** allow object for **ripple** prop ([b49c980](https://github.com/vuetifyjs/vuetify/commit/b49c9807d50f5858a9021cfc75bc772eb9ef2b65))
* **rtl:** started initial implementation ([ef761a7](https://github.com/vuetifyjs/vuetify/commit/ef761a74b8d90852f3cc12d7d32ba6b66a7b36cd))
* **select/text-field:** added new functionality, **solo-inverted** ([0e81afa](https://github.com/vuetifyjs/vuetify/commit/0e81afa413a9c9f0ccb1fde9bb60f0a765e0f7fe))
* **selection-controls:** abstracted further ([7313b77](https://github.com/vuetifyjs/vuetify/commit/7313b77f8a64c42951491e00682de65225e66369))
* **spacing:** added new `mx-auto` class ([b748b73](https://github.com/vuetifyjs/vuetify/commit/b748b7387110461276195c791fe4b0c40bb8b731))
* **ssr:** removed entry animation on layout components in ssr ([d634351](https://github.com/vuetifyjs/vuetify/commit/d6343519f40dca2815e09d5ab85617cc5cd99756))
* **stylus colors:** allow redefinition ([67e440a](https://github.com/vuetifyjs/vuetify/commit/67e440a367da9081fb90a60032b73b5d2c053f6e)), closes [#2155](https://github.com/vuetifyjs/vuetify/issues/2155)
* **theme:** add theme support to anchor tags ([#2566](https://github.com/vuetifyjs/vuetify/issues/2566)) ([a90fcdb](https://github.com/vuetifyjs/vuetify/commit/a90fcdb2448d51834ad003259b7ed579f478e20e)), closes [#2515](https://github.com/vuetifyjs/vuetify/issues/2515)
* **theme:** allow a nonce to be specified for the stylesheet ([#3952](https://github.com/vuetifyjs/vuetify/issues/3952)) ([2d69b1e](https://github.com/vuetifyjs/vuetify/commit/2d69b1eb83100a502234af423231a8776be6f5ff)), closes [#3950](https://github.com/vuetifyjs/vuetify/issues/3950)
* **theme:** Create util file with color variables ([#2567](https://github.com/vuetifyjs/vuetify/issues/2567)) ([fb6f448](https://github.com/vuetifyjs/vuetify/commit/fb6f448ccd946550a197b76cef8e82523ad7074b)), closes [#2564](https://github.com/vuetifyjs/vuetify/issues/2564)
* **types:** add icons and Vuetify plugin to type definition ([#3785](https://github.com/vuetifyjs/vuetify/issues/3785)) ([07e21c4](https://github.com/vuetifyjs/vuetify/commit/07e21c42389f0ca22ef9a742a22484e9348be91b))
* **v-bottom-sheet:** added **hide-overlay** prop ([4a3f68c](https://github.com/vuetifyjs/vuetify/commit/4a3f68cc0526ab440e31d23fa5cbd8d6791d83e8)), closes [#2668](https://github.com/vuetifyjs/vuetify/issues/2668)
* **v-card:** added new **width** prop ([5bc20c8](https://github.com/vuetifyjs/vuetify/commit/5bc20c85e7b1ca63459713a09208b0fe9dd88078))
* **v-checkbox:** added initial impl ([49e482b](https://github.com/vuetifyjs/vuetify/commit/49e482bf6ed40e2d48f1df41b6b96a660cc49dd6))
* **v-data-table:** no-data and no-results slots can take custom tr/tds ([#2952](https://github.com/vuetifyjs/vuetify/issues/2952)) ([c2c356a](https://github.com/vuetifyjs/vuetify/commit/c2c356a13e103ce7fdf047142af14d0db05500c9)), closes [#2504](https://github.com/vuetifyjs/vuetify/issues/2504)
* **v-date-picker:** improved animations ([d8e2441](https://github.com/vuetifyjs/vuetify/commit/d8e244148b2e5e6aae5ed05b68a12939848576d2))
* **v-input:** abstracted inputable to a component ([f5574fe](https://github.com/vuetifyjs/vuetify/commit/f5574fe5cc51a8101951b8b9207d41b21cd296eb))
* **v-label:** added left prop ([247de34](https://github.com/vuetifyjs/vuetify/commit/247de3457442eca6b4cd98b38ef4abee3e367fe2))
* **v-list:** added nesting functionality to list-groups ([#2563](https://github.com/vuetifyjs/vuetify/issues/2563)) ([f0764a7](https://github.com/vuetifyjs/vuetify/commit/f0764a769124778f60ad007cb2ed6fe7f402c8b1)), closes [#1898](https://github.com/vuetifyjs/vuetify/issues/1898)
* **v-select:** removed debounce prop ([#3138](https://github.com/vuetifyjs/vuetify/issues/3138)) ([ad4b1ce](https://github.com/vuetifyjs/vuetify/commit/ad4b1ce1c99d3d7ca3f066ce161eaeb9dab982eb)), closes [#2978](https://github.com/vuetifyjs/vuetify/issues/2978)
* **v-stepper-step:** added colorable support ([60a4bc6](https://github.com/vuetifyjs/vuetify/commit/60a4bc6006caa3e272ee9782e12896553530d773)), closes [#3276](https://github.com/vuetifyjs/vuetify/issues/3276)
* **v-switch:** added initial impl ([03a4a1c](https://github.com/vuetifyjs/vuetify/commit/03a4a1c190ac5a7da22ae7733f2220a556a70d4a))
* **v-tabs/v-tabs-items:** allow **value** to accept Number's ([c9e493c](https://github.com/vuetifyjs/vuetify/commit/c9e493c4b074ea755ae8356aa247d55bfbbfbe06))
* **v-text-field:** added affixes, backwards compat for appendIcon ([0857039](https://github.com/vuetifyjs/vuetify/commit/0857039ce3b62efd9aa1461c0afd719614d3e8c9))
* **v-text-field:** added counter ([4bb0536](https://github.com/vuetifyjs/vuetify/commit/4bb0536f5724359e9a3ec055f72c51dde8344ea4))
* **v-text-field:** started implementation with v-input ([eec081c](https://github.com/vuetifyjs/vuetify/commit/eec081c5be50a7326e9ac8123e3c55c1939206e8))
* **persistent** prop for v-edit-dialog ([#3196](https://github.com/vuetifyjs/vuetify/issues/3196)) ([d174129](https://github.com/vuetifyjs/vuetify/commit/d174129671d4c516c7190b8fe70866d21784fd32)), closes [#3195](https://github.com/vuetifyjs/vuetify/issues/3195)
* **width** and **full-width** props for pickers ([#3001](https://github.com/vuetifyjs/vuetify/issues/3001)) ([343335f](https://github.com/vuetifyjs/vuetify/commit/343335f9e937c74637b81f21dd0d892d0459513c))
* add options to $vuetify.goTo ([#3073](https://github.com/vuetifyjs/vuetify/issues/3073)) ([71484a1](https://github.com/vuetifyjs/vuetify/commit/71484a135f3fd5d9d6cf17de07eae460545c02ab))
* added new component, added routable to carousel, new prop to icon ([6c612c5](https://github.com/vuetifyjs/vuetify/commit/6c612c560ce19ca8c815aa5ea731b4f56ed48aea)), closes [#1709](https://github.com/vuetifyjs/vuetify/issues/1709)
* allow theme to be disabled entirely ([#3379](https://github.com/vuetifyjs/vuetify/issues/3379)) ([a7e8bb8](https://github.com/vuetifyjs/vuetify/commit/a7e8bb87b4cd3053eb99268d05e9d65b03f0fdb8)), closes [#3349](https://github.com/vuetifyjs/vuetify/issues/3349)
* contentClass for VSelect ([#2375](https://github.com/vuetifyjs/vuetify/issues/2375)) ([3c52ac6](https://github.com/vuetifyjs/vuetify/commit/3c52ac68f62a2e3eeb99dd140d585f84d3027832)), closes [#2374](https://github.com/vuetifyjs/vuetify/issues/2374)
* min/max props for date/time picker ([#3029](https://github.com/vuetifyjs/vuetify/issues/3029)) ([259ff73](https://github.com/vuetifyjs/vuetify/commit/259ff73ad27376d272dc02cb87320d5f967c6512)), closes [#2991](https://github.com/vuetifyjs/vuetify/issues/2991)
* pickerDate.sync prop ([#3019](https://github.com/vuetifyjs/vuetify/issues/3019)) ([d325bf1](https://github.com/vuetifyjs/vuetify/commit/d325bf1f3fc1d6abc3db648ee38089d75612a30d)), closes [#3008](https://github.com/vuetifyjs/vuetify/issues/3008)
* Set header font via `$header-font-family` ([b947121](https://github.com/vuetifyjs/vuetify/commit/b9471216a5967791797e36564cf2c51ac97d326a))
* **v-scroll:** added window offset to scroll callback ([8c39667](https://github.com/vuetifyjs/vuetify/commit/8c39667159ec979c455b443216735b57ff8bf0a3))
* **v-toolbar:** added new scrolling functionality to `v-toolbar` ([eac768b](https://github.com/vuetifyjs/vuetify/commit/eac768be6007fa0fd694e7725dc0bb7d259b4a76))
* add class to application if touch is supported ([#2356](https://github.com/vuetifyjs/vuetify/issues/2356)) ([6f0b6c6](https://github.com/vuetifyjs/vuetify/commit/6f0b6c69cdd1a3d22359f951fe1bed27c9218f4c))
* add disabled prop for tooltips ([#2164](https://github.com/vuetifyjs/vuetify/issues/2164)) ([13e5fbf](https://github.com/vuetifyjs/vuetify/commit/13e5fbf69788fb104a7d49015d59326b1e382328)), closes [#2002](https://github.com/vuetifyjs/vuetify/issues/2002)
* add fixed/absolute props to v-system-bar ([#2188](https://github.com/vuetifyjs/vuetify/issues/2188)) ([28fbca9](https://github.com/vuetifyjs/vuetify/commit/28fbca9262d01a9584b181e83494ecfd94468c94)), closes [#2186](https://github.com/vuetifyjs/vuetify/issues/2186) [#2186](https://github.com/vuetifyjs/vuetify/issues/2186)
* add support for float values in slider ([#2242](https://github.com/vuetifyjs/vuetify/issues/2242)) ([5478c1b](https://github.com/vuetifyjs/vuetify/commit/5478c1bf20882113fc51c2371caa9d55473ae4b3)), closes [#1914](https://github.com/vuetifyjs/vuetify/issues/1914)
* allow overriding color for contextual alert ([6e04ff1](https://github.com/vuetifyjs/vuetify/commit/6e04ff1a61ccbf02116274416c2f6e3ff6f344b4))
* do not render items-per-page select with only 1 option ([#2459](https://github.com/vuetifyjs/vuetify/issues/2459)) ([d0ce490](https://github.com/vuetifyjs/vuetify/commit/d0ce490154c60887a46fcbc81b0e88b531ee9f29)), closes [#2438](https://github.com/vuetifyjs/vuetify/issues/2438)
* hideSelected prop for v-select ([#2260](https://github.com/vuetifyjs/vuetify/issues/2260)) ([3231d06](https://github.com/vuetifyjs/vuetify/commit/3231d06e25203e055064b3def40e3a70445ee7be))
* inherit checkbox/text of selected item from v-select ([#2189](https://github.com/vuetifyjs/vuetify/issues/2189)) ([6968476](https://github.com/vuetifyjs/vuetify/commit/6968476c9e316171fa3f60cd668bcf020ea90f95)), closes [#2174](https://github.com/vuetifyjs/vuetify/issues/2174)
* Make VIcon aria-hidden by default ([f0b5043](https://github.com/vuetifyjs/vuetify/commit/f0b50437c7b22d22a0a2939bab7bbefac540c408))
* **v-alert:** added contextual support with **type** prop ([623ebca](https://github.com/vuetifyjs/vuetify/commit/623ebcabde2379ecf0b5f8931d683d65b904e276))
* **v-autocomplete:** added new functionality ([17c4d2e](https://github.com/vuetifyjs/vuetify/commit/17c4d2eea0cea3d1007ab87b810b553988795122))
* **v-autocomplete:** expanded functionality ([eb16480](https://github.com/vuetifyjs/vuetify/commit/eb16480eaea764091ea6c2c6dedf20b36355c264))
* **v-autocomplete:** improved process ([309443a](https://github.com/vuetifyjs/vuetify/commit/309443a50da2bf39dd58a2f5a6ece08ce4145f1b))
* **v-autocomplete:** started add combobox functionality ([ad99bc5](https://github.com/vuetifyjs/vuetify/commit/ad99bc5f751c6eb1274b8e6172ec7ca8bcc8bcd1))
* **v-autocomplete:** started initial impl ([115e21d](https://github.com/vuetifyjs/vuetify/commit/115e21de6e8b9cb70b20c5e5c592c4d6af00ac35))
* **v-divider:** add vertical variant ([b71b4f8](https://github.com/vuetifyjs/vuetify/commit/b71b4f89b68b1709a1634689d2d5a1f17faccb32)), closes [#3578](https://github.com/vuetifyjs/vuetify/issues/3578)
* **v-input:** add hide-details func ([ac481e0](https://github.com/vuetifyjs/vuetify/commit/ac481e0c94ebc0c40512a2827b362534d577519d))
* **v-select:** added **dense** prop to `v-select` ([729569a](https://github.com/vuetifyjs/vuetify/commit/729569a6ac3e24bf744a2d7f2db47729d64cd395))
* **v-select:** finished initial re-impl ([1d48e27](https://github.com/vuetifyjs/vuetify/commit/1d48e272ce8e12e1cbee0304b898dd55a05201c8))
* **v-select:** improved chip support, minor tweaks ([248b8fd](https://github.com/vuetifyjs/vuetify/commit/248b8fd7e2e02159495f2504bb6a05162e694f65))
* **v-select:** initial impl of `v-select` ([948b6f8](https://github.com/vuetifyjs/vuetify/commit/948b6f85e12f517ffdd13d869b49926fa435f0c4))
* **v-select:** select rebuilding for abstraction ([344eaf8](https://github.com/vuetifyjs/vuetify/commit/344eaf8253128cea3909866987648eff1990ddd7))
* **v-select:** update chip support ([bc32335](https://github.com/vuetifyjs/vuetify/commit/bc323355ed428bc8f4c229de88f3b215ff91ff77))
* **v-slider:** add new functionality ([d1f01a0](https://github.com/vuetifyjs/vuetify/commit/d1f01a06eec4214860b940356c682e9ea8b011f5)), closes [#1686](https://github.com/vuetifyjs/vuetify/issues/1686)
* **v-slider:** added v-slider support ([4a4abfb](https://github.com/vuetifyjs/vuetify/commit/4a4abfb11d22b0191298d884ffdf545d9f1240dc))
* **v-switch:** added touch support ([0614a23](https://github.com/vuetifyjs/vuetify/commit/0614a2382e62e5ef78caf78cb94e20c586673306))
* **v-text-field:** add reverse functionality ([1bbf319](https://github.com/vuetifyjs/vuetify/commit/1bbf319b365c518a3f842b29ee0cc778330684a3)), closes [#1782](https://github.com/vuetifyjs/vuetify/issues/1782)
* **v-text-field:** added new features, new styles ([7683547](https://github.com/vuetifyjs/vuetify/commit/768354778575a7b47c8da9075bb125d3864979e9))
* **v-textarea/field:** added box styles, improved textarea consistency ([572c98d](https://github.com/vuetifyjs/vuetify/commit/572c98dcfbb2402b90d3fb9e25134618ef345e2b))
* **VSelect:** deprecate all autocomplete props with functional wrapper ([02be146](https://github.com/vuetifyjs/vuetify/commit/02be1465f6fdc1ac298c47910d1f078671bbee6b))
* make $vuetify.breakpoint available before page load ([dd8214e](https://github.com/vuetifyjs/vuetify/commit/dd8214e191c1f9578ad94e99a3070e1d39d7e04b)), closes [#2208](https://github.com/vuetifyjs/vuetify/issues/2208) [#2121](https://github.com/vuetifyjs/vuetify/issues/2121)
* make $vuetify.breakpoint available before page load ([24cea8c](https://github.com/vuetifyjs/vuetify/commit/24cea8cee42e7315dae7400399995f04538b42bc)), closes [#2208](https://github.com/vuetifyjs/vuetify/issues/2208) [#2121](https://github.com/vuetifyjs/vuetify/issues/2121)
* make date/time pickers colorable ([#2199](https://github.com/vuetifyjs/vuetify/issues/2199)) ([05dfc4e](https://github.com/vuetifyjs/vuetify/commit/05dfc4e25e917d31651fe0dc23945535e3f0bd9e)), closes [#2163](https://github.com/vuetifyjs/vuetify/issues/2163)
* no-data and no-results slots for data table ([#2252](https://github.com/vuetifyjs/vuetify/issues/2252)) ([198f8bc](https://github.com/vuetifyjs/vuetify/commit/198f8bcdeed65de78756f2657c0c8d6a524385b1)), closes [#1977](https://github.com/vuetifyjs/vuetify/issues/1977)
* selects input value when focusing autocomplete ([#2358](https://github.com/vuetifyjs/vuetify/issues/2358)) ([c0ce13a](https://github.com/vuetifyjs/vuetify/commit/c0ce13aac4594d3463a1bfe7df2c84239707d523)), closes [#2255](https://github.com/vuetifyjs/vuetify/issues/2255)
* VSelectList component ([37572cf](https://github.com/vuetifyjs/vuetify/commit/37572cf5b10f31867ecf8c86ae53ceb69fd9d8ec))
* VSelectList component (cleanup) ([968fbae](https://github.com/vuetifyjs/vuetify/commit/968fbae087587b88a95277aedecdbbb2f0236750))
* **v-dialog:** changed defaults for `v-dialog` props ([5168d64](https://github.com/vuetifyjs/vuetify/commit/5168d648d62e61265c133353936e4fb0695d9725)), closes [#2098](https://github.com/vuetifyjs/vuetify/issues/2098)
* **v-select:** removed entry label animation when dirty ([1e2650b](https://github.com/vuetifyjs/vuetify/commit/1e2650b8d3b4c5cc2e41aea53812bad892e4078f)), closes [#1941](https://github.com/vuetifyjs/vuetify/issues/1941)
* **v-select:** removed entry label animation when dirty ([e8eb752](https://github.com/vuetifyjs/vuetify/commit/e8eb75297e3fe9eebd11a7b5944a18463123abf8)), closes [#1941](https://github.com/vuetifyjs/vuetify/issues/1941)
* **v-time-picker:** added argument to disabled function call ([18f6aad](https://github.com/vuetifyjs/vuetify/commit/18f6aad3c7c374aca127d7c41cd004ca2129804d)), closes [#1916](https://github.com/vuetifyjs/vuetify/issues/1916)
* **VSelect:** allow the use of custom list tiles in items slot ([#2710](https://github.com/vuetifyjs/vuetify/issues/2710)) ([263e14a](https://github.com/vuetifyjs/vuetify/commit/263e14acb4afe000fda9c9bc0cb1231be75736f4))
* **VTreeview:** add label slot ([#5567](https://github.com/vuetifyjs/vuetify/issues/5567)) ([3a968d0](https://github.com/vuetifyjs/vuetify/commit/3a968d030acbb9b18f5a750978bcf2585e47cc52)), closes [#5531](https://github.com/vuetifyjs/vuetify/issues/5531)


### Bug Fixes

* **api:** props should be kebab-case ([2007b42](https://github.com/vuetifyjs/vuetify/commit/2007b425e93ec0f4a1bfb1284c6e0ecdd2fbd2cf))
* **api:** remove source header in production ([ff7f8b8](https://github.com/vuetifyjs/vuetify/commit/ff7f8b8b6b754241379aa0f797791048d04d833c))
* **api-gen:** exclude v-virtual-table ([cf1630f](https://github.com/vuetifyjs/vuetify/commit/cf1630f9cc5c29773fb83f1c55da27f2dd5a82e6))
* **api-gen:** incorrect prop data for validatable mixin ([0074870](https://github.com/vuetifyjs/vuetify/commit/00748705faa397a66053f0a0d705af57b57541e1))
* **breakpoint:** set correct mobile value when using breakpoint strings ([468d4b6](https://github.com/vuetifyjs/vuetify/commit/468d4b646a7a5fef6b76c5d4265e9b4b2a018767))
* **build:** generate API pages for all languages ([#143](https://github.com/vuetifyjs/vuetify/issues/143)) ([5da56e3](https://github.com/vuetifyjs/vuetify/commit/5da56e330fbb5d6514318b48ea3410eb8ec96191))
* **build:** remove EN_LOCALE_ONLY flag ([#144](https://github.com/vuetifyjs/vuetify/issues/144)) ([01af502](https://github.com/vuetifyjs/vuetify/commit/01af50244950544da5b1c224e144bdcf26e64bb4))
* **build:** use platform specific separator when replacing sass paths ([5149db2](https://github.com/vuetifyjs/vuetify/commit/5149db21b53dea58ff755c290d39de7746833519))
* **click-outside:** allow programmatic click outside ([#12109](https://github.com/vuetifyjs/vuetify/issues/12109)) ([6d26819](https://github.com/vuetifyjs/vuetify/commit/6d268193d31b5bce46edafdcb1647291ee257457)), closes [#12107](https://github.com/vuetifyjs/vuetify/issues/12107)
* **click-outside:** don't trigger if mousedown inside target ([#13244](https://github.com/vuetifyjs/vuetify/issues/13244)) ([f4f8c7a](https://github.com/vuetifyjs/vuetify/commit/f4f8c7a378ec969b9aea7ad544d4692c328140c0)), closes [#5886](https://github.com/vuetifyjs/vuetify/issues/5886) [#9283](https://github.com/vuetifyjs/vuetify/issues/9283)
* **colorutils.ts:** lookbehind regexp causing FF throw error ([#11215](https://github.com/vuetifyjs/vuetify/issues/11215)) ([0604b0b](https://github.com/vuetifyjs/vuetify/commit/0604b0babcdd79b076398b18f73129e63b0f9436)), closes [#11214](https://github.com/vuetifyjs/vuetify/issues/11214)
* **docs:** fix anchors in non-latin translations ([#12790](https://github.com/vuetifyjs/vuetify/issues/12790)) ([89e833a](https://github.com/vuetifyjs/vuetify/commit/89e833a145a6d585eabdf881809f1a99f217239a))
* **docs:** ignore everything in src/pages but the en folder ([c6773fc](https://github.com/vuetifyjs/vuetify/commit/c6773fc6deb07d311a98b4c96360da609d0a98a9))
* **docs:** remove local i18n links, add missing messages ([#12185](https://github.com/vuetifyjs/vuetify/issues/12185)) ([8d58a69](https://github.com/vuetifyjs/vuetify/commit/8d58a692d46c88484c52eeddfc70c359d2908e60))
* **docs:** special characters in headers ([eaa79b9](https://github.com/vuetifyjs/vuetify/commit/eaa79b999a049ff98f05a659e8389c351f8c6a62))
* **Example:** enable prism theme colors ([c25b07f](https://github.com/vuetifyjs/vuetify/commit/c25b07f7fe67687937eb234d07dc31a2971ad3fe))
* **i18n:** Remove untranslated string from ru.ts ([#10945](https://github.com/vuetifyjs/vuetify/issues/10945)) ([c092083](https://github.com/vuetifyjs/vuetify/commit/c0920833923c6c3cd7813f9f8b73c8dd25b5f721))
* **icons:** use correct mdi icon for rating-half ([#12429](https://github.com/vuetifyjs/vuetify/issues/12429)) ([82fb3b9](https://github.com/vuetifyjs/vuetify/commit/82fb3b9503e20fc5f1cbf35f828eac1a7e4c0b0a))
* **inputs:** reset value to null instead of undefined ([#12373](https://github.com/vuetifyjs/vuetify/issues/12373)) ([8e5554d](https://github.com/vuetifyjs/vuetify/commit/8e5554d11828258cb51e25b8bbf17808d6a8730a)), closes [#7429](https://github.com/vuetifyjs/vuetify/issues/7429)
* **locale:** german translation of `carousel.ariaLabel.delimiter` ([#10789](https://github.com/vuetifyjs/vuetify/issues/10789)) ([02df247](https://github.com/vuetifyjs/vuetify/commit/02df247e81aaf4534063c4d54f89e7252a38f45d))
* **locale:** improve and add new fr translation ([#12587](https://github.com/vuetifyjs/vuetify/issues/12587)) ([4b19ae9](https://github.com/vuetifyjs/vuetify/commit/4b19ae9741f4c26c8c000ed9e33dc5c3d3261b60))
* **locale:** improve japanese translations ([#12535](https://github.com/vuetifyjs/vuetify/issues/12535)) ([6c80202](https://github.com/vuetifyjs/vuetify/commit/6c80202775bc91656adf0a98f96d85663c9488e5))
* **Locale:** add missing pagination objects to fi/sk ([aae297b](https://github.com/vuetifyjs/vuetify/commit/aae297b32dddbe8b489f390e348ea49ede3ac0d5))
* **locales:** SK localization fixes and additions ([#11497](https://github.com/vuetifyjs/vuetify/issues/11497)) ([f99df87](https://github.com/vuetifyjs/vuetify/commit/f99df870dde05f6f61607fe875918f512239cb5b))
* **locales:** update language for th-Thai 18n translation ([#12338](https://github.com/vuetifyjs/vuetify/issues/12338)) ([b0913ae](https://github.com/vuetifyjs/vuetify/commit/b0913ae557d8e5247278bd79ae3226c756da9c55))
* **locales:** update NL i18n translation ([#11992](https://github.com/vuetifyjs/vuetify/issues/11992)) ([47325bf](https://github.com/vuetifyjs/vuetify/commit/47325bfb6a71afd9f3d7bb00f65c4785f49ee7a1))
* **metadata:** add unique identifier property to prevent duplicate meta ([808cf6d](https://github.com/vuetifyjs/vuetify/commit/808cf6d0acf84feaeb84c21282085a46476d66ee))
* **overlayable:** overlay must be removed if quickly deactivated ([#10975](https://github.com/vuetifyjs/vuetify/issues/10975)) ([63eb1be](https://github.com/vuetifyjs/vuetify/commit/63eb1be1ea756453a5bf1268deb4b501baca96d7)), closes [#8625](https://github.com/vuetifyjs/vuetify/issues/8625) [#9588](https://github.com/vuetifyjs/vuetify/issues/9588)
* **SelectionControls:** adjust focus and hover styles ([1e66229](https://github.com/vuetifyjs/vuetify/commit/1e66229e86b1e9ec86ce23d69099cfd39e6a7437))
* **SelectionControls:** fix mouse events on field ([40557a6](https://github.com/vuetifyjs/vuetify/commit/40557a690b1b05f24547d0cfa603b2824b7a9ae3)), closes [#10479](https://github.com/vuetifyjs/vuetify/issues/10479)
* **SelectionControls:** fix mouse events on field ([4b6f14b](https://github.com/vuetifyjs/vuetify/commit/4b6f14b64787f9e0461082c0306f84a56c5766be)), closes [#10462](https://github.com/vuetifyjs/vuetify/issues/10462)
* **SelectionControls:** remove color from transition-property ([2f499d2](https://github.com/vuetifyjs/vuetify/commit/2f499d2f5626782cb5efd7868123beae32c19dc1))
* **SelectionControls:** remove duplicate import ([2beb81b](https://github.com/vuetifyjs/vuetify/commit/2beb81b20ed6ba53133f6c3e1e7d1034d3aa4561))
* **spacing:** set negative margin baseline to -4px ([#11453](https://github.com/vuetifyjs/vuetify/issues/11453)) ([af13208](https://github.com/vuetifyjs/vuetify/commit/af13208726a77dcffca968beefd7d71238ff5672))
* **toc:** properly update toc when at bottom of page ([#145](https://github.com/vuetifyjs/vuetify/issues/145)) ([cba2bb9](https://github.com/vuetifyjs/vuetify/commit/cba2bb98b93e89d301a2537bd5e44cf955957194))
* **types:** add missing icons to VuetifyIcons interface ([#12131](https://github.com/vuetifyjs/vuetify/issues/12131)) ([9ee10fd](https://github.com/vuetifyjs/vuetify/commit/9ee10fde8e3334f4db406ddd56b55029528844ec))
* **types:** export VueConstructor instead of Component ([f9bf635](https://github.com/vuetifyjs/vuetify/commit/f9bf63545944aa28b3c9abecfe24ab715ebe649e)), closes [#11463](https://github.com/vuetifyjs/vuetify/issues/11463)
* **types:** export VueConstructor instead of Component ([268434a](https://github.com/vuetifyjs/vuetify/commit/268434aa851dded8b67c0e67bfa39b3cbe791584)), closes [#11463](https://github.com/vuetifyjs/vuetify/issues/11463)
* **types:** export Vuetify as a class ([3a0bd24](https://github.com/vuetifyjs/vuetify/commit/3a0bd24bb19be055d94d00beddffa78f60a098bf)), closes [#12511](https://github.com/vuetifyjs/vuetify/issues/12511)
* **types:** remove number type from Breakpoint['name' ([#12113](https://github.com/vuetifyjs/vuetify/issues/12113)) ([592aca5](https://github.com/vuetifyjs/vuetify/commit/592aca5bf9dfec279a34efc3710b4e3c9ab2ccf3))
* **typography:** conditionally remove important from utility mapping ([c11ae35](https://github.com/vuetifyjs/vuetify/commit/c11ae35ab4275b72525c829969184884d9e3bc34))
* **validatable:** Allow "messages" properties to be null ([#11927](https://github.com/vuetifyjs/vuetify/issues/11927)) ([8ccff06](https://github.com/vuetifyjs/vuetify/commit/8ccff061ba8e74813e0cf9be755cb7f0444c2430)), closes [#11926](https://github.com/vuetifyjs/vuetify/issues/11926)
* **VAppBar:** ensure app bar visibility when hide-on-scroll ([#9993](https://github.com/vuetifyjs/vuetify/issues/9993)) ([#11204](https://github.com/vuetifyjs/vuetify/issues/11204)) ([baa0dd7](https://github.com/vuetifyjs/vuetify/commit/baa0dd75a1fe9043b7034b7461bd1bf3b9264f21))
* **VAppBar:** inverted scroll not hiding the app bar in an edge case ([#10656](https://github.com/vuetifyjs/vuetify/issues/10656)) ([151ae74](https://github.com/vuetifyjs/vuetify/commit/151ae7411f8328848b50be03247daad3d0032f1a)), closes [#10590](https://github.com/vuetifyjs/vuetify/issues/10590)
* **vautocomplete:** change onClick to not reopen menu ([#10158](https://github.com/vuetifyjs/vuetify/issues/10158)) ([10abc11](https://github.com/vuetifyjs/vuetify/commit/10abc11195c9d4deba4c07814f7e8855dee36306)), closes [#6564](https://github.com/vuetifyjs/vuetify/issues/6564)
* **VAutocomplete:** add minimum input width when focused ([254bb29](https://github.com/vuetifyjs/vuetify/commit/254bb29a3e0d2cbd5469e5159f5eec9e58ca3a11))
* **VAutocomplete:** apply focus properly ([#12397](https://github.com/vuetifyjs/vuetify/issues/12397)) ([5100e6e](https://github.com/vuetifyjs/vuetify/commit/5100e6e83afa2c79caa9b84341b0c4af71c7e4bb)), closes [#11989](https://github.com/vuetifyjs/vuetify/issues/11989)
* **VAutocomplete:** avoid scrolling screen when pressing down ([4fce059](https://github.com/vuetifyjs/vuetify/commit/4fce0593088017ef13b0f2b45f050dcbd248d3bd))
* **VAutocomplete:** check for inital search input prop ([#10642](https://github.com/vuetifyjs/vuetify/issues/10642)) ([e09c916](https://github.com/vuetifyjs/vuetify/commit/e09c916f4006f1d3e7fda1b3d1c79b3dc32f2e60)), closes [#9757](https://github.com/vuetifyjs/vuetify/issues/9757) [#9757](https://github.com/vuetifyjs/vuetify/issues/9757) [#9757](https://github.com/vuetifyjs/vuetify/issues/9757)
* **VAutocomplete:** don't try to set data on an empty clipboard event ([8e8c360](https://github.com/vuetifyjs/vuetify/commit/8e8c360912a393b7a9a7f84b475d41406e9fb25d)), closes [#11187](https://github.com/vuetifyjs/vuetify/issues/11187)
* **VAutocomplete:** prefix overlap with placeholder ([#10781](https://github.com/vuetifyjs/vuetify/issues/10781)) ([02723e5](https://github.com/vuetifyjs/vuetify/commit/02723e533413c8f85ea67e4a5fc6b7a1d1c94d28)), closes [#10538](https://github.com/vuetifyjs/vuetify/issues/10538)
* **VAutocomplete:** set isFocused to false on blur ([#12031](https://github.com/vuetifyjs/vuetify/issues/12031)) ([93a2ef7](https://github.com/vuetifyjs/vuetify/commit/93a2ef7a01259cef4bdf347aec307b603a4aa2a0)), closes [#11989](https://github.com/vuetifyjs/vuetify/issues/11989)
* **VBanner:** remove bottom-border on outlined banner ([#12548](https://github.com/vuetifyjs/vuetify/issues/12548)) ([49e25bb](https://github.com/vuetifyjs/vuetify/commit/49e25bb565030f65f7ceaacf86a5eb0d497ffb06)), closes [#12172](https://github.com/vuetifyjs/vuetify/issues/12172)
* **VBtn:** add hover effect radius inheritance ([#10956](https://github.com/vuetifyjs/vuetify/issues/10956)) ([001af08](https://github.com/vuetifyjs/vuetify/commit/001af08aeed2a65455429c3a928c9e56262c0882)), closes [#10671](https://github.com/vuetifyjs/vuetify/issues/10671)
* **VCalendar:** don't use nativeOn on native elements ([#11112](https://github.com/vuetifyjs/vuetify/issues/11112)) ([50d6047](https://github.com/vuetifyjs/vuetify/commit/50d60473fabbbc6ec2d22b355a051a56fc13ed39)), closes [#9999](https://github.com/vuetifyjs/vuetify/issues/9999)
* **VCalendar:** event ends midnight ([#11159](https://github.com/vuetifyjs/vuetify/issues/11159)) ([#11168](https://github.com/vuetifyjs/vuetify/issues/11168)) ([ab86223](https://github.com/vuetifyjs/vuetify/commit/ab86223fbbed752dca9da1fdc2d0586159cb1b8e))
* **VCalendar:** missing day-label slot for daily ([#11069](https://github.com/vuetifyjs/vuetify/issues/11069)) ([#11132](https://github.com/vuetifyjs/vuetify/issues/11132)) ([afc99df](https://github.com/vuetifyjs/vuetify/commit/afc99df7b9966379b22e1079c135b86f5189aa22))
* **VCalendar:** no event rendering without default slot ([#11090](https://github.com/vuetifyjs/vuetify/issues/11090)) ([#11131](https://github.com/vuetifyjs/vuetify/issues/11131)) ([e949427](https://github.com/vuetifyjs/vuetify/commit/e9494276cfaee9274ec4fc0e8cad1ba0ae457450))
* **VCalendar:** weekdays and day views conflict ([#11025](https://github.com/vuetifyjs/vuetify/issues/11025)) ([#11129](https://github.com/vuetifyjs/vuetify/issues/11129)) ([c4eb5da](https://github.com/vuetifyjs/vuetify/commit/c4eb5dadd4504a76a279cbe3de8eee0580ff04b3)), closes [#10123](https://github.com/vuetifyjs/vuetify/issues/10123) [#10123](https://github.com/vuetifyjs/vuetify/issues/10123)
* **VCard:** add !default flag to elevation variable ([7746da6](https://github.com/vuetifyjs/vuetify/commit/7746da665f78ad671d0000f672e545e37c949209)), closes [#10869](https://github.com/vuetifyjs/vuetify/issues/10869)
* **VCard:** increase css specificity for outlined hoverable cards ([#11711](https://github.com/vuetifyjs/vuetify/issues/11711)) ([c1ad4a6](https://github.com/vuetifyjs/vuetify/commit/c1ad4a6963fbd3a4e7ac7833f38b61a90ceb616e)), closes [#11672](https://github.com/vuetifyjs/vuetify/issues/11672)
* **VCard:** prevent re-render of first child when loading is toggled ([ac2f03d](https://github.com/vuetifyjs/vuetify/commit/ac2f03d7aea3ef40ada1afaa4be85a9b42b3a3a8)), closes [#10695](https://github.com/vuetifyjs/vuetify/issues/10695)
* **VCheckbox:** spacing issue with dense ([#10407](https://github.com/vuetifyjs/vuetify/issues/10407)) ([7aa8aa0](https://github.com/vuetifyjs/vuetify/commit/7aa8aa0c5555f00118678f57b634f6735ba8459d)), closes [#10336](https://github.com/vuetifyjs/vuetify/issues/10336)
* **VCheckbox,VRadio:** ripple color for colored selection control ([#11299](https://github.com/vuetifyjs/vuetify/issues/11299)) ([4b849fa](https://github.com/vuetifyjs/vuetify/commit/4b849fa4b00508634387715e7325957198d8ff65)), closes [#11290](https://github.com/vuetifyjs/vuetify/issues/11290)
* **VChip:** add close button aria-label ([#12384](https://github.com/vuetifyjs/vuetify/issues/12384)) ([9cd505d](https://github.com/vuetifyjs/vuetify/commit/9cd505d026a7f851f02a5b513a1d48fa2cc590d6))
* **VColorPicker:** center swatch grid ([#10650](https://github.com/vuetifyjs/vuetify/issues/10650)) ([5835890](https://github.com/vuetifyjs/vuetify/commit/58358900f29e4f89854c139944a5009f594beaa1))
* **VColorPicker:** extractColor util ([#12305](https://github.com/vuetifyjs/vuetify/issues/12305)) ([e7f63c5](https://github.com/vuetifyjs/vuetify/commit/e7f63c5fb068dbf094fd24f2b2409b47c3fb933b))
* **VColorPicker:** hide alpha input correctly ([#10411](https://github.com/vuetifyjs/vuetify/issues/10411)) ([33fff67](https://github.com/vuetifyjs/vuetify/commit/33fff6763ae62f9d11595da689e07a5876d4ae99)), closes [#10402](https://github.com/vuetifyjs/vuetify/issues/10402)
* **VColorPicker:** incorrect layout in RTL mode ([#10706](https://github.com/vuetifyjs/vuetify/issues/10706)) ([54ceff6](https://github.com/vuetifyjs/vuetify/commit/54ceff641532629ba4ceff7a812d1161322e8741)), closes [#10655](https://github.com/vuetifyjs/vuetify/issues/10655)
* **VColorPicker:** use theme color for color-picker inputs ([#12289](https://github.com/vuetifyjs/vuetify/issues/12289)) ([87137af](https://github.com/vuetifyjs/vuetify/commit/87137afbac967213a6c9ef428f14448fbcd2aa43)), closes [#12169](https://github.com/vuetifyjs/vuetify/issues/12169)
* **VCombobox:** blur on click outside when empty ([08c503e](https://github.com/vuetifyjs/vuetify/commit/08c503e2e6d3b10f9c9662b9386569826a258787)), closes [#10612](https://github.com/vuetifyjs/vuetify/issues/10612)
* **VCombobox:** don't try to get data from an empty clipboard event ([7106472](https://github.com/vuetifyjs/vuetify/commit/7106472e89fd8474958d28cd89d970fb0390cc6a)), closes [#11187](https://github.com/vuetifyjs/vuetify/issues/11187)
* **VDataFooter:** translate itemsPerPageText ([#12259](https://github.com/vuetifyjs/vuetify/issues/12259)) ([bcfe8ef](https://github.com/vuetifyjs/vuetify/commit/bcfe8efeb187be4138c37dbacca1032e512cbd9f)), closes [#12012](https://github.com/vuetifyjs/vuetify/issues/12012)
* **VDataIterator:** add missing isMobile property to custom item slot scope ([#10345](https://github.com/vuetifyjs/vuetify/issues/10345)) ([f4b4f0a](https://github.com/vuetifyjs/vuetify/commit/f4b4f0aceeda667a2196f799d0a182bc6aea0fbb)), closes [#8394](https://github.com/vuetifyjs/vuetify/issues/8394) [#9436](https://github.com/vuetifyjs/vuetify/issues/9436)
* **VDataIterator:** emit page-count event ([#10652](https://github.com/vuetifyjs/vuetify/issues/10652)) ([4d04771](https://github.com/vuetifyjs/vuetify/commit/4d04771d34bc40328b5f979746cb03b15e999bc0)), closes [#8886](https://github.com/vuetifyjs/vuetify/issues/8886)
* **VDataTable:** add padding for mobile rows ([#11865](https://github.com/vuetifyjs/vuetify/issues/11865)) ([ec2b4b9](https://github.com/vuetifyjs/vuetify/commit/ec2b4b9a2562ba5d007babb73e5eda5fbcd55895)), closes [#8411](https://github.com/vuetifyjs/vuetify/issues/8411) [#11325](https://github.com/vuetifyjs/vuetify/issues/11325)
* **VDataTable:** close multi-sort select when clicking on mobile ([#11332](https://github.com/vuetifyjs/vuetify/issues/11332)) ([6f8d84a](https://github.com/vuetifyjs/vuetify/commit/6f8d84aeecc180ffb023b1405b4dc86c543789a5)), closes [#10735](https://github.com/vuetifyjs/vuetify/issues/10735)
* **VDataTable:** emit pagination event when filtering ([#10651](https://github.com/vuetifyjs/vuetify/issues/10651)) ([7856dba](https://github.com/vuetifyjs/vuetify/commit/7856dbafac5e77fbcfcf7b2c1e0324c4c84acf6d)), closes [#10212](https://github.com/vuetifyjs/vuetify/issues/10212)
* **VDataTable:** group-by column should be included in search ([#10591](https://github.com/vuetifyjs/vuetify/issues/10591)) ([a40e8d3](https://github.com/vuetifyjs/vuetify/commit/a40e8d35db5f8c055274e38fd8daaae60c9c5d84)), closes [#10392](https://github.com/vuetifyjs/vuetify/issues/10392)
* **VDataTable:** group-by should use correct slot ([#10592](https://github.com/vuetifyjs/vuetify/issues/10592)) ([065e93c](https://github.com/vuetifyjs/vuetify/commit/065e93c0be611867c37daa3a5a7b9642289db685)), closes [#10289](https://github.com/vuetifyjs/vuetify/issues/10289)
* **VDataTable:** groups should be sorted according to groupDesc ([#10771](https://github.com/vuetifyjs/vuetify/issues/10771)) ([6471332](https://github.com/vuetifyjs/vuetify/commit/6471332a6ded4f069152f84dc16cbaec7a754d5c)), closes [#10627](https://github.com/vuetifyjs/vuetify/issues/10627)
* **VDataTable:** handle passing zero to itemsPerPage ([#10516](https://github.com/vuetifyjs/vuetify/issues/10516)) ([6cbcd7f](https://github.com/vuetifyjs/vuetify/commit/6cbcd7f3e55102bc74d45fe0dedc64e1c11cda9a)), closes [#10372](https://github.com/vuetifyjs/vuetify/issues/10372)
* **VDataTable:** header with divider rendered incorrectly in mobile sort select ([#11416](https://github.com/vuetifyjs/vuetify/issues/11416)) ([25001a0](https://github.com/vuetifyjs/vuetify/commit/25001a035818f510543c142082242169075ab1ac)), closes [#11399](https://github.com/vuetifyjs/vuetify/issues/11399)
* **VDataTable:** Loading Progress bar pushes content down ([#10169](https://github.com/vuetifyjs/vuetify/issues/10169)) ([6bb6238](https://github.com/vuetifyjs/vuetify/commit/6bb62381995a3bad8dfe45459eaae893b32b06a8))
* **VDataTable:** pagination event fires twice in a row ([#10769](https://github.com/vuetifyjs/vuetify/issues/10769)) ([cfee1b4](https://github.com/vuetifyjs/vuetify/commit/cfee1b4a8cd963f80a5e53d9a8b3e55d78fe9709)), closes [#10715](https://github.com/vuetifyjs/vuetify/issues/10715)
* **VDataTable:** remove hover on empty (no data) wrapper ([#10600](https://github.com/vuetifyjs/vuetify/issues/10600)) ([c978f11](https://github.com/vuetifyjs/vuetify/commit/c978f11e648fc05d76564a2d381772f0fbdd2373))
* **VDataTable:** set initial values for sort-desc and group-desc ([#11342](https://github.com/vuetifyjs/vuetify/issues/11342)) ([450357d](https://github.com/vuetifyjs/vuetify/commit/450357d023afbc35dca9cacd8d1c262ef8002406)), closes [#9685](https://github.com/vuetifyjs/vuetify/issues/9685)
* up-next functionality ([#8](https://github.com/vuetifyjs/vuetify/issues/8)) ([9bba623](https://github.com/vuetifyjs/vuetify/commit/9bba623eb04db8140607b2ca605b8fd1919d4b21))
* **VAutocomplete:** filter items without text values ([f8068ed](https://github.com/vuetifyjs/vuetify/commit/f8068ed6d4905c953463cf898150aae0b940fc3e))
* **VDataTable:** header with divider rendered incorrectly in mobile sort select ([#11416](https://github.com/vuetifyjs/vuetify/issues/11416)) ([d079b1d](https://github.com/vuetifyjs/vuetify/commit/d079b1d61b78a47a5605240f961937ae79ce45c9)), closes [#11399](https://github.com/vuetifyjs/vuetify/issues/11399)
* **VDataTable:** include rows that exclusively match custom filters ([#11181](https://github.com/vuetifyjs/vuetify/issues/11181)) ([239e238](https://github.com/vuetifyjs/vuetify/commit/239e238d69f35064db55e9f41db8fd832f347ab5)), closes [#9887](https://github.com/vuetifyjs/vuetify/issues/9887)
* **VDataTable:** respect mustSort property in options prop ([#11334](https://github.com/vuetifyjs/vuetify/issues/11334)) ([248300f](https://github.com/vuetifyjs/vuetify/commit/248300fdd9f99e1184dcc7f0b67d16be06d78c79)), closes [#10244](https://github.com/vuetifyjs/vuetify/issues/10244)
* **VDataTable:** set initial values for sort-desc and group-desc ([#11342](https://github.com/vuetifyjs/vuetify/issues/11342)) ([8a78533](https://github.com/vuetifyjs/vuetify/commit/8a785333a17a102f9b89dee5d64e25e0809ba6ad)), closes [#9685](https://github.com/vuetifyjs/vuetify/issues/9685)
* **VDataTable:** show correct aria-labels for sorting ([#9638](https://github.com/vuetifyjs/vuetify/issues/9638)) ([e3ea39d](https://github.com/vuetifyjs/vuetify/commit/e3ea39d3842ea14e03b809a5c4e6da2bb597114d)), closes [#4975](https://github.com/vuetifyjs/vuetify/issues/4975)
* **VDatePicker:** locale weeknumber calculation ([#10926](https://github.com/vuetifyjs/vuetify/issues/10926)) ([b7f830a](https://github.com/vuetifyjs/vuetify/commit/b7f830a68127aed058f48859dc22c4c012c751a5)), closes [#9764](https://github.com/vuetifyjs/vuetify/issues/9764)
* **VDatePicker:** set proper tableDate if showCurrent is set ([#11305](https://github.com/vuetifyjs/vuetify/issues/11305)) ([6aa01a7](https://github.com/vuetifyjs/vuetify/commit/6aa01a70bfcf4a9e7baf64ff6afc15ab9ac93980)), closes [#6714](https://github.com/vuetifyjs/vuetify/issues/6714)
* **VDatePicker:** unnecessarily emited change event in range picker ([874553e](https://github.com/vuetifyjs/vuetify/commit/874553ed53c5cd1bed2825590892f3e343246ace)), closes [#11056](https://github.com/vuetifyjs/vuetify/issues/11056)
* **VDialog:** allow more than 1 content node ([cc17fe1](https://github.com/vuetifyjs/vuetify/commit/cc17fe19751826d950ca5207749699935d227020))
* **VDialog:** close on esc when eager is not set ([0e31691](https://github.com/vuetifyjs/vuetify/commit/0e31691db0bcfe0f33cfe67bd43ef17b04ddfe0d)), closes [#11257](https://github.com/vuetifyjs/vuetify/issues/11257)
* **VDialog:** refocus previous element when dialog is closed ([700fd42](https://github.com/vuetifyjs/vuetify/commit/700fd4289d21f83ba17373fd390bf6bb6b52326b)), closes [#7907](https://github.com/vuetifyjs/vuetify/issues/7907)
* **VDialog:** show transition on close ([1491914](https://github.com/vuetifyjs/vuetify/commit/1491914bca565321fc9ef4b28603f48881b25ed3)), closes [#10506](https://github.com/vuetifyjs/vuetify/issues/10506)
* **VDialog:** use the origin prop ([8f6e931](https://github.com/vuetifyjs/vuetify/commit/8f6e9317eee9aa16c3383afe617952eaeffe115b)), closes [#7134](https://github.com/vuetifyjs/vuetify/issues/7134)
* **VFileInput:** avoid input field event capturing in safari ([#11897](https://github.com/vuetifyjs/vuetify/issues/11897)) ([d5800aa](https://github.com/vuetifyjs/vuetify/commit/d5800aad7dc9e62e7d398c890b7af6580e6060ce)), closes [#10832](https://github.com/vuetifyjs/vuetify/issues/10832)
* **VFooter:** only apply width when not using the inset prop ([a7381aa](https://github.com/vuetifyjs/vuetify/commit/a7381aa97c80cdd18b65354048e75397a22e4c36)), closes [#8128](https://github.com/vuetifyjs/vuetify/issues/8128)
* **VGrid:** correct row width in fill-height container ([#10241](https://github.com/vuetifyjs/vuetify/issues/10241)) ([9d69b75](https://github.com/vuetifyjs/vuetify/commit/9d69b752b64d5e8c7f18bbaacbb0d35282dfa400)), closes [#9773](https://github.com/vuetifyjs/vuetify/issues/9773)
* **VIcon:** add missing width attribute when rendering svg icons ([#10942](https://github.com/vuetifyjs/vuetify/issues/10942)) ([2112add](https://github.com/vuetifyjs/vuetify/commit/2112addbab8d8464d5b6671abe6b4f045b1350fa)), closes [#10938](https://github.com/vuetifyjs/vuetify/issues/10938)
* **VIcon:** add top and left to pseudo class for IE11 ([a3d0cf7](https://github.com/vuetifyjs/vuetify/commit/a3d0cf763f506856add1c0367857db1f16ab6338)), closes [#11686](https://github.com/vuetifyjs/vuetify/issues/11686)
* **VIcon:** change default icon svg size to match regular icon ([#10507](https://github.com/vuetifyjs/vuetify/issues/10507)) ([2045295](https://github.com/vuetifyjs/vuetify/commit/20452950e84a2593eeb0a4a7b67517f40e4f9912))
* **VIcon:** render a button element around clickable component icons ([#12148](https://github.com/vuetifyjs/vuetify/issues/12148)) ([7bddf2b](https://github.com/vuetifyjs/vuetify/commit/7bddf2b5d0b1aba7443fd2a3d3b798904751c8a1)), closes [#12143](https://github.com/vuetifyjs/vuetify/issues/12143)
* **VIcon:** revert opacity changes, only show focus ring ([de967ac](https://github.com/vuetifyjs/vuetify/commit/de967aca925d06f9af32907a3be1f0170e024e70))
* **VIcon:** use a button element for clickable icons ([#10439](https://github.com/vuetifyjs/vuetify/issues/10439)) ([1596e55](https://github.com/vuetifyjs/vuetify/commit/1596e55a885cb9c91e63bef5018f15c9f5a55ef2)), closes [#10265](https://github.com/vuetifyjs/vuetify/issues/10265) [#10391](https://github.com/vuetifyjs/vuetify/issues/10391) [#10398](https://github.com/vuetifyjs/vuetify/issues/10398)
* **VImg:** correctly pass options to intersect directive ([#10855](https://github.com/vuetifyjs/vuetify/issues/10855)) ([2133162](https://github.com/vuetifyjs/vuetify/commit/21331625b9707f19cc2004f2e0957b288a2ccad3)), closes [#10848](https://github.com/vuetifyjs/vuetify/issues/10848)
* **VInput:** show bottom border when loading prop is null ([0f9b034](https://github.com/vuetifyjs/vuetify/commit/0f9b03414b9d73e5a4501b1d9190d206c035a08d)), closes [#10828](https://github.com/vuetifyjs/vuetify/issues/10828)
* **VList:** use tag prop ([fb062bf](https://github.com/vuetifyjs/vuetify/commit/fb062bfa9e27d93cad6c10d095ae70c830deb6b9)), closes [#10529](https://github.com/vuetifyjs/vuetify/issues/10529)
* **VListItem:** vertical alignment on IE11 ([#10717](https://github.com/vuetifyjs/vuetify/issues/10717)) ([81dfbf8](https://github.com/vuetifyjs/vuetify/commit/81dfbf8e4ac6bf6fbbc0e61e121245a4e68f56bf)), closes [#10464](https://github.com/vuetifyjs/vuetify/issues/10464) [#10464](https://github.com/vuetifyjs/vuetify/issues/10464)
* **VMenu:** allow more than 1 content node ([#10525](https://github.com/vuetifyjs/vuetify/issues/10525)) ([5d8d487](https://github.com/vuetifyjs/vuetify/commit/5d8d4871c3b916090b11749ca83852616f49415b)), closes [#10522](https://github.com/vuetifyjs/vuetify/issues/10522)
* **VMenu:** remove events from old element when activator changes ([0a6946a](https://github.com/vuetifyjs/vuetify/commit/0a6946ae192a40ac9cfa80e86a3cc188b67c4a8e)), closes [#10430](https://github.com/vuetifyjs/vuetify/issues/10430)
* **VMenu:** set dimensions to 0 if content does not exist yet ([5358676](https://github.com/vuetifyjs/vuetify/commit/5358676771df99ef0adeca1c2d230f6374e5189a)), closes [#10606](https://github.com/vuetifyjs/vuetify/issues/10606)
* **VMessages/VCounter:** resolve layout jump caused by incorrect line-height ([5c8be69](https://github.com/vuetifyjs/vuetify/commit/5c8be69fc4044d9245cdec40c34a228f23c1339a))
* **VNavigationDrawer:** change closed navigation drawer visibility ([#10824](https://github.com/vuetifyjs/vuetify/issues/10824)) ([0a0f44d](https://github.com/vuetifyjs/vuetify/commit/0a0f44d13c25f7aa8c194a161b98b4bf5486bc41)), closes [#10821](https://github.com/vuetifyjs/vuetify/issues/10821)
* **VNavigationDrawer:** disable inherit value of background property ([#11419](https://github.com/vuetifyjs/vuetify/issues/11419)) ([9900388](https://github.com/vuetifyjs/vuetify/commit/9900388e126e77a5d76c500db7cb70f226c020b4)), closes [#11153](https://github.com/vuetifyjs/vuetify/issues/11153)
* **VNavigationDrawer:** dynamic expand-on-hover ([#10903](https://github.com/vuetifyjs/vuetify/issues/10903)) ([a4fe6f5](https://github.com/vuetifyjs/vuetify/commit/a4fe6f5bcf12c713d94760c360e83503345fb1b3)), closes [#10862](https://github.com/vuetifyjs/vuetify/issues/10862)
* **VNavigationDrawer:** scrolling in temporary hide-overlay ([#10759](https://github.com/vuetifyjs/vuetify/issues/10759)) ([8c99fee](https://github.com/vuetifyjs/vuetify/commit/8c99fee1aedc8517dbef1d2164c07782fb4a49f2)), closes [#10758](https://github.com/vuetifyjs/vuetify/issues/10758)
* **VPagination:** add interesectable support ([f245833](https://github.com/vuetifyjs/vuetify/commit/f245833a07e8a998a7312188620fd383069b8f8f)), closes [#2434](https://github.com/vuetifyjs/vuetify/issues/2434)
* **VProgressCircular:** dark theme background color clash ([#12192](https://github.com/vuetifyjs/vuetify/issues/12192)) ([a95840e](https://github.com/vuetifyjs/vuetify/commit/a95840eceb536de265c09deca30138ad826b8fa9))
* **VProgressLinear:** use both horizontal and vertical repeat ([#10876](https://github.com/vuetifyjs/vuetify/issues/10876)) ([583c811](https://github.com/vuetifyjs/vuetify/commit/583c8116fe3418428964ba29ba5b4da43c223d51)), closes [#10852](https://github.com/vuetifyjs/vuetify/issues/10852)
* **VRadioGroup:** apply legend style changes only when using row ([f0ceca0](https://github.com/vuetifyjs/vuetify/commit/f0ceca0e3050e684f9ffc82ba81dbf6429272fa0)), closes [#10403](https://github.com/vuetifyjs/vuetify/issues/10403)
* **VRangeSlider:** add unique id for inputs elements ([#10654](https://github.com/vuetifyjs/vuetify/issues/10654)) ([1244991](https://github.com/vuetifyjs/vuetify/commit/12449918fbe8d955de54cea43e74a008b4e46195)), closes [#6843](https://github.com/vuetifyjs/vuetify/issues/6843) [#6843](https://github.com/vuetifyjs/vuetify/issues/6843)
* **VRangeSlider:** incorrect slider width when disabled ([#11307](https://github.com/vuetifyjs/vuetify/issues/11307)) ([ee73538](https://github.com/vuetifyjs/vuetify/commit/ee73538d18bb3094c4c94dcb77468089ed37be5a)), closes [#11302](https://github.com/vuetifyjs/vuetify/issues/11302)
* **VRating:** remove tabindex from icons ([6e6d6b8](https://github.com/vuetifyjs/vuetify/commit/6e6d6b8c6ca3fc358b738138f22bde1cccc5758e)), closes [#10379](https://github.com/vuetifyjs/vuetify/issues/10379)
* **VRipple:** add keyboard trigger support ([#10304](https://github.com/vuetifyjs/vuetify/issues/10304)) ([b745d00](https://github.com/vuetifyjs/vuetify/commit/b745d006d05e2998c993152de826b5986ee13e58)), closes [#10285](https://github.com/vuetifyjs/vuetify/issues/10285)
* **VSelect:** add Y offset to menu to match material guidelines ([#10940](https://github.com/vuetifyjs/vuetify/issues/10940)) ([3586847](https://github.com/vuetifyjs/vuetify/commit/3586847f1ce45f424a40fe11bb65c812780bf70f)), closes [#10859](https://github.com/vuetifyjs/vuetify/issues/10859)
* **VSelect:** allow blur from outside click ([47b2535](https://github.com/vuetifyjs/vuetify/commit/47b25358be37df38d493dc34ffedadce8695622c))
* **VSelect:** allow tab key down on read-only ([#11431](https://github.com/vuetifyjs/vuetify/issues/11431)) ([66d37b3](https://github.com/vuetifyjs/vuetify/commit/66d37b3cdf344fc73de101c05b2406f0cd034167)), closes [#11430](https://github.com/vuetifyjs/vuetify/issues/11430)
* **VSelect:** do not open menu if clicking on selection item ([#12343](https://github.com/vuetifyjs/vuetify/issues/12343)) ([dcfbca6](https://github.com/vuetifyjs/vuetify/commit/dcfbca6e532a4591cd51dfc40dc075007322bdfd)), closes [#11824](https://github.com/vuetifyjs/vuetify/issues/11824)
* **VSelect:** don't close when a detachable child is clicked ([5077c3c](https://github.com/vuetifyjs/vuetify/commit/5077c3cd67875e7e2f3f158ab445bc0eed212b62)), closes [#12354](https://github.com/vuetifyjs/vuetify/issues/12354)
* allow $material-dark-elevation-colors to be overridden ([#12340](https://github.com/vuetifyjs/vuetify/issues/12340)) ([41cbb3a](https://github.com/vuetifyjs/vuetify/commit/41cbb3a30ff1f5eecadb6c0f6f4e59305ab14957))
* **VExpandTransition:** Properly trigger transition listeners ([#12019](https://github.com/vuetifyjs/vuetify/issues/12019)) ([b6e27f6](https://github.com/vuetifyjs/vuetify/commit/b6e27f6fa7d981ee4a79118aaaacabc08db7a2ae)), closes [#12018](https://github.com/vuetifyjs/vuetify/issues/12018)
* **VFileInput:** file-input-slot dense min-height ([#12570](https://github.com/vuetifyjs/vuetify/issues/12570)) ([3e65162](https://github.com/vuetifyjs/vuetify/commit/3e651624a9fbb55c63e1c14430481120b3df8c4b))
* **VIcon:** don't apply fill styles to component icons ([eaf2f1b](https://github.com/vuetifyjs/vuetify/commit/eaf2f1b21a0e1ffa1458c4dd5338d618dfeeee2f)), closes [#12378](https://github.com/vuetifyjs/vuetify/issues/12378) [#12148](https://github.com/vuetifyjs/vuetify/issues/12148)
* **VIcon:** set svg dimensions in style instead of attributes ([#12319](https://github.com/vuetifyjs/vuetify/issues/12319)) ([3576aa5](https://github.com/vuetifyjs/vuetify/commit/3576aa5b52c954b603e4897725dfabfd709b78f2)), closes [#12372](https://github.com/vuetifyjs/vuetify/issues/12372) [#12148](https://github.com/vuetifyjs/vuetify/issues/12148)
* **VInput:** use $label-letter-spacing variable ([#12546](https://github.com/vuetifyjs/vuetify/issues/12546)) ([915fbaa](https://github.com/vuetifyjs/vuetify/commit/915fbaa5d964c7f4563658779e02c7c4c9b29fb7))
* **VLinearProgress:** remove unnecessary z-index ([#12386](https://github.com/vuetifyjs/vuetify/issues/12386)) ([7c8b0b4](https://github.com/vuetifyjs/vuetify/commit/7c8b0b4076ec1042c1892cc49f0adc4ce1159472)), closes [#11847](https://github.com/vuetifyjs/vuetify/issues/11847)
* **VListitem:** disable mouse click in animating menu ([#12059](https://github.com/vuetifyjs/vuetify/issues/12059)) ([0b8ec25](https://github.com/vuetifyjs/vuetify/commit/0b8ec251b47bcc4f5b1924716c71805d49c3c1e5)), closes [#12021](https://github.com/vuetifyjs/vuetify/issues/12021)
* **VMenu:** open-on-hover does not close on-content-click ([#12566](https://github.com/vuetifyjs/vuetify/issues/12566)) ([389d023](https://github.com/vuetifyjs/vuetify/commit/389d023811c66f057a08ddb83f1f41bcf9080c08))
* **VPagination:** Add support for 0 totalVisible items ([#12456](https://github.com/vuetifyjs/vuetify/issues/12456)) ([53ba1d8](https://github.com/vuetifyjs/vuetify/commit/53ba1d830425d5746a803fefe02d928f12848db7))
* **VRadio:** do not use cursor pointer if disabled ([#12058](https://github.com/vuetifyjs/vuetify/issues/12058)) ([42c79b7](https://github.com/vuetifyjs/vuetify/commit/42c79b760650d50f37e710bf9e1e175b5a884d12)), closes [#12023](https://github.com/vuetifyjs/vuetify/issues/12023)
* **VRadioGroup:** label styles ([#12382](https://github.com/vuetifyjs/vuetify/issues/12382)) ([c61093f](https://github.com/vuetifyjs/vuetify/commit/c61093ff465fdf9c1d7b99d12ec973a9f7b83eb0))
* **VSelect:** do not deduplicate headers or dividers ([4a855cd](https://github.com/vuetifyjs/vuetify/commit/4a855cd8d940c35fc01c5a8521ff539c7491eda1)), closes [#12517](https://github.com/vuetifyjs/vuetify/issues/12517)
* **VSelect:** do not highlight search text without an item match ([#12163](https://github.com/vuetifyjs/vuetify/issues/12163)) ([148ecf5](https://github.com/vuetifyjs/vuetify/commit/148ecf522382dc8f3c32d092740d87810d0d5f39)), closes [#10843](https://github.com/vuetifyjs/vuetify/issues/10843)
* **VSimpleTable:** add border radius to first and last row  ([#12553](https://github.com/vuetifyjs/vuetify/issues/12553)) ([36080ca](https://github.com/vuetifyjs/vuetify/commit/36080caac7e4f49a5601ee7826f093df3c9bef62))
* **VSlider:** disable input tag ([#12630](https://github.com/vuetifyjs/vuetify/issues/12630)) ([36300b2](https://github.com/vuetifyjs/vuetify/commit/36300b2cadf3ebe93091d5df67cfa25dfb2c0348)), closes [#12620](https://github.com/vuetifyjs/vuetify/issues/12620)
* **VSnackbar:** remove transparent background with text/outlined props ([3dbd910](https://github.com/vuetifyjs/vuetify/commit/3dbd910ebebcb77077f0d90688523872a016dad3)), closes [#11835](https://github.com/vuetifyjs/vuetify/issues/11835)
* **VSparkline:** show path when all values are the same ([020e2e1](https://github.com/vuetifyjs/vuetify/commit/020e2e10bd47f0eae996dc471647cf84aef4b58e))
* **VTabs:** resize slider when icons-and-text prop changes ([#12525](https://github.com/vuetifyjs/vuetify/issues/12525)) ([aac7c54](https://github.com/vuetifyjs/vuetify/commit/aac7c54b053af96881c36efa222243d7206df73e)), closes [#12524](https://github.com/vuetifyjs/vuetify/issues/12524)
* **VTextField:** add background color to line on focus ([#12556](https://github.com/vuetifyjs/vuetify/issues/12556)) ([3e78556](https://github.com/vuetifyjs/vuetify/commit/3e78556d9c903f09382b7eaad68140ef559ee07f))
* **VTextField:** count characters instead of codepoints ([#12451](https://github.com/vuetifyjs/vuetify/issues/12451)) ([c048a77](https://github.com/vuetifyjs/vuetify/commit/c048a77660f47055676fd22d6b0b0957e0a47821))
* **VTextField:** count non-string types ([#12475](https://github.com/vuetifyjs/vuetify/issues/12475)) ([5dec772](https://github.com/vuetifyjs/vuetify/commit/5dec772bc64241aa1f9ceb9b971c19e215027b5d)), closes [#12451](https://github.com/vuetifyjs/vuetify/issues/12451)
* **VTextField:** remove erroneous white space for outlined style ([#11748](https://github.com/vuetifyjs/vuetify/issues/11748)) ([d723457](https://github.com/vuetifyjs/vuetify/commit/d723457218f35506aa8beb05c319dc45369c5e8b))
* **VTextField:** show label slot when filled prop is used ([#12371](https://github.com/vuetifyjs/vuetify/issues/12371)) ([d7d77a3](https://github.com/vuetifyjs/vuetify/commit/d7d77a3aef1d5e6699a4fdd797e3c3052b2954a6)), closes [#11533](https://github.com/vuetifyjs/vuetify/issues/11533)
* **VTextField:** use resize directive to recalculate elements width ([#11816](https://github.com/vuetifyjs/vuetify/issues/11816)) ([4efd18d](https://github.com/vuetifyjs/vuetify/commit/4efd18da09d816d5a4b1c9cc65e630f4a0985b7f))
* **VTimePicker:** add flex-basis property to container for safari 52 support ([#12239](https://github.com/vuetifyjs/vuetify/issues/12239)) ([98b510b](https://github.com/vuetifyjs/vuetify/commit/98b510b2d68a4b064fa2c4fa65f812a681450e38))
* **VToolbar:** v-toolbar sass variables typo ([#12547](https://github.com/vuetifyjs/vuetify/issues/12547)) ([11c746e](https://github.com/vuetifyjs/vuetify/commit/11c746e1005dc892d3c555f707f871d69d7bcad4))
* **VTreeView:** don't render filtered-out items ([45767d2](https://github.com/vuetifyjs/vuetify/commit/45767d2b5fcec06db3ac32f3f335f46849110e75)), closes [#11872](https://github.com/vuetifyjs/vuetify/issues/11872)
* **VVirtualScroll:** pass through native events ([c2734d3](https://github.com/vuetifyjs/vuetify/commit/c2734d3e7721ad794de84c89ce0486869580742c)), closes [#12077](https://github.com/vuetifyjs/vuetify/issues/12077)
* change curser:default selector to [aria-disabled="true"] ([#11467](https://github.com/vuetifyjs/vuetify/issues/11467)) ([04781b6](https://github.com/vuetifyjs/vuetify/commit/04781b65079935205ed2f81a30d100e6591e756c)), closes [#11003](https://github.com/vuetifyjs/vuetify/issues/11003)
* change type import paths ([#11314](https://github.com/vuetifyjs/vuetify/issues/11314)) ([2325dd9](https://github.com/vuetifyjs/vuetify/commit/2325dd9570b0fa543277304369010853c09034f8))
* do not render vuetify ads if there is no data ([#4](https://github.com/vuetifyjs/vuetify/issues/4)) ([f4315e4](https://github.com/vuetifyjs/vuetify/commit/f4315e46db3d3f1d48c3fd0d8b2c3ef9c19d2d26))
* markdown disappears on hmr update ([7035257](https://github.com/vuetifyjs/vuetify/commit/7035257f7e6a252c7156245b5c3884ff3cdb2d99))
* use $ssrContext instead of options.ssrContext ([5da64d2](https://github.com/vuetifyjs/vuetify/commit/5da64d2f1ab00e6a658f65cfb616de9abd61a1ce)), closes [#11935](https://github.com/vuetifyjs/vuetify/issues/11935)
* **_reset.css:** add removed overflow to html ([6663607](https://github.com/vuetifyjs/vuetify/commit/666360731830dc142b63a0b73f651bbece71e02e))
* **activatable:** stop activator event listener propagation ([be58395](https://github.com/vuetifyjs/vuetify/commit/be583953ed4cf9a5a374df2a09fe5aeb34937204)), closes [#3333](https://github.com/vuetifyjs/vuetify/issues/3333)
* **application-service:** overwrite location sizes when registering ([59a6bbf](https://github.com/vuetifyjs/vuetify/commit/59a6bbf8cf02a8e1565db6b268741c7c655c0176)), closes [#9797](https://github.com/vuetifyjs/vuetify/issues/9797)
* **bootable:** don't generate lazy content until it's rendered ([#8823](https://github.com/vuetifyjs/vuetify/issues/8823)) ([2b975f5](https://github.com/vuetifyjs/vuetify/commit/2b975f575f47ba75aa5d0dd9fba859595c7b9ba4)), closes [#8712](https://github.com/vuetifyjs/vuetify/issues/8712) [#8712](https://github.com/vuetifyjs/vuetify/issues/8712)
* **css-reset:** add missing comma for style declaration ([3a347a1](https://github.com/vuetifyjs/vuetify/commit/3a347a153e39cfe25f3ce6de1059c64a61ae7438)), closes [#9521](https://github.com/vuetifyjs/vuetify/issues/9521)
* **detachable:** change detach target ([6d001c7](https://github.com/vuetifyjs/vuetify/commit/6d001c7cf7b4ddd0059a127d3fed752b971949d1)), closes [#9906](https://github.com/vuetifyjs/vuetify/issues/9906)
* **form-controls:** fix disabled styles ([#10191](https://github.com/vuetifyjs/vuetify/issues/10191)) ([b4ad01a](https://github.com/vuetifyjs/vuetify/commit/b4ad01a4d1308616135fc158c85373ffe88707e6)), closes [#9488](https://github.com/vuetifyjs/vuetify/issues/9488) [#10154](https://github.com/vuetifyjs/vuetify/issues/10154)
* **framework:** update colors to match spec ([103becb](https://github.com/vuetifyjs/vuetify/commit/103becbc795c1870515ec703ba0b26447ba96e79))
* **helpers:** check if source property is object ([5a4578c](https://github.com/vuetifyjs/vuetify/commit/5a4578cde6f842b5e75362eacb88d712e7ea7c60)), closes [#10100](https://github.com/vuetifyjs/vuetify/issues/10100)
* **icons:** add missing faSvg type to iconfont ([#9996](https://github.com/vuetifyjs/vuetify/issues/9996)) ([12d03d7](https://github.com/vuetifyjs/vuetify/commit/12d03d7f7975a8fcdbe694495235b2419591b94f))
* **icons:** add support for font awesome svg icons ([#8092](https://github.com/vuetifyjs/vuetify/issues/8092)) ([37ce47b](https://github.com/vuetifyjs/vuetify/commit/37ce47be306678c66bf3d9662030e824df582266)), closes [#8016](https://github.com/vuetifyjs/vuetify/issues/8016)
* **icons:** add support for font awesome svg icons ([#8092](https://github.com/vuetifyjs/vuetify/issues/8092)) ([c4b7225](https://github.com/vuetifyjs/vuetify/commit/c4b722578855ceb78d3f00d3f6c0adb99b794106)), closes [#8016](https://github.com/vuetifyjs/vuetify/issues/8016)
* **locale:** Updated Turkish translation for Carousel ([a49dbb2](https://github.com/vuetifyjs/vuetify/commit/a49dbb2c468531cf28122e664d2c2435b855f509))
* **locales:** update hu-Hungarian 1i8n translations ([#11719](https://github.com/vuetifyjs/vuetify/issues/11719)) ([ed17793](https://github.com/vuetifyjs/vuetify/commit/ed177930cefeaf62433568c6c68d2313cfd4407b))
* **presets:** export interfaces ([#10161](https://github.com/vuetifyjs/vuetify/issues/10161)) ([843a875](https://github.com/vuetifyjs/vuetify/commit/843a87534bd229eba1346b7f105aa76c7fdd188b))
* **sass:** allow overriding $spacers ([6d913d3](https://github.com/vuetifyjs/vuetify/commit/6d913d32cf25e53abd2190fee19c25241500a8c3)), closes [#10303](https://github.com/vuetifyjs/vuetify/issues/10303)
* **sass variables:** add missing !default suffixes to numerous variables ([#11760](https://github.com/vuetifyjs/vuetify/issues/11760)) ([77a0a91](https://github.com/vuetifyjs/vuetify/commit/77a0a918378a33f18d48c381a7b7d20a1e41e943)), closes [#11751](https://github.com/vuetifyjs/vuetify/issues/11751)
* **selection-controls:** refactor click event handling ([f055c36](https://github.com/vuetifyjs/vuetify/commit/f055c3627f76fdd9f7b966dd9a6ba1868401a325)), closes [#5968](https://github.com/vuetifyjs/vuetify/issues/5968) [#9408](https://github.com/vuetifyjs/vuetify/issues/9408)
* **SelectionControls:** change selection-control disabled color ([f6ef33c](https://github.com/vuetifyjs/vuetify/commit/f6ef33c64c2fc453d4157524a3e2c587ad5de944)), closes [#9280](https://github.com/vuetifyjs/vuetify/issues/9280)
* **SelectionControls:** properly align slotted labels ([840f0ce](https://github.com/vuetifyjs/vuetify/commit/840f0ce54bd3946524908f374b5e7d6625714ef9)), closes [#10214](https://github.com/vuetifyjs/vuetify/issues/10214)
* **SelectionControls:** resolve height issues with wrapped labels in radios ([22aa469](https://github.com/vuetifyjs/vuetify/commit/22aa46965ca8a3e762d7e8c1c0f58bd689ab2571)), closes [#10360](https://github.com/vuetifyjs/vuetify/issues/10360)
* **ssr:** don't assume $el exists ([9f42467](https://github.com/vuetifyjs/vuetify/commit/9f424675829aea46b1cf4eb2a02922cc59722115)), closes [#11903](https://github.com/vuetifyjs/vuetify/issues/11903)
* **ssr:** use xs breakpoint on inital render when hydrating ([#11842](https://github.com/vuetifyjs/vuetify/issues/11842)) ([56f5668](https://github.com/vuetifyjs/vuetify/commit/56f5668d27b6ac0a52c792fb9745164155faa8e3)), closes [#3436](https://github.com/vuetifyjs/vuetify/issues/3436) [#7410](https://github.com/vuetifyjs/vuetify/issues/7410)
* **sw:** don't register the service worker is it's not available ([#75](https://github.com/vuetifyjs/vuetify/issues/75)) ([31f9eaa](https://github.com/vuetifyjs/vuetify/commit/31f9eaa53f370d48f82508f801c69c91c00d17fd))
* **TeamMembers:** fix md size ([#132](https://github.com/vuetifyjs/vuetify/issues/132)) ([940a5cc](https://github.com/vuetifyjs/vuetify/commit/940a5cc43e72d6342428f55c8dfc5d7ff9ef712f))
* **theme:** apply correct material theme for dark variants ([24c95f4](https://github.com/vuetifyjs/vuetify/commit/24c95f45e0b3821718ff62600ae876ebed7a4896))
* **theme:** resolve more dark variant inconsistences ([07a285f](https://github.com/vuetifyjs/vuetify/commit/07a285f9f72fdf97c7eb751baf532f3c8614c30b))
* **types:** add faSvg to icon's service IconFont type ([#10103](https://github.com/vuetifyjs/vuetify/issues/10103)) ([7235ff0](https://github.com/vuetifyjs/vuetify/commit/7235ff0366a8b3ba40b07ce016ddd58f24d19aec))
* **v-ripple:** remove the correct event listener ([#10062](https://github.com/vuetifyjs/vuetify/issues/10062)) ([e4c35ae](https://github.com/vuetifyjs/vuetify/commit/e4c35ae958ca56f62ccd00295085212ec6d06944))
* **VAlert:** fix transition irregularities ([5f35eff](https://github.com/vuetifyjs/vuetify/commit/5f35eff8d54fdf170ac5d2c18b57fa6e695eec25)), closes [#9033](https://github.com/vuetifyjs/vuetify/issues/9033)
* **VAlert:** pass events through to root element ([05e7d22](https://github.com/vuetifyjs/vuetify/commit/05e7d22d5f55d551afc77e69d9bc7131a0efc7e8)), closes [#11929](https://github.com/vuetifyjs/vuetify/issues/11929)
* **validatable:** properly handle boolean false as fn return ([2ac7392](https://github.com/vuetifyjs/vuetify/commit/2ac739221d43b2d9ada4a970e084263d2124561f)), closes [#9976](https://github.com/vuetifyjs/vuetify/issues/9976)
* **validatable:** validate on blur after value has persisted ([33132a2](https://github.com/vuetifyjs/vuetify/commit/33132a2277f50f3c20f56312a555e211dde30f25)), closes [#10174](https://github.com/vuetifyjs/vuetify/issues/10174)
* **VAutocomplete:** avoid setting selectedIndex to 0 after delete ([#10063](https://github.com/vuetifyjs/vuetify/issues/10063)) ([1d5ca2d](https://github.com/vuetifyjs/vuetify/commit/1d5ca2dceb71fe52d205cdb1e4e4d11e0e54e5cc)), closes [#10036](https://github.com/vuetifyjs/vuetify/issues/10036)
* **VAutocomplete:** property delete chip in single mode ([#9657](https://github.com/vuetifyjs/vuetify/issues/9657)) ([c5cddba](https://github.com/vuetifyjs/vuetify/commit/c5cddba13f7e112a4bb652f704a1aa86d962e654)), closes [#9654](https://github.com/vuetifyjs/vuetify/issues/9654)
* **VAutocomplete:** removeEventListener when destroyed ([#11811](https://github.com/vuetifyjs/vuetify/issues/11811)) ([e7c6ed5](https://github.com/vuetifyjs/vuetify/commit/e7c6ed504af01e8f87a6835cd4d955bcc7e3562e))
* **VAvatar:** hide overflow ([#10001](https://github.com/vuetifyjs/vuetify/issues/10001)) ([ecb0a73](https://github.com/vuetifyjs/vuetify/commit/ecb0a73877fb7e43734c13a2c21071ab27111c6d)), closes [#10000](https://github.com/vuetifyjs/vuetify/issues/10000)
* **VBadge:** oblong circle when using v-icon ([a5b9cbc](https://github.com/vuetifyjs/vuetify/commit/a5b9cbc17ed44e62ba65d14a364a13cdae8a0c70)), closes [#10054](https://github.com/vuetifyjs/vuetify/issues/10054)
* **VBadge:** re-enable pointer-events ([1583d7c](https://github.com/vuetifyjs/vuetify/commit/1583d7c127397e5b58d9fde979c135795da21993)), closes [#10144](https://github.com/vuetifyjs/vuetify/issues/10144) [#10125](https://github.com/vuetifyjs/vuetify/issues/10125)
* **VBadge:** re-enable pointer-events ([bc662b9](https://github.com/vuetifyjs/vuetify/commit/bc662b9e029c3cbc4250a95f0377a14e45ac080d)), closes [#10125](https://github.com/vuetifyjs/vuetify/issues/10125)
* **VBanner:** gated vuetify application support with sticky ([56d47f0](https://github.com/vuetifyjs/vuetify/commit/56d47f011362b1d6e38fa107973e6c5fbde78ee4))
* **VBanner:** hook up missing color support ([8f1ed83](https://github.com/vuetifyjs/vuetify/commit/8f1ed83424c7240ce1878c522d757eac32d3b149)), closes [#10216](https://github.com/vuetifyjs/vuetify/issues/10216)
* **VBanner:** pass attributes to v-banner element ([ddb2b9f](https://github.com/vuetifyjs/vuetify/commit/ddb2b9f980d497f2fa75fc8676bd15f07b46c89d)), closes [#9837](https://github.com/vuetifyjs/vuetify/issues/9837)
* **VBanner:** remove cached slot ([1d62d23](https://github.com/vuetifyjs/vuetify/commit/1d62d239e293f7a2963290e8839db0bae770928f))
* **VBottomSheet:** remove min-width and update flex ([22cf5a1](https://github.com/vuetifyjs/vuetify/commit/22cf5a195f50dd3085acc48f4f7040ebeadcd0f0)), closes [#10261](https://github.com/vuetifyjs/vuetify/issues/10261)
* **VBtn:** add back tile prop ([137186a](https://github.com/vuetifyjs/vuetify/commit/137186a7534c04743e5a36c6934a209a22854f30))
* **VBtn:** add missing sass variable for text-transform ([9cd96a8](https://github.com/vuetifyjs/vuetify/commit/9cd96a88e81c69e9fe2c8e20f518ab39a0ff21cc)), closes [#8619](https://github.com/vuetifyjs/vuetify/issues/8619)
* **VBtn:** normalize width behavior ([426dd02](https://github.com/vuetifyjs/vuetify/commit/426dd027dee22cfc875b3a099e299bd6799fd27d)), closes [#8699](https://github.com/vuetifyjs/vuetify/issues/8699)
* **VBtn:** remove max width ([e02a6d1](https://github.com/vuetifyjs/vuetify/commit/e02a6d1a5c5cbc91940356ffa3a20e8045da9941)), closes [#9968](https://github.com/vuetifyjs/vuetify/issues/9968)
* **VBtnToggle:** add missing RTL support in button groups ([#11849](https://github.com/vuetifyjs/vuetify/issues/11849)) ([75f2bf3](https://github.com/vuetifyjs/vuetify/commit/75f2bf39c667ae1c7d93451fdd937fed60c163c7)), closes [#11793](https://github.com/vuetifyjs/vuetify/issues/11793)
* **VCalendar:** validation, style, slot, event, and formatting fixes ([#9862](https://github.com/vuetifyjs/vuetify/issues/9862)) ([fc0ced9](https://github.com/vuetifyjs/vuetify/commit/fc0ced90a5763579815dd0fa9ed44d5fc8e0a4bd)), closes [#8429](https://github.com/vuetifyjs/vuetify/issues/8429) [#7992](https://github.com/vuetifyjs/vuetify/issues/7992) [#8870](https://github.com/vuetifyjs/vuetify/issues/8870) [#9208](https://github.com/vuetifyjs/vuetify/issues/9208) [#9154](https://github.com/vuetifyjs/vuetify/issues/9154) [#8971](https://github.com/vuetifyjs/vuetify/issues/8971) [#8525](https://github.com/vuetifyjs/vuetify/issues/8525) [#8849](https://github.com/vuetifyjs/vuetify/issues/8849) [#8342](https://github.com/vuetifyjs/vuetify/issues/8342) [#8668](https://github.com/vuetifyjs/vuetify/issues/8668) [#9114](https://github.com/vuetifyjs/vuetify/issues/9114)
* **VCalendar:** wait for animation frame before updating events ([b9809d2](https://github.com/vuetifyjs/vuetify/commit/b9809d2c3a0557898de45ba001e1b0d0bc15472b)), closes [#10168](https://github.com/vuetifyjs/vuetify/issues/10168)
* **VCard:** loading shouldn't disable the card ([#9892](https://github.com/vuetifyjs/vuetify/issues/9892)) ([bb12b96](https://github.com/vuetifyjs/vuetify/commit/bb12b961d392ac2cf12d84936faef1e62e55e233)), closes [#9889](https://github.com/vuetifyjs/vuetify/issues/9889)
* **VCard:** switched sass var values ([cfb90e2](https://github.com/vuetifyjs/vuetify/commit/cfb90e25f55cc363c4ece546ae537db4e490cb84))
* **VCardActions:** scope v-btn styles to direct children ([b33fa17](https://github.com/vuetifyjs/vuetify/commit/b33fa17421574fdb57d908cd8516103db9149151)), closes [#10118](https://github.com/vuetifyjs/vuetify/issues/10118)
* **VCheckbox:** properly style checkbox icon with fa iconfont ([2af8c6d](https://github.com/vuetifyjs/vuetify/commit/2af8c6d5c53cfecac79dc8d6cd603c4a5d17665f)), closes [#10157](https://github.com/vuetifyjs/vuetify/issues/10157)
* **VChip:** prevent navigation on close icon click ([c486693](https://github.com/vuetifyjs/vuetify/commit/c4866935a8949d1141f56d8f19d99b838cea6c52)), closes [#10166](https://github.com/vuetifyjs/vuetify/issues/10166)
* **VChip:** remove user-selection when used as link ([603496e](https://github.com/vuetifyjs/vuetify/commit/603496ec78327945407293930864b84a4ea495af)), closes [#9737](https://github.com/vuetifyjs/vuetify/issues/9737)
* **VChip:** resolve jumpy animation when toggling active state ([f703c9b](https://github.com/vuetifyjs/vuetify/commit/f703c9bb0f5f40a13c7fc829b937e3f03ccc2402))
* **VChip:** scope close icon styles ([4f151bb](https://github.com/vuetifyjs/vuetify/commit/4f151bbdf4388e76d92920ca19c6271c022e6c3f)), closes [#9451](https://github.com/vuetifyjs/vuetify/issues/9451)
* **VChipGroup:** remove unnecessary color declaration for v-icon ([2cbf929](https://github.com/vuetifyjs/vuetify/commit/2cbf929fca62cd1334cd6d65ad66ad5c3f2fd219)), closes [#9604](https://github.com/vuetifyjs/vuetify/issues/9604)
* **VCombobox:** do not add search to list when selecting items with keyboard ([#9866](https://github.com/vuetifyjs/vuetify/issues/9866)) ([78aa42f](https://github.com/vuetifyjs/vuetify/commit/78aa42f8f01d9175a9ef338b7de6c08b9155b868)), closes [#6697](https://github.com/vuetifyjs/vuetify/issues/6697) [vuetifyjs/vuetify#8841](https://github.com/vuetifyjs/vuetify/issues/8841) [/github.com/vuetifyjs/vuetify/pull/9866/files/ba3f8a40b327e7509272530fe40ffe726f016a02#r359313120](https://github.com/vuetifyjs//github.com/vuetifyjs/vuetify/pull/9866/files/ba3f8a40b327e7509272530fe40ffe726f016a02/issues/r359313120)
* **VDataIterator:** emit two item-selected events in single-select mode ([#9636](https://github.com/vuetifyjs/vuetify/issues/9636)) ([e7151f9](https://github.com/vuetifyjs/vuetify/commit/e7151f9a74a2ae818a796351e32ed2fa31016236)), closes [#8477](https://github.com/vuetifyjs/vuetify/issues/8477)
* **VDatatable:** add display style to <tr> when Mobile ([#9750](https://github.com/vuetifyjs/vuetify/issues/9750)) ([3d69508](https://github.com/vuetifyjs/vuetify/commit/3d69508d34d732742c49b4c8da471b9e5d80c2ca)), closes [#8799](https://github.com/vuetifyjs/vuetify/issues/8799)
* **VDataTable:** allow grouping by nested keys ([c8e9239](https://github.com/vuetifyjs/vuetify/commit/c8e92395dd6e342e94afe5d2fc45d45c5cf2d35c)), closes [#10323](https://github.com/vuetifyjs/vuetify/issues/10323)
* **VDataTable:** fix default table header color ([#10171](https://github.com/vuetifyjs/vuetify/issues/10171)) ([7d5d5be](https://github.com/vuetifyjs/vuetify/commit/7d5d5be89afde96a69e3cf6bf09bae45a4d1d3a9))
* **VDataTable:** respect hide-default-header prop on mobile ([#11732](https://github.com/vuetifyjs/vuetify/issues/11732)) ([bb6bfdf](https://github.com/vuetifyjs/vuetify/commit/bb6bfdf63f3db1687f686f6b4b473f2c9c58bbdd)), closes [#8774](https://github.com/vuetifyjs/vuetify/issues/8774)
* **VDatepicker:** emit change event when using the range prop ([#9761](https://github.com/vuetifyjs/vuetify/issues/9761)) ([941fe31](https://github.com/vuetifyjs/vuetify/commit/941fe31a8768bd0f8d06fc67122afe0389b85e04)), closes [#9656](https://github.com/vuetifyjs/vuetify/issues/9656)
* **VDatePicker:** allow null value for multiple date picker ([#11304](https://github.com/vuetifyjs/vuetify/issues/11304)) ([de7aacd](https://github.com/vuetifyjs/vuetify/commit/de7aacdcb879982d37422e220e4f4ef0d44e8413)), closes [#9529](https://github.com/vuetifyjs/vuetify/issues/9529)
* **VDatePicker:** range not working with month picker ([#9886](https://github.com/vuetifyjs/vuetify/issues/9886)) ([9f5747e](https://github.com/vuetifyjs/vuetify/commit/9f5747e97c4f60d78598d767f5e7cc5d5ce3a2be)), closes [#9885](https://github.com/vuetifyjs/vuetify/issues/9885)
* **VDatePicker:** restore event border radius to 50% ([9e4cfa9](https://github.com/vuetifyjs/vuetify/commit/9e4cfa9719c6bb29e39bd53c216714ada29a9666))
* **VDatePicker:** typo in sass variable name ([5997b95](https://github.com/vuetifyjs/vuetify/commit/5997b9500c065fc17c58ff735abadaa150e72db8))
* **VDatePicker, VDataTable:** incorrect date picker styling when in data table ([#11325](https://github.com/vuetifyjs/vuetify/issues/11325)) ([3fcc67e](https://github.com/vuetifyjs/vuetify/commit/3fcc67e2c6ab0a7de53577a80cf966d50522fa1b)), closes [#7384](https://github.com/vuetifyjs/vuetify/issues/7384)
* **VDateTable:** events alignment on current date ([#10367](https://github.com/vuetifyjs/vuetify/issues/10367)) ([fc2eaa5](https://github.com/vuetifyjs/vuetify/commit/fc2eaa53dd4269c03e2ca5eb8579eba19dd3d299)), closes [#8182](https://github.com/vuetifyjs/vuetify/issues/8182)
* **VDialog:** ignore outside clicks if this isn't the topmost dialog ([b3bf7ff](https://github.com/vuetifyjs/vuetify/commit/b3bf7ffd659fa4722df59dfe0d8d86bc78443913)), closes [#9907](https://github.com/vuetifyjs/vuetify/issues/9907)
* **VDialog:** prevent scroll on mobile devices ([#10149](https://github.com/vuetifyjs/vuetify/issues/10149)) ([183d79b](https://github.com/vuetifyjs/vuetify/commit/183d79bcbd717b19b36d6f6c053dbf11ef646886)), closes [#10086](https://github.com/vuetifyjs/vuetify/issues/10086)
* **VDialog:** remove unnecessary event.stopPropagation ([9ca0519](https://github.com/vuetifyjs/vuetify/commit/9ca05198fde724d149f7de315c53c0c40d9ad940)), closes [#10167](https://github.com/vuetifyjs/vuetify/issues/10167)
* **VEditDialog:** return returnValue on save ([#11740](https://github.com/vuetifyjs/vuetify/issues/11740)) ([2620930](https://github.com/vuetifyjs/vuetify/commit/262093062540afe3491ec5c207ce06f907f2f68f)), closes [#11736](https://github.com/vuetifyjs/vuetify/issues/11736)
* **VExpandTransition:** include collapsed margins in calculated  height ([046d4e0](https://github.com/vuetifyjs/vuetify/commit/046d4e01f3dbff7bc044b108a41bb0816589fe62))
* **VExpansionPanel:** remove rounded corners with tile and accordion ([30b8b9e](https://github.com/vuetifyjs/vuetify/commit/30b8b9e74908ed2c9ed2591d74e12ec09c22e797)), closes [#9643](https://github.com/vuetifyjs/vuetify/issues/9643)
* **VFileInput:** filter out values that are not instance of File ([ebdb4f6](https://github.com/vuetifyjs/vuetify/commit/ebdb4f64cdc3a1b118e61992f235c60b3586f168)), closes [#10281](https://github.com/vuetifyjs/vuetify/issues/10281)
* **VFileInput:** remove input from normal document flow ([7fa2e79](https://github.com/vuetifyjs/vuetify/commit/7fa2e7913939034599613ff9350311162047a0b2)), closes [#8931](https://github.com/vuetifyjs/vuetify/issues/8931)
* **VFileInput:** remove typeof filter in arrayValue, improve prop validator ([140d82c](https://github.com/vuetifyjs/vuetify/commit/140d82c4832d4f5d736b5c324214c65edfffcf89)), closes [#10306](https://github.com/vuetifyjs/vuetify/issues/10306)
* **VFileInput:** set value to undefined by default and on clear ([19bdb4c](https://github.com/vuetifyjs/vuetify/commit/19bdb4cdab427e4564f68901b73256f752b2ad57)), closes [#10287](https://github.com/vuetifyjs/vuetify/issues/10287)
* **VFooter:** add missing tag prop ([#11749](https://github.com/vuetifyjs/vuetify/issues/11749)) ([6160e46](https://github.com/vuetifyjs/vuetify/commit/6160e46f8c8a3eee0279f8b4ba19de845b866561)), closes [#11580](https://github.com/vuetifyjs/vuetify/issues/11580)
* **VGrid:** offset in RTL mode ([#11359](https://github.com/vuetifyjs/vuetify/issues/11359)) ([db52c0a](https://github.com/vuetifyjs/vuetify/commit/db52c0ae2d1aef7e087994830da07f4f84fa99db)), closes [#6317](https://github.com/vuetifyjs/vuetify/issues/6317)
* **VIcon:** apply default tabindex if click listener present ([86133ea](https://github.com/vuetifyjs/vuetify/commit/86133eabf01f3748056b6eae0a54d073e606f013)), closes [#10265](https://github.com/vuetifyjs/vuetify/issues/10265)
* **VIcon:** svg icon style when using the prominent prop ([#9831](https://github.com/vuetifyjs/vuetify/issues/9831)) ([abc8715](https://github.com/vuetifyjs/vuetify/commit/abc871581df3e460fd1b318781af942b133e4016)), closes [#9670](https://github.com/vuetifyjs/vuetify/issues/9670)
* **VIcon:** visibility transition delay ([#9962](https://github.com/vuetifyjs/vuetify/issues/9962)) ([55c67f4](https://github.com/vuetifyjs/vuetify/commit/55c67f47a6e564855be3d61b8240beab0689f1ad)), closes [#9541](https://github.com/vuetifyjs/vuetify/issues/9541)
* **VImg:** don't error when src is null ([e784284](https://github.com/vuetifyjs/vuetify/commit/e784284683474f0d72ed331208c5d22bc39fb7ad)), closes [#11831](https://github.com/vuetifyjs/vuetify/issues/11831)
* **VImg:** image entry animation ([1550862](https://github.com/vuetifyjs/vuetify/commit/155086241f575f02fbcf3c3c0b9417cd4cf12074))
* **VImg:** render gradient when src isn't provided ([c0fa6d5](https://github.com/vuetifyjs/vuetify/commit/c0fa6d5a90c12ca6a4f7141902effde3decb4e31)), closes [#11729](https://github.com/vuetifyjs/vuetify/issues/11729)
* **VImg:** resolve NaN value when computing normalizedSrc ([8d110bf](https://github.com/vuetifyjs/vuetify/commit/8d110bf2738cbde688d1244bec87ec768f920096))
* **VImg:** stop polling for size when loading fails ([be907b5](https://github.com/vuetifyjs/vuetify/commit/be907b5994df05ac7ce993ae23ad9a20fc874216)), closes [#11026](https://github.com/vuetifyjs/vuetify/issues/11026)
* **VInput:** apply correct placeholder color ([f6d0d61](https://github.com/vuetifyjs/vuetify/commit/f6d0d617e28aa28b696903647f2174469091a71c)), closes [#10221](https://github.com/vuetifyjs/vuetify/issues/10221)
* **VInput:** browser autocomplete default ([#9552](https://github.com/vuetifyjs/vuetify/issues/9552)) ([c060444](https://github.com/vuetifyjs/vuetify/commit/c0604449cb846b5651d03ac408e8c491ecdecf01)), closes [#9516](https://github.com/vuetifyjs/vuetify/issues/9516)
* **VItemGroup:** apply maximum width for use in flex containers ([6362eec](https://github.com/vuetifyjs/vuetify/commit/6362eec3495e3e675ee379906de2255099cf2067)), closes [#8752](https://github.com/vuetifyjs/vuetify/issues/8752)
* **VItemGroup:** update toggled item when the items array changes ([85f963e](https://github.com/vuetifyjs/vuetify/commit/85f963eea6f872a67761534737158519f0446df2)), closes [#9854](https://github.com/vuetifyjs/vuetify/issues/9854)
* **VItemGroup:** update value when using mandatory and multiple ([f4bc5bd](https://github.com/vuetifyjs/vuetify/commit/f4bc5bddb796a6b6d42fe23e02369085e27b1a2c)), closes [#10077](https://github.com/vuetifyjs/vuetify/issues/10077)
* **VListGroup:** added styles to prevent content overflow ([#10042](https://github.com/vuetifyjs/vuetify/issues/10042)) ([046fa5a](https://github.com/vuetifyjs/vuetify/commit/046fa5aff7a7fdb62731905e60192861b4bce451)), closes [#10008](https://github.com/vuetifyjs/vuetify/issues/10008)
* **VListGroup:** allow user to hide prepend-icon in subgroup ([172724e](https://github.com/vuetifyjs/vuetify/commit/172724e99fde064fd589516d31857656f120f89e)), closes [#8980](https://github.com/vuetifyjs/vuetify/issues/8980)
* **VListGroup:** remove empty div child selector ([60844a3](https://github.com/vuetifyjs/vuetify/commit/60844a32f51b3f4bd73811fd2b6997293744d099)), closes [#8823](https://github.com/vuetifyjs/vuetify/issues/8823)
* **VListItem:** only apply user-select style when using a link ([fbc8ed8](https://github.com/vuetifyjs/vuetify/commit/fbc8ed820d4072dd135e8934bf5d020def0160c0)), closes [#8648](https://github.com/vuetifyjs/vuetify/issues/8648)
* **VListItemAvatar:** apply correct margin according to spec ([97fc2de](https://github.com/vuetifyjs/vuetify/commit/97fc2de3577be3bae51aac7eb6c851b64d7806b0)), closes [#9789](https://github.com/vuetifyjs/vuetify/issues/9789)
* **VMain:** add existing v-content classes for backwards compatibility ([#11659](https://github.com/vuetifyjs/vuetify/issues/11659)) ([31912d7](https://github.com/vuetifyjs/vuetify/commit/31912d7ca86713bef54f7f10cdf038b550f4d18c))
* **VMenu:** remove unnecessary event.stopPropagation ([5af2cd1](https://github.com/vuetifyjs/vuetify/commit/5af2cd193927f20cb0df5ae492df01e9e1ed5d90)), closes [#6654](https://github.com/vuetifyjs/vuetify/issues/6654)
* **VNavigationDrawer:** apply a better default mini width ([d80e01f](https://github.com/vuetifyjs/vuetify/commit/d80e01f0c9ec9c54b066f155e642f0ca06021a17)), closes [#2830](https://github.com/vuetifyjs/vuetify/issues/2830)
* **VNavigationDrawer:** hide navigation drawer labels visually ([#10250](https://github.com/vuetifyjs/vuetify/issues/10250)) ([a28d03e](https://github.com/vuetifyjs/vuetify/commit/a28d03ea18bad5a0ce8300a894cb37eb5b1f50cf)), closes [#9741](https://github.com/vuetifyjs/vuetify/issues/9741)
* **VNavigationDrawer:** set proper border width ([9bc631a](https://github.com/vuetifyjs/vuetify/commit/9bc631a08d7d28a0d02d1daeb982972c9278cf52))
* **VOverlay:** enable touch interaction ([3365cac](https://github.com/vuetifyjs/vuetify/commit/3365cac74fea50b5b0b4c5e8dc6ce3023ff96c68))
* **VPicker:** content position in landscape / rtl mode ([#10371](https://github.com/vuetifyjs/vuetify/issues/10371)) ([92e77a2](https://github.com/vuetifyjs/vuetify/commit/92e77a2ad7dfb931568ecfab1f1432cf0f8bf542)), closes [#9258](https://github.com/vuetifyjs/vuetify/issues/9258)
* **VProgressCircular:** don't apply rotate animation to svg icon ([#11868](https://github.com/vuetifyjs/vuetify/issues/11868)) ([e2ed334](https://github.com/vuetifyjs/vuetify/commit/e2ed334a25ddd687aef72a5505a9964b42afb6ff)), closes [#11867](https://github.com/vuetifyjs/vuetify/issues/11867)
* **VProgressLinear:** resolve invalid sass transition variable reference ([fea155e](https://github.com/vuetifyjs/vuetify/commit/fea155e967359dcaa5e4af8517f929d7db379506)), closes [#10343](https://github.com/vuetifyjs/vuetify/issues/10343)
* **VRadioGroup:** overwrite inherited padding and vertical align label ([f81b639](https://github.com/vuetifyjs/vuetify/commit/f81b639dd8fca6a088dc2bbf578a2cbf0e9545f5)), closes [#10334](https://github.com/vuetifyjs/vuetify/issues/10334)
* **VRadioGroup:** properly scope selection control styles ([be965df](https://github.com/vuetifyjs/vuetify/commit/be965df0c8cd903f6c9d62e14ee25e7ade4518b4)), closes [#10131](https://github.com/vuetifyjs/vuetify/issues/10131)
* **VRadioGroup:** use correct element tags for a11y ([75f6197](https://github.com/vuetifyjs/vuetify/commit/75f6197629d6c8baf7ab86e2a8b0d12ec0d444d2)), closes [#9851](https://github.com/vuetifyjs/vuetify/issues/9851)
* **VRangeSlider:** resolve infinite loop when using NaN values ([35a654c](https://github.com/vuetifyjs/vuetify/commit/35a654c8d9b85d2c654e4199a2130aaf5b07a49b)), closes [#9818](https://github.com/vuetifyjs/vuetify/issues/9818)
* **VRating:** check if half-increments prop is used alongside rtl ([ddf3aec](https://github.com/vuetifyjs/vuetify/commit/ddf3aec89be545e3a89844ec8011530eb36a95bb)), closes [#10093](https://github.com/vuetifyjs/vuetify/issues/10093)
* **VResponsive:** apply rtl margin styles ([#10269](https://github.com/vuetifyjs/vuetify/issues/10269)) ([196bcdb](https://github.com/vuetifyjs/vuetify/commit/196bcdb01a2593ae6bb04642837f485564744807)), closes [#10268](https://github.com/vuetifyjs/vuetify/issues/10268)
* **VResponsive:** restructure elements to work with Firefox ([#10027](https://github.com/vuetifyjs/vuetify/issues/10027)) ([e92d6b7](https://github.com/vuetifyjs/vuetify/commit/e92d6b79115c28b6cae71b7bc70bbb295c12ef89)), closes [#9659](https://github.com/vuetifyjs/vuetify/issues/9659)
* **VResponsive:** tweak styles to work with Firefox ([#10095](https://github.com/vuetifyjs/vuetify/issues/10095)) ([c6d3cca](https://github.com/vuetifyjs/vuetify/commit/c6d3cca44ccfd8bcdc640401871d2027be7866a4)), closes [#9659](https://github.com/vuetifyjs/vuetify/issues/9659)
* **VSelect:** attach menu scroll handler when loading items async ([d9bb128](https://github.com/vuetifyjs/vuetify/commit/d9bb128a510d3887ca240111f15395f55d53367d)), closes [#11675](https://github.com/vuetifyjs/vuetify/issues/11675)
* **VSelect:** bind scroll listener to menu content ([972d188](https://github.com/vuetifyjs/vuetify/commit/972d1883ea4ada0735ef01d3b13331540b2eec26)), closes [#10485](https://github.com/vuetifyjs/vuetify/issues/10485)
* **VSelect:** change onMouseUp to handle menu toggle on mouse events ([#9476](https://github.com/vuetifyjs/vuetify/issues/9476)) ([49c47ec](https://github.com/vuetifyjs/vuetify/commit/49c47ecea3c87f0b351c1318d282d655fa7fd1e1)), closes [#6564](https://github.com/vuetifyjs/vuetify/issues/6564)
* **VSelect:** disable arrows on readonly select ([#11223](https://github.com/vuetifyjs/vuetify/issues/11223)) ([fd7a8b3](https://github.com/vuetifyjs/vuetify/commit/fd7a8b3f986f818edee99816ece45327f48fee8b)), closes [#11164](https://github.com/vuetifyjs/vuetify/issues/11164)
* **VSelect:** disable menu when readonly ([ba5cc58](https://github.com/vuetifyjs/vuetify/commit/ba5cc5892e3ab5346b447ff5f08f5a8cc1173e52)), closes [#9960](https://github.com/vuetifyjs/vuetify/issues/9960)
* **VSelect:** emit click event ([#10853](https://github.com/vuetifyjs/vuetify/issues/10853)) ([be86aac](https://github.com/vuetifyjs/vuetify/commit/be86aac7a51c8502804238a21c95ef556d5d2f61)), closes [#10839](https://github.com/vuetifyjs/vuetify/issues/10839)
* **VSelect:** emit keydown event ([6bf9eff](https://github.com/vuetifyjs/vuetify/commit/6bf9effe6b0709f4aedb2add9828fa1ba5875cd2)), closes [#10240](https://github.com/vuetifyjs/vuetify/issues/10240)
* **VSelect:** ensure VMenu's content has scroll listener added ([#11725](https://github.com/vuetifyjs/vuetify/issues/11725)) ([a406dd4](https://github.com/vuetifyjs/vuetify/commit/a406dd4476eaf864d15fdc478093edf7b3964f90)), closes [#11737](https://github.com/vuetifyjs/vuetify/issues/11737)
* **VSelect:** expose clickable icons to screen readers ([#10489](https://github.com/vuetifyjs/vuetify/issues/10489)) ([cee1404](https://github.com/vuetifyjs/vuetify/commit/cee14044d0a947f1952fd353d00770060995d494))
* **VSelect:** get menu content when needed ([bd2278f](https://github.com/vuetifyjs/vuetify/commit/bd2278f745ed27938b763f570d7ef5e8cb12ff72)), closes [#8823](https://github.com/vuetifyjs/vuetify/issues/8823)
* **VSelect:** incorrect dense height ([#10694](https://github.com/vuetifyjs/vuetify/issues/10694)) ([07fa3da](https://github.com/vuetifyjs/vuetify/commit/07fa3da9615b19ddf78b679d283022fbd23c79dd)), closes [#10635](https://github.com/vuetifyjs/vuetify/issues/10635)
* **VSelect:** make selection color white when using solo-inverted ([c8f2564](https://github.com/vuetifyjs/vuetify/commit/c8f2564abeba7313bee17a37e0be0bfbaf5a7582)), closes [#10617](https://github.com/vuetifyjs/vuetify/issues/10617)
* **VSelect:** normalize dense height ([#10892](https://github.com/vuetifyjs/vuetify/issues/10892)) ([1890bec](https://github.com/vuetifyjs/vuetify/commit/1890bec0389a357f3e7b2ab6d4332f77db483f22)), closes [#10877](https://github.com/vuetifyjs/vuetify/issues/10877)
* **VSelect:** propagate name attribute to hidden input ([#10327](https://github.com/vuetifyjs/vuetify/issues/10327)) ([f289b05](https://github.com/vuetifyjs/vuetify/commit/f289b05af9f7316c46c2e961a484528e7f15aa00)), closes [#10152](https://github.com/vuetifyjs/vuetify/issues/10152)
* **VSelect:** properly handle up and down arrows when focused ([f72db83](https://github.com/vuetifyjs/vuetify/commit/f72db83ca8545f00243e7919c9a108381af3f85b)), closes [#8361](https://github.com/vuetifyjs/vuetify/issues/8361)
* **VSelect:** remove duplicate item ids ([#9961](https://github.com/vuetifyjs/vuetify/issues/9961)) ([3e02eb2](https://github.com/vuetifyjs/vuetify/commit/3e02eb24f75acc815a4b1e51fa751a8eb191d0d4)), closes [#9819](https://github.com/vuetifyjs/vuetify/issues/9819)
* **VSelect:** scroll to newly selected item in long lists ([#10492](https://github.com/vuetifyjs/vuetify/issues/10492)) ([4a3d39b](https://github.com/vuetifyjs/vuetify/commit/4a3d39b4cf1305be9fc97e45a1020b105322af14)), closes [#10406](https://github.com/vuetifyjs/vuetify/issues/10406)
* **VSelect:** update inner input element value ([#9598](https://github.com/vuetifyjs/vuetify/issues/9598)) ([f4cda2b](https://github.com/vuetifyjs/vuetify/commit/f4cda2b87dd7a42a00cdbc01f4b7c9d79b5b93d1)), closes [#6310](https://github.com/vuetifyjs/vuetify/issues/6310)
* **VSelect/VMenu:** remove duplicate IDs, add aria-activedescendant ([#10226](https://github.com/vuetifyjs/vuetify/issues/10226)) ([b2e5691](https://github.com/vuetifyjs/vuetify/commit/b2e5691a747e5716aee2771c289b56757f8251de)), closes [#9680](https://github.com/vuetifyjs/vuetify/issues/9680) [#7385](https://github.com/vuetifyjs/vuetify/issues/7385)
* **VSimpleCheckbox:** pass listeners to component ([#11358](https://github.com/vuetifyjs/vuetify/issues/11358)) ([d937f5b](https://github.com/vuetifyjs/vuetify/commit/d937f5b36cdf9049ef51ea9d420494c2b10dd3f7)), closes [#11345](https://github.com/vuetifyjs/vuetify/issues/11345)
* **VSimpleTable:** bottom border of tbody th ([#10594](https://github.com/vuetifyjs/vuetify/issues/10594)) ([c014bdc](https://github.com/vuetifyjs/vuetify/commit/c014bdc4a765b4b6b1f5f88fbb5bb46cba2416ba))
* **VSimpleTable:** set max width to 100% ([#10707](https://github.com/vuetifyjs/vuetify/issues/10707)) ([905fc45](https://github.com/vuetifyjs/vuetify/commit/905fc45387075fca424fd0e2e9dd3830b0fcdaf1)), closes [#8993](https://github.com/vuetifyjs/vuetify/issues/8993)
* **VSkeletonLoader:** don't call the default slot if not used ([e0f3f08](https://github.com/vuetifyjs/vuetify/commit/e0f3f08fc28bafae52cb064702a9597c18e0207c)), closes [#10201](https://github.com/vuetifyjs/vuetify/issues/10201)
* **VSkeletonLoader:** properly animate incoming content after loading ([9ac1158](https://github.com/vuetifyjs/vuetify/commit/9ac1158f857fd1f531f1177ba623602973f81b55)), closes [#9459](https://github.com/vuetifyjs/vuetify/issues/9459)
* **VSkeletonLoader:** remove unnecessary border-radius on card style ([#10806](https://github.com/vuetifyjs/vuetify/issues/10806)) ([ac754ca](https://github.com/vuetifyjs/vuetify/commit/ac754ca057c490585451dc100c1f594169903ee9))
* **VSkeletonLoader:** use rgba transparency for animation on Safari ([#11714](https://github.com/vuetifyjs/vuetify/issues/11714)) ([f55db8d](https://github.com/vuetifyjs/vuetify/commit/f55db8d525aefd893c397fe8098672ebde9c2aa1)), closes [#10740](https://github.com/vuetifyjs/vuetify/issues/10740)
* **vslidegroup:** add display none to immediate child ([#10567](https://github.com/vuetifyjs/vuetify/issues/10567)) ([bb69192](https://github.com/vuetifyjs/vuetify/commit/bb69192b72d165c814cedf3f284a8d9639e9530b)), closes [#10310](https://github.com/vuetifyjs/vuetify/issues/10310)
* **VSlideGroup:** prevent thrashing DOM when available space < width ([0f3f4b5](https://github.com/vuetifyjs/vuetify/commit/0f3f4b5afc3fa21e6a42cd9b34b84e0b79077331)), closes [#11122](https://github.com/vuetifyjs/vuetify/issues/11122)
* **VSlider:** avoid unnecessary input event ([2f9b28f](https://github.com/vuetifyjs/vuetify/commit/2f9b28fb50bc2ffac6d633f1766b2ca417554cd0)), closes [#10018](https://github.com/vuetifyjs/vuetify/issues/10018)
* **VSlider:** prevent default when pressing slider dot ([7d2e162](https://github.com/vuetifyjs/vuetify/commit/7d2e1625b59033a7c267152acfed361347f9a5b6)), closes [#7241](https://github.com/vuetifyjs/vuetify/issues/7241)
* **VSlider:** readonly should apply only to slider control ([#10768](https://github.com/vuetifyjs/vuetify/issues/10768)) ([e089a7c](https://github.com/vuetifyjs/vuetify/commit/e089a7c9f6f0e325c6658cc933b28fb211b5a096)), closes [#10684](https://github.com/vuetifyjs/vuetify/issues/10684)
* **VSlider:** thumb shifting position when toggling disabled state ([#11306](https://github.com/vuetifyjs/vuetify/issues/11306)) ([1fa2f92](https://github.com/vuetifyjs/vuetify/commit/1fa2f9200dd9c1b16459d8a9e52a0b7760d44753)), closes [#11303](https://github.com/vuetifyjs/vuetify/issues/11303)
* **VSlider:** wrong tick labels positions in RTL mode ([#11317](https://github.com/vuetifyjs/vuetify/issues/11317)) ([225e82a](https://github.com/vuetifyjs/vuetify/commit/225e82ab2c92ee1133ddaaea7931cd1505ed6c6a)), closes [#11028](https://github.com/vuetifyjs/vuetify/issues/11028)
* **VSnackbar:** a11y and appearance improvements ([#10263](https://github.com/vuetifyjs/vuetify/issues/10263)) ([80b1568](https://github.com/vuetifyjs/vuetify/commit/80b1568ad5f2370166e33070ab6c9007629766ec)), closes [#10047](https://github.com/vuetifyjs/vuetify/issues/10047) [#10047](https://github.com/vuetifyjs/vuetify/issues/10047)
* **VSparkline:** avoid computing path total length if only 1 value provided ([f57b7a7](https://github.com/vuetifyjs/vuetify/commit/f57b7a7c6247e1b496ae87a1e4b4c014a7dcdc1d)), closes [#9426](https://github.com/vuetifyjs/vuetify/issues/9426)
* **VSparkline:** handle a divide by zero bug when all values are zero ([#11315](https://github.com/vuetifyjs/vuetify/issues/11315)) ([2dacec2](https://github.com/vuetifyjs/vuetify/commit/2dacec2955a9c00ecb9c9e5f7d136683c7bb2991)), closes [#11311](https://github.com/vuetifyjs/vuetify/issues/11311)
* **VSparkline:** remove duplicate id ([#11262](https://github.com/vuetifyjs/vuetify/issues/11262)) ([4a785ff](https://github.com/vuetifyjs/vuetify/commit/4a785ff964307759d8bf2625fb89b412c1a21d66))
* **VSparkline:** stop and fill color propagation ([#11102](https://github.com/vuetifyjs/vuetify/issues/11102)) ([4c50717](https://github.com/vuetifyjs/vuetify/commit/4c50717c6aeb4ad98d9f8e1d8d8276c8290cfd9b)), closes [#6387](https://github.com/vuetifyjs/vuetify/issues/6387)
* **VSpeedDial:** apply a baseline z-index ([1c42ed1](https://github.com/vuetifyjs/vuetify/commit/1c42ed113790cb1fff3d859dae79c582b678870d)), closes [#10194](https://github.com/vuetifyjs/vuetify/issues/10194)
* **VStepper:** adjust svg size to match icon font-size ([bc55564](https://github.com/vuetifyjs/vuetify/commit/bc55564b32019bfcc212cf53631447f86f6f86e1)), closes [#8665](https://github.com/vuetifyjs/vuetify/issues/8665)
* **VStepper:** allow numeric 0 value ([996a37f](https://github.com/vuetifyjs/vuetify/commit/996a37fc25580f4395145530ef39989fc27b1206)), closes [#10096](https://github.com/vuetifyjs/vuetify/issues/10096)
* **VStepper:** fix styles in RTL ([#10145](https://github.com/vuetifyjs/vuetify/issues/10145)) ([879adcc](https://github.com/vuetifyjs/vuetify/commit/879adcc1cd727074d686094766509edab05e8784)), closes [#10098](https://github.com/vuetifyjs/vuetify/issues/10098)
* **VTabs:** correct width of v-tab's bar and content with vertical ([df502ff](https://github.com/vuetifyjs/vuetify/commit/df502ffcc2c392bd2ab358f33c3227ecbf1fe94a)), closes [#10031](https://github.com/vuetifyjs/vuetify/issues/10031)
* **VTabs:** indent tabs on the correct with the right prop ([68a49c3](https://github.com/vuetifyjs/vuetify/commit/68a49c33d1bfa75af32d14e08296047b9b011da9)), closes [#8294](https://github.com/vuetifyjs/vuetify/issues/8294)
* **VTabs:** make buttons inside tab inherit current color of the tab ([#11183](https://github.com/vuetifyjs/vuetify/issues/11183)) ([ea68150](https://github.com/vuetifyjs/vuetify/commit/ea6815092ee93fb0b1ec8d786190e7cd140d7ff5)), closes [#11171](https://github.com/vuetifyjs/vuetify/issues/11171)
* **VTabs:** update to better match md2 spec ([a49f2c8](https://github.com/vuetifyjs/vuetify/commit/a49f2c844ba723dd9b3bd4eb2b8f08adf223f35e))
* **VTextarea:** adjust height for smaller rows and dense ([792f183](https://github.com/vuetifyjs/vuetify/commit/792f183795ac8c914d1d6fcf244d713f89d8f035)), closes [#9346](https://github.com/vuetifyjs/vuetify/issues/9346)
* **VTextarea:** make height of 1 row equal to v-text-field ([#9992](https://github.com/vuetifyjs/vuetify/issues/9992)) ([4a98297](https://github.com/vuetifyjs/vuetify/commit/4a982979e7d76aed231f67161e494d4363db653a))
* **VTextfield:** legend position with reverse and outlined prop ([#10278](https://github.com/vuetifyjs/vuetify/issues/10278)) ([55cbdbb](https://github.com/vuetifyjs/vuetify/commit/55cbdbb70f39ef431ba75c4bedf361ce9d099a29)), closes [#10277](https://github.com/vuetifyjs/vuetify/issues/10277)
* **VTextField:** add back accidentally removed transition property ([fa07fc5](https://github.com/vuetifyjs/vuetify/commit/fa07fc50f053640ecf648cb643a77fc32ea16d21)), closes [#10108](https://github.com/vuetifyjs/vuetify/issues/10108)
* **VTextField:** adjust label top position with solo prop ([7f95808](https://github.com/vuetifyjs/vuetify/commit/7f9580867904efa026c9077d2c0b546d488ea4b6))
* **VTextField:** adjust margin and css target for dense field prepend/append icons ([6603b05](https://github.com/vuetifyjs/vuetify/commit/6603b05cef207736c4d19c45c2a6b3fe6ed40bb2)), closes [#11011](https://github.com/vuetifyjs/vuetify/issues/11011)
* **VTextField:** apply different color logic for solo-inverted fields ([afa2647](https://github.com/vuetifyjs/vuetify/commit/afa264700fabbfc90aca0f04f9e1c0873b6af35c)), closes [#8827](https://github.com/vuetifyjs/vuetify/issues/8827)
* **VTextField:** autofocus when observed ([d846222](https://github.com/vuetifyjs/vuetify/commit/d84622280ec05cf03342c8bab405909a68fc2ece)), closes [#5487](https://github.com/vuetifyjs/vuetify/issues/5487) [#8845](https://github.com/vuetifyjs/vuetify/issues/8845)
* **VTextField:** calculate label width depending on the textfield width ([#10092](https://github.com/vuetifyjs/vuetify/issues/10092)) ([918b0cf](https://github.com/vuetifyjs/vuetify/commit/918b0cf513fdfd88cfc0266ca346758c6cca9596)), closes [#10030](https://github.com/vuetifyjs/vuetify/issues/10030)
* **VTextField:** fix style cascading when combinging multiple style props ([fc7b05a](https://github.com/vuetifyjs/vuetify/commit/fc7b05aaa74f4bb92366b9c2a36367c3ee720fd8)), closes [#8586](https://github.com/vuetifyjs/vuetify/issues/8586)
* **VTextField:** incorrectly displayed counter with hide-details=auto ([#10705](https://github.com/vuetifyjs/vuetify/issues/10705)) ([0e57814](https://github.com/vuetifyjs/vuetify/commit/0e57814c41d716b246b5422583aacebfb9aa5cd5)), closes [#10701](https://github.com/vuetifyjs/vuetify/issues/10701)
* **VTextField:** match spec height when using the dense prop ([e8be89a](https://github.com/vuetifyjs/vuetify/commit/e8be89a11049c5f37a768555f5cd8724dcf1dbfe)), closes [#10119](https://github.com/vuetifyjs/vuetify/issues/10119)
* **VTextField:** properly focus field when calling public "focus" method ([e783162](https://github.com/vuetifyjs/vuetify/commit/e78316267391e103a03d3c83f5290b6024858b79))
* **VTextField:** remove gap when outlined label changes to empty ([#11316](https://github.com/vuetifyjs/vuetify/issues/11316)) ([6b3562b](https://github.com/vuetifyjs/vuetify/commit/6b3562b9f5610cee3c1525257777f60fc1180604)), closes [#11269](https://github.com/vuetifyjs/vuetify/issues/11269)
* **VTextField:** remove hover effect when disabled ([#11363](https://github.com/vuetifyjs/vuetify/issues/11363)) ([bbc6b8c](https://github.com/vuetifyjs/vuetify/commit/bbc6b8cd5a8f459a4d40721f6545bec0c40529d7)), closes [#11338](https://github.com/vuetifyjs/vuetify/issues/11338) [#11338](https://github.com/vuetifyjs/vuetify/issues/11338)
* **VTextField:** remove inherit border-color and scope styles ([47c986a](https://github.com/vuetifyjs/vuetify/commit/47c986a157b86451ddda4993aa5ad944ec8f03bb)), closes [#10388](https://github.com/vuetifyjs/vuetify/issues/10388)
* **VTextField:** remove unnecessary margin on filled inputs ([130fa8e](https://github.com/vuetifyjs/vuetify/commit/130fa8e1cb08efcd6a8e7faa0d75b87301296b03))
* **VTextField:** resolve style issues in inverted solo fields ([cdd9eb1](https://github.com/vuetifyjs/vuetify/commit/cdd9eb14aedcee3f326beeeb9752f475d008b404)), closes [#9534](https://github.com/vuetifyjs/vuetify/issues/9534)
* **VTextField:** Skip value property update if IME composing string ([#11134](https://github.com/vuetifyjs/vuetify/issues/11134)) ([c02be82](https://github.com/vuetifyjs/vuetify/commit/c02be8273cca4a373eb3792e55850ff1d8409fef)), closes [#5748](https://github.com/vuetifyjs/vuetify/issues/5748)
* **VTextField:** specify border-collapse for outlined fieldset ([baed6d7](https://github.com/vuetifyjs/vuetify/commit/baed6d7a77b97f03bc486b2609ef296e93fe8db2))
* **VTextField:** update styles to better match spec ([44c86f4](https://github.com/vuetifyjs/vuetify/commit/44c86f4347abb2707a11814c16b6dd843ad7de60)), closes [#10133](https://github.com/vuetifyjs/vuetify/issues/10133) [#5097](https://github.com/vuetifyjs/vuetify/issues/5097)
* **VTextField:** update value on compositionend ([#11194](https://github.com/vuetifyjs/vuetify/issues/11194)) ([f51bef6](https://github.com/vuetifyjs/vuetify/commit/f51bef69294c2bbc13cacb7e9b3fcf5d446c34be)), closes [#11190](https://github.com/vuetifyjs/vuetify/issues/11190) [#5748](https://github.com/vuetifyjs/vuetify/issues/5748)
* **VTextField:** use intersect to recalculate elements width ([#9341](https://github.com/vuetifyjs/vuetify/issues/9341)) ([c34f35c](https://github.com/vuetifyjs/vuetify/commit/c34f35cfdffe05a75bcd1f7a18d6b3dea8149545)), closes [#9299](https://github.com/vuetifyjs/vuetify/issues/9299)
* **VTextField:** use text node for messages instead of escaped innerHTML ([81cb6a8](https://github.com/vuetifyjs/vuetify/commit/81cb6a81cd33a2707a6697f63377cbf2a1923d63)), closes [#9730](https://github.com/vuetifyjs/vuetify/issues/9730)
* **VTextField/VSelect:** don't focus clear icon if dirty ([#10461](https://github.com/vuetifyjs/vuetify/issues/10461)) ([cc7386b](https://github.com/vuetifyjs/vuetify/commit/cc7386b9010d07fba1e75bc74ce586e3a198b9ad))
* **VTextField/VTextarea:** change styles to match specification ([8242e05](https://github.com/vuetifyjs/vuetify/commit/8242e056a9f2f64f6f0102ce031dd6f0293ebcd0)), closes [#4639](https://github.com/vuetifyjs/vuetify/issues/4639)
* **VTimePicker:** AM/PM farsi translation and margins in RTL mode ([#10399](https://github.com/vuetifyjs/vuetify/issues/10399)) ([a6761a9](https://github.com/vuetifyjs/vuetify/commit/a6761a9fa092210457171eb861410a929cd415ef))
* **VTimePicker:** increase clock click accuracy ([#10400](https://github.com/vuetifyjs/vuetify/issues/10400)) ([50ed3ef](https://github.com/vuetifyjs/vuetify/commit/50ed3ef982e3a37de772650958d43feb7d993814)), closes [#7299](https://github.com/vuetifyjs/vuetify/issues/7299)
* **VTimePicker:** missing end circle in clock hand ([#10415](https://github.com/vuetifyjs/vuetify/issues/10415)) ([755c5b8](https://github.com/vuetifyjs/vuetify/commit/755c5b85c20cd02af789c7f15d177383183def2d))
* **VTimePicker:** missing update:period event when ampm clicked in title ([3a510e8](https://github.com/vuetifyjs/vuetify/commit/3a510e8af57d76da660c6b4a407f7940fefae5cb)), closes [#7027](https://github.com/vuetifyjs/vuetify/issues/7027)
* **VToolbar:** better scope v-tabs-bar background-color override ([6619c9c](https://github.com/vuetifyjs/vuetify/commit/6619c9cbd40ba94314ead2f82fcf077c4309564b)), closes [#10308](https://github.com/vuetifyjs/vuetify/issues/10308)
* **VToolbar:** prevent image overflow in webkit and trident ([25feaf9](https://github.com/vuetifyjs/vuetify/commit/25feaf97eb39503a6d82166c0b6d486699e2e729)), closes [#11873](https://github.com/vuetifyjs/vuetify/issues/11873)
* add missing i18n ([#125](https://github.com/vuetifyjs/vuetify/issues/125)) ([a179db4](https://github.com/vuetifyjs/vuetify/commit/a179db4cef4146696e4258ab01616bf104cb6fd6))
* code blocks always ltr ([eb82fe8](https://github.com/vuetifyjs/vuetify/commit/eb82fe8faedd704498aef7ca4970887b2e443937))
* **Drawer:** move drawer state to app module ([#21](https://github.com/vuetifyjs/vuetify/issues/21)) ([7df05a1](https://github.com/vuetifyjs/vuetify/commit/7df05a1b6a3481f2fe478829fa962cc6d6561742))
* **grid:** collapse vertical gutters ([d0f25fc](https://github.com/vuetifyjs/vuetify/commit/d0f25fc59b29c385a6910dc48a111df811da3bdf)), closes [#11408](https://github.com/vuetifyjs/vuetify/issues/11408)
* **grid:** don't halve gutters between v-rows ([#12916](https://github.com/vuetifyjs/vuetify/issues/12916)) ([f33d0c1](https://github.com/vuetifyjs/vuetify/commit/f33d0c1356c5eb3a685c86f754bdf85c5dd706d0)), closes [#12915](https://github.com/vuetifyjs/vuetify/issues/12915)
* **helpers:** coerce name value to string in groupItems ([#11970](https://github.com/vuetifyjs/vuetify/issues/11970)) ([b1c3f81](https://github.com/vuetifyjs/vuetify/commit/b1c3f81bb62bc218b1c18236f7252412722b32fc)), closes [#12069](https://github.com/vuetifyjs/vuetify/issues/12069) [#12501](https://github.com/vuetifyjs/vuetify/issues/12501)
* **inputs:** display title attribute on root element ([#12776](https://github.com/vuetifyjs/vuetify/issues/12776)) ([17bd263](https://github.com/vuetifyjs/vuetify/commit/17bd263fed490177d634bc8421bdfa8dbf6dc1ef)), closes [#11253](https://github.com/vuetifyjs/vuetify/issues/11253) [#12775](https://github.com/vuetifyjs/vuetify/issues/12775)
* **locales:** fa-Persian i18n translation ([#11679](https://github.com/vuetifyjs/vuetify/issues/11679)) ([f900795](https://github.com/vuetifyjs/vuetify/commit/f90079500ba47567d95f2d5f79b65e24f4f3ac2b))
* **locales:** update `sk` translation ([#13135](https://github.com/vuetifyjs/vuetify/issues/13135)) ([de9aa5d](https://github.com/vuetifyjs/vuetify/commit/de9aa5d905e03b42a8b8050de4e8d8ca15e4ed89))
* **menuable:** don't account for app offset in fixed context ([ec8fafa](https://github.com/vuetifyjs/vuetify/commit/ec8fafa9e785f6817bf6d0058a6953b0091a1370)), closes [#13740](https://github.com/vuetifyjs/vuetify/issues/13740)
* **Menuable:** correctly calculate position in embedded v-app ([#13670](https://github.com/vuetifyjs/vuetify/issues/13670)) ([9145a5e](https://github.com/vuetifyjs/vuetify/commit/9145a5e7e7d7336753b0349cbe41d96fae2f9e75)), closes [#7703](https://github.com/vuetifyjs/vuetify/issues/7703)
* **overlayable:** cancel animationFrame request on remove ([b640d6c](https://github.com/vuetifyjs/vuetify/commit/b640d6cf5ee3a30b60533e8724936c0660f23184)), closes [#10975](https://github.com/vuetifyjs/vuetify/issues/10975) [#9588](https://github.com/vuetifyjs/vuetify/issues/9588)
* **Ripple:** prevent bubbled events from triggering more ripples ([364fb8e](https://github.com/vuetifyjs/vuetify/commit/364fb8e5c2ae24cb3533e5f29b4f72e4a01c4a05)), closes [#7988](https://github.com/vuetifyjs/vuetify/issues/7988)
* **routable:** support exactPath ([8f4773c](https://github.com/vuetifyjs/vuetify/commit/8f4773cd7b58772c96f24829b34bc6846e789ee9)), closes [#13132](https://github.com/vuetifyjs/vuetify/issues/13132)
* **routes:** api pages were using documentation view ([57aafed](https://github.com/vuetifyjs/vuetify/commit/57aafed4f8e8b323c47d2ac5732dd401e461a769))
* **styles:** use math.div instead of `/` ([52c98d5](https://github.com/vuetifyjs/vuetify/commit/52c98d5706884704c33ef1d9f23c328fa9fdb061)), closes [#13694](https://github.com/vuetifyjs/vuetify/issues/13694) [#13704](https://github.com/vuetifyjs/vuetify/issues/13704)
* **types:** add component to IconsOptions ([235139a](https://github.com/vuetifyjs/vuetify/commit/235139a64901e576fa7b19b6685d19cf54da6e95)), closes [#13122](https://github.com/vuetifyjs/vuetify/issues/13122)
* **types:** add declaration for vuetify/lib/components ([#13395](https://github.com/vuetifyjs/vuetify/issues/13395)) ([d8a6cff](https://github.com/vuetifyjs/vuetify/commit/d8a6cff278faf2de2fb2bc9dc65ee0b406c50747))
* **types:** add missing `goTo` types ([#13812](https://github.com/vuetifyjs/vuetify/issues/13812)) ([9f6d0c0](https://github.com/vuetifyjs/vuetify/commit/9f6d0c02608d9029cc24e07dc30ae8a5b0c545a1)), closes [#9648](https://github.com/vuetifyjs/vuetify/issues/9648)
* **types:** add VVirtualScroll to lib.d.ts ([2c9ad3a](https://github.com/vuetifyjs/vuetify/commit/2c9ad3ac67df8b42215e3c186708a000aebc1dfe)), closes [#11701](https://github.com/vuetifyjs/vuetify/issues/11701)
* **types:** declare vuetify/lib/services/goto module ([#13838](https://github.com/vuetifyjs/vuetify/issues/13838)) ([4537798](https://github.com/vuetifyjs/vuetify/commit/4537798f619de9095fbe2a19774a9978deb38963))
* **types:** remove index signature from VuetifyParsedThemeItem ([b01e74a](https://github.com/vuetifyjs/vuetify/commit/b01e74af77d3cdd2306ebc668bd25d0e1e2b3fd4)), closes [#10863](https://github.com/vuetifyjs/vuetify/issues/10863)
* **VAutocomplete:** close mobile keyboard on blur ([#12921](https://github.com/vuetifyjs/vuetify/issues/12921)) ([82eca7e](https://github.com/vuetifyjs/vuetify/commit/82eca7e27c327d93b4bf5ea2dcc68f0b0b2b1559)), closes [#12912](https://github.com/vuetifyjs/vuetify/issues/12912)
* **VAutocomplete:** don't count search as dirty if it is empty ([#13152](https://github.com/vuetifyjs/vuetify/issues/13152)) ([28d1726](https://github.com/vuetifyjs/vuetify/commit/28d172641047a374ef3c29629fc836ac0258f2b0)), closes [#12958](https://github.com/vuetifyjs/vuetify/issues/12958)
* **VAutocomplete:** ignore home/end on menu unless ctrl is pressed ([865196b](https://github.com/vuetifyjs/vuetify/commit/865196b2f9a995e64ade27c24a713ab3a6d2234f)), closes [#13211](https://github.com/vuetifyjs/vuetify/issues/13211)
* **VAutocomplete:** return all filtered items, ensure itemText is present ([6432fb4](https://github.com/vuetifyjs/vuetify/commit/6432fb4bc8744edc7d0705b38d9c05c4ce4072ac)), closes [#11451](https://github.com/vuetifyjs/vuetify/issues/11451) [#11415](https://github.com/vuetifyjs/vuetify/issues/11415) [#11442](https://github.com/vuetifyjs/vuetify/issues/11442)
* **VChip:** outlined hover state ([#11628](https://github.com/vuetifyjs/vuetify/issues/11628)) ([d960a34](https://github.com/vuetifyjs/vuetify/commit/d960a348d2a84a4d57a4b0d2a64f52c5f2f7044f))
* **VSlider:** suppress change event on keydown ([d51d33f](https://github.com/vuetifyjs/vuetify/commit/d51d33fecaa5b5bdb1bd97be33dcd3a673562fe1)), closes [#11569](https://github.com/vuetifyjs/vuetify/issues/11569)
* **VVirtualscroll:** calculate child on mounted instead of created ([#11712](https://github.com/vuetifyjs/vuetify/issues/11712)) ([f3c8aa5](https://github.com/vuetifyjs/vuetify/commit/f3c8aa54a210b90c523ef7d6e6ca3f269fd0b611)), closes [#11707](https://github.com/vuetifyjs/vuetify/issues/11707)
* change curser:default selector to [aria-disabled=true] ([c64431b](https://github.com/vuetifyjs/vuetify/commit/c64431b08100921b4d31241caa5a4aa5345fdbc7)), closes [#11003](https://github.com/vuetifyjs/vuetify/issues/11003)
* fix color inversion ([#33](https://github.com/vuetifyjs/vuetify/issues/33)) ([9a15b5e](https://github.com/vuetifyjs/vuetify/commit/9a15b5e4e8f75ff6b5587d86ad0f5b9e1ec60ceb))
* **VAutocomplete:** select last item when pressing backspace with no index ([524c1e8](https://github.com/vuetifyjs/vuetify/commit/524c1e85d55618ef52e8b117ae75fa9829270525)), closes [#11639](https://github.com/vuetifyjs/vuetify/issues/11639)
* **VBadge:** add missing !default on border radius ([#13296](https://github.com/vuetifyjs/vuetify/issues/13296)) ([c273acb](https://github.com/vuetifyjs/vuetify/commit/c273acb0fc71d8dce7e103294d72b42bf913e012))
* **VBottomNavigation:** add missing tag functionality ([4d627e9](https://github.com/vuetifyjs/vuetify/commit/4d627e9d09e81a41fc3558d31f7792f15a2312ae)), closes [#11392](https://github.com/vuetifyjs/vuetify/issues/11392)
* **VBtn:** disabled state background-color ([#12892](https://github.com/vuetifyjs/vuetify/issues/12892)) ([edf13fe](https://github.com/vuetifyjs/vuetify/commit/edf13fe1c83841c26c3575bb5b052225d61e68ed)), closes [#12845](https://github.com/vuetifyjs/vuetify/issues/12845)
* **VBtn:** override icon font-size with left/right props ([#13120](https://github.com/vuetifyjs/vuetify/issues/13120)) ([5fca6ef](https://github.com/vuetifyjs/vuetify/commit/5fca6ef184f795a9ff3749afa3109882ff7b8d4c)), closes [#11294](https://github.com/vuetifyjs/vuetify/issues/11294)
* **VBtn:** show background on non-elevated buttons, fix color states ([#12908](https://github.com/vuetifyjs/vuetify/issues/12908)) ([a2a61c2](https://github.com/vuetifyjs/vuetify/commit/a2a61c24542e7c5b99560c222c10caa2b2867b77)), closes [#12903](https://github.com/vuetifyjs/vuetify/issues/12903) [#12892](https://github.com/vuetifyjs/vuetify/issues/12892) [#12845](https://github.com/vuetifyjs/vuetify/issues/12845)
* **VBtnToggle:** apply min-width to dense buttons ([6589ed8](https://github.com/vuetifyjs/vuetify/commit/6589ed8812468963f17523e2c8723a973f956a06)), closes [#13820](https://github.com/vuetifyjs/vuetify/issues/13820)
* **vcalendar:** object inheritance ([#12857](https://github.com/vuetifyjs/vuetify/issues/12857)) ([de3112a](https://github.com/vuetifyjs/vuetify/commit/de3112a3654516f7818e5a2a24bc17e6fe30c5c3))
* **VCalendar:** add support for string[] of categories ([#13270](https://github.com/vuetifyjs/vuetify/issues/13270)) ([1a12f12](https://github.com/vuetifyjs/vuetify/commit/1a12f12cbe3cc0f3d00ff2c0460115641b33bd3a)), closes [#12922](https://github.com/vuetifyjs/vuetify/issues/12922)
* **VCalendar:** display events ending at midnight ([#13667](https://github.com/vuetifyjs/vuetify/issues/13667)) ([9a48b0f](https://github.com/vuetifyjs/vuetify/commit/9a48b0fd30d1655393aed32357e9d8a3561786c8)), closes [#11767](https://github.com/vuetifyjs/vuetify/issues/11767) [#12223](https://github.com/vuetifyjs/vuetify/issues/12223)
* **VCalendar:** fix interval-style day when categoryDays > 1 ([#13384](https://github.com/vuetifyjs/vuetify/issues/13384)) ([434df3b](https://github.com/vuetifyjs/vuetify/commit/434df3b5a4d720a936b76d4e26554dcbb35c4623))
* **VCalendar:** missing events under certain circumstances ([#13763](https://github.com/vuetifyjs/vuetify/issues/13763)) ([8226cc9](https://github.com/vuetifyjs/vuetify/commit/8226cc96633537ebce84bf472e9e4bf3e6787db4)), closes [#13720](https://github.com/vuetifyjs/vuetify/issues/13720)
* **VCalendar:** resolve wrong relative day span for 4day ([#12687](https://github.com/vuetifyjs/vuetify/issues/12687)) ([d9138f5](https://github.com/vuetifyjs/vuetify/commit/d9138f5f880f93e2e9e89f9773cf33e5ad790b2f)), closes [#12666](https://github.com/vuetifyjs/vuetify/issues/12666)
* **VCalendar:** type category should display events ([2417f56](https://github.com/vuetifyjs/vuetify/commit/2417f56572e2b2c4a57797c7d2e1590e4dd6b389))
* **VCalendarCategory:** always render at least one day body per day ([c90fda6](https://github.com/vuetifyjs/vuetify/commit/c90fda641429be078dc813a823158cc5ee6878a7)), closes [#13155](https://github.com/vuetifyjs/vuetify/issues/13155)
* **VCalendarCategory:** category schedule for more than 1 day ([#13050](https://github.com/vuetifyjs/vuetify/issues/13050)) ([a2d014d](https://github.com/vuetifyjs/vuetify/commit/a2d014dfbd2367654e8c5eaf783d4dbac9e40979)), closes [#12967](https://github.com/vuetifyjs/vuetify/issues/12967)
* **VCard:** incorrect positioning for v-card-actions in v-dialog ([#12734](https://github.com/vuetifyjs/vuetify/issues/12734)) ([5ce3cd5](https://github.com/vuetifyjs/vuetify/commit/5ce3cd5950c6a23e2f8a4154e557e40c0239c128)), closes [#10605](https://github.com/vuetifyjs/vuetify/issues/10605) [#10605](https://github.com/vuetifyjs/vuetify/issues/10605)
* **VCard:** set correct radius for direct VAvatar children ([#13789](https://github.com/vuetifyjs/vuetify/issues/13789)) ([00b29ba](https://github.com/vuetifyjs/vuetify/commit/00b29ba06691b291b3d5fc4dcb72d97344d8e145))
* **VCard:** use a child combinator for v-card-subtitle color style ([a29b965](https://github.com/vuetifyjs/vuetify/commit/a29b9656d7d066d20e2c53d8843948195720d2ce)), closes [#13745](https://github.com/vuetifyjs/vuetify/issues/13745)
* **VCarousel:** incorrect transition direction when using touch ([#12357](https://github.com/vuetifyjs/vuetify/issues/12357)) ([2160daf](https://github.com/vuetifyjs/vuetify/commit/2160daf31f47161fbac85458383f529e90ca3d86)), closes [#11280](https://github.com/vuetifyjs/vuetify/issues/11280)
* **VCarousel:** prevent TypeError in v-if ([#13669](https://github.com/vuetifyjs/vuetify/issues/13669)) ([22db933](https://github.com/vuetifyjs/vuetify/commit/22db9334495802ed155ca52e519d342e5faf30bd)), closes [#13656](https://github.com/vuetifyjs/vuetify/issues/13656)
* **VCarousel:** stop event propagation for prev/next buttons ([#12678](https://github.com/vuetifyjs/vuetify/issues/12678)) ([07eb09e](https://github.com/vuetifyjs/vuetify/commit/07eb09e42a448b4dee2ae363826ec14dcac5af6e))
* **VChip:** icon size based on chip size prop ([#13412](https://github.com/vuetifyjs/vuetify/issues/13412)) ([f6866d4](https://github.com/vuetifyjs/vuetify/commit/f6866d4dbcea09ab100aec230d0ece9bf67c5ae5)), closes [#13248](https://github.com/vuetifyjs/vuetify/issues/13248)
* **VColorPicker:** Allow swatches to be disabled ([#13208](https://github.com/vuetifyjs/vuetify/issues/13208)) ([ed76169](https://github.com/vuetifyjs/vuetify/commit/ed76169e26795f9fd386d3b371af3c47ad70fb35)), closes [#13160](https://github.com/vuetifyjs/vuetify/issues/13160)
* **VCombobox:** clear search if matching item is selected ([#12896](https://github.com/vuetifyjs/vuetify/issues/12896)) ([6b92f53](https://github.com/vuetifyjs/vuetify/commit/6b92f531a20bd7825505a3b2552dc1cdba8ab1e9)), closes [#8842](https://github.com/vuetifyjs/vuetify/issues/8842)
* **VCombobox:** correctly handle duplicate items ([#13366](https://github.com/vuetifyjs/vuetify/issues/13366)) ([5fbea51](https://github.com/vuetifyjs/vuetify/commit/5fbea51840c399af5e7b32191b366e5121f4d4f8)), closes [#12351](https://github.com/vuetifyjs/vuetify/issues/12351)
* **VCombobox:** don't reset value to null if search is empty ([#12415](https://github.com/vuetifyjs/vuetify/issues/12415)) ([f1b621b](https://github.com/vuetifyjs/vuetify/commit/f1b621b3c400ef18c233850a1583ec0d0fa9f0ff)), closes [#12322](https://github.com/vuetifyjs/vuetify/issues/12322)
* **VCombobox:** fixed incorrect combobox behaviour ([#12806](https://github.com/vuetifyjs/vuetify/issues/12806)) ([fd339ed](https://github.com/vuetifyjs/vuetify/commit/fd339edfa780399a98cf4723e5a4f270a613eed3)), closes [#12781](https://github.com/vuetifyjs/vuetify/issues/12781)
* **VCombobox:** re-compute menu items before setting index ([#13825](https://github.com/vuetifyjs/vuetify/issues/13825)) ([8c0e2bc](https://github.com/vuetifyjs/vuetify/commit/8c0e2bcce1c9ccd64cbf5f5d085d2ca9becbac3c)), closes [#12567](https://github.com/vuetifyjs/vuetify/issues/12567)
* **VDataFooter:** show custom footer.page-text on empty data tables ([#12651](https://github.com/vuetifyjs/vuetify/issues/12651)) ([d9d3cb3](https://github.com/vuetifyjs/vuetify/commit/d9d3cb30fa5f86f94578cded02c5858e60b88b1b))
* **VDataIterator:** use itemKey instead of name for select ([#13679](https://github.com/vuetifyjs/vuetify/issues/13679)) ([b750730](https://github.com/vuetifyjs/vuetify/commit/b750730c1612a917b4c6f81f7799ddaebdca92bf)), closes [#13677](https://github.com/vuetifyjs/vuetify/issues/13677)
* **VDataTable:** clamp current page when filtering ([#13087](https://github.com/vuetifyjs/vuetify/issues/13087)) ([df75ad3](https://github.com/vuetifyjs/vuetify/commit/df75ad3555d5e30b743ad2697b91c0a7fcb2f252)), closes [#12732](https://github.com/vuetifyjs/vuetify/issues/12732)
* **VDataTable:** convert dates to timestamps before sorting ([3171d6f](https://github.com/vuetifyjs/vuetify/commit/3171d6f460ef41758817d54f18e20d6196ef05fb)), closes [#13829](https://github.com/vuetifyjs/vuetify/issues/13829)
* **VDataTable:** display as flex column on mobile ([4cc80ca](https://github.com/vuetifyjs/vuetify/commit/4cc80ca7bea963be875b3ab0f9ba03a8b21c4d92)), closes [#11337](https://github.com/vuetifyjs/vuetify/issues/11337)
* **VDataTable:** prevent NaN when itemsPerPage is 0 ([e57bd6d](https://github.com/vuetifyjs/vuetify/commit/e57bd6d78f26ea7ddddfce6b91d640651768d097)), closes [#13087](https://github.com/vuetifyjs/vuetify/issues/13087)
* **VDataTableHeader:** decrease sort icon line height ([#12868](https://github.com/vuetifyjs/vuetify/issues/12868)) ([da21feb](https://github.com/vuetifyjs/vuetify/commit/da21feb403b3282381c1b920eaecb3f0ad76400d)), closes [#12823](https://github.com/vuetifyjs/vuetify/issues/12823)
* **VDatePicker:** correctly show weeks and dates ([#13225](https://github.com/vuetifyjs/vuetify/issues/13225)) ([5ed2e0f](https://github.com/vuetifyjs/vuetify/commit/5ed2e0f1cb1e5c90a2b5f05d728cbcaaf17baa1d))
* **VDatePicker:** prevent scroll beyond max date with touchpad ([#13456](https://github.com/vuetifyjs/vuetify/issues/13456)) ([41e0311](https://github.com/vuetifyjs/vuetify/commit/41e03113eacf71a3dfa78cf3875f4f23fe70bdc6))
* **VDatePicker:** scroll not honoring min and max tableDate ([#12904](https://github.com/vuetifyjs/vuetify/issues/12904)) ([e91b288](https://github.com/vuetifyjs/vuetify/commit/e91b288cdaae40f52efb1ba1ec67903b090c1bea))
* **VDivider:** prevent wrapping in flex layouts ([f0892c3](https://github.com/vuetifyjs/vuetify/commit/f0892c3a14a6b8c2e49d953d60609ac309d897f1)), closes [#11973](https://github.com/vuetifyjs/vuetify/issues/11973)
* **VDivider:** vertical v-divider is not displayed when inside div and inline ([#12735](https://github.com/vuetifyjs/vuetify/issues/12735)) ([985ef44](https://github.com/vuetifyjs/vuetify/commit/985ef44d948bab4ab371191f539de5ad5c3a476b)), closes [#8656](https://github.com/vuetifyjs/vuetify/issues/8656)
* **VExpansionPanel:** don't boot before showing if opened externally ([0b8fc27](https://github.com/vuetifyjs/vuetify/commit/0b8fc27c6d9c02d4daced65ff966a8adfde93e33)), closes [#10140](https://github.com/vuetifyjs/vuetify/issues/10140)
* **VFileInput:** allow multiple to be bound as false ([08c1e89](https://github.com/vuetifyjs/vuetify/commit/08c1e8911ebe6f36114c9eb1bae7f449944bff78)), closes [#9530](https://github.com/vuetifyjs/vuetify/issues/9530)
* **VFileInput:** prevent label and placeholder overlap ([#12891](https://github.com/vuetifyjs/vuetify/issues/12891)) ([ff2fbb1](https://github.com/vuetifyjs/vuetify/commit/ff2fbb175d38e6c62f0b2366137d8f8c629a1d41)), closes [#12864](https://github.com/vuetifyjs/vuetify/issues/12864)
* **VImg:** default ratio to 1:1 for SVG images ([#12784](https://github.com/vuetifyjs/vuetify/issues/12784)) ([57b1e37](https://github.com/vuetifyjs/vuetify/commit/57b1e37b4852fe683f35ae42f2a9b2b35c704079)), closes [#11426](https://github.com/vuetifyjs/vuetify/issues/11426)
* **VImg:** SVG size wrong after uncached load ([#12825](https://github.com/vuetifyjs/vuetify/issues/12825)) ([a6e2e44](https://github.com/vuetifyjs/vuetify/commit/a6e2e44e718df4fa638620f561f58c8828b3ac66))
* **VLazy:** don't immediately show content if transition not set ([f1c2981](https://github.com/vuetifyjs/vuetify/commit/f1c2981987a93965e8abae6cf55fbfa11c737ced)), closes [#11801](https://github.com/vuetifyjs/vuetify/issues/11801)
* **VListGroup:** support regexp in the group prop ([43b0406](https://github.com/vuetifyjs/vuetify/commit/43b0406a89169dae8e53a705f5a7b20e03733591)), closes [#7812](https://github.com/vuetifyjs/vuetify/issues/7812)
* **VListItem:** use item role when in a group ([#13126](https://github.com/vuetifyjs/vuetify/issues/13126)) ([4974d74](https://github.com/vuetifyjs/vuetify/commit/4974d746720a0daea686448a273a310628a177b9)), closes [#13125](https://github.com/vuetifyjs/vuetify/issues/13125)
* **VMenu:** activator should not return non Element nodes ([#13774](https://github.com/vuetifyjs/vuetify/issues/13774)) ([25e80a1](https://github.com/vuetifyjs/vuetify/commit/25e80a11d4e61e5ceef8659e24b8c63c39f8469b)), closes [#13755](https://github.com/vuetifyjs/vuetify/issues/13755)
* **VMenu:** apply position:relative to v-app ([#13823](https://github.com/vuetifyjs/vuetify/issues/13823)) ([d8679b9](https://github.com/vuetifyjs/vuetify/commit/d8679b9e99a164059991b53e5defa6e6acddf7e1)), closes [#13821](https://github.com/vuetifyjs/vuetify/issues/13821)
* **VPagination:** add disabled attr to buttons ([#12953](https://github.com/vuetifyjs/vuetify/issues/12953)) ([#12990](https://github.com/vuetifyjs/vuetify/issues/12990)) ([0329e5b](https://github.com/vuetifyjs/vuetify/commit/0329e5b6b7730703bc01ff0df3fc7693e76b3231))
* **VPagination:** don't show ellipsis for one item ([#13560](https://github.com/vuetifyjs/vuetify/issues/13560)) ([bcd0379](https://github.com/vuetifyjs/vuetify/commit/bcd0379902d70e5e36e3b3905c4b45c153f86a57))
* **VProgressCircular:** prevent animation flicker ([944077e](https://github.com/vuetifyjs/vuetify/commit/944077e1695a4b4d776fbc973006710519d558a6)), closes [#12813](https://github.com/vuetifyjs/vuetify/issues/12813)
* **VRangeSlider:** properly use trackFillColor ([#12777](https://github.com/vuetifyjs/vuetify/issues/12777)) ([5cad5a0](https://github.com/vuetifyjs/vuetify/commit/5cad5a055523699b76e0b91f0a2cff802a273f96))
* **VRating:** add icon aria-label ([#12345](https://github.com/vuetifyjs/vuetify/issues/12345)) ([1be735c](https://github.com/vuetifyjs/vuetify/commit/1be735cf929126f271a677928b3d4ef7186524a4)), closes [#11590](https://github.com/vuetifyjs/vuetify/issues/11590)
* **VRating:** make icons tab-accessible ([#13098](https://github.com/vuetifyjs/vuetify/issues/13098)) ([9b1356a](https://github.com/vuetifyjs/vuetify/commit/9b1356a120109c57cc6df8621a504f8d4e5af3b2)), closes [#10820](https://github.com/vuetifyjs/vuetify/issues/10820)
* **VRipple:** hide ripple on blur ([#13264](https://github.com/vuetifyjs/vuetify/issues/13264)) ([2e95f6d](https://github.com/vuetifyjs/vuetify/commit/2e95f6d4c5fc77c8db1458e9d47550ae8e48618a)), closes [#13189](https://github.com/vuetifyjs/vuetify/issues/13189)
* **VRow:** increase specificity of no-gutters ([9892c6f](https://github.com/vuetifyjs/vuetify/commit/9892c6f5ed8f09b33289b78d24717586dddd9cb6)), closes [#13020](https://github.com/vuetifyjs/vuetify/issues/13020)
* **VSelect:** don't apply currentColor to selection slot ([c495ae8](https://github.com/vuetifyjs/vuetify/commit/c495ae87a95ef094c33adcd7ffcb63263708f30f)), closes [#11068](https://github.com/vuetifyjs/vuetify/issues/11068)
* **VSelect:** don't apply disabled styles to selections when readonly ([efe7116](https://github.com/vuetifyjs/vuetify/commit/efe711615eab08631aebd309dac0029590ab6d81)), closes [#11828](https://github.com/vuetifyjs/vuetify/issues/11828)
* **VSelect:** don't dispatch click event on arrow keys ([#12815](https://github.com/vuetifyjs/vuetify/issues/12815)) ([7fae557](https://github.com/vuetifyjs/vuetify/commit/7fae5577ae15fc590cd77191db220eaf29ed7ab7)), closes [#12769](https://github.com/vuetifyjs/vuetify/issues/12769) [#12723](https://github.com/vuetifyjs/vuetify/issues/12723)
* **VSelect:** don't resolve item values twice when emitting change ([6bdbc86](https://github.com/vuetifyjs/vuetify/commit/6bdbc86995ded07de5a657c0e22154d002745f0e)), closes [#13729](https://github.com/vuetifyjs/vuetify/issues/13729)
* **VSelect:** don't show placeholder when dirty ([ce2d5f8](https://github.com/vuetifyjs/vuetify/commit/ce2d5f82507c6e6869d3cb93959b736036246deb)), closes [#13131](https://github.com/vuetifyjs/vuetify/issues/13131)
* **VSelect:** ignore arrow up/down if no clickable tiles ([e1dd914](https://github.com/vuetifyjs/vuetify/commit/e1dd914daafc518c76161d3c3e478296f1598e96)), closes [#13084](https://github.com/vuetifyjs/vuetify/issues/13084)
* **VSelect:** show placeholder when using persistentPlaceholder ([44ef316](https://github.com/vuetifyjs/vuetify/commit/44ef3163d75d801ce1811812e3969644ed51896e)), closes [#13792](https://github.com/vuetifyjs/vuetify/issues/13792)
* **VSimpleCheckbox:** show ripple and hover ring ([7390484](https://github.com/vuetifyjs/vuetify/commit/739048495a8e4768794bee2a8517acef9e33c1fd)), closes [#12492](https://github.com/vuetifyjs/vuetify/issues/12492)
* **VSlideGroup:** fix scrollIntoView & arrows visibility ([#12318](https://github.com/vuetifyjs/vuetify/issues/12318)) ([f59279e](https://github.com/vuetifyjs/vuetify/commit/f59279ebec9b5fe9198e5bb8cf2e8c759bc90c0e))
* **VSlideGroup:** handle rounding issue if using browser zoom ([#13280](https://github.com/vuetifyjs/vuetify/issues/13280)) ([e35397c](https://github.com/vuetifyjs/vuetify/commit/e35397cdc7e25d5e365d137afdebb4d6bcb6623b)), closes [#13212](https://github.com/vuetifyjs/vuetify/issues/13212)
* **VSlider:** make slider drag respond to mousedown ([#12640](https://github.com/vuetifyjs/vuetify/issues/12640)) ([4133a76](https://github.com/vuetifyjs/vuetify/commit/4133a76f076783bb276088951cb9ef98abf99ba7))
* **VSlider:** only emit a single change event ([#13222](https://github.com/vuetifyjs/vuetify/issues/13222)) ([ed0b0ca](https://github.com/vuetifyjs/vuetify/commit/ed0b0ca7a0ab81671a0757d8d2c00b104c61b245)), closes [#13151](https://github.com/vuetifyjs/vuetify/issues/13151)
* **VSlider:** support touch and drag ([#13263](https://github.com/vuetifyjs/vuetify/issues/13263)) ([89b55e2](https://github.com/vuetifyjs/vuetify/commit/89b55e28750e39c4c6baab24d9b891e03eb35e8f)), closes [#13259](https://github.com/vuetifyjs/vuetify/issues/13259)
* **VSlider:** use a transition on the thumb when ticks are enabled ([eabff8a](https://github.com/vuetifyjs/vuetify/commit/eabff8a657e25100e0cfe063d0d950b1ec02466d)), closes [#12984](https://github.com/vuetifyjs/vuetify/issues/12984)
* **VSnackbar:** don't use !important for box-shadow ([11fd714](https://github.com/vuetifyjs/vuetify/commit/11fd714aad1913d6a7cf3b54952d68838db1c88d)), closes [#13438](https://github.com/vuetifyjs/vuetify/issues/13438)
* **VSnackbar:** set position of opposite direction values ([#12786](https://github.com/vuetifyjs/vuetify/issues/12786)) ([8c20c4f](https://github.com/vuetifyjs/vuetify/commit/8c20c4fc2b35c667ed5d278e663dc5d0356d8dd3)), closes [#11781](https://github.com/vuetifyjs/vuetify/issues/11781)
* **VTabs:** remove unused sass variables ([781370b](https://github.com/vuetifyjs/vuetify/commit/781370b9f718667c238558f4422e288dbab62851)), closes [#11217](https://github.com/vuetifyjs/vuetify/issues/11217)
* partially revert changes made in e83a203 ([8c650e4](https://github.com/vuetifyjs/vuetify/commit/8c650e48a53ac32ba44bd16d3f853a8b07810ff3)), closes [#11629](https://github.com/vuetifyjs/vuetify/issues/11629)
* remove unnecessary will-change ([a3ec892](https://github.com/vuetifyjs/vuetify/commit/a3ec892f2cd680dd8f7676559e3695dd2e675ba8)), closes [#12890](https://github.com/vuetifyjs/vuetify/issues/12890)
* **_reset.scss:** hide clear icon for search inputs ([eeb7492](https://github.com/vuetifyjs/vuetify/commit/eeb7492cf292e993de65080e5c482d82b1e643f7))
* **click-outside:** detect shadowRoot in handler ([#13462](https://github.com/vuetifyjs/vuetify/issues/13462)) ([708f8de](https://github.com/vuetifyjs/vuetify/commit/708f8de8e2055d6edf2e08492a9c8537b1672fec)), closes [#13275](https://github.com/vuetifyjs/vuetify/issues/13275)
* **intersect:** don't unbind until the element is intersecting ([#13593](https://github.com/vuetifyjs/vuetify/issues/13593)) ([806ac63](https://github.com/vuetifyjs/vuetify/commit/806ac63cd754f4e8cbfef62181094762c9f8d347))
* **locale:** improve ro translation ([#13402](https://github.com/vuetifyjs/vuetify/issues/13402)) ([ed6f621](https://github.com/vuetifyjs/vuetify/commit/ed6f621f9f9086382c2894ea695355ae0bdd1ab8))
* **locale:** update japanese translation ([#13413](https://github.com/vuetifyjs/vuetify/issues/13413)) ([427308d](https://github.com/vuetifyjs/vuetify/commit/427308d863bbddf976e002d9d4f7267228acc3d4))
* **Page:** increase max-width of page content ([#22](https://github.com/vuetifyjs/vuetify/issues/22)) ([fc82529](https://github.com/vuetifyjs/vuetify/commit/fc8252969374a490918b364286c8002adc850087))
* **theme:** convert color value to hex when not using variations ([172e852](https://github.com/vuetifyjs/vuetify/commit/172e852f70452108c356fa257def444dcc081be4))
* **transitions:** leaveAbsolute retains relative position and size ([b738de5](https://github.com/vuetifyjs/vuetify/commit/b738de5c279840a30eb640f73bf61a1c8ac2a7fd))
* **transitions:** make default transition !important ([d23ca5d](https://github.com/vuetifyjs/vuetify/commit/d23ca5d9cce7819de7e22abacdd47eeece2b4304)), closes [#9938](https://github.com/vuetifyjs/vuetify/issues/9938)
* **transitions:** remove absolute position after leave if leaveAbsolute ([2ad4586](https://github.com/vuetifyjs/vuetify/commit/2ad4586d0e45967e335dee8f50f5d25d681b2605))
* **typescript:** added missing VThemeProvider export in lib.d.ts ([#13642](https://github.com/vuetifyjs/vuetify/issues/13642)) ([8652b48](https://github.com/vuetifyjs/vuetify/commit/8652b482086ac661dc1e627abea242c2d38f6afd)), closes [#13578](https://github.com/vuetifyjs/vuetify/issues/13578)
* **v-intersect:** check for IntersectionObserver support ([b04dbba](https://github.com/vuetifyjs/vuetify/commit/b04dbba82fdd03c732f7b2e5ea144037f0b59b6a)), closes [#13644](https://github.com/vuetifyjs/vuetify/issues/13644)
* **VAlert:** increase margin for icon when using prominent and border ([4a33dfd](https://github.com/vuetifyjs/vuetify/commit/4a33dfdcb74d0689c9914b2f5f4276c84912d4a8))
* **VAlert:** reduce icon outline size for dense + prominent props ([d48eeb2](https://github.com/vuetifyjs/vuetify/commit/d48eeb24005d7704ac79d14e6e7510917e4e9ed9))
* **VAlert:** update prominent style ordering for specificity ([8e82aec](https://github.com/vuetifyjs/vuetify/commit/8e82aecd5793ddf7869e97cfd687f77972f6936a)), closes [#12181](https://github.com/vuetifyjs/vuetify/issues/12181)
* **validatable:** change logic for disabled and readonly inputs ([7e78d75](https://github.com/vuetifyjs/vuetify/commit/7e78d759a52e09f88ec8edcc3d817e054165141c)), closes [#11504](https://github.com/vuetifyjs/vuetify/issues/11504)
* **VAppBarTitle:** export VAppBarTitle types ([#13409](https://github.com/vuetifyjs/vuetify/issues/13409)) ([d20d124](https://github.com/vuetifyjs/vuetify/commit/d20d1241f1761040d785c27f4c090fd979c592fe)), closes [#13385](https://github.com/vuetifyjs/vuetify/issues/13385)
* **VAutocomplete:** compare current lazyValue before emiting update ([#13316](https://github.com/vuetifyjs/vuetify/issues/13316)) ([3024044](https://github.com/vuetifyjs/vuetify/commit/3024044342cdb06bbe63fca92cc41be31017b3bd))
* **VBadge:** fix icon size when using svg ([#13624](https://github.com/vuetifyjs/vuetify/issues/13624)) ([cd9a826](https://github.com/vuetifyjs/vuetify/commit/cd9a8264f52ce6cb39af5b12fa565b283786ff16)), closes [#13425](https://github.com/vuetifyjs/vuetify/issues/13425)
* **VBreadcrumbs:** remove duplicate scss var ([#13357](https://github.com/vuetifyjs/vuetify/issues/13357)) ([25f861c](https://github.com/vuetifyjs/vuetify/commit/25f861c69e32c2c4e767bf4c25b69010ab607754))
* **VCalendar:** apply explicit line-height to the .v-event div ([675d529](https://github.com/vuetifyjs/vuetify/commit/675d529aee1432116c28eb1903c4a63f25d7ece4))
* **VCarousel:** children inherit theme from carousel's parent ([faeb8df](https://github.com/vuetifyjs/vuetify/commit/faeb8dfb8b1361f2195ea89785b747bca3e24672)), closes [#8392](https://github.com/vuetifyjs/vuetify/issues/8392)
* **VCheckbox:** add variable checkbox-dense-padding-top ([#13420](https://github.com/vuetifyjs/vuetify/issues/13420)) ([f69d1a6](https://github.com/vuetifyjs/vuetify/commit/f69d1a6bf2d08386cb1d0667f11be349d03f5c3a))
* **VCombobox:** don't add empty values ([#13298](https://github.com/vuetifyjs/vuetify/issues/13298)) ([d2a042b](https://github.com/vuetifyjs/vuetify/commit/d2a042bea7debf2cc3b28700c64aea14db09783e)), closes [#13274](https://github.com/vuetifyjs/vuetify/issues/13274)
* **VCombobox:** reset editingIndex after clear ([#13382](https://github.com/vuetifyjs/vuetify/issues/13382)) ([335b39f](https://github.com/vuetifyjs/vuetify/commit/335b39f33dec7688efe049e6eb860bf9fafd7f01))
* **VContent:** display proper deprecated message ([#11589](https://github.com/vuetifyjs/vuetify/issues/11589)) ([0489e64](https://github.com/vuetifyjs/vuetify/commit/0489e64b0ac4686ff0154cb051f05408150d4a54))
* **VData:** allow group-by to be used with disable-sort ([#13027](https://github.com/vuetifyjs/vuetify/issues/13027)) ([560b52c](https://github.com/vuetifyjs/vuetify/commit/560b52cfde5f4467d48ba24967dc64e7495fba6b))
* **VDataTable:** union column filter with search results ([#11575](https://github.com/vuetifyjs/vuetify/issues/11575)) ([f15dbc4](https://github.com/vuetifyjs/vuetify/commit/f15dbc413741ebc881b2854bea556643a7763e78)), closes [#11402](https://github.com/vuetifyjs/vuetify/issues/11402)
* **VDataTable:** update child combinator selectors for dense & fixed-header props ([#11568](https://github.com/vuetifyjs/vuetify/issues/11568)) ([93a8aac](https://github.com/vuetifyjs/vuetify/commit/93a8aac33601883fabbb8687436cbdc871bc1496)), closes [#11566](https://github.com/vuetifyjs/vuetify/issues/11566) [#11567](https://github.com/vuetifyjs/vuetify/issues/11567)
* **VDatePicker:** consider allowed-dates in range ([#11592](https://github.com/vuetifyjs/vuetify/issues/11592)) ([49f15a7](https://github.com/vuetifyjs/vuetify/commit/49f15a7fead26d27c8257e1828a5e9d9db286544)), closes [#10639](https://github.com/vuetifyjs/vuetify/issues/10639)
* **VDatePicker:** throttle scroll with using scrollable prop ([#11372](https://github.com/vuetifyjs/vuetify/issues/11372)) ([bb18234](https://github.com/vuetifyjs/vuetify/commit/bb18234d172698ffd97df1631856aac6c8f04773)), closes [#5546](https://github.com/vuetifyjs/vuetify/issues/5546)
* **VDatePicker:** touch not honoring min and max tableDate ([#13436](https://github.com/vuetifyjs/vuetify/issues/13436)) ([a77d19f](https://github.com/vuetifyjs/vuetify/commit/a77d19f7ec4b1a28ab8dc31f78e267bb87ac42a1))
* **VDialog:** don't try to focus disabled elements ([238f361](https://github.com/vuetifyjs/vuetify/commit/238f3612c0463cd83a08941b52e0f0f696607721)), closes [#11547](https://github.com/vuetifyjs/vuetify/issues/11547)
* **VExpansionPanelHeader:** add missing aria-expanded attribute ([#13355](https://github.com/vuetifyjs/vuetify/issues/13355)) ([4b58e9c](https://github.com/vuetifyjs/vuetify/commit/4b58e9ca8e9a72997ac341f2b8d76eeeac527066))
* **VExpansionPanels:** change aria-expanded to use isActive ([#13361](https://github.com/vuetifyjs/vuetify/issues/13361)) ([4c1a9ad](https://github.com/vuetifyjs/vuetify/commit/4c1a9ad11c3be899bc11dc7e5d9dbd0b10ef9871))
* **VIcon:** support fontawsome kits ([1f1a07c](https://github.com/vuetifyjs/vuetify/commit/1f1a07c7ed12fd7441d700ef262bf77ff9660a17)), closes [#13649](https://github.com/vuetifyjs/vuetify/issues/13649)
* **VImg:** set srcset before src ([0a0bd5e](https://github.com/vuetifyjs/vuetify/commit/0a0bd5e6fb8c91ce7c888229dbf478ec892b65c6)), closes [#13423](https://github.com/vuetifyjs/vuetify/issues/13423)
* **VNavigationDrawer:** disable inherit value of background property ([#11419](https://github.com/vuetifyjs/vuetify/issues/11419)) ([2974f15](https://github.com/vuetifyjs/vuetify/commit/2974f157407931a5db798cff6406e1345dc53a0d)), closes [#11153](https://github.com/vuetifyjs/vuetify/issues/11153)
* **VProgressLinear:** limit buffer width to positive numbers ([1d6a916](https://github.com/vuetifyjs/vuetify/commit/1d6a916a160eb88177a11870129e66eac766c459)), closes [#13616](https://github.com/vuetifyjs/vuetify/issues/13616)
* **VSelect:** add min-width for overflowed selection items ([#11532](https://github.com/vuetifyjs/vuetify/issues/11532)) ([5ecebfc](https://github.com/vuetifyjs/vuetify/commit/5ecebfcb4aaf4baa59cc82313eebf5e2182fe187)), closes [#11524](https://github.com/vuetifyjs/vuetify/issues/11524)
* **VSelect:** allow tab key down on read-only ([#11431](https://github.com/vuetifyjs/vuetify/issues/11431)) ([1c6de0c](https://github.com/vuetifyjs/vuetify/commit/1c6de0c54877e9d5686afe9827b4b9d0a29f2460)), closes [#11430](https://github.com/vuetifyjs/vuetify/issues/11430)
* **VSelect:** compare object values before emitting change ([#13664](https://github.com/vuetifyjs/vuetify/issues/13664)) ([7ddf113](https://github.com/vuetifyjs/vuetify/commit/7ddf113f048688dc192a27d2b87c0b4bb635c31a)), closes [#13658](https://github.com/vuetifyjs/vuetify/issues/13658)
* **VSelect:** make CSS order-independent ([#13150](https://github.com/vuetifyjs/vuetify/issues/13150)) ([d285435](https://github.com/vuetifyjs/vuetify/commit/d28543579ccb5d42af160968f186410b06b75b13)), closes [#13149](https://github.com/vuetifyjs/vuetify/issues/13149)
* **VSelect:** resolve "Expected identifier." error ([#13439](https://github.com/vuetifyjs/vuetify/issues/13439)) ([99e6738](https://github.com/vuetifyjs/vuetify/commit/99e673832cce88ff52ccb69de95601bbab802fa4))
* **VSelect:** specify min-height 10px ([#13101](https://github.com/vuetifyjs/vuetify/issues/13101)) ([846a96d](https://github.com/vuetifyjs/vuetify/commit/846a96d6823d7932b5e831bb7971924b6522dee8))
* **VSimpleTable:** change css selector for fixed-header dense tables ([1ec7de8](https://github.com/vuetifyjs/vuetify/commit/1ec7de809d064ff917d1088f0b70b1678453690a)), closes [#11525](https://github.com/vuetifyjs/vuetify/issues/11525)
* **VSimpleTable:** reset table line-height and  adjust td dense height ([d634514](https://github.com/vuetifyjs/vuetify/commit/d6345149029e816802ff79eac05b3c61b84b956c))
* **VSlideGroup:** detect horizontal/vertical swipe intent ([#13005](https://github.com/vuetifyjs/vuetify/issues/13005)) ([f6124be](https://github.com/vuetifyjs/vuetify/commit/f6124be8790d5294354b6c808edcde6abc3f7b2e))
* **VSlideGroup:** revert deprecation of show-arrows true ([1085c02](https://github.com/vuetifyjs/vuetify/commit/1085c02f0caac82a604d9e4b0433961efd653cfe)), closes [#11620](https://github.com/vuetifyjs/vuetify/issues/11620)
* **VVirtualScroll:** provide correct item index to default slot ([#11643](https://github.com/vuetifyjs/vuetify/issues/11643)) ([4dbaec1](https://github.com/vuetifyjs/vuetify/commit/4dbaec19f1a4b1ca19d6fa861a8176669aefd393)), closes [#11622](https://github.com/vuetifyjs/vuetify/issues/11622)
* pass env to md.parse() ([ba82d29](https://github.com/vuetifyjs/vuetify/commit/ba82d291033cca9f803c2a1b28bf9bded3891cc0))
* **VSlideGroup:** vertical scroll lock for touch ([#11571](https://github.com/vuetifyjs/vuetify/issues/11571)) ([76d5862](https://github.com/vuetifyjs/vuetify/commit/76d5862ab0a9937f9fd5fdd6a42d5d5bf158b0cd)), closes [#10673](https://github.com/vuetifyjs/vuetify/issues/10673)
* **VSlider:** add mouseup event emit ([#11594](https://github.com/vuetifyjs/vuetify/issues/11594)) ([fb5e393](https://github.com/vuetifyjs/vuetify/commit/fb5e393bea4eb81f37275afc52303edcf65e7130)), closes [#11577](https://github.com/vuetifyjs/vuetify/issues/11577)
* **VSnackbar:** add missing size prop integration ([#13340](https://github.com/vuetifyjs/vuetify/issues/13340)) ([cbfad79](https://github.com/vuetifyjs/vuetify/commit/cbfad7974920a000307cc69ac952016021db2dbe)), closes [#11632](https://github.com/vuetifyjs/vuetify/issues/11632)
* **VTabs:** right aligned tabs in vertical mode ([#13012](https://github.com/vuetifyjs/vuetify/issues/13012)) ([18c2d6c](https://github.com/vuetifyjs/vuetify/commit/18c2d6ce95978cd2b75a6eaace45141deaa7dbad))
* **VTabsItems:** keep rounded corners during animations ([#11983](https://github.com/vuetifyjs/vuetify/issues/11983)) ([107bd32](https://github.com/vuetifyjs/vuetify/commit/107bd328e33f66646787fbdd0821d9f274543663))
* **VTextField:** add padding-top custom variable to details ([#12661](https://github.com/vuetifyjs/vuetify/issues/12661)) ([47e190e](https://github.com/vuetifyjs/vuetify/commit/47e190eb2ca20e2bafaa65ea221382f0e29b6500)), closes [#12660](https://github.com/vuetifyjs/vuetify/issues/12660)
* **VTextField:** align dense mode text field prefix and content ([#12759](https://github.com/vuetifyjs/vuetify/issues/12759)) ([e90e07a](https://github.com/vuetifyjs/vuetify/commit/e90e07acfd53409237bcaee60a725785d0c0827f)), closes [#12743](https://github.com/vuetifyjs/vuetify/issues/12743) [#12743](https://github.com/vuetifyjs/vuetify/issues/12743) [#12743](https://github.com/vuetifyjs/vuetify/issues/12743)
* **VTextField:** allow numeric input starting with -0  ([#11454](https://github.com/vuetifyjs/vuetify/issues/11454)) ([ef677fb](https://github.com/vuetifyjs/vuetify/commit/ef677fb3df3faf23e1905621f5d006fa920e0a16)), closes [#9368](https://github.com/vuetifyjs/vuetify/issues/9368) [#9368](https://github.com/vuetifyjs/vuetify/issues/9368)
* **VTextField:** detect activeElement from shadowRoot ([#13053](https://github.com/vuetifyjs/vuetify/issues/13053)) ([dc19b82](https://github.com/vuetifyjs/vuetify/commit/dc19b82e2b9178ddf553b42a981208d6f2d811ac)), closes [#7622](https://github.com/vuetifyjs/vuetify/issues/7622)
* **VTextField:** fix click dead zone when using clearable ([#13576](https://github.com/vuetifyjs/vuetify/issues/13576)) ([67346db](https://github.com/vuetifyjs/vuetify/commit/67346dbb02cfd7f69076098b326d591738df8cbf)), closes [#10965](https://github.com/vuetifyjs/vuetify/issues/10965)
* **VTextField:** hide-details auto animation ([#12554](https://github.com/vuetifyjs/vuetify/issues/12554)) ([07ef4e1](https://github.com/vuetifyjs/vuetify/commit/07ef4e1b98e9f47e6320a6f44a8e53d4704fe176))
* **VTextField:** legend position not aligned with reverse prop ([#13051](https://github.com/vuetifyjs/vuetify/issues/13051)) ([9e93f7d](https://github.com/vuetifyjs/vuetify/commit/9e93f7de116625c4821d2be35588d8b05e50973e)), closes [#10798](https://github.com/vuetifyjs/vuetify/issues/10798)
* **VTimePickerClock:** race condition between event and $refs ([#13648](https://github.com/vuetifyjs/vuetify/issues/13648)) ([a536e15](https://github.com/vuetifyjs/vuetify/commit/a536e15eb649f8ec19dd65d6228ccc2a18b6987f))
* **VTooltip:** don't add role:button to activator ([#12428](https://github.com/vuetifyjs/vuetify/issues/12428)) ([ec15822](https://github.com/vuetifyjs/vuetify/commit/ec158223e4be38a8eff1a0cc04f96dee29fd72e4)), closes [#12360](https://github.com/vuetifyjs/vuetify/issues/12360)
* **VTooltip:** lazy without transition ([2e55652](https://github.com/vuetifyjs/vuetify/commit/2e556524435bde7bd5a0ac7adb01bbe9411f9892))
* **VTreeview:** disabled items should be ignored when selecting parent ([#11232](https://github.com/vuetifyjs/vuetify/issues/11232)) ([3184f7e](https://github.com/vuetifyjs/vuetify/commit/3184f7e4a9706ae244da98cba03936bc9e526fff)), closes [#8244](https://github.com/vuetifyjs/vuetify/issues/8244)
* **VTreeview:** do not set indeterminate on new leafs ([adbb374](https://github.com/vuetifyjs/vuetify/commit/adbb3746b5775d6d954c8573350afc0b7c688409)), closes [#8256](https://github.com/vuetifyjs/vuetify/issues/8256)
* **VTreeview:** emit opened nodes when using load-children ([#11339](https://github.com/vuetifyjs/vuetify/issues/11339)) ([4a0916f](https://github.com/vuetifyjs/vuetify/commit/4a0916f34892b7001095545e785932b71afc8b2c)), closes [#9693](https://github.com/vuetifyjs/vuetify/issues/9693)
* **VTreeview:** incorrect alignment of nodes ([#9640](https://github.com/vuetifyjs/vuetify/issues/9640)) ([6e368ed](https://github.com/vuetifyjs/vuetify/commit/6e368edf57455d20a0d8c19945ee831bb9b24ca8)), closes [#8212](https://github.com/vuetifyjs/vuetify/issues/8212)
* **VTreeview:** independent children should be selectable when parent is disabled ([#11233](https://github.com/vuetifyjs/vuetify/issues/11233)) ([06a7af3](https://github.com/vuetifyjs/vuetify/commit/06a7af374f6eddcca12a170b2ba2852712fc0979)), closes [#10770](https://github.com/vuetifyjs/vuetify/issues/10770) [#10990](https://github.com/vuetifyjs/vuetify/issues/10990)
* **VTreeview:** load initial selection when using return-object ([#9633](https://github.com/vuetifyjs/vuetify/issues/9633)) ([9b20cd5](https://github.com/vuetifyjs/vuetify/commit/9b20cd5a037f986ac869308b1cd267c557757c37)), closes [#8709](https://github.com/vuetifyjs/vuetify/issues/8709)
* **VTreeview:** respect selection-type when rebuilding tree ([#10653](https://github.com/vuetifyjs/vuetify/issues/10653)) ([10087bb](https://github.com/vuetifyjs/vuetify/commit/10087bbe11cb4d4a89a5bb9b62ee001aad607e66)), closes [#8720](https://github.com/vuetifyjs/vuetify/issues/8720)
* **VTreeview.sass:** center vertically treeview items on IE11 ([#10816](https://github.com/vuetifyjs/vuetify/issues/10816)) ([f39a93d](https://github.com/vuetifyjs/vuetify/commit/f39a93d019abf9b4ba8968120e2d0d07ce1f94d1)), closes [#10534](https://github.com/vuetifyjs/vuetify/issues/10534)
* **VVirtualScroll:** re-calculate scroll area when height changes ([e601345](https://github.com/vuetifyjs/vuetify/commit/e601345f5ddcab0198958f724fd9b05cf13a327e)), closes [#11665](https://github.com/vuetifyjs/vuetify/issues/11665)
* **VVirtualScroller:** properly key children to avoid re-render ([#11327](https://github.com/vuetifyjs/vuetify/issues/11327)) ([14ce2f1](https://github.com/vuetifyjs/vuetify/commit/14ce2f15f53fbd0d44d7ac47e6e1a46712101ced))
* **VWindow:** apply correct transition when using the reverse prop ([51d61d2](https://github.com/vuetifyjs/vuetify/commit/51d61d27d09f8534979c97236f052a6408abd2d0)), closes [#10182](https://github.com/vuetifyjs/vuetify/issues/10182)
* **VWindow:** fix wrong reverse animation logic for only 2 items ([#12685](https://github.com/vuetifyjs/vuetify/issues/12685)) ([be00b92](https://github.com/vuetifyjs/vuetify/commit/be00b92cf61cf6f177edd72dcdf2fe9b9a79b904)), closes [#12672](https://github.com/vuetifyjs/vuetify/issues/12672)
* **VWindow:** transition in RTL mode ([#9464](https://github.com/vuetifyjs/vuetify/issues/9464)) ([90b5f3d](https://github.com/vuetifyjs/vuetify/commit/90b5f3d4e0eb075968b6522c8b2136a169e46d5b))
* **VWindow:** transition snap with different content height ([#13611](https://github.com/vuetifyjs/vuetify/issues/13611)) ([4a0d349](https://github.com/vuetifyjs/vuetify/commit/4a0d3498ad5c44cb085180ed9dcaa92ef82ad1ae)), closes [#13360](https://github.com/vuetifyjs/vuetify/issues/13360)
* add missing ltr() rules ([#9649](https://github.com/vuetifyjs/vuetify/issues/9649)) ([8f772a7](https://github.com/vuetifyjs/vuetify/commit/8f772a78ecae407f1038095aa01e055a65ed8f2e)), closes [#7586](https://github.com/vuetifyjs/vuetify/issues/7586)
* don't use nativeOn on native elements ([#11228](https://github.com/vuetifyjs/vuetify/issues/11228)) ([6168845](https://github.com/vuetifyjs/vuetify/commit/61688457776c30a69882ba5a76f989181d707a03)), closes [#9999](https://github.com/vuetifyjs/vuetify/issues/9999)
* **#6962:** Fix race conditions in VWindowItem.ts during transition. ([#8205](https://github.com/vuetifyjs/vuetify/issues/8205)) ([1523cf6](https://github.com/vuetifyjs/vuetify/commit/1523cf68f3d9a0decb058392bbb3ffca04c8b981)), closes [#6962](https://github.com/vuetifyjs/vuetify/issues/6962)
* **bind-attrs:** fix transition-group animation ([#9224](https://github.com/vuetifyjs/vuetify/issues/9224)) ([356034a](https://github.com/vuetifyjs/vuetify/commit/356034ad8862512576b64c662b68420f6583f462)), closes [#9171](https://github.com/vuetifyjs/vuetify/issues/9171)
* **breakpoint:** allow 0 value for scrollBarWidth ([#9401](https://github.com/vuetifyjs/vuetify/issues/9401)) ([a169612](https://github.com/vuetifyjs/vuetify/commit/a1696123089bd7c278fd6f3f2ce13e696c6ec3d4))
* **detachable:** detach when lazy and inititally open ([19bf5d3](https://github.com/vuetifyjs/vuetify/commit/19bf5d319bf810a5ca97efef84e90df01dfd9edb)), closes [#9175](https://github.com/vuetifyjs/vuetify/issues/9175)
* **docs:** remove gutters from nav drawers ([#9567](https://github.com/vuetifyjs/vuetify/issues/9567)) ([6f9b2f8](https://github.com/vuetifyjs/vuetify/commit/6f9b2f8d8831979798cf988b0218be5318007ab3))
* **goTo:** get clientHeight from <html> when target is <body> ([854c826](https://github.com/vuetifyjs/vuetify/commit/854c8265af5970c38d8809804d9aad708593b219)), closes [#6914](https://github.com/vuetifyjs/vuetify/issues/6914)
* **goTo:** goTo scrolls to container top ([#8687](https://github.com/vuetifyjs/vuetify/issues/8687)) ([e520433](https://github.com/vuetifyjs/vuetify/commit/e5204338def6720b6870724e89d47dc995a06030)), closes [#8662](https://github.com/vuetifyjs/vuetify/issues/8662) [#6933](https://github.com/vuetifyjs/vuetify/issues/6933)
* **grid:** allow binding style strings ([3279945](https://github.com/vuetifyjs/vuetify/commit/327994562f1aa67e931f8372aacbeb2ad469e750)), closes [#8328](https://github.com/vuetifyjs/vuetify/issues/8328)
* **icons:** use correct fa4 radioOn icon ([d14dcc9](https://github.com/vuetifyjs/vuetify/commit/d14dcc90c7d4d3878fb7ca8083b94ede37a80e12)), closes [#8201](https://github.com/vuetifyjs/vuetify/issues/8201)
* **locale:** add missing Italian translations ([#9022](https://github.com/vuetifyjs/vuetify/issues/9022)) ([2d51ae1](https://github.com/vuetifyjs/vuetify/commit/2d51ae1011812996bc7f2525f25b3b59e8fa12c9))
* **locale:** complete hebrew translation ([e711fbf](https://github.com/vuetifyjs/vuetify/commit/e711fbfeb658570b85c1a1662b4df1bb7556f452))
* **locale:** fix ko translation of noDataText ([#9305](https://github.com/vuetifyjs/vuetify/issues/9305)) ([058b1fe](https://github.com/vuetifyjs/vuetify/commit/058b1fe857d3aab1dbdb2143a69e66b9435dc1e9))
* **locale:** update japanese translation ([#9238](https://github.com/vuetifyjs/vuetify/issues/9238)) ([d7b8e5a](https://github.com/vuetifyjs/vuetify/commit/d7b8e5a3e87700601c4f2446f49dfb04c8125f69))
* **locale:** update Portuguese translation ([#9683](https://github.com/vuetifyjs/vuetify/issues/9683)) ([dd3acaf](https://github.com/vuetifyjs/vuetify/commit/dd3acaf51d3a7193099d49b1de7f822226931e9b))
* **locale:** update Russian translation ([#9563](https://github.com/vuetifyjs/vuetify/issues/9563)) ([bbae296](https://github.com/vuetifyjs/vuetify/commit/bbae2961810fa59c765bb5285d4f5808fa83a001))
* **locale:** update Thai translation. ([#9292](https://github.com/vuetifyjs/vuetify/issues/9292)) ([5d5241c](https://github.com/vuetifyjs/vuetify/commit/5d5241cc84bda46feedc8894a28a27151851cc15))
* **locale:** update Turkish translations ([#9183](https://github.com/vuetifyjs/vuetify/issues/9183)) ([72959c4](https://github.com/vuetifyjs/vuetify/commit/72959c4375044436712b7abe79bbb5a47d25c471))
* **locale:** update Ukrainian translation ([#9562](https://github.com/vuetifyjs/vuetify/issues/9562)) ([ddb90b1](https://github.com/vuetifyjs/vuetify/commit/ddb90b1c0654f6142773e428391926e86ebc2ef6))
* **overlayable:** get root element's z-index if activeIndex is not available ([db84347](https://github.com/vuetifyjs/vuetify/commit/db84347f242fe73288b72c7e72a1af04b09c9434)), closes [#8473](https://github.com/vuetifyjs/vuetify/issues/8473)
* **perf:** avoid useless re-render on parent update ([#8822](https://github.com/vuetifyjs/vuetify/issues/8822)) ([1017af7](https://github.com/vuetifyjs/vuetify/commit/1017af711c32610b360ec8ba3c1fd3b075d1fb79)), closes [#6201](https://github.com/vuetifyjs/vuetify/issues/6201) [vuejs/vue#7257](https://github.com/vuejs/vue/issues/7257) [vuejs/vue#10115](https://github.com/vuejs/vue/issues/10115) [vuejs/vue-test-utils#1130](https://github.com/vuejs/vue-test-utils/issues/1130)
* **SelectionControls:** better scope css selector for input ([d7d1ae3](https://github.com/vuetifyjs/vuetify/commit/d7d1ae30fc009b5d7e783c093c74cf7d589df0ad)), closes [#8523](https://github.com/vuetifyjs/vuetify/issues/8523)
* **SelectionControls:** fix dense styles ([#9505](https://github.com/vuetifyjs/vuetify/issues/9505)) ([1279c52](https://github.com/vuetifyjs/vuetify/commit/1279c52d837bc027896edff21e23fe1824eb9a97)), closes [#9381](https://github.com/vuetifyjs/vuetify/issues/9381)
* **sortItems:** continue to next sorter if custom sorter returns 0 ([#8433](https://github.com/vuetifyjs/vuetify/issues/8433)) ([620d87a](https://github.com/vuetifyjs/vuetify/commit/620d87a4c3f2c5855fa4d39c8974caf227347ca0)), closes [#8408](https://github.com/vuetifyjs/vuetify/issues/8408)
* **style:** bring back .v-application scope to utility classes ([#7921](https://github.com/vuetifyjs/vuetify/issues/7921)) ([bf15ab7](https://github.com/vuetifyjs/vuetify/commit/bf15ab75579a225fe6aa20c5555b17509f25cb7b))
* **styles:** add missing text-start and text-end classes ([#7958](https://github.com/vuetifyjs/vuetify/issues/7958)) ([8865c9a](https://github.com/vuetifyjs/vuetify/commit/8865c9a4d8d59090bc73911560be4108cd47a606))
* **theme:** fix vue-meta theme on page navigation ([#8234](https://github.com/vuetifyjs/vuetify/issues/8234)) ([9324ec7](https://github.com/vuetifyjs/vuetify/commit/9324ec7be5f137e4ea3a547010d674728d399229)), closes [#7879](https://github.com/vuetifyjs/vuetify/issues/7879)
* **Theme:** fix issues for spa with vue-meta ([#8566](https://github.com/vuetifyjs/vuetify/issues/8566)) ([1386cbb](https://github.com/vuetifyjs/vuetify/commit/1386cbb1b69808829c6fb97e0f2db3735a2cfd58))
* **Theme:** fix theme issue when using Vue Meta without SSR  ([#8079](https://github.com/vuetifyjs/vuetify/issues/8079)) ([681051d](https://github.com/vuetifyjs/vuetify/commit/681051dcaad24f2f6db83bd4c9c7bdc0bff17a95))
* **transitions:** correctly merge event listeners ([ad1f6ce](https://github.com/vuetifyjs/vuetify/commit/ad1f6ce8cf5261b60665222b2854615bcef7c2f3)), closes [#9691](https://github.com/vuetifyjs/vuetify/issues/9691)
* **transitions:** on.leave can be undefined ([3098590](https://github.com/vuetifyjs/vuetify/commit/3098590335e594a2c174be519799c952784fc87a))
* **types:** add missing component declarations ([#9652](https://github.com/vuetifyjs/vuetify/issues/9652)) ([50e66da](https://github.com/vuetifyjs/vuetify/commit/50e66daa39e3fe2fcb2da1af59406c123097c16d)), closes [#9364](https://github.com/vuetifyjs/vuetify/issues/9364)
* **types:** avoid importing from src, update for v2 ([#7878](https://github.com/vuetifyjs/vuetify/issues/7878)) ([64056b4](https://github.com/vuetifyjs/vuetify/commit/64056b45fedb8781c9415812117923b0c83f505b)), closes [#7040](https://github.com/vuetifyjs/vuetify/issues/7040) [#7387](https://github.com/vuetifyjs/vuetify/issues/7387) [#7964](https://github.com/vuetifyjs/vuetify/issues/7964)
* **types:** fix lang option name in preset ([#9169](https://github.com/vuetifyjs/vuetify/issues/9169)) ([06d17cf](https://github.com/vuetifyjs/vuetify/commit/06d17cfdf73eeb54c92e124e8e6473036c5a81bb))
* **types:** missing currentTheme in Theme interface ([#9697](https://github.com/vuetifyjs/vuetify/issues/9697)) ([b7701dc](https://github.com/vuetifyjs/vuetify/commit/b7701dc632d6f5798c325946f0c3ce763055816d)), closes [#9546](https://github.com/vuetifyjs/vuetify/issues/9546)
* **types:** missing VCardSubtitle declaration ([2a3d380](https://github.com/vuetifyjs/vuetify/commit/2a3d3802e50fb8c9bc428226f7d21b0c482b95f9))
* **types:** remove VToolbarSideIcon ([#7949](https://github.com/vuetifyjs/vuetify/issues/7949)) ([244cd64](https://github.com/vuetifyjs/vuetify/commit/244cd6437c5336e5953fb1f6a35cc2c4a120c30c))
* **Typescript:** update declaration file ([#9320](https://github.com/vuetifyjs/vuetify/issues/9320)) ([886c8a3](https://github.com/vuetifyjs/vuetify/commit/886c8a3aa280786c1f26a6ce58db3ab4872063c7))
* **VAlert:** adjust dimissible btn margins, decrease size ([d3bfccb](https://github.com/vuetifyjs/vuetify/commit/d3bfccbae23c1f3f420c3eba2529c30e95da4b4f))
* **VAlert:** only apply border radius when not using tile prop ([eefa18c](https://github.com/vuetifyjs/vuetify/commit/eefa18c28b5fe9ac4e5b40fc6c23b88935645fbb))
* **VAlert:** properly inherit/pass down border-radius ([7800d56](https://github.com/vuetifyjs/vuetify/commit/7800d5693bdb78b483fcd82abd5be44ad36b17c7))
* **VAppBar:** avoid screen jump when using scrollbar techniques ([899c75d](https://github.com/vuetifyjs/vuetify/commit/899c75d1bf0d88faddc2afc1f3726e8357b03914))
* **VAppBar:** fix elevation issue when extended ([#8519](https://github.com/vuetifyjs/vuetify/issues/8519)) ([f676454](https://github.com/vuetifyjs/vuetify/commit/f67645489bb2e8a21b37c5b9ea595348ce17d451)), closes [#8516](https://github.com/vuetifyjs/vuetify/issues/8516)
* **VAppBar:** v-model control when using elevate-on-scroll ([#8584](https://github.com/vuetifyjs/vuetify/issues/8584)) ([74b3270](https://github.com/vuetifyjs/vuetify/commit/74b32702de6eedc1442ef348f7d8ae7a79d78315)), closes [#8583](https://github.com/vuetifyjs/vuetify/issues/8583)
* **VAppBar/VToolbar:** use max-width to avoid overflow ([9cc7546](https://github.com/vuetifyjs/vuetify/commit/9cc7546e5a092e1c11005e41d4451ac903010381)), closes [#8364](https://github.com/vuetifyjs/vuetify/issues/8364)
* **VAutocomplete:** default broswer autocomplete to disabled ([3387708](https://github.com/vuetifyjs/vuetify/commit/3387708182ea6e2b7a39e5d9fe90bc14e201c80f))
* **VAutocomplete:** disable browser autocomplete by default ([#9246](https://github.com/vuetifyjs/vuetify/issues/9246)) ([c01f564](https://github.com/vuetifyjs/vuetify/commit/c01f564d7e03161911cad28257de122e2b59b04f)), closes [#8395](https://github.com/vuetifyjs/vuetify/issues/8395)
* **VAutocomplete:** move eventlisteners to focus watcher ([#9273](https://github.com/vuetifyjs/vuetify/issues/9273)) ([6d77ea0](https://github.com/vuetifyjs/vuetify/commit/6d77ea0333076ec578f4c8d488c8653844e86c94)), closes [#9204](https://github.com/vuetifyjs/vuetify/issues/9204)
* **VAutocomplete/VCombobox:** reset search when selecting same item ([eab8d32](https://github.com/vuetifyjs/vuetify/commit/eab8d329c33bf9eb8c22b1038e614c105c7b05d9)), closes [#7259](https://github.com/vuetifyjs/vuetify/issues/7259)
* **VAvatar:** force v-img to inherit avatar height/width ([de68a07](https://github.com/vuetifyjs/vuetify/commit/de68a070dadd12c54b20d8d0822820c4f7ca7e32)), closes [#8056](https://github.com/vuetifyjs/vuetify/issues/8056)
* **VBottomNavigation:** increase specificity of **v-bottom-navigation** styles ([#8073](https://github.com/vuetifyjs/vuetify/issues/8073)) ([0ffc14c](https://github.com/vuetifyjs/vuetify/commit/0ffc14c27432bddd37ce1a5774b0aa712b119e01)), closes [#7998](https://github.com/vuetifyjs/vuetify/issues/7998)
* **VBtn:** correct font-size for different VBtn sizes ([#8385](https://github.com/vuetifyjs/vuetify/issues/8385)) ([c67b666](https://github.com/vuetifyjs/vuetify/commit/c67b666417347baa94837f4a775385fc222d26ff)), closes [#8358](https://github.com/vuetifyjs/vuetify/issues/8358)
* **VBtn:** correct larger size button font-size ([d775278](https://github.com/vuetifyjs/vuetify/commit/d7752786ac9d62867c60aff7b0ffe011afa3f608))
* **VBtn:** keep border of outlined button when focused ([cad50e2](https://github.com/vuetifyjs/vuetify/commit/cad50e2c247e2b6b36f0175911d57c9b45573897)), closes [#9603](https://github.com/vuetifyjs/vuetify/issues/9603)
* **VBtn:** re-add support for non-fab absolutely positioned buttons ([23c8518](https://github.com/vuetifyjs/vuetify/commit/23c8518650950ceb5d4710ad17d8579b2844e948)), closes [#7948](https://github.com/vuetifyjs/vuetify/issues/7948)
* **VBtn/VToolbar:** better scope default v-btn size ([c3812fa](https://github.com/vuetifyjs/vuetify/commit/c3812fa7c576dae21eca8d995ec13a49dfcaa91a)), closes [#8035](https://github.com/vuetifyjs/vuetify/issues/8035)
* **VBtnToggle:** allow individual v-btn color override ([#9250](https://github.com/vuetifyjs/vuetify/issues/9250)) ([9fc9393](https://github.com/vuetifyjs/vuetify/commit/9fc9393796691209aa85f462f0cc9b787c51ac7d)), closes [#9226](https://github.com/vuetifyjs/vuetify/issues/9226)
* **VBtnToggle :** fix borders between buttons ([#8024](https://github.com/vuetifyjs/vuetify/issues/8024)) ([4934e1e](https://github.com/vuetifyjs/vuetify/commit/4934e1e81cb8ade83e0bdeb635692221e7b7b22c))
* **VCalendar:** end date and ripple errors ([#8189](https://github.com/vuetifyjs/vuetify/issues/8189)) ([bd793e9](https://github.com/vuetifyjs/vuetify/commit/bd793e9f8228a949f1678e913fd52dc8105e007a)), closes [#8096](https://github.com/vuetifyjs/vuetify/issues/8096) [#8175](https://github.com/vuetifyjs/vuetify/issues/8175)
* **VCalendar:** fix event-more labels in month view ([#8866](https://github.com/vuetifyjs/vuetify/issues/8866)) ([9eb7ddb](https://github.com/vuetifyjs/vuetify/commit/9eb7ddb8bba216308ae23b28f3c080a613836cdd)), closes [#8263](https://github.com/vuetifyjs/vuetify/issues/8263)
* **VCalendar:** fixed day width in month view on Firefox ([#9092](https://github.com/vuetifyjs/vuetify/issues/9092)) ([5ff3941](https://github.com/vuetifyjs/vuetify/commit/5ff3941c71b69f578b9bc51889be63f3edd7646c)), closes [#9058](https://github.com/vuetifyjs/vuetify/issues/9058)
* **VCalendar:** proper week height in month view on Firefox ([#8932](https://github.com/vuetifyjs/vuetify/issues/8932)) ([2faacd9](https://github.com/vuetifyjs/vuetify/commit/2faacd948a056e4d50e349beac0d648d9e55b4e2)), closes [#8319](https://github.com/vuetifyjs/vuetify/issues/8319)
* **VCalendar:** timed event sorting ([#7806](https://github.com/vuetifyjs/vuetify/issues/7806)) ([e38a763](https://github.com/vuetifyjs/vuetify/commit/e38a763a0fa7535d6d0c4e69443b42a17247b4fe)), closes [#7777](https://github.com/vuetifyjs/vuetify/issues/7777) [#7777](https://github.com/vuetifyjs/vuetify/issues/7777)
* **VCard:** properly break words in titles and text ([81af19d](https://github.com/vuetifyjs/vuetify/commit/81af19dbd46aa34d017a292f89bc7d91b19bf9ee)), closes [#8513](https://github.com/vuetifyjs/vuetify/issues/8513) [#8333](https://github.com/vuetifyjs/vuetify/issues/8333)
* **VCard:** properly remove border radius with **tile** prop ([3905b28](https://github.com/vuetifyjs/vuetify/commit/3905b288f0af40bb496b0f9711172af467515cbc))
* **VCardActions:** update icon boundary when using v-btn in v-card-actions ([6517b58](https://github.com/vuetifyjs/vuetify/commit/6517b5839d9be4ae30cfbe5d6e1a7f63b68d9796)), closes [#8042](https://github.com/vuetifyjs/vuetify/issues/8042)
* **VCarousel:** always respect original internal height ([#8838](https://github.com/vuetifyjs/vuetify/issues/8838)) ([21afb13](https://github.com/vuetifyjs/vuetify/commit/21afb13a7c772e12195661b77df9b4f18979b023))
* **VCarousel:** avoid resetting group internal height on change ([2246337](https://github.com/vuetifyjs/vuetify/commit/2246337cbcf64a5b13b26c33f18727c531a4bb30))
* **VCarousel:** correct prev/next buttons size ([#8122](https://github.com/vuetifyjs/vuetify/issues/8122)) ([823cb2c](https://github.com/vuetifyjs/vuetify/commit/823cb2c6fb0b78b4e3e1a14a2a14911b91ea3358))
* **VCarousel:** pass mandatory prop to the delimiters ([#8639](https://github.com/vuetifyjs/vuetify/issues/8639)) ([6c086cb](https://github.com/vuetifyjs/vuetify/commit/6c086cbf9b990a750f482fcfd13c4ad905434fce)), closes [#8273](https://github.com/vuetifyjs/vuetify/issues/8273)
* **VCarouselItem:** pass through placeholder slot ([56edbdc](https://github.com/vuetifyjs/vuetify/commit/56edbdcea5678f71f25cdbd7233f540013a651ce)), closes [#8452](https://github.com/vuetifyjs/vuetify/issues/8452)
* **VCheckbox:** use correct unchecked checkbox icon using FA4 ([75280f0](https://github.com/vuetifyjs/vuetify/commit/75280f02cee75d0b1de67dd335856ad0e24f8f30)), closes [#8998](https://github.com/vuetifyjs/vuetify/issues/8998)
* **VCheckbox:** wait for dom to process before changing indeterminate state ([7080ed4](https://github.com/vuetifyjs/vuetify/commit/7080ed41f17ba535962bce6a92a30f16b17f60bc)), closes [#8270](https://github.com/vuetifyjs/vuetify/issues/8270)
* **VColorPicker:** allow null as initial value ([#9616](https://github.com/vuetifyjs/vuetify/issues/9616)) ([2246e6b](https://github.com/vuetifyjs/vuetify/commit/2246e6b00808e14bd0f69bbe8fa244e0308aff61)), closes [#9472](https://github.com/vuetifyjs/vuetify/issues/9472)
* **VCombobox:** compare vs null/undefined as opposed to falsey in selectItem ([f53cb81](https://github.com/vuetifyjs/vuetify/commit/f53cb81bc3e586ae813b66d8e5d31305e52fcc0c)), closes [#8476](https://github.com/vuetifyjs/vuetify/issues/8476)
* **VComboBox:** disallow items editing when readonly ([#9429](https://github.com/vuetifyjs/vuetify/issues/9429)) ([22d1bd7](https://github.com/vuetifyjs/vuetify/commit/22d1bd7350a169cc4beaca2ca0b39d0902e23a99)), closes [#8867](https://github.com/vuetifyjs/vuetify/issues/8867)
* **VContainer:** import new grid styles ([0315233](https://github.com/vuetifyjs/vuetify/commit/031523394ea867c745ae193e0a20e92992c3288a)), closes [#7978](https://github.com/vuetifyjs/vuetify/issues/7978)
* **VContainer:** propagate id ([4d575f8](https://github.com/vuetifyjs/vuetify/commit/4d575f82cb09fe3c2acf4f7481924fe20d7b44d2)), closes [#7919](https://github.com/vuetifyjs/vuetify/issues/7919)
* **VContainer:** reduce max width on breakpoints ([84b39d3](https://github.com/vuetifyjs/vuetify/commit/84b39d313c4c3fef89c42d59b154ebf2d900cdc2)), closes [#8517](https://github.com/vuetifyjs/vuetify/issues/8517)
* **VDataFooter:** better handle custom item options ([#8029](https://github.com/vuetifyjs/vuetify/issues/8029)) ([8b7a25b](https://github.com/vuetifyjs/vuetify/commit/8b7a25b3a838d038a64ff6923d34d68d797927ff)), closes [#8026](https://github.com/vuetifyjs/vuetify/issues/8026)
* **VDataFooter:** disable last page button if there's no items ([#8590](https://github.com/vuetifyjs/vuetify/issues/8590)) ([2277942](https://github.com/vuetifyjs/vuetify/commit/2277942577687a3bea0ac8fa8874ac2877f3ab16)), closes [#8577](https://github.com/vuetifyjs/vuetify/issues/8577)
* **VDataTable:** allow custom header icons ([#7918](https://github.com/vuetifyjs/vuetify/issues/7918)) ([e6c448f](https://github.com/vuetifyjs/vuetify/commit/e6c448f51bb7712f90a9284f68c20b8cf014fe6f)), closes [#7647](https://github.com/vuetifyjs/vuetify/issues/7647)
* **VDataTable:** center and disabled no-data/no-results text ([#8106](https://github.com/vuetifyjs/vuetify/issues/8106)) ([63d3e00](https://github.com/vuetifyjs/vuetify/commit/63d3e00f1e5073165d214380238b24ea281cce0b)), closes [#8102](https://github.com/vuetifyjs/vuetify/issues/8102)
* **VDataTable:** change page when items length decreases ([#9634](https://github.com/vuetifyjs/vuetify/issues/9634)) ([18365e0](https://github.com/vuetifyjs/vuetify/commit/18365e086b17a4954a0b9513438e548082faf908)), closes [#9010](https://github.com/vuetifyjs/vuetify/issues/9010)
* **VDataTable:** default to first itemsPerPage option ([#8578](https://github.com/vuetifyjs/vuetify/issues/8578)) ([cb045a2](https://github.com/vuetifyjs/vuetify/commit/cb045a2736541eacd2c6745e95106293e462d642)), closes [#8184](https://github.com/vuetifyjs/vuetify/issues/8184)
* **VDataTable:** detect changes in options prop ([#8719](https://github.com/vuetifyjs/vuetify/issues/8719)) ([df9e3ff](https://github.com/vuetifyjs/vuetify/commit/df9e3ffd82c943a3c96f422a3b44b30f2bea469e)), closes [#8707](https://github.com/vuetifyjs/vuetify/issues/8707)
* **VDataTable:** display non-string item values ([#8562](https://github.com/vuetifyjs/vuetify/issues/8562)) ([c3789d9](https://github.com/vuetifyjs/vuetify/commit/c3789d92b102fd02d6687a4d1c279d69a648263a)), closes [#8554](https://github.com/vuetifyjs/vuetify/issues/8554)
* **VDataTable:** fixed table row classes ([#8443](https://github.com/vuetifyjs/vuetify/issues/8443)) ([7c875d8](https://github.com/vuetifyjs/vuetify/commit/7c875d8cb272f5ed5feec79f73763da234407709)), closes [#8368](https://github.com/vuetifyjs/vuetify/issues/8368)
* **VDataTable:** footer.page-text slot not being used ([#8509](https://github.com/vuetifyjs/vuetify/issues/8509)) ([5f33175](https://github.com/vuetifyjs/vuetify/commit/5f3317577e509232242dc323f230a3ea27ce7a81)), closes [#8120](https://github.com/vuetifyjs/vuetify/issues/8120)
* **VDataTable:** handle items-per-page-options with objects ([#8819](https://github.com/vuetifyjs/vuetify/issues/8819)) ([81703af](https://github.com/vuetifyjs/vuetify/commit/81703af758385e28228c2e12007cdce16dfb1ed0)), closes [#8817](https://github.com/vuetifyjs/vuetify/issues/8817)
* **VDataTable:** hide items-per-page select if only one value ([#8598](https://github.com/vuetifyjs/vuetify/issues/8598)) ([a05a0bb](https://github.com/vuetifyjs/vuetify/commit/a05a0bbaafd560c23cc7e503f2a5fc71773da77e)), closes [#8097](https://github.com/vuetifyjs/vuetify/issues/8097)
* **VDataTable:** items-per-page event should not emit immediately ([#9615](https://github.com/vuetifyjs/vuetify/issues/9615)) ([cbcd8e4](https://github.com/vuetifyjs/vuetify/commit/cbcd8e4dbde89b5252533c0b009500a37d58673c)), closes [#9599](https://github.com/vuetifyjs/vuetify/issues/9599)
* **VDataTable:** mismatch of nodes when using ssr ([#8508](https://github.com/vuetifyjs/vuetify/issues/8508)) ([82a369c](https://github.com/vuetifyjs/vuetify/commit/82a369cfd68b88867db3b0e67d0bc8af2ff3312f)), closes [#7410](https://github.com/vuetifyjs/vuetify/issues/7410)
* **VDataTable:** overlapping text in mobile rows ([#9639](https://github.com/vuetifyjs/vuetify/issues/9639)) ([0f84349](https://github.com/vuetifyjs/vuetify/commit/0f84349f4534406ed60d8e8af4772c0f381e077e)), closes [#8761](https://github.com/vuetifyjs/vuetify/issues/8761)
* **VDataTable:** page resets when server-items-length is zero ([#8594](https://github.com/vuetifyjs/vuetify/issues/8594)) ([39f9d8b](https://github.com/vuetifyjs/vuetify/commit/39f9d8b765bcdf071982959d6c0b37291ec6b31e)), closes [#8359](https://github.com/vuetifyjs/vuetify/issues/8359)
* **VDataTable:** properly display divider in headers ([#9635](https://github.com/vuetifyjs/vuetify/issues/9635)) ([b43716c](https://github.com/vuetifyjs/vuetify/commit/b43716c0b3270327e0fb272df4bd780e6d924365)), closes [#8514](https://github.com/vuetifyjs/vuetify/issues/8514) [#7411](https://github.com/vuetifyjs/vuetify/issues/7411)
* **VDataTable:** revert to non locale sensitive number sort  ([a54a21d](https://github.com/vuetifyjs/vuetify/commit/a54a21d647e53e2edd31e2fdabc9bd84a89d91e6)), closes [#9515](https://github.com/vuetifyjs/vuetify/issues/9515)
* **VDataTable:** use convertToUnit in table header width styles ([#8592](https://github.com/vuetifyjs/vuetify/issues/8592)) ([4a52142](https://github.com/vuetifyjs/vuetify/commit/4a52142fd81f3c50ceb948ce5ba14a3d2ed25e32)), closes [#8591](https://github.com/vuetifyjs/vuetify/issues/8591)
* **VDataTable, VSimpleTable:** missing rtl styles, other minor tweaks ([#8200](https://github.com/vuetifyjs/vuetify/issues/8200)) ([5a45ecf](https://github.com/vuetifyjs/vuetify/commit/5a45ecf6833b381af90a3063c652da66ebd0c908))
* **VDataTableHeaderMobile:** don't show disabled header in sort select ([#8081](https://github.com/vuetifyjs/vuetify/issues/8081)) ([2666cca](https://github.com/vuetifyjs/vuetify/commit/2666cca410ca6745d212ed57badbc74e9b58875f)), closes [#8036](https://github.com/vuetifyjs/vuetify/issues/8036)
* **VDataTableHeaderMobile:** translate "Sort by" ([6c49128](https://github.com/vuetifyjs/vuetify/commit/6c491286b0bbda6d7b29334804094c2327071297)), closes [#8083](https://github.com/vuetifyjs/vuetify/issues/8083)
* **VDatePicker:** improve scroll position of years selector ([#8512](https://github.com/vuetifyjs/vuetify/issues/8512)) ([7fc73f6](https://github.com/vuetifyjs/vuetify/commit/7fc73f64b5c90688a7bd7d0480d7353c1d5b6a61))
* **VDialog:** animate click outside with persistent prop ([652ba11](https://github.com/vuetifyjs/vuetify/commit/652ba11e1c62742b0f433122bd726ace36ad2b4b))
* **VDialog:** check if element is already focused on focusin event ([fa0a893](https://github.com/vuetifyjs/vuetify/commit/fa0a8936be2411f0739259c7762fec350bd9e082)), closes [#8459](https://github.com/vuetifyjs/vuetify/issues/8459)
* **VDialog:** correct v-card-subtitle positioning ([a178ac1](https://github.com/vuetifyjs/vuetify/commit/a178ac175596ea53142675a7e7ebb232d3d7f218)), closes [#9468](https://github.com/vuetifyjs/vuetify/issues/9468)
* **VDialog:** dialog is not focusing on first open ([#8716](https://github.com/vuetifyjs/vuetify/issues/8716)) ([970ac5a](https://github.com/vuetifyjs/vuetify/commit/970ac5aee2404407a62ff1b6aa0c1f52e550e173)), closes [#8220](https://github.com/vuetifyjs/vuetify/issues/8220)
* **VDialog:** don't apply tabindex if dialog is not active ([#8717](https://github.com/vuetifyjs/vuetify/issues/8717)) ([d07e5f3](https://github.com/vuetifyjs/vuetify/commit/d07e5f33e96dc17f7020bd0ac1afcaa856642ceb))
* **VDialog:** fix dialog error when clicking on overlay ([#8246](https://github.com/vuetifyjs/vuetify/issues/8246)) ([400542f](https://github.com/vuetifyjs/vuetify/commit/400542f0833738bad5c7b8923c11ea91b75ce206)), closes [#8240](https://github.com/vuetifyjs/vuetify/issues/8240)
* **VDialog:** inherit listeners ([#8491](https://github.com/vuetifyjs/vuetify/issues/8491)) ([3c7092e](https://github.com/vuetifyjs/vuetify/commit/3c7092e9d643771ed268015b4954587e0156681b)), closes [#3358](https://github.com/vuetifyjs/vuetify/issues/3358)
* **VDialog:** make first child always span 100% width ([0e5a192](https://github.com/vuetifyjs/vuetify/commit/0e5a192e7c62c2bc6a57809d79a9f9bc9b4c7ea9)), closes [#7253](https://github.com/vuetifyjs/vuetify/issues/7253)
* **VDialog:** only emit click:outside once ([f11d845](https://github.com/vuetifyjs/vuetify/commit/f11d8454320a671392bf96c9076b2f39d29d11e6)), closes [#9682](https://github.com/vuetifyjs/vuetify/issues/9682)
* **VDialog/VMenu/VTooltip:** hide wrapper element when not attached ([#9163](https://github.com/vuetifyjs/vuetify/issues/9163)) ([5a100ac](https://github.com/vuetifyjs/vuetify/commit/5a100acdd8353a67d6fde5889ba1443b58bc8504)), closes [#6951](https://github.com/vuetifyjs/vuetify/issues/6951)
* **VDialog/VMenu/VTooltip:** make all activators inline elements ([b40fa43](https://github.com/vuetifyjs/vuetify/commit/b40fa4329a4cbc9f3b5de09cafb670640208f575)), closes [#6951](https://github.com/vuetifyjs/vuetify/issues/6951)
* **VExpansionPanels:** constrain content wrap to 100% width ([79d4512](https://github.com/vuetifyjs/vuetify/commit/79d4512df26c088e1a7de7aeb0e12945a773cf27)), closes [#8352](https://github.com/vuetifyjs/vuetify/issues/8352)
* **VExpansionPanels:** outer panels styles cascade to inner panels ([#9696](https://github.com/vuetifyjs/vuetify/issues/9696)) ([c27b42d](https://github.com/vuetifyjs/vuetify/commit/c27b42df445675c37964e023e9a4d3329a923f2a)), closes [#9692](https://github.com/vuetifyjs/vuetify/issues/9692)
* **VFileInput:** bug in Safari where file is not added ([#8498](https://github.com/vuetifyjs/vuetify/issues/8498)) ([0b4a970](https://github.com/vuetifyjs/vuetify/commit/0b4a9701f7d9d83e516e7836fc2f578ed5e18625)), closes [#7941](https://github.com/vuetifyjs/vuetify/issues/7941)
* **VFileInput:** fix rogue change events ([#8193](https://github.com/vuetifyjs/vuetify/issues/8193)) ([3568df3](https://github.com/vuetifyjs/vuetify/commit/3568df36a2bd88de054213e07ca06416ba701cad)), closes [#8167](https://github.com/vuetifyjs/vuetify/issues/8167)
* **VFileInput:** issues selecting files in ie/edge ([#8718](https://github.com/vuetifyjs/vuetify/issues/8718)) ([3ca386d](https://github.com/vuetifyjs/vuetify/commit/3ca386df5cbfd368e75629a8c6a90e418576bd97)), closes [#8693](https://github.com/vuetifyjs/vuetify/issues/8693)
* **VFileInput:** replace hardcoded string boundary with computed ([#9036](https://github.com/vuetifyjs/vuetify/issues/9036)) ([8ba982d](https://github.com/vuetifyjs/vuetify/commit/8ba982d529b032e75d462d786d18893dbf6fca95)), closes [#9026](https://github.com/vuetifyjs/vuetify/issues/9026)
* **VFileInput:** unindent input when icon is empty ([#8078](https://github.com/vuetifyjs/vuetify/issues/8078)) ([d1a67ab](https://github.com/vuetifyjs/vuetify/commit/d1a67abb3a6870af39ef2ec2cec1ee0be294635e)), closes [#8049](https://github.com/vuetifyjs/vuetify/issues/8049)
* **VForm:** apply grid-list-lg to nested containers ([d77f136](https://github.com/vuetifyjs/vuetify/commit/d77f1364565368ea96b01b4d8701262978ca4f06)), closes [#7891](https://github.com/vuetifyjs/vuetify/issues/7891)
* **VGrid:** add max-width for row in container and fill-height ([#9731](https://github.com/vuetifyjs/vuetify/issues/9731)) ([3b4d26c](https://github.com/vuetifyjs/vuetify/commit/3b4d26c93348ac286af91aeb6ee0ee1a30443857))
* **VIcon:** remove the ability for a user to select ([3ece815](https://github.com/vuetifyjs/vuetify/commit/3ece815c60683ab986bca4b16017f5722f00cd57)), closes [#8344](https://github.com/vuetifyjs/vuetify/issues/8344)
* **VImg:** properly update image on src change ([6eb5e6e](https://github.com/vuetifyjs/vuetify/commit/6eb5e6e2b2da7d0c8dbb7c61ae496967ed21514d)), closes [#9210](https://github.com/vuetifyjs/vuetify/issues/9210)
* **VImg:** remove observer once init ([1700d57](https://github.com/vuetifyjs/vuetify/commit/1700d5754ed27bbd7e9a1417be466d7872956eb4)), closes [#9490](https://github.com/vuetifyjs/vuetify/issues/9490)
* **VInput:** add role alert to success/error messages ([#8681](https://github.com/vuetifyjs/vuetify/issues/8681)) ([049fbf9](https://github.com/vuetifyjs/vuetify/commit/049fbf9036be4cce5ebf47b6d7c848e5a45f2126))
* **VList:** keep circular ripple on checkboxes in shaped list items ([f8f46d5](https://github.com/vuetifyjs/vuetify/commit/f8f46d57d6e3df7571345d3765005b2debe04ca9))
* **VList/VListGroup:** add missing rtl margins and paddings (v2.0) ([#7861](https://github.com/vuetifyjs/vuetify/issues/7861)) ([e1ba658](https://github.com/vuetifyjs/vuetify/commit/e1ba658ad836e1ff8ea676157d5e242668e63ff0)), closes [#8125](https://github.com/vuetifyjs/vuetify/issues/8125)
* **VListGroup:** adjust nested item padding only for nav/dense ([d98a227](https://github.com/vuetifyjs/vuetify/commit/d98a227321123fc283c0dcb6f7ddb6a48a97e72b))
* **VListGroup:** ensure append-icon is always vertically centered ([b1bdbad](https://github.com/vuetifyjs/vuetify/commit/b1bdbad929db8222b45a0881cd2afcf4835eb35e)), closes [#8340](https://github.com/vuetifyjs/vuetify/issues/8340)
* **VListGroup:** fade hover/focus effect when active ([a9283e7](https://github.com/vuetifyjs/vuetify/commit/a9283e76a17091c8860a6259ae6a1103ffbe6a31)), closes [#8115](https://github.com/vuetifyjs/vuetify/issues/8115)
* **VListGroup:** remove unnecessary css from header ([055c246](https://github.com/vuetifyjs/vuetify/commit/055c2465dd11740931e6993dbfa4b176cce0a6a1)), closes [#8222](https://github.com/vuetifyjs/vuetify/issues/8222)
* **VListItem:** add default active color ([#8327](https://github.com/vuetifyjs/vuetify/issues/8327)) ([#8694](https://github.com/vuetifyjs/vuetify/issues/8694)) ([e31b582](https://github.com/vuetifyjs/vuetify/commit/e31b58214cae5ae977ae29e6e33ff219ac398316))
* **VListItem:** change text color implementation ([d32c0fd](https://github.com/vuetifyjs/vuetify/commit/d32c0fd30721a8df46ae96b3a775f1f7772f1119)), closes [#8327](https://github.com/vuetifyjs/vuetify/issues/8327)
* **VListItem:** only apply role attribute when needed ([#9080](https://github.com/vuetifyjs/vuetify/issues/9080)) ([6e02c05](https://github.com/vuetifyjs/vuetify/commit/6e02c05747e53da29794ad62142c213fda13a56a)), closes [#9060](https://github.com/vuetifyjs/vuetify/issues/9060)
* **VMenu:** only use the activator slot in getActivator if it exists ([0c6175f](https://github.com/vuetifyjs/vuetify/commit/0c6175f9b27495fcc31595070efa04b7e530b9db))
* **VMenu:** prefer the activator slot over a click event ([baeb7ba](https://github.com/vuetifyjs/vuetify/commit/baeb7babbfc7571d5a5fe0200707ba70aee08a94)), closes [#6906](https://github.com/vuetifyjs/vuetify/issues/6906)
* **VMenu:** set border-radius to 4px for spec ([bf2cb0e](https://github.com/vuetifyjs/vuetify/commit/bf2cb0e97560dbdb8bdbf61ca6602e7367a66c43))
* **VMessages:** apply escapeHTML to provided values ([c0a81f1](https://github.com/vuetifyjs/vuetify/commit/c0a81f193743df261905a214de037ed1d183d9e4)), closes [#9491](https://github.com/vuetifyjs/vuetify/issues/9491)
* **VNavigationDrawer:** conditionally apply clipped z-index ([15e554d](https://github.com/vuetifyjs/vuetify/commit/15e554d4c3b5ab3a8987bdfce875627d51174b23))
* **VNavigationDrawer:** display overlay over app bar ([6255bf5](https://github.com/vuetifyjs/vuetify/commit/6255bf5001e0f67bf43aa3d9abf4320e75fe579c)), closes [#8040](https://github.com/vuetifyjs/vuetify/issues/8040)
* **VNavigationDrawer:** emit update:mini-variant event ([#8768](https://github.com/vuetifyjs/vuetify/issues/8768)) ([bfd80a7](https://github.com/vuetifyjs/vuetify/commit/bfd80a7fb02e5dffb50a525f9b478bf5de856870)), closes [#8133](https://github.com/vuetifyjs/vuetify/issues/8133)
* **VOverlay:** fix second dialog overlay animation problems ([#8490](https://github.com/vuetifyjs/vuetify/issues/8490)) ([82721b6](https://github.com/vuetifyjs/vuetify/commit/82721b6482718464d491e0e355fe8640f2351363)), closes [#2984](https://github.com/vuetifyjs/vuetify/issues/2984)
* **VPagination:** display length if maxButtons is less than 1 ([7f7391d](https://github.com/vuetifyjs/vuetify/commit/7f7391d76dc44f7f7d64f30ad7e0e429c85597c8)), closes [#8558](https://github.com/vuetifyjs/vuetify/issues/8558)
* **VProgressCircular:** center inner content vertically and horizontally ([4288072](https://github.com/vuetifyjs/vuetify/commit/4288072c1c6de1c912dfb2ae7f47103f4b5d6a20)), closes [#8232](https://github.com/vuetifyjs/vuetify/issues/8232)
* **VProgressLinear:** invalid background position in RTL mode ([#8421](https://github.com/vuetifyjs/vuetify/issues/8421)) ([a870dfa](https://github.com/vuetifyjs/vuetify/commit/a870dfa4b4669a38c01fff5e3317b16096dfa000)), closes [#8419](https://github.com/vuetifyjs/vuetify/issues/8419)
* **VProgressLinear:** make progress not overlapped by buffer ([b36e27f](https://github.com/vuetifyjs/vuetify/commit/b36e27f38f852bb505ee000e9dbd318d50e48839)), closes [#8114](https://github.com/vuetifyjs/vuetify/issues/8114)
* **VRangeSlider:** do not emit change twice if thumb was dragged ([6e4f083](https://github.com/vuetifyjs/vuetify/commit/6e4f0838cd84fae8b73dc974d8a74a17ab490548)), closes [#7915](https://github.com/vuetifyjs/vuetify/issues/7915)
* **VSelect:** remove reference to missing variable ([73e08a8](https://github.com/vuetifyjs/vuetify/commit/73e08a8ab3cf6547590d3ce0ac27e199190d6d17)), closes [#8417](https://github.com/vuetifyjs/vuetify/issues/8417)
* **VSelect/Autocomplete:** fix filled prop height with dense ([fd25779](https://github.com/vuetifyjs/vuetify/commit/fd257791adc1915f8a3d084d209d36de2e0e82fe))
* **VSelect/VChip:** improve chip overflow behavior inside of selects ([ccae369](https://github.com/vuetifyjs/vuetify/commit/ccae3697986040cc0f9eb76d64cd19f8e7fcedd3)), closes [#8797](https://github.com/vuetifyjs/vuetify/issues/8797) [#8642](https://github.com/vuetifyjs/vuetify/issues/8642)
* **VSheet:** add removed border-radius sass variable ([0949763](https://github.com/vuetifyjs/vuetify/commit/0949763c114dc589d6ac608f4f8c37813317f66f))
* **VSheet:** remove default transition, display and position ([fbcb008](https://github.com/vuetifyjs/vuetify/commit/fbcb00895d61a54979a28ef7995b344a4a39e43b)), closes [#8272](https://github.com/vuetifyjs/vuetify/issues/8272)
* **VSkeletonLoader:** avatar is not rounded ([#9708](https://github.com/vuetifyjs/vuetify/issues/9708)) ([5f073b5](https://github.com/vuetifyjs/vuetify/commit/5f073b582dacad401d43db71ab7e4f062a274208)), closes [#9447](https://github.com/vuetifyjs/vuetify/issues/9447)
* **VSlideGroup:** move tabs css for next/prev to slide-group ([5329514](https://github.com/vuetifyjs/vuetify/commit/5329514763e7fab11994c4303aa601346e17104c))
* **VSlider:** disable label in readonly slider ([#9709](https://github.com/vuetifyjs/vuetify/issues/9709)) ([89050b9](https://github.com/vuetifyjs/vuetify/commit/89050b9afd1edcb8a959f3623d7ffe6eef1d98af)), closes [#9660](https://github.com/vuetifyjs/vuetify/issues/9660)
* apply correct opacity for secondary text ([#9495](https://github.com/vuetifyjs/vuetify/issues/9495)) ([bdb9f0a](https://github.com/vuetifyjs/vuetify/commit/bdb9f0a441491c601717c89d1961b2a3927d00f4)), closes [#9366](https://github.com/vuetifyjs/vuetify/issues/9366)
* **activatable:** get activator element from event or nested component ([#9294](https://github.com/vuetifyjs/vuetify/issues/9294)) ([4b73dd2](https://github.com/vuetifyjs/vuetify/commit/4b73dd2889a7b9b34b141a70247dbf50f8a16ad7)), closes [#8846](https://github.com/vuetifyjs/vuetify/issues/8846)
* **locale:** update Norwegian translation ([#9455](https://github.com/vuetifyjs/vuetify/issues/9455)) ([051399a](https://github.com/vuetifyjs/vuetify/commit/051399ad187bee86c140924501baa7b2e9193577))
* **overlayable:** avoid overlay generation toggle if not active ([4c61674](https://github.com/vuetifyjs/vuetify/commit/4c616747b1142e2ad88a22994971ec5a27070f80)), closes [#8142](https://github.com/vuetifyjs/vuetify/issues/8142)
* **sass:** move global style imports to component variable files ([63f128f](https://github.com/vuetifyjs/vuetify/commit/63f128fb6315a5660a54dfed1fbbfe5b3f2b673d)), closes [#9323](https://github.com/vuetifyjs/vuetify/issues/9323)
* **theme:** use new vue-meta api ([#9268](https://github.com/vuetifyjs/vuetify/issues/9268)) ([6d829ef](https://github.com/vuetifyjs/vuetify/commit/6d829efff05ff6d491a719b21f3ea88f5ce1aeaf))
* **VAlert:** remove pointer events from psuedo element ([1958333](https://github.com/vuetifyjs/vuetify/commit/1958333d502848aac1f23d3499e2314da7e84f5b)), closes [#9407](https://github.com/vuetifyjs/vuetify/issues/9407)
* **VAlert:** typo in computedIcon ([#9390](https://github.com/vuetifyjs/vuetify/issues/9390)) ([15ba83b](https://github.com/vuetifyjs/vuetify/commit/15ba83bb6c81b683c7bc4d9092676da8d9a05faf)), closes [#9386](https://github.com/vuetifyjs/vuetify/issues/9386)
* **VAutocomplete:** avoid changing selected index if not using multiple ([8580c7b](https://github.com/vuetifyjs/vuetify/commit/8580c7bb59945158c1b9e8df7da6979a9a394fec))
* **VAutocomplete:** show selection color when navigating selection items ([9992116](https://github.com/vuetifyjs/vuetify/commit/9992116ac327cf67731760e4039202ae2611f999))
* **vcalendar:** escape html of event name ([#9387](https://github.com/vuetifyjs/vuetify/issues/9387)) ([283d601](https://github.com/vuetifyjs/vuetify/commit/283d601329281d6bde623634804359ade17efe0f))
* **VCard:** resolved clashing border-radius, adjust to match md2 spec ([0799040](https://github.com/vuetifyjs/vuetify/commit/079904031b93b17e7c6bcd2a14405bc2bf4e91a4))
* **VCarousel:** add missing aria-labels on delimiters ([#9332](https://github.com/vuetifyjs/vuetify/issues/9332)) ([bfd25af](https://github.com/vuetifyjs/vuetify/commit/bfd25af63d9d4aff837e9c3caba7733e408a8d3a)), closes [#7996](https://github.com/vuetifyjs/vuetify/issues/7996)
* **VContainer:** adjust container fill-height ([#9189](https://github.com/vuetifyjs/vuetify/issues/9189)) ([87e8a53](https://github.com/vuetifyjs/vuetify/commit/87e8a53741306867520a7c976f1522587d912e48)), closes [#8680](https://github.com/vuetifyjs/vuetify/issues/8680)
* **VDataTable:** add toggle and remove functions to group header slots ([#9236](https://github.com/vuetifyjs/vuetify/issues/9236)) ([f6abce8](https://github.com/vuetifyjs/vuetify/commit/f6abce837fbee31e28a704e75f2e312a2681194f))
* **VDataTable:** adjust filter & sort functions to use Intl.Collator ([#7805](https://github.com/vuetifyjs/vuetify/issues/7805)) ([43adae8](https://github.com/vuetifyjs/vuetify/commit/43adae8591f9b48b05c022e1f7c93abeddc76a4f)), closes [#3672](https://github.com/vuetifyjs/vuetify/issues/3672) [#4622](https://github.com/vuetifyjs/vuetify/issues/4622)
* **VDatePicker:** fix min date ([#9097](https://github.com/vuetifyjs/vuetify/issues/9097)) ([45c07c5](https://github.com/vuetifyjs/vuetify/commit/45c07c5fa93d1c96c6f75bd5fee16684254034dd)), closes [#9039](https://github.com/vuetifyjs/vuetify/issues/9039)
* **VDatePicker:** improve range performance ([#9128](https://github.com/vuetifyjs/vuetify/issues/9128)) ([349ae88](https://github.com/vuetifyjs/vuetify/commit/349ae88e64da48930197772be6fd37589004f479)), closes [#9120](https://github.com/vuetifyjs/vuetify/issues/9120)
* **vdialog:** fix close on outside click with persist and hide-overlay ([#9304](https://github.com/vuetifyjs/vuetify/issues/9304)) ([ba99a45](https://github.com/vuetifyjs/vuetify/commit/ba99a45ca7341bcc6802621e1fefe57a42a6ec96)), closes [#8697](https://github.com/vuetifyjs/vuetify/issues/8697) [#8697](https://github.com/vuetifyjs/vuetify/issues/8697)
* **VExpansionPanels:** stop parent active class propagation ([#9227](https://github.com/vuetifyjs/vuetify/issues/9227)) ([23fd69d](https://github.com/vuetifyjs/vuetify/commit/23fd69d9dd2ea56a648382c5de13b812da325c4d)), closes [#8677](https://github.com/vuetifyjs/vuetify/issues/8677)
* **VFileInput:** trigger onInput after value has changed ([#9091](https://github.com/vuetifyjs/vuetify/issues/9091)) ([507f1b0](https://github.com/vuetifyjs/vuetify/commit/507f1b0ed26c1b3b8ee0f7472afb68f86570567f)), closes [#9045](https://github.com/vuetifyjs/vuetify/issues/9045)
* **VIcon:** dense font-size selector ([#9494](https://github.com/vuetifyjs/vuetify/issues/9494)) ([1ae752e](https://github.com/vuetifyjs/vuetify/commit/1ae752ea1a2de821b1510baa07be2025b65c1edf))
* **VImg:** do not lazy load if intersection observer is not supported ([22e23e2](https://github.com/vuetifyjs/vuetify/commit/22e23e2f07125492609cc7e65570c03fdf6ac9b6)), closes [#9412](https://github.com/vuetifyjs/vuetify/issues/9412)
* **VLazy:** properly show transition on activation ([ac7136d](https://github.com/vuetifyjs/vuetify/commit/ac7136dd98ec6eea52840643d6f79ac61c5dceba))
* **vlistitem:** fix to misplaced small icon in dense list ([#9395](https://github.com/vuetifyjs/vuetify/issues/9395)) ([f5b5e98](https://github.com/vuetifyjs/vuetify/commit/f5b5e9847969f716659d83613f61e5b1fbedce97))
* **VPagination:** max length ([#9423](https://github.com/vuetifyjs/vuetify/issues/9423)) ([1394b6c](https://github.com/vuetifyjs/vuetify/commit/1394b6c24b006596c49375d808210264fa9920ae))
* **VRangeSlider:** allow handles on same value ([#9218](https://github.com/vuetifyjs/vuetify/issues/9218)) ([3ab0f67](https://github.com/vuetifyjs/vuetify/commit/3ab0f67c79f08fbae7a50c6476020b47ac5386dc)), closes [#8756](https://github.com/vuetifyjs/vuetify/issues/8756)
* **VRating:** pass in x-small icon size ([#9351](https://github.com/vuetifyjs/vuetify/issues/9351)) ([28b0b5b](https://github.com/vuetifyjs/vuetify/commit/28b0b5bdcdcb701c18818a4b3e624df5de27a715))
* **VSheet:** add missing !default declaration for sass variable ([487ebfe](https://github.com/vuetifyjs/vuetify/commit/487ebfe5ad892685d650cf308fa30e494507936a))
* **VSheet:** default border radius ([#9405](https://github.com/vuetifyjs/vuetify/issues/9405)) ([ade8707](https://github.com/vuetifyjs/vuetify/commit/ade8707bfea1c11de4167591f359bf5b4fa6db30))
* **VSkeletonLoader:** properly cascade border-radius ([74bc901](https://github.com/vuetifyjs/vuetify/commit/74bc9011152b61b36b636249d38a6b9c367d5e99))
* **VSparkline:** add label color for light/dark theme (fix [#8557](https://github.com/vuetifyjs/vuetify/issues/8557)) ([#8613](https://github.com/vuetifyjs/vuetify/issues/8613)) ([3a89a0d](https://github.com/vuetifyjs/vuetify/commit/3a89a0dbd2dac51266c1471e8933f5f579d3ecdd))
* **VStepper:** fix transition in RTL ([#9018](https://github.com/vuetifyjs/vuetify/issues/9018)) ([87dbc7b](https://github.com/vuetifyjs/vuetify/commit/87dbc7bb055074af5395d59a0b9e4a18316f70b6))
* **VStepper:** Increase selector priority .v-icon ([#9262](https://github.com/vuetifyjs/vuetify/issues/9262)) ([d650e7e](https://github.com/vuetifyjs/vuetify/commit/d650e7e4e2008f8a8818ad276653763f25b188e6)), closes [vuetifyjs/vuetify#9261](https://github.com/vuetifyjs/vuetify/issues/9261)
* **VSwitch:** allow override vars definition ([#8771](https://github.com/vuetifyjs/vuetify/issues/8771)) ([6e6f92b](https://github.com/vuetifyjs/vuetify/commit/6e6f92bd057ebbf897b135334e2d153b93efb2b3))
* **VSwitch/VCheckbox:** color not applied if value is 0/false ([#9431](https://github.com/vuetifyjs/vuetify/issues/9431)) ([9856ca7](https://github.com/vuetifyjs/vuetify/commit/9856ca7b7e3f2001132ec5e2a7c5321f9b5c9a88))
* **VTab:** properly wrap and center text ([b45b67c](https://github.com/vuetifyjs/vuetify/commit/b45b67cd055c3fb3299fbf9fe974e0fa78e0e880)), closes [#7804](https://github.com/vuetifyjs/vuetify/issues/7804)
* **VTabs:** only indent tabs if overflowing ([dc2850f](https://github.com/vuetifyjs/vuetify/commit/dc2850f0893a7b197fa2f44e5a697702b15ed33c)), closes [#8540](https://github.com/vuetifyjs/vuetify/issues/8540)
* **VTabs:** properly position slider after resize, fix align-with-title prop ([a8c3f2a](https://github.com/vuetifyjs/vuetify/commit/a8c3f2aa0000a3810000076b05589f858214081e)), closes [#8621](https://github.com/vuetifyjs/vuetify/issues/8621) [#8653](https://github.com/vuetifyjs/vuetify/issues/8653)
* **VTabs:** scope tab white-space to horizontal only ([a173b95](https://github.com/vuetifyjs/vuetify/commit/a173b9539c1658621f207e11761f8fb2ae9a982e)), closes [#8981](https://github.com/vuetifyjs/vuetify/issues/8981)
* **VTabs:** slider hides behind the colored tab ([#8600](https://github.com/vuetifyjs/vuetify/issues/8600)) ([f74b70a](https://github.com/vuetifyjs/vuetify/commit/f74b70a3c8534481b22d736c2d955a292892719a)), closes [#8596](https://github.com/vuetifyjs/vuetify/issues/8596)
* **VTextArea:** fix clear icon overlapped by the scrollbar ([#9190](https://github.com/vuetifyjs/vuetify/issues/9190)) ([1c21d76](https://github.com/vuetifyjs/vuetify/commit/1c21d76710c55ca1569abf99177105f33a4a0236)), closes [#8910](https://github.com/vuetifyjs/vuetify/issues/8910)
* **VTextField:** add check for $refs.input before focusing ([6b0ee22](https://github.com/vuetifyjs/vuetify/commit/6b0ee22e0ebc0dff9f70f04d60a75a9fc5614ef0))
* **VTextField:** better scope hover styles for outlined text-fields ([9ddb4db](https://github.com/vuetifyjs/vuetify/commit/9ddb4dbf7ecf4f502d29df74c9e777250f62b881)), closes [#8546](https://github.com/vuetifyjs/vuetify/issues/8546)
* **VTextField:** blur should fire once ([#8455](https://github.com/vuetifyjs/vuetify/issues/8455)) ([#8723](https://github.com/vuetifyjs/vuetify/issues/8723)) ([8db1566](https://github.com/vuetifyjs/vuetify/commit/8db1566fc793635ffa67713200395b987b7767ab))
* **VTextField:** dense filled & outlined ([#9403](https://github.com/vuetifyjs/vuetify/issues/9403)) ([2283635](https://github.com/vuetifyjs/vuetify/commit/228363596bfdc7727e3cbdf4c4b43cf7f44a3a40))
* **VTextField:** remove !important flag for bg-color ([#8652](https://github.com/vuetifyjs/vuetify/issues/8652)) ([83e1c9a](https://github.com/vuetifyjs/vuetify/commit/83e1c9ad2371d22ff13d7f0e387bfe77c227c1c0))
* **VTextField:** should respect events in correct order ([#7916](https://github.com/vuetifyjs/vuetify/issues/7916)) ([#8724](https://github.com/vuetifyjs/vuetify/issues/8724)) ([b222c90](https://github.com/vuetifyjs/vuetify/commit/b222c90cad49fb4cf8901d9ec6a754c1a09fb13b))
* **VTextField:** show label on dense ([#9116](https://github.com/vuetifyjs/vuetify/issues/9116)) ([1e62a4e](https://github.com/vuetifyjs/vuetify/commit/1e62a4e89e75cee349408a27b8818902ebe64605)), closes [#9105](https://github.com/vuetifyjs/vuetify/issues/9105)
* **VTextField:** use scrollWidth to calculate label width ([#9286](https://github.com/vuetifyjs/vuetify/issues/9286)) ([0f3fa6a](https://github.com/vuetifyjs/vuetify/commit/0f3fa6a9204688abe23996d2df2be665f52a7e18))
* **VTimePicker:** center clock element ([#9059](https://github.com/vuetifyjs/vuetify/issues/9059)) ([142ef11](https://github.com/vuetifyjs/vuetify/commit/142ef11ee11039bf317ecb6fa7d06f9a66045c25))
* **VTimePicker:** reset margin on full width ([#9139](https://github.com/vuetifyjs/vuetify/issues/9139)) ([b983ea5](https://github.com/vuetifyjs/vuetify/commit/b983ea5550bc8c18b840ea11fb88cca15de5f05e)), closes [#9119](https://github.com/vuetifyjs/vuetify/issues/9119) [#9141](https://github.com/vuetifyjs/vuetify/issues/9141)
* **VTimePicker:** RTL Time Title ([#9052](https://github.com/vuetifyjs/vuetify/issues/9052)) ([0c8921c](https://github.com/vuetifyjs/vuetify/commit/0c8921c987583d8826bc7f67fa02281d5e213c22))
* **VToolbar:** fix collapsed border-radius in RTL ([c0ad16d](https://github.com/vuetifyjs/vuetify/commit/c0ad16d135123b4d30c988a230ff73fc2f657741)), closes [#9049](https://github.com/vuetifyjs/vuetify/issues/9049)
* **VToolbar:** remove overflow when collapsed ([35b0fb1](https://github.com/vuetifyjs/vuetify/commit/35b0fb136b0ab84efe33b010f956f1eefa954ba2))
* **VTreeview:** stuttering animation of toggle icon when loading ([#9705](https://github.com/vuetifyjs/vuetify/issues/9705)) ([b729afc](https://github.com/vuetifyjs/vuetify/commit/b729afc03f12b9a45254cf8f96a7f4c2fc34798e)), closes [#9475](https://github.com/vuetifyjs/vuetify/issues/9475)
* force re-version ([17116c6](https://github.com/vuetifyjs/vuetify/commit/17116c6c56445394c24076f3e5a1f18bb27bb358))
* provide backward compatibility for vue-meta@1 ([#8922](https://github.com/vuetifyjs/vuetify/issues/8922)) ([21e44d4](https://github.com/vuetifyjs/vuetify/commit/21e44d4bac1f7b935af6ebc9856e04164068f25c))
* update hebrew translation ([#8930](https://github.com/vuetifyjs/vuetify/issues/8930)) ([4464455](https://github.com/vuetifyjs/vuetify/commit/4464455d0a60f743c7f60347fd685a14d1d464a2))
* **activatable:** add listeners for custom activators ([#8121](https://github.com/vuetifyjs/vuetify/issues/8121)) ([3beea7c](https://github.com/vuetifyjs/vuetify/commit/3beea7c9107da273465b0d65f4cde3f8fbc1b7bc)), closes [#7944](https://github.com/vuetifyjs/vuetify/issues/7944) [#5890](https://github.com/vuetifyjs/vuetify/issues/5890) [#5860](https://github.com/vuetifyjs/vuetify/issues/5860)
* **Theme:** fix issues for spa with vue-meta ([#8412](https://github.com/vuetifyjs/vuetify/issues/8412)) ([9a5c333](https://github.com/vuetifyjs/vuetify/commit/9a5c333bf3e409330e11e4cffc8dfd08a5b3cc71))
* **validatable:** allow focus/blur validation to process when readonly ([9fed066](https://github.com/vuetifyjs/vuetify/commit/9fed066611d7179d8a2c056650fe0e570c10d345)), closes [#8020](https://github.com/vuetifyjs/vuetify/issues/8020)
* **VAppBar:** adjust transforms when using the **bottom** prop ([13a99c9](https://github.com/vuetifyjs/vuetify/commit/13a99c9393fddd8484901b20eaf3eae08d939950)), closes [#8337](https://github.com/vuetifyjs/vuetify/issues/8337)
* **VAvatar:** properly render when using a svg ([#8423](https://github.com/vuetifyjs/vuetify/issues/8423)) ([2cc5a4a](https://github.com/vuetifyjs/vuetify/commit/2cc5a4a3832d26f398138f65db9594fe5ef6b418)), closes [#8367](https://github.com/vuetifyjs/vuetify/issues/8367)
* **VBadge:** enable unused variable (-top, -right) ([#8282](https://github.com/vuetifyjs/vuetify/issues/8282)) ([811803b](https://github.com/vuetifyjs/vuetify/commit/811803b79ae27e661cdba26e265fef1086441b7e))
* **VBtn:** don't add color classes when disabled ([d1755df](https://github.com/vuetifyjs/vuetify/commit/d1755df2c6627cbb57e518409e0366c3c8ccdbb2)), closes [#8030](https://github.com/vuetifyjs/vuetify/issues/8030)
* **VBtn:** remove fab designation with **icon** prop ([4c4b109](https://github.com/vuetifyjs/vuetify/commit/4c4b1092608aefdeddecf314e060f99424ec034c))
* **VCard:** explicitly define white-space ([f5db05d](https://github.com/vuetifyjs/vuetify/commit/f5db05d01cff2f750db15e3d7ac7953076961cd0)), closes [#8333](https://github.com/vuetifyjs/vuetify/issues/8333)
* **VCard:** fix word wrapping & color ([#8380](https://github.com/vuetifyjs/vuetify/issues/8380)) ([68cc268](https://github.com/vuetifyjs/vuetify/commit/68cc268ce6d66c18478641f10798c183bed7daad)), closes [#7920](https://github.com/vuetifyjs/vuetify/issues/7920) [#7730](https://github.com/vuetifyjs/vuetify/issues/7730)
* **VCarousel:** wrong position of arrows on hover in rtl mode ([#8458](https://github.com/vuetifyjs/vuetify/issues/8458)) ([8de535f](https://github.com/vuetifyjs/vuetify/commit/8de535f6edd2cb9635d9823db7ca4ac4e7211aba)), closes [#8457](https://github.com/vuetifyjs/vuetify/issues/8457)
* **VColorPicker:** alpha controls showing when they shouldnt ([#8427](https://github.com/vuetifyjs/vuetify/issues/8427)) ([31ed439](https://github.com/vuetifyjs/vuetify/commit/31ed43998af2d79252c2e6bf09f666c5214ef949)), closes [#8390](https://github.com/vuetifyjs/vuetify/issues/8390)
* **VDataTable:** add missing index variable in item scoped slot ([#8283](https://github.com/vuetifyjs/vuetify/issues/8283)) ([313f634](https://github.com/vuetifyjs/vuetify/commit/313f634c95eaf17154f6941c6dbcfdc8580b7a04)), closes [#8199](https://github.com/vuetifyjs/vuetify/issues/8199)
* **VDataTable:** fix header column widths not being respected ([#8296](https://github.com/vuetifyjs/vuetify/issues/8296)) ([a18cc68](https://github.com/vuetifyjs/vuetify/commit/a18cc680e597653224cfe116da3fc09c29316e7e)), closes [#5072](https://github.com/vuetifyjs/vuetify/issues/5072) [#7623](https://github.com/vuetifyjs/vuetify/issues/7623)
* **VDataTable:** fix options prop not setting initial values ([#8280](https://github.com/vuetifyjs/vuetify/issues/8280)) ([6a3b32d](https://github.com/vuetifyjs/vuetify/commit/6a3b32d967ca505b6c8d244468a4a96aca381ac4)), closes [#8266](https://github.com/vuetifyjs/vuetify/issues/8266)
* **VDataTable:** fix passing kebab-cased footer props ([#8286](https://github.com/vuetifyjs/vuetify/issues/8286)) ([b04d853](https://github.com/vuetifyjs/vuetify/commit/b04d85336393ba443aee6ca84a46001d99657490)), closes [#8254](https://github.com/vuetifyjs/vuetify/issues/8254)
* **VDataTable:** remove pointer-events: none for empty wrapper ([#8493](https://github.com/vuetifyjs/vuetify/issues/8493)) ([7f41ee5](https://github.com/vuetifyjs/vuetify/commit/7f41ee5a19cfa275082d6aa13208bb5d97c08dd2)), closes [#8492](https://github.com/vuetifyjs/vuetify/issues/8492)
* **VDataTable:** remove unnecessary colspan in mobile view ([#8444](https://github.com/vuetifyjs/vuetify/issues/8444)) ([f56e2d8](https://github.com/vuetifyjs/vuetify/commit/f56e2d821d1c85a366743578c454ece1b5e5da63))
* **VDataTable:** replace hardcoded icons for presets in grouped rows ([#8285](https://github.com/vuetifyjs/vuetify/issues/8285)) ([014910a](https://github.com/vuetifyjs/vuetify/commit/014910a0dc9fa48f554ffc470883bb2498c0e6cf)), closes [#8255](https://github.com/vuetifyjs/vuetify/issues/8255)
* **VDataTable:** workaround for chrome colspan border-collapse bug ([#8297](https://github.com/vuetifyjs/vuetify/issues/8297)) ([bff228e](https://github.com/vuetifyjs/vuetify/commit/bff228e9c151a05d84aed6fddf6659a1201fb287)), closes [#8251](https://github.com/vuetifyjs/vuetify/issues/8251)
* **VDialog:** fix style of component to follow material spec ([#8382](https://github.com/vuetifyjs/vuetify/issues/8382)) ([34d3483](https://github.com/vuetifyjs/vuetify/commit/34d34832d52a41447d70cf100a98e6bd55f168dd)), closes [#7773](https://github.com/vuetifyjs/vuetify/issues/7773)
* **VDivider:** missing rtl styles ([#8406](https://github.com/vuetifyjs/vuetify/issues/8406)) ([e629f12](https://github.com/vuetifyjs/vuetify/commit/e629f129c48ef9d23513a47382819c2e2098b66f)), closes [#8397](https://github.com/vuetifyjs/vuetify/issues/8397)
* **VEditDialog:** fix editability of VEditDialog ([#8466](https://github.com/vuetifyjs/vuetify/issues/8466)) ([8f5388f](https://github.com/vuetifyjs/vuetify/commit/8f5388fafe19ff2bfba9d2313c530c668f9c2b2f)), closes [#8465](https://github.com/vuetifyjs/vuetify/issues/8465)
* **VFileInput:** add missing type in types/lib.d.ts ([#8258](https://github.com/vuetifyjs/vuetify/issues/8258)) ([4eb7cf6](https://github.com/vuetifyjs/vuetify/commit/4eb7cf61ad0ff67f4462e4c553657405e61b8c0c))
* **VFileInput:** counter should update for null and value type ([#8375](https://github.com/vuetifyjs/vuetify/issues/8375)) ([add1add](https://github.com/vuetifyjs/vuetify/commit/add1add595a39bf7e07d8bd16682893734cdc286)), closes [#8372](https://github.com/vuetifyjs/vuetify/issues/8372)
* **VFileInput:** use internalArrayValue ([#8371](https://github.com/vuetifyjs/vuetify/issues/8371)) ([359125d](https://github.com/vuetifyjs/vuetify/commit/359125df8f47b8f3b655603e03d130ea002642e1))
* **VList:** missing rtl styles ([#8407](https://github.com/vuetifyjs/vuetify/issues/8407)) ([ce19073](https://github.com/vuetifyjs/vuetify/commit/ce190730c04eda853ce9e5fe8e792c32086db637)), closes [#8403](https://github.com/vuetifyjs/vuetify/issues/8403) [#8378](https://github.com/vuetifyjs/vuetify/issues/8378)
* **VMenu:** ignore click outside if component is being destroyed ([#8470](https://github.com/vuetifyjs/vuetify/issues/8470)) ([2ad27f6](https://github.com/vuetifyjs/vuetify/commit/2ad27f604fb1e3f228224bf6e046c81ec067eca8)), closes [#6976](https://github.com/vuetifyjs/vuetify/issues/6976)
* **VRangeSlider:** fix focus/blur events not emitting ([#8295](https://github.com/vuetifyjs/vuetify/issues/8295)) ([56c7e65](https://github.com/vuetifyjs/vuetify/commit/56c7e653aeb2e8377682e497d14b6a933849a569)), closes [#8290](https://github.com/vuetifyjs/vuetify/issues/8290)
* **VSelect:** ignore keypress when readonly ([#8194](https://github.com/vuetifyjs/vuetify/issues/8194)) ([0f92fc9](https://github.com/vuetifyjs/vuetify/commit/0f92fc9e61d300dca7e650271179a9c700c043cd))
* **VSelect/VRadio:** apply externally bound $listeners ([ecde38e](https://github.com/vuetifyjs/vuetify/commit/ecde38e35ae69410dcffdde29eecbdeb938f6ace)), closes [#8387](https://github.com/vuetifyjs/vuetify/issues/8387)
* **VSlideGroup:** re-calculate width when children length changes ([f2c206d](https://github.com/vuetifyjs/vuetify/commit/f2c206d47cb11724d6d8af0feec2ee4882af189e)), closes [#8330](https://github.com/vuetifyjs/vuetify/issues/8330)
* **VTextField:** update label width on label change ([#8409](https://github.com/vuetifyjs/vuetify/issues/8409)) ([8b8a966](https://github.com/vuetifyjs/vuetify/commit/8b8a966c1df330c0fe96b037a62d950eafb6557c)), closes [#8393](https://github.com/vuetifyjs/vuetify/issues/8393)
* **VTimeline:** display flat cards correctly ([9b1b1b8](https://github.com/vuetifyjs/vuetify/commit/9b1b1b8af4ec555fb3241dc4461b3c25abcb37bf)), closes [#8420](https://github.com/vuetifyjs/vuetify/issues/8420)
* **VTimeline:** position small and large dots correctly ([41059c4](https://github.com/vuetifyjs/vuetify/commit/41059c40c50d5f10ccb3376be7677889efeba74c)), closes [#8437](https://github.com/vuetifyjs/vuetify/issues/8437)
* polish translation of dataTable.sortBy ([4f5d329](https://github.com/vuetifyjs/vuetify/commit/4f5d32970646cf8c1d6df3bbceb461568e22da5c))
* **VRating:** flip in RTL ([d0eb357](https://github.com/vuetifyjs/vuetify/commit/d0eb35795933549f2394d3b5c6c314ef17058761)), closes [#7381](https://github.com/vuetifyjs/vuetify/issues/7381)
* **VSelect:** tweak default menu max-height value ([#8225](https://github.com/vuetifyjs/vuetify/issues/8225)) ([7932d7a](https://github.com/vuetifyjs/vuetify/commit/7932d7a3fbf40ca586f6e6e2b1f02f4dcc495c5b))
* **VSimpleTable:** fix hover ([#8165](https://github.com/vuetifyjs/vuetify/issues/8165)) ([13816f1](https://github.com/vuetifyjs/vuetify/commit/13816f144f9fe493df0dbfd3258d4258e91bb105))
* **VSnackbar:** properly assign width on mobile devices ([c54ccbe](https://github.com/vuetifyjs/vuetify/commit/c54ccbe5dc828a765290a16d77332748248f7150)), closes [#8224](https://github.com/vuetifyjs/vuetify/issues/8224)
* **VSpeedDial:** fix transition for tooltips ([e8dbd0b](https://github.com/vuetifyjs/vuetify/commit/e8dbd0be1c19ef2ad699557c93465c01bf08d516)), closes [#8159](https://github.com/vuetifyjs/vuetify/issues/8159)
* **VSpeedDial:** make speed dial non-clickable when it's closing ([c158d04](https://github.com/vuetifyjs/vuetify/commit/c158d04e2145d50042763c43e56ebb4903ec9c7b)), closes [#8203](https://github.com/vuetifyjs/vuetify/issues/8203)
* **VSwitch:** inset styling in RTL ([#8188](https://github.com/vuetifyjs/vuetify/issues/8188)) ([d53c43c](https://github.com/vuetifyjs/vuetify/commit/d53c43c4ec4fa822b1e488ead8e22a58e8f3bdb6)), closes [#8130](https://github.com/vuetifyjs/vuetify/issues/8130)
* **VTabs:** margins in RTL mode ([#8123](https://github.com/vuetifyjs/vuetify/issues/8123)) ([e5e5f76](https://github.com/vuetifyjs/vuetify/commit/e5e5f76910b33df1cf64b9d57f658ff54e7664d4))
* **VTabs:** prevent prop style bleed ([8f126b8](https://github.com/vuetifyjs/vuetify/commit/8f126b8b836976f089db5862490ad14c32c70a07)), closes [#8303](https://github.com/vuetifyjs/vuetify/issues/8303)
* **VTabs:** set correct offset on touchend with rtl ([1565a8e](https://github.com/vuetifyjs/vuetify/commit/1565a8edc6e6929b95fd6a1b0b3d594d3b494786)), closes [#8116](https://github.com/vuetifyjs/vuetify/issues/8116)
* add missing components to $_vuetify_subcomponents ([#8080](https://github.com/vuetifyjs/vuetify/issues/8080)) ([8aff65a](https://github.com/vuetifyjs/vuetify/commit/8aff65aed2629a07a4d75967b0bda4d82da1adfe)), closes [#8047](https://github.com/vuetifyjs/vuetify/issues/8047)
* **VForm:** when validate is manually called, properly validate all inputs ([b411be4](https://github.com/vuetifyjs/vuetify/commit/b411be4ebaec38d5c4b6359ca464ed6d33b4c458)), closes [#7999](https://github.com/vuetifyjs/vuetify/issues/7999)
* **VIcon:** add missing x-small prop functionality ([9b77c73](https://github.com/vuetifyjs/vuetify/commit/9b77c734523a03261436df056a2d1535a5b67980)), closes [#7873](https://github.com/vuetifyjs/vuetify/issues/7873)
* **VImg:** limit width to 100% ([78fbc32](https://github.com/vuetifyjs/vuetify/commit/78fbc321583cac2ae845e6c3ddc55048b9f9e806)), closes [#5788](https://github.com/vuetifyjs/vuetify/issues/5788) [#7327](https://github.com/vuetifyjs/vuetify/issues/7327)
* **VList:** disabled pointer events for disabled item ([71771da](https://github.com/vuetifyjs/vuetify/commit/71771daaec7eacd3fa6378a41409bdc47a1a81be))
* **VListItem:** update css selector for list-item-avatar styles ([a689c03](https://github.com/vuetifyjs/vuetify/commit/a689c03184b615b1714f98a810098b3306985a55)), closes [#7930](https://github.com/vuetifyjs/vuetify/issues/7930)
* **VPagination:** restrict totalVisible to maxButtons ([8195ac7](https://github.com/vuetifyjs/vuetify/commit/8195ac7728ecd1fb319c52436ec8f084a2f882fd)), closes [#7947](https://github.com/vuetifyjs/vuetify/issues/7947)
* **VSelect:** add selection padding for outlined style ([9566d4d](https://github.com/vuetifyjs/vuetify/commit/9566d4daa008a1d29c1abd3db2e242b517065715))
* **VSnackbar:** add correct exit animation ([0efd2a1](https://github.com/vuetifyjs/vuetify/commit/0efd2a13aa39424d6ba53559af4f872fd66b4494)), closes [#7981](https://github.com/vuetifyjs/vuetify/issues/7981)
* **VSpeedDial:** apply even padding on speed-dial list ([4091792](https://github.com/vuetifyjs/vuetify/commit/4091792b347877cd4478c395c33f488d798e1c36)), closes [#8039](https://github.com/vuetifyjs/vuetify/issues/8039)
* **VSpeedDialg:** change spacing between list and fab from margin to padding ([4bfd0b4](https://github.com/vuetifyjs/vuetify/commit/4bfd0b495747aab9f301d84bf9ed80c4cd22be98)), closes [#8015](https://github.com/vuetifyjs/vuetify/issues/8015)
* **VSystemBar:** propagate listeners to root element ([c14aae7](https://github.com/vuetifyjs/vuetify/commit/c14aae7f4c701d960923130999973d40ebf37a46)), closes [#7960](https://github.com/vuetifyjs/vuetify/issues/7960)
* **VTabs:** add proper indentation for mobile scrollable and align-with-title ([f380842](https://github.com/vuetifyjs/vuetify/commit/f3808423a055ab6d4cfbc30f571722519e38fb03)), closes [#6932](https://github.com/vuetifyjs/vuetify/issues/6932)
* **VTabs:** allow proper adjustment of sldier size ([c31b01d](https://github.com/vuetifyjs/vuetify/commit/c31b01d7c4aeee3b4f75b7b7949021d2522ced27)), closes [#8014](https://github.com/vuetifyjs/vuetify/issues/8014)
* hyphenate remaining event names ([#7917](https://github.com/vuetifyjs/vuetify/issues/7917)) ([6fac25d](https://github.com/vuetifyjs/vuetify/commit/6fac25d8fef351f79c7309dc596cd57a2ed71758))
* **docs:** import directives with lowercase ([#7508](https://github.com/vuetifyjs/vuetify/issues/7508)) ([7d663f5](https://github.com/vuetifyjs/vuetify/commit/7d663f52dd1403425bc20ce17cb8c134f1ff46da))
* **elevatable:** allow elevation value of numeric 0 ([e690b23](https://github.com/vuetifyjs/vuetify/commit/e690b2307a54a77d45a7b0b390cfda46bf5a7816))
* **getObjectValueByPath:** fix getObjectValueByPath ([#7543](https://github.com/vuetifyjs/vuetify/issues/7543)) ([02f5471](https://github.com/vuetifyjs/vuetify/commit/02f547121743b29ac0fc036350121032b86079f5)), closes [#7302](https://github.com/vuetifyjs/vuetify/issues/7302)
* **input-controls:** properly associate labels with inputs for a11y ([7c4a1ad](https://github.com/vuetifyjs/vuetify/commit/7c4a1adfc028b2ca5f74e18b5b92fce805acf36f)), closes [#6178](https://github.com/vuetifyjs/vuetify/issues/6178)
* **Inputs:** fix multiple a11y issues ([f7b2443](https://github.com/vuetifyjs/vuetify/commit/f7b2443788ebefa173dd5bb6ee1fb9f047ec1783))
* **install:** add property to Vue object to avoid memory leak ([#7497](https://github.com/vuetifyjs/vuetify/issues/7497)) ([c7cbdc5](https://github.com/vuetifyjs/vuetify/commit/c7cbdc51618bcdce26393d434c832c9b0fa4e255)), closes [vuejs/vue#5089](https://github.com/vuejs/vue/issues/5089)
* **locale:** Japanese translation of DataTable ([#7596](https://github.com/vuetifyjs/vuetify/issues/7596)) ([c6e0327](https://github.com/vuetifyjs/vuetify/commit/c6e0327b93e632dcb5c2f56aaf862930f439ae2a))
* **locale:** update fa locale ([#7439](https://github.com/vuetifyjs/vuetify/issues/7439)) ([70180b8](https://github.com/vuetifyjs/vuetify/commit/70180b816b6db493aa37e3470112baa1e825aac4))
* **locale:** update polish translations to 2.0 ([2a57376](https://github.com/vuetifyjs/vuetify/commit/2a57376615b72ac29ed89da2a7c5ed694660d434))
* **locale:** update ru locale ([#7437](https://github.com/vuetifyjs/vuetify/issues/7437)) ([dbf4a9e](https://github.com/vuetifyjs/vuetify/commit/dbf4a9ed8a119ed25beb2a7f2ca591df59b4117c))
* **locale:** update translation files structure to 2.0 ([#7367](https://github.com/vuetifyjs/vuetify/issues/7367)) ([87b1844](https://github.com/vuetifyjs/vuetify/commit/87b1844f8b68bb36a27f77eaaf8e6e48d078de5d))
* **Overlayable:** do not remove overlay if is still active after transitionend ([dc30560](https://github.com/vuetifyjs/vuetify/commit/dc30560a0f4e967d5f9f606c4c4146c75053b5f9)), closes [#7798](https://github.com/vuetifyjs/vuetify/issues/7798)
* **Ripple:** add ripple property to denote touch enabled ([#7619](https://github.com/vuetifyjs/vuetify/issues/7619)) ([985c634](https://github.com/vuetifyjs/vuetify/commit/985c634bb288664726e0169f888e92ad03d2288f)), closes [#7605](https://github.com/vuetifyjs/vuetify/issues/7605)
* **scripts:** invalid path to jest binary in debug:test ([509b297](https://github.com/vuetifyjs/vuetify/commit/509b29743d393c94aa5f6755e41d62ffaa850eed)), closes [#7350](https://github.com/vuetifyjs/vuetify/issues/7350)
* **Selectable:** update hasColor data property on value change ([818077f](https://github.com/vuetifyjs/vuetify/commit/818077f2f0a596acbc8b4cf5d82ef9637cbb77fe)), closes [#7855](https://github.com/vuetifyjs/vuetify/issues/7855)
* **SelectionControls:** toggle model when clicking label ([90b7188](https://github.com/vuetifyjs/vuetify/commit/90b718819584a4cc46c3d7bc04826912059d8bc2)), closes [#7744](https://github.com/vuetifyjs/vuetify/issues/7744)
* **SelectionControls:** tweak styles to properly match spec ([7fab4bc](https://github.com/vuetifyjs/vuetify/commit/7fab4bcdeddbdee69e320733a444e5e203d9d281))
* **styles:** broken rtl spacing and text-alignment classes ([6c79093](https://github.com/vuetifyjs/vuetify/commit/6c790939a906f1f014304431fa9014a24e70608c))
* **styles:** missing elevation-0 ([111d777](https://github.com/vuetifyjs/vuetify/commit/111d7773122f0c79703a0b58b2430cb43f0e7816)), closes [#7652](https://github.com/vuetifyjs/vuetify/issues/7652)
* **theme:** add .v-application prefix to theme/color/typography/etc rules ([#7768](https://github.com/vuetifyjs/vuetify/issues/7768)) ([c5dae24](https://github.com/vuetifyjs/vuetify/commit/c5dae24d87204e50ae31907f6d6d6c8b79d6531d)), closes [#7517](https://github.com/vuetifyjs/vuetify/issues/7517)
* **types:** give explicit type to empty arrays ([#7557](https://github.com/vuetifyjs/vuetify/issues/7557)) ([121c694](https://github.com/vuetifyjs/vuetify/commit/121c69478986b0ea5e418342ca545ae6d1c70bd0))
* **typescript:** added vuetify constructor declaration ([#7760](https://github.com/vuetifyjs/vuetify/issues/7760)) ([5a22747](https://github.com/vuetifyjs/vuetify/commit/5a22747d8242fe9d46f1e76810db3c5c3b8229cf))
* **typescript:** export directives in PascalCase ([#7767](https://github.com/vuetifyjs/vuetify/issues/7767)) ([aee87c0](https://github.com/vuetifyjs/vuetify/commit/aee87c0ed48837e6fbc83175311ecc5695cc2096)), closes [#7684](https://github.com/vuetifyjs/vuetify/issues/7684)
* **utilities:** allow multi-dimensional values ([9ac0d11](https://github.com/vuetifyjs/vuetify/commit/9ac0d111e9d258852897944209dd5347da42b0d3))
* **VAlert:** add proper a11y role ([6006ffa](https://github.com/vuetifyjs/vuetify/commit/6006ffa919bf1c0b445fa9bd22ddb2244ee2c863))
* **validatable:** setup proper validation state coloring on all inputs ([#7810](https://github.com/vuetifyjs/vuetify/issues/7810)) ([62e8fe0](https://github.com/vuetifyjs/vuetify/commit/62e8fe0424c67030ded1b20c79fafe77637b79ca))
* **VApp:** add missing theme propagation from $vuetify object ([2589d0c](https://github.com/vuetifyjs/vuetify/commit/2589d0c456099ca08a83455c8555370781cd0eef))
* **VAppBar:** remove width declaration on fixed bar ([cf73093](https://github.com/vuetifyjs/vuetify/commit/cf73093fa41eef4d8b9a2a97e4a6423a30bdddda))
* **VAutocomplete:** don't reset search to both undefined and null ([071ae76](https://github.com/vuetifyjs/vuetify/commit/071ae76d7b16c7d9af70e248bb74886091e6b83e)), closes [#7344](https://github.com/vuetifyjs/vuetify/issues/7344)
* **VAutocomplete:** remove space preventDefault ([7583d79](https://github.com/vuetifyjs/vuetify/commit/7583d7976d5a21ec32c865652ce1d0c62693dc56))
* **VAvatar:** ensure text is always aligned properly ([cf94c0b](https://github.com/vuetifyjs/vuetify/commit/cf94c0bd9ba3d2b591bcd1942cd6fc9fe7b06ab2))
* **VBadge:** ensure text is always aligned properly ([7f5b257](https://github.com/vuetifyjs/vuetify/commit/7f5b2579eac740850414e841189136f0c1b31bad))
* **VBadge:** fix delay on closing badge if transition is disabled ([#7287](https://github.com/vuetifyjs/vuetify/issues/7287)) ([98d9a3a](https://github.com/vuetifyjs/vuetify/commit/98d9a3a03446db4c3df5c47d9591ebe7a44c78f6))
* **VBottomNavigation:** adjust styles for inner buttons ([3ae30e5](https://github.com/vuetifyjs/vuetify/commit/3ae30e50403a4dad665e691b3e4e664dcbd370fe))
* **VBottomNavigation:** decrease specificity of icon margin ([85ac7d4](https://github.com/vuetifyjs/vuetify/commit/85ac7d47b5c9c20bc12c86c6f4543fdd1dcd0238)), closes [#7568](https://github.com/vuetifyjs/vuetify/issues/7568)
* **VBtn:** add letter-indent to combat off center caused by letter-spacing ([606dfd5](https://github.com/vuetifyjs/vuetify/commit/606dfd5c830283a50b36536946ff76984e9404ed))
* **VBtn:** adjust icon margin and size calculation to properly match spec ([45df4b3](https://github.com/vuetifyjs/vuetify/commit/45df4b3756f13449c5c7ffb68ef2ee44192c385c))
* **VBtn:** adjust large button sizes to be consistent ([#7536](https://github.com/vuetifyjs/vuetify/issues/7536)) ([7e2e2a4](https://github.com/vuetifyjs/vuetify/commit/7e2e2a425986a5a8636db21530294bfd8fb8d1a4))
* **VBtn:** adjust style declaration for v-icon color inheritance ([0b6784d](https://github.com/vuetifyjs/vuetify/commit/0b6784d781b93d34b98e66b62969129d850621c5))
* **VBtn:** correct md2 fab sizes ([f787b46](https://github.com/vuetifyjs/vuetify/commit/f787b469afde7da7fb1be8a6a45879002e31b63b)), closes [#7785](https://github.com/vuetifyjs/vuetify/issues/7785)
* **VBtn:** ensure .v-btn__content extends full width ([aa30554](https://github.com/vuetifyjs/vuetify/commit/aa305540c8ac2f67578db392748a263afc668c62)), closes [#7580](https://github.com/vuetifyjs/vuetify/issues/7580)
* **VBtn:** fix style application for text/outlined variants ([4d995c9](https://github.com/vuetifyjs/vuetify/commit/4d995c96b2a700e274c08534a56c6b05b75396f0))
* **VBtn:** make tile prop work ([#7751](https://github.com/vuetifyjs/vuetify/issues/7751)) ([49292c8](https://github.com/vuetifyjs/vuetify/commit/49292c8b0f6ae7e7f4e682c71695d61508a44a61)), closes [#7750](https://github.com/vuetifyjs/vuetify/issues/7750)
* **VBtn/Tab:** normalize vertical alignment ([e2fc06b](https://github.com/vuetifyjs/vuetify/commit/e2fc06b101b59a4f5fff08bd2d3c50a3bb472aa1)), closes [#7832](https://github.com/vuetifyjs/vuetify/issues/7832)
* **VBtnToggle:** restructure styles, improve v-btn color override ([#7515](https://github.com/vuetifyjs/vuetify/issues/7515)) ([4b4b1a1](https://github.com/vuetifyjs/vuetify/commit/4b4b1a1ce3d98232d430b0ea35da18354fb50954)), closes [#7420](https://github.com/vuetifyjs/vuetify/issues/7420)
* **VCalendar:** ellipsis weekday names when overflowed ([d400b2c](https://github.com/vuetifyjs/vuetify/commit/d400b2cf249fe4d56a10355e091de140a131b022))
* **VCalendar:** proper fix for using next/prev with irregular weekdays ([1222e2a](https://github.com/vuetifyjs/vuetify/commit/1222e2ad2bd45a0a4568c32ff6cabd7d8ac3ccc4)), closes [#7155](https://github.com/vuetifyjs/vuetify/issues/7155)
* **VCalendar:** throw error when no days available ([#7675](https://github.com/vuetifyjs/vuetify/issues/7675)) ([032aadc](https://github.com/vuetifyjs/vuetify/commit/032aadc42f7e7ba520a4e397ab0b5d27189eaebe)), closes [#7155](https://github.com/vuetifyjs/vuetify/issues/7155)
* **VCalendar:** update scoped slot names to kebab-case ([#7673](https://github.com/vuetifyjs/vuetify/issues/7673)) ([7835965](https://github.com/vuetifyjs/vuetify/commit/78359658800bb6631794bce43ab3865c44047860)), closes [#6704](https://github.com/vuetifyjs/vuetify/issues/6704)
* **VCard:** prevent overflow in flex containers ([18b9bf0](https://github.com/vuetifyjs/vuetify/commit/18b9bf081ff9f465350afaf1fb022f69d9712ec2))
* **VCheckbox:** add missing input classes ([b64dafc](https://github.com/vuetifyjs/vuetify/commit/b64dafcd353cffc438af0c5b177d03814ed2d036)), closes [#7509](https://github.com/vuetifyjs/vuetify/issues/7509)
* **VCheckbox:** normalize indeterminate behavior with native checkbox input ([f7cd045](https://github.com/vuetifyjs/vuetify/commit/f7cd0459f41ad71368d3cc3580681f41063bdc31))
* **VChip:** add active prop to replace existing value functionality ([f9eadbe](https://github.com/vuetifyjs/vuetify/commit/f9eadbe9b8919be73e6a14ac388dc054fdf1ebad)), closes [#7715](https://github.com/vuetifyjs/vuetify/issues/7715)
* **VChip:** increase css specificity for outlined styles ([7667a54](https://github.com/vuetifyjs/vuetify/commit/7667a54c5d0530ca32a794acd4c074e4050409c6))
* **VChip:** show ripple ([61b0b31](https://github.com/vuetifyjs/vuetify/commit/61b0b315dfb1eed62b805769e49177f93a880f3b)), closes [#7863](https://github.com/vuetifyjs/vuetify/issues/7863)
* **VCombobox:** properly enable auto-select-first ([c84c2fb](https://github.com/vuetifyjs/vuetify/commit/c84c2fb3229382a57ea04268d95ab0ccf793736c)), closes [#6607](https://github.com/vuetifyjs/vuetify/issues/6607)
* **VData:** typo in ts interface name ([e4e01e9](https://github.com/vuetifyjs/vuetify/commit/e4e01e9ee42e8c21c8c4bfd0eb90c7835c591c77))
* **VDataFooter:** add missing translation ([#7561](https://github.com/vuetifyjs/vuetify/issues/7561)) ([372c314](https://github.com/vuetifyjs/vuetify/commit/372c3148db4da8f30664baa8f717a04a14b0ada3))
* **VDataTable:** add theme styles for group header ([a8634d6](https://github.com/vuetifyjs/vuetify/commit/a8634d6bbf38b38f29bb06836bfe2b2f9cb224a9)), closes [#7853](https://github.com/vuetifyjs/vuetify/issues/7853)
* **VDataTable:** disable header sorting if disable-sort is true ([#7665](https://github.com/vuetifyjs/vuetify/issues/7665)) ([1809a1c](https://github.com/vuetifyjs/vuetify/commit/1809a1c89eaf6296a086808e58c06a139e6880cd)), closes [#7657](https://github.com/vuetifyjs/vuetify/issues/7657)
* **VDataTable:** enable use of expanded-item slot when using item slot ([a98dde5](https://github.com/vuetifyjs/vuetify/commit/a98dde50550a258524fc469d1ed91e6800e14d8b))
* **VDataTable:** missing styles for headers ([eed1e2f](https://github.com/vuetifyjs/vuetify/commit/eed1e2f4462ff569952606c230bec8e60e08e16f))
* **VDataTable:** mobile rows did not use available slots ([3f7ecd6](https://github.com/vuetifyjs/vuetify/commit/3f7ecd6cbd34c719692018a44f39cfea6d3a89a4))
* **VDataTable:** safari bug where background color was not applied ([018f44c](https://github.com/vuetifyjs/vuetify/commit/018f44cd2d339eb9855e63cd6b4644cd96cc195b)), closes [#6766](https://github.com/vuetifyjs/vuetify/issues/6766)
* **VDataTable:** updated mobile row test ([9c62db6](https://github.com/vuetifyjs/vuetify/commit/9c62db6ae2df19afa3228cf40088197f51735de0))
* **VDataTable:** virtual table should re-render rows when items change ([#7427](https://github.com/vuetifyjs/vuetify/issues/7427)) ([50a5dbf](https://github.com/vuetifyjs/vuetify/commit/50a5dbfb81a0679855ab18051402dc7607d4c973)), closes [#7336](https://github.com/vuetifyjs/vuetify/issues/7336)
* **VDataTableHeader:** remove icon opacity ([bf0a9e4](https://github.com/vuetifyjs/vuetify/commit/bf0a9e45199412f6d172ed748522385c02687654)), closes [#6647](https://github.com/vuetifyjs/vuetify/issues/6647)
* **VDialog:** adjust flex properties for scrollable ([8877942](https://github.com/vuetifyjs/vuetify/commit/8877942cede7f6b7f5d25fc1e91e567ca0b11b8e)), closes [#6754](https://github.com/vuetifyjs/vuetify/issues/6754)
* **VDialog:** fixed event variable ref in onFocusin ([#7498](https://github.com/vuetifyjs/vuetify/issues/7498)) ([db94b73](https://github.com/vuetifyjs/vuetify/commit/db94b73854ecdb7c5861df2824b3ab78df32719f))
* **VExpansionPanel:** set proper button type in header ([cf0da4b](https://github.com/vuetifyjs/vuetify/commit/cf0da4b54a5db9b59d85468bfd1824580112b123)), closes [#7471](https://github.com/vuetifyjs/vuetify/issues/7471)
* **VIcon:** fix a11y with SVG ([1866aca](https://github.com/vuetifyjs/vuetify/commit/1866aca328415211136c0afc55a820f91fbb71fd)), closes [#7428](https://github.com/vuetifyjs/vuetify/issues/7428)
* **VIcon:** missing default icons ([796a22c](https://github.com/vuetifyjs/vuetify/commit/796a22c1bca403ad5d2be68bf5385b6951129350))
* **VInput:** attrs should be applied on input not root element ([#7579](https://github.com/vuetifyjs/vuetify/issues/7579)) ([318553a](https://github.com/vuetifyjs/vuetify/commit/318553a7a76e7b9004f11e35db9aa1dec1ba01d6)), closes [#5412](https://github.com/vuetifyjs/vuetify/issues/5412)
* **VList:** pass in measureable styles ([#7570](https://github.com/vuetifyjs/vuetify/issues/7570)) ([0fa7e73](https://github.com/vuetifyjs/vuetify/commit/0fa7e73ad86fc99904b15cbdef1f584b38c877c1))
* **VListItem:** add missing disabled styles ([ddc4e65](https://github.com/vuetifyjs/vuetify/commit/ddc4e65a5ca519eb69735db183e161262effc4aa))
* **VMenu:** avoid potential stack overflow with no clickable tiles ([7d3b8e9](https://github.com/vuetifyjs/vuetify/commit/7d3b8e9c3efc65499b9884356204c3bdc3bf56e8))
* **VMenu:** ignore elements with 0 or NaN z-index ([#7532](https://github.com/vuetifyjs/vuetify/issues/7532)) ([df96de0](https://github.com/vuetifyjs/vuetify/commit/df96de0b6d68912bf53d8546f1ac8d2c0905d3f8)), closes [#5351](https://github.com/vuetifyjs/vuetify/issues/5351)
* **VMenu/Selects:** properly configure a11y ([#7385](https://github.com/vuetifyjs/vuetify/issues/7385)) ([e9a816d](https://github.com/vuetifyjs/vuetify/commit/e9a816dd38a0ebe2c683e2bf4fac92cc44dcf6ff))
* **VPicker:** fix width in landscape mode ([5075e43](https://github.com/vuetifyjs/vuetify/commit/5075e43bcf165e2e3d9b744ed07acd7138af5114))
* **VSelect:** set input type to hidden to fix potential layout issues ([#7544](https://github.com/vuetifyjs/vuetify/issues/7544)) ([bd35bee](https://github.com/vuetifyjs/vuetify/commit/bd35bee9e8bedce66e381d6ff14567a25602a92a)), closes [#5614](https://github.com/vuetifyjs/vuetify/issues/5614)
* **VSelectList:** wrong class for masked characters ([d8fbd1e](https://github.com/vuetifyjs/vuetify/commit/d8fbd1e89cbc3015c07fd48088bc0ec7e1a11724))
* **VSparkline:** negative values, labels being cut off ([#7664](https://github.com/vuetifyjs/vuetify/issues/7664)) ([30348c8](https://github.com/vuetifyjs/vuetify/commit/30348c8fe8b1253a7dc2116f19037ef275d69926))
* normalize component active/hover/focus states ([#7519](https://github.com/vuetifyjs/vuetify/issues/7519)) ([3ab588a](https://github.com/vuetifyjs/vuetify/commit/3ab588ab52e3a9ca8f3b883e995ed2cedb8e79d9))
* **VDataTable:** added isMobile boolean to body slot props ([953a757](https://github.com/vuetifyjs/vuetify/commit/953a7577753515b08dcfa9bf34aa696cac1c8942))
* **VDataTable:** make custom filter function more user friendly ([#7885](https://github.com/vuetifyjs/vuetify/issues/7885)) ([132ac8e](https://github.com/vuetifyjs/vuetify/commit/132ac8e02f6ce7e24deb135b48e1aa16e408f46a))
* **VDatePicker:** increased css specificity ([51e49cf](https://github.com/vuetifyjs/vuetify/commit/51e49cfccb860d01a875fc74475994cbff6bf338))
* **VDialog:** add missing a11y roles ([1ee52bd](https://github.com/vuetifyjs/vuetify/commit/1ee52bd27a9523c9cf5467c236bad30ef624a481))
* **VExpansionPanel:** increase specificity for active header icon rotate ([8f83745](https://github.com/vuetifyjs/vuetify/commit/8f83745a0812fc1dc49112fdef8eb29f10f27c8c)), closes [#7809](https://github.com/vuetifyjs/vuetify/issues/7809)
* **VExpansionPanel:** remove flex style designation to v-item-group children ([d526302](https://github.com/vuetifyjs/vuetify/commit/d526302638913f6353b9ddf83c664e528d1246ae)), closes [#7524](https://github.com/vuetifyjs/vuetify/issues/7524)
* **VExpansionPanels:** increase specificity of accordion style to avoid css leak ([78c806a](https://github.com/vuetifyjs/vuetify/commit/78c806a2d5ec46f5dd148a8a65552d68671842f6)), closes [#7809](https://github.com/vuetifyjs/vuetify/issues/7809)
* **VFileInput:** properly clear file input ([dfc8948](https://github.com/vuetifyjs/vuetify/commit/dfc8948d78416d64343658be0e369aaf5c2bff20)), closes [#7848](https://github.com/vuetifyjs/vuetify/issues/7848)
* **VIcon:** add notranslate ([0c9b5f3](https://github.com/vuetifyjs/vuetify/commit/0c9b5f3672a75d2b478071a54a717bfc716a9540)), closes [#7689](https://github.com/vuetifyjs/vuetify/issues/7689)
* **VIcon:** fix race condition with material icons ([4b19e34](https://github.com/vuetifyjs/vuetify/commit/4b19e3485fc80810a550f8ce43a80855d4f5ded6)), closes [#7746](https://github.com/vuetifyjs/vuetify/issues/7746)
* **VIcon:** normalize icon styles ([3d9dc50](https://github.com/vuetifyjs/vuetify/commit/3d9dc507ecaeedb3def0b93f7ad41ba6d2419a45))
* **VList:** add missing - in nav class styles ([7eab403](https://github.com/vuetifyjs/vuetify/commit/7eab403c511749d3c21de16c9daaa35ae73f8f20))
* **VList:** center title in nav/rouneded list's items ([b899bb7](https://github.com/vuetifyjs/vuetify/commit/b899bb78318882857564614db670ead61fa9209a))
* **VListGroup:** add missing click event propagation ([204dcc6](https://github.com/vuetifyjs/vuetify/commit/204dcc6a8b3e1b6a472a6d55f12d96999e440327))
* **VPagination:** remove ul padding from base ([1ab51bf](https://github.com/vuetifyjs/vuetify/commit/1ab51bfe1c338911c0d7f9912f9d17d49e0cf66e))
* **VSelect:** allow new item creation after one is selected ([e809466](https://github.com/vuetifyjs/vuetify/commit/e8094661ca582dbdf42441ade7235f653d8fcfdb))
* **VSelect:** pass attrs through scoped slot ([b70434b](https://github.com/vuetifyjs/vuetify/commit/b70434b82b4a7cfbe1e89b658aab4959776572f3))
* **VSelect:** resolve bug in safari/ie11 with event order disparity ([5fa6a68](https://github.com/vuetifyjs/vuetify/commit/5fa6a682634a0c159cf7c37897535bc2894131b9)), closes [#6608](https://github.com/vuetifyjs/vuetify/issues/6608) [#5913](https://github.com/vuetifyjs/vuetify/issues/5913)
* **VSelect:** tab selection ([4963f72](https://github.com/vuetifyjs/vuetify/commit/4963f72fac3e5fbe1a6bfbfae132ddfa736a6a74)), closes [#5614](https://github.com/vuetifyjs/vuetify/issues/5614) [#7544](https://github.com/vuetifyjs/vuetify/issues/7544)
* **VSelect/VChip:** selected state in input fields ([4dabf8b](https://github.com/vuetifyjs/vuetify/commit/4dabf8b5508b4fa86f1b3ce732c0e3d2a5eab27d)), closes [#7719](https://github.com/vuetifyjs/vuetify/issues/7719)
* **VSelectList:** move selection listener to simple-checkbox ([80d8884](https://github.com/vuetifyjs/vuetify/commit/80d8884dcb823be80abefb97805d267535f22433)), closes [#7692](https://github.com/vuetifyjs/vuetify/issues/7692)
* **VSnackbar:** update to better match md2 spec ([9f12df7](https://github.com/vuetifyjs/vuetify/commit/9f12df767034a7b73d8697d776b54d1b245e63fa)), closes [#7772](https://github.com/vuetifyjs/vuetify/issues/7772)
* **VSparkline:** adjust label position depending on line width ([69bebc3](https://github.com/vuetifyjs/vuetify/commit/69bebc3543ebbdace1e99b6443d3c5196b602cdc))
* **VSparkline:** filled line should not obscure labels ([b4fc0bd](https://github.com/vuetifyjs/vuetify/commit/b4fc0bd818257ffb298f027af52b302d797c8c5f)), closes [#7473](https://github.com/vuetifyjs/vuetify/issues/7473)
* **VSparkline:** incorrect bar lengths ([#7766](https://github.com/vuetifyjs/vuetify/issues/7766)) ([b31c749](https://github.com/vuetifyjs/vuetify/commit/b31c74935568f7eea7a6ea78d1fa8a01157b1018)), closes [#7762](https://github.com/vuetifyjs/vuetify/issues/7762)
* **VSparkline:** show custom labels when using bars ([#7642](https://github.com/vuetifyjs/vuetify/issues/7642)) ([454235d](https://github.com/vuetifyjs/vuetify/commit/454235d53f157ef9fdc3669dc2e88970d148ed61)), closes [#7584](https://github.com/vuetifyjs/vuetify/issues/7584)
* **VSparkline:** trend with equal values generates NaN ([a375292](https://github.com/vuetifyjs/vuetify/commit/a375292e3fb3f90ba39b9a4133e407d6c7c07f04)), closes [#7753](https://github.com/vuetifyjs/vuetify/issues/7753)
* **VSpeedDial:** add correct margin between btns inside of the dial list ([5146c85](https://github.com/vuetifyjs/vuetify/commit/5146c85d6938d822a7a4eb9f5d27b4cf043bfe13))
* **VSpeedDial:** fix absolute styles and list separation from activator ([c7bc9b0](https://github.com/vuetifyjs/vuetify/commit/c7bc9b08fdf6984357d25ce907b924c78ff6ad9a))
* **VTab:** increase specificity of color ([a9376db](https://github.com/vuetifyjs/vuetify/commit/a9376db0e46a7a98ac4210e78d8be136aa541ead))
* **VTabs:** add missing theme classes ([32048c1](https://github.com/vuetifyjs/vuetify/commit/32048c1f1458a18f75638977a8c8384109b5d698))
* **VTabs:** ensure v-tabs doesn't force overflow in flex elements ([5532ac5](https://github.com/vuetifyjs/vuetify/commit/5532ac51e23886e8ff85aba31d91076591f6248e)), closes [#7720](https://github.com/vuetifyjs/vuetify/issues/7720)
* **VTabs:** normal tabs inside vertical tabs are vertical ([#7357](https://github.com/vuetifyjs/vuetify/issues/7357)) ([290c353](https://github.com/vuetifyjs/vuetify/commit/290c3530d7710896a8d371a5b248f20a4fc8c6bc)), closes [#7355](https://github.com/vuetifyjs/vuetify/issues/7355)
* **VTabs:** properly set height when provided ([1f446b4](https://github.com/vuetifyjs/vuetify/commit/1f446b4760126e25774ac7c14e41889e71bcd89c)), closes [#7345](https://github.com/vuetifyjs/vuetify/issues/7345)
* **VTabs:** remove swiping propagation for tab touch events ([#7607](https://github.com/vuetifyjs/vuetify/issues/7607)) ([9d3937f](https://github.com/vuetifyjs/vuetify/commit/9d3937f737a1358c99dbb2d540190faaf82d96bf)), closes [#6462](https://github.com/vuetifyjs/vuetify/issues/6462) [#6801](https://github.com/vuetifyjs/vuetify/issues/6801)
* **VTabs:** resolve broken link association for a11y ([186eec1](https://github.com/vuetifyjs/vuetify/commit/186eec16e3fbdc80477f065644736fee3dc60d78))
* **VTabs:** tabs default color ([79016c3](https://github.com/vuetifyjs/vuetify/commit/79016c380576baa7e3eaa97f06d402e262b94ed6))
* **VTabs:** typo in var name, changed max width to match md specs ([47689ca](https://github.com/vuetifyjs/vuetify/commit/47689caa5b653ccccb66740ea2e40bbe3fbfa652))
* **VTabsItems:** change inferred theme variant ([cf180d4](https://github.com/vuetifyjs/vuetify/commit/cf180d465a4c55fc41cfc6090d12e79be4219b3a))
* **VTextarea:** apply single-line when using the full-width option ([aad5156](https://github.com/vuetifyjs/vuetify/commit/aad5156d29d507fcfafded01a54948fd9e7caf6e)), closes [#7442](https://github.com/vuetifyjs/vuetify/issues/7442)
* **VTextarea:** recalculate height on model update ([#7363](https://github.com/vuetifyjs/vuetify/issues/7363)) ([94a8344](https://github.com/vuetifyjs/vuetify/commit/94a834466de515473b2dcb677e8f2c683364391a)), closes [#4683](https://github.com/vuetifyjs/vuetify/issues/4683) [#6978](https://github.com/vuetifyjs/vuetify/issues/6978)
* **VTextarea:** recalculate textarea height when row-height changes ([489ce4c](https://github.com/vuetifyjs/vuetify/commit/489ce4c02f852e89aae00cf5470fd8cd6fc2e39a)), closes [#7671](https://github.com/vuetifyjs/vuetify/issues/7671)
* **VTextField:** add nowrap for prefix/suffix ([dd31808](https://github.com/vuetifyjs/vuetify/commit/dd318080b7643908bec9871e12aa8b40b978227b)), closes [#6922](https://github.com/vuetifyjs/vuetify/issues/6922)
* **VTextField:** improve text-field prop combination styling ([d0e5060](https://github.com/vuetifyjs/vuetify/commit/d0e5060210116f0f63992b2a05ca0ad3362d5bec)), closes [#7711](https://github.com/vuetifyjs/vuetify/issues/7711)
* **VTextField:** remove filled variant border override ([7e98189](https://github.com/vuetifyjs/vuetify/commit/7e98189d77c2ec3aa6c1557570fee6cf62bf0345))
* **VTextField, VSelect:** check the existence of input before focusing ([f9139ec](https://github.com/vuetifyjs/vuetify/commit/f9139eceb42caf43e07593612133e132fe8e4389)), closes [#7059](https://github.com/vuetifyjs/vuetify/issues/7059)
* **VTimePicker:** improve title look in landscape mode ([bc19a28](https://github.com/vuetifyjs/vuetify/commit/bc19a28db5038df01de9b8d3e1f3db09d598ea7c))
* **VToolbar:** always apply increased size to v-btn with the icon prop ([3a1fc40](https://github.com/vuetifyjs/vuetify/commit/3a1fc40e89defd00c9c7e1739af4dcffde09f9d0)), closes [#7400](https://github.com/vuetifyjs/vuetify/issues/7400)
* **VToolbar:** give proper default tag and allow for a custom one ([47d56b2](https://github.com/vuetifyjs/vuetify/commit/47d56b2ade2ef0ec4626ea38bac089199bb57599))
* **VToolbar:** resolve missing background image ([162149f](https://github.com/vuetifyjs/vuetify/commit/162149f473b00b733c9af62af5642a08846271f3))
* **VToolbar:** reverts fix in [#7499](https://github.com/vuetifyjs/vuetify/issues/7499) in favor of flex property ([8d9b25e](https://github.com/vuetifyjs/vuetify/commit/8d9b25e3b6ca18313c2a4db2b5a6dd9e34ac4eb5))
* **VToolbar/VAppBar:** properly show background on all browsers ([f6c5cce](https://github.com/vuetifyjs/vuetify/commit/f6c5cce78be19020d11e2485610effca04ce8cec)), closes [#7742](https://github.com/vuetifyjs/vuetify/issues/7742)
* **VTreeview:** don't emit events on mount ([#7546](https://github.com/vuetifyjs/vuetify/issues/7546)) ([023e596](https://github.com/vuetifyjs/vuetify/commit/023e596a174101a44da6f4d160fd0caf626fb563)), closes [#7296](https://github.com/vuetifyjs/vuetify/issues/7296)
* **VTreeview:** propagate item-disabled to child nodes ([52b6413](https://github.com/vuetifyjs/vuetify/commit/52b6413ea165dcafd001f0eb7d4c955e1f60d083))
* **VWindow:** hide overflow when using show-arrows-on-hover prop ([af003b6](https://github.com/vuetifyjs/vuetify/commit/af003b67055007193f36423d90b7e72fb19f2658)), closes [#7542](https://github.com/vuetifyjs/vuetify/issues/7542)
* **VWindowItem:** resolve content jumping on transition (not scroll related) ([46b563b](https://github.com/vuetifyjs/vuetify/commit/46b563b13538ecbb2b6d77b9a0dfee7092541998)), closes [#6206](https://github.com/vuetifyjs/vuetify/issues/6206)
* prevent duplicated theme stylesheet id ([#7443](https://github.com/vuetifyjs/vuetify/issues/7443)) ([6b7e7b1](https://github.com/vuetifyjs/vuetify/commit/6b7e7b192094ecbd6e53b7d2dee24b202e3b6951))
* **bootable:** proper deprecation since eager is not a replacement ([#7156](https://github.com/vuetifyjs/vuetify/issues/7156)) ([213d300](https://github.com/vuetifyjs/vuetify/commit/213d300038cce2a266c6907000232fcaa530ae0e))
* **typescript:** missing components in lib.d.ts ([#7293](https://github.com/vuetifyjs/vuetify/issues/7293)) ([a090fe1](https://github.com/vuetifyjs/vuetify/commit/a090fe1bc386a3317f2f4f562d42c541f88a092e)), closes [#7267](https://github.com/vuetifyjs/vuetify/issues/7267)
* **VAlert:** adjust improperly aligned icons and incorrect border radius on bordered type ([ea1fed8](https://github.com/vuetifyjs/vuetify/commit/ea1fed8f642a192bb4d0ccf1c0851bd55f2698ec))
* **VAlert:** update derived icon logic ([fa409fb](https://github.com/vuetifyjs/vuetify/commit/fa409fbf938099378ec057703ce096a4ccad3b22))
* **validatable:** VuetifyRuleValidator can return string | bolean ([b152757](https://github.com/vuetifyjs/vuetify/commit/b1527574c296b0eabbdb8d69f850686fb0866194))
* **VBottomNavigation:** add missing change emit ([d113245](https://github.com/vuetifyjs/vuetify/commit/d113245c495da3b39f7c37f23e3a52c36889bcb5))
* **VDataIterator:** it should now emit event when toggling all selected ([#7240](https://github.com/vuetifyjs/vuetify/issues/7240)) ([134f019](https://github.com/vuetifyjs/vuetify/commit/134f0197c8a397c34f60d9f99c42be05bfb03d79)), closes [#7115](https://github.com/vuetifyjs/vuetify/issues/7115)
* **VDataIterator:** resolve type check error ([4c65efd](https://github.com/vuetifyjs/vuetify/commit/4c65efd662c6d43ad32faef3f00b73d290fc35ca))
* **VDataTable:** correctly handle custom items per page options ([#7234](https://github.com/vuetifyjs/vuetify/issues/7234)) ([cde39dd](https://github.com/vuetifyjs/vuetify/commit/cde39dd9146a29e6382ed4e55b57a715c7d9ed4f))
* **VDataTable:** fix header color ([#7341](https://github.com/vuetifyjs/vuetify/issues/7341)) ([b040ff3](https://github.com/vuetifyjs/vuetify/commit/b040ff38b37a0180cbbb2cc019eae04fcd6bd086)), closes [#7334](https://github.com/vuetifyjs/vuetify/issues/7334)
* **VDataTable:** header icons should respect icon type (svg/non-svg) ([#7342](https://github.com/vuetifyjs/vuetify/issues/7342)) ([f8cfff5](https://github.com/vuetifyjs/vuetify/commit/f8cfff5813e03409aa77919c062aeaa5f3e7f012)), closes [#7338](https://github.com/vuetifyjs/vuetify/issues/7338)
* **VDataTable:** import ripple into datatable and header ([#7308](https://github.com/vuetifyjs/vuetify/issues/7308)) ([1be65e7](https://github.com/vuetifyjs/vuetify/commit/1be65e75f7e10baf31a5fc8443da3688ee1c3649))
* **VDataTable:** server side selection ([#7270](https://github.com/vuetifyjs/vuetify/issues/7270)) ([4f3adf1](https://github.com/vuetifyjs/vuetify/commit/4f3adf142dab9b742ad9c8b1494503c6b4d72ed7))
* **VDialog:** remove console error on escape keypress ([#7030](https://github.com/vuetifyjs/vuetify/issues/7030)) ([f2303f1](https://github.com/vuetifyjs/vuetify/commit/f2303f1daac83a9ea0a25800b8f96aebcc7a322f))
* **VEditDialog:** update for new activator changes ([0d10bd1](https://github.com/vuetifyjs/vuetify/commit/0d10bd14bcc6dbb974fdaa61204335c7f020258d))
* **VGrid:** wrap gutter equation in parentheses ([6f09b23](https://github.com/vuetifyjs/vuetify/commit/6f09b23d49196bfe1295fc1e5e2a7c281c7bddf0))
* **VListTileTitle:** don't cut badge ([#7161](https://github.com/vuetifyjs/vuetify/issues/7161)) ([f20cc01](https://github.com/vuetifyjs/vuetify/commit/f20cc01c228cc4b8a427f66f42db75f3991a2fd7)), closes [#7117](https://github.com/vuetifyjs/vuetify/issues/7117)
* **VMessages:** update min-height to avoid screen jitter ([96f874e](https://github.com/vuetifyjs/vuetify/commit/96f874e3f88d9b66838e7d221a9033eca5fa4c6b))
* **VSelect:** update selected color ([#7079](https://github.com/vuetifyjs/vuetify/issues/7079)) ([8a5760c](https://github.com/vuetifyjs/vuetify/commit/8a5760c6b6a184c9c8f41cbfebf079dbaa3ccc43)), closes [#6685](https://github.com/vuetifyjs/vuetify/issues/6685)
* **VSlider:** fixed issue when value is NaN ([bf83b6f](https://github.com/vuetifyjs/vuetify/commit/bf83b6f5a4f6f86a81949a22a608610926d6d69b))
* **VSlider:** set correct value when using negative min and 0 ([928a518](https://github.com/vuetifyjs/vuetify/commit/928a518f57eeebac44d6546ddeaba370fabcdbe0)), closes [#7320](https://github.com/vuetifyjs/vuetify/issues/7320)
* remove pointer events in &:before hover ([c1b0a25](https://github.com/vuetifyjs/vuetify/commit/c1b0a2569b49fb9f6743a1743ccb2248766d759e)), closes [#7335](https://github.com/vuetifyjs/vuetify/issues/7335)
* **VParallax:** show image if no translation is available ([#7042](https://github.com/vuetifyjs/vuetify/issues/7042)) ([c6f3a2c](https://github.com/vuetifyjs/vuetify/commit/c6f3a2cd396f70abe9e2c85e5fe1352646d20bf6)), closes [#7010](https://github.com/vuetifyjs/vuetify/issues/7010)
* **VSelect:** fix entry animation and positioning ([ae8f92a](https://github.com/vuetifyjs/vuetify/commit/ae8f92a34927e6378a94ad116571c07497f16a18))
* **VSlider:** floating thumb slider in IE11 ([#7158](https://github.com/vuetifyjs/vuetify/issues/7158)) ([dd19a45](https://github.com/vuetifyjs/vuetify/commit/dd19a45d502dff3178ff7bb9deb653200828ef0d))
* **VTabs:** cursor on tab without to/href ([86eecaa](https://github.com/vuetifyjs/vuetify/commit/86eecaa6e8e12dd62dadd6d63defbf816624a656))
* **VTabs:** do not hardcode v-tabs text color to white when in dark mode ([#7220](https://github.com/vuetifyjs/vuetify/issues/7220)) ([e4c8ceb](https://github.com/vuetifyjs/vuetify/commit/e4c8cebcb35a97c1f5d4da7ced5062e2ce74b9b6))
* **VTextField:** clearable should respect readonly=true ([#7175](https://github.com/vuetifyjs/vuetify/issues/7175)) ([d30d072](https://github.com/vuetifyjs/vuetify/commit/d30d07205eae28acff5fc76b89e83c72c63fe7f9)), closes [#7111](https://github.com/vuetifyjs/vuetify/issues/7111)
* **VTextField:** correct border-radius when using outlined and shaped ([de63ebc](https://github.com/vuetifyjs/vuetify/commit/de63ebce72ba5bfd181d397ef6ed38e021a074e5))
* **VTextField:** re-calculate label width on outlined change ([6a9ab1d](https://github.com/vuetifyjs/vuetify/commit/6a9ab1df1f05b5f1e00416ddf02bdd5a4e1b22ff))
* ensure required typescript folders are included during packaging ([#7229](https://github.com/vuetifyjs/vuetify/issues/7229)) ([7fbc0f6](https://github.com/vuetifyjs/vuetify/commit/7fbc0f618ed8283b8da20d25ca857a69d276c5e4))
* tabs in RTL mode ([#7292](https://github.com/vuetifyjs/vuetify/issues/7292)) ([48f325d](https://github.com/vuetifyjs/vuetify/commit/48f325dc9e61967d64b0d0e460b8374d08a81f92)), closes [#7245](https://github.com/vuetifyjs/vuetify/issues/7245)
* vue-devtools when using nuxt ([#7162](https://github.com/vuetifyjs/vuetify/issues/7162)) ([e30053e](https://github.com/vuetifyjs/vuetify/commit/e30053e3435d385547e1bb6a3e114613706f5f97))
* **elevation:** style mixin should use important ([0d08de1](https://github.com/vuetifyjs/vuetify/commit/0d08de1c862f1c9ef0f61717f051f6396050e1f0))
* **helpers:** check for window before adding listeners ([8f477e6](https://github.com/vuetifyjs/vuetify/commit/8f477e6dd24ea6eb3a1f34f9adbf68043e9319ac)), closes [#6952](https://github.com/vuetifyjs/vuetify/issues/6952)
* **locale:** update carousel.next/prev translation ([#6993](https://github.com/vuetifyjs/vuetify/issues/6993)) ([50874af](https://github.com/vuetifyjs/vuetify/commit/50874af77924d1ef32954a95a360cac3ebb86e46))
* **overlayable:** check browser support for passive events ([#6710](https://github.com/vuetifyjs/vuetify/issues/6710)) ([bb9c47e](https://github.com/vuetifyjs/vuetify/commit/bb9c47eb00f6d503485f399a982f2590411383c6)), closes [#6617](https://github.com/vuetifyjs/vuetify/issues/6617)
* **prefix position:** provide margin-top ([#6956](https://github.com/vuetifyjs/vuetify/issues/6956)) ([0160a40](https://github.com/vuetifyjs/vuetify/commit/0160a40220a754a5cd1b72620a085bbadbcbf1e8)), closes [#6942](https://github.com/vuetifyjs/vuetify/issues/6942)
* **ssr:** apply theme with vue-meta when available ([#6878](https://github.com/vuetifyjs/vuetify/issues/6878)) ([02e4e90](https://github.com/vuetifyjs/vuetify/commit/02e4e90791ae69135306a5888e45ba699af3d3c8))
* **v-messages:** increase line-height of inputs messages ([#6868](https://github.com/vuetifyjs/vuetify/issues/6868)) ([5f88487](https://github.com/vuetifyjs/vuetify/commit/5f884878964afa2d48cc4d53e47a1f35958379c9))
* **v-ripple:** check for existance of _ripple ([fb79ea8](https://github.com/vuetifyjs/vuetify/commit/fb79ea8eb2c087333cd1c9c995b5786cfe691f04))
* **VAlert:** allow the removal of a contextual icon ([eccc6ac](https://github.com/vuetifyjs/vuetify/commit/eccc6ac60003fc7d52f36d4536268245c6df299e))
* **VAvatar:** squishing inside flex containers ([c3ee291](https://github.com/vuetifyjs/vuetify/commit/c3ee291ce87de0ce4bb9cc451a17a7c5ec6762be))
* **VBtn:** limit FAB icon transition to direct children ([a76ef42](https://github.com/vuetifyjs/vuetify/commit/a76ef42346a5518d78c7c5e00bfe764f44b14aa3))
* **VBtn:** remove font-size overwrite by typography css ([#6975](https://github.com/vuetifyjs/vuetify/issues/6975)) ([189cbd2](https://github.com/vuetifyjs/vuetify/commit/189cbd20330be6e42ed190ebe3cfd9b26295c51b)), closes [#6974](https://github.com/vuetifyjs/vuetify/issues/6974)
* **VBtn:** remove line-height and references to old class and variables ([2a94fb1](https://github.com/vuetifyjs/vuetify/commit/2a94fb1532163f4f771e99fcff375b581f8d5c41))
* **VCard:** avoid being rendered on a different layer ([926ab0d](https://github.com/vuetifyjs/vuetify/commit/926ab0d077772a7f5bf5397abcf55a00ed3ce200))
* **VChip:** increase outline transparent specificity ([639756a](https://github.com/vuetifyjs/vuetify/commit/639756ada972f3e0d158ad208b0d0dd474803237))
* **VChip:** override `v-avatar` min-width added in c3ee291 ([cb212b4](https://github.com/vuetifyjs/vuetify/commit/cb212b432139fd71ef5474628a189fb844da672a))
* **VDialog:** propagate value to isActive ([140137f](https://github.com/vuetifyjs/vuetify/commit/140137f2adf291a518e42264cd11a4a10947a005))
* **VListGroup:** change lifecycle hook for init ([8fe4f6f](https://github.com/vuetifyjs/vuetify/commit/8fe4f6f4f81dda1636a77b66bde74a5af4c72999))
* **VListItem:** fix for usage with external value ([9c4c0f9](https://github.com/vuetifyjs/vuetify/commit/9c4c0f98246cb90b4591a827f722dcec2385a055))
* **VListItemAvatar:** use proper spacing to line-up title text ([2ddbaff](https://github.com/vuetifyjs/vuetify/commit/2ddbaffd66666099a21af7dbabaaa5d49208fc56))
* **VOoverflowBtn:** remove top border ([#6984](https://github.com/vuetifyjs/vuetify/issues/6984)) ([aa14ca8](https://github.com/vuetifyjs/vuetify/commit/aa14ca8b65694e4da4a9b5c4d697988342000cd6)), closes [#6960](https://github.com/vuetifyjs/vuetify/issues/6960)
* **VOverflowBtn:** remove pointless method override ([0a5aa74](https://github.com/vuetifyjs/vuetify/commit/0a5aa74c55b0c356c13147ad63759aada3d29569)), closes [#4533](https://github.com/vuetifyjs/vuetify/issues/4533)
* **VSelect:** avoid potential use of non-primitive for key value ([f29354a](https://github.com/vuetifyjs/vuetify/commit/f29354a79bda4eb8ac3a1db266a0102a3b64d451))
* **VSelect:** highlight newly selected item on keypress ([495ffaa](https://github.com/vuetifyjs/vuetify/commit/495ffaa2d5f451c5f3994cfd9cd042c07d6df61c)), closes [#6856](https://github.com/vuetifyjs/vuetify/issues/6856)
* **VSlider:** unfriendly UX behavior ([41df699](https://github.com/vuetifyjs/vuetify/commit/41df69901ec5a4bd59887026eb098956c2e64566))
* **VSpeedDial:** add check for componentOptions existing on slot ([#6905](https://github.com/vuetifyjs/vuetify/issues/6905)) ([58a8725](https://github.com/vuetifyjs/vuetify/commit/58a8725f69b0ae04c0b29da8b3a37c3ceb2e02a0)), closes [#6901](https://github.com/vuetifyjs/vuetify/issues/6901)
* **VTabs:** dark variant tab styles inactive opacity ([2eb6c96](https://github.com/vuetifyjs/vuetify/commit/2eb6c96dd04c9c8bf658341fbcebc51df3e01eb5))
* **VTextField:** fix color of prefix/suffix when disabled ([#7189](https://github.com/vuetifyjs/vuetify/issues/7189)) ([7bc4a08](https://github.com/vuetifyjs/vuetify/commit/7bc4a08b4a02aef326732601175c874332cfbae4))
* **VTextField:** prevent TypeError when color is an empty string ([#6982](https://github.com/vuetifyjs/vuetify/issues/6982)) ([fc6a66b](https://github.com/vuetifyjs/vuetify/commit/fc6a66bb4df21ed7157e14f27ee64e2d9a524e17)), closes [#6981](https://github.com/vuetifyjs/vuetify/issues/6981)
* **VTextField:** remove legend width when single-line ([5ccafef](https://github.com/vuetifyjs/vuetify/commit/5ccafefc183355e73428fe66bad19b2609f6cab0))
* **VTimePicker:** don't allow 0 hour/minute when it's not allowed ([c49ff47](https://github.com/vuetifyjs/vuetify/commit/c49ff47e60a5ad2b526dadc03cdff081aedeaae3))
* **VTimePickerClock:** fix sass indent ([#6907](https://github.com/vuetifyjs/vuetify/issues/6907)) ([f76b6f1](https://github.com/vuetifyjs/vuetify/commit/f76b6f1e974bed4d51b7c7fd2b975348251772db))
* **VToolbar:** fix **flat** prop not removing shadow ([e930399](https://github.com/vuetifyjs/vuetify/commit/e93039966aaaa1ebf8f75f9f7a68ac2fec3e8d8f))
* **VToolbar/VAppBar:** explicitly set line-height, adjust title padding ([136866f](https://github.com/vuetifyjs/vuetify/commit/136866f790a7b56c8e68a3ae0d73b10c01ae1b62))
* properly implement bootable logic/styles ([03de717](https://github.com/vuetifyjs/vuetify/commit/03de7176527ad0ea4d9b65f18658e7b897c39f1b))
* **VTreeView:** add height limitation on v-treeview-node__root ([#6894](https://github.com/vuetifyjs/vuetify/issues/6894)) ([563e3f4](https://github.com/vuetifyjs/vuetify/commit/563e3f4268887f4d9ddb001836ac0646e283f6ea))
* babel-transform-sass-paths ([#6876](https://github.com/vuetifyjs/vuetify/issues/6876)) ([68c28b7](https://github.com/vuetifyjs/vuetify/commit/68c28b7e1d23b02840538ee9b29b7615d0b0ce07))
* **_theme:** fix font family ([d5123e9](https://github.com/vuetifyjs/vuetify/commit/d5123e9ff028cbd6eebcc77a6e59b28f5eb421c6))
* **_variables:** remove conflicting sheet variable ([070ec41](https://github.com/vuetifyjs/vuetify/commit/070ec417f04c4c11b7ee0d8977e90c4317759f0b))
* **api:** updated api-generator mapping ([15e7829](https://github.com/vuetifyjs/vuetify/commit/15e7829d94df1273a1ff68209411fc92ccca1b99)), closes [#254](https://github.com/vuetifyjs/vuetify/issues/254)
* **colorable:** remove Boolean from color prop ([820f8a3](https://github.com/vuetifyjs/vuetify/commit/820f8a321fa8b8ad1c7d1a1ad8f954863671deae))
* **detachable:** check for non-scoped activator slot first ([4fe2d02](https://github.com/vuetifyjs/vuetify/commit/4fe2d0222eb15242c5168ec55a8784faa2bfbb2e))
* **detachable:** extract all elements from activator scoped slot ([3f9ad9b](https://github.com/vuetifyjs/vuetify/commit/3f9ad9bfffb7897a2ad57289bdeb4e76cdc7e824))
* **goTo:** allow standalone call ([#6324](https://github.com/vuetifyjs/vuetify/issues/6324)) ([012693a](https://github.com/vuetifyjs/vuetify/commit/012693ae143937e6395216e58ec7ec06de3660a6))
* **goTo:** avoid negative numbers creating a scrollLock ([f11e21c](https://github.com/vuetifyjs/vuetify/commit/f11e21cc151605f6cf206551b2e79e59d6a660ef))
* **kitchen:** add .vue extension to the edit path ([fbc9146](https://github.com/vuetifyjs/vuetify/commit/fbc9146c8e4b2caa5892028ae8affa3c122dd883))
* **kitchen:** don't display edit button on the home page ([693558f](https://github.com/vuetifyjs/vuetify/commit/693558fc4b8fe0b7b3561de02ae0041bf68adef0))
* **kitchen:** edit link should point to next instead of master ([#6214](https://github.com/vuetifyjs/vuetify/issues/6214)) ([7bed285](https://github.com/vuetifyjs/vuetify/commit/7bed28590de427e103c2a46f5b2de248054e3457))
* **kitchen:** move all FABs to right ([#6213](https://github.com/vuetifyjs/vuetify/issues/6213)) ([16de882](https://github.com/vuetifyjs/vuetify/commit/16de882e2882c47a117770d98e1d1c20df077eaa))
* **menuable:** positioning when overflowing viewport ([#6412](https://github.com/vuetifyjs/vuetify/issues/6412)) ([912380f](https://github.com/vuetifyjs/vuetify/commit/912380f5d3e1091e6083d49dce702539117dd4b7)), closes [#6294](https://github.com/vuetifyjs/vuetify/issues/6294)
* **overlayable:** make hide-overlay prop reactive ([#6347](https://github.com/vuetifyjs/vuetify/issues/6347)) ([71334ef](https://github.com/vuetifyjs/vuetify/commit/71334ef07d61a576d79fe3ea2cb45b270c225902)), closes [#6346](https://github.com/vuetifyjs/vuetify/issues/6346)
* **ripple:** make event listeners passive ([12c410e](https://github.com/vuetifyjs/vuetify/commit/12c410e0b603d45da141f996af42e1fb0fbba0d4)), closes [#6407](https://github.com/vuetifyjs/vuetify/issues/6407)
* **ripple:** retain ripple on hold, show on touchstart ([79d4504](https://github.com/vuetifyjs/vuetify/commit/79d45048036e89416e86f31c559abdc7a6a79feb)), closes [#6241](https://github.com/vuetifyjs/vuetify/issues/6241)
* **ripple:** show warning when bound to an inline element ([0099f14](https://github.com/vuetifyjs/vuetify/commit/0099f14a9f11c059a9d358b46ae05509824a35b9)), closes [#6245](https://github.com/vuetifyjs/vuetify/issues/6245)
* **v-ripple:** skip mouse events if triggered by touch ([#6445](https://github.com/vuetifyjs/vuetify/issues/6445)) ([34d265e](https://github.com/vuetifyjs/vuetify/commit/34d265ed57e7661f99522ea0507e2bc795ac4634)), closes [#6418](https://github.com/vuetifyjs/vuetify/issues/6418)
* **VAlert:** fix border with dense prop ([#6217](https://github.com/vuetifyjs/vuetify/issues/6217)) ([3a47ba9](https://github.com/vuetifyjs/vuetify/commit/3a47ba9b7fc112a1449236ca48f54576a337fa27))
* **VAlert:** fix border-radius bleedover ([231e753](https://github.com/vuetifyjs/vuetify/commit/231e753ed3d07e7645e2e2b92dd18bdd34ab6636))
* **validatable:** re-check validation after reset ([4cc8b8c](https://github.com/vuetifyjs/vuetify/commit/4cc8b8c4e1e4cfbac1751da132daa4a69311e0a1)), closes [#5877](https://github.com/vuetifyjs/vuetify/issues/5877)
* **validatable:** reset validation on resetValidation call ([3eddb56](https://github.com/vuetifyjs/vuetify/commit/3eddb56dc693f28fb2e0058b2c56fba992afa62c))
* **VAutocomplete:** may not show menu with hide-selected ([#6091](https://github.com/vuetifyjs/vuetify/issues/6091)) ([8799c48](https://github.com/vuetifyjs/vuetify/commit/8799c48f9939a4592c09f9b0ca780796cecc54a7)), closes [#4580](https://github.com/vuetifyjs/vuetify/issues/4580)
* **VAutocomplete:** remove search when tabbing out of input ([df1b11e](https://github.com/vuetifyjs/vuetify/commit/df1b11efe469a1a86b580b0a8ceff416730c57a9))
* **VAutocomplete:** retain search value on multi selection ([#6342](https://github.com/vuetifyjs/vuetify/issues/6342)) ([5a5a6e2](https://github.com/vuetifyjs/vuetify/commit/5a5a6e286a783921ba04b983142b1a60ee399230)), closes [#5926](https://github.com/vuetifyjs/vuetify/issues/5926)
* **VAutocomplete:** update dynamically when itemText is updated ([#6431](https://github.com/vuetifyjs/vuetify/issues/6431)) ([50f0264](https://github.com/vuetifyjs/vuetify/commit/50f0264bd8fb024ba95c54f0b1f3bf3d0345a140)), closes [#6368](https://github.com/vuetifyjs/vuetify/issues/6368) [#6368](https://github.com/vuetifyjs/vuetify/issues/6368)
* **VAutocomplete:** use toLocaleLowerCase when filtering items ([#6333](https://github.com/vuetifyjs/vuetify/issues/6333)) ([997c329](https://github.com/vuetifyjs/vuetify/commit/997c329224fbc51a3e5608e9fe1957d277828faf)), closes [#4811](https://github.com/vuetifyjs/vuetify/issues/4811)
* **vbtn:** remove style error ([62bfa77](https://github.com/vuetifyjs/vuetify/commit/62bfa772e5772474f8b6e2e40184e10bcf022913))
* **VBtn:** actually hook up real rounded prop ([470628a](https://github.com/vuetifyjs/vuetify/commit/470628a351cf3ac7a4c498f522fd549712456c70))
* **VBtn:** change content tag ([505179f](https://github.com/vuetifyjs/vuetify/commit/505179fdbd9d54515d59fdd7e816eebcafa2b145))
* **VBtn:** change min-height to height ([a57a298](https://github.com/vuetifyjs/vuetify/commit/a57a298692fcd87c8e4992b76f2e1c39a275882b))
* **VCard:** remove computedElevation usage ([cfcff04](https://github.com/vuetifyjs/vuetify/commit/cfcff04c1e1108952df9670753790c1a1a4ba77b)), closes [#6098](https://github.com/vuetifyjs/vuetify/issues/6098)
* **VCarousel:** prevent container recreation ([#5948](https://github.com/vuetifyjs/vuetify/issues/5948)) ([f9ca3ec](https://github.com/vuetifyjs/vuetify/commit/f9ca3ec7843913d44cb1b1eebf95a349ceedcfa0))
* **VCarouselItem:** auto change height ([#6340](https://github.com/vuetifyjs/vuetify/issues/6340)) ([c6f422b](https://github.com/vuetifyjs/vuetify/commit/c6f422b5e10be2de8a353409d8ba298824133ab6)), closes [#6337](https://github.com/vuetifyjs/vuetify/issues/6337)
* **VCheckbox:** add `for` attribute on checkbox's related label ([#6179](https://github.com/vuetifyjs/vuetify/issues/6179)) ([86077df](https://github.com/vuetifyjs/vuetify/commit/86077df9960bf1a181854d153b8ce32be462f4ad)), closes [#6178](https://github.com/vuetifyjs/vuetify/issues/6178) [#6178](https://github.com/vuetifyjs/vuetify/issues/6178)
* **VChip:** Removes transparent border ([#5956](https://github.com/vuetifyjs/vuetify/issues/5956)) ([88c7b35](https://github.com/vuetifyjs/vuetify/commit/88c7b35ed10e4a96cf5e432682a0e91995d26bb4)), closes [#5619](https://github.com/vuetifyjs/vuetify/issues/5619)
* **VDatePicker:** fixed disabled styles ([1f66831](https://github.com/vuetifyjs/vuetify/commit/1f668314d9d4b6c9525e7e13a7199928757c77fb))
* **VDatePicker:** incorrect behaviour with year < 1000 ([0558fb7](https://github.com/vuetifyjs/vuetify/commit/0558fb7718c5c8c671535684fb8c9244a0516edc)), closes [#6298](https://github.com/vuetifyjs/vuetify/issues/6298)
* **VDatePicker:** unwanted form submission on header click. ([#6350](https://github.com/vuetifyjs/vuetify/issues/6350)) ([9ad76b6](https://github.com/vuetifyjs/vuetify/commit/9ad76b6505efa7fba2df21cb1188baa1b48cb5b7))
* **VDatePicker:** updated button classes ([cb3bbcf](https://github.com/vuetifyjs/vuetify/commit/cb3bbcfface901b7e0b4b9dbf37aeed1a3954caa))
* **VDialog:** allow the use of scrollable with forms ([f90c8b9](https://github.com/vuetifyjs/vuetify/commit/f90c8b9b5abcc945bf266d7421499eb579ab7dc6)), closes [#3713](https://github.com/vuetifyjs/vuetify/issues/3713)
* **VDialog:** make scroll listener non-passive ([3c9b8b6](https://github.com/vuetifyjs/vuetify/commit/3c9b8b6b5588644e0f81e9b28f2b283a99d022a3)), closes [#6263](https://github.com/vuetifyjs/vuetify/issues/6263)
* **VDialog:** prevent scrollable card from overflowing horizontally ([b0dfdc4](https://github.com/vuetifyjs/vuetify/commit/b0dfdc4c2a5321fb2ca4ab61b039bdfa2ac71d11)), closes [#6420](https://github.com/vuetifyjs/vuetify/issues/6420)
* **VDialog:** properly check for activator scopedSlot ([2acf2ff](https://github.com/vuetifyjs/vuetify/commit/2acf2ff6c17cf28762cc16b8c267a72a9cda09a6)), closes [#6115](https://github.com/vuetifyjs/vuetify/issues/6115)
* **VDialog,VMenu,VTooltip:** work around vue 2.6.2 $slots change ([82a9b67](https://github.com/vuetifyjs/vuetify/commit/82a9b677c4789ea6f00c337d6fe838a81b6521a5)), closes [vuejs/vue#9421](https://github.com/vuejs/vue/issues/9421)
* **VExpandTransition:** reflow DOM before closing ([5d8b0df](https://github.com/vuetifyjs/vuetify/commit/5d8b0dfc798a532c0f5e366bf681a50403b225c5)), closes [#6049](https://github.com/vuetifyjs/vuetify/issues/6049) [#6102](https://github.com/vuetifyjs/vuetify/issues/6102)
* **VExpansionPanel:** fix lazy animation ([#6222](https://github.com/vuetifyjs/vuetify/issues/6222)) ([d3bcdb1](https://github.com/vuetifyjs/vuetify/commit/d3bcdb1a44e167c0258795182c370d33393a0627))
* **VExpansionPanel:** fix lazy entry animation ([d3937e0](https://github.com/vuetifyjs/vuetify/commit/d3937e05228474844d764c55ef6c23ca0a58dfb1)), closes [#6190](https://github.com/vuetifyjs/vuetify/issues/6190)
* **VFooter:** center content when v-navigation-drawer exists on the right ([#5911](https://github.com/vuetifyjs/vuetify/issues/5911)) ([7e289cc](https://github.com/vuetifyjs/vuetify/commit/7e289cc30c96796a7c2ba8822d2551c29853fb97))
* **VHover:** exception in events binding ([#6335](https://github.com/vuetifyjs/vuetify/issues/6335)) ([79bf76e](https://github.com/vuetifyjs/vuetify/commit/79bf76eafa33e6bb909e21b6326fe1133eba74f1))
* **VHover, VItem:** check for scoped slot array length with vue 2.6 ([9856ed6](https://github.com/vuetifyjs/vuetify/commit/9856ed69bab846bf5fae2d9fe1f412ad58c68c92))
* **VIcon:** trim whitespace in icon name ([#6408](https://github.com/vuetifyjs/vuetify/issues/6408)) ([dc9547b](https://github.com/vuetifyjs/vuetify/commit/dc9547b608cb6658c5ad1798e5280e3d6a0b9635)), closes [#6404](https://github.com/vuetifyjs/vuetify/issues/6404)
* **VLabel:** merge VNode data ([9b6de46](https://github.com/vuetifyjs/vuetify/commit/9b6de466828684720fa067db07d301b4bb726c56)), closes [#6245](https://github.com/vuetifyjs/vuetify/issues/6245)
* **VMenu:** don't close on tab if child element has focus ([#5716](https://github.com/vuetifyjs/vuetify/issues/5716)) ([ad182c2](https://github.com/vuetifyjs/vuetify/commit/ad182c267db245c36ff40acd8ac87c3233387667)), closes [#5103](https://github.com/vuetifyjs/vuetify/issues/5103)
* **VMenu:** don't prevent default on keydown unless action taken ([#6339](https://github.com/vuetifyjs/vuetify/issues/6339)) ([cf2ba83](https://github.com/vuetifyjs/vuetify/commit/cf2ba83d66755e52d22b3ea4a9ba68ab495572d2)), closes [#2988](https://github.com/vuetifyjs/vuetify/issues/2988)
* **VMenu:** improve position when using offset, width and attach props ([#6193](https://github.com/vuetifyjs/vuetify/issues/6193)) ([bfad3d8](https://github.com/vuetifyjs/vuetify/commit/bfad3d8fe146cb7f6b16840f8816f48cac4ddd42)), closes [#5498](https://github.com/vuetifyjs/vuetify/issues/5498)
* **VMenu:** initial computation of NaN ([7093d3d](https://github.com/vuetifyjs/vuetify/commit/7093d3d6068b51cf021672f2e260df88fd0441df))
* **VMenu:** prevent scroll on keydown ([#5872](https://github.com/vuetifyjs/vuetify/issues/5872)) ([cfe48d7](https://github.com/vuetifyjs/vuetify/commit/cfe48d7a8a9be48186a71c55c777540f6e6194cb)), closes [#5714](https://github.com/vuetifyjs/vuetify/issues/5714)
* **VMenu:** show menu if value isActive on mount ([094a85e](https://github.com/vuetifyjs/vuetify/commit/094a85e4a0a2bac1f706620fd74052f4efe25d70)), closes [#6034](https://github.com/vuetifyjs/vuetify/issues/6034)
* **VMenu:** update position dynamically ([#6330](https://github.com/vuetifyjs/vuetify/issues/6330)) ([349e2b1](https://github.com/vuetifyjs/vuetify/commit/349e2b1924db6abce51741f57cbd6234db88bbb9)), closes [#4956](https://github.com/vuetifyjs/vuetify/issues/4956)
* **VNavigationDrawer:** remove max-height style when undefined ([7e310db](https://github.com/vuetifyjs/vuetify/commit/7e310db858721d00676630d4441da964742d737c))
* **VRadio:** fix `focus` event ([#5905](https://github.com/vuetifyjs/vuetify/issues/5905)) ([ea30e13](https://github.com/vuetifyjs/vuetify/commit/ea30e1361b1444af9bc43085febf1f2e0c39db4d))
* **VSelect:** don't emit change event when clicked on the selected item  ([#6054](https://github.com/vuetifyjs/vuetify/issues/6054)) ([a032214](https://github.com/vuetifyjs/vuetify/commit/a032214406176b4534cbdff946cd09bcaffd0675))
* **VSelect:** don't render a list tile if provided by item slot ([e19189c](https://github.com/vuetifyjs/vuetify/commit/e19189c4e7c237835599f35ab485a4bb33c02904)), closes [#6376](https://github.com/vuetifyjs/vuetify/issues/6376)
* **VSelect:** emit change after input event ([d7b8288](https://github.com/vuetifyjs/vuetify/commit/d7b82889c31f7695e73a9e0ba321ed9138f885ab)), closes [#6136](https://github.com/vuetifyjs/vuetify/issues/6136)
* **VSelect:** remove tabindex on chips ([f19a207](https://github.com/vuetifyjs/vuetify/commit/f19a2071d69c1cf3669d447e3e0d12282426d94a))
* **VSheet:** add missing transition ([6d782bb](https://github.com/vuetifyjs/vuetify/commit/6d782bb7b5cebef86bc43ed0451440446405b8f6))
* **VSparkline:** fix bar type ([#6370](https://github.com/vuetifyjs/vuetify/issues/6370)) ([fe03a7a](https://github.com/vuetifyjs/vuetify/commit/fe03a7a57da7b0262613f51950fe5ed546728b74))
* **VTextField:** correct styles with **full-width** prop ([9d964b3](https://github.com/vuetifyjs/vuetify/commit/9d964b385a0e5f292671328dd40520ccd0c82764)), closes [#4544](https://github.com/vuetifyjs/vuetify/issues/4544)
* **VTimePicker:** emit change event after clicking minutes/seconds ([#6079](https://github.com/vuetifyjs/vuetify/issues/6079)) ([e9c9b58](https://github.com/vuetifyjs/vuetify/commit/e9c9b584372c7c25eac0a3a52dbc3d699483f90b)), closes [#5951](https://github.com/vuetifyjs/vuetify/issues/5951)
* **VTimePicker:** remove unnecessary mixins prop ([fab2488](https://github.com/vuetifyjs/vuetify/commit/fab24887c14fd1813fd8f30b372640dd5a118d01))
* **VTooltip:** Update tooltip position dynamically ([#5967](https://github.com/vuetifyjs/vuetify/issues/5967)) ([84e5807](https://github.com/vuetifyjs/vuetify/commit/84e580775a63b5c619e8d02708700b50484ec85a)), closes [#4396](https://github.com/vuetifyjs/vuetify/issues/4396)
* **VTreeview:** correcly handle updating items array of equal size ([#6202](https://github.com/vuetifyjs/vuetify/issues/6202)) ([4177931](https://github.com/vuetifyjs/vuetify/commit/41779317121c30e6d386cccc098af02b055c79ce)), closes [#6181](https://github.com/vuetifyjs/vuetify/issues/6181)
* lint comments ([db99b47](https://github.com/vuetifyjs/vuetify/commit/db99b470ac6eb339c50695b027b213affc0ce814))
* **Btn:** add `v-tab` link functionality to `v-btn` ([0f041ec](https://github.com/vuetifyjs/vuetify/commit/0f041ec6749ed61b478f7e0f5dc027d681badffa)), closes [#5537](https://github.com/vuetifyjs/vuetify/issues/5537)
* **build:** update webpack config for hoisting ([f798f93](https://github.com/vuetifyjs/vuetify/commit/f798f93d8afcf457fb29e61a8ee0c2ca39d86e16))
* **Carousel:** deprecate input event ([a3348e8](https://github.com/vuetifyjs/vuetify/commit/a3348e85380b83ae099c78836443367937e8c6c2)), closes [#5561](https://github.com/vuetifyjs/vuetify/issues/5561)
* **DataTable:** correctly center the selection controls ([#5542](https://github.com/vuetifyjs/vuetify/issues/5542)) ([5b6b76a](https://github.com/vuetifyjs/vuetify/commit/5b6b76a0aef12480fd217fe271dbfa691d682bfe))
* **DataTable:** support nested values for item key ([#5241](https://github.com/vuetifyjs/vuetify/issues/5241)) ([0de73ea](https://github.com/vuetifyjs/vuetify/commit/0de73eaecf2d34ea0f92d04883c25bdb9e76e40c))
* **Dialog:** add/remove overlay and scroll when fullscreen is changed ([#5707](https://github.com/vuetifyjs/vuetify/issues/5707)) ([76db39d](https://github.com/vuetifyjs/vuetify/commit/76db39d6e0937888df8b67db351b0a3934a1f2b4)), closes [#2201](https://github.com/vuetifyjs/vuetify/issues/2201)
* **expand-transition:** remove delay, prevent layout jump when toggling ([a967ef7](https://github.com/vuetifyjs/vuetify/commit/a967ef7e7a765ab96c6d7d936fe01f337a541243))
* **expand-transition:** use a proper FLIP animation w/ offsetHeight ([#5709](https://github.com/vuetifyjs/vuetify/issues/5709)) ([cb605ac](https://github.com/vuetifyjs/vuetify/commit/cb605ac9d73f8f585e0a23591b4d54241950101e)), closes [#5607](https://github.com/vuetifyjs/vuetify/issues/5607)
* **ListTile:** remove duplicate event listeners ([62362c5](https://github.com/vuetifyjs/vuetify/commit/62362c5752167513939f4e9745169ab3dddebc38)), closes [#5383](https://github.com/vuetifyjs/vuetify/issues/5383)
* **Progress:** parse values as floats instead of ints ([454476c](https://github.com/vuetifyjs/vuetify/commit/454476c834eda268191bae876eb14c24f06bbc61)), closes [#5591](https://github.com/vuetifyjs/vuetify/issues/5591)
* **ProgressLinear:** use valid transition function ([f587f7c](https://github.com/vuetifyjs/vuetify/commit/f587f7c64813e7ce75da090ac13bb9fa336b2b71)), closes [#3678](https://github.com/vuetifyjs/vuetify/issues/3678)
* **ripple:** avoid reading back el.style.width ([1058210](https://github.com/vuetifyjs/vuetify/commit/10582102088a65756bb4313ff51bf5d88d6a1114)), closes [#5340](https://github.com/vuetifyjs/vuetify/issues/5340)
* **Select:** add scopeId to VSelectList ([#5574](https://github.com/vuetifyjs/vuetify/issues/5574)) ([49c1e6a](https://github.com/vuetifyjs/vuetify/commit/49c1e6af4d32d781c79b712b7bfce3aa30ab9d60)), closes [#5568](https://github.com/vuetifyjs/vuetify/issues/5568)
* **Select:** remove colon from menu-props suggestion with booleans only ([9cc06fd](https://github.com/vuetifyjs/vuetify/commit/9cc06fda0c641fefc4e7beabadcad76aec18c707))
* **selection-controls:** use ripple even when disabled ([#5710](https://github.com/vuetifyjs/vuetify/issues/5710)) ([2150554](https://github.com/vuetifyjs/vuetify/commit/215055423b9da1ecbe530b5464b4f770c9a2375b)), closes [#5653](https://github.com/vuetifyjs/vuetify/issues/5653)
* **SelectionControls:** increased css specificity for margin ([31f12b9](https://github.com/vuetifyjs/vuetify/commit/31f12b9b58c1cd5a0c367457e4741c8840ab0faf)), closes [#5404](https://github.com/vuetifyjs/vuetify/issues/5404)
* **Spacing:** add missing !important declaration ([862d593](https://github.com/vuetifyjs/vuetify/commit/862d5936c440f8579663b0e2fbbf621e3718a576))
* **TextField:** use correct color for prefix in disabled ([#5648](https://github.com/vuetifyjs/vuetify/issues/5648)) ([13814bd](https://github.com/vuetifyjs/vuetify/commit/13814bdd5cb0eee3142f715fe11b853948030dcd)), closes [#5481](https://github.com/vuetifyjs/vuetify/issues/5481)
* **Treeview:** empty children expand icon ([#5442](https://github.com/vuetifyjs/vuetify/issues/5442)) ([c636f6c](https://github.com/vuetifyjs/vuetify/commit/c636f6cc1b9fba82e1686f5e52e96a5e8e083305)), closes [#5357](https://github.com/vuetifyjs/vuetify/issues/5357)
* **v-expansion-panel:** remove entry animation ([97053db](https://github.com/vuetifyjs/vuetify/commit/97053db366b0c120a1e216f004ae8b8e19100a75)), closes [#4483](https://github.com/vuetifyjs/vuetify/issues/4483)
* **v-menu:** position problem with horizontal scrolling ([#5527](https://github.com/vuetifyjs/vuetify/issues/5527)) ([4acd24d](https://github.com/vuetifyjs/vuetify/commit/4acd24d17b3adea6d4b5406260aee2569bc51d6c))
* **Validatable:** remove validation when readonly or disabled ([945ab47](https://github.com/vuetifyjs/vuetify/commit/945ab473c4f96c8712990212881d3f9c9201b0a5)), closes [#5362](https://github.com/vuetifyjs/vuetify/issues/5362)
* **VAutocomplete:** inherit pointer-events ([592d4c9](https://github.com/vuetifyjs/vuetify/commit/592d4c96b0fdc489b1c65707bc82a570afac56a5)), closes [#5615](https://github.com/vuetifyjs/vuetify/issues/5615)
* **VButton:** removed background from diabled outline btn ([31cfae6](https://github.com/vuetifyjs/vuetify/commit/31cfae6167977a95e4c43a27f25f392bc88f51df))
* **VChip:** avatar size in small chips ([eefc276](https://github.com/vuetifyjs/vuetify/commit/eefc2768742507f95abc6050f96e761e0f6e9cb1)), closes [#3225](https://github.com/vuetifyjs/vuetify/issues/3225)
* **VExpansionPanel:** pass boolean value to toggle method ([ebc5aaf](https://github.com/vuetifyjs/vuetify/commit/ebc5aafeec27d3a299b2912168b47bda425fe380)), closes [#5703](https://github.com/vuetifyjs/vuetify/issues/5703)
* **VMenu:** auto positioning with dense prop ([#5448](https://github.com/vuetifyjs/vuetify/issues/5448)) ([6f75590](https://github.com/vuetifyjs/vuetify/commit/6f755909119c899a57569c8afb42735d2d2ae53d)), closes [#5149](https://github.com/vuetifyjs/vuetify/issues/5149)
* **VSelect:** don't handle mouseup if there was no mousedown ([e984bf3](https://github.com/vuetifyjs/vuetify/commit/e984bf33533010e563a4acd567d9cea0c8842074)), closes [#5665](https://github.com/vuetifyjs/vuetify/issues/5665)
* re-emit click events ([390d289](https://github.com/vuetifyjs/vuetify/commit/390d2897e6147b78fdaebb4155e1b81439800a5f)), closes [#2477](https://github.com/vuetifyjs/vuetify/issues/2477)
* **DataIterator:** bug when given items smaller than current items ([#5440](https://github.com/vuetifyjs/vuetify/issues/5440)) ([c9b52d1](https://github.com/vuetifyjs/vuetify/commit/c9b52d156f8ef4beb1f6227df59dbcbe3e8ae661)), closes [#5426](https://github.com/vuetifyjs/vuetify/issues/5426)
* **Dialog:** fix IE11 issue with nested flexbox on scrollable dialog ([dfcedde](https://github.com/vuetifyjs/vuetify/commit/dfcedde9bc3861d29555508a45023cc5143943cf))
* **kitchen:** fix some issues with VBtn pan ([3257648](https://github.com/vuetifyjs/vuetify/commit/32576480bb3715f78d8427974eeed275ece86d30))
* **kitchen:** fix VImg pan name ([b6f5fee](https://github.com/vuetifyjs/vuetify/commit/b6f5fee4af56fecef647fefc236446910867d10e))
* **kitchen:** seperate alert v-models ([e6978ef](https://github.com/vuetifyjs/vuetify/commit/e6978ef3564dfc7f5219adca3b8baa5f08393c73))
* **menuable:** set correct position with left+attach+offset-x ([f561ca2](https://github.com/vuetifyjs/vuetify/commit/f561ca2c13748211905bc2af8ec5805d13929df8)), closes [#5318](https://github.com/vuetifyjs/vuetify/issues/5318)
* **ripple:** fix in transition ([46da381](https://github.com/vuetifyjs/vuetify/commit/46da381bb048b9a1848f7875373868cfb03b5bcf))
* **scss:** fixed build error ([dfedf80](https://github.com/vuetifyjs/vuetify/commit/dfedf8093fcf7ce30b055cb0a7c949fa0d74e361))
* **snackbar:** add rtl to snackbar ([#6013](https://github.com/vuetifyjs/vuetify/issues/6013)) ([4f18a8c](https://github.com/vuetifyjs/vuetify/commit/4f18a8c03fb17df7611bb3b11939c7dec5448edb))
* **snackbar:** fixed deleted rtl style [#6013](https://github.com/vuetifyjs/vuetify/issues/6013) ([24c47f4](https://github.com/vuetifyjs/vuetify/commit/24c47f4de83a24680749199779d052e4ffba435c))
* **SponsorBtn:** update to prop value ([e070107](https://github.com/vuetifyjs/vuetify/commit/e07010745e65f87dade43e5b4078671eea839ed7))
* **text-field:** text-field's label overlap with long prefix. ([a438ccd](https://github.com/vuetifyjs/vuetify/commit/a438ccde106ba198bee1c4f46e9288adee8b419a)), closes [#3485](https://github.com/vuetifyjs/vuetify/issues/3485)
* **theme:** make theme work properly ([7238812](https://github.com/vuetifyjs/vuetify/commit/7238812996cfe23c4689068d8e5de57eefcce9e3))
* **v-tabs:** fix slider entry time ([50dd6a4](https://github.com/vuetifyjs/vuetify/commit/50dd6a4a525d392c1a44c4df8f96b8963fc6c898)), closes [#5371](https://github.com/vuetifyjs/vuetify/issues/5371) [#5371](https://github.com/vuetifyjs/vuetify/issues/5371)
* **validatable:** update external messages to accept null value ([eef7d4f](https://github.com/vuetifyjs/vuetify/commit/eef7d4f7bba55fb91080fda448df38bac4b761e7)), closes [#6025](https://github.com/vuetifyjs/vuetify/issues/6025)
* **VBtn:** add block display property ([87f6b09](https://github.com/vuetifyjs/vuetify/commit/87f6b09e797673acd223d4de81c773374d9fcc1e))
* **VBtn:** add elevation functionality, fix unit tests ([6861a5f](https://github.com/vuetifyjs/vuetify/commit/6861a5f5b7a721ba166df93cc6aae94f9b6b16c7))
* **VBtn:** apply correct color to text ([262d691](https://github.com/vuetifyjs/vuetify/commit/262d6917474da095488cb89dbc1d81480a576d67))
* **VBtn:** enable parent activeClass if present ([433ca20](https://github.com/vuetifyjs/vuetify/commit/433ca20f6076dac15446c49ff673c6ba6edae25d))
* **VBtn:** outline color should be [#0000001](https://github.com/vuetifyjs/vuetify/issues/0000001)e ([01eba83](https://github.com/vuetifyjs/vuetify/commit/01eba832fdc993fa82b84e11f3c4b7f782af8ae9))
* **VBtn:** remove background-color style from depressed btn ([7828e1d](https://github.com/vuetifyjs/vuetify/commit/7828e1d6bbfafbeed629f282fa1ee340b4fcde7a))
* **VBtn:** remove contained if user provides elevation ([b2e5c82](https://github.com/vuetifyjs/vuetify/commit/b2e5c8288ab1ba921642a48e1d7ddcbcbed42cfe))
* **VBtn:** remove shadow from disabled btn ([c569a83](https://github.com/vuetifyjs/vuetify/commit/c569a83ce3a9fa92003e6bf9d43f4798fd601d1b))
* **VChip:** dark mode ([#5449](https://github.com/vuetifyjs/vuetify/issues/5449)) ([3e9673e](https://github.com/vuetifyjs/vuetify/commit/3e9673eea03cf0225877dfa1a8987c09bfd221c9)), closes [#5074](https://github.com/vuetifyjs/vuetify/issues/5074)
* **VEditDialog:** use text VBtn style instead of deprecated flat style ([f41bf38](https://github.com/vuetifyjs/vuetify/commit/f41bf38d1e13599d823525547b41596b9c78b268))
* **VList:** hide input messages only when in .v-list__tile__action ([#5578](https://github.com/vuetifyjs/vuetify/issues/5578)) ([78e76ff](https://github.com/vuetifyjs/vuetify/commit/78e76ff424f328f8aa468deaf4f5590704ebdd04)), closes [#5553](https://github.com/vuetifyjs/vuetify/issues/5553)
* **VList:** rtl ([#5464](https://github.com/vuetifyjs/vuetify/issues/5464)) ([f5aeb00](https://github.com/vuetifyjs/vuetify/commit/f5aeb0088f09574d2e082a2d7b3722a8362c276b)), closes [#4606](https://github.com/vuetifyjs/vuetify/issues/4606)
* **VListGroup:** text overflow ([#5451](https://github.com/vuetifyjs/vuetify/issues/5451)) ([8bd9ce1](https://github.com/vuetifyjs/vuetify/commit/8bd9ce152515997bb4f475b4af11a04a820e959d)), closes [#3038](https://github.com/vuetifyjs/vuetify/issues/3038)
* **VOverflowBtn:** apply correct cursor ([#5943](https://github.com/vuetifyjs/vuetify/issues/5943)) ([6cf3287](https://github.com/vuetifyjs/vuetify/commit/6cf328753dbcbbf193f50a73b3302993c7cc36a6))
* **VOverflowBtn:** remove top padding to fix alignment ([86290be](https://github.com/vuetifyjs/vuetify/commit/86290bec6864a279885ef26c673a5b3128395af4))
* **VPicker:** landscape layout bug ([e180e9e](https://github.com/vuetifyjs/vuetify/commit/e180e9e85fdb442abff769e481cd8c96ec900193))
* **VRadioGroup:** main label spacing ([#5463](https://github.com/vuetifyjs/vuetify/issues/5463)) ([ab03b4d](https://github.com/vuetifyjs/vuetify/commit/ab03b4d0601f9193ac6aeb666b9849601e77475d)), closes [#5455](https://github.com/vuetifyjs/vuetify/issues/5455)
* **VSelect:** dont open menu on keydown when readonly ([#5450](https://github.com/vuetifyjs/vuetify/issues/5450)) ([773f119](https://github.com/vuetifyjs/vuetify/commit/773f119cba2392edf1da854dd972b296bd9c3e47)), closes [#5005](https://github.com/vuetifyjs/vuetify/issues/5005)
* **VSelect:** fix rendering without attrs ([#5973](https://github.com/vuetifyjs/vuetify/issues/5973)) ([a55ff28](https://github.com/vuetifyjs/vuetify/commit/a55ff28ded0699bfb4066b4b358f1f29e0f39548))
* **VSelect:** stop keydown.esc propagation ([#5579](https://github.com/vuetifyjs/vuetify/issues/5579)) ([6657fe7](https://github.com/vuetifyjs/vuetify/commit/6657fe78a34dc5e358d371fdef25f4654dd513c2)), closes [#5560](https://github.com/vuetifyjs/vuetify/issues/5560)
* **VTextField:** outline border color in error state ([#5447](https://github.com/vuetifyjs/vuetify/issues/5447)) ([02b9e79](https://github.com/vuetifyjs/vuetify/commit/02b9e7972104129bbc3f26ddea4e879f43d8ea7a)), closes [#5274](https://github.com/vuetifyjs/vuetify/issues/5274)
* **VTextField:** use available space for active label ([#5577](https://github.com/vuetifyjs/vuetify/issues/5577)) ([161222c](https://github.com/vuetifyjs/vuetify/commit/161222cc2b3bedec18e64b1223116d0bc8c03c30)), closes [#5555](https://github.com/vuetifyjs/vuetify/issues/5555)
* **VTreeview:** arrow direction in rtl ([#5535](https://github.com/vuetifyjs/vuetify/issues/5535)) ([e65ed5b](https://github.com/vuetifyjs/vuetify/commit/e65ed5b923ef2ea4374403fdf2a5d5cf4d7c9bd8)), closes [#5534](https://github.com/vuetifyjs/vuetify/issues/5534)
* added comment to generated file ([795babc](https://github.com/vuetifyjs/vuetify/commit/795babc6edd91d6a7d611903fe702b18505ba381))
* added grid component props to map ([202b7b7](https://github.com/vuetifyjs/vuetify/commit/202b7b7dea2d9f60c62678c5ad499ad41b351e2c))
* added missing mdi icons for codepen ([09243df](https://github.com/vuetifyjs/vuetify/commit/09243df9527f3783c6e66000f0b18351e1be5376)), closes [#655](https://github.com/vuetifyjs/vuetify/issues/655)
* added speed-dial slots to map ([dc77902](https://github.com/vuetifyjs/vuetify/commit/dc77902cdc09eec9429948b33368ba8d1d00e49f))
* added v-text-field label slot ([b8db800](https://github.com/vuetifyjs/vuetify/commit/b8db800814d575b55f2f5e6ab7c8026790994fff))
* bind empty object to prop default function ([9a1756f](https://github.com/vuetifyjs/vuetify/commit/9a1756feb6fdcb3b9f1cc211cd64f6bdd829ea8e))
* fix bootable transition ([9a7be1f](https://github.com/vuetifyjs/vuetify/commit/9a7be1f164dacded2b98f57808ee003be4de761e))
* make tests pass ([9b2dce8](https://github.com/vuetifyjs/vuetify/commit/9b2dce82e3e5421411244243bd175abe8792905d))
* **a-la-carte:** fix section id ([1a73ed4](https://github.com/vuetifyjs/vuetify/commit/1a73ed422c4073cc104eb93f31cf4500e60d76e8)), closes [#518](https://github.com/vuetifyjs/vuetify/issues/518)
* **ads:** change dom position ([a5c881c](https://github.com/vuetifyjs/vuetify/commit/a5c881c51267b899ae8ae8c8c59715d766963ad1))
* **ads:** hide on home page ([04b870c](https://github.com/vuetifyjs/vuetify/commit/04b870c8b1f6d820c6fec669131ff8ab520dff11))
* **analytics:** fix double collect on page load ([c24a42d](https://github.com/vuetifyjs/vuetify/commit/c24a42d2e2f0740224156c075d6d82d614ef549d))
* **api-explorer:** fix 500 ([4fab45f](https://github.com/vuetifyjs/vuetify/commit/4fab45f843661c8b35065b132f6873975377605e))
* **backers:** fix backers ([ef787e6](https://github.com/vuetifyjs/vuetify/commit/ef787e6d5a9f2c5c416a394837e495273fdcc2b1))
* **Btn:** avoid setting bg with disabled and color prop ([#5734](https://github.com/vuetifyjs/vuetify/issues/5734)) ([069558a](https://github.com/vuetifyjs/vuetify/commit/069558a00a573d0ce46bdaee834f533e096501ec)), closes [#5720](https://github.com/vuetifyjs/vuetify/issues/5720)
* **carousel-model:** fix default type ([8b04e37](https://github.com/vuetifyjs/vuetify/commit/8b04e37ddecd675d3bc3106b5a24256712f7968d))
* **checkout:** fix ability to checkout ([925ccea](https://github.com/vuetifyjs/vuetify/commit/925ccea3fe910ad0eddca630f3215ebb0486004d))
* **components:** fixed doc-subtitle and helpers-markdown ([4588750](https://github.com/vuetifyjs/vuetify/commit/45887509b0ac9baf756f1d33ce44071efe79c60a))
* **components.json:** added missing `v-btn-toggle` ([6e11b48](https://github.com/vuetifyjs/vuetify/commit/6e11b4885fa170e35135d8ade1ee6ce4b552e000))
* **example:** fix expand code ([b7c8989](https://github.com/vuetifyjs/vuetify/commit/b7c8989efc361ecab367dd454f68c4fffb593590))
* **Example:** make source expansion panel lazy ([28cac3f](https://github.com/vuetifyjs/vuetify/commit/28cac3f64f68d08dd6355c169180c9662ceedad1))
* **ExampleView:** hide current tab if selected component has no api ([a3533e7](https://github.com/vuetifyjs/vuetify/commit/a3533e7fdd167d7d5e9690eaa3ae60e25ebc7ffc))
* remove pug string literal ([f9b90ff](https://github.com/vuetifyjs/vuetify/commit/f9b90ffddd3c93e45ef593a1c4391f84fff7ee0f))
* **examples:** place other code above component instance ([6106920](https://github.com/vuetifyjs/vuetify/commit/610692081ca160825dc1103c4a645e687580adad))
* **examples:** remove drawer transition in image ratio example ([7b73149](https://github.com/vuetifyjs/vuetify/commit/7b73149ba5495271c64091d9632c400f50ed5bfa))
* **expand-transition:** reset initial state when cancelled ([a039846](https://github.com/vuetifyjs/vuetify/commit/a0398467479c094a0faa35d549082f4a4246e381))
* **faq:** markup ([2b7603d](https://github.com/vuetifyjs/vuetify/commit/2b7603d10df40a1b56e12270572e9fae06cb1fbf))
* **footer-alt:** fix mobile display ([462e510](https://github.com/vuetifyjs/vuetify/commit/462e510c385f43fe146d2686ee8b9bd4f99e7ed5))
* **forms:** simplify regexp ([a56be72](https://github.com/vuetifyjs/vuetify/commit/a56be72c549798594aaa6a87b67381e72f3ca7ec)), closes [#512](https://github.com/vuetifyjs/vuetify/issues/512)
* **kbd:** fix `kbd` background color ([#5864](https://github.com/vuetifyjs/vuetify/issues/5864)) ([28f61b5](https://github.com/vuetifyjs/vuetify/commit/28f61b51586fd0a940f392d73ee5c56c07d1720a))
* **manifest:** icon pathing in manifest ([4738ca0](https://github.com/vuetifyjs/vuetify/commit/4738ca00e92eda13c3eb9d8880fc6cfd61332835))
* **markup:** icon font colour and highlighting in examples ([a3ac135](https://github.com/vuetifyjs/vuetify/commit/a3ac1351d4910a850e498ca0ed5f71a22a422f9e))
* **menuable:** account for top+left ([50ab611](https://github.com/vuetifyjs/vuetify/commit/50ab6111b3c5f17c270c43be435e8f6c76033bec)), closes [#5318](https://github.com/vuetifyjs/vuetify/issues/5318)
* **meta:** fix facebook meta tags ([b4da0c8](https://github.com/vuetifyjs/vuetify/commit/b4da0c87f3a0fbf592d00842f10389cf6c1a2831))
* **store-toolbar:** adjust height ([b781993](https://github.com/vuetifyjs/vuetify/commit/b78199342bf0961f9390aa72f8cfc68408a1646b))
* **text-fields:** update example ([2584cae](https://github.com/vuetifyjs/vuetify/commit/2584cae866856c79652b1989e56df43268045201))
* **transitions-page:** fix example display ([b2550e9](https://github.com/vuetifyjs/vuetify/commit/b2550e9e6f2cf802d6584032dbdcfc21838c97b6))
* **translatable:** fix 500 on build ([6a010b8](https://github.com/vuetifyjs/vuetify/commit/6a010b88f7afa4f288215deb5da787dfe42b95e2))
* **translations:** rename component ([82b2483](https://github.com/vuetifyjs/vuetify/commit/82b2483f2e4d32ce94bc2ca4934253fa774d8f3e))
* **v-tabs:** update structure ([b04db2c](https://github.com/vuetifyjs/vuetify/commit/b04db2cacb35b181a5420f40b0136960b2383dcf))
* **v-textarea:** fix example ([4c69670](https://github.com/vuetifyjs/vuetify/commit/4c69670b1a1ec58a24bc724e1037e930ed290deb))
* **v-treeview:** add missing headerText ([36578ff](https://github.com/vuetifyjs/vuetify/commit/36578ff265222dfb3a1f2adfa9b1b40d9c9a9998))
* **VImg:** add link to vuetify-loader ([2a417ba](https://github.com/vuetifyjs/vuetify/commit/2a417bab0e536ceb63dbc632f83f531f3ee25dc3))
* broken cdn url ([de3425e](https://github.com/vuetifyjs/vuetify/commit/de3425eaa6fffefe84ced9877e75fe3934c94684))
* Change home image to load from cdn ([#562](https://github.com/vuetifyjs/vuetify/issues/562)) ([3fdfc35](https://github.com/vuetifyjs/vuetify/commit/3fdfc3598cbd50d1881e461e0010f9b9d7ff2314))
* extend wrapped components to correctly resolve options ([2b3405e](https://github.com/vuetifyjs/vuetify/commit/2b3405ea7112388eb1c1a4002ab8fee4afbf4a81))
* font weight on themes and quick start page ([#5474](https://github.com/vuetifyjs/vuetify/issues/5474)) ([a76c44d](https://github.com/vuetifyjs/vuetify/commit/a76c44d0c19fc18665e754993e18def564159e32))
* goto and v-scroll pages were showing the same content ([3ab7370](https://github.com/vuetifyjs/vuetify/commit/3ab7370aef77094cdd05cb64b9851e255a38f887))
* only render ad and toc on client ([5afa9a4](https://github.com/vuetifyjs/vuetify/commit/5afa9a48bcb2a55c41dc992ed32a1eecf4a6fd9f))
* path to github ([055cd84](https://github.com/vuetifyjs/vuetify/commit/055cd8483103ddf85a61444f6227b76cd1833b0b)), closes [#515](https://github.com/vuetifyjs/vuetify/issues/515)
* prevent infinite loop in validation example ([07850b5](https://github.com/vuetifyjs/vuetify/commit/07850b5de15bf9ddf9ed63188135ae598225fc74)), closes [vuetifyjs/vuetify#4640](https://github.com/vuetifyjs/vuetify/issues/4640)
* update search inputs in pre-defined layouts ([f5225e3](https://github.com/vuetifyjs/vuetify/commit/f5225e3bd87c213bc9d543bda767d13d8cacde7b))
* use combobox in chips in select example ([e610429](https://github.com/vuetifyjs/vuetify/commit/e61042906a526e4c53613905d7a53acdadbd4c8a))
* **toc/ad:** remove render on sm-and-down ([f6ff433](https://github.com/vuetifyjs/vuetify/commit/f6ff433b6e95afd37e122b2eb71311ae63ac423f))
* **VBadge:** rtl mode ([#5801](https://github.com/vuetifyjs/vuetify/issues/5801)) ([7eadc37](https://github.com/vuetifyjs/vuetify/commit/7eadc378888344b9b0cd13b756839c49f959d065)), closes [#5684](https://github.com/vuetifyjs/vuetify/issues/5684)
* **VBottomNav:** correct inactive colors ([#5822](https://github.com/vuetifyjs/vuetify/issues/5822)) ([205feed](https://github.com/vuetifyjs/vuetify/commit/205feedd53dd5c078cd4f6644a316caa17fd2dac)), closes [#2685](https://github.com/vuetifyjs/vuetify/issues/2685)
* **VCard:** add missing hover styles ([c1e8a99](https://github.com/vuetifyjs/vuetify/commit/c1e8a99539cb68ec07dbf79cb11e6f8898f47def)), closes [#5815](https://github.com/vuetifyjs/vuetify/issues/5815)
* **VCarousel:** pass `value` property to controls ([#5758](https://github.com/vuetifyjs/vuetify/issues/5758)) ([deb28c4](https://github.com/vuetifyjs/vuetify/commit/deb28c40af44b95c9829d7ca1c7766b3f5a8dc6a))
* **VChip:** rtl mode ([#5802](https://github.com/vuetifyjs/vuetify/issues/5802)) ([45da2ea](https://github.com/vuetifyjs/vuetify/commit/45da2eaae11ae4ada404e2fffef113685a72b405)), closes [#5782](https://github.com/vuetifyjs/vuetify/issues/5782)
* **VCombobox:** menu position may not update if multiple ([#5888](https://github.com/vuetifyjs/vuetify/issues/5888)) ([a1065ca](https://github.com/vuetifyjs/vuetify/commit/a1065ca639b71e51ad30911413b27fe9a165c515))
* **VDataIterator:** pagination width regression ([e015ee3](https://github.com/vuetifyjs/vuetify/commit/e015ee3524ef69341a6c86fb5237345038fca41a)), closes [#4500](https://github.com/vuetifyjs/vuetify/issues/4500)
* **VDataIterator:** select is too tall in IE11 ([#5656](https://github.com/vuetifyjs/vuetify/issues/5656)) ([68a9aec](https://github.com/vuetifyjs/vuetify/commit/68a9aecdb448b13852c150e031228fa3e40ff92e)), closes [#5655](https://github.com/vuetifyjs/vuetify/issues/5655)
* **VDatePicker:** change clickable area of month/year in header ([#5816](https://github.com/vuetifyjs/vuetify/issues/5816)) ([6eca62e](https://github.com/vuetifyjs/vuetify/commit/6eca62e04c9783b7f742c8ee7aa48f41ac29ecca)), closes [#5725](https://github.com/vuetifyjs/vuetify/issues/5725)
* **VDatePicker:** display proper year when model is null ([#5672](https://github.com/vuetifyjs/vuetify/issues/5672)) ([78339a3](https://github.com/vuetifyjs/vuetify/commit/78339a3c2695bbeb3c13cef35be424691401003e)), closes [#5663](https://github.com/vuetifyjs/vuetify/issues/5663)
* **VDialog/VMenu:** enable pointer-events for disabled activator ([#5511](https://github.com/vuetifyjs/vuetify/issues/5511)) ([90d0af9](https://github.com/vuetifyjs/vuetify/commit/90d0af9e5ac3d487c414a1607a665629c07114df)), closes [#5472](https://github.com/vuetifyjs/vuetify/issues/5472)
* **VExpandTransition:** check for parent existence before adding class ([8f15d16](https://github.com/vuetifyjs/vuetify/commit/8f15d1672f17922c4c18d9203b9c4c22119d1fdf)), closes [#5742](https://github.com/vuetifyjs/vuetify/issues/5742)
* **VExpansionPanel:** hide v-card box-shadow ([c639b06](https://github.com/vuetifyjs/vuetify/commit/c639b06c6ab461fb05d072498de5c1843c2843c9))
* **VExpansionPanelContent:** add default value for header destructure ([5d9dcf9](https://github.com/vuetifyjs/vuetify/commit/5d9dcf996defa748b2997a93e4183217873e53a7))
* **VList:** sync icon and text transition ([0781323](https://github.com/vuetifyjs/vuetify/commit/07813232e341d060715c6f4ede2509d994388516)), closes [#4689](https://github.com/vuetifyjs/vuetify/issues/4689)
* **VMenu:** hover stuck open when mouse exits page ([#5844](https://github.com/vuetifyjs/vuetify/issues/5844)) ([62ecb91](https://github.com/vuetifyjs/vuetify/commit/62ecb914f164bb3c8003a6188aca16c808b6bd7c)), closes [#5843](https://github.com/vuetifyjs/vuetify/issues/5843)
* **VProgressCircular:** fix type check for `width` prop ([#5875](https://github.com/vuetifyjs/vuetify/issues/5875)) ([e7eccfc](https://github.com/vuetifyjs/vuetify/commit/e7eccfcd2f98196fe5d6dfce7ebf76bdf16032d0))
* **VSelect:** close menu on tab out ([8a2a1a1](https://github.com/vuetifyjs/vuetify/commit/8a2a1a1b6974ec264e974866b0775f2820dc3503)), closes [#5774](https://github.com/vuetifyjs/vuetify/issues/5774)
* **VSelect:** fix VSelect behavior when switching to another tab ([#5780](https://github.com/vuetifyjs/vuetify/issues/5780)) ([980142f](https://github.com/vuetifyjs/vuetify/commit/980142f5fdd7461fc902710fab7003f195ac2d5e)), closes [#5774](https://github.com/vuetifyjs/vuetify/issues/5774)
* **VSparkline:** adjust gridX calculation ([8fc5dfb](https://github.com/vuetifyjs/vuetify/commit/8fc5dfb7422bdbc318b5ca6502dda5ea3633b8cb))
* **VSparkline:** adjust width and height calculations ([b99d3a4](https://github.com/vuetifyjs/vuetify/commit/b99d3a4466e2a2e3ab5e1ed3f8adb89f5e09b7af))
* **VSparkline:** de-reference points from helper methods ([ca529a4](https://github.com/vuetifyjs/vuetify/commit/ca529a4681be3ccc804b199ea4db38785da40a93))
* **VSparkline:** deconstruct props to avoid mutation error ([f1bdb5f](https://github.com/vuetifyjs/vuetify/commit/f1bdb5fb824ee395022a39224cc6e4dc87d2ea8b))
* **VTabs:** explicitly define tabs bar border-radius ([29a3b08](https://github.com/vuetifyjs/vuetify/commit/29a3b084afcd48fbf6dfe4d32f98998b8ca8c1bd)), closes [#2926](https://github.com/vuetifyjs/vuetify/issues/2926)
* **VTabs:** text field icon in example ([fca09f9](https://github.com/vuetifyjs/vuetify/commit/fca09f906e1ac9b522d709cf0b81dd65f615e8d0))
* **VTextField:** add missing css selector ([4efdee7](https://github.com/vuetifyjs/vuetify/commit/4efdee770eec622fa840b6c7cf5edfb610004fb4)), closes [/github.com/vuetifyjs/vuetify/commit/37c46b6#diff-eeae1149068732892197e1bb41df68fcR62](https://github.com/vuetifyjs//github.com/vuetifyjs/vuetify/commit/37c46b6/issues/diff-eeae1149068732892197e1bb41df68fcR62)
* **VTreeview:** rtl mode ([#5465](https://github.com/vuetifyjs/vuetify/issues/5465)) ([7f534a1](https://github.com/vuetifyjs/vuetify/commit/7f534a1bd9c1617f990f376362def4032d6df8dd)), closes [#5462](https://github.com/vuetifyjs/vuetify/issues/5462)
* **vuetify:** fixed import ([98693e5](https://github.com/vuetifyjs/vuetify/commit/98693e5aaaf816235a699ea19a0b5d00b1adc378))
* **vuetifyjs.com:** update eslint, fix new errors ([1ce344d](https://github.com/vuetifyjs/vuetify/commit/1ce344d3c51946fb92209abd2aced6791b9a2134))
* **WindowItem:** calculate height on leave ([#5590](https://github.com/vuetifyjs/vuetify/issues/5590)) ([af9bbd1](https://github.com/vuetifyjs/vuetify/commit/af9bbd1c80895749a03e4f2c02a43f08b1471aa5)), closes [#5582](https://github.com/vuetifyjs/vuetify/issues/5582)
* **WindowItem:** change how transitionend is processed ([ceddbce](https://github.com/vuetifyjs/vuetify/commit/ceddbce9a16c64d2a1e243b3038e789c4a83750f))
* adds link to issue creator on contributing page ([bef0e94](https://github.com/vuetifyjs/vuetify/commit/bef0e947adb7ee83f69a2eb0218d26ae31803e89)), closes [#383](https://github.com/vuetifyjs/vuetify/issues/383)
* allow card to grow in tealFooter example ([63ae083](https://github.com/vuetifyjs/vuetify/commit/63ae083ffcc4e418f10fa98ff60acde60e877416))
* correct thumbnail URLs on layout/pre-defined ([8d8cccb](https://github.com/vuetifyjs/vuetify/commit/8d8cccbcba26cc10c10d88d280f79c30a7748dd6))
* create dist if not exists ([7b4dd09](https://github.com/vuetifyjs/vuetify/commit/7b4dd09eb0865461c50b720e8f6b49fcdc120fbf))
* don't crash if the url contains "product" ([4302f3f](https://github.com/vuetifyjs/vuetify/commit/4302f3f8e1c03d8d3f4802e65afd64f06452c5fa))
* duplicated keys in v-for ([0f75588](https://github.com/vuetifyjs/vuetify/commit/0f75588e545c57faaf423ac5b69a1621c957cd58)), closes [#377](https://github.com/vuetifyjs/vuetify/issues/377)
* emit correct literal types ([650ad7a](https://github.com/vuetifyjs/vuetify/commit/650ad7a9be4c9e78fa3acfff7c06501f85635b5e))
* get props from depply-extended components ([0298528](https://github.com/vuetifyjs/vuetify/commit/0298528559f5e81b1fe64bbee5f7861e9db17056))
* material design icons css file name ([787a0a1](https://github.com/vuetifyjs/vuetify/commit/787a0a16fc8d7ea7ccfde16cfeaaab42ceb2a08d)), closes [#449](https://github.com/vuetifyjs/vuetify/issues/449)
* removes hover prop from v-btn ([56c5524](https://github.com/vuetifyjs/vuetify/commit/56c552458582e71efe6e5267a5096ef58848f2c7)), closes [#435](https://github.com/vuetifyjs/vuetify/issues/435)
* sort things alphabetically in output ([e1a7eb0](https://github.com/vuetifyjs/vuetify/commit/e1a7eb04eea18a767f946388447a9f613a0f3f02))
* stylus var name (possible breaking change introduced by [#5802](https://github.com/vuetifyjs/vuetify/issues/5802)) ([9e893dd](https://github.com/vuetifyjs/vuetify/commit/9e893ddbd1f42c335f3bae9d95091474dc340be8))
* typescript lint errors ([#5520](https://github.com/vuetifyjs/vuetify/issues/5520)) ([8691e57](https://github.com/vuetifyjs/vuetify/commit/8691e57d988c3761319f9c587150992af7e5b745))
* update async example ([#633](https://github.com/vuetifyjs/vuetify/issues/633)) ([61a9922](https://github.com/vuetifyjs/vuetify/commit/61a992201ede0446b13d7025f770e00cbe04b591))
* update v-breadcrumbs examples and doc test ([#641](https://github.com/vuetifyjs/vuetify/issues/641)) ([11196b5](https://github.com/vuetifyjs/vuetify/commit/11196b550dcb8ddb69f2ed39b68ccb4a83a9092d))
* updated map, added hacky fix for wrapped components ([3d8072b](https://github.com/vuetifyjs/vuetify/commit/3d8072bce9d68257a445aaef09fe14c54f11bf6f))
* updated parsing ([98fd92e](https://github.com/vuetifyjs/vuetify/commit/98fd92eb9c8fd97c8a0079746c1d4782534840ad))
* updated scoped slots, functions and signatures ([c7caaa3](https://github.com/vuetifyjs/vuetify/commit/c7caaa3479a9f883f3e01446e4dfa790d7afa9f4))
* use hyphenate function from Vue ([694f0fd](https://github.com/vuetifyjs/vuetify/commit/694f0fdcddd51528db9895377d9d384802d6b8e7))
* v-progress-* description ([5ca8a5d](https://github.com/vuetifyjs/vuetify/commit/5ca8a5d45d72c894b81946b734bfa7e65f74b00e)), closes [#350](https://github.com/vuetifyjs/vuetify/issues/350)
* **$carousel-example:** updated example to use custom transition ([c51730b](https://github.com/vuetifyjs/vuetify/commit/c51730b42ce302024b66590fa23e610f1d0fa6c7))
* **$carousel-examples:** fixed `customTransition` example ([4470c86](https://github.com/vuetifyjs/vuetify/commit/4470c8627df17ff9f181ef92490d9caf62606243)), closes [#332](https://github.com/vuetifyjs/vuetify/issues/332)
* **$google-contacts:** updated example to use lgAndUp ([b05d778](https://github.com/vuetifyjs/vuetify/commit/b05d7787f0c9bf4f6724e1dbddda03b50edbee78))
* **$home-page:** added missing ref and ga events ([2ad7f67](https://github.com/vuetifyjs/vuetify/commit/2ad7f67eb1474a8d480e74c6f52445b336d8e622))
* **$home-page:** adjusted logo size on mobile ([494be64](https://github.com/vuetifyjs/vuetify/commit/494be642f7b150a36c7163bf8ef350050e529965))
* **$home-page:** fixed feature cards ([19079a8](https://github.com/vuetifyjs/vuetify/commit/19079a8fdb9dd9e96118f23a16a683eef8cb6022))
* **$home-page:** fixed logo size and image hydration ([3428e88](https://github.com/vuetifyjs/vuetify/commit/3428e88f80a19f4c0fd583141b4fe59e0cb5a5ee))
* **$home-page:** removed conditional image size ([d4ea6b9](https://github.com/vuetifyjs/vuetify/commit/d4ea6b997cd84d8bde77a607b40bdae1e9a784fc))
* **api:** updated lists, improved api process ([54038a7](https://github.com/vuetifyjs/vuetify/commit/54038a7ad3b6e8df61dd13c6198b19d937bc8aa7))
* **app-toolbar:** added max-height for smaller screens ([f7ae146](https://github.com/vuetifyjs/vuetify/commit/f7ae146720ab6d07e94f6b5eced399d96a7238ca))
* **codepen:** remove self-closing elements from examples ([4dfb1f5](https://github.com/vuetifyjs/vuetify/commit/4dfb1f5ebee05c48526e3010a414dd429b5b0776))
* **example:** update process for displaying example information ([7a09ecd](https://github.com/vuetifyjs/vuetify/commit/7a09ecdbf60d8b612e14f8b527ee1baffa062ac2))
* **goTo:** add dummy easings object for codepen ([3ff4d0c](https://github.com/vuetifyjs/vuetify/commit/3ff4d0c89aeca879c716898fe6f00553ad3ae0e7))
* **grid-example:** updated markup to fix text wrapping ([327b3ce](https://github.com/vuetifyjs/vuetify/commit/327b3cea8c0b7b84196147c05ae6e4817511c8a4)), closes [#233](https://github.com/vuetifyjs/vuetify/issues/233)
* **lint:** fix lint ([1c22ed3](https://github.com/vuetifyjs/vuetify/commit/1c22ed308db81b2be16882e45ddf5d7c51931c75))
* **product:** fixed in doc navigation product resolution ([79d861f](https://github.com/vuetifyjs/vuetify/commit/79d861fdc4f9cf02589dd5275c0f8314adbcd248))
* **subheaders:** add missing spacer to list example ([#430](https://github.com/vuetifyjs/vuetify/issues/430)) ([75f3d51](https://github.com/vuetifyjs/vuetify/commit/75f3d517c93a1eb887044089ffd61d9ac065d2c4))
* **VTextField:** border color in error state ([d6d65f3](https://github.com/vuetifyjs/vuetify/commit/d6d65f334ecdb78c99117499dff95501b3a96fdf)), closes [#5738](https://github.com/vuetifyjs/vuetify/issues/5738)
* **VTextField:** css rules were applied to checkboxes in v-select menu ([#5595](https://github.com/vuetifyjs/vuetify/issues/5595)) ([37c46b6](https://github.com/vuetifyjs/vuetify/commit/37c46b62b4896a79440e500ed5acb37d1fab7cab)), closes [#5508](https://github.com/vuetifyjs/vuetify/issues/5508)
* **VTimePicker:** adjust inner/outer circle click detection in 24hr ([f148646](https://github.com/vuetifyjs/vuetify/commit/f1486465806da60977c74262e431483c7da8e38a))
* **VTimePicker:** emit proper value in change event ([#5680](https://github.com/vuetifyjs/vuetify/issues/5680)) ([8e67ed7](https://github.com/vuetifyjs/vuetify/commit/8e67ed7f18180ea7bde08b8c6efa5086cb2d3c9a)), closes [#5266](https://github.com/vuetifyjs/vuetify/issues/5266)
* **VToolbarTitle:** rtl mode ([#5642](https://github.com/vuetifyjs/vuetify/issues/5642)) ([993fa6d](https://github.com/vuetifyjs/vuetify/commit/993fa6dc9b67e9993730f5f88a275a5ef14ea054))
* **VTreeview:** active-class applies to node and all its children ([98bf6f9](https://github.com/vuetifyjs/vuetify/commit/98bf6f9f140b696f26904a77830bb0534946fd3e))
* **VTreeview:** active-class applies to node and all its children ([#5978](https://github.com/vuetifyjs/vuetify/issues/5978)) ([3920f0e](https://github.com/vuetifyjs/vuetify/commit/3920f0e19d5512899ac68bcb63ad63e74dfd1c55)), closes [#5854](https://github.com/vuetifyjs/vuetify/issues/5854)
* **VTreeview:** async loading using custom children key ([#5977](https://github.com/vuetifyjs/vuetify/issues/5977)) ([ca3e464](https://github.com/vuetifyjs/vuetify/commit/ca3e4640a64f50f77533072ce8ed0b96c7e42ba3)), closes [#5550](https://github.com/vuetifyjs/vuetify/issues/5550)
* **VTreeview:** bug when removing and adding children ([#5991](https://github.com/vuetifyjs/vuetify/issues/5991)) ([3f2bb42](https://github.com/vuetifyjs/vuetify/commit/3f2bb42ac6ddd49dd6554bf6fa0d5eb0d3b00e1b)), closes [#5719](https://github.com/vuetifyjs/vuetify/issues/5719)
* **VTreeview:** open-all not working with some item keys ([#5976](https://github.com/vuetifyjs/vuetify/issues/5976)) ([d5f8266](https://github.com/vuetifyjs/vuetify/commit/d5f82663f0cd76af9c49a29956738c0da4a98fb2)), closes [#5711](https://github.com/vuetifyjs/vuetify/issues/5711)
* **VWindowItem:** ensure afterEnter fires with no transition ([8a1b483](https://github.com/vuetifyjs/vuetify/commit/8a1b48304b64ff001e9feda3c64a23883448d76b)), closes [#5683](https://github.com/vuetifyjs/vuetify/issues/5683)
* correct current language flag URL ([921a58b](https://github.com/vuetifyjs/vuetify/commit/921a58bc0da1abbded271b1200004509e19d41ce))
* markdown on treeview headers ([7c8c189](https://github.com/vuetifyjs/vuetify/commit/7c8c189b6319706ffe31d4b6db6ca541e954873b))
* only cache succesful requests ([dbe18b4](https://github.com/vuetifyjs/vuetify/commit/dbe18b4981ba13964a8c4b68966d6ae714168a64))
* remove spaces from closing tags ([0380a26](https://github.com/vuetifyjs/vuetify/commit/0380a266ee035e7e349eabbd7c8ff5dadecf9b26))
* update some missed fa icons ([0806b71](https://github.com/vuetifyjs/vuetify/commit/0806b710f3ffe2549451a9c604997eb7c13aebf7)), closes [#341](https://github.com/vuetifyjs/vuetify/issues/341)
* uppercased hover ([1ac34c7](https://github.com/vuetifyjs/vuetify/commit/1ac34c7c90cea11e048df094b45a280edf8836a2))
* **application:** update types ([03afa59](https://github.com/vuetifyjs/vuetify/commit/03afa59f2ba82fa78e3d371b2a8fd7f9eafc4833))
* **dependent/v-dialog:** add v-dialog to dependency chain ([475d5e5](https://github.com/vuetifyjs/vuetify/commit/475d5e5537687e532252728bbf6d833c2fe9cda1)), closes [#4585](https://github.com/vuetifyjs/vuetify/issues/4585)
* **directives:** remove name ([214e561](https://github.com/vuetifyjs/vuetify/commit/214e56106ad4dbbdbd730cbdfe91102eacb09c94))
* **dividers:** prevent from growing in the wrong direction ([6754fc4](https://github.com/vuetifyjs/vuetify/commit/6754fc4d77dd3dbd99372373740f53a78b6f53d5)), closes [#4641](https://github.com/vuetifyjs/vuetify/issues/4641) [#4615](https://github.com/vuetifyjs/vuetify/issues/4615)
* **helpers:** change priority of padding and margin helpers ([#4559](https://github.com/vuetifyjs/vuetify/issues/4559)) ([3e72c8f](https://github.com/vuetifyjs/vuetify/commit/3e72c8f24854a669c66412e322656fcb9a0fcf2c))
* **index.d.ts:** added footer to VuetifyApplication ([7df6316](https://github.com/vuetifyjs/vuetify/commit/7df63160e65f18274ee4d54d30c60296404f1a2d))
* **inputs:** don't override aria-label attribute ([098d07b](https://github.com/vuetifyjs/vuetify/commit/098d07be773bc5272518c90d99bf85929aa9f979)), closes [#4642](https://github.com/vuetifyjs/vuetify/issues/4642)
* **inputs:** emit icon click events correctly ([1040ccd](https://github.com/vuetifyjs/vuetify/commit/1040ccda152e0f6de897322bdff7292462ee6c8d)), closes [#4647](https://github.com/vuetifyjs/vuetify/issues/4647) [#4545](https://github.com/vuetifyjs/vuetify/issues/4545)
* **inputs:** tweak vertical alignment ([#4803](https://github.com/vuetifyjs/vuetify/issues/4803)) ([c45b600](https://github.com/vuetifyjs/vuetify/commit/c45b6003f5c084a7463f1e51ce4070fa4f8770be))
* **lang:** corrected spelling ([50bff57](https://github.com/vuetifyjs/vuetify/commit/50bff573d6201781eeece4b9b9e76edd86655245))
* **overlayable:** add check for contenteditable ([a82c492](https://github.com/vuetifyjs/vuetify/commit/a82c492db03d3ee85057384fe119863191ecf14b)), closes [#4715](https://github.com/vuetifyjs/vuetify/issues/4715)
* **overlayable:** check for overlay after animationFrame ([94b3666](https://github.com/vuetifyjs/vuetify/commit/94b3666d2a2e1fabc165010e18c8e1d00695985a)), closes [#4678](https://github.com/vuetifyjs/vuetify/issues/4678)
* **readme:** replace broken images ([4395c3b](https://github.com/vuetifyjs/vuetify/commit/4395c3b66ace8b6f4e52380a34aceb0702d95e21))
* **select:** updated minWidth description ([b67efde](https://github.com/vuetifyjs/vuetify/commit/b67efde8dbb1f7a26dcd4b9778c77555e27545c5)), closes [#232](https://github.com/vuetifyjs/vuetify/issues/232)
* **selectable:** pass disabled prop to internal input ([d5cfdc2](https://github.com/vuetifyjs/vuetify/commit/d5cfdc2bc125c2e3e7739d50f9087a86b30a6386)), closes [#4796](https://github.com/vuetifyjs/vuetify/issues/4796) [#4797](https://github.com/vuetifyjs/vuetify/issues/4797)
* **sizeable:** add name for api-generator ([109319e](https://github.com/vuetifyjs/vuetify/commit/109319e68020cbb361b5bda2c2b9837ec9585e6d))
* **snackbars:** fixed snackbars not being shown on docs ([84a1241](https://github.com/vuetifyjs/vuetify/commit/84a1241e0cc27578d67840118f0853bdb9f5d735)), closes [#179](https://github.com/vuetifyjs/vuetify/issues/179)
* **theme:** added documentation on custom theme options ([573e920](https://github.com/vuetifyjs/vuetify/commit/573e920a7be9df433524cd1aaed409c4b0ccbd04)), closes [#202](https://github.com/vuetifyjs/vuetify/issues/202)
* **theme:** lighten-1 should be darker than lighten-5 ([7f38e4a](https://github.com/vuetifyjs/vuetify/commit/7f38e4a7f173fcb2f34e84fa25d89abf90097ce6)), closes [#4751](https://github.com/vuetifyjs/vuetify/issues/4751)
* **toolbar-logo:** fixed size for ie11 ([4f0826a](https://github.com/vuetifyjs/vuetify/commit/4f0826a1900b90f225a02832556224bdfecbfa62)), closes [#227](https://github.com/vuetifyjs/vuetify/issues/227)
* **touch:** update types ([6d9c35e](https://github.com/vuetifyjs/vuetify/commit/6d9c35ef56a69a2183581a18b117331aebe23d5d))
* **types:** prevent type leak in Toggleable, add $el to VBtn ([#4598](https://github.com/vuetifyjs/vuetify/issues/4598)) ([da5b902](https://github.com/vuetifyjs/vuetify/commit/da5b902ae90a7aa16eaffa89ab65b88284e385b7))
* **v-btn:** fix outline height ([7abf1aa](https://github.com/vuetifyjs/vuetify/commit/7abf1aa1cea8dad76543f3d554c1d702e81f70cf)), closes [#3068](https://github.com/vuetifyjs/vuetify/issues/3068) [#3127](https://github.com/vuetifyjs/vuetify/issues/3127)
* **v-combobox:** change logic for updating combobox ([37bfe03](https://github.com/vuetifyjs/vuetify/commit/37bfe032dcbe5acf37df6627867f46a75a000e1f)), closes [#4595](https://github.com/vuetifyjs/vuetify/issues/4595)
* **v-data-table:** fix icon alignment for mdi ([e22e24e](https://github.com/vuetifyjs/vuetify/commit/e22e24e51ac011bbc0d4dc77ad44f6375590277f))
* **v-expansion-panel:** assume auto height if no scroll height ([e084f27](https://github.com/vuetifyjs/vuetify/commit/e084f2787e922772e77e961efc31d8b104486818))
* **v-footer:** fix application size ([deaf2c8](https://github.com/vuetifyjs/vuetify/commit/deaf2c87cbf071cb12fee11e85a0114a7d007528))
* **v-form:** restore ability to work with inputs through $refs ([#4593](https://github.com/vuetifyjs/vuetify/issues/4593)) ([52f7357](https://github.com/vuetifyjs/vuetify/commit/52f73573285423fe46f0623d3d6be66efb53804e))
* **v-list:** fix group dividers ([e003a55](https://github.com/vuetifyjs/vuetify/commit/e003a55db02c73aa6092d3a6c052a0da37b8496c))
* **v-navigation-drawer:** fix application interaction ([cc4959f](https://github.com/vuetifyjs/vuetify/commit/cc4959f0f68487d9359d8bec48f14e36a42e7cf2)), closes [#2901](https://github.com/vuetifyjs/vuetify/issues/2901) [#3928](https://github.com/vuetifyjs/vuetify/issues/3928) [#4390](https://github.com/vuetifyjs/vuetify/issues/4390) [#4384](https://github.com/vuetifyjs/vuetify/issues/4384)
* **v-navigation-drawer:** fix maxHeight value ([517e64a](https://github.com/vuetifyjs/vuetify/commit/517e64aba7b60391fc9e255a3b8eba49876a3436))
* **v-responsive:** pass listeners to render ([585798d](https://github.com/vuetifyjs/vuetify/commit/585798d17ef7e2cc8078f80469836c37517e446e))
* **v-select:** apply custom nudgeBottom ([9b345eb](https://github.com/vuetifyjs/vuetify/commit/9b345ebb48684114e051c3726f341e8368b1390f)), closes [#4713](https://github.com/vuetifyjs/vuetify/issues/4713)
* **v-select:** fix chip editing functionality ([daeae40](https://github.com/vuetifyjs/vuetify/commit/daeae40dcd7b0afdc541742bd8d0c3766d099268)), closes [#4571](https://github.com/vuetifyjs/vuetify/issues/4571)
* **v-select:** fix reverse styles ([85b240e](https://github.com/vuetifyjs/vuetify/commit/85b240eff5298fbf830b004e6869261eb24c2810)), closes [#4699](https://github.com/vuetifyjs/vuetify/issues/4699)
* **v-select:** remove change event ([8b4e1f4](https://github.com/vuetifyjs/vuetify/commit/8b4e1f436d1da10fea7e5f80e6d8977fc80c0759))
* **v-text-field(box):** fix state colors ([af9660f](https://github.com/vuetifyjs/vuetify/commit/af9660f3e5084456a1b0099fb548ef5b881afcee))
* **v-toolbar:** fix a fix ([0a1a8f6](https://github.com/vuetifyjs/vuetify/commit/0a1a8f69e2dda9a05c6525ea288b8b9ede43204d))
* **validatable:** don't validate if rules content hasn't changed ([53ad130](https://github.com/vuetifyjs/vuetify/commit/53ad13075fed9ad4df8863556721e86e66d6a77c)), closes [#4688](https://github.com/vuetifyjs/vuetify/issues/4688)
* **validatable:** revalidate on rules change ([#4640](https://github.com/vuetifyjs/vuetify/issues/4640)) ([0693334](https://github.com/vuetifyjs/vuetify/commit/0693334f8ee0c6e9ebf40f5b117191b89629ffeb)), closes [#4635](https://github.com/vuetifyjs/vuetify/issues/4635)
* **validatable:** show success state without having focused ([525a2f6](https://github.com/vuetifyjs/vuetify/commit/525a2f6f18887745faf627eae491e0bc61c28b23))
* **VAutocomplete:** show menu when hideNoData changes ([0ae2c1d](https://github.com/vuetifyjs/vuetify/commit/0ae2c1dd2812f13929abd90c426375c1901e13a0)), closes [#4822](https://github.com/vuetifyjs/vuetify/issues/4822)
* **VAvatar:** crop v-img ([cac1ee3](https://github.com/vuetifyjs/vuetify/commit/cac1ee38fe9e41db81e8c967d80faae421d89174)), closes [#4777](https://github.com/vuetifyjs/vuetify/issues/4777)
* **VBottomNav:** shrink buttons when too narrow ([bd63a95](https://github.com/vuetifyjs/vuetify/commit/bd63a950bc53273c3cfd54a1004132a1356aaba1)), closes [#4643](https://github.com/vuetifyjs/vuetify/issues/4643) [#4547](https://github.com/vuetifyjs/vuetify/issues/4547)
* **VBtn:** remove text colour from themed buttons ([2d3f0da](https://github.com/vuetifyjs/vuetify/commit/2d3f0da7a0059afe23b7b3ef5cf96006feb8d049)), closes [#4812](https://github.com/vuetifyjs/vuetify/issues/4812)
* **VBtn:** set shrink factor to 0 ([#4547](https://github.com/vuetifyjs/vuetify/issues/4547)) ([c78753c](https://github.com/vuetifyjs/vuetify/commit/c78753c42909efa50d37297230727bb417a78a29)), closes [#3412](https://github.com/vuetifyjs/vuetify/issues/3412)
* **VCheckbox:** prevent input when readonly ([b55f5d1](https://github.com/vuetifyjs/vuetify/commit/b55f5d13a3acb1cd5dc21a83d13cdbe26ebbf7f5)), closes [#4827](https://github.com/vuetifyjs/vuetify/issues/4827)
* **VEditDialog:** show backbround color ([d40e2ff](https://github.com/vuetifyjs/vuetify/commit/d40e2ff6de99456ff9634dd9c789f38b1baf7755)), closes [#4856](https://github.com/vuetifyjs/vuetify/issues/4856)
* **version dropdown:** updated directed path ([853ac49](https://github.com/vuetifyjs/vuetify/commit/853ac495bb5b460bbffe981096af6f040df917a3)), closes [#195](https://github.com/vuetifyjs/vuetify/issues/195)
* added button to switch between hex codes and colors object in ThemeGenerator ([982bffd](https://github.com/vuetifyjs/vuetify/commit/982bffdda521de922f28b11e9bc109d862cda970))
* added grow prop to grow example ([cd9732a](https://github.com/vuetifyjs/vuetify/commit/cd9732afe6f5b59078a61bb5ece3fc1e54b0227c))
* added missing props ([e4d87cb](https://github.com/vuetifyjs/vuetify/commit/e4d87cb851dc13b1cab866b5bb9873ac44847073))
* added missing props for v-expansion-panel ([9628d7b](https://github.com/vuetifyjs/vuetify/commit/9628d7b0454b8678a13a8283d3fe859da1592317))
* added rippleable and bootable mixins ([cb6ebfe](https://github.com/vuetifyjs/vuetify/commit/cb6ebfe2d47bacfb6ce6003cf1f25efa24688588))
* bug in export theme ([2a61994](https://github.com/vuetifyjs/vuetify/commit/2a6199422de3c8d08c7b9c1355f6fa71eae2ae86)), closes [#196](https://github.com/vuetifyjs/vuetify/issues/196)
* correct HTML in masks table ([f99266a](https://github.com/vuetifyjs/vuetify/commit/f99266ade83b47a31030c98a00e53a7cdaead5a8)), closes [#230](https://github.com/vuetifyjs/vuetify/issues/230)
* correct more HTML in masks table ([cd73b3a](https://github.com/vuetifyjs/vuetify/commit/cd73b3ab1490cc01292aa9222a798960766b08c5)), closes [#230](https://github.com/vuetifyjs/vuetify/issues/230)
* duplicated key warning on /components/lists ([2379c6c](https://github.com/vuetifyjs/vuetify/commit/2379c6c13746f2a4ced32d954bb8108ecf12c694))
* forgot to remove renamed file ([baa58e9](https://github.com/vuetifyjs/vuetify/commit/baa58e9fa06220bf3d9361964533d0b6ec7bbf93))
* moved support text to i18n ([20c2be5](https://github.com/vuetifyjs/vuetify/commit/20c2be5e3fdd77c1e0ed3b8c4d96c2121b2ea0ca)), closes [#156](https://github.com/vuetifyjs/vuetify/issues/156)
* page-head header disappeared if no translation available ([c1be94c](https://github.com/vuetifyjs/vuetify/commit/c1be94c4990dade5af8ae4894646c906784238cc))
* removed centered prop from generator component ([198d454](https://github.com/vuetifyjs/vuetify/commit/198d4545f28337317f49890497d2f3643f496bc9))
* removed placeholders from translations menu ([afca665](https://github.com/vuetifyjs/vuetify/commit/afca665a49c1274037d6c021a0656be8297a380e))
* render example markup as soon as it's available ([23713aa](https://github.com/vuetifyjs/vuetify/commit/23713aa53c28045ec31642b408a8a01b47ae7331))
* set the correct drawer state when changing routes ([96a3e95](https://github.com/vuetifyjs/vuetify/commit/96a3e950ec1bd71124a4288cf13bf0957b3e9a11))
* spelling in SSR guide ([687caf4](https://github.com/vuetifyjs/vuetify/commit/687caf4672a892b899b3c65fb647561a731bfe54))
* switched order of supported browsers ([e01ade8](https://github.com/vuetifyjs/vuetify/commit/e01ade86615f28f49a8605d433286bc5e4cd39c9))
* updated a-la-carte text ([1ad5114](https://github.com/vuetifyjs/vuetify/commit/1ad5114990e3c73058c9b1217f721359026341e7)), closes [#217](https://github.com/vuetifyjs/vuetify/issues/217)
* **drawer-examples:** fixed display issues with temporary and dark theme examples ([0724b8c](https://github.com/vuetifyjs/vuetify/commit/0724b8c23f8f1a92b1cf0ec041f43f1bfbab32f5))
* **examples:** fixed snackbar being hidden ([ce1c3e0](https://github.com/vuetifyjs/vuetify/commit/ce1c3e060014496369fcc2dbef20940f4734cacd)), closes [#179](https://github.com/vuetifyjs/vuetify/issues/179)
* incorrect grid offset on home page ([984c137](https://github.com/vuetifyjs/vuetify/commit/984c137ed5ef02bcae2885483503ea35ad74b26e))
* removed duplicate markup ([0ddb833](https://github.com/vuetifyjs/vuetify/commit/0ddb83385fc08543346278cb7c2160cffc580067))
* tab bug in api section ([4ce62eb](https://github.com/vuetifyjs/vuetify/commit/4ce62eb915dec4e6cdd0afcb208c8e435ada3775))
* updated a-la-carte page ([665e59d](https://github.com/vuetifyjs/vuetify/commit/665e59d39a94f9f6a24b5ab7f1b4ecd3216ac47a))
* updated api file ([3f39a99](https://github.com/vuetifyjs/vuetify/commit/3f39a9948aaa271e83b5953a4b31c7c2c096c6fe))
* updated badge documentation ([49db8f4](https://github.com/vuetifyjs/vuetify/commit/49db8f4ed36393af80cdeff00e93f172e0a97f49))
* updated form page ([88b7428](https://github.com/vuetifyjs/vuetify/commit/88b7428f79f16672f6c1331853fdad1aa072d7e6))
* updated header text for roadmap ([94c14f3](https://github.com/vuetifyjs/vuetify/commit/94c14f3c80f5ce1b3ee9289d751cc7d4aac31ac0))
* updated Parameters component ([c4c1eab](https://github.com/vuetifyjs/vuetify/commit/c4c1eab411cd1b3576dc1b7821ca0965fcce2ad3))
* updated pre-made-themes page ([4e43510](https://github.com/vuetifyjs/vuetify/commit/4e43510890031b925cb026cbd70e59105d6bbe05))
* updated tabs component names ([9092cd8](https://github.com/vuetifyjs/vuetify/commit/9092cd8cd47c02a0b4ad1ef1cf1d9fb4bf0de38e))
* updated text on home page ([66bae3a](https://github.com/vuetifyjs/vuetify/commit/66bae3a170d3170685838a16665bd255270ca22f))
* updated toolbar page, added example ([c64bbf2](https://github.com/vuetifyjs/vuetify/commit/c64bbf24e33e927a07d85e97a089a494ec362b7c))
* updated tooltip examples ([cb6dd00](https://github.com/vuetifyjs/vuetify/commit/cb6dd00583991b7fef1f3b1eea2b7db739374ea7)), closes [#115](https://github.com/vuetifyjs/vuetify/issues/115)
* various small things ([cd89fa1](https://github.com/vuetifyjs/vuetify/commit/cd89fa16a4e859d7f6ebb65612d5925606244bdf))
* **.prettierrc:** fix file ([73aab98](https://github.com/vuetifyjs/vuetify/commit/73aab98d07b5c07db6181c4a1237556d44a06751))
* **goTo:** miscalculated target offset ([#4236](https://github.com/vuetifyjs/vuetify/issues/4236)) ([cdeba95](https://github.com/vuetifyjs/vuetify/commit/cdeba95e3a3e288f842440ce09cc4171e0477e97)), closes [#4226](https://github.com/vuetifyjs/vuetify/issues/4226)
* **goTo:** scrollY => pageYOffset (IE11) ([f09dc31](https://github.com/vuetifyjs/vuetify/commit/f09dc31bd9cf9e11db9549d56fc9b8ec5ea768ac)), closes [#4245](https://github.com/vuetifyjs/vuetify/issues/4245)
* **grid:** set v-flex max-width in column layouts ([#4321](https://github.com/vuetifyjs/vuetify/issues/4321)) ([ba4e434](https://github.com/vuetifyjs/vuetify/commit/ba4e4345271741c1f4121fb9caac3e24dc466968)), closes [#4258](https://github.com/vuetifyjs/vuetify/issues/4258)
* **grid:** too loose selector for fill-height ([#4003](https://github.com/vuetifyjs/vuetify/issues/4003)) ([099c6cd](https://github.com/vuetifyjs/vuetify/commit/099c6cda10b8e53655c968f359150b9b9a7b5649))
* **ie11:** fix styles ([999acb0](https://github.com/vuetifyjs/vuetify/commit/999acb097292faef66ea1e45b604de59d17eac27))
* **inputs:** fix styles ([4b63773](https://github.com/vuetifyjs/vuetify/commit/4b63773cd1eef34e21e6e9621267b1675e82c387))
* **inputs:** remove line-height override ([e08cde1](https://github.com/vuetifyjs/vuetify/commit/e08cde174543b249a9d99921aaf2a98692f64fc0))
* **jest:** configure from base ([510fe32](https://github.com/vuetifyjs/vuetify/commit/510fe324754abd032654e2dbf5bc9054dd9c2288))
* **selectable:** use custom true- and false-value correctly ([#4259](https://github.com/vuetifyjs/vuetify/issues/4259)) ([c1e8312](https://github.com/vuetifyjs/vuetify/commit/c1e8312521ba5337eed0e71f338d9a9d96202030)), closes [#3845](https://github.com/vuetifyjs/vuetify/issues/3845) [#4230](https://github.com/vuetifyjs/vuetify/issues/4230)
* **selection-controls:** fix disabled styles ([215f921](https://github.com/vuetifyjs/vuetify/commit/215f9218c76a6f8a295d046779e0d7516c29c2d4)), closes [#3487](https://github.com/vuetifyjs/vuetify/issues/3487)
* **sliders:** remove deprecated stylus variable ([2480215](https://github.com/vuetifyjs/vuetify/commit/248021523032e8b807c5372ee8fd49ae0dc17540)), closes [#5340](https://github.com/vuetifyjs/vuetify/issues/5340)
* **snapshots:** update snapshots ([ed2af05](https://github.com/vuetifyjs/vuetify/commit/ed2af05ae83cf5b913422df088607c8b26f8ece9))
* **solo-inverted:** fix styling on focus ([c2fc42c](https://github.com/vuetifyjs/vuetify/commit/c2fc42c9d5f036b6473bd0aca5efcf6f38a049cd)), closes [#3878](https://github.com/vuetifyjs/vuetify/issues/3878)
* **types:** export components for use with object spread ([6ac1b0b](https://github.com/vuetifyjs/vuetify/commit/6ac1b0ba2d9d9b7e677abef5412c1499629cf96c))
* **v-autocomplete:** avoid search reset ([c06c353](https://github.com/vuetifyjs/vuetify/commit/c06c35379df01de5fedfff6839066daf6682b431)), closes [#4273](https://github.com/vuetifyjs/vuetify/issues/4273)
* **v-autocomplete:** disable delete on disabled ([9442a21](https://github.com/vuetifyjs/vuetify/commit/9442a21a442acd4abdf683f3c5d5d1f2bf83b01f)), closes [#3097](https://github.com/vuetifyjs/vuetify/issues/3097)
* **v-bottom-sheets:** fix animation ([168defa](https://github.com/vuetifyjs/vuetify/commit/168defaf4e558a6b943c3cd6b1dd82693e079e9b))
* **v-data-table:** fix input styles ([0950067](https://github.com/vuetifyjs/vuetify/commit/095006725e09358135a81782a4215d23a09f52fe))
* **v-data-table:** incorrect colspan when not using headers prop ([#3920](https://github.com/vuetifyjs/vuetify/issues/3920)) ([134ac63](https://github.com/vuetifyjs/vuetify/commit/134ac6393b0787d6f81346b77fe2c4e82d4bf74b)), closes [#3419](https://github.com/vuetifyjs/vuetify/issues/3419) [#3338](https://github.com/vuetifyjs/vuetify/issues/3338)
* **v-date-picker:** disallow selecting disabled dates with keyboard ([#4200](https://github.com/vuetifyjs/vuetify/issues/4200)) ([9c4a570](https://github.com/vuetifyjs/vuetify/commit/9c4a570966c5a5b98993ea1d6e87626fb3fad265)), closes [#4151](https://github.com/vuetifyjs/vuetify/issues/4151)
* **v-input:** fix loader styles ([60a53cf](https://github.com/vuetifyjs/vuetify/commit/60a53cfaa554f71af8a5c155c48ecafe350dedf0))
* **v-input:** hint in rtl ([#4255](https://github.com/vuetifyjs/vuetify/issues/4255)) ([9a3fe86](https://github.com/vuetifyjs/vuetify/commit/9a3fe86c1f46151fdd6126d5d9057eb422cc9c3a)), closes [#4248](https://github.com/vuetifyjs/vuetify/issues/4248)
* **v-list:** align list action button ([#4110](https://github.com/vuetifyjs/vuetify/issues/4110)) ([ea128dd](https://github.com/vuetifyjs/vuetify/commit/ea128dd573afbb97c4b002101190e8e1c3e05ba5))
* **v-list:** fix hover styles ([030a9b8](https://github.com/vuetifyjs/vuetify/commit/030a9b835d6c542622dd43541e6a166f5c152d26))
* **v-menu:** add border offset ([2b5c7bc](https://github.com/vuetifyjs/vuetify/commit/2b5c7bc353c10a850b96d80859363d9a43314aaa))
* **v-menu:** fix auto calculations ([84c9abe](https://github.com/vuetifyjs/vuetify/commit/84c9abecebe49b0a378307c3fe60aee00971e9de))
* **v-menu:** fix auto style bleed ([fef9a0a](https://github.com/vuetifyjs/vuetify/commit/fef9a0a2219d8de242417b52edd48a96aed7fbf4))
* **v-range-slider:** enable always-dirty prop ([ac817fe](https://github.com/vuetifyjs/vuetify/commit/ac817febaa96d34b4be99bda6047b54912de2e0b))
* **v-select:** change import syntax ([425302b](https://github.com/vuetifyjs/vuetify/commit/425302b9ca99fadf1ff0edd8385906ea59a3265e))
* **v-select:** fix attach functionality ([725cb26](https://github.com/vuetifyjs/vuetify/commit/725cb269548ebb17926b9ec4ac5e642aea2473cb))
* **v-select:** fix hide-selected behavior ([2f29e58](https://github.com/vuetifyjs/vuetify/commit/2f29e58cb29e4014cde0f50574b92a312b792fa9)), closes [#3532](https://github.com/vuetifyjs/vuetify/issues/3532)
* **v-select:** fix input wrapping ([08a4473](https://github.com/vuetifyjs/vuetify/commit/08a447316ccd69e18610927700ada797670eebdc))
* **v-select:** update selected items logic ([2773c94](https://github.com/vuetifyjs/vuetify/commit/2773c94b4c1f5bf9d35ec4c896c8c8557b854d3e)), closes [#4264](https://github.com/vuetifyjs/vuetify/issues/4264)
* **v-slider:** fixed disabled style ([9a66781](https://github.com/vuetifyjs/vuetify/commit/9a667813cace03736bc8e3ae062877c56c89a1e5))
* **v-slider:** incorrect initial lazyValue if value is 0 ([135fcc7](https://github.com/vuetifyjs/vuetify/commit/135fcc70204e71f09762909b22a5c98e58a03797))
* **v-slider:** ticks not showing when active ([4795044](https://github.com/vuetifyjs/vuetify/commit/47950449849a22f8c1e53cf09343cf30837be2e6))
* **v-tabs:** reset scrollOffset if not overflowing ([#3781](https://github.com/vuetifyjs/vuetify/issues/3781)) ([4e94fc9](https://github.com/vuetifyjs/vuetify/commit/4e94fc905b00f09e4f0aa7580780dd4c10314cd2)), closes [#3294](https://github.com/vuetifyjs/vuetify/issues/3294)
* **v-text-field:** add **full-width** support ([ded7cae](https://github.com/vuetifyjs/vuetify/commit/ded7caecf5148a22a9a2ac0345ba3c0d3dbf6125))
* **v-text-field:** fix input overflow ([09a872e](https://github.com/vuetifyjs/vuetify/commit/09a872e44d660323bd5c3c67235e1799821ca79a))
* **v-text-field:** fix label translate ([fd6edb6](https://github.com/vuetifyjs/vuetify/commit/fd6edb679897a7de9141c7508622f7dbb8cd8444))
* **v-text-field:** fix outline styles ([0201375](https://github.com/vuetifyjs/vuetify/commit/02013754226b4e7bdbb37417258051b9babee30f))
* **v-text-field:** wrong label position in empty time input ([#4213](https://github.com/vuetifyjs/vuetify/issues/4213)) ([3feaa64](https://github.com/vuetifyjs/vuetify/commit/3feaa640dfd8099170ff00b8626466bdb5bef477)), closes [#4187](https://github.com/vuetifyjs/vuetify/issues/4187)
* **v-text-field/area:** fix solo-inverted ([7eea1c1](https://github.com/vuetifyjs/vuetify/commit/7eea1c14ef09a12b3e7d4bd06d06c8454348e0fe))
* **v-textarea:** fix scroll top on input ([f06ae31](https://github.com/vuetifyjs/vuetify/commit/f06ae313c445d838288ae6097643c58af9640aaf)), closes [#3082](https://github.com/vuetifyjs/vuetify/issues/3082)
* **v-toolbar:** align title and buttons ([#4111](https://github.com/vuetifyjs/vuetify/issues/4111)) ([51d0736](https://github.com/vuetifyjs/vuetify/commit/51d0736d8252176f8138292d8b6c4856b9515d2b))
* **VAutocomplete:** combobox - show no-data slot if provided ([#4303](https://github.com/vuetifyjs/vuetify/issues/4303)) ([e23b870](https://github.com/vuetifyjs/vuetify/commit/e23b87064961f7601ab4d2018d57ee2a6138734d)), closes [#4220](https://github.com/vuetifyjs/vuetify/issues/4220)
* **VAutocomplete:** pass correct props in through the VSelect wrapper ([30b0ab4](https://github.com/vuetifyjs/vuetify/commit/30b0ab4a0b4e87153c0b787cc40283fc204b556e))
* **VAutocomplete:** reset selected index when input is clicked ([8407053](https://github.com/vuetifyjs/vuetify/commit/84070531213762ad13a7ffa3233cab7bf5e50bbf))
* **VAutocomplete:** update input value when items change ([#4261](https://github.com/vuetifyjs/vuetify/issues/4261)) ([99b6741](https://github.com/vuetifyjs/vuetify/commit/99b6741e9f0db27e8adbf5c4873b06e2deefc98d))
* **VDivider:** add missed v- prefixes ([3b70321](https://github.com/vuetifyjs/vuetify/commit/3b70321be5562693e0bc8982297c5428130b0881)), closes [#3752](https://github.com/vuetifyjs/vuetify/issues/3752) [#3763](https://github.com/vuetifyjs/vuetify/issues/3763)
* **VExpansionPanel:** reverse child warning message ([#4153](https://github.com/vuetifyjs/vuetify/issues/4153)) ([c580dd1](https://github.com/vuetifyjs/vuetify/commit/c580dd15f617bfe8788524878a0cb1f8741c398b))
* **VInput:** emitting click:append-outer event ([#4281](https://github.com/vuetifyjs/vuetify/issues/4281)) ([e8ceabb](https://github.com/vuetifyjs/vuetify/commit/e8ceabb04aa579d54ee2aeda4f2126b4068548aa)), closes [#4279](https://github.com/vuetifyjs/vuetify/issues/4279)
* **VInput:** prefix width ([#4292](https://github.com/vuetifyjs/vuetify/issues/4292)) ([6473444](https://github.com/vuetifyjs/vuetify/commit/6473444b3a356af24aec45320f97a008d035a807)), closes [#4271](https://github.com/vuetifyjs/vuetify/issues/4271)
* **VMenu:** add missed v- prefix to default transition name ([049d5c7](https://github.com/vuetifyjs/vuetify/commit/049d5c7b821b9c3cb02485ea0035cf5ef6b8e071)), closes [#3885](https://github.com/vuetifyjs/vuetify/issues/3885)
* **VMessage:** added overflow:hidden to prevent scrollbar ([#4262](https://github.com/vuetifyjs/vuetify/issues/4262)) ([6f7194d](https://github.com/vuetifyjs/vuetify/commit/6f7194db2683686a307d726016ccd18f64692b95)), closes [#4256](https://github.com/vuetifyjs/vuetify/issues/4256)
* **VMessages:** break long words in FF ([2388874](https://github.com/vuetifyjs/vuetify/commit/23888743866cf7c74568f3810d937bc99fbe8b10))
* **VOverflowBtn:** fix spacing (again) ([0565d37](https://github.com/vuetifyjs/vuetify/commit/0565d371e4fcc560a5da0ff7f2f159735497941b))
* **VOverflowBtn:** get correct item value and ignore search unless editable ([d1abfe6](https://github.com/vuetifyjs/vuetify/commit/d1abfe682c8af2df23c7b28ce117d31f14ad9837))
* **VSelect:** pass the attach prop through properly ([352b105](https://github.com/vuetifyjs/vuetify/commit/352b105ed00e59f396b70ede00eedf78cc1d4b31)), closes [#3616](https://github.com/vuetifyjs/vuetify/issues/3616)
* **VSelectList:** use noDataText if item slot is provided ([#4297](https://github.com/vuetifyjs/vuetify/issues/4297)) ([9d45982](https://github.com/vuetifyjs/vuetify/commit/9d45982b9ff0d89102d85ce1a0453549d2279b9d)), closes [#4217](https://github.com/vuetifyjs/vuetify/issues/4217)
* **VStepper:** Use name instead of tag name ([#4165](https://github.com/vuetifyjs/vuetify/issues/4165)) ([72b7324](https://github.com/vuetifyjs/vuetify/commit/72b7324ebda9f1feab02751ac04bb5bc6a780606))
* **VTextarea:** resize handler position ([#4293](https://github.com/vuetifyjs/vuetify/issues/4293)) ([d50953d](https://github.com/vuetifyjs/vuetify/commit/d50953d7c84ec4fb9360524c57937fc4193660c3)), closes [#4232](https://github.com/vuetifyjs/vuetify/issues/4232)
* **VTextField:** do not apply hover when hovering prepend/append icon ([#4316](https://github.com/vuetifyjs/vuetify/issues/4316)) ([f3dcd8a](https://github.com/vuetifyjs/vuetify/commit/f3dcd8aa73479381076478b00d0e7a2cc79bac7e)), closes [#4278](https://github.com/vuetifyjs/vuetify/issues/4278)
* **VTextField:** ensure comparing booleans ([a68649a](https://github.com/vuetifyjs/vuetify/commit/a68649aab8b0d1d7c54a202a53e7a2f8417c62d3))
* **VTextField:** prefix and label position tweaks ([4d6cd7b](https://github.com/vuetifyjs/vuetify/commit/4d6cd7b296643ef2ebc4dec87e52568e6e85b04f))
* enable downLevelIteration ([aee0b6a](https://github.com/vuetifyjs/vuetify/commit/aee0b6addf45cdffe0dd328d2945ed8faacfbd44))
* quotes in package.json ([dcd12d8](https://github.com/vuetifyjs/vuetify/commit/dcd12d8a9c2240513b9173d59422bf69de32a3a9))
* **btn:** Allow VBtn custom padding and fix focus effect ([#3962](https://github.com/vuetifyjs/vuetify/issues/3962)) ([6350730](https://github.com/vuetifyjs/vuetify/commit/63507301943cdcdc76c8dc4df28987446593e8fc))
* **colors:** remove duplicate mixins and fix variable scope ([02f3ad8](https://github.com/vuetifyjs/vuetify/commit/02f3ad8f565846540daad5f50b6f6620937e5b07)), closes [#3965](https://github.com/vuetifyjs/vuetify/issues/3965)
* **dev:** only use externals in production builds ([627f87f](https://github.com/vuetifyjs/vuetify/commit/627f87fe51ab32110d32f1e54c523ff56ab25908))
* **grid:** fix slot class ([6a4a598](https://github.com/vuetifyjs/vuetify/commit/6a4a59899e0b1c69424d36d816a54778b3d66521)), closes [#3946](https://github.com/vuetifyjs/vuetify/issues/3946)
* **inputs:** move styles from icon ([9bcccf3](https://github.com/vuetifyjs/vuetify/commit/9bcccf3c354049a23b6478dde9014dcc7b083d35))
* **mixins:** use mixin.options when calling directly ([1a2c54c](https://github.com/vuetifyjs/vuetify/commit/1a2c54c9eb197d2e2b60ebc540eaac0a72024bfe))
* **selectable:** add id to input ([68f1101](https://github.com/vuetifyjs/vuetify/commit/68f11017ceed6f71637b7278c9ed3bcdf3f3496e)), closes [#2119](https://github.com/vuetifyjs/vuetify/issues/2119)
* **selection_slot:** added flex ([9845859](https://github.com/vuetifyjs/vuetify/commit/984585929f4dd2dbffafb58b3e05acadf20bf8b1))
* **text-field/slider:** add/fix ([ab00c4a](https://github.com/vuetifyjs/vuetify/commit/ab00c4a7d4637c50ea98cefd3ecf49a31335eb1f)), closes [#3137](https://github.com/vuetifyjs/vuetify/issues/3137)
* **text-field/textarea:** fix styles ([18b0faf](https://github.com/vuetifyjs/vuetify/commit/18b0faf72e8972227934dba28f06751c2b5d9dac)), closes [#3821](https://github.com/vuetifyjs/vuetify/issues/3821) [#3135](https://github.com/vuetifyjs/vuetify/issues/3135) [#1829](https://github.com/vuetifyjs/vuetify/issues/1829)
* **types:** remove Partial type ([6813ddc](https://github.com/vuetifyjs/vuetify/commit/6813ddc2f627b05a137fcfbd565b71463594e890))
* **v-autocomplete:** fix multiple styles ([7704d89](https://github.com/vuetifyjs/vuetify/commit/7704d89e94167c7fe6f038a352d34299172329a7))
* **v-form:** fix validation ([468b55d](https://github.com/vuetifyjs/vuetify/commit/468b55df04135b69dcd98f852a152b75935c5dbe)), closes [#2948](https://github.com/vuetifyjs/vuetify/issues/2948)
* **v-layout:** removed max-width, added min ([2b88885](https://github.com/vuetifyjs/vuetify/commit/2b8888594b5a37c5d1b80bee6beecb0fd8d14bed)), closes [#3873](https://github.com/vuetifyjs/vuetify/issues/3873)
* **v-slider:** logic mistake ([1462546](https://github.com/vuetifyjs/vuetify/commit/1462546cda97391aee304e2d9d671bb3536ee139))
* **v-slider:** should not move thumbs when click-dragging on track ([848c244](https://github.com/vuetifyjs/vuetify/commit/848c244336fe40bc3cfde3628440b6432c91c369))
* **v-tabs:** fix centered style ([fded35b](https://github.com/vuetifyjs/vuetify/commit/fded35b8e0d50bb4e2fb49f5327c520bfa4c49bb)), closes [#3934](https://github.com/vuetifyjs/vuetify/issues/3934)
* **v-text-field:** fire change event ([47c73e6](https://github.com/vuetifyjs/vuetify/commit/47c73e69f82ac4c553e8148e1737ae35315bdb47)), closes [#2982](https://github.com/vuetifyjs/vuetify/issues/2982)
* **v-text-field:** fix box styles ([b2edce2](https://github.com/vuetifyjs/vuetify/commit/b2edce21ddbc015aca5184b0467ee8c13569e582))
* **v-textarea:** fix inner icon ([eae2b9f](https://github.com/vuetifyjs/vuetify/commit/eae2b9fe9b5ad4375c875420ce3ef451201fcffe))
* **v-textarea:** fix resize handle ([188f200](https://github.com/vuetifyjs/vuetify/commit/188f2005ea68a583affbea98789378254b610058))
* **VBreadcrumbs:** don't reuse divider VNodes ([b330fc6](https://github.com/vuetifyjs/vuetify/commit/b330fc67e250e6b951357fc879eb5a83add76cf9)), closes [#3874](https://github.com/vuetifyjs/vuetify/issues/3874)
* **VBtn:** set type of value prop to any ([afbdee5](https://github.com/vuetifyjs/vuetify/commit/afbdee563c2b204cff41eb5039c78db173807d81))
* Prevent stylus variable vs. animation name collision ("query") ([#3965](https://github.com/vuetifyjs/vuetify/issues/3965)) ([7fefff3](https://github.com/vuetifyjs/vuetify/commit/7fefff3794cb2712ca397ec6969dc383d0c8699c))
* **validatable:** change beforeMount conditional ([ad663e6](https://github.com/vuetifyjs/vuetify/commit/ad663e66499469665ce6313fbb9559e99ada882f))
* **vChip:** Border radius when inside a v-card ([#3937](https://github.com/vuetifyjs/vuetify/issues/3937)) ([661f37e](https://github.com/vuetifyjs/vuetify/commit/661f37eb0dd53d25d7dae02b051185f7e89e0add))
* **VIcon:** create a default array for children ([514c1b2](https://github.com/vuetifyjs/vuetify/commit/514c1b25052c0e95bbb07f85114e27342467a51f))
* **VMenu:** add missed v- prefix in toolbars and dialogs ([bfb503c](https://github.com/vuetifyjs/vuetify/commit/bfb503cd4dafce92da2e07b17be45d98317712d5)), closes [#3885](https://github.com/vuetifyjs/vuetify/issues/3885)
* **VSnackbar:** add missed v- prefix to transition name ([27cbe4d](https://github.com/vuetifyjs/vuetify/commit/27cbe4d9d21ea820c55c65c6805bf06659eb67a2)), closes [#3801](https://github.com/vuetifyjs/vuetify/issues/3801)
* **VTextField wrapper:** rebuild children from context.slots ([1196a7c](https://github.com/vuetifyjs/vuetify/commit/1196a7cbe4d5a0ac0c332f80c6adb9baf4204b90))
* **vTooltip:** missing lazy behavior ([#3959](https://github.com/vuetifyjs/vuetify/issues/3959)) ([700c319](https://github.com/vuetifyjs/vuetify/commit/700c31998c43c64b6b3955ef2f86df60fb1146fd))
* expand-transition error ([#3852](https://github.com/vuetifyjs/vuetify/issues/3852)) ([6dea196](https://github.com/vuetifyjs/vuetify/commit/6dea196bbdc232e2336aa349436add09865c15c3)), closes [#3812](https://github.com/vuetifyjs/vuetify/issues/3812) [#3050](https://github.com/vuetifyjs/vuetify/issues/3050)
* missed css prefix ([78c8c7b](https://github.com/vuetifyjs/vuetify/commit/78c8c7b79d83540889b0c40d9b1086e9a96f3a8a))
* missing css due to v- prefix rename ([e79df2a](https://github.com/vuetifyjs/vuetify/commit/e79df2a3f58570c9cb363bc12800aa1dec2e47c9))
* typo (del => delete) ([20df1dc](https://github.com/vuetifyjs/vuetify/commit/20df1dc582c16823c7459b03228e7401802ca600))
* **3688:** twice emitted `update:returnValue` event ([#3690](https://github.com/vuetifyjs/vuetify/issues/3690)) ([bbc2403](https://github.com/vuetifyjs/vuetify/commit/bbc24037bd1cf84242c7bf17eb9801a2b5064e22)), closes [#3688](https://github.com/vuetifyjs/vuetify/issues/3688)
* **detachable:** apply lazy behavior to initDetach ([#3593](https://github.com/vuetifyjs/vuetify/issues/3593)) ([ee2f21f](https://github.com/vuetifyjs/vuetify/commit/ee2f21f868c7f1b1778884a5a2a12cfd26b314ca)), closes [#3570](https://github.com/vuetifyjs/vuetify/issues/3570)
* **goTo:** validate target correctly when vue is minified ([#3638](https://github.com/vuetifyjs/vuetify/issues/3638)) ([568248f](https://github.com/vuetifyjs/vuetify/commit/568248f64d7ec5554825e628d61469b1f14db569)), closes [#3611](https://github.com/vuetifyjs/vuetify/issues/3611)
* **icons:** added missing key ([7b1d18f](https://github.com/vuetifyjs/vuetify/commit/7b1d18fdde3812e7ab6ac4a06ff1a91c32c8c1e8))
* **rippleable:** added explicit click event ([#3556](https://github.com/vuetifyjs/vuetify/issues/3556)) ([2aa07de](https://github.com/vuetifyjs/vuetify/commit/2aa07de115c4c03c9d45f6f6ad782ef566a5b2e5)), closes [#3554](https://github.com/vuetifyjs/vuetify/issues/3554)
* **styles:** fixed missed merge ([be91db9](https://github.com/vuetifyjs/vuetify/commit/be91db98a246d3cd9f51a0cacad70736226668ae))
* **tabs:** fixed twice emit input ([#3561](https://github.com/vuetifyjs/vuetify/issues/3561)) ([2cf0ba2](https://github.com/vuetifyjs/vuetify/commit/2cf0ba26116d6b5d263a30d6ce93cbe400cc0e07))
* **v-menu:** changed implementation for 15a5d76 ([45d4fa9](https://github.com/vuetifyjs/vuetify/commit/45d4fa91e2d9fafc9e14b4517b427b0c9f43df19)), closes [#3653](https://github.com/vuetifyjs/vuetify/issues/3653)
* **v-message:** fixed transition between items ([fd28679](https://github.com/vuetifyjs/vuetify/commit/fd28679a3c573b714546ae73245c2dc7ca5e8352))
* **v-messages:** fixed transition ([78ec288](https://github.com/vuetifyjs/vuetify/commit/78ec28855431fe6cffa1d36470701beae911cdf9))
* **v-pagination:** fixed responsive pagination ([#3843](https://github.com/vuetifyjs/vuetify/issues/3843)) ([cf32d90](https://github.com/vuetifyjs/vuetify/commit/cf32d903f630fe0e7675ba72dd4a395056d67d0d)), closes [#3759](https://github.com/vuetifyjs/vuetify/issues/3759)
* **v-radio-group:** added missing functionality ([78964e3](https://github.com/vuetifyjs/vuetify/commit/78964e36893f34021989feb9e588d23dac0b76f9))
* **VBreadcrumbs:** only create dividers for v-breadcrumbs-item ([#3854](https://github.com/vuetifyjs/vuetify/issues/3854)) ([9ab4645](https://github.com/vuetifyjs/vuetify/commit/9ab4645df8596b2a637238cc4df891311dd1aa6c))
* zero-width activator when edit-dialog input is empty ([#3848](https://github.com/vuetifyjs/vuetify/issues/3848)) ([662eaa0](https://github.com/vuetifyjs/vuetify/commit/662eaa0492aa00c4e7025c684a55504d402a05a9)), closes [#1795](https://github.com/vuetifyjs/vuetify/issues/1795)
* **v-menu:** fixed locking scroll ([15a5d76](https://github.com/vuetifyjs/vuetify/commit/15a5d761d66e4fc557580619451f217f15e68686))
* **v-radio-group:** fixed row wrap on smaller screens ([5ccad87](https://github.com/vuetifyjs/vuetify/commit/5ccad8796115f976a17fce33adfae809cc546570))
* **v-select-list:** avatar prop requires boolean ([b43b3cf](https://github.com/vuetifyjs/vuetify/commit/b43b3cf061425f671d674d2837d867afb3f597b6))
* **v-slider:** hide label if none provided ([a094c07](https://github.com/vuetifyjs/vuetify/commit/a094c0741a798438a0e7da5feea3b0a83b1fa5e3))
* **v-tab:** fixed resolve comparison and args ([#3667](https://github.com/vuetifyjs/vuetify/issues/3667)) ([9cc70e4](https://github.com/vuetifyjs/vuetify/commit/9cc70e458962d3c0e73903c9dcf2721db0e60eef)), closes [#3654](https://github.com/vuetifyjs/vuetify/issues/3654)
* **v-tab:** updated logic for determining action ([#3575](https://github.com/vuetifyjs/vuetify/issues/3575)) ([2874fa3](https://github.com/vuetifyjs/vuetify/commit/2874fa341beaf35b0f4edd2f26918280835e9ee5)), closes [#3418](https://github.com/vuetifyjs/vuetify/issues/3418)
* **v-tabs:** avoid referencing undefined obj ([06df9b1](https://github.com/vuetifyjs/vuetify/commit/06df9b121f15a29ac16e73b50584f14627200296)), closes [#3581](https://github.com/vuetifyjs/vuetify/issues/3581)
* **v-tabs:** fixed dynamic arrows ([#3623](https://github.com/vuetifyjs/vuetify/issues/3623)) ([fb840bf](https://github.com/vuetifyjs/vuetify/commit/fb840bf7d989c1faab522c57f1330b717cd12028)), closes [#3620](https://github.com/vuetifyjs/vuetify/issues/3620)
* **v-tabs:** moved setWidths call location ([9239c89](https://github.com/vuetifyjs/vuetify/commit/9239c89115ca6c37ff10e9bfaca64d0ca5b18b93)), closes [#3838](https://github.com/vuetifyjs/vuetify/issues/3838)
* **v-tabs:** recalculate overflow on tabs change ([#3728](https://github.com/vuetifyjs/vuetify/issues/3728)) ([46c7335](https://github.com/vuetifyjs/vuetify/commit/46c73351d56345013d60d34177e55769d6369064)), closes [#3643](https://github.com/vuetifyjs/vuetify/issues/3643)
* **v-text-field:** fixed icon generation logic ([579e417](https://github.com/vuetifyjs/vuetify/commit/579e4176b32200dd44ce141fc9fca9edddd439e1))
* **VMenu:** use will-change instead of translate hack ([9e044d5](https://github.com/vuetifyjs/vuetify/commit/9e044d5fd387d443262b5f0abe90e2cac1953660))
* missing args in text field wrapper render function ([5a6a861](https://github.com/vuetifyjs/vuetify/commit/5a6a861b7314769cd3ec550e4fa2dd7f2d151c99))
* missing args in text field wrapper render function ([35ad4df](https://github.com/vuetifyjs/vuetify/commit/35ad4df1d80a9917f44f458ec90af56ca13e3a1d))
* **v-text-field:** added proper text wrap ([a5c2fa6](https://github.com/vuetifyjs/vuetify/commit/a5c2fa6f3b801776a4827816af68809bc03f7e16))
* **VDialog:** inherit z-index from wrapper ([#3639](https://github.com/vuetifyjs/vuetify/issues/3639)) ([d6e6611](https://github.com/vuetifyjs/vuetify/commit/d6e66113a1cc0ec9c6f610e2fdf2f804262ad252)), closes [#2111](https://github.com/vuetifyjs/vuetify/issues/2111)
* **VProgressCircular:** width relative to progress size ([#3661](https://github.com/vuetifyjs/vuetify/issues/3661)) ([b79f721](https://github.com/vuetifyjs/vuetify/commit/b79f72183041c07c3e70281b63d246199caa1ebc)), closes [#3557](https://github.com/vuetifyjs/vuetify/issues/3557)
* **VTabs:** update slider position after resize timeout ([#3640](https://github.com/vuetifyjs/vuetify/issues/3640)) ([7cd4ad8](https://github.com/vuetifyjs/vuetify/commit/7cd4ad8780914fe7dcb3c294d96c4587a85f42a4)), closes [#3637](https://github.com/vuetifyjs/vuetify/issues/3637)
* [#3625](https://github.com/vuetifyjs/vuetify/issues/3625) - image-links with parentheses aren't recognized ([#3626](https://github.com/vuetifyjs/vuetify/issues/3626)) ([5a1b0c8](https://github.com/vuetifyjs/vuetify/commit/5a1b0c8f1547ad1b146486f1ca781b8ae636c474))
* **$data-iterator:** changed watcher ([#3513](https://github.com/vuetifyjs/vuetify/issues/3513)) ([e57229d](https://github.com/vuetifyjs/vuetify/commit/e57229d09e33a920575f0fdaa3c4b2edff513d4f)), closes [#3511](https://github.com/vuetifyjs/vuetify/issues/3511)
* **$goTo:** fixed negative scroll and cleaned up process ([#3542](https://github.com/vuetifyjs/vuetify/issues/3542)) ([db7fa2a](https://github.com/vuetifyjs/vuetify/commit/db7fa2afefbc3bd460ac0288d3d6b6e55f739647)), closes [#3384](https://github.com/vuetifyjs/vuetify/issues/3384)
* **$stepper-step:** removed import from merge ([d631741](https://github.com/vuetifyjs/vuetify/commit/d6317419f3e4ee4561475b6ee935f112ba52e506))
* **applicationable:** updated process ([#3365](https://github.com/vuetifyjs/vuetify/issues/3365)) ([19281b1](https://github.com/vuetifyjs/vuetify/commit/19281b17a89d895948c2b6de5838a52c10827ad0)), closes [#3347](https://github.com/vuetifyjs/vuetify/issues/3347)
* **build:** remove CSS sourcemaps from production builds ([#3441](https://github.com/vuetifyjs/vuetify/issues/3441)) ([6273097](https://github.com/vuetifyjs/vuetify/commit/62730974723d448737ceeda2bf9f8dffdadc56ea)), closes [#3403](https://github.com/vuetifyjs/vuetify/issues/3403)
* **build:** use babel-transform-define instead of webpack.DefinePlugin ([f22e9aa](https://github.com/vuetifyjs/vuetify/commit/f22e9aaec57513c73ee9469abd52c3db60438a27)), closes [vuetifyjs/nuxt#27](https://github.com/vuetifyjs/nuxt/issues/27) [vuetifyjs/nuxt#28](https://github.com/vuetifyjs/nuxt/issues/28) [vuetifyjs/webpack#5](https://github.com/vuetifyjs/webpack/issues/5)
* **click-outside:** check clicked element instead of position ([559c579](https://github.com/vuetifyjs/vuetify/commit/559c5799ebc383ec1de7c4780facbece3ec6992b))
* **DataIterable:** Update selection when items change. ([#6097](https://github.com/vuetifyjs/vuetify/issues/6097)) ([33f4033](https://github.com/vuetifyjs/vuetify/commit/33f403342d3eccbd1a445c4c676bf8b02bce8303))
* **dependent:** don't close if a child's overlay is clicked ([dbe3213](https://github.com/vuetifyjs/vuetify/commit/dbe3213d7322e115526251be2dca61b66f756a2e)), closes [#5310](https://github.com/vuetifyjs/vuetify/issues/5310)
* **detachable:** allow any object in the attach prop ([#3241](https://github.com/vuetifyjs/vuetify/issues/3241)) ([cc0092e](https://github.com/vuetifyjs/vuetify/commit/cc0092e18b23e064155e0d51e407934a5c7887f6))
* **detachable:** remove detached activator element on destroy ([8875f68](https://github.com/vuetifyjs/vuetify/commit/8875f68fbd0d8b4a1691bc4aeac7e3cd020ceff8)), closes [#6568](https://github.com/vuetifyjs/vuetify/issues/6568)
* **dialog:** flex ignores width with scrollable dialogs([#6480](https://github.com/vuetifyjs/vuetify/issues/6480)) ([592e3f4](https://github.com/vuetifyjs/vuetify/commit/592e3f4c57fcea14f65ae064768c357b1c7b4a02))
* **divider:** resolve sass variable build error ([05c79e9](https://github.com/vuetifyjs/vuetify/commit/05c79e9e33d4973a632c61bb240ff7332d5be2f9))
* **entry-lib:** fix directives export ([635537e](https://github.com/vuetifyjs/vuetify/commit/635537e3f8e43e2adaa42b058d59f3c55dcf5bda))
* **grid:** partial revert of [#3491](https://github.com/vuetifyjs/vuetify/issues/3491) ([c4775e4](https://github.com/vuetifyjs/vuetify/commit/c4775e4d9ecb749b45fb53ac125f5f32b3c44218))
* **grid:** prevent .flex from growing instead of using max-width ([#3491](https://github.com/vuetifyjs/vuetify/issues/3491)) ([8e83ce6](https://github.com/vuetifyjs/vuetify/commit/8e83ce627abe898704157b21550b23fc2efd77cb)), closes [#3470](https://github.com/vuetifyjs/vuetify/issues/3470)
* **helpers:** detect legacy non-scoped slots correctly ([0d3ab63](https://github.com/vuetifyjs/vuetify/commit/0d3ab63fd335d87cc86b4fa7d535c9fe68843e4b))
* **locale:** improve polish translation ([eb64675](https://github.com/vuetifyjs/vuetify/commit/eb64675b44e9f1e474184e626ba2c1a5cfb20f92))
* **menuable:** use activatorNode.elm if activated externally ([8bf9e28](https://github.com/vuetifyjs/vuetify/commit/8bf9e28feddd5351f6414f24d05a6a7c8dc2876d))
* **progressbar:** center inner content ([#6712](https://github.com/vuetifyjs/vuetify/issues/6712)) ([27c3242](https://github.com/vuetifyjs/vuetify/commit/27c32422a3cd37b26e55b6a64ba97033beab98a3))
* **ripple:** allow getComputedStyle to return null ([#6639](https://github.com/vuetifyjs/vuetify/issues/6639)) ([0bf395c](https://github.com/vuetifyjs/vuetify/commit/0bf395caed281ed32941bff6a7eb14f566705200))
* **ripple:** check for undefined el._ripple ([#6698](https://github.com/vuetifyjs/vuetify/issues/6698)) ([3310920](https://github.com/vuetifyjs/vuetify/commit/3310920a80bc31858bc9517ed7a43dbe499c6f74)), closes [#6477](https://github.com/vuetifyjs/vuetify/issues/6477)
* **ripple:** ensure _ripple data exists ([#6476](https://github.com/vuetifyjs/vuetify/issues/6476)) ([0cd5671](https://github.com/vuetifyjs/vuetify/commit/0cd56717b0b4334c78e8e99dc7bad6b7dc479d0b))
* **snackbar:** don't allow buttons to grow ([94de39f](https://github.com/vuetifyjs/vuetify/commit/94de39f0f6fb357dedf9eb3a556c094af374af8b)), closes [#3363](https://github.com/vuetifyjs/vuetify/issues/3363)
* **speed-dial:** add z-index and remove btn margin when fixed ([#3489](https://github.com/vuetifyjs/vuetify/issues/3489)) ([f2d2139](https://github.com/vuetifyjs/vuetify/commit/f2d2139ecca3b805ab014f82a8d52a7bf40c23a5)), closes [#3414](https://github.com/vuetifyjs/vuetify/issues/3414)
* **ssr:** allow theme to be applied with vue-meta ([#3314](https://github.com/vuetifyjs/vuetify/issues/3314)) ([2256b13](https://github.com/vuetifyjs/vuetify/commit/2256b136dd7f923ec37ff1421c499a436a9700b1)), closes [#3329](https://github.com/vuetifyjs/vuetify/issues/3329)
* **stackable:** move stack classes to explicit values ([7dad5e9](https://github.com/vuetifyjs/vuetify/commit/7dad5e9df9cfdfb49cc4a3a5e12b63c066398ca3)), closes [#5141](https://github.com/vuetifyjs/vuetify/issues/5141)
* **stackable:** return a z-index of 0 in SSR) ([ee7ad4f](https://github.com/vuetifyjs/vuetify/commit/ee7ad4f61b1c78acf34d2a5a5633da1556aa3c78)), closes [#3242](https://github.com/vuetifyjs/vuetify/issues/3242)
* **tabs:** fixed twice call tabClick ([#3494](https://github.com/vuetifyjs/vuetify/issues/3494)) ([d8faedc](https://github.com/vuetifyjs/vuetify/commit/d8faedc46fcb084ffd5939ec6486410199f3f268))
* **tabs:** render all other elements in the tabs container ([#3442](https://github.com/vuetifyjs/vuetify/issues/3442)) ([b14ab29](https://github.com/vuetifyjs/vuetify/commit/b14ab298ef778e2655bca0d1e683d2370f9a22c1)), closes [#3434](https://github.com/vuetifyjs/vuetify/issues/3434)
* **text:** don't cut off bottom parts of letters with text-truncate ([8161cc0](https://github.com/vuetifyjs/vuetify/commit/8161cc0ec1d1650b2a3f04516a7b68a9e1b99263)), closes [#6488](https://github.com/vuetifyjs/vuetify/issues/6488)
* **text-field:** add color and file to dirty types ([#3490](https://github.com/vuetifyjs/vuetify/issues/3490)) ([b083b4e](https://github.com/vuetifyjs/vuetify/commit/b083b4e3cf60c6eea54bd1a3e79511909a8585eb)), closes [#3467](https://github.com/vuetifyjs/vuetify/issues/3467)
* **theme:** only apply theme to head element when not using vue-meta ([#3440](https://github.com/vuetifyjs/vuetify/issues/3440)) ([be3b233](https://github.com/vuetifyjs/vuetify/commit/be3b233b26353ca58dd0c2fe5db051b4ab2b4fc4)), closes [#3405](https://github.com/vuetifyjs/vuetify/issues/3405)
* **v-btn:** added missing component import ([ee3f9bd](https://github.com/vuetifyjs/vuetify/commit/ee3f9bd4b50200c8c5cc934b3c9f7f1da31512ad)), closes [#3391](https://github.com/vuetifyjs/vuetify/issues/3391)
* **v-btn:** properly hooked up active-class ([f0a0ca0](https://github.com/vuetifyjs/vuetify/commit/f0a0ca0f80518d5fc2a5e071a89fe375c4ebb2cf))
* **v-list-tile:** force remove pointer-events ([c7c3df3](https://github.com/vuetifyjs/vuetify/commit/c7c3df38c1e0eb34bd918ee48ac112f39a85cdac)), closes [#3387](https://github.com/vuetifyjs/vuetify/issues/3387)
* **v-select:** removed useless operation ([#3231](https://github.com/vuetifyjs/vuetify/issues/3231)) ([acb2e66](https://github.com/vuetifyjs/vuetify/commit/acb2e66f98dd5658b2f79c79a73737813bd6f980)), closes [#3151](https://github.com/vuetifyjs/vuetify/issues/3151)
* **v-tab:** added back removed nextTick ([#3232](https://github.com/vuetifyjs/vuetify/issues/3232)) ([3e3ae40](https://github.com/vuetifyjs/vuetify/commit/3e3ae40e50b30cb7bd58a8e4d8e68ab184044aba)), closes [#3203](https://github.com/vuetifyjs/vuetify/issues/3203)
* **v-tabs:** updated booting process ([#3234](https://github.com/vuetifyjs/vuetify/issues/3234)) ([3fc70d8](https://github.com/vuetifyjs/vuetify/commit/3fc70d8fa7eee94a63a86ede7767be71bfa4478b)), closes [#3174](https://github.com/vuetifyjs/vuetify/issues/3174)
* **v-tabs:** updated computed prop ([fcb0b4b](https://github.com/vuetifyjs/vuetify/commit/fcb0b4bfdd82c5ae59b0cd5624483cba2b7ff2f2)), closes [#3270](https://github.com/vuetifyjs/vuetify/issues/3270)
* **v-toolbar:** added back missing functionality ([1822153](https://github.com/vuetifyjs/vuetify/commit/1822153bc4763dc30b3bb704107bf1f6f97ae5ec)), closes [#3484](https://github.com/vuetifyjs/vuetify/issues/3484)
* **v-tooltip:** fix alignment issue caused by `v-tooltip` ([becd484](https://github.com/vuetifyjs/vuetify/commit/becd4843fdd766e4a59ee2dbd99760f18db7d340)), closes [#3222](https://github.com/vuetifyjs/vuetify/issues/3222) [#3267](https://github.com/vuetifyjs/vuetify/issues/3267) [#3272](https://github.com/vuetifyjs/vuetify/issues/3272)
* **v-tooltip:** fixed tooltip height ([#3222](https://github.com/vuetifyjs/vuetify/issues/3222)) ([f021e5b](https://github.com/vuetifyjs/vuetify/commit/f021e5b37b676aa460da8fd143a89a8aba5c76f6)), closes [#3205](https://github.com/vuetifyjs/vuetify/issues/3205)
* **VAppBar:** allow menu to overflow ([ff4cfd3](https://github.com/vuetifyjs/vuetify/commit/ff4cfd3ff2494621f2788ab0dff635471c222e24))
* **VAppBar:** let elevate-on-scroll and hide-on-scroll work together ([8581e19](https://github.com/vuetifyjs/vuetify/commit/8581e1919d9f87b6844b90a518aa70f9ff8c60b6))
* **VAutocomplete:** retain filtered list on item selection ([#6388](https://github.com/vuetifyjs/vuetify/issues/6388)) ([3b184b4](https://github.com/vuetifyjs/vuetify/commit/3b184b40df314ca301eb19a54840acab13e47cfe)), closes [#6260](https://github.com/vuetifyjs/vuetify/issues/6260)
* **VBadge:** fix invalid height when wrapping spans ([ae12eaf](https://github.com/vuetifyjs/vuetify/commit/ae12eafaea7ea1df7b4eed846751ac9dfe29ea31))
* **VBanner:** flexbox related issues with IE11 ([#6686](https://github.com/vuetifyjs/vuetify/issues/6686)) ([748e480](https://github.com/vuetifyjs/vuetify/commit/748e4803953bcbad3e1a6edbe36ef0c1b806652e))
* **VBreadcrumbs:** remove deprecated method ([20cf338](https://github.com/vuetifyjs/vuetify/commit/20cf338d49f85d8b46945cfd1e2332c331d98793))
* **VBreadcrumbs:** v-for key error when two items have identical texts ([#6642](https://github.com/vuetifyjs/vuetify/issues/6642)) ([2146ca8](https://github.com/vuetifyjs/vuetify/commit/2146ca88409eb30d42cab1328803295835faeb04)), closes [#5454](https://github.com/vuetifyjs/vuetify/issues/5454)
* **VBtn:** correct fab box-shadow ([#3525](https://github.com/vuetifyjs/vuetify/issues/3525)) ([dfa671a](https://github.com/vuetifyjs/vuetify/commit/dfa671a535e6408b1309027ecdc2d6e521439b0a)), closes [#3524](https://github.com/vuetifyjs/vuetify/issues/3524)
* **VBtn:** hide hover overlay on touch devices ([6ed5cc6](https://github.com/vuetifyjs/vuetify/commit/6ed5cc6142423df131df490030e30dae4c28918b)), closes [#2178](https://github.com/vuetifyjs/vuetify/issues/2178)
* **VBtn:** use correct icon color with **icon** prop ([e27a6f5](https://github.com/vuetifyjs/vuetify/commit/e27a6f540d62e62d18473a5246843f7b0b30fe15))
* **VCalendar:** fix snapshots ([9cca725](https://github.com/vuetifyjs/vuetify/commit/9cca7250f51ae46972b18e3b9771cc55f6859d2f))
* **VCalendar:** fix tests ([9426508](https://github.com/vuetifyjs/vuetify/commit/942650893aa6b0604fa5a0989b982dce3fab76aa))
* **VCalendar:** input generates correct type ([#6434](https://github.com/vuetifyjs/vuetify/issues/6434)) ([#6482](https://github.com/vuetifyjs/vuetify/issues/6482)) ([620b823](https://github.com/vuetifyjs/vuetify/commit/620b823c8973be76fc6daf582f951bc41108322b))
* **VCarousel:** add aria-label on controls ([#6498](https://github.com/vuetifyjs/vuetify/issues/6498)) ([d61ee0e](https://github.com/vuetifyjs/vuetify/commit/d61ee0e2d14efc1cb959194686a4cfe16e787a23))
* **VCarousel:** transition direction when outside button click ([#6515](https://github.com/vuetifyjs/vuetify/issues/6515)) ([6219ad0](https://github.com/vuetifyjs/vuetify/commit/6219ad0e4ca243e0ed5ec47b36d97d800c74cfd9))
* **VDataTable:** add horizontal overflow scroll ([bde7c8f](https://github.com/vuetifyjs/vuetify/commit/bde7c8fa4631b6e6baec9ae70d63c562b3bff34f))
* **VDataTable:** update lang function ([a73e076](https://github.com/vuetifyjs/vuetify/commit/a73e0764be4fce051a9808b2d6ce7bcfd2f086b2))
* **VDatePicker:** tableDate gets invalid value when changing year ([262a702](https://github.com/vuetifyjs/vuetify/commit/262a702eb66bdd9bad9802c3cc1b5f8d456e3385)), closes [#6689](https://github.com/vuetifyjs/vuetify/issues/6689)
* **VDatePicker:** wrong date when changing month in reactive picker ([7885aaf](https://github.com/vuetifyjs/vuetify/commit/7885aafa0e14d703e553e225d7fbe7f3b1b59226)), closes [#6461](https://github.com/vuetifyjs/vuetify/issues/6461)
* **VDatePickerYears:** year picker is not scrolled to the selected year ([a41f23d](https://github.com/vuetifyjs/vuetify/commit/a41f23db2eba683ede4f3ed9a7c8d57ccc1f0415)), closes [#6367](https://github.com/vuetifyjs/vuetify/issues/6367)
* **VDialog:** close when escape is pressed ([c64ed2a](https://github.com/vuetifyjs/vuetify/commit/c64ed2aa91d333dd8d7f8f6df2b19ec5655af31c)), closes [#6352](https://github.com/vuetifyjs/vuetify/issues/6352)
* **VDialog:** focus the first child when tab leaves the dialog ([2d5d72b](https://github.com/vuetifyjs/vuetify/commit/2d5d72b83e42ac086b793f34301926d660c511a0)), closes [#2538](https://github.com/vuetifyjs/vuetify/issues/2538)
* **VDialog, VMenu:** focus activator when closed with esc ([cef2d1d](https://github.com/vuetifyjs/vuetify/commit/cef2d1d09ecd5eec1c2a5598ba79d5c9bd0987e5))
* **VDialog,VMenu,VTooltip:** work around vue 2.6.4 $slots change ([a865794](https://github.com/vuetifyjs/vuetify/commit/a865794bb4187074c51f2a804e813c06a711e0f7)), closes [#6440](https://github.com/vuetifyjs/vuetify/issues/6440)
* **VFooter:** update application after mount when using auto height ([#3295](https://github.com/vuetifyjs/vuetify/issues/3295)) ([c968a9a](https://github.com/vuetifyjs/vuetify/commit/c968a9a06be362522505156221e47e589b325201))
* **VGrid:** apply !important to helper classes ([4893523](https://github.com/vuetifyjs/vuetify/commit/48935235d71766864e7a9dd4bf68aa371a407107))
* **VIcon:** fix theme ([8f04200](https://github.com/vuetifyjs/vuetify/commit/8f042008dbcca09d3e5d92daaf2455ec225f619d))
* **VItemGroup:** return proper selected values when value is undefined ([054edba](https://github.com/vuetifyjs/vuetify/commit/054edbadbe05d2c9e137b0fb57b492760cabc558))
* **VItemGroup:** select first non-disabled item with **mandatory** prop ([6d1615f](https://github.com/vuetifyjs/vuetify/commit/6d1615f52567378cfae89801b7906a870b342b17))
* **VList:** resize `v-subheader` children when using **dense** prop ([663c584](https://github.com/vuetifyjs/vuetify/commit/663c5848dd7c866149b60f92d28aff3324047be6))
* **VListItem:** text-cutoff on title ([c1bcc05](https://github.com/vuetifyjs/vuetify/commit/c1bcc05609ff20812a2963a02f0a4c46e8304135))
* **VMenu:** account for minWidth when setting initial position ([591779a](https://github.com/vuetifyjs/vuetify/commit/591779ac5856038df3b9839439b8b7801aa6204a)), closes [#3438](https://github.com/vuetifyjs/vuetify/issues/3438)
* **VMenu:** delay closing when save is called ([74e0bd1](https://github.com/vuetifyjs/vuetify/commit/74e0bd16d815f45d237a6320432976b46923a661)), closes [#5200](https://github.com/vuetifyjs/vuetify/issues/5200)
* **VMenu:** limit to screen width ([d19ddba](https://github.com/vuetifyjs/vuetify/commit/d19ddbae06d8790cf3871e87a585ec3016f21393))
* **VMenu:** respond to keydown when using scoped activator slot ([1b4dbae](https://github.com/vuetifyjs/vuetify/commit/1b4dbae58cbfdeda4edbc14104a53ce9c0a36f62)), closes [#6621](https://github.com/vuetifyjs/vuetify/issues/6621)
* **VMenu, VTooltip:** detect when activator has position:fixed ([#6460](https://github.com/vuetifyjs/vuetify/issues/6460)) ([700bb49](https://github.com/vuetifyjs/vuetify/commit/700bb49e87fc144063ea93c3d82d1113f0b66e85)), closes [#6471](https://github.com/vuetifyjs/vuetify/issues/6471) [#1551](https://github.com/vuetifyjs/vuetify/issues/1551)
* **VPagination:** remove unnecessary outline for circle pagination buttons. ([#6513](https://github.com/vuetifyjs/vuetify/issues/6513)) ([b00abfe](https://github.com/vuetifyjs/vuetify/commit/b00abfe26b8aead84230cc6c94cd3363f5174c76))
* **VSelect:** disable the menu transition with false instead of '' ([#3527](https://github.com/vuetifyjs/vuetify/issues/3527)) ([b8c6db4](https://github.com/vuetifyjs/vuetify/commit/b8c6db48165e867230eeed311991dba25a89de29)), closes [#3526](https://github.com/vuetifyjs/vuetify/issues/3526)
* **VSelect:** keep menu closed when removing chip items. ([#6845](https://github.com/vuetifyjs/vuetify/issues/6845)) ([a4761cb](https://github.com/vuetifyjs/vuetify/commit/a4761cb341a64749a33b8a2312f3ecd6be3843d6)), closes [#6844](https://github.com/vuetifyjs/vuetify/issues/6844)
* **VSheet:** listen to events ([#6573](https://github.com/vuetifyjs/vuetify/issues/6573)) ([66ca89d](https://github.com/vuetifyjs/vuetify/commit/66ca89dd942bfaeb5b971c9cab7705d314fcb709)), closes [#6572](https://github.com/vuetifyjs/vuetify/issues/6572)
* **VSheet/ripple:** ensure sheets are always block level elements ([f67f17f](https://github.com/vuetifyjs/vuetify/commit/f67f17f32f40b1ceaf435d8ed681772c567dcfef))
* **VSheet/VCard:** animate on elevation change ([152874e](https://github.com/vuetifyjs/vuetify/commit/152874ecae22bf770e0d4345072a34d237489af1))
* **VSlider:** make sure stars do not wrap ([c92e569](https://github.com/vuetifyjs/vuetify/commit/c92e569ab0446ad9276e640c90d67a6744a45957)), closes [#6481](https://github.com/vuetifyjs/vuetify/issues/6481)
* **VSlider:** set value to min if it's less than min ([#6604](https://github.com/vuetifyjs/vuetify/issues/6604)) ([#6605](https://github.com/vuetifyjs/vuetify/issues/6605)) ([91eb0db](https://github.com/vuetifyjs/vuetify/commit/91eb0db075040a837d627beed3803789d9adbdf6))
* **VSpeedDial:** fixed transition animation ([#6373](https://github.com/vuetifyjs/vuetify/issues/6373)) ([7e0a521](https://github.com/vuetifyjs/vuetify/commit/7e0a521e29f12c2e62b5ce0525452e00fa401f81))
* **VTextField:** allow error container to shrink ([#3529](https://github.com/vuetifyjs/vuetify/issues/3529)) ([6feb183](https://github.com/vuetifyjs/vuetify/commit/6feb183440ecd1d56ab20b36a24eda8866c95905)), closes [#3381](https://github.com/vuetifyjs/vuetify/issues/3381)
* **VTextField:** force validation with validate-on-blur ([#4260](https://github.com/vuetifyjs/vuetify/issues/4260)) ([0f6be51](https://github.com/vuetifyjs/vuetify/commit/0f6be518b388845ee7d270193d3df782d7c0bc88)), closes [#4247](https://github.com/vuetifyjs/vuetify/issues/4247)
* **VTextField:** invalid label position with placeholder ([#4270](https://github.com/vuetifyjs/vuetify/issues/4270)) ([d881d44](https://github.com/vuetifyjs/vuetify/commit/d881d44d1631510b110197c91b318cedb0bc51f2))
* **VTextField:** properly align suffix in filled variant ([126f891](https://github.com/vuetifyjs/vuetify/commit/126f8918208a06f86e99188d216abcd251ef9570)), closes [#7871](https://github.com/vuetifyjs/vuetify/issues/7871)
* **VTextField:** recalculate prefix on change ([f9049b3](https://github.com/vuetifyjs/vuetify/commit/f9049b3e0e858a72d25c1fe12d5bc46e232f2ebd)), closes [#8268](https://github.com/vuetifyjs/vuetify/issues/8268)
* **VTextField:** show correct deprecation notices for icon props ([fcefbcb](https://github.com/vuetifyjs/vuetify/commit/fcefbcb2a97e5f63ad213f69ddd449b54ef378fa)), closes [#4254](https://github.com/vuetifyjs/vuetify/issues/4254)
* **VTimePickerClock:** dont switch to minutes if clicked disabled hour ([#4304](https://github.com/vuetifyjs/vuetify/issues/4304)) ([aaeca1f](https://github.com/vuetifyjs/vuetify/commit/aaeca1f808794b6d60066de93aa996ab2f9d71ef)), closes [#4196](https://github.com/vuetifyjs/vuetify/issues/4196)
* **VTimePickerClock:** invalid values can be selected ([d41f1c1](https://github.com/vuetifyjs/vuetify/commit/d41f1c18547b7cf189a2c804a88d6d57d45c5d85)), closes [#5897](https://github.com/vuetifyjs/vuetify/issues/5897)
* **VToolbar:** use computed height for root element ([6332259](https://github.com/vuetifyjs/vuetify/commit/63322596699c91d9726d76423e9bf7c1ba1fff35)), closes [#8101](https://github.com/vuetifyjs/vuetify/issues/8101)
* **VTooltip:** bring back automatic fixed positioning ([#8887](https://github.com/vuetifyjs/vuetify/issues/8887)) ([57c084a](https://github.com/vuetifyjs/vuetify/commit/57c084a66f3a58b5ec590d3dcb71b829976789a0)), closes [#8894](https://github.com/vuetifyjs/vuetify/issues/8894) [#6460](https://github.com/vuetifyjs/vuetify/issues/6460)
* **VTooltip:** min width is not applied ([#6622](https://github.com/vuetifyjs/vuetify/issues/6622)) ([b95b76e](https://github.com/vuetifyjs/vuetify/commit/b95b76ef5fa4cc158ed8d3a0baad31a532089d61))
* **VTreeviewNode:** allow empty children item to behave as leaf ([#9082](https://github.com/vuetifyjs/vuetify/issues/9082)) ([8555450](https://github.com/vuetifyjs/vuetify/commit/855545064a5fa5acec7fa517eea4d68c63f2a3c0)), closes [#9043](https://github.com/vuetifyjs/vuetify/issues/9043)
* **Vuetify:** reintroduced browser installation of Vuetify ([7892e0a](https://github.com/vuetifyjs/vuetify/commit/7892e0a87557c1f46812225b02289b0c18200e09))
* **VuetifyGoToOptions:** add missing properties to types ([ee1078f](https://github.com/vuetifyjs/vuetify/commit/ee1078f27b99cfb745e1c74ba7abbabd7ba9deaf))
* add names back to mixins ([3e5ffa2](https://github.com/vuetifyjs/vuetify/commit/3e5ffa2e3c7c2505862f81d4e1d59dfb235c3442))
* add non-default exports for single components ([70dfc11](https://github.com/vuetifyjs/vuetify/commit/70dfc11d25ca8b22350487e81ffaa923e39933c5)), closes [#4149](https://github.com/vuetifyjs/vuetify/issues/4149)
* cast version parts to string before comparing ([39e0641](https://github.com/vuetifyjs/vuetify/commit/39e064145ede222420d55ca6058a18a3ed58e9ef))
* centers active year in date picker ([#4046](https://github.com/vuetifyjs/vuetify/issues/4046)) ([78cda73](https://github.com/vuetifyjs/vuetify/commit/78cda7319932f741f54a12d4822f6545b1a69c94)), closes [#3828](https://github.com/vuetifyjs/vuetify/issues/3828)
* correct type definition for $vuetidy.goTo ([c5cb1db](https://github.com/vuetifyjs/vuetify/commit/c5cb1db35f0a5616e9cfb6a4a8a9601c685a8a50)), closes [#3200](https://github.com/vuetifyjs/vuetify/issues/3200)
* don't switch to hours after selecting minutes ([#4198](https://github.com/vuetifyjs/vuetify/issues/4198)) ([97db26d](https://github.com/vuetifyjs/vuetify/commit/97db26d03b809ea7d85c3f98dd6e109ecdf10fdc)), closes [#3371](https://github.com/vuetifyjs/vuetify/issues/3371)
* export vuetify class from entry-lib ([314eb8a](https://github.com/vuetifyjs/vuetify/commit/314eb8afe40522754f794c03d1bd9c505d0ac112))
* **app-theme:** add csp nonce to vueMeta ([1715f2d](https://github.com/vuetifyjs/vuetify/commit/1715f2d8e60085b55afc6125604197cccff940bc)), closes [#4159](https://github.com/vuetifyjs/vuetify/issues/4159)
* **build:** don't import Vue ([4890c83](https://github.com/vuetifyjs/vuetify/commit/4890c83e94041bc0cf06608fc9e307acd132836d))
* **build:** import Vue again ([ff27d02](https://github.com/vuetifyjs/vuetify/commit/ff27d025fdd6ed222a1258c29ee8cba04129d152))
* **data-iterable:** fix pagination sync ([78a273e](https://github.com/vuetifyjs/vuetify/commit/78a273ee0c4bab62b6ee5dfa209ff6c58e737697)), closes [#4122](https://github.com/vuetifyjs/vuetify/issues/4122)
* **form-inputs:** fix input irregularities ([5268dc4](https://github.com/vuetifyjs/vuetify/commit/5268dc467122426609f1471997ac00c8b0123798)), closes [#4078](https://github.com/vuetifyjs/vuetify/issues/4078)
* **inputs:** set correct error label color ([31233c2](https://github.com/vuetifyjs/vuetify/commit/31233c2f863314615f86d3cd2a4ee4f061afd0f0))
* **stylus:** allow re-defining $grid-gutter ([#4095](https://github.com/vuetifyjs/vuetify/issues/4095)) ([ed4a176](https://github.com/vuetifyjs/vuetify/commit/ed4a1768852a149f6f5388c744e39ea04dd14601))
* **theme:** add CSP nonce with vue ssr ([589de09](https://github.com/vuetifyjs/vuetify/commit/589de094df6ae98a13ccafe9abeb0129fe69f8b4)), closes [#4159](https://github.com/vuetifyjs/vuetify/issues/4159)
* **types:** correct colors.d.ts exports ([#4155](https://github.com/vuetifyjs/vuetify/issues/4155)) ([40907c1](https://github.com/vuetifyjs/vuetify/commit/40907c10bf51119e2a79909b65e44be4babe662d))
* **v-autocomplete:** add content-class ([874aad1](https://github.com/vuetifyjs/vuetify/commit/874aad18d3264da96dd196f37ca66a95776f07f8)), closes [#4088](https://github.com/vuetifyjs/vuetify/issues/4088)
* **v-bottom-nav:** update styles ([0fb69d2](https://github.com/vuetifyjs/vuetify/commit/0fb69d2f12eab9929da5efdd6a08a696753636f2))
* **v-btn:** fix transition styles ([a11be7a](https://github.com/vuetifyjs/vuetify/commit/a11be7a80290835762dae263154894dd073d864c))
* **v-btn:** fix v-icon styles ([cde0588](https://github.com/vuetifyjs/vuetify/commit/cde058862b35d6b4965530c39959525d14b7d476)), closes [#4134](https://github.com/vuetifyjs/vuetify/issues/4134)
* **v-btn:** resolve router-link issue ([2d1e00e](https://github.com/vuetifyjs/vuetify/commit/2d1e00e048ef335be32c1872f4c3568d16ea8152))
* **v-data-table:** add *:key* to <tr> ([#3968](https://github.com/vuetifyjs/vuetify/issues/3968)) ([f75b952](https://github.com/vuetifyjs/vuetify/commit/f75b95242a11acb3a6aa93316afe9b77957c8761)), closes [#3967](https://github.com/vuetifyjs/vuetify/issues/3967)
* **v-dialog:** update animation condition ([74e77d0](https://github.com/vuetifyjs/vuetify/commit/74e77d04c443da186b80fbab4074366e11dc0802))
* **v-dialog/selection-controls:** style updates ([#4170](https://github.com/vuetifyjs/vuetify/issues/4170)) ([2f6006f](https://github.com/vuetifyjs/vuetify/commit/2f6006f5d99e87837fba7ea25f7fee321fdf47f6)), closes [#4168](https://github.com/vuetifyjs/vuetify/issues/4168)
* **v-divider:** add minimum width ([efb5425](https://github.com/vuetifyjs/vuetify/commit/efb54250c649bf74f8eb74ee9c45ca36fef8ae9f))
* **v-list-tile:** remove pointer events ([34c6b43](https://github.com/vuetifyjs/vuetify/commit/34c6b436ce873aef0a6019ad83a7de48e6bc2a85)), closes [#4152](https://github.com/vuetifyjs/vuetify/issues/4152)
* **v-list-tile:** remove pointless style ([540f9e4](https://github.com/vuetifyjs/vuetify/commit/540f9e410eb70185a5fe5beee3cc56cf380367e9)), closes [#4140](https://github.com/vuetifyjs/vuetify/issues/4140)
* **v-messages:** fix transition exit ([bf6ff3f](https://github.com/vuetifyjs/vuetify/commit/bf6ff3f12dbb402feefb14db9630baff672719ed))
* **v-messages:** remove absolute position ([1db80eb](https://github.com/vuetifyjs/vuetify/commit/1db80eb11aca71568891c42863f0f0dc7e01ea37)), closes [#4147](https://github.com/vuetifyjs/vuetify/issues/4147)
* **v-navigation-drawer:** change event type ([cce9ffa](https://github.com/vuetifyjs/vuetify/commit/cce9ffa33593b4583f77c23c8756d1090c996517)), closes [#4031](https://github.com/vuetifyjs/vuetify/issues/4031)
* **v-radio-group:** add back label ([da1b64e](https://github.com/vuetifyjs/vuetify/commit/da1b64eb05cdcb3c86dd6dd1dd6df1d7fa70d3da)), closes [#4146](https://github.com/vuetifyjs/vuetify/issues/4146)
* **v-select:** update style ([591e4ff](https://github.com/vuetifyjs/vuetify/commit/591e4ffb0d701554d788ab65d3ceaddddf3e5d73))
* **v-slider:** update readonly ([34ae4c2](https://github.com/vuetifyjs/vuetify/commit/34ae4c2285899a48c524bff108fcd3aaa66d8e47)), closes [#4177](https://github.com/vuetifyjs/vuetify/issues/4177)
* **v-text-field:** fix enclosed loaders ([aaf6865](https://github.com/vuetifyjs/vuetify/commit/aaf6865901a604c6234e7f5417e5f72665aef6bf)), closes [#4141](https://github.com/vuetifyjs/vuetify/issues/4141)
* **validatable:** fix error-messages comparison ([4be1512](https://github.com/vuetifyjs/vuetify/commit/4be1512e87bdd16d677c50921bfcf1c5e17d8e38)), closes [#4130](https://github.com/vuetifyjs/vuetify/issues/4130)
* **VSelect:** use scopedSlots.selection instead of slots.item ([1cb54dc](https://github.com/vuetifyjs/vuetify/commit/1cb54dcc47b5c609aad5636ac772a94ad8cc68a9)), closes [#4104](https://github.com/vuetifyjs/vuetify/issues/4104)
* **VSlider:** allow step to be set to 0 ([#4124](https://github.com/vuetifyjs/vuetify/issues/4124)) ([55aafc7](https://github.com/vuetifyjs/vuetify/commit/55aafc7d63c9a890a046d74808683635a4146143))
* **VTextArea:** add no-resize styles ([b419066](https://github.com/vuetifyjs/vuetify/commit/b4190667922e500b15591c0a8e4ead99df8581c3))
* incorrect variable name ([dd08b98](https://github.com/vuetifyjs/vuetify/commit/dd08b9800fbb2bb98732a9e491a21a0e58f20a1d))
* **form-inputs:** fix styles and match spec ([cf43a19](https://github.com/vuetifyjs/vuetify/commit/cf43a19d0cec33a88a5411d4a300ded22cb27903))
* **helpers:** fixed variable name ([423d315](https://github.com/vuetifyjs/vuetify/commit/423d315c3d0072e572e9ac4a17703f2d1a0357ad))
* **ripple:** convert to ts, only remove the last ripple ([#4040](https://github.com/vuetifyjs/vuetify/issues/4040)) ([bd1993a](https://github.com/vuetifyjs/vuetify/commit/bd1993a516ef9d0221c71abfb949b5abd85f2f37))
* **selection-controls:** fix alignment ([7fb9c79](https://github.com/vuetifyjs/vuetify/commit/7fb9c79254c5e55b982f8f3b1b79ffebf2bd3bc2))
* **stackable:** fix z-index ([3c2ee99](https://github.com/vuetifyjs/vuetify/commit/3c2ee99b91a93e2103e17988d84f53762ddbf403))
* **v-autocomplete:** add missing functionality ([d724779](https://github.com/vuetifyjs/vuetify/commit/d724779defded93f887afb257869063fc22d0b43))
* **v-autocomplete:** fix displayed text ([b349463](https://github.com/vuetifyjs/vuetify/commit/b349463940fa4ae4c8434ce5f248cdc73bc6ed3f))
* **v-autocomplete:** fix hideNoData logic ([1eb9363](https://github.com/vuetifyjs/vuetify/commit/1eb9363899bdb230bd85a7054243ae3ab3356b83))
* **v-autocomplete:** refactor combobox experience ([3996f27](https://github.com/vuetifyjs/vuetify/commit/3996f27bf1c5331abc762fcc4c515a2aff31820f)), closes [#4032](https://github.com/vuetifyjs/vuetify/issues/4032)
* **v-flex:** add max-width ([a4b5ce8](https://github.com/vuetifyjs/vuetify/commit/a4b5ce8826063cf86f62d71fa035971cbdf0b516))
* **v-input:** adjust pointer-events ([df52046](https://github.com/vuetifyjs/vuetify/commit/df52046bb47a4531d03629cbdb8331db1adf1a9c)), closes [#4034](https://github.com/vuetifyjs/vuetify/issues/4034)
* **v-input:** change min-height of slot ([bf08da0](https://github.com/vuetifyjs/vuetify/commit/bf08da03607d817ce08976731104c8d74fa9793f))
* **v-input:** fix input color ([db1fd09](https://github.com/vuetifyjs/vuetify/commit/db1fd091f508a988051c225b66189929e89a45d8))
* **v-label:** fix pointer-events ([68bf3d8](https://github.com/vuetifyjs/vuetify/commit/68bf3d8fdace3bd00461f7c9cfddcd2ae2148d3a)), closes [#4013](https://github.com/vuetifyjs/vuetify/issues/4013)
* **v-navigation-drawer:** change event type ([db8e638](https://github.com/vuetifyjs/vuetify/commit/db8e638ed760a6a0f1823c764776dfb17bdae5d5)), closes [#4031](https://github.com/vuetifyjs/vuetify/issues/4031)
* **v-overflow-btn:** align labels in ie11 ([9f17663](https://github.com/vuetifyjs/vuetify/commit/9f1766333ea407dd01af7ba034af0943a485aaad))
* **v-select:** add back fake virtualization ([#4025](https://github.com/vuetifyjs/vuetify/issues/4025)) ([339863a](https://github.com/vuetifyjs/vuetify/commit/339863a62a95fc4ca9e78f8f09498267b2867dd5))
* **v-select:** add width ([2256bea](https://github.com/vuetifyjs/vuetify/commit/2256bead9636879c67c32e66ab6fa1326be28ebd))
* **v-select:** change close conditional ([297c80e](https://github.com/vuetifyjs/vuetify/commit/297c80e6463fbb7e8f195e4d0256e98aa26c3a00)), closes [#4023](https://github.com/vuetifyjs/vuetify/issues/4023)
* **v-select:** hide cursor ([37c9e53](https://github.com/vuetifyjs/vuetify/commit/37c9e539b2f3701aa42b68c1e2f6cac1544bafec))
* **v-select:** improve chip styles ([0708cee](https://github.com/vuetifyjs/vuetify/commit/0708cee252e6e928b06bcf7de16255246c6318de))
* data-table issues ([#3857](https://github.com/vuetifyjs/vuetify/issues/3857)) ([5113291](https://github.com/vuetifyjs/vuetify/commit/511329179271f2e4baa1e59deec5178e33fbfcf4)), closes [#3766](https://github.com/vuetifyjs/vuetify/issues/3766) [#3511](https://github.com/vuetifyjs/vuetify/issues/3511) [#3585](https://github.com/vuetifyjs/vuetify/issues/3585) [#3766](https://github.com/vuetifyjs/vuetify/issues/3766) [#3585](https://github.com/vuetifyjs/vuetify/issues/3585)
* data-table pagination did not update when using custom-filter ([#3850](https://github.com/vuetifyjs/vuetify/issues/3850)) ([8a14daa](https://github.com/vuetifyjs/vuetify/commit/8a14daaf34542ed0de22bbbbdbb8ddc444a1d549)), closes [#3770](https://github.com/vuetifyjs/vuetify/issues/3770)
* data-table selection now works with nested item-key ([#3849](https://github.com/vuetifyjs/vuetify/issues/3849)) ([2e43d7d](https://github.com/vuetifyjs/vuetify/commit/2e43d7d0a9ceae5e01797f1dbac17bffaa9474c9)), closes [#3714](https://github.com/vuetifyjs/vuetify/issues/3714)
* **grid:** update desktop/mobile gutters ([9a5aef6](https://github.com/vuetifyjs/vuetify/commit/9a5aef6c3d2dad9b0d275143038f2d40002884ad))
* **select/autocomplete:** update no data available logic ([3a2c67a](https://github.com/vuetifyjs/vuetify/commit/3a2c67a682291ed37c126882b845f237f2548aa3)), closes [#2081](https://github.com/vuetifyjs/vuetify/issues/2081)
* **v-autocomplete:** disable onInput when selecting index ([fb89744](https://github.com/vuetifyjs/vuetify/commit/fb8974460c035e9fc3bcc7c39d626055777ed7d9)), closes [#2834](https://github.com/vuetifyjs/vuetify/issues/2834)
* **v-autocomplete:** fix index evaluation ([34d96e7](https://github.com/vuetifyjs/vuetify/commit/34d96e73fed0793ca161ab419177b32ed635d5b0))
* **v-autocomplete:** set search on init ([3fc9787](https://github.com/vuetifyjs/vuetify/commit/3fc97870218b88bbc9c646921e3687e71432053e))
* **v-dialog:** remove overflow ([33d46ce](https://github.com/vuetifyjs/vuetify/commit/33d46ced850bb159ece0ec778dd4f1465b8b4d63)), closes [#4066](https://github.com/vuetifyjs/vuetify/issues/4066)
* **v-input:** fix loader styles ([0e59fa7](https://github.com/vuetifyjs/vuetify/commit/0e59fa78c1e776b3bf0185e16384318d931a02d5))
* **v-input:** fix toolbar styles ([c604bc0](https://github.com/vuetifyjs/vuetify/commit/c604bc072858ff9c84415039beac357290f5eea3))
* **v-input:** update progress styles ([2b02a3d](https://github.com/vuetifyjs/vuetify/commit/2b02a3dd0d32f08003e8829afd7d6a19c475ccde))
* **v-radio:** fix label position ([3aa738c](https://github.com/vuetifyjs/vuetify/commit/3aa738c078620a918877fe876dcc538cef9703f2))
* **v-radio-group:** add test for issue ([e6baef8](https://github.com/vuetifyjs/vuetify/commit/e6baef81028115864e1531a611d28f0b6539e91c)), closes [#3299](https://github.com/vuetifyjs/vuetify/issues/3299)
* **v-select:** add all items ([87062ac](https://github.com/vuetifyjs/vuetify/commit/87062ac0b52311d7cc52f052be2b3dc45a3c6df6))
* **v-select:** add specificity to input alignment ([33fc90a](https://github.com/vuetifyjs/vuetify/commit/33fc90a69f1af4fdfb4ed731b92852db369467b5))
* **v-select:** adjust input flex alignment ([36a7461](https://github.com/vuetifyjs/vuetify/commit/36a7461c77b22140019441c72452fdfaee0b595b))
* **v-select:** fix auto menu positioning ([f685b72](https://github.com/vuetifyjs/vuetify/commit/f685b721d16b678d013ceabbcd87277b34be3716))
* **v-select:** fix comma selection spacing ([053dba3](https://github.com/vuetifyjs/vuetify/commit/053dba30e5ce0cfb0e67e74f329e4f4ca47a9d06))
* **v-select:** fix open on clear ([5d3c15e](https://github.com/vuetifyjs/vuetify/commit/5d3c15e8f6176e3785a6b22675d63560cca15739))
* **v-select:** hide placeholder when dirty ([e2915c8](https://github.com/vuetifyjs/vuetify/commit/e2915c86b4d57b797b3821927935074f9d168a77))
* **v-select:** refactor keyboard functionality ([5022b80](https://github.com/vuetifyjs/vuetify/commit/5022b80c3397d8a64cbacdfff1fbe2bbf2770798)), closes [#3973](https://github.com/vuetifyjs/vuetify/issues/3973)
* **v-select:** update change event ([c9bd680](https://github.com/vuetifyjs/vuetify/commit/c9bd68091cb364de32fe78543c89fa8170ba5206)), closes [#3457](https://github.com/vuetifyjs/vuetify/issues/3457)
* **v-select-list:** fix hide-selected logic ([3b5f7b2](https://github.com/vuetifyjs/vuetify/commit/3b5f7b2175678503574f77a8eb4d716c36d58413))
* **v-slider:** add missing input-groups import ([#4047](https://github.com/vuetifyjs/vuetify/issues/4047)) ([c769cb8](https://github.com/vuetifyjs/vuetify/commit/c769cb8609324727c7e382b3e87bd2d81e41a055))
* **v-slider:** added missing style import ([6fd21f6](https://github.com/vuetifyjs/vuetify/commit/6fd21f6fe2595c0b19af988e6062869a11b170ac))
* **v-slider:** revert incorrect fix ([89f97d2](https://github.com/vuetifyjs/vuetify/commit/89f97d2257a6fe353e83e90c4d6a349a4d0c4429))
* **v-subheader:** fix broken styles ([b355155](https://github.com/vuetifyjs/vuetify/commit/b3551558c79cdbc48297023f77c22d700a188d6c))
* **v-text-field:** adjust suffix logic ([4c8c5e6](https://github.com/vuetifyjs/vuetify/commit/4c8c5e697f8fcf366303acb633259ae966f11f15))
* **v-text-field:** improve long suffixes ([91b3cf0](https://github.com/vuetifyjs/vuetify/commit/91b3cf0ea21474f797bb7fe42220be584ea3dfd7))
* **v-text-field:** remove clearable ([81f73c1](https://github.com/vuetifyjs/vuetify/commit/81f73c168c69cb77debe81fa7c98fa1effff09ae))
* **v-text-field:** remove duplicate clear icon ([913c2ab](https://github.com/vuetifyjs/vuetify/commit/913c2abfa1316c22d37ec50ac3fd09008b48a32e))
* **v-text-field:** remove full-width margin ([7e06f6c](https://github.com/vuetifyjs/vuetify/commit/7e06f6c4b5de022c6d9f8600de20bae375bc1457))
* **v-text-field:** updated box styles ([7781a71](https://github.com/vuetifyjs/vuetify/commit/7781a71b7dca2e0dee80f0e8076d0b5b4acadaf4))
* **v-text-field/area:** add keydown events ([57597a3](https://github.com/vuetifyjs/vuetify/commit/57597a3e4fdb346650406a108f38c85cbbd43cba)), closes [#3545](https://github.com/vuetifyjs/vuetify/issues/3545)
* **v-textarea:** add overflow ([6fcea3b](https://github.com/vuetifyjs/vuetify/commit/6fcea3b9617967ba2f104f13e7828feed385f113)), closes [#4012](https://github.com/vuetifyjs/vuetify/issues/4012)
* **v-textarea:** adjust details top ([17bd969](https://github.com/vuetifyjs/vuetify/commit/17bd969c0edabd7e91b44d295639745c1c87714b))
* **validatable:** update shouldValidate logic ([404eba3](https://github.com/vuetifyjs/vuetify/commit/404eba3fed74a9c3f7c166118fa54c279c618133))
* **VBreadcrumbs:** don't reuse divider VNodes ([f679af6](https://github.com/vuetifyjs/vuetify/commit/f679af6f09537752b015f52a9a7946c5794907e1)), closes [#3874](https://github.com/vuetifyjs/vuetify/issues/3874)
* **VInput:** allow input to fill width when in a flex container ([#4029](https://github.com/vuetifyjs/vuetify/issues/4029)) ([2a09896](https://github.com/vuetifyjs/vuetify/commit/2a098960f8c6bd541523f68eb89dc2345177d11c)), closes [#4022](https://github.com/vuetifyjs/vuetify/issues/4022)
* **VInput:** allow messages to contain HTML ([e7ad8fe](https://github.com/vuetifyjs/vuetify/commit/e7ad8fe973cdf00666829f2407718eb78f26b9a8))
* **VInput:** grow properly in IE ([f092c71](https://github.com/vuetifyjs/vuetify/commit/f092c7103b90303ce40cb2b23f81573e90290fff)), closes [#4029](https://github.com/vuetifyjs/vuetify/issues/4029)
* **VLabel:** correct Colorable call ([2037b18](https://github.com/vuetifyjs/vuetify/commit/2037b1853d75e936563c9021eb6d6ac2b3cfb518))
* **VRadio:** set correct checked attribute on internal input ([b34922e](https://github.com/vuetifyjs/vuetify/commit/b34922ed1ac25fd315f2e1eca44fdb8fa2a9df27))
* **VSelect:** toggle menu when dropdown arrow is clicked ([#4036](https://github.com/vuetifyjs/vuetify/issues/4036)) ([e66d513](https://github.com/vuetifyjs/vuetify/commit/e66d513281d5e9f47c5627463a019a9a8906824b)), closes [#4033](https://github.com/vuetifyjs/vuetify/issues/4033)
* **VSlider,VSelect:** hide input on IE and android ([641426c](https://github.com/vuetifyjs/vuetify/commit/641426c2b24374d5f35d45585327acd2032070d7))
* hide selection control's input in IE11 ([#4035](https://github.com/vuetifyjs/vuetify/issues/4035)) ([f57a775](https://github.com/vuetifyjs/vuetify/commit/f57a77535d6a98b8a449144aa9ac78cddd5bd912))
* **VTextField:** add back focus and blur methods ([#4030](https://github.com/vuetifyjs/vuetify/issues/4030)) ([d6870a4](https://github.com/vuetifyjs/vuetify/commit/d6870a472d2b6720d73fa137bb1b485eb16afb94))
* **VTextField:** fix error state with external validation ([#4010](https://github.com/vuetifyjs/vuetify/issues/4010)) ([33064ee](https://github.com/vuetifyjs/vuetify/commit/33064ee76ce5a5dc1d5ffaf178a9cc4f447796c6))
* increase specificity of outline chips to override theme background ([#3449](https://github.com/vuetifyjs/vuetify/issues/3449)) ([2038293](https://github.com/vuetifyjs/vuetify/commit/2038293395a513cbf68c933d6e4653eb98f16596)), closes [#3374](https://github.com/vuetifyjs/vuetify/issues/3374)
* reset page when changing sort order ([b2df69d](https://github.com/vuetifyjs/vuetify/commit/b2df69dd53b08e27d6b8a63c5edf838459b6461c))
* **VSelect:** add tags with tab when the menu is open ([#3240](https://github.com/vuetifyjs/vuetify/issues/3240)) ([cfbf262](https://github.com/vuetifyjs/vuetify/commit/cfbf262f3c7326b28876eea1ad23f5def62c3333))
* reset page to 1 when sorting changes ([3655f27](https://github.com/vuetifyjs/vuetify/commit/3655f27f99eadd06d14cfaffa4aa0b13508faa68))
* update $vuetify.application when created instead of mounted ([#3156](https://github.com/vuetifyjs/vuetify/issues/3156)) ([4518ccf](https://github.com/vuetifyjs/vuetify/commit/4518ccf435890a3ab5950ca0b124e3114a3c20d0))
* **application:** abstracting applicationable functionality ([#2703](https://github.com/vuetifyjs/vuetify/issues/2703)) ([b8d72ab](https://github.com/vuetifyjs/vuetify/commit/b8d72ab11f471ca2bdc531c433c04e341a847533))
* **bootable:** added check for active status ([#3132](https://github.com/vuetifyjs/vuetify/issues/3132)) ([77e119a](https://github.com/vuetifyjs/vuetify/commit/77e119a039184a30978221c413b7b579394b8363)), closes [#3084](https://github.com/vuetifyjs/vuetify/issues/3084)
* **date-picker:** allow external switching between date and month view ([d6935aa](https://github.com/vuetifyjs/vuetify/commit/d6935aa52a35d0b02b247efb8214d9de0fcf4ed4)), closes [#2809](https://github.com/vuetifyjs/vuetify/issues/2809)
* **date-picker:** incorrect button styles ([2e9d6af](https://github.com/vuetifyjs/vuetify/commit/2e9d6af4fabaee724c112837f8cc224bd53939ea)), closes [#2812](https://github.com/vuetifyjs/vuetify/issues/2812)
* **detachable:** fixed pug bug ([fcaf99c](https://github.com/vuetifyjs/vuetify/commit/fcaf99c9a68916ee3510b19ec3b10b15dce856ad))
* **detachable:** Hide when deactivated ([#2780](https://github.com/vuetifyjs/vuetify/issues/2780)) ([210813f](https://github.com/vuetifyjs/vuetify/commit/210813fae4eaa16504db1140d1f00fcc8fe1f03d)), closes [#2480](https://github.com/vuetifyjs/vuetify/issues/2480)
* **directives:** fixed a memory leak ([5b1ad97](https://github.com/vuetifyjs/vuetify/commit/5b1ad97dc32c5dc36f53e7dd64839116df97ae03)), closes [#2779](https://github.com/vuetifyjs/vuetify/issues/2779)
* **directives:** fixed a memory leak ([9d8d9d6](https://github.com/vuetifyjs/vuetify/commit/9d8d9d676cdb6935d6d3970fe3e839758fb828d5)), closes [#2779](https://github.com/vuetifyjs/vuetify/issues/2779)
* **display-helpers:** added !important to property declaration ([020d442](https://github.com/vuetifyjs/vuetify/commit/020d44206c276cad9903019aaa2c83505077cdf2))
* **maskable:** will now mask a value on mount ([aae73b7](https://github.com/vuetifyjs/vuetify/commit/aae73b75d699418303f6bd135f7389d3494e464a)), closes [#2722](https://github.com/vuetifyjs/vuetify/issues/2722)
* **menuable:** Enforce the check that $refs.content exist in sneakPeek ([#2721](https://github.com/vuetifyjs/vuetify/issues/2721)) ([9df0881](https://github.com/vuetifyjs/vuetify/commit/9df088191cbc76c951fbae7c6e6377e0b30cb672))
* **menuable:** removed margin, added functionality to parse margin ([dc44b0b](https://github.com/vuetifyjs/vuetify/commit/dc44b0b030fd6c44b21526ee7277f39a841f93ac)), closes [#2760](https://github.com/vuetifyjs/vuetify/issues/2760)
* **selection-controls:** removed pointer events when disabled ([67342c7](https://github.com/vuetifyjs/vuetify/commit/67342c7b6e463bc6aff35dc950d3ca20404026a6)), closes [#2670](https://github.com/vuetifyjs/vuetify/issues/2670)
* **tests:** all tests were failing after latest dependency bump ([#2817](https://github.com/vuetifyjs/vuetify/issues/2817)) ([caaa22a](https://github.com/vuetifyjs/vuetify/commit/caaa22a2e1971937ca4825d4b3d7503c142daa06))
* **text-field:** fixed bad styles causing issues ([50cfa89](https://github.com/vuetifyjs/vuetify/commit/50cfa89439a9f4c3df307479a11d3ea422c93ac2))
* **text-field/select:** set **input** to 100% width ([5453fd6](https://github.com/vuetifyjs/vuetify/commit/5453fd6b3be781abaff913d6212af45da0798c6f))
* **toolbar:** fixed scroll threshold ([8936e19](https://github.com/vuetifyjs/vuetify/commit/8936e19acf8209166597033eb3a1581d4a260333))
* **v-alert:** close icon now inherits color ([edf7860](https://github.com/vuetifyjs/vuetify/commit/edf786079e010f55c43364b77d08eeef98c7a2c0)), closes [#2762](https://github.com/vuetifyjs/vuetify/issues/2762)
* **v-avatar:** removed class overwrite ([ffec22b](https://github.com/vuetifyjs/vuetify/commit/ffec22bce0b6e4280266a3f3d44038ccd7d6ef3e))
* **v-bottom-nav:** fixed `v-btn` not being highlighted ([a7ff53a](https://github.com/vuetifyjs/vuetify/commit/a7ff53adfcfd27ef8ed344e8a99e6205ffccac04)), closes [#2801](https://github.com/vuetifyjs/vuetify/issues/2801)
* **v-btn:** fixed fab styles in ie11 ([#3127](https://github.com/vuetifyjs/vuetify/issues/3127)) ([251fe7b](https://github.com/vuetifyjs/vuetify/commit/251fe7bb445ce75a6a5ddaf3abf3785ce7b11482)), closes [#3068](https://github.com/vuetifyjs/vuetify/issues/3068)
* **v-chip:** updated for spec ([d5154ad](https://github.com/vuetifyjs/vuetify/commit/d5154ad2e555001fb17234fe79c9ff1610069045))
* **v-date-picker:** adjusted styles and markup ([#2966](https://github.com/vuetifyjs/vuetify/issues/2966)) ([01c306a](https://github.com/vuetifyjs/vuetify/commit/01c306ad11552cc4ea16cb910eac715b3d356d78))
* **v-date-picker:** fixed prop definition ([f37fe83](https://github.com/vuetifyjs/vuetify/commit/f37fe8391fea26d556b02eb468880c8ae94efd73))
* **v-date-picker-title:** fixed improper comparison for transition ([#3160](https://github.com/vuetifyjs/vuetify/issues/3160)) ([76a6043](https://github.com/vuetifyjs/vuetify/commit/76a604375800c5875a23b521913911d09c19cfb7))
* **v-expansion-panel:** add max-width to resolve overflow issues ([#2975](https://github.com/vuetifyjs/vuetify/issues/2975)) ([143e501](https://github.com/vuetifyjs/vuetify/commit/143e501cd64d67537d8c8a6b69a0b0a9cbd0b0dd))
* **v-list:** remove ability to select icons in list tiles ([9f17ac0](https://github.com/vuetifyjs/vuetify/commit/9f17ac0206f7ce39387f7b64ce4da8a3edd6e65f))
* **v-select:** fixed event call on empty value when blurring ([0985915](https://github.com/vuetifyjs/vuetify/commit/09859151e8bd708de4a70d6b7ab618af20ae37ef))
* **v-select:** fixed select keyboard functionality ([#3134](https://github.com/vuetifyjs/vuetify/issues/3134)) ([44ba15f](https://github.com/vuetifyjs/vuetify/commit/44ba15fa5eb3f90b57ef974fc0e553de9be67216)), closes [#3069](https://github.com/vuetifyjs/vuetify/issues/3069)
* **v-tab:** changed how active link is derived ([#3126](https://github.com/vuetifyjs/vuetify/issues/3126)) ([f262d1e](https://github.com/vuetifyjs/vuetify/commit/f262d1e781ec3bb09cfec7aade2cde3d1738fa07)), closes [#3010](https://github.com/vuetifyjs/vuetify/issues/3010)
* all color names are now lowercase ([350f01e](https://github.com/vuetifyjs/vuetify/commit/350f01e6f63a2fbe921afce47f7fcfca914d45e4))
* allow to override the elevation’s Stylus variables ([#3098](https://github.com/vuetifyjs/vuetify/issues/3098)) ([1e9b555](https://github.com/vuetifyjs/vuetify/commit/1e9b5552ad67f3b170b3f95aa104167fd01e6cc9))
* append/prepend icon position for switch and checkbox ([#2483](https://github.com/vuetifyjs/vuetify/issues/2483)) ([6317673](https://github.com/vuetifyjs/vuetify/commit/631767373b2848e1c7fe68beb236f9ec19854bb8)), closes [#2418](https://github.com/vuetifyjs/vuetify/issues/2418)
* Avoid high CPU usage in Safari ([#2958](https://github.com/vuetifyjs/vuetify/issues/2958)) ([88eacdd](https://github.com/vuetifyjs/vuetify/commit/88eacddb45b391e2f16d7298929a7e1dfdc857bd)), closes [#2773](https://github.com/vuetifyjs/vuetify/issues/2773)
* eventColor prop definition ([9264513](https://github.com/vuetifyjs/vuetify/commit/926451319965f9bcd600b6c23f3d4a0aed1a2b53))
* expansion-panel can't find nested content ([#3040](https://github.com/vuetifyjs/vuetify/issues/3040)) ([fc466fe](https://github.com/vuetifyjs/vuetify/commit/fc466fe9a0d29318c0f72c1e6f6287acee2a39d5)), closes [#2617](https://github.com/vuetifyjs/vuetify/issues/2617)
* generate row in data-table no-data slot ([#3106](https://github.com/vuetifyjs/vuetify/issues/3106)) ([a67f3b1](https://github.com/vuetifyjs/vuetify/commit/a67f3b17814152965a5cabcdef9a4261f7b73795)), closes [#3088](https://github.com/vuetifyjs/vuetify/issues/3088)
* hide slider when hideSlider is true ([#3014](https://github.com/vuetifyjs/vuetify/issues/3014)) ([4323cf6](https://github.com/vuetifyjs/vuetify/commit/4323cf6ea1074e7b8f0541766e277d62c9b8c45a)), closes [#2949](https://github.com/vuetifyjs/vuetify/issues/2949)
* make input error full width ([#3077](https://github.com/vuetifyjs/vuetify/issues/3077)) ([5fa860c](https://github.com/vuetifyjs/vuetify/commit/5fa860c47c970b2a7d0451e10fc443f24c075aa3))
* padStart polyfill implementation bug ([be0418c](https://github.com/vuetifyjs/vuetify/commit/be0418ca889af0702939c4fc8eba81b52b86c24a))
* picker title transition for month picker ([001bfd7](https://github.com/vuetifyjs/vuetify/commit/001bfd7268f9c16567c08df32c358c0520bd1c47))
* replaced throw with consoleError ([8b96ef9](https://github.com/vuetifyjs/vuetify/commit/8b96ef9340af81da931587822fd359682c32de53))
* selected date button is invisible with color prop applied ([d89e950](https://github.com/vuetifyjs/vuetify/commit/d89e95082211233ae7cffd76a69c72569a73b761))
* stepper style bleed ([#3096](https://github.com/vuetifyjs/vuetify/issues/3096)) ([cb2d597](https://github.com/vuetifyjs/vuetify/commit/cb2d597358198765e756a98fa0c26abcc0f06dc6)), closes [#3094](https://github.com/vuetifyjs/vuetify/issues/3094)
* stopped dialog activator event propagation ([#3105](https://github.com/vuetifyjs/vuetify/issues/3105)) ([d68ba24](https://github.com/vuetifyjs/vuetify/commit/d68ba24aed15df42bacba9f4d5935ddc04856bc6)), closes [#2942](https://github.com/vuetifyjs/vuetify/issues/2942)
* **babelrc:** transform harmony exports ([#3054](https://github.com/vuetifyjs/vuetify/issues/3054)) ([111c49d](https://github.com/vuetifyjs/vuetify/commit/111c49d5592854c1d698c1bfabd7f9ac23930879))
* **click-outside:** adjusted logic for determining click-outside state ([#3034](https://github.com/vuetifyjs/vuetify/issues/3034)) ([1e1d364](https://github.com/vuetifyjs/vuetify/commit/1e1d3640905b7d8d3db83f079d24046f8d2b267e)), closes [#3021](https://github.com/vuetifyjs/vuetify/issues/3021)
* **color-utils:** refactored **intToHex** function ([7b7cb19](https://github.com/vuetifyjs/vuetify/commit/7b7cb19a84e1fe3ed1c8178353807effb2318352)), closes [#3042](https://github.com/vuetifyjs/vuetify/issues/3042)
* **directives:** fixed memory leak ([#2997](https://github.com/vuetifyjs/vuetify/issues/2997)) ([355a0d1](https://github.com/vuetifyjs/vuetify/commit/355a0d15b8a1d3a416b2a6f1a5a4e7c905af384e))
* **menu:** clean up from the multiple renames in [#2716](https://github.com/vuetifyjs/vuetify/issues/2716) ([41c163f](https://github.com/vuetifyjs/vuetify/commit/41c163f3068f265daadbe3c831439c17f1bade9f)), closes [#1989](https://github.com/vuetifyjs/vuetify/issues/1989)
* **routable:** added default to **exact** prop ([faf2c39](https://github.com/vuetifyjs/vuetify/commit/faf2c3936214505126891ef0058a2c67750f823d)), closes [#2485](https://github.com/vuetifyjs/vuetify/issues/2485)
* **ssr:** use requestAnimationFrame for bootable instead of setTimeout ([ce04349](https://github.com/vuetifyjs/vuetify/commit/ce0434997bfebb22c8c3240081fe8b5bfbf7dfd5))
* **theme:** warn when invalid strings are used + add more formats ([991c262](https://github.com/vuetifyjs/vuetify/commit/991c26231988828bdcd0cf6a34c8be584a6156f0)), closes [#2995](https://github.com/vuetifyjs/vuetify/issues/2995)
* **v-btn:** fixed absent click event with using router ([be7fef1](https://github.com/vuetifyjs/vuetify/commit/be7fef1ecc599be118d248686f73e5b669e9caf0))
* **v-chip:** fixed focus styles in ie11 ([c02bb83](https://github.com/vuetifyjs/vuetify/commit/c02bb8390bbe7df0d8cb50eccf4514e957b1c611))
* **v-data-table:** adjustment for implicit alignment ([37595d3](https://github.com/vuetifyjs/vuetify/commit/37595d30aa119e456f39d88be514a30f27c0525a))
* **v-icon:** fixed render statement length for lint ([c9917be](https://github.com/vuetifyjs/vuetify/commit/c9917befe111e2fe9ab4a2a892b383d048ca1c7e))
* **v-jumbotron:** added missing transition ([cb1c3c3](https://github.com/vuetifyjs/vuetify/commit/cb1c3c37b0be33b7abb9eee32670353de4cfc127))
* **v-jumbotron:** fixed improperly styled images ([a368a5e](https://github.com/vuetifyjs/vuetify/commit/a368a5e8b85c93e2967e1b7d075f169c104e06d4)), closes [#2751](https://github.com/vuetifyjs/vuetify/issues/2751)
* **v-lists:** fixed improper hover style ([88a5ddd](https://github.com/vuetifyjs/vuetify/commit/88a5ddd522652b89348a2023b3936a8ea2c6404b)), closes [#2914](https://github.com/vuetifyjs/vuetify/issues/2914)
* **v-navigation-drawer:** adjusted logic for route watcher ([f629416](https://github.com/vuetifyjs/vuetify/commit/f6294162f297caebd4aa7d126c9e9440a9b799a1))
* **v-pagination:** removed overflow-x hide ([49df844](https://github.com/vuetifyjs/vuetify/commit/49df84448acefb02a6bd9b2ddf3efe462eafcd2a))
* **v-progress-circular:** removed unused prop fill ([7cd0f31](https://github.com/vuetifyjs/vuetify/commit/7cd0f31de96e7a189bc9477e9b2386973d701104))
* **v-scroll:** check if property exists before destructuring ([575d717](https://github.com/vuetifyjs/vuetify/commit/575d71711213173de5c7ab549a806369a91fe877))
* **v-select:** corrected search comparison ([98e15ca](https://github.com/vuetifyjs/vuetify/commit/98e15ca4b2748f4ebe7680afc089efa4b2ceed5b)), closes [#2754](https://github.com/vuetifyjs/vuetify/issues/2754)
* **v-select:** fixed menu positioning when filtering ([b44e5b4](https://github.com/vuetifyjs/vuetify/commit/b44e5b49c6050f6d6d32529f4707661b4d84640c))
* **v-select:** removed top and bottom padding for **chips** prop ([0deb043](https://github.com/vuetifyjs/vuetify/commit/0deb0433bfa85364e79ab9d21e4cfccc0037e5ae))
* **v-speed-dial:** renamed hover prop to open-on-hover ([#2903](https://github.com/vuetifyjs/vuetify/issues/2903)) ([6389663](https://github.com/vuetifyjs/vuetify/commit/6389663ebb00fcbd2971f764fde96807b2594171))
* **v-tab:** moved text specific styling to parent ([002b261](https://github.com/vuetifyjs/vuetify/commit/002b26148a1f5e50900b1fa688bfe7b1b5cb1049)), closes [#2909](https://github.com/vuetifyjs/vuetify/issues/2909)
* **v-tabs:** fixed error when using routes and tabs ([604faa6](https://github.com/vuetifyjs/vuetify/commit/604faa6df7af53fbff7f643672727b97791e0731)), closes [#2921](https://github.com/vuetifyjs/vuetify/issues/2921)
* **v-tabs:** moved css property ([7a39fb1](https://github.com/vuetifyjs/vuetify/commit/7a39fb133a0d2acd84ad4d20482402173da58219))
* **v-toolbar:** toolbar was applying incorrect application top ([743ba06](https://github.com/vuetifyjs/vuetify/commit/743ba06548002061732b0f5112037892c0af90c3))
* **VTextField:** only use valid domProps ([#3078](https://github.com/vuetifyjs/vuetify/issues/3078)) ([3344ddd](https://github.com/vuetifyjs/vuetify/commit/3344dddf2b02f604a4f5e8868f3111f13413b761)), closes [#3072](https://github.com/vuetifyjs/vuetify/issues/3072)
* add missing boolean operator ([3941758](https://github.com/vuetifyjs/vuetify/commit/394175890711fd2625d9cdecb99fe11e3503108f))
* added Colorable mixin to VAvatar ([d714af9](https://github.com/vuetifyjs/vuetify/commit/d714af95f4b2f764e2e26ce39810e5cd59621efc))
* do not apply ripple on disabled routable ([#2899](https://github.com/vuetifyjs/vuetify/issues/2899)) ([ec9fcae](https://github.com/vuetifyjs/vuetify/commit/ec9fcae39d982eddb0b51f866684eb85682c8ba8))
* fixed right aligned tabs ([ca1973d](https://github.com/vuetifyjs/vuetify/commit/ca1973d84d9b0224bc36940885ed37bf02594c39))
* flex-grow for tabs_container ([114f6fa](https://github.com/vuetifyjs/vuetify/commit/114f6fa3ee927f0ec8eb1f925f03441185c58dd7))
* move stylus with side-effects from tools to generic ([3d36d83](https://github.com/vuetifyjs/vuetify/commit/3d36d8352948a697061727762e1b55ad4f2a5916))
* remove old tooltip import from app.styl ([a8ad157](https://github.com/vuetifyjs/vuetify/commit/a8ad15711583c5ff148ebf020709cd005eadc95f))
* ripple prop as an object is passed as a bool to ripple directive ([7c18ae8](https://github.com/vuetifyjs/vuetify/commit/7c18ae8eb6c396d75fc143084be5aa933ae9a284))
* **v-stepper-content:** height not being set to auto ([f0fd28b](https://github.com/vuetifyjs/vuetify/commit/f0fd28b6a7562b1ae55abd7daa678d3f9a7e559e)), closes [#2870](https://github.com/vuetifyjs/vuetify/issues/2870)
* **v-tabs:** added flex-grow to centered tabs ([351eb82](https://github.com/vuetifyjs/vuetify/commit/351eb823632fb363efb23f4be2945d49c9affc32))
* **v-tabs:** fixed-tabs needed the container to grow ([66e8629](https://github.com/vuetifyjs/vuetify/commit/66e86292f983a551b9217869ddb16f0a9a660316))
* **v-toolbar:** corrected directive arguments ([d14f367](https://github.com/vuetifyjs/vuetify/commit/d14f367fce85eb6fb9d006bc902fffaff373a6cc))
* **VNavigationDrawer:** only close on route change when mobile/temporary ([99efccc](https://github.com/vuetifyjs/vuetify/commit/99efcccfacc4ef2f8201bdb38a422d0b869bf4ee)), closes [#2894](https://github.com/vuetifyjs/vuetify/issues/2894)
* **VSelect:** refresh menu position when filteredItems changes ([#2829](https://github.com/vuetifyjs/vuetify/issues/2829)) ([d6b1351](https://github.com/vuetifyjs/vuetify/commit/d6b13514e6d5899a6e26ea5006fb29b2f019ee1c)), closes [#2269](https://github.com/vuetifyjs/vuetify/issues/2269)
* **VTabs:** use new value as an index if tab action isn't found ([39f6717](https://github.com/vuetifyjs/vuetify/commit/39f671737384949b072cf05cb4aa453e5cba2fa0))
* application not updating top on screen resize ([#2782](https://github.com/vuetifyjs/vuetify/issues/2782)) ([68b7d8d](https://github.com/vuetifyjs/vuetify/commit/68b7d8de325995f5001936a4208514da43aa9988)), closes [#2781](https://github.com/vuetifyjs/vuetify/issues/2781)
* fixed bug where drawer would close on any touch event ([d7aa97e](https://github.com/vuetifyjs/vuetify/commit/d7aa97e4f42c4bfd40d27d102184a869439f3e38))
* removed unnecessary prop ([34d5e07](https://github.com/vuetifyjs/vuetify/commit/34d5e07883bc9ec9c0d7da64c7df057e8cd275ff))
* typo in prop definition ([65129b9](https://github.com/vuetifyjs/vuetify/commit/65129b910cfbbc8502c9b3f88e801ed44138dedf)), closes [#2803](https://github.com/vuetifyjs/vuetify/issues/2803)
* **input-groups:** added themeable for the **solo** prop ([e0a376d](https://github.com/vuetifyjs/vuetify/commit/e0a376dc14b0e4640be381ffd5140b9024cc5560)), closes [#2705](https://github.com/vuetifyjs/vuetify/issues/2705)
* **menuable:** removed position reset ([df2eec8](https://github.com/vuetifyjs/vuetify/commit/df2eec868c598c748822337c76d153619c3a161e)), closes [#2634](https://github.com/vuetifyjs/vuetify/issues/2634)
* **overlayable:** only check Elements for a scrollbar ([a5023be](https://github.com/vuetifyjs/vuetify/commit/a5023be65d51cb0c5a3f2eee8689e9e13c2bb83c)), closes [#2586](https://github.com/vuetifyjs/vuetify/issues/2586)
* **speed-dial:** Allow any element inside the activator button ([#2650](https://github.com/vuetifyjs/vuetify/issues/2650)) ([9066fb1](https://github.com/vuetifyjs/vuetify/commit/9066fb1a30eed2ea0774a160e045b93597300b8d))
* **tests:** downgrade babel-jest back to 21.0.2 ([405d121](https://github.com/vuetifyjs/vuetify/commit/405d12117e7ef0cba3ee16713e56323472f8bbed))
* **theme, ssr:** create $ssrContext._styles if it doesn't exist ([a082374](https://github.com/vuetifyjs/vuetify/commit/a0823746c8699a5cf0074b2e5e16e73e633acd34))
* **v-card:** fixed border radius when in card ([d7215d0](https://github.com/vuetifyjs/vuetify/commit/d7215d071e575be20afe909bc67ba2f6ab45a93c))
* **v-data-table:** adjusted icon size ([5b6dec6](https://github.com/vuetifyjs/vuetify/commit/5b6dec6b1338345a0477fcaf084c501a965327a1))
* **v-data-table:** removed key assignment to slotted tr ([2cf08d7](https://github.com/vuetifyjs/vuetify/commit/2cf08d71a9d32311d79846828ecb076d0c978758))
* **v-jumbotron:** added width 100% to image ([77dbf9f](https://github.com/vuetifyjs/vuetify/commit/77dbf9f44c0745167c5e37d80ebc3d1903c7bcf9)), closes [#2751](https://github.com/vuetifyjs/vuetify/issues/2751)
* **v-list:** fixed list display issue caused by a45089a6c646811a7fd08a6df66eb2f2e6d01a83 ([b9625af](https://github.com/vuetifyjs/vuetify/commit/b9625afa4ce1ad53e01760b55e6d8fa73f8b8c3e))
* **v-list:** fixed spacing in mini drawer ([a45089a](https://github.com/vuetifyjs/vuetify/commit/a45089a6c646811a7fd08a6df66eb2f2e6d01a83)), closes [#2746](https://github.com/vuetifyjs/vuetify/issues/2746)
* **v-list:** fixed top and bottom borders showing when active ([4e1a7de](https://github.com/vuetifyjs/vuetify/commit/4e1a7de014f6db7647b30a80130df16ac8673a73))
* **v-list-tile-action:** fixed alignment of selection-controls ([4f9d982](https://github.com/vuetifyjs/vuetify/commit/4f9d982980c8a86b38008687446b50fe973734ae)), closes [#2684](https://github.com/vuetifyjs/vuetify/issues/2684)
* **v-navigation-drawer:** added check for element before attempting to scrollTop ([efdbd80](https://github.com/vuetifyjs/vuetify/commit/efdbd80c6390b5f770b0e75956e396218c5a834c))
* **v-navigation-drawer:** resizing from mobile to desktop not updating layout ([2b40331](https://github.com/vuetifyjs/vuetify/commit/2b403314fa81a772907c216bd656c0dfe5d7dc28))
* **v-navigation-drawer:** revert lazy styles ([#2719](https://github.com/vuetifyjs/vuetify/issues/2719)) ([9fdf43d](https://github.com/vuetifyjs/vuetify/commit/9fdf43dd3d1d9fa0d71187b511638bae91d3cafa))
* **v-pagination:** change keys to use array index ([#2718](https://github.com/vuetifyjs/vuetify/issues/2718)) ([e371b81](https://github.com/vuetifyjs/vuetify/commit/e371b81df473f130d1cd7b4ef502e7e4fa2ea354))
* **v-progress-linear:** fixed active/inactive animation ([c2c114c](https://github.com/vuetifyjs/vuetify/commit/c2c114c3e4bdafcf90fd8a6d47b5abd3ffe0a7b5))
* **v-radio:** added error functionality ([60868e1](https://github.com/vuetifyjs/vuetify/commit/60868e19a8ef98750fe2dfa674b93f1d56c1161a)), closes [#2212](https://github.com/vuetifyjs/vuetify/issues/2212)
* **v-select:** fixed bug clearing value on tabout ([72ca1b9](https://github.com/vuetifyjs/vuetify/commit/72ca1b9bd7cd8b35a47c44055d9431c7b9c6217a)), closes [#2697](https://github.com/vuetifyjs/vuetify/issues/2697)
* **v-select:** fixed currentRange not properly evaluating integers ([496ff2c](https://github.com/vuetifyjs/vuetify/commit/496ff2c2f15270cd97d1acf50f7636fda8977bc5))
* **v-select:** fixed on blur value for combobox ([e9c405a](https://github.com/vuetifyjs/vuetify/commit/e9c405a643a0c47c4da7cf9529e387c2db09f69c))
* **v-select:** Initial items passed via prop should be cached too ([#2667](https://github.com/vuetifyjs/vuetify/issues/2667)) ([ea4f74a](https://github.com/vuetifyjs/vuetify/commit/ea4f74a0ec46cdc87bfb1482212b1e6a967b90ef))
* **v-select:** updated nudge top values for various props ([d78aac6](https://github.com/vuetifyjs/vuetify/commit/d78aac6cee745db52ba11914c755da29baaf63f6)), closes [#2626](https://github.com/vuetifyjs/vuetify/issues/2626)
* **v-select:** updated to handle integer 0 ([e05a390](https://github.com/vuetifyjs/vuetify/commit/e05a390e9530f22763552ab0aec7d4b1e67d4eba))
* **v-stepper:** fixed transition being cancelled early in certain situations ([eb19639](https://github.com/vuetifyjs/vuetify/commit/eb19639ef961caf3019d91361c8c0fa485e3999e)), closes [#2410](https://github.com/vuetifyjs/vuetify/issues/2410)
* **v-toolbar:** allow dynamic changing of **scroll-off-screen** ([11d0a5e](https://github.com/vuetifyjs/vuetify/commit/11d0a5e35b3eeeaa4b7dfa81bca2490690344682))
* **v-toolbar:** fixed a bug where scrolling to top would bring back a manual-scrolled toolbar ([36bc2a1](https://github.com/vuetifyjs/vuetify/commit/36bc2a16c0d4a78b1b20ce7a6a09cab66c9dde7b))
* **v-toolbar:** fixed false positive when scrolling ([d152334](https://github.com/vuetifyjs/vuetify/commit/d1523342850c0239e755187943024f749dc599c3))
* **v-toolbar:** re-evaluate application when **inverted-scroll** changes ([6ad1113](https://github.com/vuetifyjs/vuetify/commit/6ad1113c8d35fc6ed41ba7efe3dfe87fcb13dbf1))
* **v-toolbar/v-system-bar:** fixed the usage of `v-toolbar` and `v-system-bar` when using the **app* ([d89401a](https://github.com/vuetifyjs/vuetify/commit/d89401a2b3d91c3f0376e13420a6304ea9deccdf))
* **VBtn:** override padding on icon buttons ([8d6c8b7](https://github.com/vuetifyjs/vuetify/commit/8d6c8b7a782a5eba341cdf5aee172940cdf4bf16)), closes [#2558](https://github.com/vuetifyjs/vuetify/issues/2558)
* **VDataTable:** reset expanded value to object instead of array ([#2666](https://github.com/vuetifyjs/vuetify/issues/2666)) ([21268c8](https://github.com/vuetifyjs/vuetify/commit/21268c885bda40941d2c5c4156ef44815fa8f7d9))
* **VDialog:** prevent scrollable dialog content from being cut off in IE ([#2720](https://github.com/vuetifyjs/vuetify/issues/2720)) ([3f089fa](https://github.com/vuetifyjs/vuetify/commit/3f089fa36d19b97af1cf95291055598f4334230b)), closes [#2654](https://github.com/vuetifyjs/vuetify/issues/2654)
* **Vicon:** merge custom inline styles ([e4c1166](https://github.com/vuetifyjs/vuetify/commit/e4c1166e092abc59e835f6bfd0b4a3b925613df5)), closes [#2764](https://github.com/vuetifyjs/vuetify/issues/2764)
* **VSelect:** don't open the menu if readonly or disabled ([64b7e9e](https://github.com/vuetifyjs/vuetify/commit/64b7e9ee2754ee5f1aee759e501f0bbc8e4657c4)), closes [#2690](https://github.com/vuetifyjs/vuetify/issues/2690)
* accent button text color ([#2589](https://github.com/vuetifyjs/vuetify/issues/2589)) ([d74b138](https://github.com/vuetifyjs/vuetify/commit/d74b13843ff35f685917e660e1aa7f8059fa26fb)), closes [#2581](https://github.com/vuetifyjs/vuetify/issues/2581)
* added keys to stuff ([#2630](https://github.com/vuetifyjs/vuetify/issues/2630)) ([f09a516](https://github.com/vuetifyjs/vuetify/commit/f09a5165b77ead7b7e81e61a977a39d60e5c849c))
* **a-la-carte:** add missing exports ([#2473](https://github.com/vuetifyjs/vuetify/issues/2473)) ([888cbc5](https://github.com/vuetifyjs/vuetify/commit/888cbc5990d6d3783bf149f484a1a6900f40ada1)), closes [#2472](https://github.com/vuetifyjs/vuetify/issues/2472)
* **drawer:** convert isMobile to a computed property ([#2569](https://github.com/vuetifyjs/vuetify/issues/2569)) ([7430503](https://github.com/vuetifyjs/vuetify/commit/743050378ef09208ff44b5a3125a89908956a0c0)), closes [#2559](https://github.com/vuetifyjs/vuetify/issues/2559)
* **drawer:** only update layout when isActive changes ([b521ada](https://github.com/vuetifyjs/vuetify/commit/b521ada40f18299c17ea04988ebd7958c00bd7e8)), closes [#2512](https://github.com/vuetifyjs/vuetify/issues/2512)
* **drawer:** set correct content padding when temporary is toggled ([fe4eaba](https://github.com/vuetifyjs/vuetify/commit/fe4eaba21f6a5c9b850e1e7ba29b654dade8b48b))
* **v-list-tile-avatar:** refactored v-list-tile-avatar ([#2554](https://github.com/vuetifyjs/vuetify/issues/2554)) ([af1f9e4](https://github.com/vuetifyjs/vuetify/commit/af1f9e458f0c27e2293dbc9cb20c34467af35ac9)), closes [#1805](https://github.com/vuetifyjs/vuetify/issues/1805)
* display progress with headers slot ([#2479](https://github.com/vuetifyjs/vuetify/issues/2479)) ([50023ab](https://github.com/vuetifyjs/vuetify/commit/50023abec4a9f662d166f0e866f1551e6ac306b4)), closes [#2471](https://github.com/vuetifyjs/vuetify/issues/2471)
* remove extra padding from text field hint with prepended icon ([189954f](https://github.com/vuetifyjs/vuetify/commit/189954f71556ddccddf3d4fd2809f8b1f00f8785)), closes [#2063](https://github.com/vuetifyjs/vuetify/issues/2063) [#895](https://github.com/vuetifyjs/vuetify/issues/895) [#2517](https://github.com/vuetifyjs/vuetify/issues/2517)
* TypeScript export default class ([#2440](https://github.com/vuetifyjs/vuetify/issues/2440)) ([c352b71](https://github.com/vuetifyjs/vuetify/commit/c352b71966bf304758d4ae762e99dd2a7adeb9ee))
* **chip:** Move chip__content in front of background ([#2505](https://github.com/vuetifyjs/vuetify/issues/2505)) ([abb00d6](https://github.com/vuetifyjs/vuetify/commit/abb00d6afd5c87827c5dbb4f04bde8154d9c3bdc)), closes [#2501](https://github.com/vuetifyjs/vuetify/issues/2501)
* **stylus:** removed deprecated variable ([a08a37d](https://github.com/vuetifyjs/vuetify/commit/a08a37d2ccc6f71bfe9d698c5aa91385f5bd6659)), closes [#2497](https://github.com/vuetifyjs/vuetify/issues/2497)
* **subheader:** use correct text color ([872ade1](https://github.com/vuetifyjs/vuetify/commit/872ade15731715e647bca8dfcf223c0b2b0c72f0)), closes [#2054](https://github.com/vuetifyjs/vuetify/issues/2054)
* **tabs:** scroll controls were visible on mobile ([d438347](https://github.com/vuetifyjs/vuetify/commit/d43834752bbf0903fed1e4603dc8981b5919cf86))
* **text-field:** update lazyValue when bound value is changed by keydown ([#2503](https://github.com/vuetifyjs/vuetify/issues/2503)) ([f0b26ec](https://github.com/vuetifyjs/vuetify/commit/f0b26eccad393ffce152d4e477ef4fe987e82128))
* **theme:** generate theme stylesheet with SSR ([#2486](https://github.com/vuetifyjs/vuetify/issues/2486)) ([a39d01d](https://github.com/vuetifyjs/vuetify/commit/a39d01d6da9a2c93ff9333f08cffa71141260b86))
* **toolbar:** set correct mobile landscape height ([bc82fd5](https://github.com/vuetifyjs/vuetify/commit/bc82fd514f30849380c96a992fc43e70b25b6a99)), closes [#2447](https://github.com/vuetifyjs/vuetify/issues/2447)
* **v-bottom-nav:** added **app** support ([09791da](https://github.com/vuetifyjs/vuetify/commit/09791da95d4a82e6a59f72cb7145c1719fe17ba5)), closes [#2423](https://github.com/vuetifyjs/vuetify/issues/2423)
* **v-chip:** adjusted styling for proper spacing and colors ([38f84be](https://github.com/vuetifyjs/vuetify/commit/38f84be0028220908bf4cc4cabcebfd6070773d8)), closes [#2236](https://github.com/vuetifyjs/vuetify/issues/2236)
* **v-chip:** fixed overlay position on focus ([1fc2663](https://github.com/vuetifyjs/vuetify/commit/1fc26634a8a68883d0812a0479a6c0c432ce3448)), closes [#2539](https://github.com/vuetifyjs/vuetify/issues/2539)
* **v-dialog:** compare target on outside click ([0ef59de](https://github.com/vuetifyjs/vuetify/commit/0ef59de322641d1a1d08380918f073ddc4d23209)), closes [#2463](https://github.com/vuetifyjs/vuetify/issues/2463)
* **v-list:** changed markup to use proper tags ([8a55cc0](https://github.com/vuetifyjs/vuetify/commit/8a55cc0038358e3c63d723012e3aed2dfb1c9b78)), closes [#2301](https://github.com/vuetifyjs/vuetify/issues/2301)
* **v-menu:** added proper calculation for content min width ([d8d7b33](https://github.com/vuetifyjs/vuetify/commit/d8d7b3396a30c9c6a283b8397fcc98501eb5376a)), closes [#2416](https://github.com/vuetifyjs/vuetify/issues/2416)
* **v-navigation-drawer:** added stateless prop, fixed booting logic ([e7bc6e2](https://github.com/vuetifyjs/vuetify/commit/e7bc6e224866b73b0db32ec09b6973efdb0c8374))
* **v-navigation-drawer:** added temporary check in init ([e1759f1](https://github.com/vuetifyjs/vuetify/commit/e1759f1d24cbe2c5f042bc19db88bc331918725d))
* **v-navigation-drawer:** update drawer states reactivity with permanent ([#2495](https://github.com/vuetifyjs/vuetify/issues/2495)) ([10c64e3](https://github.com/vuetifyjs/vuetify/commit/10c64e3163fce752d4e81f4529cb45595c97270d)), closes [#2493](https://github.com/vuetifyjs/vuetify/issues/2493) [vuejs/vue#7063](https://github.com/vuejs/vue/issues/7063)
* **v-select:** adjusted nudge top based upon **hide-details** prop ([e2e11ba](https://github.com/vuetifyjs/vuetify/commit/e2e11ba6a6153422bf421c03af1423d3eed28dfa)), closes [#2377](https://github.com/vuetifyjs/vuetify/issues/2377)
* **v-tabs:** abort evaluation if there are no more items ([eb51034](https://github.com/vuetifyjs/vuetify/commit/eb51034eb49e56182a4c1d0f50e9e53b31aecbf3))
* **v-text-field:** stop propagation of return key when using **multi-line** prop ([8fce320](https://github.com/vuetifyjs/vuetify/commit/8fce320bf28eca51ba4ec2d312344cf622eb905d)), closes [#2506](https://github.com/vuetifyjs/vuetify/issues/2506)
* **VNavigationDrawer:** update application when miniVariant changes ([fc06302](https://github.com/vuetifyjs/vuetify/commit/fc0630267dc279d365e7e107a3a66cd61f49b6cb)), closes [#2534](https://github.com/vuetifyjs/vuetify/issues/2534) [#2547](https://github.com/vuetifyjs/vuetify/issues/2547)
* block next button when value equals to length ([0589c15](https://github.com/vuetifyjs/vuetify/commit/0589c1513c8938d5592a7850cc44930ace4a9254)), closes [#2433](https://github.com/vuetifyjs/vuetify/issues/2433) [#2460](https://github.com/vuetifyjs/vuetify/issues/2460)
* disabled pagination next button if length=0 ([#2460](https://github.com/vuetifyjs/vuetify/issues/2460)) ([50fc653](https://github.com/vuetifyjs/vuetify/commit/50fc65312896e21ee70441f5471ab4838633e53a)), closes [#2433](https://github.com/vuetifyjs/vuetify/issues/2433)
* Don't let cssnano mess with z-indexes ([e748769](https://github.com/vuetifyjs/vuetify/commit/e748769426391e55f65db7a62e50aa1f58928461)), closes [#2449](https://github.com/vuetifyjs/vuetify/issues/2449)
* **VDataTable:** customFilter function now only filters on header values ([#2287](https://github.com/vuetifyjs/vuetify/issues/2287)) ([648e03f](https://github.com/vuetifyjs/vuetify/commit/648e03faf89fb2a68ed5d6fb59accfc5869800cc)), closes [#1045](https://github.com/vuetifyjs/vuetify/issues/1045)
* clip progress bar on loading input groups ([aba924a](https://github.com/vuetifyjs/vuetify/commit/aba924a7e159fe703b3fd1ceae895ac0220f6e10)), closes [#2063](https://github.com/vuetifyjs/vuetify/issues/2063)
* picker header color in dark theme ([#2402](https://github.com/vuetifyjs/vuetify/issues/2402)) ([5bfd110](https://github.com/vuetifyjs/vuetify/commit/5bfd1102b85030717980fe1e8fe159f5a4dccd7c))
* removed javascript:; declarations ([#2450](https://github.com/vuetifyjs/vuetify/issues/2450)) ([b2b1a4a](https://github.com/vuetifyjs/vuetify/commit/b2b1a4a96bf87d938c415ffbc8197131e67b276f)), closes [#2321](https://github.com/vuetifyjs/vuetify/issues/2321)
* updated link specificity ([6c2adf4](https://github.com/vuetifyjs/vuetify/commit/6c2adf4447b8d2d81779fdef988e2498a3c978f6)), closes [#2437](https://github.com/vuetifyjs/vuetify/issues/2437)
* **VForm:** don't show native validation errors on submit ([c58cf66](https://github.com/vuetifyjs/vuetify/commit/c58cf66a64b88a6165ee4ccf0e373ec6ca72f68f)), closes [#2445](https://github.com/vuetifyjs/vuetify/issues/2445)
* escape item text in select menu ([#2391](https://github.com/vuetifyjs/vuetify/issues/2391)) ([d6a2582](https://github.com/vuetifyjs/vuetify/commit/d6a25820a9a6bc7adf89349f2e811dfcfceb88f6))
* **v-select:** removed dev code ([b0b8707](https://github.com/vuetifyjs/vuetify/commit/b0b87072c2c6b7b5a0bd3316f01f1f7de460d280))
* **v-select:** updated logic for determining menu active state ([da6bec6](https://github.com/vuetifyjs/vuetify/commit/da6bec67881039482867e144b340694dd8974ff5)), closes [#2103](https://github.com/vuetifyjs/vuetify/issues/2103)
* [#2342](https://github.com/vuetifyjs/vuetify/issues/2342) ([#2344](https://github.com/vuetifyjs/vuetify/issues/2344)) ([df230ed](https://github.com/vuetifyjs/vuetify/commit/df230edb1273f608295ed9cebefdc12b8feb1ee5))
* **input:** removed generation of messages with prop ([3eb8c4a](https://github.com/vuetifyjs/vuetify/commit/3eb8c4a9a4518ea6570390e14b92f03d030a37a3)), closes [#2417](https://github.com/vuetifyjs/vuetify/issues/2417)
* invalid textfield behaviour with number value ([#2360](https://github.com/vuetifyjs/vuetify/issues/2360)) ([f12c7ef](https://github.com/vuetifyjs/vuetify/commit/f12c7ef233220641761db7990c9923a613d6daf1)), closes [#2359](https://github.com/vuetifyjs/vuetify/issues/2359)
* **chips:** prevent changing the size of an element in outline mode ([#2394](https://github.com/vuetifyjs/vuetify/issues/2394)) ([8dd82f6](https://github.com/vuetifyjs/vuetify/commit/8dd82f6b2edfa4a805c902e732b50569b4d1b6aa))
* (VExpansionPanel) use component name instead of private property _componentTag ([#2312](https://github.com/vuetifyjs/vuetify/issues/2312)) ([1face80](https://github.com/vuetifyjs/vuetify/commit/1face802cec0d339dcc9de183bf44c65c32d43a7))
* **layout:** fix layout regression from [#2298](https://github.com/vuetifyjs/vuetify/issues/2298) ([#2328](https://github.com/vuetifyjs/vuetify/issues/2328)) ([7203c7d](https://github.com/vuetifyjs/vuetify/commit/7203c7d41a03de2078e8a094cfbf7c57055232c6))
* **layout:** make .application the root element again ([1825d2a](https://github.com/vuetifyjs/vuetify/commit/1825d2ac7a7593bafc9d198b3fd5ac6dbbc92e4f))
* **perf:** gpu accelerate time picker hand ([1f89d64](https://github.com/vuetifyjs/vuetify/commit/1f89d64b11670f9ac0fef56e7cc7ba6167382e90))
* **perf:** Make date pickers slightly faster ([5e5b40e](https://github.com/vuetifyjs/vuetify/commit/5e5b40ef96408873b6180aba0a39ed8e1d3877fd))
* **ripple:** size the ripple correctly to its activator ([16cfdec](https://github.com/vuetifyjs/vuetify/commit/16cfdec37327a131f1fb57d7b018960b9bdb855f))
* **v-badge:** fixed text vertical position ([7072183](https://github.com/vuetifyjs/vuetify/commit/7072183625ae048fd057a65800796c0172267eda))
* **v-chip:** fixed sizing bug in `v-chip` when using the **small** prop ([08284ac](https://github.com/vuetifyjs/vuetify/commit/08284aca73cf49d0d68d748947d5b03832b2ff3d))
* **v-icon:** updated style specificity for color ([efe74f3](https://github.com/vuetifyjs/vuetify/commit/efe74f309510e90b6c9c8fab2b0eb4d8874de708))
* **v-navigation-drawer:** fixed `v-navigation-drawer` with **temporary** prop ([676d4a3](https://github.com/vuetifyjs/vuetify/commit/676d4a306e2b7a5c794cd1c4ccef7e674b85252c))
* **v-select:** fixed combobox functionality ([e6993e5](https://github.com/vuetifyjs/vuetify/commit/e6993e5aac5ec4bd417841365e416d54778a1b0d))
* **v-tabs:** fixed ssr-bug, remove default background declaration ([bd0ce95](https://github.com/vuetifyjs/vuetify/commit/bd0ce959c3e3877c3f00478f3ff9585c5acb7bf2))
* **v-tabs-item:** added theme colors ([ada1d09](https://github.com/vuetifyjs/vuetify/commit/ada1d09c50d1c5e6703c3960e183765821d8285a))
* **v-text-field:** fixed **internalChange** prop not resetting ([0414fc6](https://github.com/vuetifyjs/vuetify/commit/0414fc62b9a71fb2f609c55607da5fd12ff5a216))
* adds quotes to background image ([#2349](https://github.com/vuetifyjs/vuetify/issues/2349)) ([f26b660](https://github.com/vuetifyjs/vuetify/commit/f26b660163ef74bf0c91c152d5eec05930896219)), closes [#2346](https://github.com/vuetifyjs/vuetify/issues/2346)
* **btn:** fixed fab and outline styling ([a2bd0f2](https://github.com/vuetifyjs/vuetify/commit/a2bd0f2c9197bd0866b506adff02a1cd56e1c701))
* **v-select:** fixed auto menu position ([c52bf1f](https://github.com/vuetifyjs/vuetify/commit/c52bf1f448dda10e6fee9f9cbaaabb58b8fde187))
* allow string for mobileBreakPoint in v-navigation-drawer ([4cc9c01](https://github.com/vuetifyjs/vuetify/commit/4cc9c01549cb6111fae256f973b24cd29ba4996f))
* Allow text fields to have an initial value of 0 ([95b7f83](https://github.com/vuetifyjs/vuetify/commit/95b7f834688eeb486ca3e922945a50c89e4a47bc)), closes [#2136](https://github.com/vuetifyjs/vuetify/issues/2136)
* arrow up/down not working in inputs in dialog ([#2350](https://github.com/vuetifyjs/vuetify/issues/2350)) ([aa8684a](https://github.com/vuetifyjs/vuetify/commit/aa8684a3567353c587cc97932ec7b4e4faa0103a)), closes [#2319](https://github.com/vuetifyjs/vuetify/issues/2319)
* auto height of data table expanded row ([#2275](https://github.com/vuetifyjs/vuetify/issues/2275)) ([9e4d92b](https://github.com/vuetifyjs/vuetify/commit/9e4d92bac9c2afd569b28981be0a959281b7d497))
* background color for segmented button ([#2183](https://github.com/vuetifyjs/vuetify/issues/2183)) ([5500c0b](https://github.com/vuetifyjs/vuetify/commit/5500c0bfe87b06e3ea7facae7b57c4d49be699b3)), closes [#2126](https://github.com/vuetifyjs/vuetify/issues/2126)
* clearable icon behaviour in autocomplete ([#2263](https://github.com/vuetifyjs/vuetify/issues/2263)) ([eb1879d](https://github.com/vuetifyjs/vuetify/commit/eb1879d85d15cc57def091150305e76295c93a28)), closes [#2200](https://github.com/vuetifyjs/vuetify/issues/2200)
* disable focusing slider when disabled ([e44c079](https://github.com/vuetifyjs/vuetify/commit/e44c07959f7e10e3ccd1dac370f103f3226f51fe))
* don't setSelectionRange if the input doesn't exist any more ([0a406e9](https://github.com/vuetifyjs/vuetify/commit/0a406e9751e395b1d092482eda4af6ad39d2f25f)), closes [#2219](https://github.com/vuetifyjs/vuetify/issues/2219)
* don't trigger click-outside when click() is called programmaticaly ([#2229](https://github.com/vuetifyjs/vuetify/issues/2229)) ([50d3b8b](https://github.com/vuetifyjs/vuetify/commit/50d3b8b8ee9ede65834e07eb767f9b4925987431)), closes [#2092](https://github.com/vuetifyjs/vuetify/issues/2092)
* proper unbinding of touch events ([#2286](https://github.com/vuetifyjs/vuetify/issues/2286)) ([b29b7a5](https://github.com/vuetifyjs/vuetify/commit/b29b7a55dc6031c19c6aa622bf418760a9726f7d)), closes [#2248](https://github.com/vuetifyjs/vuetify/issues/2248)
* remove necessity of <main> ([#2298](https://github.com/vuetifyjs/vuetify/issues/2298)) ([3744603](https://github.com/vuetifyjs/vuetify/commit/3744603d3107c7e1a244f8b9224b723d6e32a87f))
* **menuable:** added comparison logic for shown ([8792777](https://github.com/vuetifyjs/vuetify/commit/879277771ff201269e6c07cc5d5d6e7588250d08))
* **v-select:** fixed tests from [#2243](https://github.com/vuetifyjs/vuetify/issues/2243) PR ([efebc93](https://github.com/vuetifyjs/vuetify/commit/efebc93e416504f388f0e31ba91881a7af04c13f))
* **v-tooltip:** increased flex width of tooltip ([#2206](https://github.com/vuetifyjs/vuetify/issues/2206)) ([a1265fa](https://github.com/vuetifyjs/vuetify/commit/a1265fa51e5c46fbcedb02aa0afaaadcb0c89518)), closes [#2171](https://github.com/vuetifyjs/vuetify/issues/2171)
* **VDialog:** focus dialog__content when opened ([4bcda35](https://github.com/vuetifyjs/vuetify/commit/4bcda358dc12647e8255d7622bd685e5712eca40)), closes [#2261](https://github.com/vuetifyjs/vuetify/issues/2261)
* don't setSelectionRange if the input doesn't exist any more ([b35c446](https://github.com/vuetifyjs/vuetify/commit/b35c446ebe8a254f62a6571ceab48a3663d8c8b0)), closes [#2219](https://github.com/vuetifyjs/vuetify/issues/2219)
* prevent race condition when VSelect is destroyed after mount ([4695b21](https://github.com/vuetifyjs/vuetify/commit/4695b21eeb8922866b74fe97266ac74dacc3e0ca)), closes [#2194](https://github.com/vuetifyjs/vuetify/issues/2194)
* set proper expanded row height ([#2220](https://github.com/vuetifyjs/vuetify/issues/2220)) ([992bd59](https://github.com/vuetifyjs/vuetify/commit/992bd59a483539a7eb2e492df82228268b9e5e1a)), closes [#2215](https://github.com/vuetifyjs/vuetify/issues/2215)
* **VDialog:** only disable scrolling when active ([ce4e44c](https://github.com/vuetifyjs/vuetify/commit/ce4e44c2b1fda75c9ccac4bf72c021536a9cf72d)), closes [#2262](https://github.com/vuetifyjs/vuetify/issues/2262)
* set proper expanded row height ([#2220](https://github.com/vuetifyjs/vuetify/issues/2220)) ([7d4b463](https://github.com/vuetifyjs/vuetify/commit/7d4b463827d1f8489401082b02c6f1ee4cee98c7)), closes [#2215](https://github.com/vuetifyjs/vuetify/issues/2215)
* **VSelect:** check for addEventListener in isBooted watcher ([0c710b0](https://github.com/vuetifyjs/vuetify/commit/0c710b0bee18fccad9223312cab421ff7eb6dd09)), closes [#2213](https://github.com/vuetifyjs/vuetify/issues/2213) [#1821](https://github.com/vuetifyjs/vuetify/issues/1821)
* **VSelect:** check for addEventListener in isBooted watcher ([a2a3533](https://github.com/vuetifyjs/vuetify/commit/a2a35330169a8c7b9abbcfcbdacb91a0b995fcab)), closes [#2213](https://github.com/vuetifyjs/vuetify/issues/2213) [#1821](https://github.com/vuetifyjs/vuetify/issues/1821)
* **VSelect:** don't hide the text field when not dirty ([3592f5e](https://github.com/vuetifyjs/vuetify/commit/3592f5ef23f74b4ca7e0b2244530c467c6227639)), closes [#2214](https://github.com/vuetifyjs/vuetify/issues/2214) [#2172](https://github.com/vuetifyjs/vuetify/issues/2172)
* **VSelect:** don't hide the text field when not dirty ([f146c49](https://github.com/vuetifyjs/vuetify/commit/f146c49d1b0215c40c30cb28f87d68377833da13)), closes [#2214](https://github.com/vuetifyjs/vuetify/issues/2214) [#2172](https://github.com/vuetifyjs/vuetify/issues/2172)
* background color for segmented button ([#2183](https://github.com/vuetifyjs/vuetify/issues/2183)) ([49f4823](https://github.com/vuetifyjs/vuetify/commit/49f482381b2545d66e684f97e9ee4f52206a47d0)), closes [#2126](https://github.com/vuetifyjs/vuetify/issues/2126)
* data iterator items should not be filtered with empty search ([#2635](https://github.com/vuetifyjs/vuetify/issues/2635)) ([85bd400](https://github.com/vuetifyjs/vuetify/commit/85bd400867c7e5715f035d1d919bdf7636e49ffe)), closes [#2590](https://github.com/vuetifyjs/vuetify/issues/2590)
* do not render bootable content if not active ([#2347](https://github.com/vuetifyjs/vuetify/issues/2347)) ([8a9ec36](https://github.com/vuetifyjs/vuetify/commit/8a9ec365a42594af533257de9112da8cf59d176f)), closes [#2305](https://github.com/vuetifyjs/vuetify/issues/2305) [#2080](https://github.com/vuetifyjs/vuetify/issues/2080)
* don't select date when changing year and date not allowed ([#2612](https://github.com/vuetifyjs/vuetify/issues/2612)) ([9a3ae44](https://github.com/vuetifyjs/vuetify/commit/9a3ae44177251091f4309500090fa252259ce78e)), closes [#2611](https://github.com/vuetifyjs/vuetify/issues/2611)
* Don't show 'undefined' in empty v-selects with Vue 2.5.0 ([b7940c4](https://github.com/vuetifyjs/vuetify/commit/b7940c40794d726737453dc60c74ce30db9bf32d))
* Don't show 'undefined' in empty v-selects with Vue 2.5.0 ([f581177](https://github.com/vuetifyjs/vuetify/commit/f5811774f8ec34c68eba40256600583a8a3311a7))
* don't update inputDate if new date is not allowed ([#2198](https://github.com/vuetifyjs/vuetify/issues/2198)) ([79272bf](https://github.com/vuetifyjs/vuetify/commit/79272bf74e45e2fd9e37157fc57579356cedd4cc)), closes [#2106](https://github.com/vuetifyjs/vuetify/issues/2106)
* duplicated entries when using cache-items with return-object ([#2195](https://github.com/vuetifyjs/vuetify/issues/2195)) ([9c4da4a](https://github.com/vuetifyjs/vuetify/commit/9c4da4a9ff69fcc1d07b1926a95f2bec28d661b2))
* duplicated entries when using cache-items with return-object ([#2195](https://github.com/vuetifyjs/vuetify/issues/2195)) ([d3dddd8](https://github.com/vuetifyjs/vuetify/commit/d3dddd8e626ca49619dbe42c24dffd51be2e2529))
* fixed bug where drawer would close on any touch event ([5acd07e](https://github.com/vuetifyjs/vuetify/commit/5acd07e2c8822f00eddd155eb557d0999309f613))
* styles for buttons in bottom navigation ([#2182](https://github.com/vuetifyjs/vuetify/issues/2182)) ([bbaa09d](https://github.com/vuetifyjs/vuetify/commit/bbaa09d7d26beb0edbb82311d1b34d1ec690b998)), closes [#2015](https://github.com/vuetifyjs/vuetify/issues/2015)
* styles for buttons in bottom navigation ([#2182](https://github.com/vuetifyjs/vuetify/issues/2182)) ([94564d6](https://github.com/vuetifyjs/vuetify/commit/94564d6685a886c39fb6f50285829c214fe8f8f7)), closes [#2015](https://github.com/vuetifyjs/vuetify/issues/2015)
* **textarea:** Match border transition with the label ([25c56a3](https://github.com/vuetifyjs/vuetify/commit/25c56a3c53271c875a47c1cc532bdf6e686a4989))
* **v-dialog:** always remove scrollbar when fullscreen ([ff5d07b](https://github.com/vuetifyjs/vuetify/commit/ff5d07b6cd78d23312a924cc45269ea9818318b0)), closes [#3101](https://github.com/vuetifyjs/vuetify/issues/3101)
* **v-item-group:** avoid unregistration process when destroyed ([cd18540](https://github.com/vuetifyjs/vuetify/commit/cd18540d6f7a34443b00a7789f69e52f56dab729)), closes [#5384](https://github.com/vuetifyjs/vuetify/issues/5384)
* **v-item-group:** handle initial item state on registration ([4af99de](https://github.com/vuetifyjs/vuetify/commit/4af99de2e979ade669d3f479346101e530f5cddc)), closes [#5410](https://github.com/vuetifyjs/vuetify/issues/5410)
* **v-item-group:** invoke state update on nextTick ([b9a5e64](https://github.com/vuetifyjs/vuetify/commit/b9a5e649508965de761cf4473b35573899710a25)), closes [#5352](https://github.com/vuetifyjs/vuetify/issues/5352)
* **v-item-group:** update item model on register ([b6ec287](https://github.com/vuetifyjs/vuetify/commit/b6ec287d8ed3fc4b555df8d6b3f2868c82582d46)), closes [#5222](https://github.com/vuetifyjs/vuetify/issues/5222)
* **v-radio-group:** change radio margin selector ([08cac48](https://github.com/vuetifyjs/vuetify/commit/08cac4872d1643c5e96902fe42032ad121474861)), closes [#5255](https://github.com/vuetifyjs/vuetify/issues/5255)
* **v-rating:** switched from using offsetX to calculate half-increments ([#5374](https://github.com/vuetifyjs/vuetify/issues/5374)) ([e43441d](https://github.com/vuetifyjs/vuetify/commit/e43441d3f91dde84f8bc0832e61f4c0a792533e7)), closes [#5240](https://github.com/vuetifyjs/vuetify/issues/5240)
* **v-ripple:** decrease click target size on selection control ripple ([#5250](https://github.com/vuetifyjs/vuetify/issues/5250)) ([26af9bf](https://github.com/vuetifyjs/vuetify/commit/26af9bfea5b7b53b217e9bd9063e0e34699e3e6e)), closes [#2661](https://github.com/vuetifyjs/vuetify/issues/2661)
* **v-ripple:** only modify position if current one is static ([#5249](https://github.com/vuetifyjs/vuetify/issues/5249)) ([85bfe20](https://github.com/vuetifyjs/vuetify/commit/85bfe20c27205960dd2a2188185771583809b3cd)), closes [#2573](https://github.com/vuetifyjs/vuetify/issues/2573)
* **v-select:** change isDisabled conditional ([5cfaeba](https://github.com/vuetifyjs/vuetify/commit/5cfaeba0b7277823fb83ba5be4ec792009eace5d)), closes [#5051](https://github.com/vuetifyjs/vuetify/issues/5051)
* **v-select:** move progress loader ([43cb35f](https://github.com/vuetifyjs/vuetify/commit/43cb35f6f676d0f185f61af43d8ce9e30ad78a20)), closes [#5365](https://github.com/vuetifyjs/vuetify/issues/5365)
* **v-stepper:** add registrable mixin ([f7b17e7](https://github.com/vuetifyjs/vuetify/commit/f7b17e78b66420046382b8ad8a64b2ee7b0bcf7d)), closes [#3330](https://github.com/vuetifyjs/vuetify/issues/3330)
* **v-stepper:** remove deprecated fn call ([e454bba](https://github.com/vuetifyjs/vuetify/commit/e454bbafa9d081e6981fcd923ee194ff35a84b63))
* **v-tabs:** re-enable tests ([bb69dd5](https://github.com/vuetifyjs/vuetify/commit/bb69dd58d142078f57eb1e68dd0a12860010b2c2))
* **v-tabs:** remove arbitrary delay on init ([6810169](https://github.com/vuetifyjs/vuetify/commit/6810169ec01fcc7205e45ee0b421deecf6742ec0))
* **VImg:** load image after mount ([d72ea8d](https://github.com/vuetifyjs/vuetify/commit/d72ea8d91b710a427f2b36df5e0e08d8180e88d4)), closes [#5153](https://github.com/vuetifyjs/vuetify/issues/5153)
* VPagination acts as submit in forms ([#5212](https://github.com/vuetifyjs/vuetify/issues/5212)) ([#5229](https://github.com/vuetifyjs/vuetify/issues/5229)) ([cb29f21](https://github.com/vuetifyjs/vuetify/commit/cb29f210895c5ddb2585d792707bbf456636d94c))
* **v-item-group:** remove default flex-grow ([1fb9e58](https://github.com/vuetifyjs/vuetify/commit/1fb9e5848f847acca3a19963cfa33c9d4c22abd1)), closes [#5337](https://github.com/vuetifyjs/vuetify/issues/5337)
* **v-tabs:** scroll tab into view when model changes ([51e917c](https://github.com/vuetifyjs/vuetify/commit/51e917cb8e372516e0756ab5036ea4735496c993)), closes [#5052](https://github.com/vuetifyjs/vuetify/issues/5052)
* **VTab:** remove theme override ([2b2e06d](https://github.com/vuetifyjs/vuetify/commit/2b2e06d7657239501c3b639d4bc82c2aa3170364)), closes [#5349](https://github.com/vuetifyjs/vuetify/issues/5349)
* readded catalan locale ([932349a](https://github.com/vuetifyjs/vuetify/commit/932349ace32e6f74f4dc9ba2d3a69120cb2ec12d)), closes [#5348](https://github.com/vuetifyjs/vuetify/issues/5348)
* remove VBreadcrumbs.js ([5bc327b](https://github.com/vuetifyjs/vuetify/commit/5bc327bd02827ab760b6117b49545d19956ce2d2))
* **DatePicker:** Title spacing when month === August ([#5027](https://github.com/vuetifyjs/vuetify/issues/5027)) ([046d284](https://github.com/vuetifyjs/vuetify/commit/046d2840b3d0150c2cd42c642fa54e35e136988f))
* **directives:** register by key instead of name ([a443828](https://github.com/vuetifyjs/vuetify/commit/a4438289867621101748601ba06f05ff3d324e93)), closes [#4667](https://github.com/vuetifyjs/vuetify/issues/4667) [#4871](https://github.com/vuetifyjs/vuetify/issues/4871)
* **iterable:** rows-per-page selector not inheriting theme ([a81310f](https://github.com/vuetifyjs/vuetify/commit/a81310f6433dca9a78c1efd23eb75a21872da9e4))
* **selectable:** only emit change event once ([94c4b2e](https://github.com/vuetifyjs/vuetify/commit/94c4b2e9d02608ad0e462d59d1f9cebc555b4afb)), closes [#4886](https://github.com/vuetifyjs/vuetify/issues/4886)
* **theme:** work around vue-meta bug ([190274f](https://github.com/vuetifyjs/vuetify/commit/190274fc58125803108a3cf0a3374059c7b61b07)), closes [#4958](https://github.com/vuetifyjs/vuetify/issues/4958)
* **transitions:** fix scroll-y ([49a8cbe](https://github.com/vuetifyjs/vuetify/commit/49a8cbec3a7246e3d4ae7327c8159795f6ddcc03))
* **transitions:** fix slide-y-reverse-transition ([91f0fb3](https://github.com/vuetifyjs/vuetify/commit/91f0fb3095b329bc5a9ed6160a11f76b0febf084)), closes [#4971](https://github.com/vuetifyjs/vuetify/issues/4971) [#4978](https://github.com/vuetifyjs/vuetify/issues/4978)
* **translatable:** partially revert 5f661a3 ([ffc3c9c](https://github.com/vuetifyjs/vuetify/commit/ffc3c9c501ff8e7dfcc43ace58e2734ec49e395c)), closes [#4847](https://github.com/vuetifyjs/vuetify/issues/4847)
* **v-autocomplete:** add conditional for single-line ([d74624c](https://github.com/vuetifyjs/vuetify/commit/d74624ca1bd2304e20c2a7774eaedf510e31a410)), closes [#5076](https://github.com/vuetifyjs/vuetify/issues/5076)
* **v-autocomplete:** allow setSearch for numeric 0 ([488f0d6](https://github.com/vuetifyjs/vuetify/commit/488f0d602cb1c055b7757e91423f7696eba3e093)), closes [#5110](https://github.com/vuetifyjs/vuetify/issues/5110)
* **v-combobox:** prevent default action ([259da33](https://github.com/vuetifyjs/vuetify/commit/259da33bff5627b7f5d9a79e0b4b9627883f6be5)), closes [#4974](https://github.com/vuetifyjs/vuetify/issues/4974)
* **v-combobox:** update onEnterDown logic ([6179807](https://github.com/vuetifyjs/vuetify/commit/61798076229021e5b61a34c22c60bf05fc9dabe3)), closes [#5008](https://github.com/vuetifyjs/vuetify/issues/5008)
* **v-divider:** fix **vertical** prop display ([96c4391](https://github.com/vuetifyjs/vuetify/commit/96c43910b83cf22d8ffb7e7c80135c30971df52c))
* **v-divider:** fix vertical styles ([04a8b86](https://github.com/vuetifyjs/vuetify/commit/04a8b8659a02c0419d63f9e5789df6dc69d74687)), closes [#4976](https://github.com/vuetifyjs/vuetify/issues/4976)
* **v-expand-transition:** fix replaced height ([9412890](https://github.com/vuetifyjs/vuetify/commit/94128903d535752bc64260d7735bb22cdf888799))
* **v-expand-transition:** remove height afterLeave ([f90d17b](https://github.com/vuetifyjs/vuetify/commit/f90d17be03531526614edb59a76ade238472949c)), closes [#4808](https://github.com/vuetifyjs/vuetify/issues/4808)
* **v-expansion-panel:** remove explicit height ([3b7adf3](https://github.com/vuetifyjs/vuetify/commit/3b7adf38a8a0928a968e17f797b65c6772fdf7c2)), closes [#4977](https://github.com/vuetifyjs/vuetify/issues/4977)
* **v-expansion-transition:** do not overwrite user defined height ([44ac40d](https://github.com/vuetifyjs/vuetify/commit/44ac40d34aa6abc0e19e929143d11f8b0694e406))
* **v-footer:** fix applicationProperty update ([bdb5060](https://github.com/vuetifyjs/vuetify/commit/bdb506050c88eee12cb9a5292b35ffe9c170e6cd)), closes [#4686](https://github.com/vuetifyjs/vuetify/issues/4686)
* **v-item:** add value prop ([fba1631](https://github.com/vuetifyjs/vuetify/commit/fba163111cf94d53c24f357234f677b12acb9cc3))
* **v-list-tile-action:** add support for v-html ([f3b4192](https://github.com/vuetifyjs/vuetify/commit/f3b4192d18e7657be515c65da12f957c84f5b0e3)), closes [#5037](https://github.com/vuetifyjs/vuetify/issues/5037)
* **v-menu:** remove activator height ([2f38cfa](https://github.com/vuetifyjs/vuetify/commit/2f38cfa3a82273be5dafd034e1a132a11d2df037)), closes [#4942](https://github.com/vuetifyjs/vuetify/issues/4942)
* **v-messages:** change assigned key ([6fc95a5](https://github.com/vuetifyjs/vuetify/commit/6fc95a532792f35b3cb9e4ea351a18ba88673187)), closes [#4880](https://github.com/vuetifyjs/vuetify/issues/4880)
* **v-navigation-drawer:** pull in Dependent mixin for click-outside ([d7318a6](https://github.com/vuetifyjs/vuetify/commit/d7318a6764438445b9b3c735d7116b55509eb50a))
* **v-radio:** remove bottom margin ([439bf67](https://github.com/vuetifyjs/vuetify/commit/439bf6792002188cf6ebb4db6697d362c590988d)), closes [#5162](https://github.com/vuetifyjs/vuetify/issues/5162)
* **v-radio-group:** change radio margin selector ([a7d9d6e](https://github.com/vuetifyjs/vuetify/commit/a7d9d6e766588aba7f0e08e8db0bc07e0f1f5b44)), closes [#5255](https://github.com/vuetifyjs/vuetify/issues/5255)
* **v-select:** add genProgress ([646a3ee](https://github.com/vuetifyjs/vuetify/commit/646a3eeb4421a8db5ae5d7049379927a9fa2d813)), closes [#4805](https://github.com/vuetifyjs/vuetify/issues/4805) [#5279](https://github.com/vuetifyjs/vuetify/issues/5279)
* **v-select:** remove change event for external changes ([545b20c](https://github.com/vuetifyjs/vuetify/commit/545b20ca827eeeb2f2ee7a0a2c4f3f0e10578e24)), closes [#5006](https://github.com/vuetifyjs/vuetify/issues/5006)
* **v-slider:** remove duplicate change event ([86eca2b](https://github.com/vuetifyjs/vuetify/commit/86eca2baa42788c2e5a74652048dc9591c701cfc)), closes [#4996](https://github.com/vuetifyjs/vuetify/issues/4996)
* **v-stepper-content:** visibility desync ([#4859](https://github.com/vuetifyjs/vuetify/issues/4859)) ([67b3c97](https://github.com/vuetifyjs/vuetify/commit/67b3c976bb07aaf4f63a525681d85f27e6515560))
* **v-tab:** fix mixin duplication bug ([d19c3b2](https://github.com/vuetifyjs/vuetify/commit/d19c3b2c65c4777e660fe30a9831d459eb7176a4))
* **v-tab-item:** add backwards compat for id ([64b1fbb](https://github.com/vuetifyjs/vuetify/commit/64b1fbb45e7d4c9bd5877046ca9e4f369fe0d801))
* **v-tabs:** cleanup and improve feel ([648c02d](https://github.com/vuetifyjs/vuetify/commit/648c02dc71e56212b2b8c46b2b701d9045d17c90))
* **v-tabs:** fix broken tests ([37502c7](https://github.com/vuetifyjs/vuetify/commit/37502c79a2d67ffb8170c494850603598587db3f))
* **v-tabs:** watch change of items ([bc6bd60](https://github.com/vuetifyjs/vuetify/commit/bc6bd60acc057899f9396e2ee00004ebafed3a92)), closes [#52222](https://github.com/vuetifyjs/vuetify/issues/52222)
* **v-text-field:** change mouseup focus to conditional ([5b1f3b4](https://github.com/vuetifyjs/vuetify/commit/5b1f3b41f41c88a47cee200fb56e14f57e1f1455)), closes [#5018](https://github.com/vuetifyjs/vuetify/issues/5018)
* **v-text-field/v-select:** remove explicit height ([#4902](https://github.com/vuetifyjs/vuetify/issues/4902)) ([65edb1c](https://github.com/vuetifyjs/vuetify/commit/65edb1c96883c3beeb9bde594e4386c9b60d4a2b)), closes [#4456](https://github.com/vuetifyjs/vuetify/issues/4456)
* **v-toolbar:** correct automatic height on landscape views ([f18b54e](https://github.com/vuetifyjs/vuetify/commit/f18b54ea5d8723f921e77ae4b08794770ef6f7fb)), closes [#3990](https://github.com/vuetifyjs/vuetify/issues/3990)
* **v-treeview:** propagate checkbox color ([48b1ec7](https://github.com/vuetifyjs/vuetify/commit/48b1ec7fe2be90531b79cf8f00769ab700047320))
* **VBtn:** don't change text color on outlined buttons ([ee3f6df](https://github.com/vuetifyjs/vuetify/commit/ee3f6dff5c8a8369c332bae475f26a00199b8950))
* **VDataTable:** ensure expand slot is always an array ([0398263](https://github.com/vuetifyjs/vuetify/commit/03982635304159aa4238878776d56b43a385f620)), closes [#4948](https://github.com/vuetifyjs/vuetify/issues/4948)
* **VDatePicker:** height of year selector ([977fd7d](https://github.com/vuetifyjs/vuetify/commit/977fd7d29f17d490b00241dfe3a8dd6b2688701f))
* **VEditDialog:** apply theme classes to content ([#5152](https://github.com/vuetifyjs/vuetify/issues/5152)) ([cf94d46](https://github.com/vuetifyjs/vuetify/commit/cf94d461db8ee1a2febe88c3a20b0461d9da412c)), closes [#5127](https://github.com/vuetifyjs/vuetify/issues/5127)
* **VEditDialog:** display action buttons in 1 line ([e0d39fe](https://github.com/vuetifyjs/vuetify/commit/e0d39feaabd4063e2ea9d0205119c28959684748)), closes [#4450](https://github.com/vuetifyjs/vuetify/issues/4450)
* **VImg:** allow transition to be disabled ([b01094d](https://github.com/vuetifyjs/vuetify/commit/b01094d89b3df224c03f7bf786377bafd1110519))
* **VImg:** fall back to image.src in IE and safari ([50e1043](https://github.com/vuetifyjs/vuetify/commit/50e10433f68e85dbc890fa727933cd9ff6a7361b))
* **VImg:** update src anyway if decode fails ([4341ce0](https://github.com/vuetifyjs/vuetify/commit/4341ce0292e4867804c5813d2ae7694abbe08d3d)), closes [#4969](https://github.com/vuetifyjs/vuetify/issues/4969)
* **VLinearProgress:** invalid class applied when using css color ([1f56645](https://github.com/vuetifyjs/vuetify/commit/1f566457b1494e6dcdbd4c8105fb1a718d6c9cfd))
* add .css to sideEffects ([5b8c19f](https://github.com/vuetifyjs/vuetify/commit/5b8c19fc5a5f89c11008b9643999e66735f9eb4b))
* small css issue with treeview labels ([550cbfa](https://github.com/vuetifyjs/vuetify/commit/550cbfa865c9dc7c6b855620bca11cfeb7c28742))
* v-treeview infinite loop bug ([6d0f035](https://github.com/vuetifyjs/vuetify/commit/6d0f03549a3c110214a719041ca335a5597b36c9))
* v-treeview margins ([04d7a50](https://github.com/vuetifyjs/vuetify/commit/04d7a50f1650226c94b8053e410026ac17df96a1))
* **v-window:** add mandatory true default ([e774214](https://github.com/vuetifyjs/vuetify/commit/e774214c883ea978f10a052af040504e40d3afc6))
* **v-window:** remove entry animation ([db316cd](https://github.com/vuetifyjs/vuetify/commit/db316cd3b9abe462453905b3fa2e0662f8d48202))
* **VBreadcrumbs:** add Themeable classes ([37858db](https://github.com/vuetifyjs/vuetify/commit/37858db67b4aaecd600a3823f5220a4a9991e8b8)), closes [#4986](https://github.com/vuetifyjs/vuetify/issues/4986)
* **VInput:** themeable label, icon, counter, messages ([#4457](https://github.com/vuetifyjs/vuetify/issues/4457)) ([abf7007](https://github.com/vuetifyjs/vuetify/commit/abf7007ac8c731044a6e7255dc522f34fa9f4dd1)), closes [#4453](https://github.com/vuetifyjs/vuetify/issues/4453)
* **VMenu:** inherit light/dark from v-app ([9bf02af](https://github.com/vuetifyjs/vuetify/commit/9bf02afc57fe639151c1250e28ef0c5dc1492cc8))
* **VMenu:** make detached provide reactive ([acf90be](https://github.com/vuetifyjs/vuetify/commit/acf90be4de5c68bccd4066aa8ab8d32e80215b49)), closes [#5010](https://github.com/vuetifyjs/vuetify/issues/5010)
* **VMenu, VDialog:** allow content theme to be overridden ([6e242cb](https://github.com/vuetifyjs/vuetify/commit/6e242cb37c02a83f9cb9c862ad40a595e612d027))
* **VNavigationDrawer:** unbind old side when applicationProperty changes ([3561a70](https://github.com/vuetifyjs/vuetify/commit/3561a7053da009586da9e339b4bd74b29e2526dc)), closes [#4617](https://github.com/vuetifyjs/vuetify/issues/4617)
* **VPagination:** fix v-pagination misbehavior ([#3636](https://github.com/vuetifyjs/vuetify/issues/3636)) ([#4651](https://github.com/vuetifyjs/vuetify/issues/4651)) ([8d1724a](https://github.com/vuetifyjs/vuetify/commit/8d1724a803e15723bf951d873be250580ffd0a54))
* **VRadioGroup:** emit the new value when reset ([25ae6b3](https://github.com/vuetifyjs/vuetify/commit/25ae6b30039c06daf54f4d4aacb337fde90e9f79)), closes [#4752](https://github.com/vuetifyjs/vuetify/issues/4752)
* **VSelect:** allow null values to be selected ([#4649](https://github.com/vuetifyjs/vuetify/issues/4649)) ([43a18b6](https://github.com/vuetifyjs/vuetify/commit/43a18b613f5b2716d8356069093eb8be917ca9c1)), closes [#4431](https://github.com/vuetifyjs/vuetify/issues/4431)
* **VSelect:** don't show menu if readonly ([f37e961](https://github.com/vuetifyjs/vuetify/commit/f37e961f0245ceed5a3ab31a996b2cd292e222fe)), closes [#4815](https://github.com/vuetifyjs/vuetify/issues/4815)
* **VSelect:** remove 'auto' prop definition, update deprecation notice ([5f01466](https://github.com/vuetifyjs/vuetify/commit/5f0146656ea9c2c2d50f6f58958b2ae18a004051)), closes [#4881](https://github.com/vuetifyjs/vuetify/issues/4881)
* **VSelect:** show falsy items in the list ([5172f68](https://github.com/vuetifyjs/vuetify/commit/5172f686cb635464fe7974febe3cf41612a17ed1)), closes [#4431](https://github.com/vuetifyjs/vuetify/issues/4431) [#4649](https://github.com/vuetifyjs/vuetify/issues/4649)
* **VSelect:** show pointer cursor on the correct element ([2e96f22](https://github.com/vuetifyjs/vuetify/commit/2e96f2249dc889d7d1f72262a6d878a9d06f43fe)), closes [#4851](https://github.com/vuetifyjs/vuetify/issues/4851)
* **VStepperStep:** use colorable mixin ([5032c8a](https://github.com/vuetifyjs/vuetify/commit/5032c8a9af577299428080cc1cc5022541b33b80)), closes [#5183](https://github.com/vuetifyjs/vuetify/issues/5183)
* added themeable mixin, organized imports ([3f2be2a](https://github.com/vuetifyjs/vuetify/commit/3f2be2a1b877fb564d89423bd3d275a0ad893a15))
* always apply margin-top to v-input--slider ([#4899](https://github.com/vuetifyjs/vuetify/issues/4899)) ([2c0a3a9](https://github.com/vuetifyjs/vuetify/commit/2c0a3a92fc74bc267310cfe10409128b3df4761e))
* icon button's height in toolbar items ([#4907](https://github.com/vuetifyjs/vuetify/issues/4907)) ([ca6a44e](https://github.com/vuetifyjs/vuetify/commit/ca6a44e8497e23717f4304436afd658373ab85a4))
* updated tests ([f4a7722](https://github.com/vuetifyjs/vuetify/commit/f4a772279be3396d3fcb7b222400516b738bb2c3))
* **VMenu, VDialog:** inherit content theme from v-app instead of parent ([9f61a81](https://github.com/vuetifyjs/vuetify/commit/9f61a817a0df6d1ffe6bb060c16a737529bcfade))
* **VMenu, VDialog:** show multiple elements in the default slot ([f90d631](https://github.com/vuetifyjs/vuetify/commit/f90d6312e987519fe1ae2e59269bebe8cf91078a))
* **VPagination:** add themeable ([9461ba2](https://github.com/vuetifyjs/vuetify/commit/9461ba2b495f5730f73e1c43365520faa15c6b94))
* **VResponsive:** prevent content overflow ([a7ffbfe](https://github.com/vuetifyjs/vuetify/commit/a7ffbfeeafdbdef20272fdd8247b44f617eb6be5))
* **VTabs:** don't provide own theme ([93ee3c7](https://github.com/vuetifyjs/vuetify/commit/93ee3c76ec341858b6afb860347b5b392af10401))
* **VTabs:** make theme reactive, provide to icons ([7d55184](https://github.com/vuetifyjs/vuetify/commit/7d5518488452170c18ce45f492993e1b59f6f00d))
* **VTabs:** pass parent theme to items ([d3def0b](https://github.com/vuetifyjs/vuetify/commit/d3def0bc6a09cfdb924c2439f6a42322543f8de1))
* **VTabs:** pass parent theme to items ([08b67a7](https://github.com/vuetifyjs/vuetify/commit/08b67a7a1b857e0705255d447b557c1200c19b7f))
* **VTextField:** allow input to shrink below the base width ([60cf038](https://github.com/vuetifyjs/vuetify/commit/60cf038292b69286788949aa1f316b63ce0f863a)), closes [#4768](https://github.com/vuetifyjs/vuetify/issues/4768)
* **VTextField:** preserve VNode.data.model ([e34e48b](https://github.com/vuetifyjs/vuetify/commit/e34e48bb0d22c7d4150c02725789da74d748522b)), closes [#4460](https://github.com/vuetifyjs/vuetify/issues/4460)
* [#4825](https://github.com/vuetifyjs/vuetify/issues/4825) - icon alignment in fab broken ([#4833](https://github.com/vuetifyjs/vuetify/issues/4833)) ([3c5604d](https://github.com/vuetifyjs/vuetify/commit/3c5604d4c236c1cec8bcd1d27dd26c414a7424d9))
* [#4826](https://github.com/vuetifyjs/vuetify/issues/4826) - Data Table Progress bar overlaps table header border ([#4835](https://github.com/vuetifyjs/vuetify/issues/4835)) ([c483398](https://github.com/vuetifyjs/vuetify/commit/c483398ccc804883a3f13bfd15dffd2840874341))
* **VDataTable:** duplicate key ([#4294](https://github.com/vuetifyjs/vuetify/issues/4294)) ([3970ba6](https://github.com/vuetifyjs/vuetify/commit/3970ba609f474c7a4675c978b328636fab9f8d39)), closes [#3841](https://github.com/vuetifyjs/vuetify/issues/3841)
* **VNavigationDrawer:** transition width and transform ([c83f935](https://github.com/vuetifyjs/vuetify/commit/c83f935b0f4561af7571cf4ace890353c101ef84))
* **VRadio:** set correct name and value on input element ([15012f8](https://github.com/vuetifyjs/vuetify/commit/15012f85f157823fea2953279299543f08b1218c)), closes [#4719](https://github.com/vuetifyjs/vuetify/issues/4719)
* **VSelect:** don't show underline in checkboxes when attached ([4bb8bfb](https://github.com/vuetifyjs/vuetify/commit/4bb8bfb345fddb8b1da04ddbef3747ba92d316e6)), closes [#4754](https://github.com/vuetifyjs/vuetify/issues/4754)
* **VSlider:** use a text input internally ([33d1652](https://github.com/vuetifyjs/vuetify/commit/33d16523254db0cf144444ec56e89ceddf7f6403)), closes [#4464](https://github.com/vuetifyjs/vuetify/issues/4464)
* **VTextField:** blur internal input when blur() is called ([1b6463a](https://github.com/vuetifyjs/vuetify/commit/1b6463acd504ab7a4c23e7e2e690fb6f79683bdb)), closes [#3009](https://github.com/vuetifyjs/vuetify/issues/3009)
* **VTextField:** prevent pointer events on the label ([74ff691](https://github.com/vuetifyjs/vuetify/commit/74ff6916c85b1ab43cc18855557066e2c101d24e))
* don't change month autmatically when deselecting date ([09eeb6c](https://github.com/vuetifyjs/vuetify/commit/09eeb6cee7a74910452a4721534efb8d71c42a63))
* **VTextField:** show dashed underline when disabled ([2dec42a](https://github.com/vuetifyjs/vuetify/commit/2dec42ac474071c7e7cf7da75f9512c77e00a2ba)), closes [#4615](https://github.com/vuetifyjs/vuetify/issues/4615)
* added default value to items prop ([d5f67ab](https://github.com/vuetifyjs/vuetify/commit/d5f67ab85c0e0adc1699b01fca0e1deaed78b46b))
* added key ([c2d2dfc](https://github.com/vuetifyjs/vuetify/commit/c2d2dfcda977f89ac2611a885d94370589e95a5f))
* don't reduce animation keyframes ([#4564](https://github.com/vuetifyjs/vuetify/issues/4564)) ([0c5eb5b](https://github.com/vuetifyjs/vuetify/commit/0c5eb5baafe5f075d4f2a6ba1442bbe20a6372ba))
* thin lines are rendered inconsistently ([#4615](https://github.com/vuetifyjs/vuetify/issues/4615)) ([7cd89ea](https://github.com/vuetifyjs/vuetify/commit/7cd89ea7f7acd823aa5c9ee0cca0217e29c077ed)), closes [#3847](https://github.com/vuetifyjs/vuetify/issues/3847) [#3588](https://github.com/vuetifyjs/vuetify/issues/3588) [#3090](https://github.com/vuetifyjs/vuetify/issues/3090)
* **VSelect:** blur called after input is destroyed ([33785e6](https://github.com/vuetifyjs/vuetify/commit/33785e6758258f743b075af4d47a57eeb5824834))
* **VSelect:** don't register click-outside if not focused ([b730f14](https://github.com/vuetifyjs/vuetify/commit/b730f149e215e88d47b2793e13fbf3f31fa4c5ce))
* **webpack:** fix stylus usage in dev ([166b489](https://github.com/vuetifyjs/vuetify/commit/166b4896fa9bfc277a411705d9b58930229aee9c)), closes [/github.com/vuejs/vue-loader/issues/1273#issuecomment-385492783](https://github.com/vuetifyjs//github.com/vuejs/vue-loader/issues/1273/issues/issuecomment-385492783)
* removed unused variables ([1749e99](https://github.com/vuetifyjs/vuetify/commit/1749e999c1af74567ff137e63989f7946f5a3c4a))
* replace no-unused-variable with noUnusedLocals, enable noImplicitReturns ([af7e505](https://github.com/vuetifyjs/vuetify/commit/af7e505f38500ea8b56896cd8bb1efdfd94d40f9))
* **inputs:** fix cursor styles ([f875c9d](https://github.com/vuetifyjs/vuetify/commit/f875c9d27e6f8686a0d31358622e2232abce28af)), closes [#4404](https://github.com/vuetifyjs/vuetify/issues/4404)
* **v-autocomplete:** add cursor style ([bb5859d](https://github.com/vuetifyjs/vuetify/commit/bb5859d2e1f4d24dd4f12d4631ce980559de45b4)), closes [#4404](https://github.com/vuetifyjs/vuetify/issues/4404)
* **v-autocomplete:** change setSearch logic ([c2f861e](https://github.com/vuetifyjs/vuetify/commit/c2f861efbb5bd3b36d0e164031426b2d76fdde0c)), closes [#4403](https://github.com/vuetifyjs/vuetify/issues/4403)
* **v-autocomplete:** fix onBlur functionality ([d8cb90a](https://github.com/vuetifyjs/vuetify/commit/d8cb90ad05fd0d1444a68fc1478b61ed9c28be6f)), closes [#4407](https://github.com/vuetifyjs/vuetify/issues/4407)
* **v-combobox:** fix updateCombobox logic ([750821b](https://github.com/vuetifyjs/vuetify/commit/750821b58c5d74d76785e2447678f03cd8d2b279)), closes [#4448](https://github.com/vuetifyjs/vuetify/issues/4448)
* **v-divider:** fix vertical prop in flex ([3d7fc2a](https://github.com/vuetifyjs/vuetify/commit/3d7fc2acdf3af3d205499d0c1796e74651608ab2))
* **v-icon:** fix link specificity ([b7f1efc](https://github.com/vuetifyjs/vuetify/commit/b7f1efcd42a7a42d7dcdfa4078352e64edbd3c30))
* **v-overflow-btn:** placeholder text ([cc5a9b8](https://github.com/vuetifyjs/vuetify/commit/cc5a9b87aedb949c4a20923a5356d448fd803847))
* **v-select-list:** normalize hasItem check ([0b550c5](https://github.com/vuetifyjs/vuetify/commit/0b550c5801757878c641467be2722ef7cb83746b))
* **v-switch:** add part key ([6885681](https://github.com/vuetifyjs/vuetify/commit/6885681e9dd3bb36d548afaba5d925f0978fb0b4))
* **v-tabs:** update active comparison ([#4406](https://github.com/vuetifyjs/vuetify/issues/4406)) ([33ab338](https://github.com/vuetifyjs/vuetify/commit/33ab3380d6a948dc3ad54de0e4defefe0f9b283a)), closes [#4397](https://github.com/vuetifyjs/vuetify/issues/4397)
* **VChip:** cursor on close icon ([9a9b718](https://github.com/vuetifyjs/vuetify/commit/9a9b71872477dd3372067a61494d841d98ffad10)), closes [#4517](https://github.com/vuetifyjs/vuetify/issues/4517)
* **VChip:** styles for disabled chips ([#4531](https://github.com/vuetifyjs/vuetify/issues/4531)) ([fa0ebff](https://github.com/vuetifyjs/vuetify/commit/fa0ebff97f8ddf2774323fdda904f2e3a1827092)), closes [#4442](https://github.com/vuetifyjs/vuetify/issues/4442)
* **VDataTable:** added missing v- prefix ([96d262d](https://github.com/vuetifyjs/vuetify/commit/96d262d2d85827ab2d3f3645d02cef3864a29696)), closes [#4458](https://github.com/vuetifyjs/vuetify/issues/4458)
* **VDialog:** use overlay with persistent and hide-overlay props ([#4529](https://github.com/vuetifyjs/vuetify/issues/4529)) ([b7b14f1](https://github.com/vuetifyjs/vuetify/commit/b7b14f1293ead25b9ec5eebeed5e0bf96c8fb593)), closes [#4466](https://github.com/vuetifyjs/vuetify/issues/4466)
* **VDialog,VMenu:** cursor on activator ([447447e](https://github.com/vuetifyjs/vuetify/commit/447447ee48968d8df68aced42ad4230ba1a2fc8d)), closes [#3996](https://github.com/vuetifyjs/vuetify/issues/3996)
* **VProgressCircular:** add vertical alignment ([#4339](https://github.com/vuetifyjs/vuetify/issues/4339)) ([a81f293](https://github.com/vuetifyjs/vuetify/commit/a81f293810dc06298414ff865fd486661c73d6d2)), closes [#4285](https://github.com/vuetifyjs/vuetify/issues/4285)
* **VRadio:** don't override negative tabindex ([d119455](https://github.com/vuetifyjs/vuetify/commit/d11945584cb1c9181032230c5b2bb20016ca4c37)), closes [#4490](https://github.com/vuetifyjs/vuetify/issues/4490)
* **VSelect:** don't generate append slot if append-icon is empty ([149bed7](https://github.com/vuetifyjs/vuetify/commit/149bed7555e2c489ecc275a45efa73298a0d11c2)), closes [#4477](https://github.com/vuetifyjs/vuetify/issues/4477)
* **VSelect:** override v-text-field's blur method ([#4441](https://github.com/vuetifyjs/vuetify/issues/4441)) ([c047a21](https://github.com/vuetifyjs/vuetify/commit/c047a21536fdeffe6481ce18b00c12183539963b))
* **VSelect:** pass attach prop to menu when not true ([77d25c7](https://github.com/vuetifyjs/vuetify/commit/77d25c7b2489646745aa16d6c7cb2b2a0e85cd5d))
* **VSelect:** prevent emitting change again on blur ([#4539](https://github.com/vuetifyjs/vuetify/issues/4539)) ([0f4f649](https://github.com/vuetifyjs/vuetify/commit/0f4f64974d1c5a4e0770cce6e714b051402fe0dd)), closes [#4481](https://github.com/vuetifyjs/vuetify/issues/4481)
* **VTabs:** tab width in IE11 ([#4526](https://github.com/vuetifyjs/vuetify/issues/4526)) ([ac49887](https://github.com/vuetifyjs/vuetify/commit/ac49887d7c8dcd17f3370a87fad20f1c9d163128)), closes [#4489](https://github.com/vuetifyjs/vuetify/issues/4489)
* **VTextField:** border radius for solo field ([d6bdc94](https://github.com/vuetifyjs/vuetify/commit/d6bdc94679fdc2d456dd914215ba25ce58600761)), closes [#4463](https://github.com/vuetifyjs/vuetify/issues/4463)
* **VTextField:** counter with v-model.number ([#4524](https://github.com/vuetifyjs/vuetify/issues/4524)) ([291e8bd](https://github.com/vuetifyjs/vuetify/commit/291e8bdefb0091894f5d3a02316719612082e948)), closes [#4475](https://github.com/vuetifyjs/vuetify/issues/4475)
* **VTextField:** only call rules on blur with validateOnBlur set ([f5f7667](https://github.com/vuetifyjs/vuetify/commit/f5f76678532712f802df384678c77f92f36444c5)), closes [#4494](https://github.com/vuetifyjs/vuetify/issues/4494)
* prevent double emit from wrapping components ([6e8b6b7](https://github.com/vuetifyjs/vuetify/commit/6e8b6b76bf65c1d5aa55140f4222bf4849d9b4f0)), closes [vuejs/vue#8436](https://github.com/vuejs/vue/issues/8436)
* prevent selection controls' labels from growing ([#4430](https://github.com/vuetifyjs/vuetify/issues/4430)) ([20af23c](https://github.com/vuetifyjs/vuetify/commit/20af23cb46a454421d3503c88c4089d80bc2d5cc))
* typo in transition name ([a5e302e](https://github.com/vuetifyjs/vuetify/commit/a5e302ee241e9ddb3a023678f9fd425d5bb845f8))
* v-btn classes cleanup ([#4371](https://github.com/vuetifyjs/vuetify/issues/4371)) ([da33df0](https://github.com/vuetifyjs/vuetify/commit/da33df0fcf36f7eda2eaf9dbecdc3f5bcae6c0ff))
* v-tabs should now update v-model if swiping on v-tab ([#4515](https://github.com/vuetifyjs/vuetify/issues/4515)) ([a7a65a1](https://github.com/vuetifyjs/vuetify/commit/a7a65a1fc27e39da5920353a7d0eae6a96af5910)), closes [#4402](https://github.com/vuetifyjs/vuetify/issues/4402)
* **VTextField:** prefix/suffix cursor ([#4525](https://github.com/vuetifyjs/vuetify/issues/4525)) ([6a34c5d](https://github.com/vuetifyjs/vuetify/commit/6a34c5dd32af1ce3ded53ee7d284954540943e56)), closes [#4478](https://github.com/vuetifyjs/vuetify/issues/4478)
* various issues with overflow-btn ([4dfa633](https://github.com/vuetifyjs/vuetify/commit/4dfa633fd525747211ce7baa1af6ebaaa35f3fed))
* **RTL:** next/prev icons and transitions in picker, pagination, carousel, iterable ([#4328](https://github.com/vuetifyjs/vuetify/issues/4328)) ([4ca0f0f](https://github.com/vuetifyjs/vuetify/commit/4ca0f0ffc344467190e631457652cecd7bee6332)), closes [#4327](https://github.com/vuetifyjs/vuetify/issues/4327)
* **selection-controls:** add cursor styles ([f15f851](https://github.com/vuetifyjs/vuetify/commit/f15f85174668370b49adb488544cd8cd330ac829))
* **selection-controls:** label height and IE11 layout issues ([#4323](https://github.com/vuetifyjs/vuetify/issues/4323)) ([eb8b710](https://github.com/vuetifyjs/vuetify/commit/eb8b7106ce07aaeffc4088f495c5a2016afc0ef9)), closes [#4314](https://github.com/vuetifyjs/vuetify/issues/4314)
* **translatable:** removed normalizedHeight ([#4301](https://github.com/vuetifyjs/vuetify/issues/4301)) ([3c9a7a1](https://github.com/vuetifyjs/vuetify/commit/3c9a7a160d946c0824a84bba5d010a3c16d9ad5e))
* **v-autocomplete:** fix single select styles ([345975d](https://github.com/vuetifyjs/vuetify/commit/345975d9255eb2e5f9931598af7991459a6a41fc))
* **v-autocomplete:** remove onEnterKey call ([3f80d8e](https://github.com/vuetifyjs/vuetify/commit/3f80d8eb4309f63d6967ecd3b1d81d3c37470d80))
* **v-autocomplete:** show menu when items update ([d4732ec](https://github.com/vuetifyjs/vuetify/commit/d4732ec0b8b5d80578c4c6d8ce0cc4bf3447a307))
* **v-btn:** increase specificity of transition ([e28325e](https://github.com/vuetifyjs/vuetify/commit/e28325eb789a16a5dc40d23dc668817030aa0ab0))
* **v-card-actions:** remove style ([1144530](https://github.com/vuetifyjs/vuetify/commit/114453002a15cbfca8620f0ac3e09299382140ec)), closes [#4215](https://github.com/vuetifyjs/vuetify/issues/4215)
* **v-data-table:** change css selector ([075e426](https://github.com/vuetifyjs/vuetify/commit/075e426a940c85e23c5093dff0afd40343e9b4cd)), closes [#4350](https://github.com/vuetifyjs/vuetify/issues/4350)
* **v-icon:** fix vertical styling ([52a5f07](https://github.com/vuetifyjs/vuetify/commit/52a5f077f2bbdcf7d7c850376f54a8057c11e269))
* **v-input:** remove ff styles ([9642a13](https://github.com/vuetifyjs/vuetify/commit/9642a13985aeb5f167857f50e9187d209b926cd3)), closes [#4379](https://github.com/vuetifyjs/vuetify/issues/4379)
* **v-radio:** fix readonly styles ([e3f1601](https://github.com/vuetifyjs/vuetify/commit/e3f16015adf5ab1bc453447c0927394a0aa90b8b)), closes [#4349](https://github.com/vuetifyjs/vuetify/issues/4349)
* **v-select:** destructure object properties ([2934435](https://github.com/vuetifyjs/vuetify/commit/2934435768560fbb33c63fddbbfb3fe211b67f71)), closes [#4359](https://github.com/vuetifyjs/vuetify/issues/4359)
* **v-select:** fix item wrapping ([b543e3a](https://github.com/vuetifyjs/vuetify/commit/b543e3a2b74c83fd561831646a937c9dabb7b9c8)), closes [#4275](https://github.com/vuetifyjs/vuetify/issues/4275)
* **v-select:** fix menu alignment ([667d3f0](https://github.com/vuetifyjs/vuetify/commit/667d3f07419df23dcdd3871f11b45fee558bc65d))
* **v-select:** revert b543e3a ([78c0fe0](https://github.com/vuetifyjs/vuetify/commit/78c0fe0bb192a384cf541795b39bddf3f2c96c7e)), closes [#4275](https://github.com/vuetifyjs/vuetify/issues/4275)
* **v-select-list:** remove disabled ([5162c3d](https://github.com/vuetifyjs/vuetify/commit/5162c3d1047f1c2989885311a81affa25ef26bac))
* **v-tabs:** improve model comparison ([158424f](https://github.com/vuetifyjs/vuetify/commit/158424fc546c07d11fa732f60bd92c9a99e20817)), closes [#3641](https://github.com/vuetifyjs/vuetify/issues/3641)
* **v-text-field:** remove enclosed margin ([fa3842d](https://github.com/vuetifyjs/vuetify/commit/fa3842de724c8df90c83d7ff8209809bbab1feb9))
* **v-toolbar:** add back missing styles ([3c29d75](https://github.com/vuetifyjs/vuetify/commit/3c29d75f8c565a86fc2cc6d122a348ff639230d4)), closes [#4331](https://github.com/vuetifyjs/vuetify/issues/4331)
* **v-toolbar:** fix alignment with tooltip and menu ([48dad2d](https://github.com/vuetifyjs/vuetify/commit/48dad2d133df2ffa10e43066d055635424d9c688))
* **v-toolbar:** fix toolbar list alignment ([#4343](https://github.com/vuetifyjs/vuetify/issues/4343)) ([05c4d95](https://github.com/vuetifyjs/vuetify/commit/05c4d95fd842cedc301f025a83a424aef08eafbe))
* **v-window:** fix example ([88383ae](https://github.com/vuetifyjs/vuetify/commit/88383ae5d51d7dd0631a64832f3a83d989e42b49))
* **VCard, converToUnit:** set proper styles with falsy height prop ([#4348](https://github.com/vuetifyjs/vuetify/issues/4348)) ([88e0ead](https://github.com/vuetifyjs/vuetify/commit/88e0ead6cc80a7921629dffea975268b08cf7728)), closes [#4344](https://github.com/vuetifyjs/vuetify/issues/4344)
* **VF-34:** pass query string through language redirects ([c40d498](https://github.com/vuetifyjs/vuetify/commit/c40d49878f1a37849704ad004dbc862756d4c428))
* **VInput:** remove red outline in FF for invalid fields ([af69aea](https://github.com/vuetifyjs/vuetify/commit/af69aea27745296c089610e07f874851086bd996))
* **VPicker:** added picker body z-index ([aa15e0d](https://github.com/vuetifyjs/vuetify/commit/aa15e0dbcb91e615f92d55353efe7544f6d9aa2d)), closes [#4391](https://github.com/vuetifyjs/vuetify/issues/4391)
* **VRadio:** inject disabled/readonly from VRadioGroup ([#4388](https://github.com/vuetifyjs/vuetify/issues/4388)) ([5385038](https://github.com/vuetifyjs/vuetify/commit/538503838840797608dc7ae834510c294490433b)), closes [#4349](https://github.com/vuetifyjs/vuetify/issues/4349)
* **VRadioGroup:** fixed last fix, ripple, user-select, label padding ([5dfc927](https://github.com/vuetifyjs/vuetify/commit/5dfc92792ffcc428531b55dc70aad09a966634c1))
* **VRadioGroup:** removed pointer cursor from main label ([33a72be](https://github.com/vuetifyjs/vuetify/commit/33a72be78a318bb5ae683f72de18c7800ef04cde))
* **vtextfield:** check input change before mask logic ([#6758](https://github.com/vuetifyjs/vuetify/issues/6758)) ([9b354fd](https://github.com/vuetifyjs/vuetify/commit/9b354fd9aa9c5a15ec9b23c80dad677bb6430820)), closes [#4290](https://github.com/vuetifyjs/vuetify/issues/4290) [#5223](https://github.com/vuetifyjs/vuetify/issues/5223)
* **Vuetify:** adjust install pattern for proper treeshaking ([51d5aaf](https://github.com/vuetifyjs/vuetify/commit/51d5aaf6332bd04dd67e545c1dcc74fa4a28a8e4))
* fixed a bug where icons inside of a toolbar had improper styles - ([ee19f03](https://github.com/vuetifyjs/vuetify/commit/ee19f03d932cd4e5d5751824d0baa06abfeb962a)), closes [#2093](https://github.com/vuetifyjs/vuetify/issues/2093) [#2093](https://github.com/vuetifyjs/vuetify/issues/2093)
* Fixed select blur in Edge ([#2162](https://github.com/vuetifyjs/vuetify/issues/2162)) ([2d32d3c](https://github.com/vuetifyjs/vuetify/commit/2d32d3c8e5464ebabf18a50da0546b84ee9191e4)), closes [#2152](https://github.com/vuetifyjs/vuetify/issues/2152)
* Fixed select blur in Edge ([#2162](https://github.com/vuetifyjs/vuetify/issues/2162)) ([5c05519](https://github.com/vuetifyjs/vuetify/commit/5c05519a8360966d24193d45f32db62f0d7bf2a7)), closes [#2152](https://github.com/vuetifyjs/vuetify/issues/2152)
* Fixed/added logic to better handle different situations ([5eb1743](https://github.com/vuetifyjs/vuetify/commit/5eb17434cfb58957e96c5d79ee13a45efe5012e6)), closes [#2067](https://github.com/vuetifyjs/vuetify/issues/2067)
* Hide text field in blurred autocomplete v-selects ([#2172](https://github.com/vuetifyjs/vuetify/issues/2172)) ([382432d](https://github.com/vuetifyjs/vuetify/commit/382432d1e5ec28c9d21e6c9713f84b6c031788f3)), closes [#1691](https://github.com/vuetifyjs/vuetify/issues/1691)
* Hide text field in blurred autocomplete v-selects ([#2172](https://github.com/vuetifyjs/vuetify/issues/2172)) ([08c4da8](https://github.com/vuetifyjs/vuetify/commit/08c4da809ea3ec9019f23888afa24f465136670a)), closes [#1691](https://github.com/vuetifyjs/vuetify/issues/1691)
* icon colors ([92d3c1f](https://github.com/vuetifyjs/vuetify/commit/92d3c1f6282a09ce5d23d0e5265a5423c4848b66)), closes [#2353](https://github.com/vuetifyjs/vuetify/issues/2353)
* ignore clicks if pagination button is disabled ([1c0a64c](https://github.com/vuetifyjs/vuetify/commit/1c0a64c75cc68a9f49a9b047ccad6107ad0e0a6a))
* improve date picker performance ([#2332](https://github.com/vuetifyjs/vuetify/issues/2332)) ([a15e0ca](https://github.com/vuetifyjs/vuetify/commit/a15e0ca19156a02d0f4c4252d262a986050c084d)), closes [#2308](https://github.com/vuetifyjs/vuetify/issues/2308)
* jest toHaveBeenWarned matched ([040f5ed](https://github.com/vuetifyjs/vuetify/commit/040f5edc8180807ae8fbe3c6fae03b543069ba6c))
* make sure this.$attrs is defined ([b3e818d](https://github.com/vuetifyjs/vuetify/commit/b3e818d135c85003d25d0d192095219b3082e0e7))
* nested v-data-table thead ([a37b73f](https://github.com/vuetifyjs/vuetify/commit/a37b73f7000b6d6d2bd9883cdf1f1a63dc13332a))
* prevent race condition when VSelect is destroyed after mount ([bbdd418](https://github.com/vuetifyjs/vuetify/commit/bbdd41809005dde09a328416f511bcf9a85162aa)), closes [#2194](https://github.com/vuetifyjs/vuetify/issues/2194)
* proper installation of Vuetify component for testing ([#2367](https://github.com/vuetifyjs/vuetify/issues/2367)) ([867e5e3](https://github.com/vuetifyjs/vuetify/commit/867e5e352a3b74b2ddde3e7512a95e389d68462a))
* remove duplicated styles in dev ([c53cc0e](https://github.com/vuetifyjs/vuetify/commit/c53cc0e931c5bd74140a049f7f0148edabb353c5))
* Remove stylus [@extend](https://github.com/extend) for stylus block level import ([#1902](https://github.com/vuetifyjs/vuetify/issues/1902)) ([#2209](https://github.com/vuetifyjs/vuetify/issues/2209)) ([77b5af4](https://github.com/vuetifyjs/vuetify/commit/77b5af4ffa7e5665476255e3aee890a0f29ebce9))
* set proper color for textarea placeholder ([#2180](https://github.com/vuetifyjs/vuetify/issues/2180)) ([1c77a5d](https://github.com/vuetifyjs/vuetify/commit/1c77a5da5014fe1058d1e38e7e913739f273c02b)), closes [#2143](https://github.com/vuetifyjs/vuetify/issues/2143)
* set proper color for textarea placeholder ([#2180](https://github.com/vuetifyjs/vuetify/issues/2180)) ([061fd35](https://github.com/vuetifyjs/vuetify/commit/061fd35c8386b31263fddad5887e39bc0f7bfe9f)), closes [#2143](https://github.com/vuetifyjs/vuetify/issues/2143)
* strip non-numbers when checking vue version ([435b83f](https://github.com/vuetifyjs/vuetify/commit/435b83f0ef022c873fa27b5f31438f37a536b2d0))
* table items should not be filtered if the search if empty ([#2590](https://github.com/vuetifyjs/vuetify/issues/2590)) ([acaa6af](https://github.com/vuetifyjs/vuetify/commit/acaa6afb9e8ce2bbc95c16add041bd0fd6f7020f))
* tooltip not initially visiable when v-model is true ([#2595](https://github.com/vuetifyjs/vuetify/issues/2595)) ([f20278d](https://github.com/vuetifyjs/vuetify/commit/f20278dd78086954c51178ba46ffefcecfa57d33)), closes [#2000](https://github.com/vuetifyjs/vuetify/issues/2000)
* trigger swipe events only for proper swiping angle ([#2181](https://github.com/vuetifyjs/vuetify/issues/2181)) ([3875fef](https://github.com/vuetifyjs/vuetify/commit/3875fef24097706f9a8b7bfde3786da5a07177f0)), closes [#2125](https://github.com/vuetifyjs/vuetify/issues/2125)
* trigger swipe events only for proper swiping angle ([#2181](https://github.com/vuetifyjs/vuetify/issues/2181)) ([37fdced](https://github.com/vuetifyjs/vuetify/commit/37fdced596a0b47f86f4fb1fb18b227b3269321d)), closes [#2125](https://github.com/vuetifyjs/vuetify/issues/2125)
* typo in prop definition ([cbfc455](https://github.com/vuetifyjs/vuetify/commit/cbfc455d85eef9a2e7e61fbbdc59af68c55d74e7))
* use accent color for selection controls ([#2207](https://github.com/vuetifyjs/vuetify/issues/2207)) ([e408974](https://github.com/vuetifyjs/vuetify/commit/e4089745bbaff6c2a77479e9ccc037e2c8ac0346)), closes [#2003](https://github.com/vuetifyjs/vuetify/issues/2003)
* use actual folder containing file ([5182ee4](https://github.com/vuetifyjs/vuetify/commit/5182ee4c595d393a57bad2c757ed75bbd7a2793d))
* v-content size desync with SSR ([fb77f5c](https://github.com/vuetifyjs/vuetify/commit/fb77f5ce5425977a98b8e9f9a09ff4ac7752655c))
* v-content size desync with SSR ([10eb8e2](https://github.com/vuetifyjs/vuetify/commit/10eb8e25af3e4df57d2c7d5efc28ba302a21784d))
* **$browser:** Improperly styled nested expansion-panels ([7ebf61d](https://github.com/vuetifyjs/vuetify/commit/7ebf61d5ad11f0ed573d944c2611f0b3daeccc47)), closes [#2141](https://github.com/vuetifyjs/vuetify/issues/2141)
* **v-select:** adjusted selected items functionality ([5b1a408](https://github.com/vuetifyjs/vuetify/commit/5b1a40885ccf2f0abd20d7823223b053dffff257))
* **v-select:** adjusted selected items functionality ([9db604a](https://github.com/vuetifyjs/vuetify/commit/9db604a5f585b5c2b093ec73577274de5e96bc82))
* **v-select:** fixed a bug introduced by [#2183](https://github.com/vuetifyjs/vuetify/issues/2183) ([24f5680](https://github.com/vuetifyjs/vuetify/commit/24f5680f307d8cc66e4b9060543fb39a713b7763)), closes [#2126](https://github.com/vuetifyjs/vuetify/issues/2126) [#2126](https://github.com/vuetifyjs/vuetify/issues/2126)
* **v-select:** fixed menu auto position (again) ([78ce200](https://github.com/vuetifyjs/vuetify/commit/78ce200bd7988db9478ad66c08502f5e33add2e2))
* **v-tabs:** slider not re-positioning ([fc9c5df](https://github.com/vuetifyjs/vuetify/commit/fc9c5df7f4f86baf21aabe7bf560545ae6b4d930)), closes [#684](https://github.com/vuetifyjs/vuetify/issues/684)
* **v-tabs:** slider not re-positioning ([574e0d6](https://github.com/vuetifyjs/vuetify/commit/574e0d634bbe16140fe0659b17643d78cb6e2227)), closes [#684](https://github.com/vuetifyjs/vuetify/issues/684)
* **v-time-picker:** in addition to 18f6aad ([fb9646a](https://github.com/vuetifyjs/vuetify/commit/fb9646a1f7a09b98daf2b26d181c72cff5572266)), closes [#1916](https://github.com/vuetifyjs/vuetify/issues/1916)
* **v-toolbar:** fixed **scroll-off-screen** prop ([9956d9b](https://github.com/vuetifyjs/vuetify/commit/9956d9b34f1e17baf6763519c82af2549820d453))
* **VDialog:** don't create overlay on initially open fullscreen dialogs ([b84cbca](https://github.com/vuetifyjs/vuetify/commit/b84cbca797ff2be03383c58782460c4652a61b61))
* **VDialog:** don't create overlay on initially open fullscreen dialogs ([993bcb3](https://github.com/vuetifyjs/vuetify/commit/993bcb33ee3533e7d10d829a9c68c4603f27bbc8))
* **VNavigationDrawer:** update application when destroyed ([f51e2ab](https://github.com/vuetifyjs/vuetify/commit/f51e2ab4151b8872941c0a3931e0b9ba10b6ae1c))
* **VSelect:** better null check on menu ref ([0b97231](https://github.com/vuetifyjs/vuetify/commit/0b972318554a1951a40ce341dfb598ca489c3e06))
* **VSelect:** show input placeholder ([#4098](https://github.com/vuetifyjs/vuetify/issues/4098)) ([54d1612](https://github.com/vuetifyjs/vuetify/commit/54d1612d8542286916b22345efe5dcbf7644e6e1))
* **VTextField:** apply flat to the correct element when solo ([6257e6d](https://github.com/vuetifyjs/vuetify/commit/6257e6d511409b54b57c12333def09a31b63080d))
* **VTextField:** don't show v-counter if counter is null/undefined ([#4337](https://github.com/vuetifyjs/vuetify/issues/4337)) ([10b1d34](https://github.com/vuetifyjs/vuetify/commit/10b1d3442cbcf922ed05fc92793985e25d6621cd))
* **VTimePicker:** better sizing ([#4905](https://github.com/vuetifyjs/vuetify/issues/4905)) ([3ba2f89](https://github.com/vuetifyjs/vuetify/commit/3ba2f89c8b29620cffedb68331de2a2e0a2904b0)), closes [#3123](https://github.com/vuetifyjs/vuetify/issues/3123)
* **VToolbar:** remove margin from lists ([1ba4a17](https://github.com/vuetifyjs/vuetify/commit/1ba4a17902fd458ba5848bb8c6a1469260326331)), closes [#4111](https://github.com/vuetifyjs/vuetify/issues/4111)
* **vuetify:** fixed a memory leak ([3d9438a](https://github.com/vuetifyjs/vuetify/commit/3d9438a82cac71a593618ede55f35f482895c8bf))
* **VWindow:** select first non-disabled window-item when using touch swipe ([1938ee7](https://github.com/vuetifyjs/vuetify/commit/1938ee790862323ddfd29a2f14c7248a89e77d71)), closes [#5000](https://github.com/vuetifyjs/vuetify/issues/5000)
* Import Touch directive in VTabsItems ([9b6b0fd](https://github.com/vuetifyjs/vuetify/commit/9b6b0fd321c98d4e7001d13099ed3f762253857a)), closes [#2157](https://github.com/vuetifyjs/vuetify/issues/2157)
* textarea border should match chosen color ([79c8900](https://github.com/vuetifyjs/vuetify/commit/79c890080bf6a70986aa682f86d9eb90efdedc9a)), closes [#2140](https://github.com/vuetifyjs/vuetify/issues/2140)


* **framework:** remove deprecated stylus ([#6879](https://github.com/vuetifyjs/vuetify/issues/6879)) ([7d615eb](https://github.com/vuetifyjs/vuetify/commit/7d615eb12edd374c921c0292d92416b346e96cac))
* **kitchen:** remove from build process ([1df6a6f](https://github.com/vuetifyjs/vuetify/commit/1df6a6f4d08ecd1576cfa1abffaf77464ee72437))
* **routable/VItemGroup:** normalize behavior ([#7249](https://github.com/vuetifyjs/vuetify/issues/7249)) ([2bb3ec0](https://github.com/vuetifyjs/vuetify/commit/2bb3ec068154f53c83d8be5fded2a436adb078ca))
* **VApp:** scope component styles ([ec7b2e4](https://github.com/vuetifyjs/vuetify/commit/ec7b2e4dacacd247becf15f3f29f5f9fb3e64ba3))
* **VBottomNav:** update to md2 ([#6741](https://github.com/vuetifyjs/vuetify/issues/6741)) ([897b367](https://github.com/vuetifyjs/vuetify/commit/897b367e4eac5307b46f327277889cf46a4c855e))
* **VBottomSheet:** update for v2 ([#6786](https://github.com/vuetifyjs/vuetify/issues/6786)) ([568216b](https://github.com/vuetifyjs/vuetify/commit/568216b083217a277a4d511a018576b329526dc0))
* **VDataTable:** disable virtual-rows ([8284ef5](https://github.com/vuetifyjs/vuetify/commit/8284ef577e602a871719a747874212d9f3bc77bf))
* **VTextField:** remove browser-autocomplete prop ([68f85d6](https://github.com/vuetifyjs/vuetify/commit/68f85d6194fe006758a3316e3ca3376a758993d7))
* remove avoriaz, update to jest 24 ([#6972](https://github.com/vuetifyjs/vuetify/issues/6972)) ([84fc538](https://github.com/vuetifyjs/vuetify/commit/84fc53861297c0b76119b99ddd0d03e39cb6de14))
* use a single theme mixin ([#6889](https://github.com/vuetifyjs/vuetify/issues/6889)) ([04c4adc](https://github.com/vuetifyjs/vuetify/commit/04c4adcd976bea7b5e20ca399f3a929f6499e571))
